// ignore_for_file: camel_case_extensions, camel_case_types, discarded_futures
// ignore_for_file: no_leading_underscores_for_local_identifiers
// ignore_for_file: public_member_api_docs, unreachable_switch_case

library spreed_openapi;

import 'dart:typed_data';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/json_object.dart';
import 'package:built_value/serializer.dart';
import 'package:built_value/standard_json_plugin.dart';
import 'package:collection/collection.dart';
import 'package:dynamite_runtime/built_value.dart';
import 'package:dynamite_runtime/http_client.dart';
import 'package:dynamite_runtime/models.dart';
import 'package:dynamite_runtime/utils.dart' as dynamite_utils;
import 'package:meta/meta.dart';
import 'package:universal_io/io.dart';
import 'package:uri/uri.dart';

part 'spreed.openapi.g.dart';

class $Client extends DynamiteClient {
  $Client(
    super.baseURL, {
    super.baseHeaders,
    super.userAgent,
    super.httpClient,
    super.cookieJar,
    super.authentications,
  });

  $Client.fromClient(DynamiteClient client)
      : super(
          client.baseURL,
          baseHeaders: client.baseHeaders,
          httpClient: client.httpClient,
          cookieJar: client.cookieJar,
          authentications: client.authentications,
        );

  $AvatarClient get avatar => $AvatarClient(this);

  $BotClient get bot => $BotClient(this);

  $BreakoutRoomClient get breakoutRoom => $BreakoutRoomClient(this);

  $CallClient get call => $CallClient(this);

  $CertificateClient get certificate => $CertificateClient(this);

  $ChatClient get chat => $ChatClient(this);

  $FilesIntegrationClient get filesIntegration => $FilesIntegrationClient(this);

  $GuestClient get guest => $GuestClient(this);

  $HostedSignalingServerClient get hostedSignalingServer => $HostedSignalingServerClient(this);

  $MatterbridgeClient get matterbridge => $MatterbridgeClient(this);

  $MatterbridgeSettingsClient get matterbridgeSettings => $MatterbridgeSettingsClient(this);

  $PollClient get poll => $PollClient(this);

  $PublicShareAuthClient get publicShareAuth => $PublicShareAuthClient(this);

  $ReactionClient get reaction => $ReactionClient(this);

  $RecordingClient get recording => $RecordingClient(this);

  $RoomClient get room => $RoomClient(this);

  $SettingsClient get settings => $SettingsClient(this);

  $SignalingClient get signaling => $SignalingClient(this);

  $TempAvatarClient get tempAvatar => $TempAvatarClient(this);
}

class $AvatarClient {
  $AvatarClient(this._rootClient);

  final $Client _rootClient;

  /// Get the avatar of a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [getAvatarRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<Uint8List, void>> getAvatar({
    required String token,
    int? darkTheme,
    AvatarGetAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getAvatarRaw(
      token: token,
      darkTheme: darkTheme,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the avatar of a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [darkTheme] Theme used for background. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [getAvatar] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<Uint8List, void> getAvatarRaw({
    required String token,
    int? darkTheme,
    AvatarGetAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': '*/*',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $darkTheme = jsonSerializers.serialize(darkTheme, specifiedType: const FullType(int));
    $darkTheme ??= 0;
    _parameters['darkTheme'] = $darkTheme;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarGetAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar{?darkTheme*}').expand(_parameters);
    return DynamiteRawResponse<Uint8List, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(Uint8List),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Upload an avatar for a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Avatar invalid
  ///
  /// See:
  ///  * [uploadAvatarRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<AvatarUploadAvatarResponseApplicationJson, void>> uploadAvatar({
    required String token,
    AvatarUploadAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = uploadAvatarRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Upload an avatar for a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Avatar invalid
  ///
  /// See:
  ///  * [uploadAvatar] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<AvatarUploadAvatarResponseApplicationJson, void> uploadAvatarRaw({
    required String token,
    AvatarUploadAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarUploadAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar').expand(_parameters);
    return DynamiteRawResponse<AvatarUploadAvatarResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(AvatarUploadAvatarResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Delete the avatar of a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar removed successfully
  ///
  /// See:
  ///  * [deleteAvatarRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<AvatarDeleteAvatarResponseApplicationJson, void>> deleteAvatar({
    required String token,
    AvatarDeleteAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteAvatarRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete the avatar of a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar removed successfully
  ///
  /// See:
  ///  * [deleteAvatar] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<AvatarDeleteAvatarResponseApplicationJson, void> deleteAvatarRaw({
    required String token,
    AvatarDeleteAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarDeleteAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar').expand(_parameters);
    return DynamiteRawResponse<AvatarDeleteAvatarResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(AvatarDeleteAvatarResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Set an emoji as avatar.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [emoji] Emoji.
  ///   * [color] Color of the emoji.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar set successfully
  ///   * 400: Setting emoji avatar is not possible
  ///
  /// See:
  ///  * [emojiAvatarRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<AvatarEmojiAvatarResponseApplicationJson, void>> emojiAvatar({
    required String emoji,
    required String token,
    String? color,
    AvatarEmojiAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = emojiAvatarRaw(
      emoji: emoji,
      token: token,
      color: color,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set an emoji as avatar.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [emoji] Emoji.
  ///   * [color] Color of the emoji.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar set successfully
  ///   * 400: Setting emoji avatar is not possible
  ///
  /// See:
  ///  * [emojiAvatar] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<AvatarEmojiAvatarResponseApplicationJson, void> emojiAvatarRaw({
    required String emoji,
    required String token,
    String? color,
    AvatarEmojiAvatarApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $emoji = jsonSerializers.serialize(emoji, specifiedType: const FullType(String));
    _parameters['emoji'] = $emoji;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $color = jsonSerializers.serialize(color, specifiedType: const FullType(String));
    _parameters['color'] = $color;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarEmojiAvatarApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar/emoji{?emoji*,color*}')
        .expand(_parameters);
    return DynamiteRawResponse<AvatarEmojiAvatarResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(AvatarEmojiAvatarResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get the dark mode avatar of a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [getAvatarDarkRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<Uint8List, void>> getAvatarDark({
    required String token,
    AvatarGetAvatarDarkApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getAvatarDarkRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the dark mode avatar of a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room avatar returned
  ///
  /// See:
  ///  * [getAvatarDark] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<Uint8List, void> getAvatarDarkRaw({
    required String token,
    AvatarGetAvatarDarkApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': '*/*',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(AvatarGetAvatarDarkApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/avatar/dark').expand(_parameters);
    return DynamiteRawResponse<Uint8List, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(Uint8List),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $BotClient {
  $BotClient(this._rootClient);

  final $Client _rootClient;

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] The message to send.
  ///   * [referenceId] For the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: Sending message is not possible
  ///   * 401: Sending message is not allowed
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [sendMessageRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BotSendMessageResponseApplicationJson, void>> sendMessage({
    required String message,
    required String token,
    String? referenceId,
    int? replyTo,
    int? silent,
    BotSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = sendMessageRaw(
      message: message,
      token: token,
      referenceId: referenceId,
      replyTo: replyTo,
      silent: silent,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] The message to send.
  ///   * [referenceId] For the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: Sending message is not possible
  ///   * 401: Sending message is not allowed
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [sendMessage] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BotSendMessageResponseApplicationJson, void> sendMessageRaw({
    required String message,
    required String token,
    String? referenceId,
    int? replyTo,
    int? silent,
    BotSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $message = jsonSerializers.serialize(message, specifiedType: const FullType(String));
    _parameters['message'] = $message;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $referenceId = jsonSerializers.serialize(referenceId, specifiedType: const FullType(String));
    $referenceId ??= '';
    _parameters['referenceId'] = $referenceId;

    var $replyTo = jsonSerializers.serialize(replyTo, specifiedType: const FullType(int));
    $replyTo ??= 0;
    _parameters['replyTo'] = $replyTo;

    var $silent = jsonSerializers.serialize(silent, specifiedType: const FullType(int));
    $silent ??= 0;
    _parameters['silent'] = $silent;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotSendMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/message{?message*,referenceId*,replyTo*,silent*}',
    ).expand(_parameters);
    return DynamiteRawResponse<BotSendMessageResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201, 400, 401, 413},
      ),
      bodyType: const FullType(BotSendMessageResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Adds a reaction to a chat message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already exists
  ///   * 201: Reacted successfully
  ///   * 400: Reacting is not possible
  ///   * 401: Reacting is not allowed
  ///   * 404: Reaction not found
  ///
  /// See:
  ///  * [reactRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BotReactResponseApplicationJson, void>> react({
    required String reaction,
    required String token,
    required int messageId,
    BotReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = reactRaw(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Adds a reaction to a chat message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already exists
  ///   * 201: Reacted successfully
  ///   * 400: Reacting is not possible
  ///   * 401: Reacting is not allowed
  ///   * 404: Reaction not found
  ///
  /// See:
  ///  * [react] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BotReactResponseApplicationJson, void> reactRaw({
    required String reaction,
    required String token,
    required int messageId,
    BotReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $reaction = jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotReactApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/reaction/{messageId}{?reaction*}')
        .expand(_parameters);
    return DynamiteRawResponse<BotReactResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 201, 400, 401, 404},
      ),
      bodyType: const FullType(BotReactResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Deletes a reaction from a chat message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to delete.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Reacting is not possible
  ///   * 404: Reaction not found
  ///   * 401: Reacting is not allowed
  ///
  /// See:
  ///  * [deleteReactionRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BotDeleteReactionResponseApplicationJson, void>> deleteReaction({
    required String reaction,
    required String token,
    required int messageId,
    BotDeleteReactionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteReactionRaw(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Deletes a reaction from a chat message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Reaction to delete.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token] Conversation token.
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Reacting is not possible
  ///   * 404: Reaction not found
  ///   * 401: Reacting is not allowed
  ///
  /// See:
  ///  * [deleteReaction] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BotDeleteReactionResponseApplicationJson, void> deleteReactionRaw({
    required String reaction,
    required String token,
    required int messageId,
    BotDeleteReactionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $reaction = jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotDeleteReactionApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/reaction/{messageId}{?reaction*}')
        .expand(_parameters);
    return DynamiteRawResponse<BotDeleteReactionResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 400, 404, 401},
      ),
      bodyType: const FullType(BotDeleteReactionResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// List admin bots.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [adminListBotsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BotAdminListBotsResponseApplicationJson, void>> adminListBots({
    BotAdminListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = adminListBotsRaw(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// List admin bots.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [adminListBots] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BotAdminListBotsResponseApplicationJson, void> adminListBotsRaw({
    BotAdminListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotAdminListBotsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/admin').expand(_parameters);
    return DynamiteRawResponse<BotAdminListBotsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BotAdminListBotsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// List bots.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [listBotsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BotListBotsResponseApplicationJson, void>> listBots({
    required String token,
    BotListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = listBotsRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// List bots.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot list returned
  ///
  /// See:
  ///  * [listBots] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BotListBotsResponseApplicationJson, void> listBotsRaw({
    required String token,
    BotListBotsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotListBotsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}').expand(_parameters);
    return DynamiteRawResponse<BotListBotsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BotListBotsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Enables a bot.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot already enabled
  ///   * 201: Bot enabled successfully
  ///   * 400: Enabling bot errored
  ///
  /// See:
  ///  * [enableBotRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BotEnableBotResponseApplicationJson, void>> enableBot({
    required String token,
    required int botId,
    BotEnableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = enableBotRaw(
      token: token,
      botId: botId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Enables a bot.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot already enabled
  ///   * 201: Bot enabled successfully
  ///   * 400: Enabling bot errored
  ///
  /// See:
  ///  * [enableBot] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BotEnableBotResponseApplicationJson, void> enableBotRaw({
    required String token,
    required int botId,
    BotEnableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $botId = jsonSerializers.serialize(botId, specifiedType: const FullType(int));
    _parameters['botId'] = $botId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotEnableBotApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/{botId}').expand(_parameters);
    return DynamiteRawResponse<BotEnableBotResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 201},
      ),
      bodyType: const FullType(BotEnableBotResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Disables a bot.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot disabled successfully
  ///   * 400: Disabling bot errored
  ///
  /// See:
  ///  * [disableBotRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BotDisableBotResponseApplicationJson, void>> disableBot({
    required String token,
    required int botId,
    BotDisableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = disableBotRaw(
      token: token,
      botId: botId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Disables a bot.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [botId] ID of the bot.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bot disabled successfully
  ///   * 400: Disabling bot errored
  ///
  /// See:
  ///  * [disableBot] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BotDisableBotResponseApplicationJson, void> disableBotRaw({
    required String token,
    required int botId,
    BotDisableBotApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $botId = jsonSerializers.serialize(botId, specifiedType: const FullType(int));
    _parameters['botId'] = $botId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BotDisableBotApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bot/{token}/{botId}').expand(_parameters);
    return DynamiteRawResponse<BotDisableBotResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BotDisableBotResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $BreakoutRoomClient {
  $BreakoutRoomClient(this._rootClient);

  final $Client _rootClient;

  /// Configure the breakout rooms.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [mode] Mode of the breakout rooms.
  ///   * [amount] Number of breakout rooms - Constants {@see BreakoutRoom::MINIMUM_ROOM_AMOUNT} and {@see BreakoutRoom::MAXIMUM_ROOM_AMOUNT}.
  ///   * [attendeeMap] Mapping of the attendees to breakout rooms. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms configured successfully
  ///   * 400: Configuring breakout rooms errored
  ///
  /// See:
  ///  * [configureBreakoutRoomsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson, void>> configureBreakoutRooms({
    required BreakoutRoomConfigureBreakoutRoomsMode mode,
    required int amount,
    required String token,
    String? attendeeMap,
    BreakoutRoomConfigureBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = configureBreakoutRoomsRaw(
      mode: mode,
      amount: amount,
      token: token,
      attendeeMap: attendeeMap,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Configure the breakout rooms.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [mode] Mode of the breakout rooms.
  ///   * [amount] Number of breakout rooms - Constants {@see BreakoutRoom::MINIMUM_ROOM_AMOUNT} and {@see BreakoutRoom::MAXIMUM_ROOM_AMOUNT}.
  ///   * [attendeeMap] Mapping of the attendees to breakout rooms. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms configured successfully
  ///   * 400: Configuring breakout rooms errored
  ///
  /// See:
  ///  * [configureBreakoutRooms] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson, void> configureBreakoutRoomsRaw({
    required BreakoutRoomConfigureBreakoutRoomsMode mode,
    required int amount,
    required String token,
    String? attendeeMap,
    BreakoutRoomConfigureBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $mode =
        jsonSerializers.serialize(mode, specifiedType: const FullType(BreakoutRoomConfigureBreakoutRoomsMode));
    _parameters['mode'] = $mode;

    final $amount = jsonSerializers.serialize(amount, specifiedType: const FullType(int));
    _parameters['amount'] = $amount;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $attendeeMap = jsonSerializers.serialize(attendeeMap, specifiedType: const FullType(String));
    $attendeeMap ??= '[]';
    _parameters['attendeeMap'] = $attendeeMap;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomConfigureBreakoutRoomsApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}{?mode*,amount*,attendeeMap*}')
            .expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Remove the breakout rooms.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms removed successfully
  ///
  /// See:
  ///  * [removeBreakoutRoomsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson, void>> removeBreakoutRooms({
    required String token,
    BreakoutRoomRemoveBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = removeBreakoutRoomsRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Remove the breakout rooms.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms removed successfully
  ///
  /// See:
  ///  * [removeBreakoutRooms] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson, void> removeBreakoutRoomsRaw({
    required String token,
    BreakoutRoomRemoveBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomRemoveBreakoutRoomsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}').expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Broadcast a chat message to all breakout rooms.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] Message to broadcast.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Chat message broadcasted successfully
  ///   * 400: Broadcasting chat message is not possible
  ///   * 413: Chat message too long
  ///
  /// See:
  ///  * [broadcastChatMessageRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomBroadcastChatMessageResponseApplicationJson, void>> broadcastChatMessage({
    required String message,
    required String token,
    BreakoutRoomBroadcastChatMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = broadcastChatMessageRaw(
      message: message,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Broadcast a chat message to all breakout rooms.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] Message to broadcast.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Chat message broadcasted successfully
  ///   * 400: Broadcasting chat message is not possible
  ///   * 413: Chat message too long
  ///
  /// See:
  ///  * [broadcastChatMessage] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomBroadcastChatMessageResponseApplicationJson, void> broadcastChatMessageRaw({
    required String message,
    required String token,
    BreakoutRoomBroadcastChatMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $message = jsonSerializers.serialize(message, specifiedType: const FullType(String));
    _parameters['message'] = $message;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomBroadcastChatMessageApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/broadcast{?message*}')
        .expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomBroadcastChatMessageResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201},
      ),
      bodyType: const FullType(BreakoutRoomBroadcastChatMessageResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Apply an attendee map to the breakout rooms.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeMap] JSON encoded mapping of the attendees to breakout rooms `array<int, int>`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee map applied successfully
  ///   * 400: Applying attendee map is not possible
  ///
  /// See:
  ///  * [applyAttendeeMapRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomApplyAttendeeMapResponseApplicationJson, void>> applyAttendeeMap({
    required String attendeeMap,
    required String token,
    BreakoutRoomApplyAttendeeMapApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = applyAttendeeMapRaw(
      attendeeMap: attendeeMap,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Apply an attendee map to the breakout rooms.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeMap] JSON encoded mapping of the attendees to breakout rooms `array<int, int>`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee map applied successfully
  ///   * 400: Applying attendee map is not possible
  ///
  /// See:
  ///  * [applyAttendeeMap] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomApplyAttendeeMapResponseApplicationJson, void> applyAttendeeMapRaw({
    required String attendeeMap,
    required String token,
    BreakoutRoomApplyAttendeeMapApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $attendeeMap = jsonSerializers.serialize(attendeeMap, specifiedType: const FullType(String));
    _parameters['attendeeMap'] = $attendeeMap;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomApplyAttendeeMapApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/attendees{?attendeeMap*}')
            .expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomApplyAttendeeMapResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomApplyAttendeeMapResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Request assistance.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Assistance requested successfully
  ///   * 400: Requesting assistance is not possible
  ///
  /// See:
  ///  * [requestAssistanceRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomRequestAssistanceResponseApplicationJson, void>> requestAssistance({
    required String token,
    BreakoutRoomRequestAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = requestAssistanceRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Request assistance.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Assistance requested successfully
  ///   * 400: Requesting assistance is not possible
  ///
  /// See:
  ///  * [requestAssistance] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomRequestAssistanceResponseApplicationJson, void> requestAssistanceRaw({
    required String token,
    BreakoutRoomRequestAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomRequestAssistanceApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/request-assistance')
        .expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomRequestAssistanceResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomRequestAssistanceResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Reset the request for assistance.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Request for assistance reset successfully
  ///   * 400: Resetting the request for assistance is not possible
  ///
  /// See:
  ///  * [resetRequestForAssistanceRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomResetRequestForAssistanceResponseApplicationJson, void>>
      resetRequestForAssistance({
    required String token,
    BreakoutRoomResetRequestForAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = resetRequestForAssistanceRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Reset the request for assistance.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Request for assistance reset successfully
  ///   * 400: Resetting the request for assistance is not possible
  ///
  /// See:
  ///  * [resetRequestForAssistance] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomResetRequestForAssistanceResponseApplicationJson, void> resetRequestForAssistanceRaw({
    required String token,
    BreakoutRoomResetRequestForAssistanceApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(BreakoutRoomResetRequestForAssistanceApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/request-assistance')
        .expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomResetRequestForAssistanceResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomResetRequestForAssistanceResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Start the breakout rooms.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms started successfully
  ///   * 400: Starting breakout rooms is not possible
  ///
  /// See:
  ///  * [startBreakoutRoomsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomStartBreakoutRoomsResponseApplicationJson, void>> startBreakoutRooms({
    required String token,
    BreakoutRoomStartBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = startBreakoutRoomsRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Start the breakout rooms.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms started successfully
  ///   * 400: Starting breakout rooms is not possible
  ///
  /// See:
  ///  * [startBreakoutRooms] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomStartBreakoutRoomsResponseApplicationJson, void> startBreakoutRoomsRaw({
    required String token,
    BreakoutRoomStartBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomStartBreakoutRoomsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/rooms').expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomStartBreakoutRoomsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomStartBreakoutRoomsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Stop the breakout rooms.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms stopped successfully
  ///   * 400: Stopping breakout rooms is not possible
  ///
  /// See:
  ///  * [stopBreakoutRoomsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomStopBreakoutRoomsResponseApplicationJson, void>> stopBreakoutRooms({
    required String token,
    BreakoutRoomStopBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = stopBreakoutRoomsRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Stop the breakout rooms.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms stopped successfully
  ///   * 400: Stopping breakout rooms is not possible
  ///
  /// See:
  ///  * [stopBreakoutRooms] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomStopBreakoutRoomsResponseApplicationJson, void> stopBreakoutRoomsRaw({
    required String token,
    BreakoutRoomStopBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomStopBreakoutRoomsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/rooms').expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomStopBreakoutRoomsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomStopBreakoutRoomsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Switch to another breakout room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [target] Target breakout room.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Switched to breakout room successfully
  ///   * 400: Switching to breakout room is not possible
  ///
  /// See:
  ///  * [switchBreakoutRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson, void>> switchBreakoutRoom({
    required String target,
    required String token,
    BreakoutRoomSwitchBreakoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = switchBreakoutRoomRaw(
      target: target,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Switch to another breakout room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [target] Target breakout room.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Switched to breakout room successfully
  ///   * 400: Switching to breakout room is not possible
  ///
  /// See:
  ///  * [switchBreakoutRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson, void> switchBreakoutRoomRaw({
    required String target,
    required String token,
    BreakoutRoomSwitchBreakoutRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $target = jsonSerializers.serialize(target, specifiedType: const FullType(String));
    _parameters['target'] = $target;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(BreakoutRoomSwitchBreakoutRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/breakout-rooms/{token}/switch{?target*}')
        .expand(_parameters);
    return DynamiteRawResponse<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $CallClient {
  $CallClient(this._rootClient);

  final $Client _rootClient;

  /// Get the peers for a call.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of peers in the call returned
  ///
  /// See:
  ///  * [getPeersForCallRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<CallGetPeersForCallResponseApplicationJson, void>> getPeersForCall({
    required String token,
    CallGetPeersForCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getPeersForCallRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the peers for a call.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of peers in the call returned
  ///
  /// See:
  ///  * [getPeersForCall] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<CallGetPeersForCallResponseApplicationJson, void> getPeersForCallRaw({
    required String token,
    CallGetPeersForCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallGetPeersForCallApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}').expand(_parameters);
    return DynamiteRawResponse<CallGetPeersForCallResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(CallGetPeersForCallResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update the in-call flags.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] New flags.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: In-call flags updated successfully
  ///   * 400: Updating in-call flags is not possible
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [updateCallFlagsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<CallUpdateCallFlagsResponseApplicationJson, void>> updateCallFlags({
    required int flags,
    required String token,
    CallUpdateCallFlagsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = updateCallFlagsRaw(
      flags: flags,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update the in-call flags.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] New flags.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: In-call flags updated successfully
  ///   * 400: Updating in-call flags is not possible
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [updateCallFlags] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<CallUpdateCallFlagsResponseApplicationJson, void> updateCallFlagsRaw({
    required int flags,
    required String token,
    CallUpdateCallFlagsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $flags = jsonSerializers.serialize(flags, specifiedType: const FullType(int));
    _parameters['flags'] = $flags;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallUpdateCallFlagsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}{?flags*}').expand(_parameters);
    return DynamiteRawResponse<CallUpdateCallFlagsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200, 400, 404},
      ),
      bodyType: const FullType(CallUpdateCallFlagsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Join a call.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] In-Call flags.
  ///   * [forcePermissions] In-call permissions.
  ///   * [silent] Join the call silently. Defaults to `0`.
  ///   * [recordingConsent] When the user ticked a checkbox and agreed with being recorded (Only needed when the `config => call => recording-consent` capability is set to {@see RecordingService::CONSENT_REQUIRED_YES} or the capability is {@see RecordingService::CONSENT_REQUIRED_OPTIONAL} and the conversation `recordingConsent` value is {@see RecordingService::CONSENT_REQUIRED_YES} ). Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call joined successfully
  ///   * 404: Call not found
  ///   * 400: No recording consent was given
  ///
  /// See:
  ///  * [joinCallRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<CallJoinCallResponseApplicationJson, void>> joinCall({
    required String token,
    CallJoinCallFlags? flags,
    CallJoinCallForcePermissions? forcePermissions,
    int? silent,
    int? recordingConsent,
    CallJoinCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = joinCallRaw(
      token: token,
      flags: flags,
      forcePermissions: forcePermissions,
      silent: silent,
      recordingConsent: recordingConsent,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Join a call.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [flags] In-Call flags.
  ///   * [forcePermissions] In-call permissions.
  ///   * [silent] Join the call silently. Defaults to `0`.
  ///   * [recordingConsent] When the user ticked a checkbox and agreed with being recorded (Only needed when the `config => call => recording-consent` capability is set to {@see RecordingService::CONSENT_REQUIRED_YES} or the capability is {@see RecordingService::CONSENT_REQUIRED_OPTIONAL} and the conversation `recordingConsent` value is {@see RecordingService::CONSENT_REQUIRED_YES} ). Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call joined successfully
  ///   * 404: Call not found
  ///   * 400: No recording consent was given
  ///
  /// See:
  ///  * [joinCall] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<CallJoinCallResponseApplicationJson, void> joinCallRaw({
    required String token,
    CallJoinCallFlags? flags,
    CallJoinCallForcePermissions? forcePermissions,
    int? silent,
    int? recordingConsent,
    CallJoinCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $flags = jsonSerializers.serialize(flags, specifiedType: const FullType(CallJoinCallFlags));
    _parameters['flags'] = $flags;

    final $forcePermissions =
        jsonSerializers.serialize(forcePermissions, specifiedType: const FullType(CallJoinCallForcePermissions));
    _parameters['forcePermissions'] = $forcePermissions;

    var $silent = jsonSerializers.serialize(silent, specifiedType: const FullType(int));
    $silent ??= 0;
    _parameters['silent'] = $silent;

    var $recordingConsent = jsonSerializers.serialize(recordingConsent, specifiedType: const FullType(int));
    $recordingConsent ??= 0;
    _parameters['recordingConsent'] = $recordingConsent;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallJoinCallApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}{?flags*,forcePermissions*,silent*,recordingConsent*}',
    ).expand(_parameters);
    return DynamiteRawResponse<CallJoinCallResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 404},
      ),
      bodyType: const FullType(CallJoinCallResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Leave a call.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [all] whether to also terminate the call for all participants. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call left successfully
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [leaveCallRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<CallLeaveCallResponseApplicationJson, void>> leaveCall({
    required String token,
    int? all,
    CallLeaveCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = leaveCallRaw(
      token: token,
      all: all,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Leave a call.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [all] whether to also terminate the call for all participants. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call left successfully
  ///   * 404: Call session not found
  ///
  /// See:
  ///  * [leaveCall] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<CallLeaveCallResponseApplicationJson, void> leaveCallRaw({
    required String token,
    int? all,
    CallLeaveCallApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $all = jsonSerializers.serialize(all, specifiedType: const FullType(int));
    $all ??= 0;
    _parameters['all'] = $all;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallLeaveCallApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}{?all*}').expand(_parameters);
    return DynamiteRawResponse<CallLeaveCallResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 404},
      ),
      bodyType: const FullType(CallLeaveCallResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Ring an attendee.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to ring.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee rang successfully
  ///   * 400: Ringing attendee is not possible
  ///   * 404: Attendee could not be found
  ///
  /// See:
  ///  * [ringAttendeeRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<CallRingAttendeeResponseApplicationJson, void>> ringAttendee({
    required String token,
    required int attendeeId,
    CallRingAttendeeApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = ringAttendeeRaw(
      token: token,
      attendeeId: attendeeId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Ring an attendee.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to ring.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee rang successfully
  ///   * 400: Ringing attendee is not possible
  ///   * 404: Attendee could not be found
  ///
  /// See:
  ///  * [ringAttendee] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<CallRingAttendeeResponseApplicationJson, void> ringAttendeeRaw({
    required String token,
    required int attendeeId,
    CallRingAttendeeApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $attendeeId = jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallRingAttendeeApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}/ring/{attendeeId}').expand(_parameters);
    return DynamiteRawResponse<CallRingAttendeeResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 400, 404},
      ),
      bodyType: const FullType(CallRingAttendeeResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Call a SIP dial-out attendee.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to call.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Dial-out initiated successfully
  ///   * 400: SIP dial-out not possible
  ///   * 404: Participant could not be found or is a wrong type
  ///   * 501: SIP dial-out is not configured on the server
  ///
  /// See:
  ///  * [sipDialOutRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<CallSipDialOutResponseApplicationJson, void>> sipDialOut({
    required String token,
    required int attendeeId,
    CallSipDialOutApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = sipDialOutRaw(
      token: token,
      attendeeId: attendeeId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Call a SIP dial-out attendee.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [attendeeId] ID of the attendee to call.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Dial-out initiated successfully
  ///   * 400: SIP dial-out not possible
  ///   * 404: Participant could not be found or is a wrong type
  ///   * 501: SIP dial-out is not configured on the server
  ///
  /// See:
  ///  * [sipDialOut] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<CallSipDialOutResponseApplicationJson, void> sipDialOutRaw({
    required String token,
    required int attendeeId,
    CallSipDialOutApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $attendeeId = jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(CallSipDialOutApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/call/{token}/dialout/{attendeeId}').expand(_parameters);
    return DynamiteRawResponse<CallSipDialOutResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201, 400, 404, 501},
      ),
      bodyType: const FullType(CallSipDialOutResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $CertificateClient {
  $CertificateClient(this._rootClient);

  final $Client _rootClient;

  /// Get the certificate expiration for a host.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [host] Host to check.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Certificate expiration returned
  ///   * 400: Getting certificate expiration is not possible
  ///
  /// See:
  ///  * [getCertificateExpirationRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<CertificateGetCertificateExpirationResponseApplicationJson, void>> getCertificateExpiration({
    required String host,
    CertificateGetCertificateExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getCertificateExpirationRaw(
      host: host,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the certificate expiration for a host.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [host] Host to check.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Certificate expiration returned
  ///   * 400: Getting certificate expiration is not possible
  ///
  /// See:
  ///  * [getCertificateExpiration] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<CertificateGetCertificateExpirationResponseApplicationJson, void> getCertificateExpirationRaw({
    required String host,
    CertificateGetCertificateExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $host = jsonSerializers.serialize(host, specifiedType: const FullType(String));
    _parameters['host'] = $host;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(CertificateGetCertificateExpirationApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/certificate/expiration{?host*}').expand(_parameters);
    return DynamiteRawResponse<CertificateGetCertificateExpirationResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(CertificateGetCertificateExpirationResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $ChatClient {
  $ChatClient(this._rootClient);

  final $Client _rootClient;

  /// Receives chat messages from the given room.
  ///
  /// - Receiving the history ($lookIntoFuture=0): The next $limit messages after $lastKnownMessageId will be returned. The new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// - Looking into the future ($lookIntoFuture=1): If there are currently no messages the response will not be sent immediately. Instead, HTTP connection will be kept open waiting for new messages to arrive and, when they do, then the response will be sent. The connection will not be kept open indefinitely, though; the number of seconds to wait for new messages to arrive can be set using the timeout parameter; the default timeout is 30 seconds, maximum timeout is 60 seconds. If the timeout ends a successful but empty response will be sent. If messages have been returned (status=200) the new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// The limit specifies the maximum number of messages that will be returned, although the actual number of returned messages could be lower if some messages are not visible to the participant. Note that if none of the messages are visible to the participant the returned number of messages will be 0, yet the status will still be 200. Also note that `X-Chat-Last-Given` may reference a message not visible and thus not returned, but it should be used nevertheless as the $lastKnownMessageId for the follow-up query.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lookIntoFuture] Polling for new messages (1) or getting the history of the chat (0).
  ///   * [limit] Number of chat messages to receive (100 by default, 200 at most). Defaults to `100`.
  ///   * [lastKnownMessageId] The last known message (serves as offset). Defaults to `0`.
  ///   * [lastCommonReadId] The last known common read message (so the response is 200 instead of 304 when it changes even when there are no messages). Defaults to `0`.
  ///   * [timeout] Number of seconds to wait for new messages (30 by default, 30 at most). Defaults to `30`.
  ///   * [setReadMarker] Automatically set the last read marker when 1, if your client does this itself via chat/{token}/read set to 0. Defaults to `1`.
  ///   * [includeLastKnown] Include the $lastKnownMessageId in the messages when 1 (default 0). Defaults to `0`.
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [markNotificationsAsRead] Set to 0 when notifications should not be marked as read (default 1). Defaults to `1`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Messages returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [receiveMessagesRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatReceiveMessagesResponseApplicationJson, ChatChatReceiveMessagesHeaders>> receiveMessages({
    required ChatReceiveMessagesLookIntoFuture lookIntoFuture,
    required String token,
    int? limit,
    int? lastKnownMessageId,
    int? lastCommonReadId,
    int? timeout,
    ChatReceiveMessagesSetReadMarker? setReadMarker,
    ChatReceiveMessagesIncludeLastKnown? includeLastKnown,
    ChatReceiveMessagesNoStatusUpdate? noStatusUpdate,
    ChatReceiveMessagesMarkNotificationsAsRead? markNotificationsAsRead,
    ChatReceiveMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = receiveMessagesRaw(
      lookIntoFuture: lookIntoFuture,
      token: token,
      limit: limit,
      lastKnownMessageId: lastKnownMessageId,
      lastCommonReadId: lastCommonReadId,
      timeout: timeout,
      setReadMarker: setReadMarker,
      includeLastKnown: includeLastKnown,
      noStatusUpdate: noStatusUpdate,
      markNotificationsAsRead: markNotificationsAsRead,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Receives chat messages from the given room.
  ///
  /// - Receiving the history ($lookIntoFuture=0): The next $limit messages after $lastKnownMessageId will be returned. The new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// - Looking into the future ($lookIntoFuture=1): If there are currently no messages the response will not be sent immediately. Instead, HTTP connection will be kept open waiting for new messages to arrive and, when they do, then the response will be sent. The connection will not be kept open indefinitely, though; the number of seconds to wait for new messages to arrive can be set using the timeout parameter; the default timeout is 30 seconds, maximum timeout is 60 seconds. If the timeout ends a successful but empty response will be sent. If messages have been returned (status=200) the new $lastKnownMessageId for the follow up query is available as `X-Chat-Last-Given` header.
  /// The limit specifies the maximum number of messages that will be returned, although the actual number of returned messages could be lower if some messages are not visible to the participant. Note that if none of the messages are visible to the participant the returned number of messages will be 0, yet the status will still be 200. Also note that `X-Chat-Last-Given` may reference a message not visible and thus not returned, but it should be used nevertheless as the $lastKnownMessageId for the follow-up query.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lookIntoFuture] Polling for new messages (1) or getting the history of the chat (0).
  ///   * [limit] Number of chat messages to receive (100 by default, 200 at most). Defaults to `100`.
  ///   * [lastKnownMessageId] The last known message (serves as offset). Defaults to `0`.
  ///   * [lastCommonReadId] The last known common read message (so the response is 200 instead of 304 when it changes even when there are no messages). Defaults to `0`.
  ///   * [timeout] Number of seconds to wait for new messages (30 by default, 30 at most). Defaults to `30`.
  ///   * [setReadMarker] Automatically set the last read marker when 1, if your client does this itself via chat/{token}/read set to 0. Defaults to `1`.
  ///   * [includeLastKnown] Include the $lastKnownMessageId in the messages when 1 (default 0). Defaults to `0`.
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [markNotificationsAsRead] Set to 0 when notifications should not be marked as read (default 1). Defaults to `1`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Messages returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [receiveMessages] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatReceiveMessagesResponseApplicationJson, ChatChatReceiveMessagesHeaders> receiveMessagesRaw({
    required ChatReceiveMessagesLookIntoFuture lookIntoFuture,
    required String token,
    int? limit,
    int? lastKnownMessageId,
    int? lastCommonReadId,
    int? timeout,
    ChatReceiveMessagesSetReadMarker? setReadMarker,
    ChatReceiveMessagesIncludeLastKnown? includeLastKnown,
    ChatReceiveMessagesNoStatusUpdate? noStatusUpdate,
    ChatReceiveMessagesMarkNotificationsAsRead? markNotificationsAsRead,
    ChatReceiveMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $lookIntoFuture =
        jsonSerializers.serialize(lookIntoFuture, specifiedType: const FullType(ChatReceiveMessagesLookIntoFuture));
    _parameters['lookIntoFuture'] = $lookIntoFuture;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $limit = jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 100;
    _parameters['limit'] = $limit;

    var $lastKnownMessageId = jsonSerializers.serialize(lastKnownMessageId, specifiedType: const FullType(int));
    $lastKnownMessageId ??= 0;
    _parameters['lastKnownMessageId'] = $lastKnownMessageId;

    var $lastCommonReadId = jsonSerializers.serialize(lastCommonReadId, specifiedType: const FullType(int));
    $lastCommonReadId ??= 0;
    _parameters['lastCommonReadId'] = $lastCommonReadId;

    var $timeout = jsonSerializers.serialize(timeout, specifiedType: const FullType(int));
    $timeout ??= 30;
    _parameters['timeout'] = $timeout;

    var $setReadMarker =
        jsonSerializers.serialize(setReadMarker, specifiedType: const FullType(ChatReceiveMessagesSetReadMarker));
    $setReadMarker ??= 1;
    _parameters['setReadMarker'] = $setReadMarker;

    var $includeLastKnown =
        jsonSerializers.serialize(includeLastKnown, specifiedType: const FullType(ChatReceiveMessagesIncludeLastKnown));
    $includeLastKnown ??= 0;
    _parameters['includeLastKnown'] = $includeLastKnown;

    var $noStatusUpdate =
        jsonSerializers.serialize(noStatusUpdate, specifiedType: const FullType(ChatReceiveMessagesNoStatusUpdate));
    $noStatusUpdate ??= 0;
    _parameters['noStatusUpdate'] = $noStatusUpdate;

    var $markNotificationsAsRead = jsonSerializers.serialize(
      markNotificationsAsRead,
      specifiedType: const FullType(ChatReceiveMessagesMarkNotificationsAsRead),
    );
    $markNotificationsAsRead ??= 1;
    _parameters['markNotificationsAsRead'] = $markNotificationsAsRead;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatReceiveMessagesApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}{?lookIntoFuture*,limit*,lastKnownMessageId*,lastCommonReadId*,timeout*,setReadMarker*,includeLastKnown*,noStatusUpdate*,markNotificationsAsRead*}',
    ).expand(_parameters);
    return DynamiteRawResponse<ChatReceiveMessagesResponseApplicationJson, ChatChatReceiveMessagesHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200, 304},
      ),
      bodyType: const FullType(ChatReceiveMessagesResponseApplicationJson),
      headersType: const FullType(ChatChatReceiveMessagesHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] the message to send.
  ///   * [actorDisplayName] for guests. Defaults to `''`.
  ///   * [referenceId] for the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: Sending message is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [sendMessageRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatSendMessageResponseApplicationJson, ChatChatSendMessageHeaders>> sendMessage({
    required String message,
    required String token,
    String? actorDisplayName,
    String? referenceId,
    int? replyTo,
    int? silent,
    ChatSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = sendMessageRaw(
      message: message,
      token: token,
      actorDisplayName: actorDisplayName,
      referenceId: referenceId,
      replyTo: replyTo,
      silent: silent,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Sends a new chat message to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [message] the message to send.
  ///   * [actorDisplayName] for guests. Defaults to `''`.
  ///   * [referenceId] for the message to be able to later identify it again. Defaults to `''`.
  ///   * [replyTo] Parent id which this message is a reply to. Defaults to `0`.
  ///   * [silent] If sent silent the chat message will not create any notifications. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Message sent successfully
  ///   * 400: Sending message is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [sendMessage] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatSendMessageResponseApplicationJson, ChatChatSendMessageHeaders> sendMessageRaw({
    required String message,
    required String token,
    String? actorDisplayName,
    String? referenceId,
    int? replyTo,
    int? silent,
    ChatSendMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $message = jsonSerializers.serialize(message, specifiedType: const FullType(String));
    _parameters['message'] = $message;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $actorDisplayName = jsonSerializers.serialize(actorDisplayName, specifiedType: const FullType(String));
    $actorDisplayName ??= '';
    _parameters['actorDisplayName'] = $actorDisplayName;

    var $referenceId = jsonSerializers.serialize(referenceId, specifiedType: const FullType(String));
    $referenceId ??= '';
    _parameters['referenceId'] = $referenceId;

    var $replyTo = jsonSerializers.serialize(replyTo, specifiedType: const FullType(int));
    $replyTo ??= 0;
    _parameters['replyTo'] = $replyTo;

    var $silent = jsonSerializers.serialize(silent, specifiedType: const FullType(int));
    $silent ??= 0;
    _parameters['silent'] = $silent;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatSendMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}{?message*,actorDisplayName*,referenceId*,replyTo*,silent*}',
    ).expand(_parameters);
    return DynamiteRawResponse<ChatSendMessageResponseApplicationJson, ChatChatSendMessageHeaders>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201},
      ),
      bodyType: const FullType(ChatSendMessageResponseApplicationJson),
      headersType: const FullType(ChatChatSendMessageHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Clear the chat history.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: History cleared successfully
  ///   * 202: History cleared successfully, but Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 403: Missing permissions to clear history
  ///
  /// See:
  ///  * [clearHistoryRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatClearHistoryResponseApplicationJson, ChatChatClearHistoryHeaders>> clearHistory({
    required String token,
    ChatClearHistoryApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = clearHistoryRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Clear the chat history.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: History cleared successfully
  ///   * 202: History cleared successfully, but Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 403: Missing permissions to clear history
  ///
  /// See:
  ///  * [clearHistory] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatClearHistoryResponseApplicationJson, ChatChatClearHistoryHeaders> clearHistoryRaw({
    required String token,
    ChatClearHistoryApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatClearHistoryApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}').expand(_parameters);
    return DynamiteRawResponse<ChatClearHistoryResponseApplicationJson, ChatChatClearHistoryHeaders>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 202},
      ),
      bodyType: const FullType(ChatClearHistoryResponseApplicationJson),
      headersType: const FullType(ChatChatClearHistoryHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Delete a chat message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message deleted successfully
  ///   * 202: Message deleted successfully, but Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 400: Deleting message is not possible
  ///   * 403: Missing permissions to delete message
  ///   * 404: Message not found
  ///   * 405: Deleting message is not allowed
  ///
  /// See:
  ///  * [deleteMessageRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatDeleteMessageResponseApplicationJson, ChatChatDeleteMessageHeaders>> deleteMessage({
    required String token,
    required int messageId,
    ChatDeleteMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteMessageRaw(
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete a chat message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message deleted successfully
  ///   * 202: Message deleted successfully, but Matterbridge is configured, so the information can be replicated elsewhere
  ///   * 400: Deleting message is not possible
  ///   * 403: Missing permissions to delete message
  ///   * 404: Message not found
  ///   * 405: Deleting message is not allowed
  ///
  /// See:
  ///  * [deleteMessage] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatDeleteMessageResponseApplicationJson, ChatChatDeleteMessageHeaders> deleteMessageRaw({
    required String token,
    required int messageId,
    ChatDeleteMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatDeleteMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}').expand(_parameters);
    return DynamiteRawResponse<ChatDeleteMessageResponseApplicationJson, ChatChatDeleteMessageHeaders>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 202},
      ),
      bodyType: const FullType(ChatDeleteMessageResponseApplicationJson),
      headersType: const FullType(ChatChatDeleteMessageHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Get the context of a message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Number of chat messages to receive in both directions (50 by default, 100 at most, might return 201 messages). Defaults to `50`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] The focused message which should be in the "middle" of the returned context.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message context returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [getMessageContextRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatGetMessageContextResponseApplicationJson, ChatChatGetMessageContextHeaders>>
      getMessageContext({
    required String token,
    required int messageId,
    int? limit,
    ChatGetMessageContextApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getMessageContextRaw(
      token: token,
      messageId: messageId,
      limit: limit,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the context of a message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Number of chat messages to receive in both directions (50 by default, 100 at most, might return 201 messages). Defaults to `50`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] The focused message which should be in the "middle" of the returned context.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message context returned
  ///   * 304: No messages
  ///
  /// See:
  ///  * [getMessageContext] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatGetMessageContextResponseApplicationJson, ChatChatGetMessageContextHeaders>
      getMessageContextRaw({
    required String token,
    required int messageId,
    int? limit,
    ChatGetMessageContextApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $limit = jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 50;
    _parameters['limit'] = $limit;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatGetMessageContextApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/context{?limit*}')
        .expand(_parameters);
    return DynamiteRawResponse<ChatGetMessageContextResponseApplicationJson, ChatChatGetMessageContextHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200, 304},
      ),
      bodyType: const FullType(ChatGetMessageContextResponseApplicationJson),
      headersType: const FullType(ChatChatGetMessageContextHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Get the reminder for a chat message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder returned
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [getReminderRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatGetReminderResponseApplicationJson, void>> getReminder({
    required String token,
    required int messageId,
    ChatGetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getReminderRaw(
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the reminder for a chat message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder returned
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [getReminder] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatGetReminderResponseApplicationJson, void> getReminderRaw({
    required String token,
    required int messageId,
    ChatGetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatGetReminderApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/reminder').expand(_parameters);
    return DynamiteRawResponse<ChatGetReminderResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ChatGetReminderResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Set a reminder for a chat message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the reminder.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Reminder created successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [setReminderRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatSetReminderResponseApplicationJson, void>> setReminder({
    required int timestamp,
    required String token,
    required int messageId,
    ChatSetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setReminderRaw(
      timestamp: timestamp,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set a reminder for a chat message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the reminder.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Reminder created successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [setReminder] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatSetReminderResponseApplicationJson, void> setReminderRaw({
    required int timestamp,
    required String token,
    required int messageId,
    ChatSetReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $timestamp = jsonSerializers.serialize(timestamp, specifiedType: const FullType(int));
    _parameters['timestamp'] = $timestamp;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatSetReminderApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/reminder{?timestamp*}')
        .expand(_parameters);
    return DynamiteRawResponse<ChatSetReminderResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201},
      ),
      bodyType: const FullType(ChatSetReminderResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Delete a chat reminder.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder deleted successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [deleteReminderRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatDeleteReminderResponseApplicationJson, void>> deleteReminder({
    required String token,
    required int messageId,
    ChatDeleteReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteReminderRaw(
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete a chat reminder.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reminder deleted successfully
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [deleteReminder] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatDeleteReminderResponseApplicationJson, void> deleteReminderRaw({
    required String token,
    required int messageId,
    ChatDeleteReminderApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatDeleteReminderApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/{messageId}/reminder').expand(_parameters);
    return DynamiteRawResponse<ChatDeleteReminderResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 404},
      ),
      bodyType: const FullType(ChatDeleteReminderResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Set the read marker to a specific message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lastReadMessage] ID if the last read message.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [setReadMarkerRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatSetReadMarkerResponseApplicationJson, ChatChatSetReadMarkerHeaders>> setReadMarker({
    required int lastReadMessage,
    required String token,
    ChatSetReadMarkerApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setReadMarkerRaw(
      lastReadMessage: lastReadMessage,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set the read marker to a specific message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [lastReadMessage] ID if the last read message.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [setReadMarker] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatSetReadMarkerResponseApplicationJson, ChatChatSetReadMarkerHeaders> setReadMarkerRaw({
    required int lastReadMessage,
    required String token,
    ChatSetReadMarkerApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $lastReadMessage = jsonSerializers.serialize(lastReadMessage, specifiedType: const FullType(int));
    _parameters['lastReadMessage'] = $lastReadMessage;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatSetReadMarkerApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/read{?lastReadMessage*}')
        .expand(_parameters);
    return DynamiteRawResponse<ChatSetReadMarkerResponseApplicationJson, ChatChatSetReadMarkerHeaders>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ChatSetReadMarkerResponseApplicationJson),
      headersType: const FullType(ChatChatSetReadMarkerHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Mark a chat as unread.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [markUnreadRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatMarkUnreadResponseApplicationJson, ChatChatMarkUnreadHeaders>> markUnread({
    required String token,
    ChatMarkUnreadApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = markUnreadRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Mark a chat as unread.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read marker set successfully
  ///
  /// See:
  ///  * [markUnread] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatMarkUnreadResponseApplicationJson, ChatChatMarkUnreadHeaders> markUnreadRaw({
    required String token,
    ChatMarkUnreadApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatMarkUnreadApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/read').expand(_parameters);
    return DynamiteRawResponse<ChatMarkUnreadResponseApplicationJson, ChatChatMarkUnreadHeaders>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ChatMarkUnreadResponseApplicationJson),
      headersType: const FullType(ChatChatMarkUnreadHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Search for mentions.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [search] Text to search for.
  ///   * [limit] Maximum number of results. Defaults to `20`.
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of mention suggestions returned
  ///
  /// See:
  ///  * [mentionsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatMentionsResponseApplicationJson, void>> mentions({
    required String search,
    required String token,
    int? limit,
    int? includeStatus,
    ChatMentionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = mentionsRaw(
      search: search,
      token: token,
      limit: limit,
      includeStatus: includeStatus,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Search for mentions.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [search] Text to search for.
  ///   * [limit] Maximum number of results. Defaults to `20`.
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of mention suggestions returned
  ///
  /// See:
  ///  * [mentions] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatMentionsResponseApplicationJson, void> mentionsRaw({
    required String search,
    required String token,
    int? limit,
    int? includeStatus,
    ChatMentionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $search = jsonSerializers.serialize(search, specifiedType: const FullType(String));
    _parameters['search'] = $search;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $limit = jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 20;
    _parameters['limit'] = $limit;

    var $includeStatus = jsonSerializers.serialize(includeStatus, specifiedType: const FullType(int));
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatMentionsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/mentions{?search*,limit*,includeStatus*}')
            .expand(_parameters);
    return DynamiteRawResponse<ChatMentionsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ChatMentionsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get objects that are shared in the room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the objects.
  ///   * [lastKnownMessageId] ID of the last known message. Defaults to `0`.
  ///   * [limit] Maximum number of objects. Defaults to `100`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages returned
  ///
  /// See:
  ///  * [getObjectsSharedInRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatGetObjectsSharedInRoomResponseApplicationJson, ChatChatGetObjectsSharedInRoomHeaders>>
      getObjectsSharedInRoom({
    required String objectType,
    required String token,
    int? lastKnownMessageId,
    int? limit,
    ChatGetObjectsSharedInRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getObjectsSharedInRoomRaw(
      objectType: objectType,
      token: token,
      lastKnownMessageId: lastKnownMessageId,
      limit: limit,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get objects that are shared in the room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the objects.
  ///   * [lastKnownMessageId] ID of the last known message. Defaults to `0`.
  ///   * [limit] Maximum number of objects. Defaults to `100`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages returned
  ///
  /// See:
  ///  * [getObjectsSharedInRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatGetObjectsSharedInRoomResponseApplicationJson, ChatChatGetObjectsSharedInRoomHeaders>
      getObjectsSharedInRoomRaw({
    required String objectType,
    required String token,
    int? lastKnownMessageId,
    int? limit,
    ChatGetObjectsSharedInRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $objectType = jsonSerializers.serialize(objectType, specifiedType: const FullType(String));
    _parameters['objectType'] = $objectType;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $lastKnownMessageId = jsonSerializers.serialize(lastKnownMessageId, specifiedType: const FullType(int));
    $lastKnownMessageId ??= 0;
    _parameters['lastKnownMessageId'] = $lastKnownMessageId;

    var $limit = jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 100;
    _parameters['limit'] = $limit;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatGetObjectsSharedInRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/share{?objectType*,lastKnownMessageId*,limit*}',
    ).expand(_parameters);
    return DynamiteRawResponse<ChatGetObjectsSharedInRoomResponseApplicationJson,
        ChatChatGetObjectsSharedInRoomHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ChatGetObjectsSharedInRoomResponseApplicationJson),
      headersType: const FullType(ChatChatGetObjectsSharedInRoomHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Sends a rich-object to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the object.
  ///   * [objectId] ID of the object.
  ///   * [metaData] Additional metadata. Defaults to `''`.
  ///   * [actorDisplayName] Guest name. Defaults to `''`.
  ///   * [referenceId] Reference ID. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Object shared successfully
  ///   * 400: Sharing object is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [shareObjectToChatRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatShareObjectToChatResponseApplicationJson, ChatChatShareObjectToChatHeaders>>
      shareObjectToChat({
    required String objectType,
    required String objectId,
    required String token,
    String? metaData,
    String? actorDisplayName,
    String? referenceId,
    ChatShareObjectToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = shareObjectToChatRaw(
      objectType: objectType,
      objectId: objectId,
      token: token,
      metaData: metaData,
      actorDisplayName: actorDisplayName,
      referenceId: referenceId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Sends a rich-object to the given room.
  ///
  /// The author and timestamp are automatically set to the current user/guest and time.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [objectType] Type of the object.
  ///   * [objectId] ID of the object.
  ///   * [metaData] Additional metadata. Defaults to `''`.
  ///   * [actorDisplayName] Guest name. Defaults to `''`.
  ///   * [referenceId] Reference ID. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Object shared successfully
  ///   * 400: Sharing object is not possible
  ///   * 404: Actor not found
  ///   * 413: Message too long
  ///
  /// See:
  ///  * [shareObjectToChat] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatShareObjectToChatResponseApplicationJson, ChatChatShareObjectToChatHeaders>
      shareObjectToChatRaw({
    required String objectType,
    required String objectId,
    required String token,
    String? metaData,
    String? actorDisplayName,
    String? referenceId,
    ChatShareObjectToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $objectType = jsonSerializers.serialize(objectType, specifiedType: const FullType(String));
    _parameters['objectType'] = $objectType;

    final $objectId = jsonSerializers.serialize(objectId, specifiedType: const FullType(String));
    _parameters['objectId'] = $objectId;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $metaData = jsonSerializers.serialize(metaData, specifiedType: const FullType(String));
    $metaData ??= '';
    _parameters['metaData'] = $metaData;

    var $actorDisplayName = jsonSerializers.serialize(actorDisplayName, specifiedType: const FullType(String));
    $actorDisplayName ??= '';
    _parameters['actorDisplayName'] = $actorDisplayName;

    var $referenceId = jsonSerializers.serialize(referenceId, specifiedType: const FullType(String));
    $referenceId ??= '';
    _parameters['referenceId'] = $referenceId;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ChatShareObjectToChatApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/share{?objectType*,objectId*,metaData*,actorDisplayName*,referenceId*}',
    ).expand(_parameters);
    return DynamiteRawResponse<ChatShareObjectToChatResponseApplicationJson, ChatChatShareObjectToChatHeaders>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201},
      ),
      bodyType: const FullType(ChatShareObjectToChatResponseApplicationJson),
      headersType: const FullType(ChatChatShareObjectToChatHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Get objects that are shared in the room overview.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Maximum number of objects. Defaults to `7`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages of each type returned
  ///
  /// See:
  ///  * [getObjectsSharedInRoomOverviewRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson, void>>
      getObjectsSharedInRoomOverview({
    required String token,
    int? limit,
    ChatGetObjectsSharedInRoomOverviewApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getObjectsSharedInRoomOverviewRaw(
      token: token,
      limit: limit,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get objects that are shared in the room overview.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [limit] Maximum number of objects. Defaults to `7`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: List of shared objects messages of each type returned
  ///
  /// See:
  ///  * [getObjectsSharedInRoomOverview] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson, void>
      getObjectsSharedInRoomOverviewRaw({
    required String token,
    int? limit,
    ChatGetObjectsSharedInRoomOverviewApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $limit = jsonSerializers.serialize(limit, specifiedType: const FullType(int));
    $limit ??= 7;
    _parameters['limit'] = $limit;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(ChatGetObjectsSharedInRoomOverviewApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/chat/{token}/share/overview{?limit*}')
        .expand(_parameters);
    return DynamiteRawResponse<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $FilesIntegrationClient {
  $FilesIntegrationClient(this._rootClient);

  final $Client _rootClient;

  /// Get the token of the room associated to the given file id.
  ///
  /// This is the counterpart of self::getRoomByShareToken() for file ids instead of share tokens, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the given file id a new room is created; the new room is a public room associated with a "file" object with the given file id. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be shared and the user must be the owner of a public share of the file (like a link share, for example) or have direct access to that file; an error is returned otherwise. A user has direct access to a file if she has access to it (or to an ancestor) through a user, group, circle or room share (but not through a link share, for example), or if she is the owner of such a file.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [fileId] ID of the file.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [getRoomByFileIdRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<FilesIntegrationGetRoomByFileIdResponseApplicationJson, void>> getRoomByFileId({
    required String fileId,
    FilesIntegrationGetRoomByFileIdApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getRoomByFileIdRaw(
      fileId: fileId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the token of the room associated to the given file id.
  ///
  /// This is the counterpart of self::getRoomByShareToken() for file ids instead of share tokens, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the given file id a new room is created; the new room is a public room associated with a "file" object with the given file id. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be shared and the user must be the owner of a public share of the file (like a link share, for example) or have direct access to that file; an error is returned otherwise. A user has direct access to a file if she has access to it (or to an ancestor) through a user, group, circle or room share (but not through a link share, for example), or if she is the owner of such a file.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [fileId] ID of the file.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [getRoomByFileId] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<FilesIntegrationGetRoomByFileIdResponseApplicationJson, void> getRoomByFileIdRaw({
    required String fileId,
    FilesIntegrationGetRoomByFileIdApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $fileId = jsonSerializers.serialize(fileId, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($fileId as String?, RegExp(r'^.+$'), 'fileId');
    _parameters['fileId'] = $fileId;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(FilesIntegrationGetRoomByFileIdApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/file/{fileId}').expand(_parameters);
    return DynamiteRawResponse<FilesIntegrationGetRoomByFileIdResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Returns the token of the room associated to the file of the given share token.
  ///
  /// This is the counterpart of self::getRoomByFileId() for share tokens instead of file ids, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the file id of the given share token a new room is created; the new room is a public room associated with a "file" object with the file id of the given share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be publicly shared (like a link share, for example); an error is returned otherwise.
  /// Besides the token of the room this also returns the current user ID and display name, if any; this is needed by the Talk sidebar to know the actual current user, as the public share page uses the incognito mode and thus logged-in users as seen as guests.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [shareToken] Token of the file share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token and user info returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [getRoomByShareTokenRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<FilesIntegrationGetRoomByShareTokenResponseApplicationJson, void>> getRoomByShareToken({
    required String shareToken,
    FilesIntegrationGetRoomByShareTokenApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getRoomByShareTokenRaw(
      shareToken: shareToken,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Returns the token of the room associated to the file of the given share token.
  ///
  /// This is the counterpart of self::getRoomByFileId() for share tokens instead of file ids, although both return the same room token if the given file id and share token refer to the same file.
  /// If there is no room associated to the file id of the given share token a new room is created; the new room is a public room associated with a "file" object with the file id of the given share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms without owner (although self joined users with direct access to the file become persistent participants automatically when they join until they explicitly leave or no longer have access to the file).
  /// In any case, to create or even get the token of the room, the file must be publicly shared (like a link share, for example); an error is returned otherwise.
  /// Besides the token of the room this also returns the current user ID and display name, if any; this is needed by the Talk sidebar to know the actual current user, as the public share page uses the incognito mode and thus logged-in users as seen as guests.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [shareToken] Token of the file share.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room token and user info returned
  ///   * 400: Rooms not allowed for shares
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [getRoomByShareToken] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<FilesIntegrationGetRoomByShareTokenResponseApplicationJson, void> getRoomByShareTokenRaw({
    required String shareToken,
    FilesIntegrationGetRoomByShareTokenApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $shareToken = jsonSerializers.serialize(shareToken, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($shareToken as String?, RegExp(r'^.+$'), 'shareToken');
    _parameters['shareToken'] = $shareToken;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(FilesIntegrationGetRoomByShareTokenApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/publicshare/{shareToken}').expand(_parameters);
    return DynamiteRawResponse<FilesIntegrationGetRoomByShareTokenResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $GuestClient {
  $GuestClient(this._rootClient);

  final $Client _rootClient;

  /// Set the display name as a guest.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [displayName] New display name.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Display name updated successfully
  ///   * 403: Not a guest
  ///   * 404: Not a participant
  ///
  /// See:
  ///  * [setDisplayNameRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<GuestSetDisplayNameResponseApplicationJson, void>> setDisplayName({
    required String displayName,
    required String token,
    GuestSetDisplayNameApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setDisplayNameRaw(
      displayName: displayName,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set the display name as a guest.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [displayName] New display name.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Display name updated successfully
  ///   * 403: Not a guest
  ///   * 404: Not a participant
  ///
  /// See:
  ///  * [setDisplayName] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<GuestSetDisplayNameResponseApplicationJson, void> setDisplayNameRaw({
    required String displayName,
    required String token,
    GuestSetDisplayNameApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $displayName = jsonSerializers.serialize(displayName, specifiedType: const FullType(String));
    _parameters['displayName'] = $displayName;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(GuestSetDisplayNameApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/guest/{token}/name{?displayName*}').expand(_parameters);
    return DynamiteRawResponse<GuestSetDisplayNameResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 403, 404},
      ),
      bodyType: const FullType(GuestSetDisplayNameResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $HostedSignalingServerClient {
  $HostedSignalingServerClient(this._rootClient);

  final $Client _rootClient;

  /// Request a trial account.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [url] Server URL.
  ///   * [name] Display name of the user.
  ///   * [email] Email of the user.
  ///   * [language] Language of the user.
  ///   * [country] Country of the user.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Trial requested successfully
  ///   * 400: Requesting trial is not possible
  ///   * 500
  ///
  /// See:
  ///  * [requestTrialRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<HostedSignalingServerRequestTrialResponseApplicationJson, void>> requestTrial({
    required String url,
    required String name,
    required String email,
    required String language,
    required String country,
    HostedSignalingServerRequestTrialApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = requestTrialRaw(
      url: url,
      name: name,
      email: email,
      language: language,
      country: country,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Request a trial account.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [url] Server URL.
  ///   * [name] Display name of the user.
  ///   * [email] Email of the user.
  ///   * [language] Language of the user.
  ///   * [country] Country of the user.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Trial requested successfully
  ///   * 400: Requesting trial is not possible
  ///   * 500
  ///
  /// See:
  ///  * [requestTrial] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<HostedSignalingServerRequestTrialResponseApplicationJson, void> requestTrialRaw({
    required String url,
    required String name,
    required String email,
    required String language,
    required String country,
    HostedSignalingServerRequestTrialApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $url = jsonSerializers.serialize(url, specifiedType: const FullType(String));
    _parameters['url'] = $url;

    final $name = jsonSerializers.serialize(name, specifiedType: const FullType(String));
    _parameters['name'] = $name;

    final $email = jsonSerializers.serialize(email, specifiedType: const FullType(String));
    _parameters['email'] = $email;

    final $language = jsonSerializers.serialize(language, specifiedType: const FullType(String));
    _parameters['language'] = $language;

    final $country = jsonSerializers.serialize(country, specifiedType: const FullType(String));
    _parameters['country'] = $country;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(HostedSignalingServerRequestTrialApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/hostedsignalingserver/requesttrial{?url*,name*,email*,language*,country*}',
    ).expand(_parameters);
    return DynamiteRawResponse<HostedSignalingServerRequestTrialResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(HostedSignalingServerRequestTrialResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Delete the account.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 204: Account deleted successfully
  ///   * 400: Deleting account is not possible
  ///   * 500
  ///
  /// See:
  ///  * [deleteAccountRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<HostedSignalingServerDeleteAccountResponseApplicationJson, void>> deleteAccount({
    HostedSignalingServerDeleteAccountApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteAccountRaw(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete the account.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 204: Account deleted successfully
  ///   * 400: Deleting account is not possible
  ///   * 500
  ///
  /// See:
  ///  * [deleteAccount] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<HostedSignalingServerDeleteAccountResponseApplicationJson, void> deleteAccountRaw({
    HostedSignalingServerDeleteAccountApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(HostedSignalingServerDeleteAccountApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/hostedsignalingserver/delete').expand(_parameters);
    return DynamiteRawResponse<HostedSignalingServerDeleteAccountResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {204},
      ),
      bodyType: const FullType(HostedSignalingServerDeleteAccountResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $MatterbridgeClient {
  $MatterbridgeClient(this._rootClient);

  final $Client _rootClient;

  /// Get bridge information of one room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of configured bridges
  ///
  /// See:
  ///  * [getBridgeOfRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<MatterbridgeGetBridgeOfRoomResponseApplicationJson, void>> getBridgeOfRoom({
    required String token,
    MatterbridgeGetBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getBridgeOfRoomRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get bridge information of one room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of configured bridges
  ///
  /// See:
  ///  * [getBridgeOfRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<MatterbridgeGetBridgeOfRoomResponseApplicationJson, void> getBridgeOfRoomRaw({
    required String token,
    MatterbridgeGetBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(MatterbridgeGetBridgeOfRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}').expand(_parameters);
    return DynamiteRawResponse<MatterbridgeGetBridgeOfRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(MatterbridgeGetBridgeOfRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Edit bridge information of one room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [enabled] If the bridge should be enabled.
  ///   * [parts] New parts.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge edited successfully
  ///   * 406: Editing bridge is not possible
  ///
  /// See:
  ///  * [editBridgeOfRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<MatterbridgeEditBridgeOfRoomResponseApplicationJson, void>> editBridgeOfRoom({
    required int enabled,
    required String token,
    ContentString<BuiltList<BuiltMap<String, JsonObject>>>? parts,
    MatterbridgeEditBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = editBridgeOfRoomRaw(
      enabled: enabled,
      token: token,
      parts: parts,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Edit bridge information of one room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [enabled] If the bridge should be enabled.
  ///   * [parts] New parts.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge edited successfully
  ///   * 406: Editing bridge is not possible
  ///
  /// See:
  ///  * [editBridgeOfRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<MatterbridgeEditBridgeOfRoomResponseApplicationJson, void> editBridgeOfRoomRaw({
    required int enabled,
    required String token,
    ContentString<BuiltList<BuiltMap<String, JsonObject>>>? parts,
    MatterbridgeEditBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $enabled = jsonSerializers.serialize(enabled, specifiedType: const FullType(int));
    _parameters['enabled'] = $enabled;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $parts = jsonSerializers.serialize(
      parts,
      specifiedType: const FullType(ContentString, [
        FullType(BuiltList, [
          FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        ]),
      ]),
    );
    _parameters['parts'] = $parts;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(MatterbridgeEditBridgeOfRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}{?enabled*,parts*}').expand(_parameters);
    return DynamiteRawResponse<MatterbridgeEditBridgeOfRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(MatterbridgeEditBridgeOfRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Delete bridge of one room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge deleted successfully
  ///   * 406: Deleting bridge is not possible
  ///
  /// See:
  ///  * [deleteBridgeOfRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson, void>> deleteBridgeOfRoom({
    required String token,
    MatterbridgeDeleteBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteBridgeOfRoomRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete bridge of one room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge deleted successfully
  ///   * 406: Deleting bridge is not possible
  ///
  /// See:
  ///  * [deleteBridgeOfRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson, void> deleteBridgeOfRoomRaw({
    required String token,
    MatterbridgeDeleteBridgeOfRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(MatterbridgeDeleteBridgeOfRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}').expand(_parameters);
    return DynamiteRawResponse<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get bridge process information.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of running processes
  ///
  /// See:
  ///  * [getBridgeProcessStateRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<MatterbridgeGetBridgeProcessStateResponseApplicationJson, void>> getBridgeProcessState({
    required String token,
    MatterbridgeGetBridgeProcessStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getBridgeProcessStateRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get bridge process information.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of running processes
  ///
  /// See:
  ///  * [getBridgeProcessState] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<MatterbridgeGetBridgeProcessStateResponseApplicationJson, void> getBridgeProcessStateRaw({
    required String token,
    MatterbridgeGetBridgeProcessStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(MatterbridgeGetBridgeProcessStateApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/{token}/process').expand(_parameters);
    return DynamiteRawResponse<MatterbridgeGetBridgeProcessStateResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(MatterbridgeGetBridgeProcessStateResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $MatterbridgeSettingsClient {
  $MatterbridgeSettingsClient(this._rootClient);

  final $Client _rootClient;

  /// Stop all bridges.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: All bridges stopped successfully
  ///   * 406: Stopping all bridges is not possible
  ///
  /// See:
  ///  * [stopAllBridgesRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<MatterbridgeSettingsStopAllBridgesResponseApplicationJson, void>> stopAllBridges({
    MatterbridgeSettingsStopAllBridgesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = stopAllBridgesRaw(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Stop all bridges.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: All bridges stopped successfully
  ///   * 406: Stopping all bridges is not possible
  ///
  /// See:
  ///  * [stopAllBridges] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<MatterbridgeSettingsStopAllBridgesResponseApplicationJson, void> stopAllBridgesRaw({
    MatterbridgeSettingsStopAllBridgesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(MatterbridgeSettingsStopAllBridgesApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge').expand(_parameters);
    return DynamiteRawResponse<MatterbridgeSettingsStopAllBridgesResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(MatterbridgeSettingsStopAllBridgesResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get Matterbridge version.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge version returned
  ///   * 400: Getting bridge version is not possible
  ///
  /// See:
  ///  * [getMatterbridgeVersionRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson, void>>
      getMatterbridgeVersion({
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getMatterbridgeVersionRaw(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get Matterbridge version.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Bridge version returned
  ///   * 400: Getting bridge version is not possible
  ///
  /// See:
  ///  * [getMatterbridgeVersion] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson, void>
      getMatterbridgeVersionRaw({
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $apiVersion = jsonSerializers.serialize(
      apiVersion,
      specifiedType: const FullType(MatterbridgeSettingsGetMatterbridgeVersionApiVersion),
    );
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/bridge/version').expand(_parameters);
    return DynamiteRawResponse<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $PollClient {
  $PollClient(this._rootClient);

  final $Client _rootClient;

  /// Create a poll.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [question] Question of the poll.
  ///   * [options] Options of the poll.
  ///   * [resultMode] Mode how the results will be shown.
  ///   * [maxVotes] Number of maximum votes per voter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Poll created successfully
  ///   * 400: Creating poll is not possible
  ///
  /// See:
  ///  * [createPollRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<PollCreatePollResponseApplicationJson, void>> createPoll({
    required String question,
    required BuiltList<String> options,
    required PollCreatePollResultMode resultMode,
    required int maxVotes,
    required String token,
    PollCreatePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = createPollRaw(
      question: question,
      options: options,
      resultMode: resultMode,
      maxVotes: maxVotes,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Create a poll.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [question] Question of the poll.
  ///   * [options] Options of the poll.
  ///   * [resultMode] Mode how the results will be shown.
  ///   * [maxVotes] Number of maximum votes per voter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Poll created successfully
  ///   * 400: Creating poll is not possible
  ///
  /// See:
  ///  * [createPoll] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<PollCreatePollResponseApplicationJson, void> createPollRaw({
    required String question,
    required BuiltList<String> options,
    required PollCreatePollResultMode resultMode,
    required int maxVotes,
    required String token,
    PollCreatePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $question = jsonSerializers.serialize(question, specifiedType: const FullType(String));
    _parameters['question'] = $question;

    final $options = jsonSerializers.serialize(options, specifiedType: const FullType(BuiltList, [FullType(String)]));
    _parameters['options%5B%5D'] = $options;

    final $resultMode = jsonSerializers.serialize(resultMode, specifiedType: const FullType(PollCreatePollResultMode));
    _parameters['resultMode'] = $resultMode;

    final $maxVotes = jsonSerializers.serialize(maxVotes, specifiedType: const FullType(int));
    _parameters['maxVotes'] = $maxVotes;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollCreatePollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}{?question*,options%5B%5D*,resultMode*,maxVotes*}',
    ).expand(_parameters);
    return DynamiteRawResponse<PollCreatePollResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201},
      ),
      bodyType: const FullType(PollCreatePollResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get a poll.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll returned
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [showPollRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<PollShowPollResponseApplicationJson, void>> showPoll({
    required String token,
    required int pollId,
    PollShowPollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = showPollRaw(
      token: token,
      pollId: pollId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get a poll.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll returned
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [showPoll] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<PollShowPollResponseApplicationJson, void> showPollRaw({
    required String token,
    required int pollId,
    PollShowPollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $pollId = jsonSerializers.serialize(pollId, specifiedType: const FullType(int));
    _parameters['pollId'] = $pollId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollShowPollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}/{pollId}').expand(_parameters);
    return DynamiteRawResponse<PollShowPollResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(PollShowPollResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Vote on a poll.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [optionIds] IDs of the selected options. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Voted successfully
  ///   * 400: Voting is not possible
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [votePollRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<PollVotePollResponseApplicationJson, void>> votePoll({
    required String token,
    required int pollId,
    BuiltList<int>? optionIds,
    PollVotePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = votePollRaw(
      token: token,
      pollId: pollId,
      optionIds: optionIds,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Vote on a poll.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [optionIds] IDs of the selected options. Defaults to `[]`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Voted successfully
  ///   * 400: Voting is not possible
  ///   * 404: Poll not found
  ///
  /// See:
  ///  * [votePoll] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<PollVotePollResponseApplicationJson, void> votePollRaw({
    required String token,
    required int pollId,
    BuiltList<int>? optionIds,
    PollVotePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $pollId = jsonSerializers.serialize(pollId, specifiedType: const FullType(int));
    _parameters['pollId'] = $pollId;

    var $optionIds = jsonSerializers.serialize(optionIds, specifiedType: const FullType(BuiltList, [FullType(int)]));
    $optionIds ??= [];
    _parameters['optionIds%5B%5D'] = $optionIds;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollVotePollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}/{pollId}{?optionIds%5B%5D*}')
        .expand(_parameters);
    return DynamiteRawResponse<PollVotePollResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(PollVotePollResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Close a poll.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll closed successfully
  ///   * 400: Poll already closed
  ///   * 403: Missing permissions to close poll
  ///   * 404: Poll not found
  ///   * 500
  ///
  /// See:
  ///  * [closePollRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<PollClosePollResponseApplicationJson, void>> closePoll({
    required String token,
    required int pollId,
    PollClosePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = closePollRaw(
      token: token,
      pollId: pollId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Close a poll.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [pollId] ID of the poll.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Poll closed successfully
  ///   * 400: Poll already closed
  ///   * 403: Missing permissions to close poll
  ///   * 404: Poll not found
  ///   * 500
  ///
  /// See:
  ///  * [closePoll] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<PollClosePollResponseApplicationJson, void> closePollRaw({
    required String token,
    required int pollId,
    PollClosePollApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $pollId = jsonSerializers.serialize(pollId, specifiedType: const FullType(int));
    _parameters['pollId'] = $pollId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PollClosePollApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/poll/{token}/{pollId}').expand(_parameters);
    return DynamiteRawResponse<PollClosePollResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(PollClosePollResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $PublicShareAuthClient {
  $PublicShareAuthClient(this._rootClient);

  final $Client _rootClient;

  /// Creates a new room for video verification (requesting the password of a share).
  ///
  /// The new room is a public room associated with a "share:password" object with the ID of the share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms always created by a guest or user on behalf of a registered user, the sharer, who will be the owner of the room.
  /// The share must have "send password by Talk" enabled; an error is returned otherwise.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [shareToken] Token of the file share.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Room created successfully
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [createRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<PublicShareAuthCreateRoomResponseApplicationJson, void>> createRoom({
    required String shareToken,
    PublicShareAuthCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = createRoomRaw(
      shareToken: shareToken,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Creates a new room for video verification (requesting the password of a share).
  ///
  /// The new room is a public room associated with a "share:password" object with the ID of the share token. Unlike normal rooms in which the owner is the user that created the room these are special rooms always created by a guest or user on behalf of a registered user, the sharer, who will be the owner of the room.
  /// The share must have "send password by Talk" enabled; an error is returned otherwise.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [shareToken] Token of the file share.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 201: Room created successfully
  ///   * 404: Share not found
  ///
  /// See:
  ///  * [createRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<PublicShareAuthCreateRoomResponseApplicationJson, void> createRoomRaw({
    required String shareToken,
    PublicShareAuthCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $shareToken = jsonSerializers.serialize(shareToken, specifiedType: const FullType(String));
    _parameters['shareToken'] = $shareToken;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(PublicShareAuthCreateRoomApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/publicshareauth{?shareToken*}').expand(_parameters);
    return DynamiteRawResponse<PublicShareAuthCreateRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {201},
      ),
      bodyType: const FullType(PublicShareAuthCreateRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $ReactionClient {
  $ReactionClient(this._rootClient);

  final $Client _rootClient;

  /// Get a list of reactions for a message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to filter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reactions returned
  ///   * 404: Message or reaction not found
  ///
  /// See:
  ///  * [getReactionsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ReactionGetReactionsResponseApplicationJson, void>> getReactions({
    required String token,
    required int messageId,
    String? reaction,
    ReactionGetReactionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getReactionsRaw(
      token: token,
      messageId: messageId,
      reaction: reaction,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get a list of reactions for a message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to filter.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reactions returned
  ///   * 404: Message or reaction not found
  ///
  /// See:
  ///  * [getReactions] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ReactionGetReactionsResponseApplicationJson, void> getReactionsRaw({
    required String token,
    required int messageId,
    String? reaction,
    ReactionGetReactionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    final $reaction = jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ReactionGetReactionsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/reaction/{token}/{messageId}{?reaction*}')
        .expand(_parameters);
    return DynamiteRawResponse<ReactionGetReactionsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ReactionGetReactionsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Add a reaction to a message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already existed
  ///   * 201: Reaction added successfully
  ///   * 400: Adding reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [reactRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ReactionReactResponseApplicationJson, void>> react({
    required String reaction,
    required String token,
    required int messageId,
    ReactionReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = reactRaw(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Add a reaction to a message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to add.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction already existed
  ///   * 201: Reaction added successfully
  ///   * 400: Adding reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [react] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ReactionReactResponseApplicationJson, void> reactRaw({
    required String reaction,
    required String token,
    required int messageId,
    ReactionReactApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $reaction = jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ReactionReactApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/reaction/{token}/{messageId}{?reaction*}')
        .expand(_parameters);
    return DynamiteRawResponse<ReactionReactResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 201},
      ),
      bodyType: const FullType(ReactionReactResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Delete a reaction from a message.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to remove.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Deleting reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [deleteRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<ReactionDeleteResponseApplicationJson, void>> delete({
    required String reaction,
    required String token,
    required int messageId,
    ReactionDeleteApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteRaw(
      reaction: reaction,
      token: token,
      messageId: messageId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete a reaction from a message.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [reaction] Emoji to remove.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [messageId] ID of the message.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Reaction deleted successfully
  ///   * 400: Deleting reaction is not possible
  ///   * 404: Message not found
  ///
  /// See:
  ///  * [delete] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<ReactionDeleteResponseApplicationJson, void> deleteRaw({
    required String reaction,
    required String token,
    required int messageId,
    ReactionDeleteApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $reaction = jsonSerializers.serialize(reaction, specifiedType: const FullType(String));
    _parameters['reaction'] = $reaction;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $messageId = jsonSerializers.serialize(messageId, specifiedType: const FullType(int));
    _parameters['messageId'] = $messageId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(ReactionDeleteApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/reaction/{token}/{messageId}{?reaction*}')
        .expand(_parameters);
    return DynamiteRawResponse<ReactionDeleteResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(ReactionDeleteResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $RecordingClient {
  $RecordingClient(this._rootClient);

  final $Client _rootClient;

  /// Get the welcome message of a recording server.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [serverId] ID of the server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Recording server not found or not configured
  ///   * 500
  ///
  /// See:
  ///  * [getWelcomeMessageRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RecordingGetWelcomeMessageResponseApplicationJson, void>> getWelcomeMessage({
    required int serverId,
    RecordingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getWelcomeMessageRaw(
      serverId: serverId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the welcome message of a recording server.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [serverId] ID of the server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Recording server not found or not configured
  ///   * 500
  ///
  /// See:
  ///  * [getWelcomeMessage] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RecordingGetWelcomeMessageResponseApplicationJson, void> getWelcomeMessageRaw({
    required int serverId,
    RecordingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $serverId = jsonSerializers.serialize(serverId, specifiedType: const FullType(int));
    _parameters['serverId'] = $serverId;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingGetWelcomeMessageApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/welcome/{serverId}').expand(_parameters);
    return DynamiteRawResponse<RecordingGetWelcomeMessageResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RecordingGetWelcomeMessageResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Start the recording.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [status] Type of the recording.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording started successfully
  ///   * 400: Starting recording is not possible
  ///
  /// See:
  ///  * [startRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RecordingStartResponseApplicationJson, void>> start({
    required int status,
    required String token,
    RecordingStartApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = startRaw(
      status: status,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Start the recording.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [status] Type of the recording.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording started successfully
  ///   * 400: Starting recording is not possible
  ///
  /// See:
  ///  * [start] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RecordingStartResponseApplicationJson, void> startRaw({
    required int status,
    required String token,
    RecordingStartApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $status = jsonSerializers.serialize(status, specifiedType: const FullType(int));
    _parameters['status'] = $status;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingStartApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}{?status*}').expand(_parameters);
    return DynamiteRawResponse<RecordingStartResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RecordingStartResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Stop the recording.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stopped successfully
  ///   * 400: Stopping recording is not possible
  ///
  /// See:
  ///  * [stopRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RecordingStopResponseApplicationJson, void>> stop({
    required String token,
    RecordingStopApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = stopRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Stop the recording.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stopped successfully
  ///   * 400: Stopping recording is not possible
  ///
  /// See:
  ///  * [stop] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RecordingStopResponseApplicationJson, void> stopRaw({
    required String token,
    RecordingStopApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingStopApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}').expand(_parameters);
    return DynamiteRawResponse<RecordingStopResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RecordingStopResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Store the recording.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [owner] User that will own the recording file.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stored successfully
  ///   * 400: Storing recording is not possible
  ///   * 401: Missing permissions to store recording
  ///
  /// See:
  ///  * [storeRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RecordingStoreResponseApplicationJson, void>> store({
    required String owner,
    required String token,
    RecordingStoreApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = storeRaw(
      owner: owner,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Store the recording.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [owner] User that will own the recording file.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording stored successfully
  ///   * 400: Storing recording is not possible
  ///   * 401: Missing permissions to store recording
  ///
  /// See:
  ///  * [store] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RecordingStoreResponseApplicationJson, void> storeRaw({
    required String owner,
    required String token,
    RecordingStoreApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $owner = jsonSerializers.serialize(owner, specifiedType: const FullType(String));
    _parameters['owner'] = $owner;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingStoreApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}/store{?owner*}').expand(_parameters);
    return DynamiteRawResponse<RecordingStoreResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RecordingStoreResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Dismiss the store call recording notification.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification dismissed successfully
  ///   * 400: Dismissing notification is not possible
  ///
  /// See:
  ///  * [notificationDismissRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RecordingNotificationDismissResponseApplicationJson, void>> notificationDismiss({
    required int timestamp,
    required String token,
    RecordingNotificationDismissApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = notificationDismissRaw(
      timestamp: timestamp,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Dismiss the store call recording notification.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification dismissed successfully
  ///   * 400: Dismissing notification is not possible
  ///
  /// See:
  ///  * [notificationDismiss] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RecordingNotificationDismissResponseApplicationJson, void> notificationDismissRaw({
    required int timestamp,
    required String token,
    RecordingNotificationDismissApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $timestamp = jsonSerializers.serialize(timestamp, specifiedType: const FullType(int));
    _parameters['timestamp'] = $timestamp;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingNotificationDismissApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}/notification{?timestamp*}')
        .expand(_parameters);
    return DynamiteRawResponse<RecordingNotificationDismissResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RecordingNotificationDismissResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Share the recorded file to the chat.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [fileId] ID of the file.
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording shared to chat successfully
  ///   * 400: Sharing recording to chat is not possible
  ///
  /// See:
  ///  * [shareToChatRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RecordingShareToChatResponseApplicationJson, void>> shareToChat({
    required int fileId,
    required int timestamp,
    required String token,
    RecordingShareToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = shareToChatRaw(
      fileId: fileId,
      timestamp: timestamp,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Share the recorded file to the chat.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [fileId] ID of the file.
  ///   * [timestamp] Timestamp of the notification to be dismissed.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording shared to chat successfully
  ///   * 400: Sharing recording to chat is not possible
  ///
  /// See:
  ///  * [shareToChat] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RecordingShareToChatResponseApplicationJson, void> shareToChatRaw({
    required int fileId,
    required int timestamp,
    required String token,
    RecordingShareToChatApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $fileId = jsonSerializers.serialize(fileId, specifiedType: const FullType(int));
    _parameters['fileId'] = $fileId;

    final $timestamp = jsonSerializers.serialize(timestamp, specifiedType: const FullType(int));
    _parameters['timestamp'] = $timestamp;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RecordingShareToChatApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/recording/{token}/share-chat{?fileId*,timestamp*}')
            .expand(_parameters);
    return DynamiteRawResponse<RecordingShareToChatResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RecordingShareToChatResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $RoomClient {
  $RoomClient(this._rootClient);

  final $Client _rootClient;

  /// Get all currently existent rooms which the user has joined.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [includeStatus] Include the user status. Defaults to `0`.
  ///   * [modifiedSince] Filter rooms modified after a timestamp. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of rooms
  ///
  /// See:
  ///  * [getRoomsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomGetRoomsResponseApplicationJson, RoomRoomGetRoomsHeaders>> getRooms({
    RoomGetRoomsNoStatusUpdate? noStatusUpdate,
    int? includeStatus,
    int? modifiedSince,
    RoomGetRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getRoomsRaw(
      noStatusUpdate: noStatusUpdate,
      includeStatus: includeStatus,
      modifiedSince: modifiedSince,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get all currently existent rooms which the user has joined.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [noStatusUpdate] When the user status should not be automatically set to online set to 1 (default 0). Defaults to `0`.
  ///   * [includeStatus] Include the user status. Defaults to `0`.
  ///   * [modifiedSince] Filter rooms modified after a timestamp. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of rooms
  ///
  /// See:
  ///  * [getRooms] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomGetRoomsResponseApplicationJson, RoomRoomGetRoomsHeaders> getRoomsRaw({
    RoomGetRoomsNoStatusUpdate? noStatusUpdate,
    int? includeStatus,
    int? modifiedSince,
    RoomGetRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $noStatusUpdate =
        jsonSerializers.serialize(noStatusUpdate, specifiedType: const FullType(RoomGetRoomsNoStatusUpdate));
    $noStatusUpdate ??= 0;
    _parameters['noStatusUpdate'] = $noStatusUpdate;

    var $includeStatus = jsonSerializers.serialize(includeStatus, specifiedType: const FullType(int));
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $modifiedSince = jsonSerializers.serialize(modifiedSince, specifiedType: const FullType(int));
    $modifiedSince ??= 0;
    _parameters['modifiedSince'] = $modifiedSince;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetRoomsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room{?noStatusUpdate*,includeStatus*,modifiedSince*}')
            .expand(_parameters);
    return DynamiteRawResponse<RoomGetRoomsResponseApplicationJson, RoomRoomGetRoomsHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomGetRoomsResponseApplicationJson),
      headersType: const FullType(RoomRoomGetRoomsHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Create a room with a user, a group or a circle.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [roomType] Type of the room.
  ///   * [invite] User, group, … ID to invite. Defaults to `''`.
  ///   * [roomName] Name of the room. Defaults to `''`.
  ///   * [source] Source of the invite ID ('circles' to create a room with a circle, etc.). Defaults to `''`.
  ///   * [objectType] Type of the object. Defaults to `''`.
  ///   * [objectId] ID of the object. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room already existed
  ///   * 201: Room created successfully
  ///   * 400: Room type invalid
  ///   * 403: Missing permissions to create room
  ///   * 404: User, group or other target to invite was not found
  ///
  /// See:
  ///  * [createRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomCreateRoomResponseApplicationJson, void>> createRoom({
    required int roomType,
    String? invite,
    String? roomName,
    String? source,
    String? objectType,
    String? objectId,
    RoomCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = createRoomRaw(
      roomType: roomType,
      invite: invite,
      roomName: roomName,
      source: source,
      objectType: objectType,
      objectId: objectId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Create a room with a user, a group or a circle.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [roomType] Type of the room.
  ///   * [invite] User, group, … ID to invite. Defaults to `''`.
  ///   * [roomName] Name of the room. Defaults to `''`.
  ///   * [source] Source of the invite ID ('circles' to create a room with a circle, etc.). Defaults to `''`.
  ///   * [objectType] Type of the object. Defaults to `''`.
  ///   * [objectId] ID of the object. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room already existed
  ///   * 201: Room created successfully
  ///   * 400: Room type invalid
  ///   * 403: Missing permissions to create room
  ///   * 404: User, group or other target to invite was not found
  ///
  /// See:
  ///  * [createRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomCreateRoomResponseApplicationJson, void> createRoomRaw({
    required int roomType,
    String? invite,
    String? roomName,
    String? source,
    String? objectType,
    String? objectId,
    RoomCreateRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $roomType = jsonSerializers.serialize(roomType, specifiedType: const FullType(int));
    _parameters['roomType'] = $roomType;

    var $invite = jsonSerializers.serialize(invite, specifiedType: const FullType(String));
    $invite ??= '';
    _parameters['invite'] = $invite;

    var $roomName = jsonSerializers.serialize(roomName, specifiedType: const FullType(String));
    $roomName ??= '';
    _parameters['roomName'] = $roomName;

    var $source = jsonSerializers.serialize(source, specifiedType: const FullType(String));
    $source ??= '';
    _parameters['source'] = $source;

    var $objectType = jsonSerializers.serialize(objectType, specifiedType: const FullType(String));
    $objectType ??= '';
    _parameters['objectType'] = $objectType;

    var $objectId = jsonSerializers.serialize(objectId, specifiedType: const FullType(String));
    $objectId ??= '';
    _parameters['objectId'] = $objectId;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomCreateRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room{?roomType*,invite*,roomName*,source*,objectType*,objectId*}',
    ).expand(_parameters);
    return DynamiteRawResponse<RoomCreateRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 201},
      ),
      bodyType: const FullType(RoomCreateRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get listed rooms with optional search term.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [searchTerm] search term. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of matching rooms
  ///
  /// See:
  ///  * [getListedRoomsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomGetListedRoomsResponseApplicationJson, void>> getListedRooms({
    String? searchTerm,
    RoomGetListedRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getListedRoomsRaw(
      searchTerm: searchTerm,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get listed rooms with optional search term.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [searchTerm] search term. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Return list of matching rooms
  ///
  /// See:
  ///  * [getListedRooms] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomGetListedRoomsResponseApplicationJson, void> getListedRoomsRaw({
    String? searchTerm,
    RoomGetListedRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $searchTerm = jsonSerializers.serialize(searchTerm, specifiedType: const FullType(String));
    $searchTerm ??= '';
    _parameters['searchTerm'] = $searchTerm;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetListedRoomsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/listed-room{?searchTerm*}').expand(_parameters);
    return DynamiteRawResponse<RoomGetListedRoomsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomGetListedRoomsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get the "Note to self" conversation for the user.
  ///
  /// It will be automatically created when it is currently missing.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned successfully
  ///
  /// See:
  ///  * [getNoteToSelfConversationRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<
      DynamiteResponse<RoomGetNoteToSelfConversationResponseApplicationJson,
          RoomRoomGetNoteToSelfConversationHeaders>> getNoteToSelfConversation({
    RoomGetNoteToSelfConversationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getNoteToSelfConversationRaw(
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the "Note to self" conversation for the user.
  ///
  /// It will be automatically created when it is currently missing.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned successfully
  ///
  /// See:
  ///  * [getNoteToSelfConversation] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomGetNoteToSelfConversationResponseApplicationJson, RoomRoomGetNoteToSelfConversationHeaders>
      getNoteToSelfConversationRaw({
    RoomGetNoteToSelfConversationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetNoteToSelfConversationApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/note-to-self').expand(_parameters);
    return DynamiteRawResponse<RoomGetNoteToSelfConversationResponseApplicationJson,
        RoomRoomGetNoteToSelfConversationHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomGetNoteToSelfConversationResponseApplicationJson),
      headersType: const FullType(RoomRoomGetNoteToSelfConversationHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Get a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned
  ///   * 401: SIP request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [getSingleRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomGetSingleRoomResponseApplicationJson, RoomRoomGetSingleRoomHeaders>> getSingleRoom({
    required String token,
    RoomGetSingleRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getSingleRoomRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room returned
  ///   * 401: SIP request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [getSingleRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomGetSingleRoomResponseApplicationJson, RoomRoomGetSingleRoomHeaders> getSingleRoomRaw({
    required String token,
    RoomGetSingleRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetSingleRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}').expand(_parameters);
    return DynamiteRawResponse<RoomGetSingleRoomResponseApplicationJson, RoomRoomGetSingleRoomHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomGetSingleRoomResponseApplicationJson),
      headersType: const FullType(RoomRoomGetSingleRoomHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Rename a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [roomName] New name.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room renamed successfully
  ///   * 400: Renaming room is not possible
  ///
  /// See:
  ///  * [renameRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomRenameRoomResponseApplicationJson, void>> renameRoom({
    required String roomName,
    required String token,
    RoomRenameRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = renameRoomRaw(
      roomName: roomName,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Rename a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [roomName] New name.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room renamed successfully
  ///   * 400: Renaming room is not possible
  ///
  /// See:
  ///  * [renameRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomRenameRoomResponseApplicationJson, void> renameRoomRaw({
    required String roomName,
    required String token,
    RoomRenameRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $roomName = jsonSerializers.serialize(roomName, specifiedType: const FullType(String));
    _parameters['roomName'] = $roomName;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRenameRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}{?roomName*}').expand(_parameters);
    return DynamiteRawResponse<RoomRenameRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomRenameRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Delete a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room successfully deleted
  ///   * 400: Deleting room is not possible
  ///
  /// See:
  ///  * [deleteRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomDeleteRoomResponseApplicationJson, void>> deleteRoom({
    required String token,
    RoomDeleteRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteRoomRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room successfully deleted
  ///   * 400: Deleting room is not possible
  ///
  /// See:
  ///  * [deleteRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomDeleteRoomResponseApplicationJson, void> deleteRoomRaw({
    required String token,
    RoomDeleteRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomDeleteRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}').expand(_parameters);
    return DynamiteRawResponse<RoomDeleteRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomDeleteRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get breakout rooms.
  ///
  /// All for moderators and in case of "free selection", or the assigned breakout room for other participants.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms returned
  ///   * 400: Getting breakout rooms is not possible
  ///
  /// See:
  ///  * [getBreakoutRoomsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomGetBreakoutRoomsResponseApplicationJson, void>> getBreakoutRooms({
    required String token,
    RoomGetBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getBreakoutRoomsRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get breakout rooms.
  ///
  /// All for moderators and in case of "free selection", or the assigned breakout room for other participants.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout rooms returned
  ///   * 400: Getting breakout rooms is not possible
  ///
  /// See:
  ///  * [getBreakoutRooms] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomGetBreakoutRoomsResponseApplicationJson, void> getBreakoutRoomsRaw({
    required String token,
    RoomGetBreakoutRoomsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetBreakoutRoomsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/breakout-rooms').expand(_parameters);
    return DynamiteRawResponse<RoomGetBreakoutRoomsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomGetBreakoutRoomsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Allowed guests to join conversation.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Allowed guests successfully
  ///   * 400: Allowing guests is not possible
  ///
  /// See:
  ///  * [makePublicRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomMakePublicResponseApplicationJson, void>> makePublic({
    required String token,
    RoomMakePublicApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = makePublicRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Allowed guests to join conversation.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Allowed guests successfully
  ///   * 400: Allowing guests is not possible
  ///
  /// See:
  ///  * [makePublic] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomMakePublicResponseApplicationJson, void> makePublicRaw({
    required String token,
    RoomMakePublicApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomMakePublicApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/public').expand(_parameters);
    return DynamiteRawResponse<RoomMakePublicResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomMakePublicResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Disallowed guests to join conversation.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room unpublished Disallowing guests successfully
  ///   * 400: Disallowing guests is not possible
  ///
  /// See:
  ///  * [makePrivateRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomMakePrivateResponseApplicationJson, void>> makePrivate({
    required String token,
    RoomMakePrivateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = makePrivateRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Disallowed guests to join conversation.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room unpublished Disallowing guests successfully
  ///   * 400: Disallowing guests is not possible
  ///
  /// See:
  ///  * [makePrivate] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomMakePrivateResponseApplicationJson, void> makePrivateRaw({
    required String token,
    RoomMakePrivateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomMakePrivateApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/public').expand(_parameters);
    return DynamiteRawResponse<RoomMakePrivateResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomMakePrivateResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update the description of a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [description] New description.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Description updated successfully
  ///   * 400: Updating description is not possible
  ///
  /// See:
  ///  * [setDescriptionRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetDescriptionResponseApplicationJson, void>> setDescription({
    required String description,
    required String token,
    RoomSetDescriptionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setDescriptionRaw(
      description: description,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update the description of a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [description] New description.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Description updated successfully
  ///   * 400: Updating description is not possible
  ///
  /// See:
  ///  * [setDescription] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetDescriptionResponseApplicationJson, void> setDescriptionRaw({
    required String description,
    required String token,
    RoomSetDescriptionApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $description = jsonSerializers.serialize(description, specifiedType: const FullType(String));
    _parameters['description'] = $description;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetDescriptionApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/description{?description*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomSetDescriptionResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomSetDescriptionResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Set read-only state of a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New read-only state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read-only state updated successfully
  ///   * 400: Updating read-only state is not possible
  ///
  /// See:
  ///  * [setReadOnlyRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetReadOnlyResponseApplicationJson, void>> setReadOnly({
    required RoomSetReadOnlyState state,
    required String token,
    RoomSetReadOnlyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setReadOnlyRaw(
      state: state,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set read-only state of a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New read-only state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Read-only state updated successfully
  ///   * 400: Updating read-only state is not possible
  ///
  /// See:
  ///  * [setReadOnly] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetReadOnlyResponseApplicationJson, void> setReadOnlyRaw({
    required RoomSetReadOnlyState state,
    required String token,
    RoomSetReadOnlyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $state = jsonSerializers.serialize(state, specifiedType: const FullType(RoomSetReadOnlyState));
    _parameters['state'] = $state;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetReadOnlyApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/read-only{?state*}').expand(_parameters);
    return DynamiteRawResponse<RoomSetReadOnlyResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomSetReadOnlyResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Make a room listable.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [scope] Scope where the room is listable.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Made room listable successfully
  ///   * 400: Making room listable is not possible
  ///
  /// See:
  ///  * [setListableRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetListableResponseApplicationJson, void>> setListable({
    required RoomSetListableScope scope,
    required String token,
    RoomSetListableApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setListableRaw(
      scope: scope,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Make a room listable.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [scope] Scope where the room is listable.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Made room listable successfully
  ///   * 400: Making room listable is not possible
  ///
  /// See:
  ///  * [setListable] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetListableResponseApplicationJson, void> setListableRaw({
    required RoomSetListableScope scope,
    required String token,
    RoomSetListableApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $scope = jsonSerializers.serialize(scope, specifiedType: const FullType(RoomSetListableScope));
    _parameters['scope'] = $scope;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetListableApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/listable{?scope*}').expand(_parameters);
    return DynamiteRawResponse<RoomSetListableResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomSetListableResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Set a password for a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] New password.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Password set successfully
  ///   * 403: Setting password is not allowed
  ///   * 400: Setting password is not possible
  ///
  /// See:
  ///  * [setPasswordRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetPasswordResponseApplicationJson, void>> setPassword({
    required String password,
    required String token,
    RoomSetPasswordApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setPasswordRaw(
      password: password,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set a password for a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] New password.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Password set successfully
  ///   * 403: Setting password is not allowed
  ///   * 400: Setting password is not possible
  ///
  /// See:
  ///  * [setPassword] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetPasswordResponseApplicationJson, void> setPasswordRaw({
    required String password,
    required String token,
    RoomSetPasswordApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $password = jsonSerializers.serialize(password, specifiedType: const FullType(String));
    _parameters['password'] = $password;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetPasswordApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/password{?password*}').expand(_parameters);
    return DynamiteRawResponse<RoomSetPasswordResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200, 403},
      ),
      bodyType: const FullType(RoomSetPasswordResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update the permissions of a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [mode] Level of the permissions ('call', 'default').
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [setPermissionsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetPermissionsResponseApplicationJson, void>> setPermissions({
    required RoomSetPermissionsPermissions permissions,
    required String token,
    required RoomSetPermissionsMode mode,
    RoomSetPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setPermissionsRaw(
      permissions: permissions,
      token: token,
      mode: mode,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update the permissions of a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [mode] Level of the permissions ('call', 'default').
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [setPermissions] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetPermissionsResponseApplicationJson, void> setPermissionsRaw({
    required RoomSetPermissionsPermissions permissions,
    required String token,
    required RoomSetPermissionsMode mode,
    RoomSetPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $permissions =
        jsonSerializers.serialize(permissions, specifiedType: const FullType(RoomSetPermissionsPermissions));
    _parameters['permissions'] = $permissions;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $mode = jsonSerializers.serialize(mode, specifiedType: const FullType(RoomSetPermissionsMode));
    dynamite_utils.checkPattern($mode as String?, RegExp(r'^(call|default)$'), 'mode');
    _parameters['mode'] = $mode;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetPermissionsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/permissions/{mode}{?permissions*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomSetPermissionsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomSetPermissionsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get a list of participants for a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participants returned
  ///   * 403: Missing permissions for getting participants
  ///
  /// See:
  ///  * [getParticipantsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomGetParticipantsResponseApplicationJson, RoomRoomGetParticipantsHeaders>> getParticipants({
    required String token,
    int? includeStatus,
    RoomGetParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getParticipantsRaw(
      token: token,
      includeStatus: includeStatus,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get a list of participants for a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participants returned
  ///   * 403: Missing permissions for getting participants
  ///
  /// See:
  ///  * [getParticipants] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomGetParticipantsResponseApplicationJson, RoomRoomGetParticipantsHeaders> getParticipantsRaw({
    required String token,
    int? includeStatus,
    RoomGetParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $includeStatus = jsonSerializers.serialize(includeStatus, specifiedType: const FullType(int));
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetParticipantsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants{?includeStatus*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomGetParticipantsResponseApplicationJson, RoomRoomGetParticipantsHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomGetParticipantsResponseApplicationJson),
      headersType: const FullType(RoomRoomGetParticipantsHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Add a participant to a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newParticipant] New participant.
  ///   * [source] Source of the participant. Defaults to `users`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant successfully added
  ///   * 404: User, group or other target to invite was not found
  ///   * 501: SIP dial-out is not configured
  ///   * 400: Adding participant is not possible
  ///
  /// See:
  ///  * [addParticipantToRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomAddParticipantToRoomResponseApplicationJson, void>> addParticipantToRoom({
    required String newParticipant,
    required String token,
    RoomAddParticipantToRoomSource? source,
    RoomAddParticipantToRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = addParticipantToRoomRaw(
      newParticipant: newParticipant,
      token: token,
      source: source,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Add a participant to a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [newParticipant] New participant.
  ///   * [source] Source of the participant. Defaults to `users`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant successfully added
  ///   * 404: User, group or other target to invite was not found
  ///   * 501: SIP dial-out is not configured
  ///   * 400: Adding participant is not possible
  ///
  /// See:
  ///  * [addParticipantToRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomAddParticipantToRoomResponseApplicationJson, void> addParticipantToRoomRaw({
    required String newParticipant,
    required String token,
    RoomAddParticipantToRoomSource? source,
    RoomAddParticipantToRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $newParticipant = jsonSerializers.serialize(newParticipant, specifiedType: const FullType(String));
    _parameters['newParticipant'] = $newParticipant;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $source = jsonSerializers.serialize(source, specifiedType: const FullType(RoomAddParticipantToRoomSource));
    $source ??= 'users';
    _parameters['source'] = $source;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomAddParticipantToRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants{?newParticipant*,source*}')
            .expand(_parameters);
    return DynamiteRawResponse<RoomAddParticipantToRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomAddParticipantToRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get the breakout room participants for a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout room participants returned
  ///   * 400: Getting breakout room participants is not possible
  ///   * 403: Missing permissions to get breakout room participants
  ///
  /// See:
  ///  * [getBreakoutRoomParticipantsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<
      DynamiteResponse<RoomGetBreakoutRoomParticipantsResponseApplicationJson,
          RoomRoomGetBreakoutRoomParticipantsHeaders>> getBreakoutRoomParticipants({
    required String token,
    int? includeStatus,
    RoomGetBreakoutRoomParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getBreakoutRoomParticipantsRaw(
      token: token,
      includeStatus: includeStatus,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the breakout room participants for a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [includeStatus] Include the user statuses. Defaults to `0`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Breakout room participants returned
  ///   * 400: Getting breakout room participants is not possible
  ///   * 403: Missing permissions to get breakout room participants
  ///
  /// See:
  ///  * [getBreakoutRoomParticipants] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomGetBreakoutRoomParticipantsResponseApplicationJson,
      RoomRoomGetBreakoutRoomParticipantsHeaders> getBreakoutRoomParticipantsRaw({
    required String token,
    int? includeStatus,
    RoomGetBreakoutRoomParticipantsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $includeStatus = jsonSerializers.serialize(includeStatus, specifiedType: const FullType(int));
    $includeStatus ??= 0;
    _parameters['includeStatus'] = $includeStatus;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomGetBreakoutRoomParticipantsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/breakout-rooms/participants{?includeStatus*}',
    ).expand(_parameters);
    return DynamiteRawResponse<RoomGetBreakoutRoomParticipantsResponseApplicationJson,
        RoomRoomGetBreakoutRoomParticipantsHeaders>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomGetBreakoutRoomParticipantsResponseApplicationJson),
      headersType: const FullType(RoomRoomGetBreakoutRoomParticipantsHeaders),
      serializers: jsonSerializers,
    );
  }

  /// Remove the current user from a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant removed successfully
  ///   * 400: Removing participant is not possible
  ///   * 404: Participant not found
  ///
  /// See:
  ///  * [removeSelfFromRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomRemoveSelfFromRoomResponseApplicationJson, void>> removeSelfFromRoom({
    required String token,
    RoomRemoveSelfFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = removeSelfFromRoomRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Remove the current user from a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Participant removed successfully
  ///   * 400: Removing participant is not possible
  ///   * 404: Participant not found
  ///
  /// See:
  ///  * [removeSelfFromRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomRemoveSelfFromRoomResponseApplicationJson, void> removeSelfFromRoomRaw({
    required String token,
    RoomRemoveSelfFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRemoveSelfFromRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/self').expand(_parameters);
    return DynamiteRawResponse<RoomRemoveSelfFromRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 400, 404},
      ),
      bodyType: const FullType(RoomRemoveSelfFromRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Remove an attendee from a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee removed successfully
  ///   * 400: Removing attendee is not possible
  ///   * 403: Removing attendee is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [removeAttendeeFromRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomRemoveAttendeeFromRoomResponseApplicationJson, void>> removeAttendeeFromRoom({
    required int attendeeId,
    required String token,
    RoomRemoveAttendeeFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = removeAttendeeFromRoomRaw(
      attendeeId: attendeeId,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Remove an attendee from a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee removed successfully
  ///   * 400: Removing attendee is not possible
  ///   * 403: Removing attendee is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [removeAttendeeFromRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomRemoveAttendeeFromRoomResponseApplicationJson, void> removeAttendeeFromRoomRaw({
    required int attendeeId,
    required String token,
    RoomRemoveAttendeeFromRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $attendeeId = jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRemoveAttendeeFromRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/attendees{?attendeeId*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomRemoveAttendeeFromRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 400, 403, 404},
      ),
      bodyType: const FullType(RoomRemoveAttendeeFromRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update the permissions of an attendee.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///   * 403: Missing permissions to update permissions
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [setAttendeePermissionsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetAttendeePermissionsResponseApplicationJson, void>> setAttendeePermissions({
    required int attendeeId,
    required RoomSetAttendeePermissionsMethod method,
    required RoomSetAttendeePermissionsPermissions permissions,
    required String token,
    RoomSetAttendeePermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setAttendeePermissionsRaw(
      attendeeId: attendeeId,
      method: method,
      permissions: permissions,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update the permissions of an attendee.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///   * 403: Missing permissions to update permissions
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [setAttendeePermissions] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetAttendeePermissionsResponseApplicationJson, void> setAttendeePermissionsRaw({
    required int attendeeId,
    required RoomSetAttendeePermissionsMethod method,
    required RoomSetAttendeePermissionsPermissions permissions,
    required String token,
    RoomSetAttendeePermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $attendeeId = jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $method = jsonSerializers.serialize(method, specifiedType: const FullType(RoomSetAttendeePermissionsMethod));
    _parameters['method'] = $method;

    final $permissions =
        jsonSerializers.serialize(permissions, specifiedType: const FullType(RoomSetAttendeePermissionsPermissions));
    _parameters['permissions'] = $permissions;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetAttendeePermissionsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/attendees/permissions{?attendeeId*,method*,permissions*}',
    ).expand(_parameters);
    return DynamiteRawResponse<RoomSetAttendeePermissionsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200, 400, 403, 404},
      ),
      bodyType: const FullType(RoomSetAttendeePermissionsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update the permissions of all attendees.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [setAllAttendeesPermissionsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetAllAttendeesPermissionsResponseApplicationJson, void>> setAllAttendeesPermissions({
    required RoomSetAllAttendeesPermissionsMethod method,
    required RoomSetAllAttendeesPermissionsPermissions permissions,
    required String token,
    RoomSetAllAttendeesPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setAllAttendeesPermissionsRaw(
      method: method,
      permissions: permissions,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update the permissions of all attendees.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [method] Method of updating permissions ('set', 'remove', 'add').
  ///   * [permissions] New permissions.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Permissions updated successfully
  ///   * 400: Updating permissions is not possible
  ///
  /// See:
  ///  * [setAllAttendeesPermissions] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetAllAttendeesPermissionsResponseApplicationJson, void> setAllAttendeesPermissionsRaw({
    required RoomSetAllAttendeesPermissionsMethod method,
    required RoomSetAllAttendeesPermissionsPermissions permissions,
    required String token,
    RoomSetAllAttendeesPermissionsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $method =
        jsonSerializers.serialize(method, specifiedType: const FullType(RoomSetAllAttendeesPermissionsMethod));
    _parameters['method'] = $method;

    final $permissions = jsonSerializers.serialize(
      permissions,
      specifiedType: const FullType(RoomSetAllAttendeesPermissionsPermissions),
    );
    _parameters['permissions'] = $permissions;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetAllAttendeesPermissionsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/attendees/permissions/all{?method*,permissions*}',
    ).expand(_parameters);
    return DynamiteRawResponse<RoomSetAllAttendeesPermissionsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomSetAllAttendeesPermissionsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Join a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] Password of the room. Defaults to `''`.
  ///   * [force] Create a new session if necessary. Defaults to `1`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room joined successfully
  ///   * 403: Joining room is not allowed
  ///   * 404: Room not found
  ///   * 409: Session already exists
  ///
  /// See:
  ///  * [joinRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomJoinRoomResponseApplicationJson, void>> joinRoom({
    required String token,
    String? password,
    int? force,
    RoomJoinRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = joinRoomRaw(
      token: token,
      password: password,
      force: force,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Join a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [password] Password of the room. Defaults to `''`.
  ///   * [force] Create a new session if necessary. Defaults to `1`.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Room joined successfully
  ///   * 403: Joining room is not allowed
  ///   * 404: Room not found
  ///   * 409: Session already exists
  ///
  /// See:
  ///  * [joinRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomJoinRoomResponseApplicationJson, void> joinRoomRaw({
    required String token,
    String? password,
    int? force,
    RoomJoinRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $password = jsonSerializers.serialize(password, specifiedType: const FullType(String));
    $password ??= '';
    _parameters['password'] = $password;

    var $force = jsonSerializers.serialize(force, specifiedType: const FullType(int));
    $force ??= 1;
    _parameters['force'] = $force;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomJoinRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/active{?password*,force*}')
            .expand(_parameters);
    return DynamiteRawResponse<RoomJoinRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomJoinRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Leave a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully left the room
  ///
  /// See:
  ///  * [leaveRoomRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomLeaveRoomResponseApplicationJson, void>> leaveRoom({
    required String token,
    RoomLeaveRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = leaveRoomRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Leave a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully left the room
  ///
  /// See:
  ///  * [leaveRoom] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomLeaveRoomResponseApplicationJson, void> leaveRoomRaw({
    required String token,
    RoomLeaveRoomApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomLeaveRoomApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/active').expand(_parameters);
    return DynamiteRawResponse<RoomLeaveRoomResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomLeaveRoomResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Resend invitations.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invitation resent successfully
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [resendInvitationsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomResendInvitationsResponseApplicationJson, void>> resendInvitations({
    required String token,
    int? attendeeId,
    RoomResendInvitationsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = resendInvitationsRaw(
      token: token,
      attendeeId: attendeeId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Resend invitations.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Invitation resent successfully
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [resendInvitations] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomResendInvitationsResponseApplicationJson, void> resendInvitationsRaw({
    required String token,
    int? attendeeId,
    RoomResendInvitationsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $attendeeId = jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomResendInvitationsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/resend-invitations{?attendeeId*}',
    ).expand(_parameters);
    return DynamiteRawResponse<RoomResendInvitationsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 404},
      ),
      bodyType: const FullType(RoomResendInvitationsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Set active state for a session.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] of the room.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Session state set successfully
  ///   * 400: The provided new state was invalid
  ///   * 404: The participant did not have a session
  ///
  /// See:
  ///  * [setSessionStateRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetSessionStateResponseApplicationJson, void>> setSessionState({
    required RoomSetSessionStateState state,
    required String token,
    RoomSetSessionStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setSessionStateRaw(
      state: state,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set active state for a session.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] of the room.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Session state set successfully
  ///   * 400: The provided new state was invalid
  ///   * 404: The participant did not have a session
  ///
  /// See:
  ///  * [setSessionState] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetSessionStateResponseApplicationJson, void> setSessionStateRaw({
    required RoomSetSessionStateState state,
    required String token,
    RoomSetSessionStateApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $state = jsonSerializers.serialize(state, specifiedType: const FullType(RoomSetSessionStateState));
    _parameters['state'] = $state;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetSessionStateApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/participants/state{?state*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomSetSessionStateResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomSetSessionStateResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Promote an attendee to moderator.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee promoted to moderator successfully
  ///   * 400: Promoting attendee to moderator is not possible
  ///   * 403: Promoting attendee to moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [promoteModeratorRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomPromoteModeratorResponseApplicationJson, void>> promoteModerator({
    required int attendeeId,
    required String token,
    RoomPromoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = promoteModeratorRaw(
      attendeeId: attendeeId,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Promote an attendee to moderator.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee promoted to moderator successfully
  ///   * 400: Promoting attendee to moderator is not possible
  ///   * 403: Promoting attendee to moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [promoteModerator] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomPromoteModeratorResponseApplicationJson, void> promoteModeratorRaw({
    required int attendeeId,
    required String token,
    RoomPromoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $attendeeId = jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomPromoteModeratorApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/moderators{?attendeeId*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomPromoteModeratorResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 400, 403, 404},
      ),
      bodyType: const FullType(RoomPromoteModeratorResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Demote an attendee from moderator.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee demoted from moderator successfully
  ///   * 400: Demoting attendee from moderator is not possible
  ///   * 403: Demoting attendee from moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [demoteModeratorRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomDemoteModeratorResponseApplicationJson, void>> demoteModerator({
    required int attendeeId,
    required String token,
    RoomDemoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = demoteModeratorRaw(
      attendeeId: attendeeId,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Demote an attendee from moderator.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [attendeeId] ID of the attendee.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Attendee demoted from moderator successfully
  ///   * 400: Demoting attendee from moderator is not possible
  ///   * 403: Demoting attendee from moderator is not allowed
  ///   * 404: Attendee not found
  ///
  /// See:
  ///  * [demoteModerator] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomDemoteModeratorResponseApplicationJson, void> demoteModeratorRaw({
    required int attendeeId,
    required String token,
    RoomDemoteModeratorApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $attendeeId = jsonSerializers.serialize(attendeeId, specifiedType: const FullType(int));
    _parameters['attendeeId'] = $attendeeId;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomDemoteModeratorApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/moderators{?attendeeId*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomDemoteModeratorResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 400, 403, 404},
      ),
      bodyType: const FullType(RoomDemoteModeratorResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Add a room to the favorites.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully added room to favorites
  ///
  /// See:
  ///  * [addToFavoritesRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomAddToFavoritesResponseApplicationJson, void>> addToFavorites({
    required String token,
    RoomAddToFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = addToFavoritesRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Add a room to the favorites.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully added room to favorites
  ///
  /// See:
  ///  * [addToFavorites] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomAddToFavoritesResponseApplicationJson, void> addToFavoritesRaw({
    required String token,
    RoomAddToFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomAddToFavoritesApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/favorite').expand(_parameters);
    return DynamiteRawResponse<RoomAddToFavoritesResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomAddToFavoritesResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Remove a room from the favorites.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully removed room from favorites
  ///
  /// See:
  ///  * [removeFromFavoritesRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomRemoveFromFavoritesResponseApplicationJson, void>> removeFromFavorites({
    required String token,
    RoomRemoveFromFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = removeFromFavoritesRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Remove a room from the favorites.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully removed room from favorites
  ///
  /// See:
  ///  * [removeFromFavorites] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomRemoveFromFavoritesResponseApplicationJson, void> removeFromFavoritesRaw({
    required String token,
    RoomRemoveFromFavoritesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomRemoveFromFavoritesApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/favorite').expand(_parameters);
    return DynamiteRawResponse<RoomRemoveFromFavoritesResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomRemoveFromFavoritesResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update the notification level for a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification level updated successfully
  ///   * 400: Updating notification level is not possible
  ///
  /// See:
  ///  * [setNotificationLevelRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetNotificationLevelResponseApplicationJson, void>> setNotificationLevel({
    required int level,
    required String token,
    RoomSetNotificationLevelApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setNotificationLevelRaw(
      level: level,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update the notification level for a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Notification level updated successfully
  ///   * 400: Updating notification level is not possible
  ///
  /// See:
  ///  * [setNotificationLevel] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetNotificationLevelResponseApplicationJson, void> setNotificationLevelRaw({
    required int level,
    required String token,
    RoomSetNotificationLevelApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $level = jsonSerializers.serialize(level, specifiedType: const FullType(int));
    _parameters['level'] = $level;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetNotificationLevelApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/notify{?level*}').expand(_parameters);
    return DynamiteRawResponse<RoomSetNotificationLevelResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomSetNotificationLevelResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update call notifications.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call notification level updated successfully
  ///   * 400: Updating call notification level is not possible
  ///
  /// See:
  ///  * [setNotificationCallsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetNotificationCallsResponseApplicationJson, void>> setNotificationCalls({
    required int level,
    required String token,
    RoomSetNotificationCallsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setNotificationCallsRaw(
      level: level,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update call notifications.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [level] New level.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Call notification level updated successfully
  ///   * 400: Updating call notification level is not possible
  ///
  /// See:
  ///  * [setNotificationCalls] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetNotificationCallsResponseApplicationJson, void> setNotificationCallsRaw({
    required int level,
    required String token,
    RoomSetNotificationCallsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $level = jsonSerializers.serialize(level, specifiedType: const FullType(int));
    _parameters['level'] = $level;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetNotificationCallsApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/notify-calls{?level*}').expand(_parameters);
    return DynamiteRawResponse<RoomSetNotificationCallsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(RoomSetNotificationCallsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update the lobby state for a room.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [timer] Timer when the lobby will be removed.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Lobby state updated successfully
  ///   * 400: Updating lobby state is not possible
  ///
  /// See:
  ///  * [setLobbyRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetLobbyResponseApplicationJson, void>> setLobby({
    required int state,
    required String token,
    int? timer,
    RoomSetLobbyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setLobbyRaw(
      state: state,
      token: token,
      timer: timer,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update the lobby state for a room.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [timer] Timer when the lobby will be removed.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Lobby state updated successfully
  ///   * 400: Updating lobby state is not possible
  ///
  /// See:
  ///  * [setLobby] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetLobbyResponseApplicationJson, void> setLobbyRaw({
    required int state,
    required String token,
    int? timer,
    RoomSetLobbyApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $state = jsonSerializers.serialize(state, specifiedType: const FullType(int));
    _parameters['state'] = $state;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    final $timer = jsonSerializers.serialize(timer, specifiedType: const FullType(int));
    _parameters['timer'] = $timer;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetLobbyApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/webinar/lobby{?state*,timer*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomSetLobbyResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomSetLobbyResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update SIP enabled state.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: SIP enabled state updated successfully
  ///   * 400: Updating SIP enabled state is not possible
  ///   * 401: User not found
  ///   * 403: Missing permissions to update SIP enabled state
  ///   * 412: SIP not configured
  ///
  /// See:
  ///  * [setsipEnabledRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetsipEnabledResponseApplicationJson, void>> setsipEnabled({
    required RoomSetsipEnabledState state,
    required String token,
    RoomSetsipEnabledApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setsipEnabledRaw(
      state: state,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update SIP enabled state.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [state] New state.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: SIP enabled state updated successfully
  ///   * 400: Updating SIP enabled state is not possible
  ///   * 401: User not found
  ///   * 403: Missing permissions to update SIP enabled state
  ///   * 412: SIP not configured
  ///
  /// See:
  ///  * [setsipEnabled] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetsipEnabledResponseApplicationJson, void> setsipEnabledRaw({
    required RoomSetsipEnabledState state,
    required String token,
    RoomSetsipEnabledApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $state = jsonSerializers.serialize(state, specifiedType: const FullType(RoomSetsipEnabledState));
    _parameters['state'] = $state;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion = jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetsipEnabledApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/webinar/sip{?state*}').expand(_parameters);
    return DynamiteRawResponse<RoomSetsipEnabledResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomSetsipEnabledResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Set recording consent requirement for this conversation.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [recordingConsent] New consent setting for the conversation (Only {@see RecordingService::CONSENT_REQUIRED_NO} and {@see RecordingService::CONSENT_REQUIRED_YES} are allowed here.).
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording consent requirement set successfully
  ///   * 400: Setting recording consent requirement is not possible
  ///   * 412: No recording server is configured
  ///
  /// See:
  ///  * [setRecordingConsentRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetRecordingConsentResponseApplicationJson, void>> setRecordingConsent({
    required int recordingConsent,
    required String token,
    RoomSetRecordingConsentApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setRecordingConsentRaw(
      recordingConsent: recordingConsent,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Set recording consent requirement for this conversation.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [recordingConsent] New consent setting for the conversation (Only {@see RecordingService::CONSENT_REQUIRED_NO} and {@see RecordingService::CONSENT_REQUIRED_YES} are allowed here.).
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Recording consent requirement set successfully
  ///   * 400: Setting recording consent requirement is not possible
  ///   * 412: No recording server is configured
  ///
  /// See:
  ///  * [setRecordingConsent] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetRecordingConsentResponseApplicationJson, void> setRecordingConsentRaw({
    required int recordingConsent,
    required String token,
    RoomSetRecordingConsentApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $recordingConsent = jsonSerializers.serialize(recordingConsent, specifiedType: const FullType(int));
    _parameters['recordingConsent'] = $recordingConsent;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetRecordingConsentApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/recording-consent{?recordingConsent*}')
            .expand(_parameters);
    return DynamiteRawResponse<RoomSetRecordingConsentResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'put',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomSetRecordingConsentResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update message expiration time.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [seconds] New time.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message expiration time updated successfully
  ///   * 400: Updating message expiration time is not possible
  ///
  /// See:
  ///  * [setMessageExpirationRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<RoomSetMessageExpirationResponseApplicationJson, void>> setMessageExpiration({
    required int seconds,
    required String token,
    RoomSetMessageExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setMessageExpirationRaw(
      seconds: seconds,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update message expiration time.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [seconds] New time.
  ///   * [apiVersion] Defaults to `v4`.
  ///   * [token]
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Message expiration time updated successfully
  ///   * 400: Updating message expiration time is not possible
  ///
  /// See:
  ///  * [setMessageExpiration] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<RoomSetMessageExpirationResponseApplicationJson, void> setMessageExpirationRaw({
    required int seconds,
    required String token,
    RoomSetMessageExpirationApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $seconds = jsonSerializers.serialize(seconds, specifiedType: const FullType(int));
    _parameters['seconds'] = $seconds;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(RoomSetMessageExpirationApiVersion));
    $apiVersion ??= 'v4';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/room/{token}/message-expiration{?seconds*}')
        .expand(_parameters);
    return DynamiteRawResponse<RoomSetMessageExpirationResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(RoomSetMessageExpirationResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $SettingsClient {
  $SettingsClient(this._rootClient);

  final $Client _rootClient;

  /// Update SIP bridge settings.
  ///
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [sipGroups] New SIP groups. Defaults to `[]`.
  ///   * [dialInInfo] New dial info. Defaults to `''`.
  ///   * [sharedSecret] New shared secret. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully set new SIP settings
  ///
  /// See:
  ///  * [setsipSettingsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<SettingsSetsipSettingsResponseApplicationJson, void>> setsipSettings({
    BuiltList<String>? sipGroups,
    String? dialInInfo,
    String? sharedSecret,
    SettingsSetsipSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setsipSettingsRaw(
      sipGroups: sipGroups,
      dialInInfo: dialInInfo,
      sharedSecret: sharedSecret,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update SIP bridge settings.
  ///
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [sipGroups] New SIP groups. Defaults to `[]`.
  ///   * [dialInInfo] New dial info. Defaults to `''`.
  ///   * [sharedSecret] New shared secret. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Successfully set new SIP settings
  ///
  /// See:
  ///  * [setsipSettings] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<SettingsSetsipSettingsResponseApplicationJson, void> setsipSettingsRaw({
    BuiltList<String>? sipGroups,
    String? dialInInfo,
    String? sharedSecret,
    SettingsSetsipSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $sipGroups = jsonSerializers.serialize(sipGroups, specifiedType: const FullType(BuiltList, [FullType(String)]));
    $sipGroups ??= [];
    _parameters['sipGroups%5B%5D'] = $sipGroups;

    var $dialInInfo = jsonSerializers.serialize(dialInInfo, specifiedType: const FullType(String));
    $dialInInfo ??= '';
    _parameters['dialInInfo'] = $dialInInfo;

    var $sharedSecret = jsonSerializers.serialize(sharedSecret, specifiedType: const FullType(String));
    $sharedSecret ??= '';
    _parameters['sharedSecret'] = $sharedSecret;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SettingsSetsipSettingsApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate(
      '/ocs/v2.php/apps/spreed/api/{apiVersion}/settings/sip{?sipGroups%5B%5D*,dialInInfo*,sharedSecret*}',
    ).expand(_parameters);
    return DynamiteRawResponse<SettingsSetsipSettingsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(SettingsSetsipSettingsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Update user setting.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [key] Key to update.
  ///   * [value] New value for the key.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User setting updated successfully
  ///   * 400: Updating user setting is not possible
  ///
  /// See:
  ///  * [setUserSettingRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<SettingsSetUserSettingResponseApplicationJson, void>> setUserSetting({
    required SettingsSetUserSettingKey key,
    SettingsSetUserSettingValue? value,
    SettingsSetUserSettingApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = setUserSettingRaw(
      key: key,
      value: value,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Update user setting.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [key] Key to update.
  ///   * [value] New value for the key.
  ///   * [apiVersion] Defaults to `v1`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: User setting updated successfully
  ///   * 400: Updating user setting is not possible
  ///
  /// See:
  ///  * [setUserSetting] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<SettingsSetUserSettingResponseApplicationJson, void> setUserSettingRaw({
    required SettingsSetUserSettingKey key,
    SettingsSetUserSettingValue? value,
    SettingsSetUserSettingApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $key = jsonSerializers.serialize(key, specifiedType: const FullType(SettingsSetUserSettingKey));
    _parameters['key'] = $key;

    final $value = jsonSerializers.serialize(value, specifiedType: const FullType(SettingsSetUserSettingValue));
    _parameters['value'] = $value;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SettingsSetUserSettingApiVersion));
    $apiVersion ??= 'v1';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/settings/user{?key*,value*}').expand(_parameters);
    return DynamiteRawResponse<SettingsSetUserSettingResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(SettingsSetUserSettingResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $SignalingClient {
  $SignalingClient(this._rootClient);

  final $Client _rootClient;

  /// Get the signaling settings.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the room. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling settings returned
  ///   * 401: Recording request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [getSettingsRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<SignalingGetSettingsResponseApplicationJson, void>> getSettings({
    String? token,
    SignalingGetSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getSettingsRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the signaling settings.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [token] Token of the room. Defaults to `''`.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling settings returned
  ///   * 401: Recording request invalid
  ///   * 404: Room not found
  ///
  /// See:
  ///  * [getSettings] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<SignalingGetSettingsResponseApplicationJson, void> getSettingsRaw({
    String? token,
    SignalingGetSettingsApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    var $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    $token ??= '';
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingGetSettingsApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/settings{?token*}').expand(_parameters);
    return DynamiteRawResponse<SignalingGetSettingsResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(SignalingGetSettingsResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get the welcome message from a signaling server.
  ///
  /// Only available for logged-in users because guests can not use the apps right now.
  /// This endpoint requires admin access.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [serverId] ID of the signaling server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Signaling server not found
  ///   * 500
  ///
  /// See:
  ///  * [getWelcomeMessageRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<SignalingGetWelcomeMessageResponseApplicationJson, void>> getWelcomeMessage({
    required int serverId,
    SignalingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = getWelcomeMessageRaw(
      serverId: serverId,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get the welcome message from a signaling server.
  ///
  /// Only available for logged-in users because guests can not use the apps right now.
  /// This endpoint requires admin access.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [serverId] ID of the signaling server.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Welcome message returned
  ///   * 404: Signaling server not found
  ///   * 500
  ///
  /// See:
  ///  * [getWelcomeMessage] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<SignalingGetWelcomeMessageResponseApplicationJson, void> getWelcomeMessageRaw({
    required int serverId,
    SignalingGetWelcomeMessageApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    final $serverId = jsonSerializers.serialize(serverId, specifiedType: const FullType(int));
    _parameters['serverId'] = $serverId;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingGetWelcomeMessageApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/welcome/{serverId}').expand(_parameters);
    return DynamiteRawResponse<SignalingGetWelcomeMessageResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(SignalingGetWelcomeMessageResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Get signaling messages.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling messages returned
  ///   * 404: Session, room or participant not found
  ///   * 409: Session killed
  ///   * 400: Getting signaling messages is not possible
  ///
  /// See:
  ///  * [pullMessagesRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<SignalingPullMessagesResponseApplicationJson, void>> pullMessages({
    required String token,
    SignalingPullMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = pullMessagesRaw(
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Get signaling messages.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling messages returned
  ///   * 404: Session, room or participant not found
  ///   * 409: Session killed
  ///   * 400: Getting signaling messages is not possible
  ///
  /// See:
  ///  * [pullMessages] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<SignalingPullMessagesResponseApplicationJson, void> pullMessagesRaw({
    required String token,
    SignalingPullMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingPullMessagesApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path = UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/{token}').expand(_parameters);
    return DynamiteRawResponse<SignalingPullMessagesResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'get',
        _path,
        _headers,
        null,
        const {200, 404, 409},
      ),
      bodyType: const FullType(SignalingPullMessagesResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Send signaling messages.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [messages] JSON encoded messages.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling message sent successfully
  ///   * 400: Sending signaling message is not possible
  ///
  /// See:
  ///  * [sendMessagesRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<SignalingSendMessagesResponseApplicationJson, void>> sendMessages({
    required String messages,
    required String token,
    SignalingSendMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = sendMessagesRaw(
      messages: messages,
      token: token,
      apiVersion: apiVersion,
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Send signaling messages.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [messages] JSON encoded messages.
  ///   * [apiVersion] Defaults to `v3`.
  ///   * [token] Token of the room.
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Signaling message sent successfully
  ///   * 400: Sending signaling message is not possible
  ///
  /// See:
  ///  * [sendMessages] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<SignalingSendMessagesResponseApplicationJson, void> sendMessagesRaw({
    required String messages,
    required String token,
    SignalingSendMessagesApiVersion? apiVersion,
    bool? oCSAPIRequest,
  }) {
    final _parameters = <String, dynamic>{};
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    }

// coverage:ignore-end
    final $messages = jsonSerializers.serialize(messages, specifiedType: const FullType(String));
    _parameters['messages'] = $messages;

    final $token = jsonSerializers.serialize(token, specifiedType: const FullType(String));
    dynamite_utils.checkPattern($token as String?, RegExp(r'^[a-z0-9]{4,30}$'), 'token');
    _parameters['token'] = $token;

    var $apiVersion =
        jsonSerializers.serialize(apiVersion, specifiedType: const FullType(SignalingSendMessagesApiVersion));
    $apiVersion ??= 'v3';
    _parameters['apiVersion'] = $apiVersion;

    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    final _path =
        UriTemplate('/ocs/v2.php/apps/spreed/api/{apiVersion}/signaling/{token}{?messages*}').expand(_parameters);
    return DynamiteRawResponse<SignalingSendMessagesResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(SignalingSendMessagesResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class $TempAvatarClient {
  $TempAvatarClient(this._rootClient);

  final $Client _rootClient;

  /// Upload your avatar as a user.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Uploading avatar is not possible
  ///
  /// See:
  ///  * [postAvatarRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<TempAvatarPostAvatarResponseApplicationJson, void>> postAvatar({bool? oCSAPIRequest}) async {
    final rawResponse = postAvatarRaw(
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Upload your avatar as a user.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar uploaded successfully
  ///   * 400: Uploading avatar is not possible
  ///
  /// See:
  ///  * [postAvatar] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<TempAvatarPostAvatarResponseApplicationJson, void> postAvatarRaw({bool? oCSAPIRequest}) {
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    const _path = '/ocs/v2.php/apps/spreed/temp-user-avatar';
    return DynamiteRawResponse<TempAvatarPostAvatarResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'post',
        _path,
        _headers,
        null,
        const {200},
      ),
      bodyType: const FullType(TempAvatarPostAvatarResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }

  /// Delete your avatar as a user.
  ///
  /// Returns a [Future] containing a [DynamiteResponse] with the status code, deserialized body and headers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar deleted successfully
  ///   * 400: Deleting avatar is not possible
  ///
  /// See:
  ///  * [deleteAvatarRaw] for an experimental operation that returns a [DynamiteRawResponse] that can be serialized.
  Future<DynamiteResponse<TempAvatarDeleteAvatarResponseApplicationJson, void>> deleteAvatar({
    bool? oCSAPIRequest,
  }) async {
    final rawResponse = deleteAvatarRaw(
      oCSAPIRequest: oCSAPIRequest,
    );

    return rawResponse.future;
  }

  /// Delete your avatar as a user.
  ///
  /// This method and the response it returns is experimental. The API might change without a major version bump.
  ///
  /// Returns a [Future] containing a [DynamiteRawResponse] with the raw [HttpClientResponse] and serialization helpers.
  /// Throws a [DynamiteApiException] if the API call does not return an expected status code.
  ///
  /// Parameters:
  ///   * [oCSAPIRequest] Required to be true for the API request to pass. Defaults to `true`.
  ///
  /// Status codes:
  ///   * 200: Avatar deleted successfully
  ///   * 400: Deleting avatar is not possible
  ///
  /// See:
  ///  * [deleteAvatar] for an operation that returns a [DynamiteResponse] with a stable API.
  @experimental
  DynamiteRawResponse<TempAvatarDeleteAvatarResponseApplicationJson, void> deleteAvatarRaw({bool? oCSAPIRequest}) {
    final _headers = <String, String>{
      'Accept': 'application/json',
    };

// coverage:ignore-start
    final authentication = _rootClient.authentications.firstWhereOrNull(
      (auth) => switch (auth) {
        DynamiteHttpBearerAuthentication() || DynamiteHttpBasicAuthentication() => true,
        _ => false,
      },
    );

    if (authentication != null) {
      _headers.addAll(
        authentication.headers,
      );
    } else {
      throw Exception('Missing authentication for bearer_auth or basic_auth');
    }

// coverage:ignore-end
    var $oCSAPIRequest = jsonSerializers.serialize(oCSAPIRequest, specifiedType: const FullType(bool));
    $oCSAPIRequest ??= true;
    _headers['OCS-APIRequest'] = const dynamite_utils.HeaderEncoder().convert($oCSAPIRequest);

    const _path = '/ocs/v2.php/apps/spreed/temp-user-avatar';
    return DynamiteRawResponse<TempAvatarDeleteAvatarResponseApplicationJson, void>(
      response: _rootClient.executeRequest(
        'delete',
        _path,
        _headers,
        null,
        const {200, 400},
      ),
      bodyType: const FullType(TempAvatarDeleteAvatarResponseApplicationJson),
      headersType: null,
      serializers: jsonSerializers,
    );
  }
}

class AvatarGetAvatarApiVersion extends EnumClass {
  const AvatarGetAvatarApiVersion._(super.name);

  static const AvatarGetAvatarApiVersion v1 = _$avatarGetAvatarApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<AvatarGetAvatarApiVersion> get values => _$avatarGetAvatarApiVersionValues;
  // coverage:ignore-end

  static AvatarGetAvatarApiVersion valueOf(String name) => _$valueOfAvatarGetAvatarApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetAvatarApiVersion> get serializer => const _$AvatarGetAvatarApiVersionSerializer();
}

class _$AvatarGetAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarGetAvatarApiVersion> {
  const _$AvatarGetAvatarApiVersionSerializer();

  static const Map<AvatarGetAvatarApiVersion, Object> _toWire = <AvatarGetAvatarApiVersion, Object>{
    AvatarGetAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetAvatarApiVersion> _fromWire = <Object, AvatarGetAvatarApiVersion>{
    'v1': AvatarGetAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetAvatarApiVersion];

  @override
  String get wireName => 'AvatarGetAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class AvatarUploadAvatarApiVersion extends EnumClass {
  const AvatarUploadAvatarApiVersion._(super.name);

  static const AvatarUploadAvatarApiVersion v1 = _$avatarUploadAvatarApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<AvatarUploadAvatarApiVersion> get values => _$avatarUploadAvatarApiVersionValues;
  // coverage:ignore-end

  static AvatarUploadAvatarApiVersion valueOf(String name) => _$valueOfAvatarUploadAvatarApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarUploadAvatarApiVersion> get serializer => const _$AvatarUploadAvatarApiVersionSerializer();
}

class _$AvatarUploadAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarUploadAvatarApiVersion> {
  const _$AvatarUploadAvatarApiVersionSerializer();

  static const Map<AvatarUploadAvatarApiVersion, Object> _toWire = <AvatarUploadAvatarApiVersion, Object>{
    AvatarUploadAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarUploadAvatarApiVersion> _fromWire = <Object, AvatarUploadAvatarApiVersion>{
    'v1': AvatarUploadAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarUploadAvatarApiVersion];

  @override
  String get wireName => 'AvatarUploadAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarUploadAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarUploadAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $OCSMetaInterface {
  String get status;
  int get statuscode;
  String? get message;
  String? get totalitems;
  String? get itemsperpage;
}

abstract class OCSMeta implements $OCSMetaInterface, Built<OCSMeta, OCSMetaBuilder> {
  factory OCSMeta([void Function(OCSMetaBuilder)? b]) = _$OCSMeta;

  // coverage:ignore-start
  const OCSMeta._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory OCSMeta.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<OCSMeta> get serializer => _$oCSMetaSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMessageInterface {
  String get actorDisplayName;
  String get actorId;
  String get actorType;
  bool? get deleted;
  int get expirationTimestamp;
  int get id;
  bool get isReplyable;
  bool? get markdown;
  String get message;
  BuiltMap<String, BuiltMap<String, JsonObject>> get messageParameters;
  String get messageType;
  BuiltMap<String, int> get reactions;
  String get referenceId;
  String get systemMessage;
  int get timestamp;
  String get token;
}

abstract class ChatMessage implements $ChatMessageInterface, Built<ChatMessage, ChatMessageBuilder> {
  factory ChatMessage([void Function(ChatMessageBuilder)? b]) = _$ChatMessage;

  // coverage:ignore-start
  const ChatMessage._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatMessage.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatMessage> get serializer => _$chatMessageSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomInterface {
  String get actorId;
  String get actorType;
  int get attendeeId;
  int get attendeePermissions;
  String? get attendeePin;
  String get avatarVersion;
  int get breakoutRoomMode;
  int get breakoutRoomStatus;
  int get callFlag;
  int get callPermissions;
  int get callRecording;
  int get callStartTime;
  bool get canDeleteConversation;
  bool get canEnableSIP;
  bool get canLeaveConversation;
  bool get canStartCall;
  int get defaultPermissions;
  String get description;
  String get displayName;
  bool get hasCall;
  bool get hasPassword;
  int get id;
  bool? get isCustomAvatar;
  bool get isFavorite;
  int get lastActivity;
  int get lastCommonReadMessage;
  Room_LastMessage get lastMessage;
  int get lastPing;
  int get lastReadMessage;
  int get listable;
  int get lobbyState;
  int get lobbyTimer;
  int get messageExpiration;
  String get name;
  int get notificationCalls;
  int get notificationLevel;
  String get objectId;
  String get objectType;
  int get participantFlags;
  int get participantType;
  int get permissions;
  int get readOnly;
  int? get recordingConsent;
  String get sessionId;
  int get sipEnabled;
  String? get status;
  int? get statusClearAt;
  String? get statusIcon;
  String? get statusMessage;
  String get token;
  int get type;
  bool get unreadMention;
  bool get unreadMentionDirect;
  int get unreadMessages;
}

abstract class Room implements $RoomInterface, Built<Room, RoomBuilder> {
  factory Room([void Function(RoomBuilder)? b]) = _$Room;

  // coverage:ignore-start
  const Room._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory Room.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<Room> get serializer => _$roomSerializer;

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomBuilder b) {
    b.lastMessage?.validateOneOf();
  }
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarUploadAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class AvatarUploadAvatarResponseApplicationJson_Ocs
    implements
        $AvatarUploadAvatarResponseApplicationJson_OcsInterface,
        Built<AvatarUploadAvatarResponseApplicationJson_Ocs, AvatarUploadAvatarResponseApplicationJson_OcsBuilder> {
  factory AvatarUploadAvatarResponseApplicationJson_Ocs([
    void Function(AvatarUploadAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AvatarUploadAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AvatarUploadAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory AvatarUploadAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<AvatarUploadAvatarResponseApplicationJson_Ocs> get serializer =>
      _$avatarUploadAvatarResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarUploadAvatarResponseApplicationJsonInterface {
  AvatarUploadAvatarResponseApplicationJson_Ocs get ocs;
}

abstract class AvatarUploadAvatarResponseApplicationJson
    implements
        $AvatarUploadAvatarResponseApplicationJsonInterface,
        Built<AvatarUploadAvatarResponseApplicationJson, AvatarUploadAvatarResponseApplicationJsonBuilder> {
  factory AvatarUploadAvatarResponseApplicationJson([
    void Function(AvatarUploadAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$AvatarUploadAvatarResponseApplicationJson;

  // coverage:ignore-start
  const AvatarUploadAvatarResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory AvatarUploadAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<AvatarUploadAvatarResponseApplicationJson> get serializer =>
      _$avatarUploadAvatarResponseApplicationJsonSerializer;
}

class AvatarDeleteAvatarApiVersion extends EnumClass {
  const AvatarDeleteAvatarApiVersion._(super.name);

  static const AvatarDeleteAvatarApiVersion v1 = _$avatarDeleteAvatarApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<AvatarDeleteAvatarApiVersion> get values => _$avatarDeleteAvatarApiVersionValues;
  // coverage:ignore-end

  static AvatarDeleteAvatarApiVersion valueOf(String name) => _$valueOfAvatarDeleteAvatarApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarDeleteAvatarApiVersion> get serializer => const _$AvatarDeleteAvatarApiVersionSerializer();
}

class _$AvatarDeleteAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarDeleteAvatarApiVersion> {
  const _$AvatarDeleteAvatarApiVersionSerializer();

  static const Map<AvatarDeleteAvatarApiVersion, Object> _toWire = <AvatarDeleteAvatarApiVersion, Object>{
    AvatarDeleteAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarDeleteAvatarApiVersion> _fromWire = <Object, AvatarDeleteAvatarApiVersion>{
    'v1': AvatarDeleteAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarDeleteAvatarApiVersion];

  @override
  String get wireName => 'AvatarDeleteAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarDeleteAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarDeleteAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarDeleteAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class AvatarDeleteAvatarResponseApplicationJson_Ocs
    implements
        $AvatarDeleteAvatarResponseApplicationJson_OcsInterface,
        Built<AvatarDeleteAvatarResponseApplicationJson_Ocs, AvatarDeleteAvatarResponseApplicationJson_OcsBuilder> {
  factory AvatarDeleteAvatarResponseApplicationJson_Ocs([
    void Function(AvatarDeleteAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AvatarDeleteAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AvatarDeleteAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory AvatarDeleteAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<AvatarDeleteAvatarResponseApplicationJson_Ocs> get serializer =>
      _$avatarDeleteAvatarResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarDeleteAvatarResponseApplicationJsonInterface {
  AvatarDeleteAvatarResponseApplicationJson_Ocs get ocs;
}

abstract class AvatarDeleteAvatarResponseApplicationJson
    implements
        $AvatarDeleteAvatarResponseApplicationJsonInterface,
        Built<AvatarDeleteAvatarResponseApplicationJson, AvatarDeleteAvatarResponseApplicationJsonBuilder> {
  factory AvatarDeleteAvatarResponseApplicationJson([
    void Function(AvatarDeleteAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$AvatarDeleteAvatarResponseApplicationJson;

  // coverage:ignore-start
  const AvatarDeleteAvatarResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory AvatarDeleteAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<AvatarDeleteAvatarResponseApplicationJson> get serializer =>
      _$avatarDeleteAvatarResponseApplicationJsonSerializer;
}

class AvatarEmojiAvatarApiVersion extends EnumClass {
  const AvatarEmojiAvatarApiVersion._(super.name);

  static const AvatarEmojiAvatarApiVersion v1 = _$avatarEmojiAvatarApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<AvatarEmojiAvatarApiVersion> get values => _$avatarEmojiAvatarApiVersionValues;
  // coverage:ignore-end

  static AvatarEmojiAvatarApiVersion valueOf(String name) => _$valueOfAvatarEmojiAvatarApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarEmojiAvatarApiVersion> get serializer => const _$AvatarEmojiAvatarApiVersionSerializer();
}

class _$AvatarEmojiAvatarApiVersionSerializer implements PrimitiveSerializer<AvatarEmojiAvatarApiVersion> {
  const _$AvatarEmojiAvatarApiVersionSerializer();

  static const Map<AvatarEmojiAvatarApiVersion, Object> _toWire = <AvatarEmojiAvatarApiVersion, Object>{
    AvatarEmojiAvatarApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarEmojiAvatarApiVersion> _fromWire = <Object, AvatarEmojiAvatarApiVersion>{
    'v1': AvatarEmojiAvatarApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarEmojiAvatarApiVersion];

  @override
  String get wireName => 'AvatarEmojiAvatarApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarEmojiAvatarApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarEmojiAvatarApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarEmojiAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class AvatarEmojiAvatarResponseApplicationJson_Ocs
    implements
        $AvatarEmojiAvatarResponseApplicationJson_OcsInterface,
        Built<AvatarEmojiAvatarResponseApplicationJson_Ocs, AvatarEmojiAvatarResponseApplicationJson_OcsBuilder> {
  factory AvatarEmojiAvatarResponseApplicationJson_Ocs([
    void Function(AvatarEmojiAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$AvatarEmojiAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const AvatarEmojiAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory AvatarEmojiAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<AvatarEmojiAvatarResponseApplicationJson_Ocs> get serializer =>
      _$avatarEmojiAvatarResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $AvatarEmojiAvatarResponseApplicationJsonInterface {
  AvatarEmojiAvatarResponseApplicationJson_Ocs get ocs;
}

abstract class AvatarEmojiAvatarResponseApplicationJson
    implements
        $AvatarEmojiAvatarResponseApplicationJsonInterface,
        Built<AvatarEmojiAvatarResponseApplicationJson, AvatarEmojiAvatarResponseApplicationJsonBuilder> {
  factory AvatarEmojiAvatarResponseApplicationJson([
    void Function(AvatarEmojiAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$AvatarEmojiAvatarResponseApplicationJson;

  // coverage:ignore-start
  const AvatarEmojiAvatarResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory AvatarEmojiAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<AvatarEmojiAvatarResponseApplicationJson> get serializer =>
      _$avatarEmojiAvatarResponseApplicationJsonSerializer;
}

class AvatarGetAvatarDarkApiVersion extends EnumClass {
  const AvatarGetAvatarDarkApiVersion._(super.name);

  static const AvatarGetAvatarDarkApiVersion v1 = _$avatarGetAvatarDarkApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<AvatarGetAvatarDarkApiVersion> get values => _$avatarGetAvatarDarkApiVersionValues;
  // coverage:ignore-end

  static AvatarGetAvatarDarkApiVersion valueOf(String name) => _$valueOfAvatarGetAvatarDarkApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<AvatarGetAvatarDarkApiVersion> get serializer => const _$AvatarGetAvatarDarkApiVersionSerializer();
}

class _$AvatarGetAvatarDarkApiVersionSerializer implements PrimitiveSerializer<AvatarGetAvatarDarkApiVersion> {
  const _$AvatarGetAvatarDarkApiVersionSerializer();

  static const Map<AvatarGetAvatarDarkApiVersion, Object> _toWire = <AvatarGetAvatarDarkApiVersion, Object>{
    AvatarGetAvatarDarkApiVersion.v1: 'v1',
  };

  static const Map<Object, AvatarGetAvatarDarkApiVersion> _fromWire = <Object, AvatarGetAvatarDarkApiVersion>{
    'v1': AvatarGetAvatarDarkApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [AvatarGetAvatarDarkApiVersion];

  @override
  String get wireName => 'AvatarGetAvatarDarkApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    AvatarGetAvatarDarkApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  AvatarGetAvatarDarkApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class BotSendMessageApiVersion extends EnumClass {
  const BotSendMessageApiVersion._(super.name);

  static const BotSendMessageApiVersion v1 = _$botSendMessageApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BotSendMessageApiVersion> get values => _$botSendMessageApiVersionValues;
  // coverage:ignore-end

  static BotSendMessageApiVersion valueOf(String name) => _$valueOfBotSendMessageApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BotSendMessageApiVersion> get serializer => const _$BotSendMessageApiVersionSerializer();
}

class _$BotSendMessageApiVersionSerializer implements PrimitiveSerializer<BotSendMessageApiVersion> {
  const _$BotSendMessageApiVersionSerializer();

  static const Map<BotSendMessageApiVersion, Object> _toWire = <BotSendMessageApiVersion, Object>{
    BotSendMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, BotSendMessageApiVersion> _fromWire = <Object, BotSendMessageApiVersion>{
    'v1': BotSendMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotSendMessageApiVersion];

  @override
  String get wireName => 'BotSendMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotSendMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotSendMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotSendMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class BotSendMessageResponseApplicationJson_Ocs
    implements
        $BotSendMessageResponseApplicationJson_OcsInterface,
        Built<BotSendMessageResponseApplicationJson_Ocs, BotSendMessageResponseApplicationJson_OcsBuilder> {
  factory BotSendMessageResponseApplicationJson_Ocs([
    void Function(BotSendMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotSendMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotSendMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotSendMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotSendMessageResponseApplicationJson_Ocs> get serializer =>
      _$botSendMessageResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotSendMessageResponseApplicationJsonInterface {
  BotSendMessageResponseApplicationJson_Ocs get ocs;
}

abstract class BotSendMessageResponseApplicationJson
    implements
        $BotSendMessageResponseApplicationJsonInterface,
        Built<BotSendMessageResponseApplicationJson, BotSendMessageResponseApplicationJsonBuilder> {
  factory BotSendMessageResponseApplicationJson([void Function(BotSendMessageResponseApplicationJsonBuilder)? b]) =
      _$BotSendMessageResponseApplicationJson;

  // coverage:ignore-start
  const BotSendMessageResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotSendMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotSendMessageResponseApplicationJson> get serializer =>
      _$botSendMessageResponseApplicationJsonSerializer;
}

class BotReactApiVersion extends EnumClass {
  const BotReactApiVersion._(super.name);

  static const BotReactApiVersion v1 = _$botReactApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BotReactApiVersion> get values => _$botReactApiVersionValues;
  // coverage:ignore-end

  static BotReactApiVersion valueOf(String name) => _$valueOfBotReactApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BotReactApiVersion> get serializer => const _$BotReactApiVersionSerializer();
}

class _$BotReactApiVersionSerializer implements PrimitiveSerializer<BotReactApiVersion> {
  const _$BotReactApiVersionSerializer();

  static const Map<BotReactApiVersion, Object> _toWire = <BotReactApiVersion, Object>{
    BotReactApiVersion.v1: 'v1',
  };

  static const Map<Object, BotReactApiVersion> _fromWire = <Object, BotReactApiVersion>{
    'v1': BotReactApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotReactApiVersion];

  @override
  String get wireName => 'BotReactApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotReactApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotReactApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotReactResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class BotReactResponseApplicationJson_Ocs
    implements
        $BotReactResponseApplicationJson_OcsInterface,
        Built<BotReactResponseApplicationJson_Ocs, BotReactResponseApplicationJson_OcsBuilder> {
  factory BotReactResponseApplicationJson_Ocs([void Function(BotReactResponseApplicationJson_OcsBuilder)? b]) =
      _$BotReactResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotReactResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotReactResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotReactResponseApplicationJson_Ocs> get serializer =>
      _$botReactResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotReactResponseApplicationJsonInterface {
  BotReactResponseApplicationJson_Ocs get ocs;
}

abstract class BotReactResponseApplicationJson
    implements
        $BotReactResponseApplicationJsonInterface,
        Built<BotReactResponseApplicationJson, BotReactResponseApplicationJsonBuilder> {
  factory BotReactResponseApplicationJson([void Function(BotReactResponseApplicationJsonBuilder)? b]) =
      _$BotReactResponseApplicationJson;

  // coverage:ignore-start
  const BotReactResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotReactResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotReactResponseApplicationJson> get serializer => _$botReactResponseApplicationJsonSerializer;
}

class BotDeleteReactionApiVersion extends EnumClass {
  const BotDeleteReactionApiVersion._(super.name);

  static const BotDeleteReactionApiVersion v1 = _$botDeleteReactionApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BotDeleteReactionApiVersion> get values => _$botDeleteReactionApiVersionValues;
  // coverage:ignore-end

  static BotDeleteReactionApiVersion valueOf(String name) => _$valueOfBotDeleteReactionApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BotDeleteReactionApiVersion> get serializer => const _$BotDeleteReactionApiVersionSerializer();
}

class _$BotDeleteReactionApiVersionSerializer implements PrimitiveSerializer<BotDeleteReactionApiVersion> {
  const _$BotDeleteReactionApiVersionSerializer();

  static const Map<BotDeleteReactionApiVersion, Object> _toWire = <BotDeleteReactionApiVersion, Object>{
    BotDeleteReactionApiVersion.v1: 'v1',
  };

  static const Map<Object, BotDeleteReactionApiVersion> _fromWire = <Object, BotDeleteReactionApiVersion>{
    'v1': BotDeleteReactionApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotDeleteReactionApiVersion];

  @override
  String get wireName => 'BotDeleteReactionApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotDeleteReactionApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotDeleteReactionApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotDeleteReactionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class BotDeleteReactionResponseApplicationJson_Ocs
    implements
        $BotDeleteReactionResponseApplicationJson_OcsInterface,
        Built<BotDeleteReactionResponseApplicationJson_Ocs, BotDeleteReactionResponseApplicationJson_OcsBuilder> {
  factory BotDeleteReactionResponseApplicationJson_Ocs([
    void Function(BotDeleteReactionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotDeleteReactionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotDeleteReactionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotDeleteReactionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotDeleteReactionResponseApplicationJson_Ocs> get serializer =>
      _$botDeleteReactionResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotDeleteReactionResponseApplicationJsonInterface {
  BotDeleteReactionResponseApplicationJson_Ocs get ocs;
}

abstract class BotDeleteReactionResponseApplicationJson
    implements
        $BotDeleteReactionResponseApplicationJsonInterface,
        Built<BotDeleteReactionResponseApplicationJson, BotDeleteReactionResponseApplicationJsonBuilder> {
  factory BotDeleteReactionResponseApplicationJson([
    void Function(BotDeleteReactionResponseApplicationJsonBuilder)? b,
  ]) = _$BotDeleteReactionResponseApplicationJson;

  // coverage:ignore-start
  const BotDeleteReactionResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotDeleteReactionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotDeleteReactionResponseApplicationJson> get serializer =>
      _$botDeleteReactionResponseApplicationJsonSerializer;
}

class BotAdminListBotsApiVersion extends EnumClass {
  const BotAdminListBotsApiVersion._(super.name);

  static const BotAdminListBotsApiVersion v1 = _$botAdminListBotsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BotAdminListBotsApiVersion> get values => _$botAdminListBotsApiVersionValues;
  // coverage:ignore-end

  static BotAdminListBotsApiVersion valueOf(String name) => _$valueOfBotAdminListBotsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BotAdminListBotsApiVersion> get serializer => const _$BotAdminListBotsApiVersionSerializer();
}

class _$BotAdminListBotsApiVersionSerializer implements PrimitiveSerializer<BotAdminListBotsApiVersion> {
  const _$BotAdminListBotsApiVersionSerializer();

  static const Map<BotAdminListBotsApiVersion, Object> _toWire = <BotAdminListBotsApiVersion, Object>{
    BotAdminListBotsApiVersion.v1: 'v1',
  };

  static const Map<Object, BotAdminListBotsApiVersion> _fromWire = <Object, BotAdminListBotsApiVersion>{
    'v1': BotAdminListBotsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotAdminListBotsApiVersion];

  @override
  String get wireName => 'BotAdminListBotsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotAdminListBotsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotAdminListBotsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotInterface {
  String? get description;
  int get id;
  String get name;
  int get state;
}

abstract class Bot implements $BotInterface, Built<Bot, BotBuilder> {
  factory Bot([void Function(BotBuilder)? b]) = _$Bot;

  // coverage:ignore-start
  const Bot._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory Bot.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<Bot> get serializer => _$botSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotWithDetails_1Interface {
  @BuiltValueField(wireName: 'error_count')
  int get errorCount;
  int get features;
  @BuiltValueField(wireName: 'last_error_date')
  int get lastErrorDate;
  @BuiltValueField(wireName: 'last_error_message')
  String get lastErrorMessage;
  String get url;
  @BuiltValueField(wireName: 'url_hash')
  String get urlHash;
}

@BuiltValue(instantiable: false)
abstract interface class $BotWithDetailsInterface implements $BotInterface, $BotWithDetails_1Interface {}

abstract class BotWithDetails implements $BotWithDetailsInterface, Built<BotWithDetails, BotWithDetailsBuilder> {
  factory BotWithDetails([void Function(BotWithDetailsBuilder)? b]) = _$BotWithDetails;

  // coverage:ignore-start
  const BotWithDetails._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotWithDetails.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotWithDetails> get serializer => _$botWithDetailsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotAdminListBotsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<BotWithDetails> get data;
}

abstract class BotAdminListBotsResponseApplicationJson_Ocs
    implements
        $BotAdminListBotsResponseApplicationJson_OcsInterface,
        Built<BotAdminListBotsResponseApplicationJson_Ocs, BotAdminListBotsResponseApplicationJson_OcsBuilder> {
  factory BotAdminListBotsResponseApplicationJson_Ocs([
    void Function(BotAdminListBotsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotAdminListBotsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotAdminListBotsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotAdminListBotsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotAdminListBotsResponseApplicationJson_Ocs> get serializer =>
      _$botAdminListBotsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotAdminListBotsResponseApplicationJsonInterface {
  BotAdminListBotsResponseApplicationJson_Ocs get ocs;
}

abstract class BotAdminListBotsResponseApplicationJson
    implements
        $BotAdminListBotsResponseApplicationJsonInterface,
        Built<BotAdminListBotsResponseApplicationJson, BotAdminListBotsResponseApplicationJsonBuilder> {
  factory BotAdminListBotsResponseApplicationJson([void Function(BotAdminListBotsResponseApplicationJsonBuilder)? b]) =
      _$BotAdminListBotsResponseApplicationJson;

  // coverage:ignore-start
  const BotAdminListBotsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotAdminListBotsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotAdminListBotsResponseApplicationJson> get serializer =>
      _$botAdminListBotsResponseApplicationJsonSerializer;
}

class BotListBotsApiVersion extends EnumClass {
  const BotListBotsApiVersion._(super.name);

  static const BotListBotsApiVersion v1 = _$botListBotsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BotListBotsApiVersion> get values => _$botListBotsApiVersionValues;
  // coverage:ignore-end

  static BotListBotsApiVersion valueOf(String name) => _$valueOfBotListBotsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BotListBotsApiVersion> get serializer => const _$BotListBotsApiVersionSerializer();
}

class _$BotListBotsApiVersionSerializer implements PrimitiveSerializer<BotListBotsApiVersion> {
  const _$BotListBotsApiVersionSerializer();

  static const Map<BotListBotsApiVersion, Object> _toWire = <BotListBotsApiVersion, Object>{
    BotListBotsApiVersion.v1: 'v1',
  };

  static const Map<Object, BotListBotsApiVersion> _fromWire = <Object, BotListBotsApiVersion>{
    'v1': BotListBotsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotListBotsApiVersion];

  @override
  String get wireName => 'BotListBotsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotListBotsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotListBotsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotListBotsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Bot> get data;
}

abstract class BotListBotsResponseApplicationJson_Ocs
    implements
        $BotListBotsResponseApplicationJson_OcsInterface,
        Built<BotListBotsResponseApplicationJson_Ocs, BotListBotsResponseApplicationJson_OcsBuilder> {
  factory BotListBotsResponseApplicationJson_Ocs([void Function(BotListBotsResponseApplicationJson_OcsBuilder)? b]) =
      _$BotListBotsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotListBotsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotListBotsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotListBotsResponseApplicationJson_Ocs> get serializer =>
      _$botListBotsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotListBotsResponseApplicationJsonInterface {
  BotListBotsResponseApplicationJson_Ocs get ocs;
}

abstract class BotListBotsResponseApplicationJson
    implements
        $BotListBotsResponseApplicationJsonInterface,
        Built<BotListBotsResponseApplicationJson, BotListBotsResponseApplicationJsonBuilder> {
  factory BotListBotsResponseApplicationJson([void Function(BotListBotsResponseApplicationJsonBuilder)? b]) =
      _$BotListBotsResponseApplicationJson;

  // coverage:ignore-start
  const BotListBotsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotListBotsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotListBotsResponseApplicationJson> get serializer =>
      _$botListBotsResponseApplicationJsonSerializer;
}

class BotEnableBotApiVersion extends EnumClass {
  const BotEnableBotApiVersion._(super.name);

  static const BotEnableBotApiVersion v1 = _$botEnableBotApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BotEnableBotApiVersion> get values => _$botEnableBotApiVersionValues;
  // coverage:ignore-end

  static BotEnableBotApiVersion valueOf(String name) => _$valueOfBotEnableBotApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BotEnableBotApiVersion> get serializer => const _$BotEnableBotApiVersionSerializer();
}

class _$BotEnableBotApiVersionSerializer implements PrimitiveSerializer<BotEnableBotApiVersion> {
  const _$BotEnableBotApiVersionSerializer();

  static const Map<BotEnableBotApiVersion, Object> _toWire = <BotEnableBotApiVersion, Object>{
    BotEnableBotApiVersion.v1: 'v1',
  };

  static const Map<Object, BotEnableBotApiVersion> _fromWire = <Object, BotEnableBotApiVersion>{
    'v1': BotEnableBotApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotEnableBotApiVersion];

  @override
  String get wireName => 'BotEnableBotApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotEnableBotApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotEnableBotApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotEnableBotResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Bot? get data;
}

abstract class BotEnableBotResponseApplicationJson_Ocs
    implements
        $BotEnableBotResponseApplicationJson_OcsInterface,
        Built<BotEnableBotResponseApplicationJson_Ocs, BotEnableBotResponseApplicationJson_OcsBuilder> {
  factory BotEnableBotResponseApplicationJson_Ocs([void Function(BotEnableBotResponseApplicationJson_OcsBuilder)? b]) =
      _$BotEnableBotResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotEnableBotResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotEnableBotResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotEnableBotResponseApplicationJson_Ocs> get serializer =>
      _$botEnableBotResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotEnableBotResponseApplicationJsonInterface {
  BotEnableBotResponseApplicationJson_Ocs get ocs;
}

abstract class BotEnableBotResponseApplicationJson
    implements
        $BotEnableBotResponseApplicationJsonInterface,
        Built<BotEnableBotResponseApplicationJson, BotEnableBotResponseApplicationJsonBuilder> {
  factory BotEnableBotResponseApplicationJson([void Function(BotEnableBotResponseApplicationJsonBuilder)? b]) =
      _$BotEnableBotResponseApplicationJson;

  // coverage:ignore-start
  const BotEnableBotResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotEnableBotResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotEnableBotResponseApplicationJson> get serializer =>
      _$botEnableBotResponseApplicationJsonSerializer;
}

class BotDisableBotApiVersion extends EnumClass {
  const BotDisableBotApiVersion._(super.name);

  static const BotDisableBotApiVersion v1 = _$botDisableBotApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BotDisableBotApiVersion> get values => _$botDisableBotApiVersionValues;
  // coverage:ignore-end

  static BotDisableBotApiVersion valueOf(String name) => _$valueOfBotDisableBotApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BotDisableBotApiVersion> get serializer => const _$BotDisableBotApiVersionSerializer();
}

class _$BotDisableBotApiVersionSerializer implements PrimitiveSerializer<BotDisableBotApiVersion> {
  const _$BotDisableBotApiVersionSerializer();

  static const Map<BotDisableBotApiVersion, Object> _toWire = <BotDisableBotApiVersion, Object>{
    BotDisableBotApiVersion.v1: 'v1',
  };

  static const Map<Object, BotDisableBotApiVersion> _fromWire = <Object, BotDisableBotApiVersion>{
    'v1': BotDisableBotApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BotDisableBotApiVersion];

  @override
  String get wireName => 'BotDisableBotApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BotDisableBotApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BotDisableBotApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BotDisableBotResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Bot? get data;
}

abstract class BotDisableBotResponseApplicationJson_Ocs
    implements
        $BotDisableBotResponseApplicationJson_OcsInterface,
        Built<BotDisableBotResponseApplicationJson_Ocs, BotDisableBotResponseApplicationJson_OcsBuilder> {
  factory BotDisableBotResponseApplicationJson_Ocs([
    void Function(BotDisableBotResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BotDisableBotResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BotDisableBotResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotDisableBotResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotDisableBotResponseApplicationJson_Ocs> get serializer =>
      _$botDisableBotResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotDisableBotResponseApplicationJsonInterface {
  BotDisableBotResponseApplicationJson_Ocs get ocs;
}

abstract class BotDisableBotResponseApplicationJson
    implements
        $BotDisableBotResponseApplicationJsonInterface,
        Built<BotDisableBotResponseApplicationJson, BotDisableBotResponseApplicationJsonBuilder> {
  factory BotDisableBotResponseApplicationJson([void Function(BotDisableBotResponseApplicationJsonBuilder)? b]) =
      _$BotDisableBotResponseApplicationJson;

  // coverage:ignore-start
  const BotDisableBotResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotDisableBotResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotDisableBotResponseApplicationJson> get serializer =>
      _$botDisableBotResponseApplicationJsonSerializer;
}

class BreakoutRoomConfigureBreakoutRoomsMode extends EnumClass {
  const BreakoutRoomConfigureBreakoutRoomsMode._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const BreakoutRoomConfigureBreakoutRoomsMode $0 = _$breakoutRoomConfigureBreakoutRoomsMode$0;

  @BuiltValueEnumConst(wireName: '1')
  static const BreakoutRoomConfigureBreakoutRoomsMode $1 = _$breakoutRoomConfigureBreakoutRoomsMode$1;

  @BuiltValueEnumConst(wireName: '2')
  static const BreakoutRoomConfigureBreakoutRoomsMode $2 = _$breakoutRoomConfigureBreakoutRoomsMode$2;

  @BuiltValueEnumConst(wireName: '3')
  static const BreakoutRoomConfigureBreakoutRoomsMode $3 = _$breakoutRoomConfigureBreakoutRoomsMode$3;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomConfigureBreakoutRoomsMode> get values => _$breakoutRoomConfigureBreakoutRoomsModeValues;
  // coverage:ignore-end

  static BreakoutRoomConfigureBreakoutRoomsMode valueOf(String name) =>
      _$valueOfBreakoutRoomConfigureBreakoutRoomsMode(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomConfigureBreakoutRoomsMode> get serializer =>
      const _$BreakoutRoomConfigureBreakoutRoomsModeSerializer();
}

class _$BreakoutRoomConfigureBreakoutRoomsModeSerializer
    implements PrimitiveSerializer<BreakoutRoomConfigureBreakoutRoomsMode> {
  const _$BreakoutRoomConfigureBreakoutRoomsModeSerializer();

  static const Map<BreakoutRoomConfigureBreakoutRoomsMode, Object> _toWire =
      <BreakoutRoomConfigureBreakoutRoomsMode, Object>{
    BreakoutRoomConfigureBreakoutRoomsMode.$0: 0,
    BreakoutRoomConfigureBreakoutRoomsMode.$1: 1,
    BreakoutRoomConfigureBreakoutRoomsMode.$2: 2,
    BreakoutRoomConfigureBreakoutRoomsMode.$3: 3,
  };

  static const Map<Object, BreakoutRoomConfigureBreakoutRoomsMode> _fromWire =
      <Object, BreakoutRoomConfigureBreakoutRoomsMode>{
    0: BreakoutRoomConfigureBreakoutRoomsMode.$0,
    1: BreakoutRoomConfigureBreakoutRoomsMode.$1,
    2: BreakoutRoomConfigureBreakoutRoomsMode.$2,
    3: BreakoutRoomConfigureBreakoutRoomsMode.$3,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomConfigureBreakoutRoomsMode];

  @override
  String get wireName => 'BreakoutRoomConfigureBreakoutRoomsMode';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomConfigureBreakoutRoomsMode object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomConfigureBreakoutRoomsMode deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class BreakoutRoomConfigureBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomConfigureBreakoutRoomsApiVersion._(super.name);

  static const BreakoutRoomConfigureBreakoutRoomsApiVersion v1 = _$breakoutRoomConfigureBreakoutRoomsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomConfigureBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomConfigureBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomConfigureBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomConfigureBreakoutRoomsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomConfigureBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomConfigureBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomConfigureBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomConfigureBreakoutRoomsApiVersion> {
  const _$BreakoutRoomConfigureBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomConfigureBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomConfigureBreakoutRoomsApiVersion, Object>{
    BreakoutRoomConfigureBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomConfigureBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomConfigureBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomConfigureBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomConfigureBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomConfigureBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomConfigureBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomConfigureBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomConfigureBreakoutRoomsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson,
            BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder> {
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomConfigureBreakoutRoomsResponseApplicationJsonSerializer;
}

class BreakoutRoomRemoveBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomRemoveBreakoutRoomsApiVersion._(super.name);

  static const BreakoutRoomRemoveBreakoutRoomsApiVersion v1 = _$breakoutRoomRemoveBreakoutRoomsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomRemoveBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomRemoveBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomRemoveBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomRemoveBreakoutRoomsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomRemoveBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomRemoveBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomRemoveBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomRemoveBreakoutRoomsApiVersion> {
  const _$BreakoutRoomRemoveBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomRemoveBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomRemoveBreakoutRoomsApiVersion, Object>{
    BreakoutRoomRemoveBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomRemoveBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomRemoveBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomRemoveBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomRemoveBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomRemoveBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomRemoveBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomRemoveBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomRemoveBreakoutRoomsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson,
            BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder> {
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomRemoveBreakoutRoomsResponseApplicationJsonSerializer;
}

class BreakoutRoomBroadcastChatMessageApiVersion extends EnumClass {
  const BreakoutRoomBroadcastChatMessageApiVersion._(super.name);

  static const BreakoutRoomBroadcastChatMessageApiVersion v1 = _$breakoutRoomBroadcastChatMessageApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomBroadcastChatMessageApiVersion> get values =>
      _$breakoutRoomBroadcastChatMessageApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomBroadcastChatMessageApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomBroadcastChatMessageApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomBroadcastChatMessageApiVersion> get serializer =>
      const _$BreakoutRoomBroadcastChatMessageApiVersionSerializer();
}

class _$BreakoutRoomBroadcastChatMessageApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomBroadcastChatMessageApiVersion> {
  const _$BreakoutRoomBroadcastChatMessageApiVersionSerializer();

  static const Map<BreakoutRoomBroadcastChatMessageApiVersion, Object> _toWire =
      <BreakoutRoomBroadcastChatMessageApiVersion, Object>{
    BreakoutRoomBroadcastChatMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomBroadcastChatMessageApiVersion> _fromWire =
      <Object, BreakoutRoomBroadcastChatMessageApiVersion>{
    'v1': BreakoutRoomBroadcastChatMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomBroadcastChatMessageApiVersion];

  @override
  String get wireName => 'BreakoutRoomBroadcastChatMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomBroadcastChatMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomBroadcastChatMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs
    implements
        $BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs,
            BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs([
    void Function(BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomBroadcastChatMessageResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterface {
  BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomBroadcastChatMessageResponseApplicationJson
    implements
        $BreakoutRoomBroadcastChatMessageResponseApplicationJsonInterface,
        Built<BreakoutRoomBroadcastChatMessageResponseApplicationJson,
            BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder> {
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson([
    void Function(BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomBroadcastChatMessageResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomBroadcastChatMessageResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomBroadcastChatMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomBroadcastChatMessageResponseApplicationJson> get serializer =>
      _$breakoutRoomBroadcastChatMessageResponseApplicationJsonSerializer;
}

class BreakoutRoomApplyAttendeeMapApiVersion extends EnumClass {
  const BreakoutRoomApplyAttendeeMapApiVersion._(super.name);

  static const BreakoutRoomApplyAttendeeMapApiVersion v1 = _$breakoutRoomApplyAttendeeMapApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomApplyAttendeeMapApiVersion> get values => _$breakoutRoomApplyAttendeeMapApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomApplyAttendeeMapApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomApplyAttendeeMapApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomApplyAttendeeMapApiVersion> get serializer =>
      const _$BreakoutRoomApplyAttendeeMapApiVersionSerializer();
}

class _$BreakoutRoomApplyAttendeeMapApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomApplyAttendeeMapApiVersion> {
  const _$BreakoutRoomApplyAttendeeMapApiVersionSerializer();

  static const Map<BreakoutRoomApplyAttendeeMapApiVersion, Object> _toWire =
      <BreakoutRoomApplyAttendeeMapApiVersion, Object>{
    BreakoutRoomApplyAttendeeMapApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomApplyAttendeeMapApiVersion> _fromWire =
      <Object, BreakoutRoomApplyAttendeeMapApiVersion>{
    'v1': BreakoutRoomApplyAttendeeMapApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomApplyAttendeeMapApiVersion];

  @override
  String get wireName => 'BreakoutRoomApplyAttendeeMapApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomApplyAttendeeMapApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomApplyAttendeeMapApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs
    implements
        $BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs,
            BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs([
    void Function(BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomApplyAttendeeMapResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterface {
  BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomApplyAttendeeMapResponseApplicationJson
    implements
        $BreakoutRoomApplyAttendeeMapResponseApplicationJsonInterface,
        Built<BreakoutRoomApplyAttendeeMapResponseApplicationJson,
            BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder> {
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson([
    void Function(BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomApplyAttendeeMapResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomApplyAttendeeMapResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomApplyAttendeeMapResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomApplyAttendeeMapResponseApplicationJson> get serializer =>
      _$breakoutRoomApplyAttendeeMapResponseApplicationJsonSerializer;
}

class BreakoutRoomRequestAssistanceApiVersion extends EnumClass {
  const BreakoutRoomRequestAssistanceApiVersion._(super.name);

  static const BreakoutRoomRequestAssistanceApiVersion v1 = _$breakoutRoomRequestAssistanceApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomRequestAssistanceApiVersion> get values =>
      _$breakoutRoomRequestAssistanceApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomRequestAssistanceApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomRequestAssistanceApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomRequestAssistanceApiVersion> get serializer =>
      const _$BreakoutRoomRequestAssistanceApiVersionSerializer();
}

class _$BreakoutRoomRequestAssistanceApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomRequestAssistanceApiVersion> {
  const _$BreakoutRoomRequestAssistanceApiVersionSerializer();

  static const Map<BreakoutRoomRequestAssistanceApiVersion, Object> _toWire =
      <BreakoutRoomRequestAssistanceApiVersion, Object>{
    BreakoutRoomRequestAssistanceApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomRequestAssistanceApiVersion> _fromWire =
      <Object, BreakoutRoomRequestAssistanceApiVersion>{
    'v1': BreakoutRoomRequestAssistanceApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomRequestAssistanceApiVersion];

  @override
  String get wireName => 'BreakoutRoomRequestAssistanceApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomRequestAssistanceApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomRequestAssistanceApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs
    implements
        $BreakoutRoomRequestAssistanceResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs,
            BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs([
    void Function(BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomRequestAssistanceResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomRequestAssistanceResponseApplicationJsonInterface {
  BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomRequestAssistanceResponseApplicationJson
    implements
        $BreakoutRoomRequestAssistanceResponseApplicationJsonInterface,
        Built<BreakoutRoomRequestAssistanceResponseApplicationJson,
            BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder> {
  factory BreakoutRoomRequestAssistanceResponseApplicationJson([
    void Function(BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomRequestAssistanceResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomRequestAssistanceResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomRequestAssistanceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomRequestAssistanceResponseApplicationJson> get serializer =>
      _$breakoutRoomRequestAssistanceResponseApplicationJsonSerializer;
}

class BreakoutRoomResetRequestForAssistanceApiVersion extends EnumClass {
  const BreakoutRoomResetRequestForAssistanceApiVersion._(super.name);

  static const BreakoutRoomResetRequestForAssistanceApiVersion v1 = _$breakoutRoomResetRequestForAssistanceApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomResetRequestForAssistanceApiVersion> get values =>
      _$breakoutRoomResetRequestForAssistanceApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomResetRequestForAssistanceApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomResetRequestForAssistanceApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomResetRequestForAssistanceApiVersion> get serializer =>
      const _$BreakoutRoomResetRequestForAssistanceApiVersionSerializer();
}

class _$BreakoutRoomResetRequestForAssistanceApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomResetRequestForAssistanceApiVersion> {
  const _$BreakoutRoomResetRequestForAssistanceApiVersionSerializer();

  static const Map<BreakoutRoomResetRequestForAssistanceApiVersion, Object> _toWire =
      <BreakoutRoomResetRequestForAssistanceApiVersion, Object>{
    BreakoutRoomResetRequestForAssistanceApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomResetRequestForAssistanceApiVersion> _fromWire =
      <Object, BreakoutRoomResetRequestForAssistanceApiVersion>{
    'v1': BreakoutRoomResetRequestForAssistanceApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomResetRequestForAssistanceApiVersion];

  @override
  String get wireName => 'BreakoutRoomResetRequestForAssistanceApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomResetRequestForAssistanceApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomResetRequestForAssistanceApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs
    implements
        $BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs,
            BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs([
    void Function(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomResetRequestForAssistanceResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterface {
  BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomResetRequestForAssistanceResponseApplicationJson
    implements
        $BreakoutRoomResetRequestForAssistanceResponseApplicationJsonInterface,
        Built<BreakoutRoomResetRequestForAssistanceResponseApplicationJson,
            BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder> {
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson([
    void Function(BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomResetRequestForAssistanceResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomResetRequestForAssistanceResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomResetRequestForAssistanceResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomResetRequestForAssistanceResponseApplicationJson> get serializer =>
      _$breakoutRoomResetRequestForAssistanceResponseApplicationJsonSerializer;
}

class BreakoutRoomStartBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomStartBreakoutRoomsApiVersion._(super.name);

  static const BreakoutRoomStartBreakoutRoomsApiVersion v1 = _$breakoutRoomStartBreakoutRoomsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomStartBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomStartBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomStartBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomStartBreakoutRoomsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomStartBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomStartBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomStartBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomStartBreakoutRoomsApiVersion> {
  const _$BreakoutRoomStartBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomStartBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomStartBreakoutRoomsApiVersion, Object>{
    BreakoutRoomStartBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomStartBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomStartBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomStartBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomStartBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomStartBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomStartBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomStartBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomStartBreakoutRoomsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomStartBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomStartBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomStartBreakoutRoomsResponseApplicationJson,
            BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder> {
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomStartBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomStartBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomStartBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomStartBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomStartBreakoutRoomsResponseApplicationJsonSerializer;
}

class BreakoutRoomStopBreakoutRoomsApiVersion extends EnumClass {
  const BreakoutRoomStopBreakoutRoomsApiVersion._(super.name);

  static const BreakoutRoomStopBreakoutRoomsApiVersion v1 = _$breakoutRoomStopBreakoutRoomsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomStopBreakoutRoomsApiVersion> get values =>
      _$breakoutRoomStopBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomStopBreakoutRoomsApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomStopBreakoutRoomsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomStopBreakoutRoomsApiVersion> get serializer =>
      const _$BreakoutRoomStopBreakoutRoomsApiVersionSerializer();
}

class _$BreakoutRoomStopBreakoutRoomsApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomStopBreakoutRoomsApiVersion> {
  const _$BreakoutRoomStopBreakoutRoomsApiVersionSerializer();

  static const Map<BreakoutRoomStopBreakoutRoomsApiVersion, Object> _toWire =
      <BreakoutRoomStopBreakoutRoomsApiVersion, Object>{
    BreakoutRoomStopBreakoutRoomsApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomStopBreakoutRoomsApiVersion> _fromWire =
      <Object, BreakoutRoomStopBreakoutRoomsApiVersion>{
    'v1': BreakoutRoomStopBreakoutRoomsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomStopBreakoutRoomsApiVersion];

  @override
  String get wireName => 'BreakoutRoomStopBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomStopBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomStopBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs,
            BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomStopBreakoutRoomsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterface {
  BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomStopBreakoutRoomsResponseApplicationJson
    implements
        $BreakoutRoomStopBreakoutRoomsResponseApplicationJsonInterface,
        Built<BreakoutRoomStopBreakoutRoomsResponseApplicationJson,
            BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder> {
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson([
    void Function(BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomStopBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomStopBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomStopBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomStopBreakoutRoomsResponseApplicationJson> get serializer =>
      _$breakoutRoomStopBreakoutRoomsResponseApplicationJsonSerializer;
}

class BreakoutRoomSwitchBreakoutRoomApiVersion extends EnumClass {
  const BreakoutRoomSwitchBreakoutRoomApiVersion._(super.name);

  static const BreakoutRoomSwitchBreakoutRoomApiVersion v1 = _$breakoutRoomSwitchBreakoutRoomApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<BreakoutRoomSwitchBreakoutRoomApiVersion> get values =>
      _$breakoutRoomSwitchBreakoutRoomApiVersionValues;
  // coverage:ignore-end

  static BreakoutRoomSwitchBreakoutRoomApiVersion valueOf(String name) =>
      _$valueOfBreakoutRoomSwitchBreakoutRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<BreakoutRoomSwitchBreakoutRoomApiVersion> get serializer =>
      const _$BreakoutRoomSwitchBreakoutRoomApiVersionSerializer();
}

class _$BreakoutRoomSwitchBreakoutRoomApiVersionSerializer
    implements PrimitiveSerializer<BreakoutRoomSwitchBreakoutRoomApiVersion> {
  const _$BreakoutRoomSwitchBreakoutRoomApiVersionSerializer();

  static const Map<BreakoutRoomSwitchBreakoutRoomApiVersion, Object> _toWire =
      <BreakoutRoomSwitchBreakoutRoomApiVersion, Object>{
    BreakoutRoomSwitchBreakoutRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, BreakoutRoomSwitchBreakoutRoomApiVersion> _fromWire =
      <Object, BreakoutRoomSwitchBreakoutRoomApiVersion>{
    'v1': BreakoutRoomSwitchBreakoutRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [BreakoutRoomSwitchBreakoutRoomApiVersion];

  @override
  String get wireName => 'BreakoutRoomSwitchBreakoutRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    BreakoutRoomSwitchBreakoutRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  BreakoutRoomSwitchBreakoutRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs
    implements
        $BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsInterface,
        Built<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs,
            BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder> {
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs([
    void Function(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs> get serializer =>
      _$breakoutRoomSwitchBreakoutRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterface {
  BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs get ocs;
}

abstract class BreakoutRoomSwitchBreakoutRoomResponseApplicationJson
    implements
        $BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonInterface,
        Built<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson,
            BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder> {
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson([
    void Function(BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder)? b,
  ]) = _$BreakoutRoomSwitchBreakoutRoomResponseApplicationJson;

  // coverage:ignore-start
  const BreakoutRoomSwitchBreakoutRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BreakoutRoomSwitchBreakoutRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BreakoutRoomSwitchBreakoutRoomResponseApplicationJson> get serializer =>
      _$breakoutRoomSwitchBreakoutRoomResponseApplicationJsonSerializer;
}

class CallGetPeersForCallApiVersion extends EnumClass {
  const CallGetPeersForCallApiVersion._(super.name);

  static const CallGetPeersForCallApiVersion v4 = _$callGetPeersForCallApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<CallGetPeersForCallApiVersion> get values => _$callGetPeersForCallApiVersionValues;
  // coverage:ignore-end

  static CallGetPeersForCallApiVersion valueOf(String name) => _$valueOfCallGetPeersForCallApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallGetPeersForCallApiVersion> get serializer => const _$CallGetPeersForCallApiVersionSerializer();
}

class _$CallGetPeersForCallApiVersionSerializer implements PrimitiveSerializer<CallGetPeersForCallApiVersion> {
  const _$CallGetPeersForCallApiVersionSerializer();

  static const Map<CallGetPeersForCallApiVersion, Object> _toWire = <CallGetPeersForCallApiVersion, Object>{
    CallGetPeersForCallApiVersion.v4: 'v4',
  };

  static const Map<Object, CallGetPeersForCallApiVersion> _fromWire = <Object, CallGetPeersForCallApiVersion>{
    'v4': CallGetPeersForCallApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallGetPeersForCallApiVersion];

  @override
  String get wireName => 'CallGetPeersForCallApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallGetPeersForCallApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallGetPeersForCallApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallPeerInterface {
  String get actorId;
  String get actorType;
  String get displayName;
  int get lastPing;
  String get sessionId;
  String get token;
}

abstract class CallPeer implements $CallPeerInterface, Built<CallPeer, CallPeerBuilder> {
  factory CallPeer([void Function(CallPeerBuilder)? b]) = _$CallPeer;

  // coverage:ignore-start
  const CallPeer._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallPeer.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallPeer> get serializer => _$callPeerSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallGetPeersForCallResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<CallPeer> get data;
}

abstract class CallGetPeersForCallResponseApplicationJson_Ocs
    implements
        $CallGetPeersForCallResponseApplicationJson_OcsInterface,
        Built<CallGetPeersForCallResponseApplicationJson_Ocs, CallGetPeersForCallResponseApplicationJson_OcsBuilder> {
  factory CallGetPeersForCallResponseApplicationJson_Ocs([
    void Function(CallGetPeersForCallResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallGetPeersForCallResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallGetPeersForCallResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallGetPeersForCallResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallGetPeersForCallResponseApplicationJson_Ocs> get serializer =>
      _$callGetPeersForCallResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallGetPeersForCallResponseApplicationJsonInterface {
  CallGetPeersForCallResponseApplicationJson_Ocs get ocs;
}

abstract class CallGetPeersForCallResponseApplicationJson
    implements
        $CallGetPeersForCallResponseApplicationJsonInterface,
        Built<CallGetPeersForCallResponseApplicationJson, CallGetPeersForCallResponseApplicationJsonBuilder> {
  factory CallGetPeersForCallResponseApplicationJson([
    void Function(CallGetPeersForCallResponseApplicationJsonBuilder)? b,
  ]) = _$CallGetPeersForCallResponseApplicationJson;

  // coverage:ignore-start
  const CallGetPeersForCallResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallGetPeersForCallResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallGetPeersForCallResponseApplicationJson> get serializer =>
      _$callGetPeersForCallResponseApplicationJsonSerializer;
}

class CallUpdateCallFlagsApiVersion extends EnumClass {
  const CallUpdateCallFlagsApiVersion._(super.name);

  static const CallUpdateCallFlagsApiVersion v4 = _$callUpdateCallFlagsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<CallUpdateCallFlagsApiVersion> get values => _$callUpdateCallFlagsApiVersionValues;
  // coverage:ignore-end

  static CallUpdateCallFlagsApiVersion valueOf(String name) => _$valueOfCallUpdateCallFlagsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallUpdateCallFlagsApiVersion> get serializer => const _$CallUpdateCallFlagsApiVersionSerializer();
}

class _$CallUpdateCallFlagsApiVersionSerializer implements PrimitiveSerializer<CallUpdateCallFlagsApiVersion> {
  const _$CallUpdateCallFlagsApiVersionSerializer();

  static const Map<CallUpdateCallFlagsApiVersion, Object> _toWire = <CallUpdateCallFlagsApiVersion, Object>{
    CallUpdateCallFlagsApiVersion.v4: 'v4',
  };

  static const Map<Object, CallUpdateCallFlagsApiVersion> _fromWire = <Object, CallUpdateCallFlagsApiVersion>{
    'v4': CallUpdateCallFlagsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallUpdateCallFlagsApiVersion];

  @override
  String get wireName => 'CallUpdateCallFlagsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallUpdateCallFlagsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallUpdateCallFlagsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallUpdateCallFlagsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class CallUpdateCallFlagsResponseApplicationJson_Ocs
    implements
        $CallUpdateCallFlagsResponseApplicationJson_OcsInterface,
        Built<CallUpdateCallFlagsResponseApplicationJson_Ocs, CallUpdateCallFlagsResponseApplicationJson_OcsBuilder> {
  factory CallUpdateCallFlagsResponseApplicationJson_Ocs([
    void Function(CallUpdateCallFlagsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallUpdateCallFlagsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallUpdateCallFlagsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallUpdateCallFlagsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallUpdateCallFlagsResponseApplicationJson_Ocs> get serializer =>
      _$callUpdateCallFlagsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallUpdateCallFlagsResponseApplicationJsonInterface {
  CallUpdateCallFlagsResponseApplicationJson_Ocs get ocs;
}

abstract class CallUpdateCallFlagsResponseApplicationJson
    implements
        $CallUpdateCallFlagsResponseApplicationJsonInterface,
        Built<CallUpdateCallFlagsResponseApplicationJson, CallUpdateCallFlagsResponseApplicationJsonBuilder> {
  factory CallUpdateCallFlagsResponseApplicationJson([
    void Function(CallUpdateCallFlagsResponseApplicationJsonBuilder)? b,
  ]) = _$CallUpdateCallFlagsResponseApplicationJson;

  // coverage:ignore-start
  const CallUpdateCallFlagsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallUpdateCallFlagsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallUpdateCallFlagsResponseApplicationJson> get serializer =>
      _$callUpdateCallFlagsResponseApplicationJsonSerializer;
}

class CallJoinCallFlags extends EnumClass {
  const CallJoinCallFlags._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const CallJoinCallFlags $0 = _$callJoinCallFlags$0;

  @BuiltValueEnumConst(wireName: '1')
  static const CallJoinCallFlags $1 = _$callJoinCallFlags$1;

  @BuiltValueEnumConst(wireName: '2')
  static const CallJoinCallFlags $2 = _$callJoinCallFlags$2;

  @BuiltValueEnumConst(wireName: '3')
  static const CallJoinCallFlags $3 = _$callJoinCallFlags$3;

  @BuiltValueEnumConst(wireName: '4')
  static const CallJoinCallFlags $4 = _$callJoinCallFlags$4;

  @BuiltValueEnumConst(wireName: '5')
  static const CallJoinCallFlags $5 = _$callJoinCallFlags$5;

  @BuiltValueEnumConst(wireName: '6')
  static const CallJoinCallFlags $6 = _$callJoinCallFlags$6;

  @BuiltValueEnumConst(wireName: '7')
  static const CallJoinCallFlags $7 = _$callJoinCallFlags$7;

  @BuiltValueEnumConst(wireName: '8')
  static const CallJoinCallFlags $8 = _$callJoinCallFlags$8;

  @BuiltValueEnumConst(wireName: '9')
  static const CallJoinCallFlags $9 = _$callJoinCallFlags$9;

  @BuiltValueEnumConst(wireName: '10')
  static const CallJoinCallFlags $10 = _$callJoinCallFlags$10;

  @BuiltValueEnumConst(wireName: '11')
  static const CallJoinCallFlags $11 = _$callJoinCallFlags$11;

  @BuiltValueEnumConst(wireName: '12')
  static const CallJoinCallFlags $12 = _$callJoinCallFlags$12;

  @BuiltValueEnumConst(wireName: '13')
  static const CallJoinCallFlags $13 = _$callJoinCallFlags$13;

  @BuiltValueEnumConst(wireName: '14')
  static const CallJoinCallFlags $14 = _$callJoinCallFlags$14;

  @BuiltValueEnumConst(wireName: '15')
  static const CallJoinCallFlags $15 = _$callJoinCallFlags$15;

  // coverage:ignore-start
  static BuiltSet<CallJoinCallFlags> get values => _$callJoinCallFlagsValues;
  // coverage:ignore-end

  static CallJoinCallFlags valueOf(String name) => _$valueOfCallJoinCallFlags(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallJoinCallFlags> get serializer => const _$CallJoinCallFlagsSerializer();
}

class _$CallJoinCallFlagsSerializer implements PrimitiveSerializer<CallJoinCallFlags> {
  const _$CallJoinCallFlagsSerializer();

  static const Map<CallJoinCallFlags, Object> _toWire = <CallJoinCallFlags, Object>{
    CallJoinCallFlags.$0: 0,
    CallJoinCallFlags.$1: 1,
    CallJoinCallFlags.$2: 2,
    CallJoinCallFlags.$3: 3,
    CallJoinCallFlags.$4: 4,
    CallJoinCallFlags.$5: 5,
    CallJoinCallFlags.$6: 6,
    CallJoinCallFlags.$7: 7,
    CallJoinCallFlags.$8: 8,
    CallJoinCallFlags.$9: 9,
    CallJoinCallFlags.$10: 10,
    CallJoinCallFlags.$11: 11,
    CallJoinCallFlags.$12: 12,
    CallJoinCallFlags.$13: 13,
    CallJoinCallFlags.$14: 14,
    CallJoinCallFlags.$15: 15,
  };

  static const Map<Object, CallJoinCallFlags> _fromWire = <Object, CallJoinCallFlags>{
    0: CallJoinCallFlags.$0,
    1: CallJoinCallFlags.$1,
    2: CallJoinCallFlags.$2,
    3: CallJoinCallFlags.$3,
    4: CallJoinCallFlags.$4,
    5: CallJoinCallFlags.$5,
    6: CallJoinCallFlags.$6,
    7: CallJoinCallFlags.$7,
    8: CallJoinCallFlags.$8,
    9: CallJoinCallFlags.$9,
    10: CallJoinCallFlags.$10,
    11: CallJoinCallFlags.$11,
    12: CallJoinCallFlags.$12,
    13: CallJoinCallFlags.$13,
    14: CallJoinCallFlags.$14,
    15: CallJoinCallFlags.$15,
  };

  @override
  Iterable<Type> get types => const [CallJoinCallFlags];

  @override
  String get wireName => 'CallJoinCallFlags';

  @override
  Object serialize(
    Serializers serializers,
    CallJoinCallFlags object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallJoinCallFlags deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class CallJoinCallForcePermissions extends EnumClass {
  const CallJoinCallForcePermissions._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const CallJoinCallForcePermissions $0 = _$callJoinCallForcePermissions$0;

  @BuiltValueEnumConst(wireName: '1')
  static const CallJoinCallForcePermissions $1 = _$callJoinCallForcePermissions$1;

  @BuiltValueEnumConst(wireName: '2')
  static const CallJoinCallForcePermissions $2 = _$callJoinCallForcePermissions$2;

  @BuiltValueEnumConst(wireName: '3')
  static const CallJoinCallForcePermissions $3 = _$callJoinCallForcePermissions$3;

  @BuiltValueEnumConst(wireName: '4')
  static const CallJoinCallForcePermissions $4 = _$callJoinCallForcePermissions$4;

  @BuiltValueEnumConst(wireName: '5')
  static const CallJoinCallForcePermissions $5 = _$callJoinCallForcePermissions$5;

  @BuiltValueEnumConst(wireName: '6')
  static const CallJoinCallForcePermissions $6 = _$callJoinCallForcePermissions$6;

  @BuiltValueEnumConst(wireName: '7')
  static const CallJoinCallForcePermissions $7 = _$callJoinCallForcePermissions$7;

  @BuiltValueEnumConst(wireName: '8')
  static const CallJoinCallForcePermissions $8 = _$callJoinCallForcePermissions$8;

  @BuiltValueEnumConst(wireName: '9')
  static const CallJoinCallForcePermissions $9 = _$callJoinCallForcePermissions$9;

  @BuiltValueEnumConst(wireName: '10')
  static const CallJoinCallForcePermissions $10 = _$callJoinCallForcePermissions$10;

  @BuiltValueEnumConst(wireName: '11')
  static const CallJoinCallForcePermissions $11 = _$callJoinCallForcePermissions$11;

  @BuiltValueEnumConst(wireName: '12')
  static const CallJoinCallForcePermissions $12 = _$callJoinCallForcePermissions$12;

  @BuiltValueEnumConst(wireName: '13')
  static const CallJoinCallForcePermissions $13 = _$callJoinCallForcePermissions$13;

  @BuiltValueEnumConst(wireName: '14')
  static const CallJoinCallForcePermissions $14 = _$callJoinCallForcePermissions$14;

  @BuiltValueEnumConst(wireName: '15')
  static const CallJoinCallForcePermissions $15 = _$callJoinCallForcePermissions$15;

  @BuiltValueEnumConst(wireName: '16')
  static const CallJoinCallForcePermissions $16 = _$callJoinCallForcePermissions$16;

  @BuiltValueEnumConst(wireName: '17')
  static const CallJoinCallForcePermissions $17 = _$callJoinCallForcePermissions$17;

  @BuiltValueEnumConst(wireName: '18')
  static const CallJoinCallForcePermissions $18 = _$callJoinCallForcePermissions$18;

  @BuiltValueEnumConst(wireName: '19')
  static const CallJoinCallForcePermissions $19 = _$callJoinCallForcePermissions$19;

  @BuiltValueEnumConst(wireName: '20')
  static const CallJoinCallForcePermissions $20 = _$callJoinCallForcePermissions$20;

  @BuiltValueEnumConst(wireName: '21')
  static const CallJoinCallForcePermissions $21 = _$callJoinCallForcePermissions$21;

  @BuiltValueEnumConst(wireName: '22')
  static const CallJoinCallForcePermissions $22 = _$callJoinCallForcePermissions$22;

  @BuiltValueEnumConst(wireName: '23')
  static const CallJoinCallForcePermissions $23 = _$callJoinCallForcePermissions$23;

  @BuiltValueEnumConst(wireName: '24')
  static const CallJoinCallForcePermissions $24 = _$callJoinCallForcePermissions$24;

  @BuiltValueEnumConst(wireName: '25')
  static const CallJoinCallForcePermissions $25 = _$callJoinCallForcePermissions$25;

  @BuiltValueEnumConst(wireName: '26')
  static const CallJoinCallForcePermissions $26 = _$callJoinCallForcePermissions$26;

  @BuiltValueEnumConst(wireName: '27')
  static const CallJoinCallForcePermissions $27 = _$callJoinCallForcePermissions$27;

  @BuiltValueEnumConst(wireName: '28')
  static const CallJoinCallForcePermissions $28 = _$callJoinCallForcePermissions$28;

  @BuiltValueEnumConst(wireName: '29')
  static const CallJoinCallForcePermissions $29 = _$callJoinCallForcePermissions$29;

  @BuiltValueEnumConst(wireName: '30')
  static const CallJoinCallForcePermissions $30 = _$callJoinCallForcePermissions$30;

  @BuiltValueEnumConst(wireName: '31')
  static const CallJoinCallForcePermissions $31 = _$callJoinCallForcePermissions$31;

  @BuiltValueEnumConst(wireName: '32')
  static const CallJoinCallForcePermissions $32 = _$callJoinCallForcePermissions$32;

  @BuiltValueEnumConst(wireName: '33')
  static const CallJoinCallForcePermissions $33 = _$callJoinCallForcePermissions$33;

  @BuiltValueEnumConst(wireName: '34')
  static const CallJoinCallForcePermissions $34 = _$callJoinCallForcePermissions$34;

  @BuiltValueEnumConst(wireName: '35')
  static const CallJoinCallForcePermissions $35 = _$callJoinCallForcePermissions$35;

  @BuiltValueEnumConst(wireName: '36')
  static const CallJoinCallForcePermissions $36 = _$callJoinCallForcePermissions$36;

  @BuiltValueEnumConst(wireName: '37')
  static const CallJoinCallForcePermissions $37 = _$callJoinCallForcePermissions$37;

  @BuiltValueEnumConst(wireName: '38')
  static const CallJoinCallForcePermissions $38 = _$callJoinCallForcePermissions$38;

  @BuiltValueEnumConst(wireName: '39')
  static const CallJoinCallForcePermissions $39 = _$callJoinCallForcePermissions$39;

  @BuiltValueEnumConst(wireName: '40')
  static const CallJoinCallForcePermissions $40 = _$callJoinCallForcePermissions$40;

  @BuiltValueEnumConst(wireName: '41')
  static const CallJoinCallForcePermissions $41 = _$callJoinCallForcePermissions$41;

  @BuiltValueEnumConst(wireName: '42')
  static const CallJoinCallForcePermissions $42 = _$callJoinCallForcePermissions$42;

  @BuiltValueEnumConst(wireName: '43')
  static const CallJoinCallForcePermissions $43 = _$callJoinCallForcePermissions$43;

  @BuiltValueEnumConst(wireName: '44')
  static const CallJoinCallForcePermissions $44 = _$callJoinCallForcePermissions$44;

  @BuiltValueEnumConst(wireName: '45')
  static const CallJoinCallForcePermissions $45 = _$callJoinCallForcePermissions$45;

  @BuiltValueEnumConst(wireName: '46')
  static const CallJoinCallForcePermissions $46 = _$callJoinCallForcePermissions$46;

  @BuiltValueEnumConst(wireName: '47')
  static const CallJoinCallForcePermissions $47 = _$callJoinCallForcePermissions$47;

  @BuiltValueEnumConst(wireName: '48')
  static const CallJoinCallForcePermissions $48 = _$callJoinCallForcePermissions$48;

  @BuiltValueEnumConst(wireName: '49')
  static const CallJoinCallForcePermissions $49 = _$callJoinCallForcePermissions$49;

  @BuiltValueEnumConst(wireName: '50')
  static const CallJoinCallForcePermissions $50 = _$callJoinCallForcePermissions$50;

  @BuiltValueEnumConst(wireName: '51')
  static const CallJoinCallForcePermissions $51 = _$callJoinCallForcePermissions$51;

  @BuiltValueEnumConst(wireName: '52')
  static const CallJoinCallForcePermissions $52 = _$callJoinCallForcePermissions$52;

  @BuiltValueEnumConst(wireName: '53')
  static const CallJoinCallForcePermissions $53 = _$callJoinCallForcePermissions$53;

  @BuiltValueEnumConst(wireName: '54')
  static const CallJoinCallForcePermissions $54 = _$callJoinCallForcePermissions$54;

  @BuiltValueEnumConst(wireName: '55')
  static const CallJoinCallForcePermissions $55 = _$callJoinCallForcePermissions$55;

  @BuiltValueEnumConst(wireName: '56')
  static const CallJoinCallForcePermissions $56 = _$callJoinCallForcePermissions$56;

  @BuiltValueEnumConst(wireName: '57')
  static const CallJoinCallForcePermissions $57 = _$callJoinCallForcePermissions$57;

  @BuiltValueEnumConst(wireName: '58')
  static const CallJoinCallForcePermissions $58 = _$callJoinCallForcePermissions$58;

  @BuiltValueEnumConst(wireName: '59')
  static const CallJoinCallForcePermissions $59 = _$callJoinCallForcePermissions$59;

  @BuiltValueEnumConst(wireName: '60')
  static const CallJoinCallForcePermissions $60 = _$callJoinCallForcePermissions$60;

  @BuiltValueEnumConst(wireName: '61')
  static const CallJoinCallForcePermissions $61 = _$callJoinCallForcePermissions$61;

  @BuiltValueEnumConst(wireName: '62')
  static const CallJoinCallForcePermissions $62 = _$callJoinCallForcePermissions$62;

  @BuiltValueEnumConst(wireName: '63')
  static const CallJoinCallForcePermissions $63 = _$callJoinCallForcePermissions$63;

  @BuiltValueEnumConst(wireName: '64')
  static const CallJoinCallForcePermissions $64 = _$callJoinCallForcePermissions$64;

  @BuiltValueEnumConst(wireName: '65')
  static const CallJoinCallForcePermissions $65 = _$callJoinCallForcePermissions$65;

  @BuiltValueEnumConst(wireName: '66')
  static const CallJoinCallForcePermissions $66 = _$callJoinCallForcePermissions$66;

  @BuiltValueEnumConst(wireName: '67')
  static const CallJoinCallForcePermissions $67 = _$callJoinCallForcePermissions$67;

  @BuiltValueEnumConst(wireName: '68')
  static const CallJoinCallForcePermissions $68 = _$callJoinCallForcePermissions$68;

  @BuiltValueEnumConst(wireName: '69')
  static const CallJoinCallForcePermissions $69 = _$callJoinCallForcePermissions$69;

  @BuiltValueEnumConst(wireName: '70')
  static const CallJoinCallForcePermissions $70 = _$callJoinCallForcePermissions$70;

  @BuiltValueEnumConst(wireName: '71')
  static const CallJoinCallForcePermissions $71 = _$callJoinCallForcePermissions$71;

  @BuiltValueEnumConst(wireName: '72')
  static const CallJoinCallForcePermissions $72 = _$callJoinCallForcePermissions$72;

  @BuiltValueEnumConst(wireName: '73')
  static const CallJoinCallForcePermissions $73 = _$callJoinCallForcePermissions$73;

  @BuiltValueEnumConst(wireName: '74')
  static const CallJoinCallForcePermissions $74 = _$callJoinCallForcePermissions$74;

  @BuiltValueEnumConst(wireName: '75')
  static const CallJoinCallForcePermissions $75 = _$callJoinCallForcePermissions$75;

  @BuiltValueEnumConst(wireName: '76')
  static const CallJoinCallForcePermissions $76 = _$callJoinCallForcePermissions$76;

  @BuiltValueEnumConst(wireName: '77')
  static const CallJoinCallForcePermissions $77 = _$callJoinCallForcePermissions$77;

  @BuiltValueEnumConst(wireName: '78')
  static const CallJoinCallForcePermissions $78 = _$callJoinCallForcePermissions$78;

  @BuiltValueEnumConst(wireName: '79')
  static const CallJoinCallForcePermissions $79 = _$callJoinCallForcePermissions$79;

  @BuiltValueEnumConst(wireName: '80')
  static const CallJoinCallForcePermissions $80 = _$callJoinCallForcePermissions$80;

  @BuiltValueEnumConst(wireName: '81')
  static const CallJoinCallForcePermissions $81 = _$callJoinCallForcePermissions$81;

  @BuiltValueEnumConst(wireName: '82')
  static const CallJoinCallForcePermissions $82 = _$callJoinCallForcePermissions$82;

  @BuiltValueEnumConst(wireName: '83')
  static const CallJoinCallForcePermissions $83 = _$callJoinCallForcePermissions$83;

  @BuiltValueEnumConst(wireName: '84')
  static const CallJoinCallForcePermissions $84 = _$callJoinCallForcePermissions$84;

  @BuiltValueEnumConst(wireName: '85')
  static const CallJoinCallForcePermissions $85 = _$callJoinCallForcePermissions$85;

  @BuiltValueEnumConst(wireName: '86')
  static const CallJoinCallForcePermissions $86 = _$callJoinCallForcePermissions$86;

  @BuiltValueEnumConst(wireName: '87')
  static const CallJoinCallForcePermissions $87 = _$callJoinCallForcePermissions$87;

  @BuiltValueEnumConst(wireName: '88')
  static const CallJoinCallForcePermissions $88 = _$callJoinCallForcePermissions$88;

  @BuiltValueEnumConst(wireName: '89')
  static const CallJoinCallForcePermissions $89 = _$callJoinCallForcePermissions$89;

  @BuiltValueEnumConst(wireName: '90')
  static const CallJoinCallForcePermissions $90 = _$callJoinCallForcePermissions$90;

  @BuiltValueEnumConst(wireName: '91')
  static const CallJoinCallForcePermissions $91 = _$callJoinCallForcePermissions$91;

  @BuiltValueEnumConst(wireName: '92')
  static const CallJoinCallForcePermissions $92 = _$callJoinCallForcePermissions$92;

  @BuiltValueEnumConst(wireName: '93')
  static const CallJoinCallForcePermissions $93 = _$callJoinCallForcePermissions$93;

  @BuiltValueEnumConst(wireName: '94')
  static const CallJoinCallForcePermissions $94 = _$callJoinCallForcePermissions$94;

  @BuiltValueEnumConst(wireName: '95')
  static const CallJoinCallForcePermissions $95 = _$callJoinCallForcePermissions$95;

  @BuiltValueEnumConst(wireName: '96')
  static const CallJoinCallForcePermissions $96 = _$callJoinCallForcePermissions$96;

  @BuiltValueEnumConst(wireName: '97')
  static const CallJoinCallForcePermissions $97 = _$callJoinCallForcePermissions$97;

  @BuiltValueEnumConst(wireName: '98')
  static const CallJoinCallForcePermissions $98 = _$callJoinCallForcePermissions$98;

  @BuiltValueEnumConst(wireName: '99')
  static const CallJoinCallForcePermissions $99 = _$callJoinCallForcePermissions$99;

  @BuiltValueEnumConst(wireName: '100')
  static const CallJoinCallForcePermissions $100 = _$callJoinCallForcePermissions$100;

  @BuiltValueEnumConst(wireName: '101')
  static const CallJoinCallForcePermissions $101 = _$callJoinCallForcePermissions$101;

  @BuiltValueEnumConst(wireName: '102')
  static const CallJoinCallForcePermissions $102 = _$callJoinCallForcePermissions$102;

  @BuiltValueEnumConst(wireName: '103')
  static const CallJoinCallForcePermissions $103 = _$callJoinCallForcePermissions$103;

  @BuiltValueEnumConst(wireName: '104')
  static const CallJoinCallForcePermissions $104 = _$callJoinCallForcePermissions$104;

  @BuiltValueEnumConst(wireName: '105')
  static const CallJoinCallForcePermissions $105 = _$callJoinCallForcePermissions$105;

  @BuiltValueEnumConst(wireName: '106')
  static const CallJoinCallForcePermissions $106 = _$callJoinCallForcePermissions$106;

  @BuiltValueEnumConst(wireName: '107')
  static const CallJoinCallForcePermissions $107 = _$callJoinCallForcePermissions$107;

  @BuiltValueEnumConst(wireName: '108')
  static const CallJoinCallForcePermissions $108 = _$callJoinCallForcePermissions$108;

  @BuiltValueEnumConst(wireName: '109')
  static const CallJoinCallForcePermissions $109 = _$callJoinCallForcePermissions$109;

  @BuiltValueEnumConst(wireName: '110')
  static const CallJoinCallForcePermissions $110 = _$callJoinCallForcePermissions$110;

  @BuiltValueEnumConst(wireName: '111')
  static const CallJoinCallForcePermissions $111 = _$callJoinCallForcePermissions$111;

  @BuiltValueEnumConst(wireName: '112')
  static const CallJoinCallForcePermissions $112 = _$callJoinCallForcePermissions$112;

  @BuiltValueEnumConst(wireName: '113')
  static const CallJoinCallForcePermissions $113 = _$callJoinCallForcePermissions$113;

  @BuiltValueEnumConst(wireName: '114')
  static const CallJoinCallForcePermissions $114 = _$callJoinCallForcePermissions$114;

  @BuiltValueEnumConst(wireName: '115')
  static const CallJoinCallForcePermissions $115 = _$callJoinCallForcePermissions$115;

  @BuiltValueEnumConst(wireName: '116')
  static const CallJoinCallForcePermissions $116 = _$callJoinCallForcePermissions$116;

  @BuiltValueEnumConst(wireName: '117')
  static const CallJoinCallForcePermissions $117 = _$callJoinCallForcePermissions$117;

  @BuiltValueEnumConst(wireName: '118')
  static const CallJoinCallForcePermissions $118 = _$callJoinCallForcePermissions$118;

  @BuiltValueEnumConst(wireName: '119')
  static const CallJoinCallForcePermissions $119 = _$callJoinCallForcePermissions$119;

  @BuiltValueEnumConst(wireName: '120')
  static const CallJoinCallForcePermissions $120 = _$callJoinCallForcePermissions$120;

  @BuiltValueEnumConst(wireName: '121')
  static const CallJoinCallForcePermissions $121 = _$callJoinCallForcePermissions$121;

  @BuiltValueEnumConst(wireName: '122')
  static const CallJoinCallForcePermissions $122 = _$callJoinCallForcePermissions$122;

  @BuiltValueEnumConst(wireName: '123')
  static const CallJoinCallForcePermissions $123 = _$callJoinCallForcePermissions$123;

  @BuiltValueEnumConst(wireName: '124')
  static const CallJoinCallForcePermissions $124 = _$callJoinCallForcePermissions$124;

  @BuiltValueEnumConst(wireName: '125')
  static const CallJoinCallForcePermissions $125 = _$callJoinCallForcePermissions$125;

  @BuiltValueEnumConst(wireName: '126')
  static const CallJoinCallForcePermissions $126 = _$callJoinCallForcePermissions$126;

  @BuiltValueEnumConst(wireName: '127')
  static const CallJoinCallForcePermissions $127 = _$callJoinCallForcePermissions$127;

  @BuiltValueEnumConst(wireName: '128')
  static const CallJoinCallForcePermissions $128 = _$callJoinCallForcePermissions$128;

  @BuiltValueEnumConst(wireName: '129')
  static const CallJoinCallForcePermissions $129 = _$callJoinCallForcePermissions$129;

  @BuiltValueEnumConst(wireName: '130')
  static const CallJoinCallForcePermissions $130 = _$callJoinCallForcePermissions$130;

  @BuiltValueEnumConst(wireName: '131')
  static const CallJoinCallForcePermissions $131 = _$callJoinCallForcePermissions$131;

  @BuiltValueEnumConst(wireName: '132')
  static const CallJoinCallForcePermissions $132 = _$callJoinCallForcePermissions$132;

  @BuiltValueEnumConst(wireName: '133')
  static const CallJoinCallForcePermissions $133 = _$callJoinCallForcePermissions$133;

  @BuiltValueEnumConst(wireName: '134')
  static const CallJoinCallForcePermissions $134 = _$callJoinCallForcePermissions$134;

  @BuiltValueEnumConst(wireName: '135')
  static const CallJoinCallForcePermissions $135 = _$callJoinCallForcePermissions$135;

  @BuiltValueEnumConst(wireName: '136')
  static const CallJoinCallForcePermissions $136 = _$callJoinCallForcePermissions$136;

  @BuiltValueEnumConst(wireName: '137')
  static const CallJoinCallForcePermissions $137 = _$callJoinCallForcePermissions$137;

  @BuiltValueEnumConst(wireName: '138')
  static const CallJoinCallForcePermissions $138 = _$callJoinCallForcePermissions$138;

  @BuiltValueEnumConst(wireName: '139')
  static const CallJoinCallForcePermissions $139 = _$callJoinCallForcePermissions$139;

  @BuiltValueEnumConst(wireName: '140')
  static const CallJoinCallForcePermissions $140 = _$callJoinCallForcePermissions$140;

  @BuiltValueEnumConst(wireName: '141')
  static const CallJoinCallForcePermissions $141 = _$callJoinCallForcePermissions$141;

  @BuiltValueEnumConst(wireName: '142')
  static const CallJoinCallForcePermissions $142 = _$callJoinCallForcePermissions$142;

  @BuiltValueEnumConst(wireName: '143')
  static const CallJoinCallForcePermissions $143 = _$callJoinCallForcePermissions$143;

  @BuiltValueEnumConst(wireName: '144')
  static const CallJoinCallForcePermissions $144 = _$callJoinCallForcePermissions$144;

  @BuiltValueEnumConst(wireName: '145')
  static const CallJoinCallForcePermissions $145 = _$callJoinCallForcePermissions$145;

  @BuiltValueEnumConst(wireName: '146')
  static const CallJoinCallForcePermissions $146 = _$callJoinCallForcePermissions$146;

  @BuiltValueEnumConst(wireName: '147')
  static const CallJoinCallForcePermissions $147 = _$callJoinCallForcePermissions$147;

  @BuiltValueEnumConst(wireName: '148')
  static const CallJoinCallForcePermissions $148 = _$callJoinCallForcePermissions$148;

  @BuiltValueEnumConst(wireName: '149')
  static const CallJoinCallForcePermissions $149 = _$callJoinCallForcePermissions$149;

  @BuiltValueEnumConst(wireName: '150')
  static const CallJoinCallForcePermissions $150 = _$callJoinCallForcePermissions$150;

  @BuiltValueEnumConst(wireName: '151')
  static const CallJoinCallForcePermissions $151 = _$callJoinCallForcePermissions$151;

  @BuiltValueEnumConst(wireName: '152')
  static const CallJoinCallForcePermissions $152 = _$callJoinCallForcePermissions$152;

  @BuiltValueEnumConst(wireName: '153')
  static const CallJoinCallForcePermissions $153 = _$callJoinCallForcePermissions$153;

  @BuiltValueEnumConst(wireName: '154')
  static const CallJoinCallForcePermissions $154 = _$callJoinCallForcePermissions$154;

  @BuiltValueEnumConst(wireName: '155')
  static const CallJoinCallForcePermissions $155 = _$callJoinCallForcePermissions$155;

  @BuiltValueEnumConst(wireName: '156')
  static const CallJoinCallForcePermissions $156 = _$callJoinCallForcePermissions$156;

  @BuiltValueEnumConst(wireName: '157')
  static const CallJoinCallForcePermissions $157 = _$callJoinCallForcePermissions$157;

  @BuiltValueEnumConst(wireName: '158')
  static const CallJoinCallForcePermissions $158 = _$callJoinCallForcePermissions$158;

  @BuiltValueEnumConst(wireName: '159')
  static const CallJoinCallForcePermissions $159 = _$callJoinCallForcePermissions$159;

  @BuiltValueEnumConst(wireName: '160')
  static const CallJoinCallForcePermissions $160 = _$callJoinCallForcePermissions$160;

  @BuiltValueEnumConst(wireName: '161')
  static const CallJoinCallForcePermissions $161 = _$callJoinCallForcePermissions$161;

  @BuiltValueEnumConst(wireName: '162')
  static const CallJoinCallForcePermissions $162 = _$callJoinCallForcePermissions$162;

  @BuiltValueEnumConst(wireName: '163')
  static const CallJoinCallForcePermissions $163 = _$callJoinCallForcePermissions$163;

  @BuiltValueEnumConst(wireName: '164')
  static const CallJoinCallForcePermissions $164 = _$callJoinCallForcePermissions$164;

  @BuiltValueEnumConst(wireName: '165')
  static const CallJoinCallForcePermissions $165 = _$callJoinCallForcePermissions$165;

  @BuiltValueEnumConst(wireName: '166')
  static const CallJoinCallForcePermissions $166 = _$callJoinCallForcePermissions$166;

  @BuiltValueEnumConst(wireName: '167')
  static const CallJoinCallForcePermissions $167 = _$callJoinCallForcePermissions$167;

  @BuiltValueEnumConst(wireName: '168')
  static const CallJoinCallForcePermissions $168 = _$callJoinCallForcePermissions$168;

  @BuiltValueEnumConst(wireName: '169')
  static const CallJoinCallForcePermissions $169 = _$callJoinCallForcePermissions$169;

  @BuiltValueEnumConst(wireName: '170')
  static const CallJoinCallForcePermissions $170 = _$callJoinCallForcePermissions$170;

  @BuiltValueEnumConst(wireName: '171')
  static const CallJoinCallForcePermissions $171 = _$callJoinCallForcePermissions$171;

  @BuiltValueEnumConst(wireName: '172')
  static const CallJoinCallForcePermissions $172 = _$callJoinCallForcePermissions$172;

  @BuiltValueEnumConst(wireName: '173')
  static const CallJoinCallForcePermissions $173 = _$callJoinCallForcePermissions$173;

  @BuiltValueEnumConst(wireName: '174')
  static const CallJoinCallForcePermissions $174 = _$callJoinCallForcePermissions$174;

  @BuiltValueEnumConst(wireName: '175')
  static const CallJoinCallForcePermissions $175 = _$callJoinCallForcePermissions$175;

  @BuiltValueEnumConst(wireName: '176')
  static const CallJoinCallForcePermissions $176 = _$callJoinCallForcePermissions$176;

  @BuiltValueEnumConst(wireName: '177')
  static const CallJoinCallForcePermissions $177 = _$callJoinCallForcePermissions$177;

  @BuiltValueEnumConst(wireName: '178')
  static const CallJoinCallForcePermissions $178 = _$callJoinCallForcePermissions$178;

  @BuiltValueEnumConst(wireName: '179')
  static const CallJoinCallForcePermissions $179 = _$callJoinCallForcePermissions$179;

  @BuiltValueEnumConst(wireName: '180')
  static const CallJoinCallForcePermissions $180 = _$callJoinCallForcePermissions$180;

  @BuiltValueEnumConst(wireName: '181')
  static const CallJoinCallForcePermissions $181 = _$callJoinCallForcePermissions$181;

  @BuiltValueEnumConst(wireName: '182')
  static const CallJoinCallForcePermissions $182 = _$callJoinCallForcePermissions$182;

  @BuiltValueEnumConst(wireName: '183')
  static const CallJoinCallForcePermissions $183 = _$callJoinCallForcePermissions$183;

  @BuiltValueEnumConst(wireName: '184')
  static const CallJoinCallForcePermissions $184 = _$callJoinCallForcePermissions$184;

  @BuiltValueEnumConst(wireName: '185')
  static const CallJoinCallForcePermissions $185 = _$callJoinCallForcePermissions$185;

  @BuiltValueEnumConst(wireName: '186')
  static const CallJoinCallForcePermissions $186 = _$callJoinCallForcePermissions$186;

  @BuiltValueEnumConst(wireName: '187')
  static const CallJoinCallForcePermissions $187 = _$callJoinCallForcePermissions$187;

  @BuiltValueEnumConst(wireName: '188')
  static const CallJoinCallForcePermissions $188 = _$callJoinCallForcePermissions$188;

  @BuiltValueEnumConst(wireName: '189')
  static const CallJoinCallForcePermissions $189 = _$callJoinCallForcePermissions$189;

  @BuiltValueEnumConst(wireName: '190')
  static const CallJoinCallForcePermissions $190 = _$callJoinCallForcePermissions$190;

  @BuiltValueEnumConst(wireName: '191')
  static const CallJoinCallForcePermissions $191 = _$callJoinCallForcePermissions$191;

  @BuiltValueEnumConst(wireName: '192')
  static const CallJoinCallForcePermissions $192 = _$callJoinCallForcePermissions$192;

  @BuiltValueEnumConst(wireName: '193')
  static const CallJoinCallForcePermissions $193 = _$callJoinCallForcePermissions$193;

  @BuiltValueEnumConst(wireName: '194')
  static const CallJoinCallForcePermissions $194 = _$callJoinCallForcePermissions$194;

  @BuiltValueEnumConst(wireName: '195')
  static const CallJoinCallForcePermissions $195 = _$callJoinCallForcePermissions$195;

  @BuiltValueEnumConst(wireName: '196')
  static const CallJoinCallForcePermissions $196 = _$callJoinCallForcePermissions$196;

  @BuiltValueEnumConst(wireName: '197')
  static const CallJoinCallForcePermissions $197 = _$callJoinCallForcePermissions$197;

  @BuiltValueEnumConst(wireName: '198')
  static const CallJoinCallForcePermissions $198 = _$callJoinCallForcePermissions$198;

  @BuiltValueEnumConst(wireName: '199')
  static const CallJoinCallForcePermissions $199 = _$callJoinCallForcePermissions$199;

  @BuiltValueEnumConst(wireName: '200')
  static const CallJoinCallForcePermissions $200 = _$callJoinCallForcePermissions$200;

  @BuiltValueEnumConst(wireName: '201')
  static const CallJoinCallForcePermissions $201 = _$callJoinCallForcePermissions$201;

  @BuiltValueEnumConst(wireName: '202')
  static const CallJoinCallForcePermissions $202 = _$callJoinCallForcePermissions$202;

  @BuiltValueEnumConst(wireName: '203')
  static const CallJoinCallForcePermissions $203 = _$callJoinCallForcePermissions$203;

  @BuiltValueEnumConst(wireName: '204')
  static const CallJoinCallForcePermissions $204 = _$callJoinCallForcePermissions$204;

  @BuiltValueEnumConst(wireName: '205')
  static const CallJoinCallForcePermissions $205 = _$callJoinCallForcePermissions$205;

  @BuiltValueEnumConst(wireName: '206')
  static const CallJoinCallForcePermissions $206 = _$callJoinCallForcePermissions$206;

  @BuiltValueEnumConst(wireName: '207')
  static const CallJoinCallForcePermissions $207 = _$callJoinCallForcePermissions$207;

  @BuiltValueEnumConst(wireName: '208')
  static const CallJoinCallForcePermissions $208 = _$callJoinCallForcePermissions$208;

  @BuiltValueEnumConst(wireName: '209')
  static const CallJoinCallForcePermissions $209 = _$callJoinCallForcePermissions$209;

  @BuiltValueEnumConst(wireName: '210')
  static const CallJoinCallForcePermissions $210 = _$callJoinCallForcePermissions$210;

  @BuiltValueEnumConst(wireName: '211')
  static const CallJoinCallForcePermissions $211 = _$callJoinCallForcePermissions$211;

  @BuiltValueEnumConst(wireName: '212')
  static const CallJoinCallForcePermissions $212 = _$callJoinCallForcePermissions$212;

  @BuiltValueEnumConst(wireName: '213')
  static const CallJoinCallForcePermissions $213 = _$callJoinCallForcePermissions$213;

  @BuiltValueEnumConst(wireName: '214')
  static const CallJoinCallForcePermissions $214 = _$callJoinCallForcePermissions$214;

  @BuiltValueEnumConst(wireName: '215')
  static const CallJoinCallForcePermissions $215 = _$callJoinCallForcePermissions$215;

  @BuiltValueEnumConst(wireName: '216')
  static const CallJoinCallForcePermissions $216 = _$callJoinCallForcePermissions$216;

  @BuiltValueEnumConst(wireName: '217')
  static const CallJoinCallForcePermissions $217 = _$callJoinCallForcePermissions$217;

  @BuiltValueEnumConst(wireName: '218')
  static const CallJoinCallForcePermissions $218 = _$callJoinCallForcePermissions$218;

  @BuiltValueEnumConst(wireName: '219')
  static const CallJoinCallForcePermissions $219 = _$callJoinCallForcePermissions$219;

  @BuiltValueEnumConst(wireName: '220')
  static const CallJoinCallForcePermissions $220 = _$callJoinCallForcePermissions$220;

  @BuiltValueEnumConst(wireName: '221')
  static const CallJoinCallForcePermissions $221 = _$callJoinCallForcePermissions$221;

  @BuiltValueEnumConst(wireName: '222')
  static const CallJoinCallForcePermissions $222 = _$callJoinCallForcePermissions$222;

  @BuiltValueEnumConst(wireName: '223')
  static const CallJoinCallForcePermissions $223 = _$callJoinCallForcePermissions$223;

  @BuiltValueEnumConst(wireName: '224')
  static const CallJoinCallForcePermissions $224 = _$callJoinCallForcePermissions$224;

  @BuiltValueEnumConst(wireName: '225')
  static const CallJoinCallForcePermissions $225 = _$callJoinCallForcePermissions$225;

  @BuiltValueEnumConst(wireName: '226')
  static const CallJoinCallForcePermissions $226 = _$callJoinCallForcePermissions$226;

  @BuiltValueEnumConst(wireName: '227')
  static const CallJoinCallForcePermissions $227 = _$callJoinCallForcePermissions$227;

  @BuiltValueEnumConst(wireName: '228')
  static const CallJoinCallForcePermissions $228 = _$callJoinCallForcePermissions$228;

  @BuiltValueEnumConst(wireName: '229')
  static const CallJoinCallForcePermissions $229 = _$callJoinCallForcePermissions$229;

  @BuiltValueEnumConst(wireName: '230')
  static const CallJoinCallForcePermissions $230 = _$callJoinCallForcePermissions$230;

  @BuiltValueEnumConst(wireName: '231')
  static const CallJoinCallForcePermissions $231 = _$callJoinCallForcePermissions$231;

  @BuiltValueEnumConst(wireName: '232')
  static const CallJoinCallForcePermissions $232 = _$callJoinCallForcePermissions$232;

  @BuiltValueEnumConst(wireName: '233')
  static const CallJoinCallForcePermissions $233 = _$callJoinCallForcePermissions$233;

  @BuiltValueEnumConst(wireName: '234')
  static const CallJoinCallForcePermissions $234 = _$callJoinCallForcePermissions$234;

  @BuiltValueEnumConst(wireName: '235')
  static const CallJoinCallForcePermissions $235 = _$callJoinCallForcePermissions$235;

  @BuiltValueEnumConst(wireName: '236')
  static const CallJoinCallForcePermissions $236 = _$callJoinCallForcePermissions$236;

  @BuiltValueEnumConst(wireName: '237')
  static const CallJoinCallForcePermissions $237 = _$callJoinCallForcePermissions$237;

  @BuiltValueEnumConst(wireName: '238')
  static const CallJoinCallForcePermissions $238 = _$callJoinCallForcePermissions$238;

  @BuiltValueEnumConst(wireName: '239')
  static const CallJoinCallForcePermissions $239 = _$callJoinCallForcePermissions$239;

  @BuiltValueEnumConst(wireName: '240')
  static const CallJoinCallForcePermissions $240 = _$callJoinCallForcePermissions$240;

  @BuiltValueEnumConst(wireName: '241')
  static const CallJoinCallForcePermissions $241 = _$callJoinCallForcePermissions$241;

  @BuiltValueEnumConst(wireName: '242')
  static const CallJoinCallForcePermissions $242 = _$callJoinCallForcePermissions$242;

  @BuiltValueEnumConst(wireName: '243')
  static const CallJoinCallForcePermissions $243 = _$callJoinCallForcePermissions$243;

  @BuiltValueEnumConst(wireName: '244')
  static const CallJoinCallForcePermissions $244 = _$callJoinCallForcePermissions$244;

  @BuiltValueEnumConst(wireName: '245')
  static const CallJoinCallForcePermissions $245 = _$callJoinCallForcePermissions$245;

  @BuiltValueEnumConst(wireName: '246')
  static const CallJoinCallForcePermissions $246 = _$callJoinCallForcePermissions$246;

  @BuiltValueEnumConst(wireName: '247')
  static const CallJoinCallForcePermissions $247 = _$callJoinCallForcePermissions$247;

  @BuiltValueEnumConst(wireName: '248')
  static const CallJoinCallForcePermissions $248 = _$callJoinCallForcePermissions$248;

  @BuiltValueEnumConst(wireName: '249')
  static const CallJoinCallForcePermissions $249 = _$callJoinCallForcePermissions$249;

  @BuiltValueEnumConst(wireName: '250')
  static const CallJoinCallForcePermissions $250 = _$callJoinCallForcePermissions$250;

  @BuiltValueEnumConst(wireName: '251')
  static const CallJoinCallForcePermissions $251 = _$callJoinCallForcePermissions$251;

  @BuiltValueEnumConst(wireName: '252')
  static const CallJoinCallForcePermissions $252 = _$callJoinCallForcePermissions$252;

  @BuiltValueEnumConst(wireName: '253')
  static const CallJoinCallForcePermissions $253 = _$callJoinCallForcePermissions$253;

  @BuiltValueEnumConst(wireName: '254')
  static const CallJoinCallForcePermissions $254 = _$callJoinCallForcePermissions$254;

  @BuiltValueEnumConst(wireName: '255')
  static const CallJoinCallForcePermissions $255 = _$callJoinCallForcePermissions$255;

  // coverage:ignore-start
  static BuiltSet<CallJoinCallForcePermissions> get values => _$callJoinCallForcePermissionsValues;
  // coverage:ignore-end

  static CallJoinCallForcePermissions valueOf(String name) => _$valueOfCallJoinCallForcePermissions(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallJoinCallForcePermissions> get serializer => const _$CallJoinCallForcePermissionsSerializer();
}

class _$CallJoinCallForcePermissionsSerializer implements PrimitiveSerializer<CallJoinCallForcePermissions> {
  const _$CallJoinCallForcePermissionsSerializer();

  static const Map<CallJoinCallForcePermissions, Object> _toWire = <CallJoinCallForcePermissions, Object>{
    CallJoinCallForcePermissions.$0: 0,
    CallJoinCallForcePermissions.$1: 1,
    CallJoinCallForcePermissions.$2: 2,
    CallJoinCallForcePermissions.$3: 3,
    CallJoinCallForcePermissions.$4: 4,
    CallJoinCallForcePermissions.$5: 5,
    CallJoinCallForcePermissions.$6: 6,
    CallJoinCallForcePermissions.$7: 7,
    CallJoinCallForcePermissions.$8: 8,
    CallJoinCallForcePermissions.$9: 9,
    CallJoinCallForcePermissions.$10: 10,
    CallJoinCallForcePermissions.$11: 11,
    CallJoinCallForcePermissions.$12: 12,
    CallJoinCallForcePermissions.$13: 13,
    CallJoinCallForcePermissions.$14: 14,
    CallJoinCallForcePermissions.$15: 15,
    CallJoinCallForcePermissions.$16: 16,
    CallJoinCallForcePermissions.$17: 17,
    CallJoinCallForcePermissions.$18: 18,
    CallJoinCallForcePermissions.$19: 19,
    CallJoinCallForcePermissions.$20: 20,
    CallJoinCallForcePermissions.$21: 21,
    CallJoinCallForcePermissions.$22: 22,
    CallJoinCallForcePermissions.$23: 23,
    CallJoinCallForcePermissions.$24: 24,
    CallJoinCallForcePermissions.$25: 25,
    CallJoinCallForcePermissions.$26: 26,
    CallJoinCallForcePermissions.$27: 27,
    CallJoinCallForcePermissions.$28: 28,
    CallJoinCallForcePermissions.$29: 29,
    CallJoinCallForcePermissions.$30: 30,
    CallJoinCallForcePermissions.$31: 31,
    CallJoinCallForcePermissions.$32: 32,
    CallJoinCallForcePermissions.$33: 33,
    CallJoinCallForcePermissions.$34: 34,
    CallJoinCallForcePermissions.$35: 35,
    CallJoinCallForcePermissions.$36: 36,
    CallJoinCallForcePermissions.$37: 37,
    CallJoinCallForcePermissions.$38: 38,
    CallJoinCallForcePermissions.$39: 39,
    CallJoinCallForcePermissions.$40: 40,
    CallJoinCallForcePermissions.$41: 41,
    CallJoinCallForcePermissions.$42: 42,
    CallJoinCallForcePermissions.$43: 43,
    CallJoinCallForcePermissions.$44: 44,
    CallJoinCallForcePermissions.$45: 45,
    CallJoinCallForcePermissions.$46: 46,
    CallJoinCallForcePermissions.$47: 47,
    CallJoinCallForcePermissions.$48: 48,
    CallJoinCallForcePermissions.$49: 49,
    CallJoinCallForcePermissions.$50: 50,
    CallJoinCallForcePermissions.$51: 51,
    CallJoinCallForcePermissions.$52: 52,
    CallJoinCallForcePermissions.$53: 53,
    CallJoinCallForcePermissions.$54: 54,
    CallJoinCallForcePermissions.$55: 55,
    CallJoinCallForcePermissions.$56: 56,
    CallJoinCallForcePermissions.$57: 57,
    CallJoinCallForcePermissions.$58: 58,
    CallJoinCallForcePermissions.$59: 59,
    CallJoinCallForcePermissions.$60: 60,
    CallJoinCallForcePermissions.$61: 61,
    CallJoinCallForcePermissions.$62: 62,
    CallJoinCallForcePermissions.$63: 63,
    CallJoinCallForcePermissions.$64: 64,
    CallJoinCallForcePermissions.$65: 65,
    CallJoinCallForcePermissions.$66: 66,
    CallJoinCallForcePermissions.$67: 67,
    CallJoinCallForcePermissions.$68: 68,
    CallJoinCallForcePermissions.$69: 69,
    CallJoinCallForcePermissions.$70: 70,
    CallJoinCallForcePermissions.$71: 71,
    CallJoinCallForcePermissions.$72: 72,
    CallJoinCallForcePermissions.$73: 73,
    CallJoinCallForcePermissions.$74: 74,
    CallJoinCallForcePermissions.$75: 75,
    CallJoinCallForcePermissions.$76: 76,
    CallJoinCallForcePermissions.$77: 77,
    CallJoinCallForcePermissions.$78: 78,
    CallJoinCallForcePermissions.$79: 79,
    CallJoinCallForcePermissions.$80: 80,
    CallJoinCallForcePermissions.$81: 81,
    CallJoinCallForcePermissions.$82: 82,
    CallJoinCallForcePermissions.$83: 83,
    CallJoinCallForcePermissions.$84: 84,
    CallJoinCallForcePermissions.$85: 85,
    CallJoinCallForcePermissions.$86: 86,
    CallJoinCallForcePermissions.$87: 87,
    CallJoinCallForcePermissions.$88: 88,
    CallJoinCallForcePermissions.$89: 89,
    CallJoinCallForcePermissions.$90: 90,
    CallJoinCallForcePermissions.$91: 91,
    CallJoinCallForcePermissions.$92: 92,
    CallJoinCallForcePermissions.$93: 93,
    CallJoinCallForcePermissions.$94: 94,
    CallJoinCallForcePermissions.$95: 95,
    CallJoinCallForcePermissions.$96: 96,
    CallJoinCallForcePermissions.$97: 97,
    CallJoinCallForcePermissions.$98: 98,
    CallJoinCallForcePermissions.$99: 99,
    CallJoinCallForcePermissions.$100: 100,
    CallJoinCallForcePermissions.$101: 101,
    CallJoinCallForcePermissions.$102: 102,
    CallJoinCallForcePermissions.$103: 103,
    CallJoinCallForcePermissions.$104: 104,
    CallJoinCallForcePermissions.$105: 105,
    CallJoinCallForcePermissions.$106: 106,
    CallJoinCallForcePermissions.$107: 107,
    CallJoinCallForcePermissions.$108: 108,
    CallJoinCallForcePermissions.$109: 109,
    CallJoinCallForcePermissions.$110: 110,
    CallJoinCallForcePermissions.$111: 111,
    CallJoinCallForcePermissions.$112: 112,
    CallJoinCallForcePermissions.$113: 113,
    CallJoinCallForcePermissions.$114: 114,
    CallJoinCallForcePermissions.$115: 115,
    CallJoinCallForcePermissions.$116: 116,
    CallJoinCallForcePermissions.$117: 117,
    CallJoinCallForcePermissions.$118: 118,
    CallJoinCallForcePermissions.$119: 119,
    CallJoinCallForcePermissions.$120: 120,
    CallJoinCallForcePermissions.$121: 121,
    CallJoinCallForcePermissions.$122: 122,
    CallJoinCallForcePermissions.$123: 123,
    CallJoinCallForcePermissions.$124: 124,
    CallJoinCallForcePermissions.$125: 125,
    CallJoinCallForcePermissions.$126: 126,
    CallJoinCallForcePermissions.$127: 127,
    CallJoinCallForcePermissions.$128: 128,
    CallJoinCallForcePermissions.$129: 129,
    CallJoinCallForcePermissions.$130: 130,
    CallJoinCallForcePermissions.$131: 131,
    CallJoinCallForcePermissions.$132: 132,
    CallJoinCallForcePermissions.$133: 133,
    CallJoinCallForcePermissions.$134: 134,
    CallJoinCallForcePermissions.$135: 135,
    CallJoinCallForcePermissions.$136: 136,
    CallJoinCallForcePermissions.$137: 137,
    CallJoinCallForcePermissions.$138: 138,
    CallJoinCallForcePermissions.$139: 139,
    CallJoinCallForcePermissions.$140: 140,
    CallJoinCallForcePermissions.$141: 141,
    CallJoinCallForcePermissions.$142: 142,
    CallJoinCallForcePermissions.$143: 143,
    CallJoinCallForcePermissions.$144: 144,
    CallJoinCallForcePermissions.$145: 145,
    CallJoinCallForcePermissions.$146: 146,
    CallJoinCallForcePermissions.$147: 147,
    CallJoinCallForcePermissions.$148: 148,
    CallJoinCallForcePermissions.$149: 149,
    CallJoinCallForcePermissions.$150: 150,
    CallJoinCallForcePermissions.$151: 151,
    CallJoinCallForcePermissions.$152: 152,
    CallJoinCallForcePermissions.$153: 153,
    CallJoinCallForcePermissions.$154: 154,
    CallJoinCallForcePermissions.$155: 155,
    CallJoinCallForcePermissions.$156: 156,
    CallJoinCallForcePermissions.$157: 157,
    CallJoinCallForcePermissions.$158: 158,
    CallJoinCallForcePermissions.$159: 159,
    CallJoinCallForcePermissions.$160: 160,
    CallJoinCallForcePermissions.$161: 161,
    CallJoinCallForcePermissions.$162: 162,
    CallJoinCallForcePermissions.$163: 163,
    CallJoinCallForcePermissions.$164: 164,
    CallJoinCallForcePermissions.$165: 165,
    CallJoinCallForcePermissions.$166: 166,
    CallJoinCallForcePermissions.$167: 167,
    CallJoinCallForcePermissions.$168: 168,
    CallJoinCallForcePermissions.$169: 169,
    CallJoinCallForcePermissions.$170: 170,
    CallJoinCallForcePermissions.$171: 171,
    CallJoinCallForcePermissions.$172: 172,
    CallJoinCallForcePermissions.$173: 173,
    CallJoinCallForcePermissions.$174: 174,
    CallJoinCallForcePermissions.$175: 175,
    CallJoinCallForcePermissions.$176: 176,
    CallJoinCallForcePermissions.$177: 177,
    CallJoinCallForcePermissions.$178: 178,
    CallJoinCallForcePermissions.$179: 179,
    CallJoinCallForcePermissions.$180: 180,
    CallJoinCallForcePermissions.$181: 181,
    CallJoinCallForcePermissions.$182: 182,
    CallJoinCallForcePermissions.$183: 183,
    CallJoinCallForcePermissions.$184: 184,
    CallJoinCallForcePermissions.$185: 185,
    CallJoinCallForcePermissions.$186: 186,
    CallJoinCallForcePermissions.$187: 187,
    CallJoinCallForcePermissions.$188: 188,
    CallJoinCallForcePermissions.$189: 189,
    CallJoinCallForcePermissions.$190: 190,
    CallJoinCallForcePermissions.$191: 191,
    CallJoinCallForcePermissions.$192: 192,
    CallJoinCallForcePermissions.$193: 193,
    CallJoinCallForcePermissions.$194: 194,
    CallJoinCallForcePermissions.$195: 195,
    CallJoinCallForcePermissions.$196: 196,
    CallJoinCallForcePermissions.$197: 197,
    CallJoinCallForcePermissions.$198: 198,
    CallJoinCallForcePermissions.$199: 199,
    CallJoinCallForcePermissions.$200: 200,
    CallJoinCallForcePermissions.$201: 201,
    CallJoinCallForcePermissions.$202: 202,
    CallJoinCallForcePermissions.$203: 203,
    CallJoinCallForcePermissions.$204: 204,
    CallJoinCallForcePermissions.$205: 205,
    CallJoinCallForcePermissions.$206: 206,
    CallJoinCallForcePermissions.$207: 207,
    CallJoinCallForcePermissions.$208: 208,
    CallJoinCallForcePermissions.$209: 209,
    CallJoinCallForcePermissions.$210: 210,
    CallJoinCallForcePermissions.$211: 211,
    CallJoinCallForcePermissions.$212: 212,
    CallJoinCallForcePermissions.$213: 213,
    CallJoinCallForcePermissions.$214: 214,
    CallJoinCallForcePermissions.$215: 215,
    CallJoinCallForcePermissions.$216: 216,
    CallJoinCallForcePermissions.$217: 217,
    CallJoinCallForcePermissions.$218: 218,
    CallJoinCallForcePermissions.$219: 219,
    CallJoinCallForcePermissions.$220: 220,
    CallJoinCallForcePermissions.$221: 221,
    CallJoinCallForcePermissions.$222: 222,
    CallJoinCallForcePermissions.$223: 223,
    CallJoinCallForcePermissions.$224: 224,
    CallJoinCallForcePermissions.$225: 225,
    CallJoinCallForcePermissions.$226: 226,
    CallJoinCallForcePermissions.$227: 227,
    CallJoinCallForcePermissions.$228: 228,
    CallJoinCallForcePermissions.$229: 229,
    CallJoinCallForcePermissions.$230: 230,
    CallJoinCallForcePermissions.$231: 231,
    CallJoinCallForcePermissions.$232: 232,
    CallJoinCallForcePermissions.$233: 233,
    CallJoinCallForcePermissions.$234: 234,
    CallJoinCallForcePermissions.$235: 235,
    CallJoinCallForcePermissions.$236: 236,
    CallJoinCallForcePermissions.$237: 237,
    CallJoinCallForcePermissions.$238: 238,
    CallJoinCallForcePermissions.$239: 239,
    CallJoinCallForcePermissions.$240: 240,
    CallJoinCallForcePermissions.$241: 241,
    CallJoinCallForcePermissions.$242: 242,
    CallJoinCallForcePermissions.$243: 243,
    CallJoinCallForcePermissions.$244: 244,
    CallJoinCallForcePermissions.$245: 245,
    CallJoinCallForcePermissions.$246: 246,
    CallJoinCallForcePermissions.$247: 247,
    CallJoinCallForcePermissions.$248: 248,
    CallJoinCallForcePermissions.$249: 249,
    CallJoinCallForcePermissions.$250: 250,
    CallJoinCallForcePermissions.$251: 251,
    CallJoinCallForcePermissions.$252: 252,
    CallJoinCallForcePermissions.$253: 253,
    CallJoinCallForcePermissions.$254: 254,
    CallJoinCallForcePermissions.$255: 255,
  };

  static const Map<Object, CallJoinCallForcePermissions> _fromWire = <Object, CallJoinCallForcePermissions>{
    0: CallJoinCallForcePermissions.$0,
    1: CallJoinCallForcePermissions.$1,
    2: CallJoinCallForcePermissions.$2,
    3: CallJoinCallForcePermissions.$3,
    4: CallJoinCallForcePermissions.$4,
    5: CallJoinCallForcePermissions.$5,
    6: CallJoinCallForcePermissions.$6,
    7: CallJoinCallForcePermissions.$7,
    8: CallJoinCallForcePermissions.$8,
    9: CallJoinCallForcePermissions.$9,
    10: CallJoinCallForcePermissions.$10,
    11: CallJoinCallForcePermissions.$11,
    12: CallJoinCallForcePermissions.$12,
    13: CallJoinCallForcePermissions.$13,
    14: CallJoinCallForcePermissions.$14,
    15: CallJoinCallForcePermissions.$15,
    16: CallJoinCallForcePermissions.$16,
    17: CallJoinCallForcePermissions.$17,
    18: CallJoinCallForcePermissions.$18,
    19: CallJoinCallForcePermissions.$19,
    20: CallJoinCallForcePermissions.$20,
    21: CallJoinCallForcePermissions.$21,
    22: CallJoinCallForcePermissions.$22,
    23: CallJoinCallForcePermissions.$23,
    24: CallJoinCallForcePermissions.$24,
    25: CallJoinCallForcePermissions.$25,
    26: CallJoinCallForcePermissions.$26,
    27: CallJoinCallForcePermissions.$27,
    28: CallJoinCallForcePermissions.$28,
    29: CallJoinCallForcePermissions.$29,
    30: CallJoinCallForcePermissions.$30,
    31: CallJoinCallForcePermissions.$31,
    32: CallJoinCallForcePermissions.$32,
    33: CallJoinCallForcePermissions.$33,
    34: CallJoinCallForcePermissions.$34,
    35: CallJoinCallForcePermissions.$35,
    36: CallJoinCallForcePermissions.$36,
    37: CallJoinCallForcePermissions.$37,
    38: CallJoinCallForcePermissions.$38,
    39: CallJoinCallForcePermissions.$39,
    40: CallJoinCallForcePermissions.$40,
    41: CallJoinCallForcePermissions.$41,
    42: CallJoinCallForcePermissions.$42,
    43: CallJoinCallForcePermissions.$43,
    44: CallJoinCallForcePermissions.$44,
    45: CallJoinCallForcePermissions.$45,
    46: CallJoinCallForcePermissions.$46,
    47: CallJoinCallForcePermissions.$47,
    48: CallJoinCallForcePermissions.$48,
    49: CallJoinCallForcePermissions.$49,
    50: CallJoinCallForcePermissions.$50,
    51: CallJoinCallForcePermissions.$51,
    52: CallJoinCallForcePermissions.$52,
    53: CallJoinCallForcePermissions.$53,
    54: CallJoinCallForcePermissions.$54,
    55: CallJoinCallForcePermissions.$55,
    56: CallJoinCallForcePermissions.$56,
    57: CallJoinCallForcePermissions.$57,
    58: CallJoinCallForcePermissions.$58,
    59: CallJoinCallForcePermissions.$59,
    60: CallJoinCallForcePermissions.$60,
    61: CallJoinCallForcePermissions.$61,
    62: CallJoinCallForcePermissions.$62,
    63: CallJoinCallForcePermissions.$63,
    64: CallJoinCallForcePermissions.$64,
    65: CallJoinCallForcePermissions.$65,
    66: CallJoinCallForcePermissions.$66,
    67: CallJoinCallForcePermissions.$67,
    68: CallJoinCallForcePermissions.$68,
    69: CallJoinCallForcePermissions.$69,
    70: CallJoinCallForcePermissions.$70,
    71: CallJoinCallForcePermissions.$71,
    72: CallJoinCallForcePermissions.$72,
    73: CallJoinCallForcePermissions.$73,
    74: CallJoinCallForcePermissions.$74,
    75: CallJoinCallForcePermissions.$75,
    76: CallJoinCallForcePermissions.$76,
    77: CallJoinCallForcePermissions.$77,
    78: CallJoinCallForcePermissions.$78,
    79: CallJoinCallForcePermissions.$79,
    80: CallJoinCallForcePermissions.$80,
    81: CallJoinCallForcePermissions.$81,
    82: CallJoinCallForcePermissions.$82,
    83: CallJoinCallForcePermissions.$83,
    84: CallJoinCallForcePermissions.$84,
    85: CallJoinCallForcePermissions.$85,
    86: CallJoinCallForcePermissions.$86,
    87: CallJoinCallForcePermissions.$87,
    88: CallJoinCallForcePermissions.$88,
    89: CallJoinCallForcePermissions.$89,
    90: CallJoinCallForcePermissions.$90,
    91: CallJoinCallForcePermissions.$91,
    92: CallJoinCallForcePermissions.$92,
    93: CallJoinCallForcePermissions.$93,
    94: CallJoinCallForcePermissions.$94,
    95: CallJoinCallForcePermissions.$95,
    96: CallJoinCallForcePermissions.$96,
    97: CallJoinCallForcePermissions.$97,
    98: CallJoinCallForcePermissions.$98,
    99: CallJoinCallForcePermissions.$99,
    100: CallJoinCallForcePermissions.$100,
    101: CallJoinCallForcePermissions.$101,
    102: CallJoinCallForcePermissions.$102,
    103: CallJoinCallForcePermissions.$103,
    104: CallJoinCallForcePermissions.$104,
    105: CallJoinCallForcePermissions.$105,
    106: CallJoinCallForcePermissions.$106,
    107: CallJoinCallForcePermissions.$107,
    108: CallJoinCallForcePermissions.$108,
    109: CallJoinCallForcePermissions.$109,
    110: CallJoinCallForcePermissions.$110,
    111: CallJoinCallForcePermissions.$111,
    112: CallJoinCallForcePermissions.$112,
    113: CallJoinCallForcePermissions.$113,
    114: CallJoinCallForcePermissions.$114,
    115: CallJoinCallForcePermissions.$115,
    116: CallJoinCallForcePermissions.$116,
    117: CallJoinCallForcePermissions.$117,
    118: CallJoinCallForcePermissions.$118,
    119: CallJoinCallForcePermissions.$119,
    120: CallJoinCallForcePermissions.$120,
    121: CallJoinCallForcePermissions.$121,
    122: CallJoinCallForcePermissions.$122,
    123: CallJoinCallForcePermissions.$123,
    124: CallJoinCallForcePermissions.$124,
    125: CallJoinCallForcePermissions.$125,
    126: CallJoinCallForcePermissions.$126,
    127: CallJoinCallForcePermissions.$127,
    128: CallJoinCallForcePermissions.$128,
    129: CallJoinCallForcePermissions.$129,
    130: CallJoinCallForcePermissions.$130,
    131: CallJoinCallForcePermissions.$131,
    132: CallJoinCallForcePermissions.$132,
    133: CallJoinCallForcePermissions.$133,
    134: CallJoinCallForcePermissions.$134,
    135: CallJoinCallForcePermissions.$135,
    136: CallJoinCallForcePermissions.$136,
    137: CallJoinCallForcePermissions.$137,
    138: CallJoinCallForcePermissions.$138,
    139: CallJoinCallForcePermissions.$139,
    140: CallJoinCallForcePermissions.$140,
    141: CallJoinCallForcePermissions.$141,
    142: CallJoinCallForcePermissions.$142,
    143: CallJoinCallForcePermissions.$143,
    144: CallJoinCallForcePermissions.$144,
    145: CallJoinCallForcePermissions.$145,
    146: CallJoinCallForcePermissions.$146,
    147: CallJoinCallForcePermissions.$147,
    148: CallJoinCallForcePermissions.$148,
    149: CallJoinCallForcePermissions.$149,
    150: CallJoinCallForcePermissions.$150,
    151: CallJoinCallForcePermissions.$151,
    152: CallJoinCallForcePermissions.$152,
    153: CallJoinCallForcePermissions.$153,
    154: CallJoinCallForcePermissions.$154,
    155: CallJoinCallForcePermissions.$155,
    156: CallJoinCallForcePermissions.$156,
    157: CallJoinCallForcePermissions.$157,
    158: CallJoinCallForcePermissions.$158,
    159: CallJoinCallForcePermissions.$159,
    160: CallJoinCallForcePermissions.$160,
    161: CallJoinCallForcePermissions.$161,
    162: CallJoinCallForcePermissions.$162,
    163: CallJoinCallForcePermissions.$163,
    164: CallJoinCallForcePermissions.$164,
    165: CallJoinCallForcePermissions.$165,
    166: CallJoinCallForcePermissions.$166,
    167: CallJoinCallForcePermissions.$167,
    168: CallJoinCallForcePermissions.$168,
    169: CallJoinCallForcePermissions.$169,
    170: CallJoinCallForcePermissions.$170,
    171: CallJoinCallForcePermissions.$171,
    172: CallJoinCallForcePermissions.$172,
    173: CallJoinCallForcePermissions.$173,
    174: CallJoinCallForcePermissions.$174,
    175: CallJoinCallForcePermissions.$175,
    176: CallJoinCallForcePermissions.$176,
    177: CallJoinCallForcePermissions.$177,
    178: CallJoinCallForcePermissions.$178,
    179: CallJoinCallForcePermissions.$179,
    180: CallJoinCallForcePermissions.$180,
    181: CallJoinCallForcePermissions.$181,
    182: CallJoinCallForcePermissions.$182,
    183: CallJoinCallForcePermissions.$183,
    184: CallJoinCallForcePermissions.$184,
    185: CallJoinCallForcePermissions.$185,
    186: CallJoinCallForcePermissions.$186,
    187: CallJoinCallForcePermissions.$187,
    188: CallJoinCallForcePermissions.$188,
    189: CallJoinCallForcePermissions.$189,
    190: CallJoinCallForcePermissions.$190,
    191: CallJoinCallForcePermissions.$191,
    192: CallJoinCallForcePermissions.$192,
    193: CallJoinCallForcePermissions.$193,
    194: CallJoinCallForcePermissions.$194,
    195: CallJoinCallForcePermissions.$195,
    196: CallJoinCallForcePermissions.$196,
    197: CallJoinCallForcePermissions.$197,
    198: CallJoinCallForcePermissions.$198,
    199: CallJoinCallForcePermissions.$199,
    200: CallJoinCallForcePermissions.$200,
    201: CallJoinCallForcePermissions.$201,
    202: CallJoinCallForcePermissions.$202,
    203: CallJoinCallForcePermissions.$203,
    204: CallJoinCallForcePermissions.$204,
    205: CallJoinCallForcePermissions.$205,
    206: CallJoinCallForcePermissions.$206,
    207: CallJoinCallForcePermissions.$207,
    208: CallJoinCallForcePermissions.$208,
    209: CallJoinCallForcePermissions.$209,
    210: CallJoinCallForcePermissions.$210,
    211: CallJoinCallForcePermissions.$211,
    212: CallJoinCallForcePermissions.$212,
    213: CallJoinCallForcePermissions.$213,
    214: CallJoinCallForcePermissions.$214,
    215: CallJoinCallForcePermissions.$215,
    216: CallJoinCallForcePermissions.$216,
    217: CallJoinCallForcePermissions.$217,
    218: CallJoinCallForcePermissions.$218,
    219: CallJoinCallForcePermissions.$219,
    220: CallJoinCallForcePermissions.$220,
    221: CallJoinCallForcePermissions.$221,
    222: CallJoinCallForcePermissions.$222,
    223: CallJoinCallForcePermissions.$223,
    224: CallJoinCallForcePermissions.$224,
    225: CallJoinCallForcePermissions.$225,
    226: CallJoinCallForcePermissions.$226,
    227: CallJoinCallForcePermissions.$227,
    228: CallJoinCallForcePermissions.$228,
    229: CallJoinCallForcePermissions.$229,
    230: CallJoinCallForcePermissions.$230,
    231: CallJoinCallForcePermissions.$231,
    232: CallJoinCallForcePermissions.$232,
    233: CallJoinCallForcePermissions.$233,
    234: CallJoinCallForcePermissions.$234,
    235: CallJoinCallForcePermissions.$235,
    236: CallJoinCallForcePermissions.$236,
    237: CallJoinCallForcePermissions.$237,
    238: CallJoinCallForcePermissions.$238,
    239: CallJoinCallForcePermissions.$239,
    240: CallJoinCallForcePermissions.$240,
    241: CallJoinCallForcePermissions.$241,
    242: CallJoinCallForcePermissions.$242,
    243: CallJoinCallForcePermissions.$243,
    244: CallJoinCallForcePermissions.$244,
    245: CallJoinCallForcePermissions.$245,
    246: CallJoinCallForcePermissions.$246,
    247: CallJoinCallForcePermissions.$247,
    248: CallJoinCallForcePermissions.$248,
    249: CallJoinCallForcePermissions.$249,
    250: CallJoinCallForcePermissions.$250,
    251: CallJoinCallForcePermissions.$251,
    252: CallJoinCallForcePermissions.$252,
    253: CallJoinCallForcePermissions.$253,
    254: CallJoinCallForcePermissions.$254,
    255: CallJoinCallForcePermissions.$255,
  };

  @override
  Iterable<Type> get types => const [CallJoinCallForcePermissions];

  @override
  String get wireName => 'CallJoinCallForcePermissions';

  @override
  Object serialize(
    Serializers serializers,
    CallJoinCallForcePermissions object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallJoinCallForcePermissions deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class CallJoinCallApiVersion extends EnumClass {
  const CallJoinCallApiVersion._(super.name);

  static const CallJoinCallApiVersion v4 = _$callJoinCallApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<CallJoinCallApiVersion> get values => _$callJoinCallApiVersionValues;
  // coverage:ignore-end

  static CallJoinCallApiVersion valueOf(String name) => _$valueOfCallJoinCallApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallJoinCallApiVersion> get serializer => const _$CallJoinCallApiVersionSerializer();
}

class _$CallJoinCallApiVersionSerializer implements PrimitiveSerializer<CallJoinCallApiVersion> {
  const _$CallJoinCallApiVersionSerializer();

  static const Map<CallJoinCallApiVersion, Object> _toWire = <CallJoinCallApiVersion, Object>{
    CallJoinCallApiVersion.v4: 'v4',
  };

  static const Map<Object, CallJoinCallApiVersion> _fromWire = <Object, CallJoinCallApiVersion>{
    'v4': CallJoinCallApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallJoinCallApiVersion];

  @override
  String get wireName => 'CallJoinCallApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallJoinCallApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallJoinCallApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallJoinCallResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class CallJoinCallResponseApplicationJson_Ocs
    implements
        $CallJoinCallResponseApplicationJson_OcsInterface,
        Built<CallJoinCallResponseApplicationJson_Ocs, CallJoinCallResponseApplicationJson_OcsBuilder> {
  factory CallJoinCallResponseApplicationJson_Ocs([void Function(CallJoinCallResponseApplicationJson_OcsBuilder)? b]) =
      _$CallJoinCallResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallJoinCallResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallJoinCallResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallJoinCallResponseApplicationJson_Ocs> get serializer =>
      _$callJoinCallResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallJoinCallResponseApplicationJsonInterface {
  CallJoinCallResponseApplicationJson_Ocs get ocs;
}

abstract class CallJoinCallResponseApplicationJson
    implements
        $CallJoinCallResponseApplicationJsonInterface,
        Built<CallJoinCallResponseApplicationJson, CallJoinCallResponseApplicationJsonBuilder> {
  factory CallJoinCallResponseApplicationJson([void Function(CallJoinCallResponseApplicationJsonBuilder)? b]) =
      _$CallJoinCallResponseApplicationJson;

  // coverage:ignore-start
  const CallJoinCallResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallJoinCallResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallJoinCallResponseApplicationJson> get serializer =>
      _$callJoinCallResponseApplicationJsonSerializer;
}

class CallLeaveCallApiVersion extends EnumClass {
  const CallLeaveCallApiVersion._(super.name);

  static const CallLeaveCallApiVersion v4 = _$callLeaveCallApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<CallLeaveCallApiVersion> get values => _$callLeaveCallApiVersionValues;
  // coverage:ignore-end

  static CallLeaveCallApiVersion valueOf(String name) => _$valueOfCallLeaveCallApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallLeaveCallApiVersion> get serializer => const _$CallLeaveCallApiVersionSerializer();
}

class _$CallLeaveCallApiVersionSerializer implements PrimitiveSerializer<CallLeaveCallApiVersion> {
  const _$CallLeaveCallApiVersionSerializer();

  static const Map<CallLeaveCallApiVersion, Object> _toWire = <CallLeaveCallApiVersion, Object>{
    CallLeaveCallApiVersion.v4: 'v4',
  };

  static const Map<Object, CallLeaveCallApiVersion> _fromWire = <Object, CallLeaveCallApiVersion>{
    'v4': CallLeaveCallApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallLeaveCallApiVersion];

  @override
  String get wireName => 'CallLeaveCallApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallLeaveCallApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallLeaveCallApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallLeaveCallResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class CallLeaveCallResponseApplicationJson_Ocs
    implements
        $CallLeaveCallResponseApplicationJson_OcsInterface,
        Built<CallLeaveCallResponseApplicationJson_Ocs, CallLeaveCallResponseApplicationJson_OcsBuilder> {
  factory CallLeaveCallResponseApplicationJson_Ocs([
    void Function(CallLeaveCallResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallLeaveCallResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallLeaveCallResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallLeaveCallResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallLeaveCallResponseApplicationJson_Ocs> get serializer =>
      _$callLeaveCallResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallLeaveCallResponseApplicationJsonInterface {
  CallLeaveCallResponseApplicationJson_Ocs get ocs;
}

abstract class CallLeaveCallResponseApplicationJson
    implements
        $CallLeaveCallResponseApplicationJsonInterface,
        Built<CallLeaveCallResponseApplicationJson, CallLeaveCallResponseApplicationJsonBuilder> {
  factory CallLeaveCallResponseApplicationJson([void Function(CallLeaveCallResponseApplicationJsonBuilder)? b]) =
      _$CallLeaveCallResponseApplicationJson;

  // coverage:ignore-start
  const CallLeaveCallResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallLeaveCallResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallLeaveCallResponseApplicationJson> get serializer =>
      _$callLeaveCallResponseApplicationJsonSerializer;
}

class CallRingAttendeeApiVersion extends EnumClass {
  const CallRingAttendeeApiVersion._(super.name);

  static const CallRingAttendeeApiVersion v4 = _$callRingAttendeeApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<CallRingAttendeeApiVersion> get values => _$callRingAttendeeApiVersionValues;
  // coverage:ignore-end

  static CallRingAttendeeApiVersion valueOf(String name) => _$valueOfCallRingAttendeeApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallRingAttendeeApiVersion> get serializer => const _$CallRingAttendeeApiVersionSerializer();
}

class _$CallRingAttendeeApiVersionSerializer implements PrimitiveSerializer<CallRingAttendeeApiVersion> {
  const _$CallRingAttendeeApiVersionSerializer();

  static const Map<CallRingAttendeeApiVersion, Object> _toWire = <CallRingAttendeeApiVersion, Object>{
    CallRingAttendeeApiVersion.v4: 'v4',
  };

  static const Map<Object, CallRingAttendeeApiVersion> _fromWire = <Object, CallRingAttendeeApiVersion>{
    'v4': CallRingAttendeeApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallRingAttendeeApiVersion];

  @override
  String get wireName => 'CallRingAttendeeApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallRingAttendeeApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallRingAttendeeApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallRingAttendeeResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class CallRingAttendeeResponseApplicationJson_Ocs
    implements
        $CallRingAttendeeResponseApplicationJson_OcsInterface,
        Built<CallRingAttendeeResponseApplicationJson_Ocs, CallRingAttendeeResponseApplicationJson_OcsBuilder> {
  factory CallRingAttendeeResponseApplicationJson_Ocs([
    void Function(CallRingAttendeeResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallRingAttendeeResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallRingAttendeeResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallRingAttendeeResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallRingAttendeeResponseApplicationJson_Ocs> get serializer =>
      _$callRingAttendeeResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallRingAttendeeResponseApplicationJsonInterface {
  CallRingAttendeeResponseApplicationJson_Ocs get ocs;
}

abstract class CallRingAttendeeResponseApplicationJson
    implements
        $CallRingAttendeeResponseApplicationJsonInterface,
        Built<CallRingAttendeeResponseApplicationJson, CallRingAttendeeResponseApplicationJsonBuilder> {
  factory CallRingAttendeeResponseApplicationJson([void Function(CallRingAttendeeResponseApplicationJsonBuilder)? b]) =
      _$CallRingAttendeeResponseApplicationJson;

  // coverage:ignore-start
  const CallRingAttendeeResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallRingAttendeeResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallRingAttendeeResponseApplicationJson> get serializer =>
      _$callRingAttendeeResponseApplicationJsonSerializer;
}

class CallSipDialOutApiVersion extends EnumClass {
  const CallSipDialOutApiVersion._(super.name);

  static const CallSipDialOutApiVersion v4 = _$callSipDialOutApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<CallSipDialOutApiVersion> get values => _$callSipDialOutApiVersionValues;
  // coverage:ignore-end

  static CallSipDialOutApiVersion valueOf(String name) => _$valueOfCallSipDialOutApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<CallSipDialOutApiVersion> get serializer => const _$CallSipDialOutApiVersionSerializer();
}

class _$CallSipDialOutApiVersionSerializer implements PrimitiveSerializer<CallSipDialOutApiVersion> {
  const _$CallSipDialOutApiVersionSerializer();

  static const Map<CallSipDialOutApiVersion, Object> _toWire = <CallSipDialOutApiVersion, Object>{
    CallSipDialOutApiVersion.v4: 'v4',
  };

  static const Map<Object, CallSipDialOutApiVersion> _fromWire = <Object, CallSipDialOutApiVersion>{
    'v4': CallSipDialOutApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [CallSipDialOutApiVersion];

  @override
  String get wireName => 'CallSipDialOutApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CallSipDialOutApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CallSipDialOutApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CallSipDialOutResponseApplicationJson_Ocs_DataInterface {
  String? get error;
  String? get message;
}

abstract class CallSipDialOutResponseApplicationJson_Ocs_Data
    implements
        $CallSipDialOutResponseApplicationJson_Ocs_DataInterface,
        Built<CallSipDialOutResponseApplicationJson_Ocs_Data, CallSipDialOutResponseApplicationJson_Ocs_DataBuilder> {
  factory CallSipDialOutResponseApplicationJson_Ocs_Data([
    void Function(CallSipDialOutResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$CallSipDialOutResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const CallSipDialOutResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallSipDialOutResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallSipDialOutResponseApplicationJson_Ocs_Data> get serializer =>
      _$callSipDialOutResponseApplicationJsonOcsDataSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallSipDialOutResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  CallSipDialOutResponseApplicationJson_Ocs_Data get data;
}

abstract class CallSipDialOutResponseApplicationJson_Ocs
    implements
        $CallSipDialOutResponseApplicationJson_OcsInterface,
        Built<CallSipDialOutResponseApplicationJson_Ocs, CallSipDialOutResponseApplicationJson_OcsBuilder> {
  factory CallSipDialOutResponseApplicationJson_Ocs([
    void Function(CallSipDialOutResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CallSipDialOutResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CallSipDialOutResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallSipDialOutResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallSipDialOutResponseApplicationJson_Ocs> get serializer =>
      _$callSipDialOutResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CallSipDialOutResponseApplicationJsonInterface {
  CallSipDialOutResponseApplicationJson_Ocs get ocs;
}

abstract class CallSipDialOutResponseApplicationJson
    implements
        $CallSipDialOutResponseApplicationJsonInterface,
        Built<CallSipDialOutResponseApplicationJson, CallSipDialOutResponseApplicationJsonBuilder> {
  factory CallSipDialOutResponseApplicationJson([void Function(CallSipDialOutResponseApplicationJsonBuilder)? b]) =
      _$CallSipDialOutResponseApplicationJson;

  // coverage:ignore-start
  const CallSipDialOutResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CallSipDialOutResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CallSipDialOutResponseApplicationJson> get serializer =>
      _$callSipDialOutResponseApplicationJsonSerializer;
}

class CertificateGetCertificateExpirationApiVersion extends EnumClass {
  const CertificateGetCertificateExpirationApiVersion._(super.name);

  static const CertificateGetCertificateExpirationApiVersion v1 = _$certificateGetCertificateExpirationApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<CertificateGetCertificateExpirationApiVersion> get values =>
      _$certificateGetCertificateExpirationApiVersionValues;
  // coverage:ignore-end

  static CertificateGetCertificateExpirationApiVersion valueOf(String name) =>
      _$valueOfCertificateGetCertificateExpirationApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<CertificateGetCertificateExpirationApiVersion> get serializer =>
      const _$CertificateGetCertificateExpirationApiVersionSerializer();
}

class _$CertificateGetCertificateExpirationApiVersionSerializer
    implements PrimitiveSerializer<CertificateGetCertificateExpirationApiVersion> {
  const _$CertificateGetCertificateExpirationApiVersionSerializer();

  static const Map<CertificateGetCertificateExpirationApiVersion, Object> _toWire =
      <CertificateGetCertificateExpirationApiVersion, Object>{
    CertificateGetCertificateExpirationApiVersion.v1: 'v1',
  };

  static const Map<Object, CertificateGetCertificateExpirationApiVersion> _fromWire =
      <Object, CertificateGetCertificateExpirationApiVersion>{
    'v1': CertificateGetCertificateExpirationApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [CertificateGetCertificateExpirationApiVersion];

  @override
  String get wireName => 'CertificateGetCertificateExpirationApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    CertificateGetCertificateExpirationApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  CertificateGetCertificateExpirationApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterface {
  @BuiltValueField(wireName: 'expiration_in_days')
  int? get expirationInDays;
}

abstract class CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data
    implements
        $CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataInterface,
        Built<CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data,
            CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder> {
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data([
    void Function(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data> get serializer =>
      _$certificateGetCertificateExpirationResponseApplicationJsonOcsDataSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CertificateGetCertificateExpirationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data get data;
}

abstract class CertificateGetCertificateExpirationResponseApplicationJson_Ocs
    implements
        $CertificateGetCertificateExpirationResponseApplicationJson_OcsInterface,
        Built<CertificateGetCertificateExpirationResponseApplicationJson_Ocs,
            CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder> {
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs([
    void Function(CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$CertificateGetCertificateExpirationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const CertificateGetCertificateExpirationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CertificateGetCertificateExpirationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CertificateGetCertificateExpirationResponseApplicationJson_Ocs> get serializer =>
      _$certificateGetCertificateExpirationResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $CertificateGetCertificateExpirationResponseApplicationJsonInterface {
  CertificateGetCertificateExpirationResponseApplicationJson_Ocs get ocs;
}

abstract class CertificateGetCertificateExpirationResponseApplicationJson
    implements
        $CertificateGetCertificateExpirationResponseApplicationJsonInterface,
        Built<CertificateGetCertificateExpirationResponseApplicationJson,
            CertificateGetCertificateExpirationResponseApplicationJsonBuilder> {
  factory CertificateGetCertificateExpirationResponseApplicationJson([
    void Function(CertificateGetCertificateExpirationResponseApplicationJsonBuilder)? b,
  ]) = _$CertificateGetCertificateExpirationResponseApplicationJson;

  // coverage:ignore-start
  const CertificateGetCertificateExpirationResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory CertificateGetCertificateExpirationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<CertificateGetCertificateExpirationResponseApplicationJson> get serializer =>
      _$certificateGetCertificateExpirationResponseApplicationJsonSerializer;
}

class ChatReceiveMessagesLookIntoFuture extends EnumClass {
  const ChatReceiveMessagesLookIntoFuture._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesLookIntoFuture $0 = _$chatReceiveMessagesLookIntoFuture$0;

  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesLookIntoFuture $1 = _$chatReceiveMessagesLookIntoFuture$1;

  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesLookIntoFuture> get values => _$chatReceiveMessagesLookIntoFutureValues;
  // coverage:ignore-end

  static ChatReceiveMessagesLookIntoFuture valueOf(String name) => _$valueOfChatReceiveMessagesLookIntoFuture(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesLookIntoFuture> get serializer =>
      const _$ChatReceiveMessagesLookIntoFutureSerializer();
}

class _$ChatReceiveMessagesLookIntoFutureSerializer implements PrimitiveSerializer<ChatReceiveMessagesLookIntoFuture> {
  const _$ChatReceiveMessagesLookIntoFutureSerializer();

  static const Map<ChatReceiveMessagesLookIntoFuture, Object> _toWire = <ChatReceiveMessagesLookIntoFuture, Object>{
    ChatReceiveMessagesLookIntoFuture.$0: 0,
    ChatReceiveMessagesLookIntoFuture.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesLookIntoFuture> _fromWire = <Object, ChatReceiveMessagesLookIntoFuture>{
    0: ChatReceiveMessagesLookIntoFuture.$0,
    1: ChatReceiveMessagesLookIntoFuture.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesLookIntoFuture];

  @override
  String get wireName => 'ChatReceiveMessagesLookIntoFuture';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesLookIntoFuture object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesLookIntoFuture deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesSetReadMarker extends EnumClass {
  const ChatReceiveMessagesSetReadMarker._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesSetReadMarker $0 = _$chatReceiveMessagesSetReadMarker$0;

  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesSetReadMarker $1 = _$chatReceiveMessagesSetReadMarker$1;

  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesSetReadMarker> get values => _$chatReceiveMessagesSetReadMarkerValues;
  // coverage:ignore-end

  static ChatReceiveMessagesSetReadMarker valueOf(String name) => _$valueOfChatReceiveMessagesSetReadMarker(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesSetReadMarker> get serializer =>
      const _$ChatReceiveMessagesSetReadMarkerSerializer();
}

class _$ChatReceiveMessagesSetReadMarkerSerializer implements PrimitiveSerializer<ChatReceiveMessagesSetReadMarker> {
  const _$ChatReceiveMessagesSetReadMarkerSerializer();

  static const Map<ChatReceiveMessagesSetReadMarker, Object> _toWire = <ChatReceiveMessagesSetReadMarker, Object>{
    ChatReceiveMessagesSetReadMarker.$0: 0,
    ChatReceiveMessagesSetReadMarker.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesSetReadMarker> _fromWire = <Object, ChatReceiveMessagesSetReadMarker>{
    0: ChatReceiveMessagesSetReadMarker.$0,
    1: ChatReceiveMessagesSetReadMarker.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesSetReadMarker];

  @override
  String get wireName => 'ChatReceiveMessagesSetReadMarker';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesSetReadMarker object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesSetReadMarker deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesIncludeLastKnown extends EnumClass {
  const ChatReceiveMessagesIncludeLastKnown._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesIncludeLastKnown $0 = _$chatReceiveMessagesIncludeLastKnown$0;

  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesIncludeLastKnown $1 = _$chatReceiveMessagesIncludeLastKnown$1;

  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesIncludeLastKnown> get values => _$chatReceiveMessagesIncludeLastKnownValues;
  // coverage:ignore-end

  static ChatReceiveMessagesIncludeLastKnown valueOf(String name) => _$valueOfChatReceiveMessagesIncludeLastKnown(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesIncludeLastKnown> get serializer =>
      const _$ChatReceiveMessagesIncludeLastKnownSerializer();
}

class _$ChatReceiveMessagesIncludeLastKnownSerializer
    implements PrimitiveSerializer<ChatReceiveMessagesIncludeLastKnown> {
  const _$ChatReceiveMessagesIncludeLastKnownSerializer();

  static const Map<ChatReceiveMessagesIncludeLastKnown, Object> _toWire = <ChatReceiveMessagesIncludeLastKnown, Object>{
    ChatReceiveMessagesIncludeLastKnown.$0: 0,
    ChatReceiveMessagesIncludeLastKnown.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesIncludeLastKnown> _fromWire =
      <Object, ChatReceiveMessagesIncludeLastKnown>{
    0: ChatReceiveMessagesIncludeLastKnown.$0,
    1: ChatReceiveMessagesIncludeLastKnown.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesIncludeLastKnown];

  @override
  String get wireName => 'ChatReceiveMessagesIncludeLastKnown';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesIncludeLastKnown object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesIncludeLastKnown deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesNoStatusUpdate extends EnumClass {
  const ChatReceiveMessagesNoStatusUpdate._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesNoStatusUpdate $0 = _$chatReceiveMessagesNoStatusUpdate$0;

  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesNoStatusUpdate $1 = _$chatReceiveMessagesNoStatusUpdate$1;

  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesNoStatusUpdate> get values => _$chatReceiveMessagesNoStatusUpdateValues;
  // coverage:ignore-end

  static ChatReceiveMessagesNoStatusUpdate valueOf(String name) => _$valueOfChatReceiveMessagesNoStatusUpdate(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesNoStatusUpdate> get serializer =>
      const _$ChatReceiveMessagesNoStatusUpdateSerializer();
}

class _$ChatReceiveMessagesNoStatusUpdateSerializer implements PrimitiveSerializer<ChatReceiveMessagesNoStatusUpdate> {
  const _$ChatReceiveMessagesNoStatusUpdateSerializer();

  static const Map<ChatReceiveMessagesNoStatusUpdate, Object> _toWire = <ChatReceiveMessagesNoStatusUpdate, Object>{
    ChatReceiveMessagesNoStatusUpdate.$0: 0,
    ChatReceiveMessagesNoStatusUpdate.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesNoStatusUpdate> _fromWire = <Object, ChatReceiveMessagesNoStatusUpdate>{
    0: ChatReceiveMessagesNoStatusUpdate.$0,
    1: ChatReceiveMessagesNoStatusUpdate.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesNoStatusUpdate];

  @override
  String get wireName => 'ChatReceiveMessagesNoStatusUpdate';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesNoStatusUpdate object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesNoStatusUpdate deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesMarkNotificationsAsRead extends EnumClass {
  const ChatReceiveMessagesMarkNotificationsAsRead._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const ChatReceiveMessagesMarkNotificationsAsRead $0 = _$chatReceiveMessagesMarkNotificationsAsRead$0;

  @BuiltValueEnumConst(wireName: '1')
  static const ChatReceiveMessagesMarkNotificationsAsRead $1 = _$chatReceiveMessagesMarkNotificationsAsRead$1;

  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesMarkNotificationsAsRead> get values =>
      _$chatReceiveMessagesMarkNotificationsAsReadValues;
  // coverage:ignore-end

  static ChatReceiveMessagesMarkNotificationsAsRead valueOf(String name) =>
      _$valueOfChatReceiveMessagesMarkNotificationsAsRead(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesMarkNotificationsAsRead> get serializer =>
      const _$ChatReceiveMessagesMarkNotificationsAsReadSerializer();
}

class _$ChatReceiveMessagesMarkNotificationsAsReadSerializer
    implements PrimitiveSerializer<ChatReceiveMessagesMarkNotificationsAsRead> {
  const _$ChatReceiveMessagesMarkNotificationsAsReadSerializer();

  static const Map<ChatReceiveMessagesMarkNotificationsAsRead, Object> _toWire =
      <ChatReceiveMessagesMarkNotificationsAsRead, Object>{
    ChatReceiveMessagesMarkNotificationsAsRead.$0: 0,
    ChatReceiveMessagesMarkNotificationsAsRead.$1: 1,
  };

  static const Map<Object, ChatReceiveMessagesMarkNotificationsAsRead> _fromWire =
      <Object, ChatReceiveMessagesMarkNotificationsAsRead>{
    0: ChatReceiveMessagesMarkNotificationsAsRead.$0,
    1: ChatReceiveMessagesMarkNotificationsAsRead.$1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesMarkNotificationsAsRead];

  @override
  String get wireName => 'ChatReceiveMessagesMarkNotificationsAsRead';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesMarkNotificationsAsRead object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesMarkNotificationsAsRead deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class ChatReceiveMessagesApiVersion extends EnumClass {
  const ChatReceiveMessagesApiVersion._(super.name);

  static const ChatReceiveMessagesApiVersion v1 = _$chatReceiveMessagesApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatReceiveMessagesApiVersion> get values => _$chatReceiveMessagesApiVersionValues;
  // coverage:ignore-end

  static ChatReceiveMessagesApiVersion valueOf(String name) => _$valueOfChatReceiveMessagesApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatReceiveMessagesApiVersion> get serializer => const _$ChatReceiveMessagesApiVersionSerializer();
}

class _$ChatReceiveMessagesApiVersionSerializer implements PrimitiveSerializer<ChatReceiveMessagesApiVersion> {
  const _$ChatReceiveMessagesApiVersionSerializer();

  static const Map<ChatReceiveMessagesApiVersion, Object> _toWire = <ChatReceiveMessagesApiVersion, Object>{
    ChatReceiveMessagesApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatReceiveMessagesApiVersion> _fromWire = <Object, ChatReceiveMessagesApiVersion>{
    'v1': ChatReceiveMessagesApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatReceiveMessagesApiVersion];

  @override
  String get wireName => 'ChatReceiveMessagesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatReceiveMessagesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatReceiveMessagesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatReceiveMessagesHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueField(wireName: 'x-chat-last-given')
  String? get xChatLastGiven;
}

abstract class ChatChatReceiveMessagesHeaders
    implements
        $ChatChatReceiveMessagesHeadersInterface,
        Built<ChatChatReceiveMessagesHeaders, ChatChatReceiveMessagesHeadersBuilder> {
  factory ChatChatReceiveMessagesHeaders([void Function(ChatChatReceiveMessagesHeadersBuilder)? b]) =
      _$ChatChatReceiveMessagesHeaders;

  // coverage:ignore-start
  const ChatChatReceiveMessagesHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatReceiveMessagesHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatReceiveMessagesHeaders> get serializer => _$chatChatReceiveMessagesHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMessageWithParent_1Interface {
  ChatMessage? get parent;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMessageWithParentInterface
    implements $ChatMessageInterface, $ChatMessageWithParent_1Interface {}

abstract class ChatMessageWithParent
    implements $ChatMessageWithParentInterface, Built<ChatMessageWithParent, ChatMessageWithParentBuilder> {
  factory ChatMessageWithParent([void Function(ChatMessageWithParentBuilder)? b]) = _$ChatMessageWithParent;

  // coverage:ignore-start
  const ChatMessageWithParent._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatMessageWithParent.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatMessageWithParent> get serializer => _$chatMessageWithParentSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatReceiveMessagesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMessageWithParent> get data;
}

abstract class ChatReceiveMessagesResponseApplicationJson_Ocs
    implements
        $ChatReceiveMessagesResponseApplicationJson_OcsInterface,
        Built<ChatReceiveMessagesResponseApplicationJson_Ocs, ChatReceiveMessagesResponseApplicationJson_OcsBuilder> {
  factory ChatReceiveMessagesResponseApplicationJson_Ocs([
    void Function(ChatReceiveMessagesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatReceiveMessagesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatReceiveMessagesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatReceiveMessagesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatReceiveMessagesResponseApplicationJson_Ocs> get serializer =>
      _$chatReceiveMessagesResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatReceiveMessagesResponseApplicationJsonInterface {
  ChatReceiveMessagesResponseApplicationJson_Ocs get ocs;
}

abstract class ChatReceiveMessagesResponseApplicationJson
    implements
        $ChatReceiveMessagesResponseApplicationJsonInterface,
        Built<ChatReceiveMessagesResponseApplicationJson, ChatReceiveMessagesResponseApplicationJsonBuilder> {
  factory ChatReceiveMessagesResponseApplicationJson([
    void Function(ChatReceiveMessagesResponseApplicationJsonBuilder)? b,
  ]) = _$ChatReceiveMessagesResponseApplicationJson;

  // coverage:ignore-start
  const ChatReceiveMessagesResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatReceiveMessagesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatReceiveMessagesResponseApplicationJson> get serializer =>
      _$chatReceiveMessagesResponseApplicationJsonSerializer;
}

class ChatSendMessageApiVersion extends EnumClass {
  const ChatSendMessageApiVersion._(super.name);

  static const ChatSendMessageApiVersion v1 = _$chatSendMessageApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatSendMessageApiVersion> get values => _$chatSendMessageApiVersionValues;
  // coverage:ignore-end

  static ChatSendMessageApiVersion valueOf(String name) => _$valueOfChatSendMessageApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatSendMessageApiVersion> get serializer => const _$ChatSendMessageApiVersionSerializer();
}

class _$ChatSendMessageApiVersionSerializer implements PrimitiveSerializer<ChatSendMessageApiVersion> {
  const _$ChatSendMessageApiVersionSerializer();

  static const Map<ChatSendMessageApiVersion, Object> _toWire = <ChatSendMessageApiVersion, Object>{
    ChatSendMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatSendMessageApiVersion> _fromWire = <Object, ChatSendMessageApiVersion>{
    'v1': ChatSendMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatSendMessageApiVersion];

  @override
  String get wireName => 'ChatSendMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatSendMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatSendMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatSendMessageHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
}

abstract class ChatChatSendMessageHeaders
    implements
        $ChatChatSendMessageHeadersInterface,
        Built<ChatChatSendMessageHeaders, ChatChatSendMessageHeadersBuilder> {
  factory ChatChatSendMessageHeaders([void Function(ChatChatSendMessageHeadersBuilder)? b]) =
      _$ChatChatSendMessageHeaders;

  // coverage:ignore-start
  const ChatChatSendMessageHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatSendMessageHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatSendMessageHeaders> get serializer => _$chatChatSendMessageHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSendMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessageWithParent? get data;
}

abstract class ChatSendMessageResponseApplicationJson_Ocs
    implements
        $ChatSendMessageResponseApplicationJson_OcsInterface,
        Built<ChatSendMessageResponseApplicationJson_Ocs, ChatSendMessageResponseApplicationJson_OcsBuilder> {
  factory ChatSendMessageResponseApplicationJson_Ocs([
    void Function(ChatSendMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatSendMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatSendMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatSendMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatSendMessageResponseApplicationJson_Ocs> get serializer =>
      _$chatSendMessageResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSendMessageResponseApplicationJsonInterface {
  ChatSendMessageResponseApplicationJson_Ocs get ocs;
}

abstract class ChatSendMessageResponseApplicationJson
    implements
        $ChatSendMessageResponseApplicationJsonInterface,
        Built<ChatSendMessageResponseApplicationJson, ChatSendMessageResponseApplicationJsonBuilder> {
  factory ChatSendMessageResponseApplicationJson([void Function(ChatSendMessageResponseApplicationJsonBuilder)? b]) =
      _$ChatSendMessageResponseApplicationJson;

  // coverage:ignore-start
  const ChatSendMessageResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatSendMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatSendMessageResponseApplicationJson> get serializer =>
      _$chatSendMessageResponseApplicationJsonSerializer;
}

class ChatClearHistoryApiVersion extends EnumClass {
  const ChatClearHistoryApiVersion._(super.name);

  static const ChatClearHistoryApiVersion v1 = _$chatClearHistoryApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatClearHistoryApiVersion> get values => _$chatClearHistoryApiVersionValues;
  // coverage:ignore-end

  static ChatClearHistoryApiVersion valueOf(String name) => _$valueOfChatClearHistoryApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatClearHistoryApiVersion> get serializer => const _$ChatClearHistoryApiVersionSerializer();
}

class _$ChatClearHistoryApiVersionSerializer implements PrimitiveSerializer<ChatClearHistoryApiVersion> {
  const _$ChatClearHistoryApiVersionSerializer();

  static const Map<ChatClearHistoryApiVersion, Object> _toWire = <ChatClearHistoryApiVersion, Object>{
    ChatClearHistoryApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatClearHistoryApiVersion> _fromWire = <Object, ChatClearHistoryApiVersion>{
    'v1': ChatClearHistoryApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatClearHistoryApiVersion];

  @override
  String get wireName => 'ChatClearHistoryApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatClearHistoryApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatClearHistoryApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatClearHistoryHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
}

abstract class ChatChatClearHistoryHeaders
    implements
        $ChatChatClearHistoryHeadersInterface,
        Built<ChatChatClearHistoryHeaders, ChatChatClearHistoryHeadersBuilder> {
  factory ChatChatClearHistoryHeaders([void Function(ChatChatClearHistoryHeadersBuilder)? b]) =
      _$ChatChatClearHistoryHeaders;

  // coverage:ignore-start
  const ChatChatClearHistoryHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatClearHistoryHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatClearHistoryHeaders> get serializer => _$chatChatClearHistoryHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatClearHistoryResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessage get data;
}

abstract class ChatClearHistoryResponseApplicationJson_Ocs
    implements
        $ChatClearHistoryResponseApplicationJson_OcsInterface,
        Built<ChatClearHistoryResponseApplicationJson_Ocs, ChatClearHistoryResponseApplicationJson_OcsBuilder> {
  factory ChatClearHistoryResponseApplicationJson_Ocs([
    void Function(ChatClearHistoryResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatClearHistoryResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatClearHistoryResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatClearHistoryResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatClearHistoryResponseApplicationJson_Ocs> get serializer =>
      _$chatClearHistoryResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatClearHistoryResponseApplicationJsonInterface {
  ChatClearHistoryResponseApplicationJson_Ocs get ocs;
}

abstract class ChatClearHistoryResponseApplicationJson
    implements
        $ChatClearHistoryResponseApplicationJsonInterface,
        Built<ChatClearHistoryResponseApplicationJson, ChatClearHistoryResponseApplicationJsonBuilder> {
  factory ChatClearHistoryResponseApplicationJson([void Function(ChatClearHistoryResponseApplicationJsonBuilder)? b]) =
      _$ChatClearHistoryResponseApplicationJson;

  // coverage:ignore-start
  const ChatClearHistoryResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatClearHistoryResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatClearHistoryResponseApplicationJson> get serializer =>
      _$chatClearHistoryResponseApplicationJsonSerializer;
}

class ChatDeleteMessageApiVersion extends EnumClass {
  const ChatDeleteMessageApiVersion._(super.name);

  static const ChatDeleteMessageApiVersion v1 = _$chatDeleteMessageApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatDeleteMessageApiVersion> get values => _$chatDeleteMessageApiVersionValues;
  // coverage:ignore-end

  static ChatDeleteMessageApiVersion valueOf(String name) => _$valueOfChatDeleteMessageApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatDeleteMessageApiVersion> get serializer => const _$ChatDeleteMessageApiVersionSerializer();
}

class _$ChatDeleteMessageApiVersionSerializer implements PrimitiveSerializer<ChatDeleteMessageApiVersion> {
  const _$ChatDeleteMessageApiVersionSerializer();

  static const Map<ChatDeleteMessageApiVersion, Object> _toWire = <ChatDeleteMessageApiVersion, Object>{
    ChatDeleteMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatDeleteMessageApiVersion> _fromWire = <Object, ChatDeleteMessageApiVersion>{
    'v1': ChatDeleteMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatDeleteMessageApiVersion];

  @override
  String get wireName => 'ChatDeleteMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatDeleteMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatDeleteMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatDeleteMessageHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
}

abstract class ChatChatDeleteMessageHeaders
    implements
        $ChatChatDeleteMessageHeadersInterface,
        Built<ChatChatDeleteMessageHeaders, ChatChatDeleteMessageHeadersBuilder> {
  factory ChatChatDeleteMessageHeaders([void Function(ChatChatDeleteMessageHeadersBuilder)? b]) =
      _$ChatChatDeleteMessageHeaders;

  // coverage:ignore-start
  const ChatChatDeleteMessageHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatDeleteMessageHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatDeleteMessageHeaders> get serializer => _$chatChatDeleteMessageHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessageWithParent get data;
}

abstract class ChatDeleteMessageResponseApplicationJson_Ocs
    implements
        $ChatDeleteMessageResponseApplicationJson_OcsInterface,
        Built<ChatDeleteMessageResponseApplicationJson_Ocs, ChatDeleteMessageResponseApplicationJson_OcsBuilder> {
  factory ChatDeleteMessageResponseApplicationJson_Ocs([
    void Function(ChatDeleteMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatDeleteMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatDeleteMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatDeleteMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatDeleteMessageResponseApplicationJson_Ocs> get serializer =>
      _$chatDeleteMessageResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteMessageResponseApplicationJsonInterface {
  ChatDeleteMessageResponseApplicationJson_Ocs get ocs;
}

abstract class ChatDeleteMessageResponseApplicationJson
    implements
        $ChatDeleteMessageResponseApplicationJsonInterface,
        Built<ChatDeleteMessageResponseApplicationJson, ChatDeleteMessageResponseApplicationJsonBuilder> {
  factory ChatDeleteMessageResponseApplicationJson([
    void Function(ChatDeleteMessageResponseApplicationJsonBuilder)? b,
  ]) = _$ChatDeleteMessageResponseApplicationJson;

  // coverage:ignore-start
  const ChatDeleteMessageResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatDeleteMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatDeleteMessageResponseApplicationJson> get serializer =>
      _$chatDeleteMessageResponseApplicationJsonSerializer;
}

class ChatGetMessageContextApiVersion extends EnumClass {
  const ChatGetMessageContextApiVersion._(super.name);

  static const ChatGetMessageContextApiVersion v1 = _$chatGetMessageContextApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatGetMessageContextApiVersion> get values => _$chatGetMessageContextApiVersionValues;
  // coverage:ignore-end

  static ChatGetMessageContextApiVersion valueOf(String name) => _$valueOfChatGetMessageContextApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetMessageContextApiVersion> get serializer =>
      const _$ChatGetMessageContextApiVersionSerializer();
}

class _$ChatGetMessageContextApiVersionSerializer implements PrimitiveSerializer<ChatGetMessageContextApiVersion> {
  const _$ChatGetMessageContextApiVersionSerializer();

  static const Map<ChatGetMessageContextApiVersion, Object> _toWire = <ChatGetMessageContextApiVersion, Object>{
    ChatGetMessageContextApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetMessageContextApiVersion> _fromWire = <Object, ChatGetMessageContextApiVersion>{
    'v1': ChatGetMessageContextApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetMessageContextApiVersion];

  @override
  String get wireName => 'ChatGetMessageContextApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetMessageContextApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetMessageContextApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatGetMessageContextHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
  @BuiltValueField(wireName: 'x-chat-last-given')
  String? get xChatLastGiven;
}

abstract class ChatChatGetMessageContextHeaders
    implements
        $ChatChatGetMessageContextHeadersInterface,
        Built<ChatChatGetMessageContextHeaders, ChatChatGetMessageContextHeadersBuilder> {
  factory ChatChatGetMessageContextHeaders([void Function(ChatChatGetMessageContextHeadersBuilder)? b]) =
      _$ChatChatGetMessageContextHeaders;

  // coverage:ignore-start
  const ChatChatGetMessageContextHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatGetMessageContextHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatGetMessageContextHeaders> get serializer => _$chatChatGetMessageContextHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetMessageContextResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMessageWithParent> get data;
}

abstract class ChatGetMessageContextResponseApplicationJson_Ocs
    implements
        $ChatGetMessageContextResponseApplicationJson_OcsInterface,
        Built<ChatGetMessageContextResponseApplicationJson_Ocs,
            ChatGetMessageContextResponseApplicationJson_OcsBuilder> {
  factory ChatGetMessageContextResponseApplicationJson_Ocs([
    void Function(ChatGetMessageContextResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetMessageContextResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetMessageContextResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetMessageContextResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetMessageContextResponseApplicationJson_Ocs> get serializer =>
      _$chatGetMessageContextResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetMessageContextResponseApplicationJsonInterface {
  ChatGetMessageContextResponseApplicationJson_Ocs get ocs;
}

abstract class ChatGetMessageContextResponseApplicationJson
    implements
        $ChatGetMessageContextResponseApplicationJsonInterface,
        Built<ChatGetMessageContextResponseApplicationJson, ChatGetMessageContextResponseApplicationJsonBuilder> {
  factory ChatGetMessageContextResponseApplicationJson([
    void Function(ChatGetMessageContextResponseApplicationJsonBuilder)? b,
  ]) = _$ChatGetMessageContextResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetMessageContextResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetMessageContextResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetMessageContextResponseApplicationJson> get serializer =>
      _$chatGetMessageContextResponseApplicationJsonSerializer;
}

class ChatGetReminderApiVersion extends EnumClass {
  const ChatGetReminderApiVersion._(super.name);

  static const ChatGetReminderApiVersion v1 = _$chatGetReminderApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatGetReminderApiVersion> get values => _$chatGetReminderApiVersionValues;
  // coverage:ignore-end

  static ChatGetReminderApiVersion valueOf(String name) => _$valueOfChatGetReminderApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetReminderApiVersion> get serializer => const _$ChatGetReminderApiVersionSerializer();
}

class _$ChatGetReminderApiVersionSerializer implements PrimitiveSerializer<ChatGetReminderApiVersion> {
  const _$ChatGetReminderApiVersionSerializer();

  static const Map<ChatGetReminderApiVersion, Object> _toWire = <ChatGetReminderApiVersion, Object>{
    ChatGetReminderApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetReminderApiVersion> _fromWire = <Object, ChatGetReminderApiVersion>{
    'v1': ChatGetReminderApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetReminderApiVersion];

  @override
  String get wireName => 'ChatGetReminderApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetReminderApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetReminderApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatReminderInterface {
  int get messageId;
  int get timestamp;
  String get token;
  String get userId;
}

abstract class ChatReminder implements $ChatReminderInterface, Built<ChatReminder, ChatReminderBuilder> {
  factory ChatReminder([void Function(ChatReminderBuilder)? b]) = _$ChatReminder;

  // coverage:ignore-start
  const ChatReminder._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatReminder.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatReminder> get serializer => _$chatReminderSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetReminderResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatReminder get data;
}

abstract class ChatGetReminderResponseApplicationJson_Ocs
    implements
        $ChatGetReminderResponseApplicationJson_OcsInterface,
        Built<ChatGetReminderResponseApplicationJson_Ocs, ChatGetReminderResponseApplicationJson_OcsBuilder> {
  factory ChatGetReminderResponseApplicationJson_Ocs([
    void Function(ChatGetReminderResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetReminderResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetReminderResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetReminderResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetReminderResponseApplicationJson_Ocs> get serializer =>
      _$chatGetReminderResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetReminderResponseApplicationJsonInterface {
  ChatGetReminderResponseApplicationJson_Ocs get ocs;
}

abstract class ChatGetReminderResponseApplicationJson
    implements
        $ChatGetReminderResponseApplicationJsonInterface,
        Built<ChatGetReminderResponseApplicationJson, ChatGetReminderResponseApplicationJsonBuilder> {
  factory ChatGetReminderResponseApplicationJson([void Function(ChatGetReminderResponseApplicationJsonBuilder)? b]) =
      _$ChatGetReminderResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetReminderResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetReminderResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetReminderResponseApplicationJson> get serializer =>
      _$chatGetReminderResponseApplicationJsonSerializer;
}

class ChatSetReminderApiVersion extends EnumClass {
  const ChatSetReminderApiVersion._(super.name);

  static const ChatSetReminderApiVersion v1 = _$chatSetReminderApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatSetReminderApiVersion> get values => _$chatSetReminderApiVersionValues;
  // coverage:ignore-end

  static ChatSetReminderApiVersion valueOf(String name) => _$valueOfChatSetReminderApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatSetReminderApiVersion> get serializer => const _$ChatSetReminderApiVersionSerializer();
}

class _$ChatSetReminderApiVersionSerializer implements PrimitiveSerializer<ChatSetReminderApiVersion> {
  const _$ChatSetReminderApiVersionSerializer();

  static const Map<ChatSetReminderApiVersion, Object> _toWire = <ChatSetReminderApiVersion, Object>{
    ChatSetReminderApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatSetReminderApiVersion> _fromWire = <Object, ChatSetReminderApiVersion>{
    'v1': ChatSetReminderApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatSetReminderApiVersion];

  @override
  String get wireName => 'ChatSetReminderApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatSetReminderApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatSetReminderApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReminderResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatReminder get data;
}

abstract class ChatSetReminderResponseApplicationJson_Ocs
    implements
        $ChatSetReminderResponseApplicationJson_OcsInterface,
        Built<ChatSetReminderResponseApplicationJson_Ocs, ChatSetReminderResponseApplicationJson_OcsBuilder> {
  factory ChatSetReminderResponseApplicationJson_Ocs([
    void Function(ChatSetReminderResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatSetReminderResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatSetReminderResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatSetReminderResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatSetReminderResponseApplicationJson_Ocs> get serializer =>
      _$chatSetReminderResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReminderResponseApplicationJsonInterface {
  ChatSetReminderResponseApplicationJson_Ocs get ocs;
}

abstract class ChatSetReminderResponseApplicationJson
    implements
        $ChatSetReminderResponseApplicationJsonInterface,
        Built<ChatSetReminderResponseApplicationJson, ChatSetReminderResponseApplicationJsonBuilder> {
  factory ChatSetReminderResponseApplicationJson([void Function(ChatSetReminderResponseApplicationJsonBuilder)? b]) =
      _$ChatSetReminderResponseApplicationJson;

  // coverage:ignore-start
  const ChatSetReminderResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatSetReminderResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatSetReminderResponseApplicationJson> get serializer =>
      _$chatSetReminderResponseApplicationJsonSerializer;
}

class ChatDeleteReminderApiVersion extends EnumClass {
  const ChatDeleteReminderApiVersion._(super.name);

  static const ChatDeleteReminderApiVersion v1 = _$chatDeleteReminderApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatDeleteReminderApiVersion> get values => _$chatDeleteReminderApiVersionValues;
  // coverage:ignore-end

  static ChatDeleteReminderApiVersion valueOf(String name) => _$valueOfChatDeleteReminderApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatDeleteReminderApiVersion> get serializer => const _$ChatDeleteReminderApiVersionSerializer();
}

class _$ChatDeleteReminderApiVersionSerializer implements PrimitiveSerializer<ChatDeleteReminderApiVersion> {
  const _$ChatDeleteReminderApiVersionSerializer();

  static const Map<ChatDeleteReminderApiVersion, Object> _toWire = <ChatDeleteReminderApiVersion, Object>{
    ChatDeleteReminderApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatDeleteReminderApiVersion> _fromWire = <Object, ChatDeleteReminderApiVersion>{
    'v1': ChatDeleteReminderApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatDeleteReminderApiVersion];

  @override
  String get wireName => 'ChatDeleteReminderApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatDeleteReminderApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatDeleteReminderApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteReminderResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class ChatDeleteReminderResponseApplicationJson_Ocs
    implements
        $ChatDeleteReminderResponseApplicationJson_OcsInterface,
        Built<ChatDeleteReminderResponseApplicationJson_Ocs, ChatDeleteReminderResponseApplicationJson_OcsBuilder> {
  factory ChatDeleteReminderResponseApplicationJson_Ocs([
    void Function(ChatDeleteReminderResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatDeleteReminderResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatDeleteReminderResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatDeleteReminderResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatDeleteReminderResponseApplicationJson_Ocs> get serializer =>
      _$chatDeleteReminderResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatDeleteReminderResponseApplicationJsonInterface {
  ChatDeleteReminderResponseApplicationJson_Ocs get ocs;
}

abstract class ChatDeleteReminderResponseApplicationJson
    implements
        $ChatDeleteReminderResponseApplicationJsonInterface,
        Built<ChatDeleteReminderResponseApplicationJson, ChatDeleteReminderResponseApplicationJsonBuilder> {
  factory ChatDeleteReminderResponseApplicationJson([
    void Function(ChatDeleteReminderResponseApplicationJsonBuilder)? b,
  ]) = _$ChatDeleteReminderResponseApplicationJson;

  // coverage:ignore-start
  const ChatDeleteReminderResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatDeleteReminderResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatDeleteReminderResponseApplicationJson> get serializer =>
      _$chatDeleteReminderResponseApplicationJsonSerializer;
}

class ChatSetReadMarkerApiVersion extends EnumClass {
  const ChatSetReadMarkerApiVersion._(super.name);

  static const ChatSetReadMarkerApiVersion v1 = _$chatSetReadMarkerApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatSetReadMarkerApiVersion> get values => _$chatSetReadMarkerApiVersionValues;
  // coverage:ignore-end

  static ChatSetReadMarkerApiVersion valueOf(String name) => _$valueOfChatSetReadMarkerApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatSetReadMarkerApiVersion> get serializer => const _$ChatSetReadMarkerApiVersionSerializer();
}

class _$ChatSetReadMarkerApiVersionSerializer implements PrimitiveSerializer<ChatSetReadMarkerApiVersion> {
  const _$ChatSetReadMarkerApiVersionSerializer();

  static const Map<ChatSetReadMarkerApiVersion, Object> _toWire = <ChatSetReadMarkerApiVersion, Object>{
    ChatSetReadMarkerApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatSetReadMarkerApiVersion> _fromWire = <Object, ChatSetReadMarkerApiVersion>{
    'v1': ChatSetReadMarkerApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatSetReadMarkerApiVersion];

  @override
  String get wireName => 'ChatSetReadMarkerApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatSetReadMarkerApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatSetReadMarkerApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatSetReadMarkerHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
}

abstract class ChatChatSetReadMarkerHeaders
    implements
        $ChatChatSetReadMarkerHeadersInterface,
        Built<ChatChatSetReadMarkerHeaders, ChatChatSetReadMarkerHeadersBuilder> {
  factory ChatChatSetReadMarkerHeaders([void Function(ChatChatSetReadMarkerHeadersBuilder)? b]) =
      _$ChatChatSetReadMarkerHeaders;

  // coverage:ignore-start
  const ChatChatSetReadMarkerHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatSetReadMarkerHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatSetReadMarkerHeaders> get serializer => _$chatChatSetReadMarkerHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReadMarkerResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class ChatSetReadMarkerResponseApplicationJson_Ocs
    implements
        $ChatSetReadMarkerResponseApplicationJson_OcsInterface,
        Built<ChatSetReadMarkerResponseApplicationJson_Ocs, ChatSetReadMarkerResponseApplicationJson_OcsBuilder> {
  factory ChatSetReadMarkerResponseApplicationJson_Ocs([
    void Function(ChatSetReadMarkerResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatSetReadMarkerResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatSetReadMarkerResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatSetReadMarkerResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatSetReadMarkerResponseApplicationJson_Ocs> get serializer =>
      _$chatSetReadMarkerResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatSetReadMarkerResponseApplicationJsonInterface {
  ChatSetReadMarkerResponseApplicationJson_Ocs get ocs;
}

abstract class ChatSetReadMarkerResponseApplicationJson
    implements
        $ChatSetReadMarkerResponseApplicationJsonInterface,
        Built<ChatSetReadMarkerResponseApplicationJson, ChatSetReadMarkerResponseApplicationJsonBuilder> {
  factory ChatSetReadMarkerResponseApplicationJson([
    void Function(ChatSetReadMarkerResponseApplicationJsonBuilder)? b,
  ]) = _$ChatSetReadMarkerResponseApplicationJson;

  // coverage:ignore-start
  const ChatSetReadMarkerResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatSetReadMarkerResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatSetReadMarkerResponseApplicationJson> get serializer =>
      _$chatSetReadMarkerResponseApplicationJsonSerializer;
}

class ChatMarkUnreadApiVersion extends EnumClass {
  const ChatMarkUnreadApiVersion._(super.name);

  static const ChatMarkUnreadApiVersion v1 = _$chatMarkUnreadApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatMarkUnreadApiVersion> get values => _$chatMarkUnreadApiVersionValues;
  // coverage:ignore-end

  static ChatMarkUnreadApiVersion valueOf(String name) => _$valueOfChatMarkUnreadApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatMarkUnreadApiVersion> get serializer => const _$ChatMarkUnreadApiVersionSerializer();
}

class _$ChatMarkUnreadApiVersionSerializer implements PrimitiveSerializer<ChatMarkUnreadApiVersion> {
  const _$ChatMarkUnreadApiVersionSerializer();

  static const Map<ChatMarkUnreadApiVersion, Object> _toWire = <ChatMarkUnreadApiVersion, Object>{
    ChatMarkUnreadApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatMarkUnreadApiVersion> _fromWire = <Object, ChatMarkUnreadApiVersion>{
    'v1': ChatMarkUnreadApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatMarkUnreadApiVersion];

  @override
  String get wireName => 'ChatMarkUnreadApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatMarkUnreadApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatMarkUnreadApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatMarkUnreadHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
}

abstract class ChatChatMarkUnreadHeaders
    implements $ChatChatMarkUnreadHeadersInterface, Built<ChatChatMarkUnreadHeaders, ChatChatMarkUnreadHeadersBuilder> {
  factory ChatChatMarkUnreadHeaders([void Function(ChatChatMarkUnreadHeadersBuilder)? b]) = _$ChatChatMarkUnreadHeaders;

  // coverage:ignore-start
  const ChatChatMarkUnreadHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatMarkUnreadHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatMarkUnreadHeaders> get serializer => _$chatChatMarkUnreadHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMarkUnreadResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class ChatMarkUnreadResponseApplicationJson_Ocs
    implements
        $ChatMarkUnreadResponseApplicationJson_OcsInterface,
        Built<ChatMarkUnreadResponseApplicationJson_Ocs, ChatMarkUnreadResponseApplicationJson_OcsBuilder> {
  factory ChatMarkUnreadResponseApplicationJson_Ocs([
    void Function(ChatMarkUnreadResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatMarkUnreadResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatMarkUnreadResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatMarkUnreadResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatMarkUnreadResponseApplicationJson_Ocs> get serializer =>
      _$chatMarkUnreadResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMarkUnreadResponseApplicationJsonInterface {
  ChatMarkUnreadResponseApplicationJson_Ocs get ocs;
}

abstract class ChatMarkUnreadResponseApplicationJson
    implements
        $ChatMarkUnreadResponseApplicationJsonInterface,
        Built<ChatMarkUnreadResponseApplicationJson, ChatMarkUnreadResponseApplicationJsonBuilder> {
  factory ChatMarkUnreadResponseApplicationJson([void Function(ChatMarkUnreadResponseApplicationJsonBuilder)? b]) =
      _$ChatMarkUnreadResponseApplicationJson;

  // coverage:ignore-start
  const ChatMarkUnreadResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatMarkUnreadResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatMarkUnreadResponseApplicationJson> get serializer =>
      _$chatMarkUnreadResponseApplicationJsonSerializer;
}

class ChatMentionsApiVersion extends EnumClass {
  const ChatMentionsApiVersion._(super.name);

  static const ChatMentionsApiVersion v1 = _$chatMentionsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatMentionsApiVersion> get values => _$chatMentionsApiVersionValues;
  // coverage:ignore-end

  static ChatMentionsApiVersion valueOf(String name) => _$valueOfChatMentionsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatMentionsApiVersion> get serializer => const _$ChatMentionsApiVersionSerializer();
}

class _$ChatMentionsApiVersionSerializer implements PrimitiveSerializer<ChatMentionsApiVersion> {
  const _$ChatMentionsApiVersionSerializer();

  static const Map<ChatMentionsApiVersion, Object> _toWire = <ChatMentionsApiVersion, Object>{
    ChatMentionsApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatMentionsApiVersion> _fromWire = <Object, ChatMentionsApiVersion>{
    'v1': ChatMentionsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatMentionsApiVersion];

  @override
  String get wireName => 'ChatMentionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatMentionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatMentionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMentionSuggestionInterface {
  String get id;
  String get label;
  String get source;
  String? get status;
  int? get statusClearAt;
  String? get statusIcon;
  String? get statusMessage;
}

abstract class ChatMentionSuggestion
    implements $ChatMentionSuggestionInterface, Built<ChatMentionSuggestion, ChatMentionSuggestionBuilder> {
  factory ChatMentionSuggestion([void Function(ChatMentionSuggestionBuilder)? b]) = _$ChatMentionSuggestion;

  // coverage:ignore-start
  const ChatMentionSuggestion._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatMentionSuggestion.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatMentionSuggestion> get serializer => _$chatMentionSuggestionSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMentionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMentionSuggestion> get data;
}

abstract class ChatMentionsResponseApplicationJson_Ocs
    implements
        $ChatMentionsResponseApplicationJson_OcsInterface,
        Built<ChatMentionsResponseApplicationJson_Ocs, ChatMentionsResponseApplicationJson_OcsBuilder> {
  factory ChatMentionsResponseApplicationJson_Ocs([void Function(ChatMentionsResponseApplicationJson_OcsBuilder)? b]) =
      _$ChatMentionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatMentionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatMentionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatMentionsResponseApplicationJson_Ocs> get serializer =>
      _$chatMentionsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatMentionsResponseApplicationJsonInterface {
  ChatMentionsResponseApplicationJson_Ocs get ocs;
}

abstract class ChatMentionsResponseApplicationJson
    implements
        $ChatMentionsResponseApplicationJsonInterface,
        Built<ChatMentionsResponseApplicationJson, ChatMentionsResponseApplicationJsonBuilder> {
  factory ChatMentionsResponseApplicationJson([void Function(ChatMentionsResponseApplicationJsonBuilder)? b]) =
      _$ChatMentionsResponseApplicationJson;

  // coverage:ignore-start
  const ChatMentionsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatMentionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatMentionsResponseApplicationJson> get serializer =>
      _$chatMentionsResponseApplicationJsonSerializer;
}

class ChatGetObjectsSharedInRoomApiVersion extends EnumClass {
  const ChatGetObjectsSharedInRoomApiVersion._(super.name);

  static const ChatGetObjectsSharedInRoomApiVersion v1 = _$chatGetObjectsSharedInRoomApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatGetObjectsSharedInRoomApiVersion> get values => _$chatGetObjectsSharedInRoomApiVersionValues;
  // coverage:ignore-end

  static ChatGetObjectsSharedInRoomApiVersion valueOf(String name) =>
      _$valueOfChatGetObjectsSharedInRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetObjectsSharedInRoomApiVersion> get serializer =>
      const _$ChatGetObjectsSharedInRoomApiVersionSerializer();
}

class _$ChatGetObjectsSharedInRoomApiVersionSerializer
    implements PrimitiveSerializer<ChatGetObjectsSharedInRoomApiVersion> {
  const _$ChatGetObjectsSharedInRoomApiVersionSerializer();

  static const Map<ChatGetObjectsSharedInRoomApiVersion, Object> _toWire =
      <ChatGetObjectsSharedInRoomApiVersion, Object>{
    ChatGetObjectsSharedInRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetObjectsSharedInRoomApiVersion> _fromWire =
      <Object, ChatGetObjectsSharedInRoomApiVersion>{
    'v1': ChatGetObjectsSharedInRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetObjectsSharedInRoomApiVersion];

  @override
  String get wireName => 'ChatGetObjectsSharedInRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetObjectsSharedInRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetObjectsSharedInRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatGetObjectsSharedInRoomHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-given')
  String? get xChatLastGiven;
}

abstract class ChatChatGetObjectsSharedInRoomHeaders
    implements
        $ChatChatGetObjectsSharedInRoomHeadersInterface,
        Built<ChatChatGetObjectsSharedInRoomHeaders, ChatChatGetObjectsSharedInRoomHeadersBuilder> {
  factory ChatChatGetObjectsSharedInRoomHeaders([void Function(ChatChatGetObjectsSharedInRoomHeadersBuilder)? b]) =
      _$ChatChatGetObjectsSharedInRoomHeaders;

  // coverage:ignore-start
  const ChatChatGetObjectsSharedInRoomHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatGetObjectsSharedInRoomHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatGetObjectsSharedInRoomHeaders> get serializer =>
      _$chatChatGetObjectsSharedInRoomHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<ChatMessage> get data;
}

abstract class ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs
    implements
        $ChatGetObjectsSharedInRoomResponseApplicationJson_OcsInterface,
        Built<ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs,
            ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder> {
  factory ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs([
    void Function(ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs> get serializer =>
      _$chatGetObjectsSharedInRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomResponseApplicationJsonInterface {
  ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs get ocs;
}

abstract class ChatGetObjectsSharedInRoomResponseApplicationJson
    implements
        $ChatGetObjectsSharedInRoomResponseApplicationJsonInterface,
        Built<ChatGetObjectsSharedInRoomResponseApplicationJson,
            ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder> {
  factory ChatGetObjectsSharedInRoomResponseApplicationJson([
    void Function(ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetObjectsSharedInRoomResponseApplicationJson> get serializer =>
      _$chatGetObjectsSharedInRoomResponseApplicationJsonSerializer;
}

class ChatShareObjectToChatApiVersion extends EnumClass {
  const ChatShareObjectToChatApiVersion._(super.name);

  static const ChatShareObjectToChatApiVersion v1 = _$chatShareObjectToChatApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatShareObjectToChatApiVersion> get values => _$chatShareObjectToChatApiVersionValues;
  // coverage:ignore-end

  static ChatShareObjectToChatApiVersion valueOf(String name) => _$valueOfChatShareObjectToChatApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatShareObjectToChatApiVersion> get serializer =>
      const _$ChatShareObjectToChatApiVersionSerializer();
}

class _$ChatShareObjectToChatApiVersionSerializer implements PrimitiveSerializer<ChatShareObjectToChatApiVersion> {
  const _$ChatShareObjectToChatApiVersionSerializer();

  static const Map<ChatShareObjectToChatApiVersion, Object> _toWire = <ChatShareObjectToChatApiVersion, Object>{
    ChatShareObjectToChatApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatShareObjectToChatApiVersion> _fromWire = <Object, ChatShareObjectToChatApiVersion>{
    'v1': ChatShareObjectToChatApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatShareObjectToChatApiVersion];

  @override
  String get wireName => 'ChatShareObjectToChatApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatShareObjectToChatApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatShareObjectToChatApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatChatShareObjectToChatHeadersInterface {
  @BuiltValueField(wireName: 'x-chat-last-common-read')
  String? get xChatLastCommonRead;
}

abstract class ChatChatShareObjectToChatHeaders
    implements
        $ChatChatShareObjectToChatHeadersInterface,
        Built<ChatChatShareObjectToChatHeaders, ChatChatShareObjectToChatHeadersBuilder> {
  factory ChatChatShareObjectToChatHeaders([void Function(ChatChatShareObjectToChatHeadersBuilder)? b]) =
      _$ChatChatShareObjectToChatHeaders;

  // coverage:ignore-start
  const ChatChatShareObjectToChatHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatChatShareObjectToChatHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatChatShareObjectToChatHeaders> get serializer => _$chatChatShareObjectToChatHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatShareObjectToChatResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  ChatMessageWithParent? get data;
}

abstract class ChatShareObjectToChatResponseApplicationJson_Ocs
    implements
        $ChatShareObjectToChatResponseApplicationJson_OcsInterface,
        Built<ChatShareObjectToChatResponseApplicationJson_Ocs,
            ChatShareObjectToChatResponseApplicationJson_OcsBuilder> {
  factory ChatShareObjectToChatResponseApplicationJson_Ocs([
    void Function(ChatShareObjectToChatResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatShareObjectToChatResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatShareObjectToChatResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatShareObjectToChatResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatShareObjectToChatResponseApplicationJson_Ocs> get serializer =>
      _$chatShareObjectToChatResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatShareObjectToChatResponseApplicationJsonInterface {
  ChatShareObjectToChatResponseApplicationJson_Ocs get ocs;
}

abstract class ChatShareObjectToChatResponseApplicationJson
    implements
        $ChatShareObjectToChatResponseApplicationJsonInterface,
        Built<ChatShareObjectToChatResponseApplicationJson, ChatShareObjectToChatResponseApplicationJsonBuilder> {
  factory ChatShareObjectToChatResponseApplicationJson([
    void Function(ChatShareObjectToChatResponseApplicationJsonBuilder)? b,
  ]) = _$ChatShareObjectToChatResponseApplicationJson;

  // coverage:ignore-start
  const ChatShareObjectToChatResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatShareObjectToChatResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatShareObjectToChatResponseApplicationJson> get serializer =>
      _$chatShareObjectToChatResponseApplicationJsonSerializer;
}

class ChatGetObjectsSharedInRoomOverviewApiVersion extends EnumClass {
  const ChatGetObjectsSharedInRoomOverviewApiVersion._(super.name);

  static const ChatGetObjectsSharedInRoomOverviewApiVersion v1 = _$chatGetObjectsSharedInRoomOverviewApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ChatGetObjectsSharedInRoomOverviewApiVersion> get values =>
      _$chatGetObjectsSharedInRoomOverviewApiVersionValues;
  // coverage:ignore-end

  static ChatGetObjectsSharedInRoomOverviewApiVersion valueOf(String name) =>
      _$valueOfChatGetObjectsSharedInRoomOverviewApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ChatGetObjectsSharedInRoomOverviewApiVersion> get serializer =>
      const _$ChatGetObjectsSharedInRoomOverviewApiVersionSerializer();
}

class _$ChatGetObjectsSharedInRoomOverviewApiVersionSerializer
    implements PrimitiveSerializer<ChatGetObjectsSharedInRoomOverviewApiVersion> {
  const _$ChatGetObjectsSharedInRoomOverviewApiVersionSerializer();

  static const Map<ChatGetObjectsSharedInRoomOverviewApiVersion, Object> _toWire =
      <ChatGetObjectsSharedInRoomOverviewApiVersion, Object>{
    ChatGetObjectsSharedInRoomOverviewApiVersion.v1: 'v1',
  };

  static const Map<Object, ChatGetObjectsSharedInRoomOverviewApiVersion> _fromWire =
      <Object, ChatGetObjectsSharedInRoomOverviewApiVersion>{
    'v1': ChatGetObjectsSharedInRoomOverviewApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ChatGetObjectsSharedInRoomOverviewApiVersion];

  @override
  String get wireName => 'ChatGetObjectsSharedInRoomOverviewApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ChatGetObjectsSharedInRoomOverviewApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ChatGetObjectsSharedInRoomOverviewApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<ChatMessage>> get data;
}

abstract class ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs
    implements
        $ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsInterface,
        Built<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs,
            ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder> {
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs([
    void Function(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs> get serializer =>
      _$chatGetObjectsSharedInRoomOverviewResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterface {
  ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs get ocs;
}

abstract class ChatGetObjectsSharedInRoomOverviewResponseApplicationJson
    implements
        $ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonInterface,
        Built<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson,
            ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder> {
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson([
    void Function(ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder)? b,
  ]) = _$ChatGetObjectsSharedInRoomOverviewResponseApplicationJson;

  // coverage:ignore-start
  const ChatGetObjectsSharedInRoomOverviewResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ChatGetObjectsSharedInRoomOverviewResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ChatGetObjectsSharedInRoomOverviewResponseApplicationJson> get serializer =>
      _$chatGetObjectsSharedInRoomOverviewResponseApplicationJsonSerializer;
}

class FilesIntegrationGetRoomByFileIdApiVersion extends EnumClass {
  const FilesIntegrationGetRoomByFileIdApiVersion._(super.name);

  static const FilesIntegrationGetRoomByFileIdApiVersion v1 = _$filesIntegrationGetRoomByFileIdApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<FilesIntegrationGetRoomByFileIdApiVersion> get values =>
      _$filesIntegrationGetRoomByFileIdApiVersionValues;
  // coverage:ignore-end

  static FilesIntegrationGetRoomByFileIdApiVersion valueOf(String name) =>
      _$valueOfFilesIntegrationGetRoomByFileIdApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<FilesIntegrationGetRoomByFileIdApiVersion> get serializer =>
      const _$FilesIntegrationGetRoomByFileIdApiVersionSerializer();
}

class _$FilesIntegrationGetRoomByFileIdApiVersionSerializer
    implements PrimitiveSerializer<FilesIntegrationGetRoomByFileIdApiVersion> {
  const _$FilesIntegrationGetRoomByFileIdApiVersionSerializer();

  static const Map<FilesIntegrationGetRoomByFileIdApiVersion, Object> _toWire =
      <FilesIntegrationGetRoomByFileIdApiVersion, Object>{
    FilesIntegrationGetRoomByFileIdApiVersion.v1: 'v1',
  };

  static const Map<Object, FilesIntegrationGetRoomByFileIdApiVersion> _fromWire =
      <Object, FilesIntegrationGetRoomByFileIdApiVersion>{
    'v1': FilesIntegrationGetRoomByFileIdApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [FilesIntegrationGetRoomByFileIdApiVersion];

  @override
  String get wireName => 'FilesIntegrationGetRoomByFileIdApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    FilesIntegrationGetRoomByFileIdApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  FilesIntegrationGetRoomByFileIdApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterface {
  String get token;
}

abstract class FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data
    implements
        $FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataInterface,
        Built<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data,
            FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder> {
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data([
    void Function(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data> get serializer =>
      _$filesIntegrationGetRoomByFileIdResponseApplicationJsonOcsDataSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data get data;
}

abstract class FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs
    implements
        $FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsInterface,
        Built<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs,
            FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder> {
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs([
    void Function(FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs> get serializer =>
      _$filesIntegrationGetRoomByFileIdResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterface {
  FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs get ocs;
}

abstract class FilesIntegrationGetRoomByFileIdResponseApplicationJson
    implements
        $FilesIntegrationGetRoomByFileIdResponseApplicationJsonInterface,
        Built<FilesIntegrationGetRoomByFileIdResponseApplicationJson,
            FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder> {
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson([
    void Function(FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByFileIdResponseApplicationJson;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByFileIdResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory FilesIntegrationGetRoomByFileIdResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<FilesIntegrationGetRoomByFileIdResponseApplicationJson> get serializer =>
      _$filesIntegrationGetRoomByFileIdResponseApplicationJsonSerializer;
}

class FilesIntegrationGetRoomByShareTokenApiVersion extends EnumClass {
  const FilesIntegrationGetRoomByShareTokenApiVersion._(super.name);

  static const FilesIntegrationGetRoomByShareTokenApiVersion v1 = _$filesIntegrationGetRoomByShareTokenApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<FilesIntegrationGetRoomByShareTokenApiVersion> get values =>
      _$filesIntegrationGetRoomByShareTokenApiVersionValues;
  // coverage:ignore-end

  static FilesIntegrationGetRoomByShareTokenApiVersion valueOf(String name) =>
      _$valueOfFilesIntegrationGetRoomByShareTokenApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<FilesIntegrationGetRoomByShareTokenApiVersion> get serializer =>
      const _$FilesIntegrationGetRoomByShareTokenApiVersionSerializer();
}

class _$FilesIntegrationGetRoomByShareTokenApiVersionSerializer
    implements PrimitiveSerializer<FilesIntegrationGetRoomByShareTokenApiVersion> {
  const _$FilesIntegrationGetRoomByShareTokenApiVersionSerializer();

  static const Map<FilesIntegrationGetRoomByShareTokenApiVersion, Object> _toWire =
      <FilesIntegrationGetRoomByShareTokenApiVersion, Object>{
    FilesIntegrationGetRoomByShareTokenApiVersion.v1: 'v1',
  };

  static const Map<Object, FilesIntegrationGetRoomByShareTokenApiVersion> _fromWire =
      <Object, FilesIntegrationGetRoomByShareTokenApiVersion>{
    'v1': FilesIntegrationGetRoomByShareTokenApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [FilesIntegrationGetRoomByShareTokenApiVersion];

  @override
  String get wireName => 'FilesIntegrationGetRoomByShareTokenApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    FilesIntegrationGetRoomByShareTokenApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  FilesIntegrationGetRoomByShareTokenApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterface {
  String get token;
  String get userId;
  String get userDisplayName;
}

abstract class FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data
    implements
        $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataInterface,
        Built<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data,
            FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder> {
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data([
    void Function(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data> get serializer =>
      _$filesIntegrationGetRoomByShareTokenResponseApplicationJsonOcsDataSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data get data;
}

abstract class FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs
    implements
        $FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsInterface,
        Built<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs,
            FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder> {
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs([
    void Function(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs> get serializer =>
      _$filesIntegrationGetRoomByShareTokenResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterface {
  FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs get ocs;
}

abstract class FilesIntegrationGetRoomByShareTokenResponseApplicationJson
    implements
        $FilesIntegrationGetRoomByShareTokenResponseApplicationJsonInterface,
        Built<FilesIntegrationGetRoomByShareTokenResponseApplicationJson,
            FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder> {
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson([
    void Function(FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder)? b,
  ]) = _$FilesIntegrationGetRoomByShareTokenResponseApplicationJson;

  // coverage:ignore-start
  const FilesIntegrationGetRoomByShareTokenResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory FilesIntegrationGetRoomByShareTokenResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<FilesIntegrationGetRoomByShareTokenResponseApplicationJson> get serializer =>
      _$filesIntegrationGetRoomByShareTokenResponseApplicationJsonSerializer;
}

class GuestSetDisplayNameApiVersion extends EnumClass {
  const GuestSetDisplayNameApiVersion._(super.name);

  static const GuestSetDisplayNameApiVersion v1 = _$guestSetDisplayNameApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<GuestSetDisplayNameApiVersion> get values => _$guestSetDisplayNameApiVersionValues;
  // coverage:ignore-end

  static GuestSetDisplayNameApiVersion valueOf(String name) => _$valueOfGuestSetDisplayNameApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<GuestSetDisplayNameApiVersion> get serializer => const _$GuestSetDisplayNameApiVersionSerializer();
}

class _$GuestSetDisplayNameApiVersionSerializer implements PrimitiveSerializer<GuestSetDisplayNameApiVersion> {
  const _$GuestSetDisplayNameApiVersionSerializer();

  static const Map<GuestSetDisplayNameApiVersion, Object> _toWire = <GuestSetDisplayNameApiVersion, Object>{
    GuestSetDisplayNameApiVersion.v1: 'v1',
  };

  static const Map<Object, GuestSetDisplayNameApiVersion> _fromWire = <Object, GuestSetDisplayNameApiVersion>{
    'v1': GuestSetDisplayNameApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [GuestSetDisplayNameApiVersion];

  @override
  String get wireName => 'GuestSetDisplayNameApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    GuestSetDisplayNameApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  GuestSetDisplayNameApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $GuestSetDisplayNameResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class GuestSetDisplayNameResponseApplicationJson_Ocs
    implements
        $GuestSetDisplayNameResponseApplicationJson_OcsInterface,
        Built<GuestSetDisplayNameResponseApplicationJson_Ocs, GuestSetDisplayNameResponseApplicationJson_OcsBuilder> {
  factory GuestSetDisplayNameResponseApplicationJson_Ocs([
    void Function(GuestSetDisplayNameResponseApplicationJson_OcsBuilder)? b,
  ]) = _$GuestSetDisplayNameResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const GuestSetDisplayNameResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory GuestSetDisplayNameResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<GuestSetDisplayNameResponseApplicationJson_Ocs> get serializer =>
      _$guestSetDisplayNameResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $GuestSetDisplayNameResponseApplicationJsonInterface {
  GuestSetDisplayNameResponseApplicationJson_Ocs get ocs;
}

abstract class GuestSetDisplayNameResponseApplicationJson
    implements
        $GuestSetDisplayNameResponseApplicationJsonInterface,
        Built<GuestSetDisplayNameResponseApplicationJson, GuestSetDisplayNameResponseApplicationJsonBuilder> {
  factory GuestSetDisplayNameResponseApplicationJson([
    void Function(GuestSetDisplayNameResponseApplicationJsonBuilder)? b,
  ]) = _$GuestSetDisplayNameResponseApplicationJson;

  // coverage:ignore-start
  const GuestSetDisplayNameResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory GuestSetDisplayNameResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<GuestSetDisplayNameResponseApplicationJson> get serializer =>
      _$guestSetDisplayNameResponseApplicationJsonSerializer;
}

class HostedSignalingServerRequestTrialApiVersion extends EnumClass {
  const HostedSignalingServerRequestTrialApiVersion._(super.name);

  static const HostedSignalingServerRequestTrialApiVersion v1 = _$hostedSignalingServerRequestTrialApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<HostedSignalingServerRequestTrialApiVersion> get values =>
      _$hostedSignalingServerRequestTrialApiVersionValues;
  // coverage:ignore-end

  static HostedSignalingServerRequestTrialApiVersion valueOf(String name) =>
      _$valueOfHostedSignalingServerRequestTrialApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<HostedSignalingServerRequestTrialApiVersion> get serializer =>
      const _$HostedSignalingServerRequestTrialApiVersionSerializer();
}

class _$HostedSignalingServerRequestTrialApiVersionSerializer
    implements PrimitiveSerializer<HostedSignalingServerRequestTrialApiVersion> {
  const _$HostedSignalingServerRequestTrialApiVersionSerializer();

  static const Map<HostedSignalingServerRequestTrialApiVersion, Object> _toWire =
      <HostedSignalingServerRequestTrialApiVersion, Object>{
    HostedSignalingServerRequestTrialApiVersion.v1: 'v1',
  };

  static const Map<Object, HostedSignalingServerRequestTrialApiVersion> _fromWire =
      <Object, HostedSignalingServerRequestTrialApiVersion>{
    'v1': HostedSignalingServerRequestTrialApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [HostedSignalingServerRequestTrialApiVersion];

  @override
  String get wireName => 'HostedSignalingServerRequestTrialApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    HostedSignalingServerRequestTrialApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  HostedSignalingServerRequestTrialApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, JsonObject> get data;
}

abstract class HostedSignalingServerRequestTrialResponseApplicationJson_Ocs
    implements
        $HostedSignalingServerRequestTrialResponseApplicationJson_OcsInterface,
        Built<HostedSignalingServerRequestTrialResponseApplicationJson_Ocs,
            HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder> {
  factory HostedSignalingServerRequestTrialResponseApplicationJson_Ocs([
    void Function(HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder)? b,
  ]) = _$HostedSignalingServerRequestTrialResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const HostedSignalingServerRequestTrialResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory HostedSignalingServerRequestTrialResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<HostedSignalingServerRequestTrialResponseApplicationJson_Ocs> get serializer =>
      _$hostedSignalingServerRequestTrialResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $HostedSignalingServerRequestTrialResponseApplicationJsonInterface {
  HostedSignalingServerRequestTrialResponseApplicationJson_Ocs get ocs;
}

abstract class HostedSignalingServerRequestTrialResponseApplicationJson
    implements
        $HostedSignalingServerRequestTrialResponseApplicationJsonInterface,
        Built<HostedSignalingServerRequestTrialResponseApplicationJson,
            HostedSignalingServerRequestTrialResponseApplicationJsonBuilder> {
  factory HostedSignalingServerRequestTrialResponseApplicationJson([
    void Function(HostedSignalingServerRequestTrialResponseApplicationJsonBuilder)? b,
  ]) = _$HostedSignalingServerRequestTrialResponseApplicationJson;

  // coverage:ignore-start
  const HostedSignalingServerRequestTrialResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory HostedSignalingServerRequestTrialResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<HostedSignalingServerRequestTrialResponseApplicationJson> get serializer =>
      _$hostedSignalingServerRequestTrialResponseApplicationJsonSerializer;
}

class HostedSignalingServerDeleteAccountApiVersion extends EnumClass {
  const HostedSignalingServerDeleteAccountApiVersion._(super.name);

  static const HostedSignalingServerDeleteAccountApiVersion v1 = _$hostedSignalingServerDeleteAccountApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<HostedSignalingServerDeleteAccountApiVersion> get values =>
      _$hostedSignalingServerDeleteAccountApiVersionValues;
  // coverage:ignore-end

  static HostedSignalingServerDeleteAccountApiVersion valueOf(String name) =>
      _$valueOfHostedSignalingServerDeleteAccountApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<HostedSignalingServerDeleteAccountApiVersion> get serializer =>
      const _$HostedSignalingServerDeleteAccountApiVersionSerializer();
}

class _$HostedSignalingServerDeleteAccountApiVersionSerializer
    implements PrimitiveSerializer<HostedSignalingServerDeleteAccountApiVersion> {
  const _$HostedSignalingServerDeleteAccountApiVersionSerializer();

  static const Map<HostedSignalingServerDeleteAccountApiVersion, Object> _toWire =
      <HostedSignalingServerDeleteAccountApiVersion, Object>{
    HostedSignalingServerDeleteAccountApiVersion.v1: 'v1',
  };

  static const Map<Object, HostedSignalingServerDeleteAccountApiVersion> _fromWire =
      <Object, HostedSignalingServerDeleteAccountApiVersion>{
    'v1': HostedSignalingServerDeleteAccountApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [HostedSignalingServerDeleteAccountApiVersion];

  @override
  String get wireName => 'HostedSignalingServerDeleteAccountApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    HostedSignalingServerDeleteAccountApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  HostedSignalingServerDeleteAccountApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $HostedSignalingServerDeleteAccountResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs
    implements
        $HostedSignalingServerDeleteAccountResponseApplicationJson_OcsInterface,
        Built<HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs,
            HostedSignalingServerDeleteAccountResponseApplicationJson_OcsBuilder> {
  factory HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs([
    void Function(HostedSignalingServerDeleteAccountResponseApplicationJson_OcsBuilder)? b,
  ]) = _$HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs> get serializer =>
      _$hostedSignalingServerDeleteAccountResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $HostedSignalingServerDeleteAccountResponseApplicationJsonInterface {
  HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs get ocs;
}

abstract class HostedSignalingServerDeleteAccountResponseApplicationJson
    implements
        $HostedSignalingServerDeleteAccountResponseApplicationJsonInterface,
        Built<HostedSignalingServerDeleteAccountResponseApplicationJson,
            HostedSignalingServerDeleteAccountResponseApplicationJsonBuilder> {
  factory HostedSignalingServerDeleteAccountResponseApplicationJson([
    void Function(HostedSignalingServerDeleteAccountResponseApplicationJsonBuilder)? b,
  ]) = _$HostedSignalingServerDeleteAccountResponseApplicationJson;

  // coverage:ignore-start
  const HostedSignalingServerDeleteAccountResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory HostedSignalingServerDeleteAccountResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<HostedSignalingServerDeleteAccountResponseApplicationJson> get serializer =>
      _$hostedSignalingServerDeleteAccountResponseApplicationJsonSerializer;
}

class MatterbridgeGetBridgeOfRoomApiVersion extends EnumClass {
  const MatterbridgeGetBridgeOfRoomApiVersion._(super.name);

  static const MatterbridgeGetBridgeOfRoomApiVersion v1 = _$matterbridgeGetBridgeOfRoomApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<MatterbridgeGetBridgeOfRoomApiVersion> get values => _$matterbridgeGetBridgeOfRoomApiVersionValues;
  // coverage:ignore-end

  static MatterbridgeGetBridgeOfRoomApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeGetBridgeOfRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeGetBridgeOfRoomApiVersion> get serializer =>
      const _$MatterbridgeGetBridgeOfRoomApiVersionSerializer();
}

class _$MatterbridgeGetBridgeOfRoomApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeGetBridgeOfRoomApiVersion> {
  const _$MatterbridgeGetBridgeOfRoomApiVersionSerializer();

  static const Map<MatterbridgeGetBridgeOfRoomApiVersion, Object> _toWire =
      <MatterbridgeGetBridgeOfRoomApiVersion, Object>{
    MatterbridgeGetBridgeOfRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeGetBridgeOfRoomApiVersion> _fromWire =
      <Object, MatterbridgeGetBridgeOfRoomApiVersion>{
    'v1': MatterbridgeGetBridgeOfRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeGetBridgeOfRoomApiVersion];

  @override
  String get wireName => 'MatterbridgeGetBridgeOfRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeGetBridgeOfRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeGetBridgeOfRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeInterface {
  bool get enabled;
  BuiltList<BuiltMap<String, JsonObject>> get parts;
  int get pid;
}

abstract class Matterbridge implements $MatterbridgeInterface, Built<Matterbridge, MatterbridgeBuilder> {
  factory Matterbridge([void Function(MatterbridgeBuilder)? b]) = _$Matterbridge;

  // coverage:ignore-start
  const Matterbridge._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory Matterbridge.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<Matterbridge> get serializer => _$matterbridgeSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeProcessStateInterface {
  String get log;
  bool get running;
}

abstract class MatterbridgeProcessState
    implements $MatterbridgeProcessStateInterface, Built<MatterbridgeProcessState, MatterbridgeProcessStateBuilder> {
  factory MatterbridgeProcessState([void Function(MatterbridgeProcessStateBuilder)? b]) = _$MatterbridgeProcessState;

  // coverage:ignore-start
  const MatterbridgeProcessState._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeProcessState.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeProcessState> get serializer => _$matterbridgeProcessStateSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeWithProcessStateInterface
    implements $MatterbridgeInterface, $MatterbridgeProcessStateInterface {}

abstract class MatterbridgeWithProcessState
    implements
        $MatterbridgeWithProcessStateInterface,
        Built<MatterbridgeWithProcessState, MatterbridgeWithProcessStateBuilder> {
  factory MatterbridgeWithProcessState([void Function(MatterbridgeWithProcessStateBuilder)? b]) =
      _$MatterbridgeWithProcessState;

  // coverage:ignore-start
  const MatterbridgeWithProcessState._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeWithProcessState.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeWithProcessState> get serializer => _$matterbridgeWithProcessStateSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeWithProcessState get data;
}

abstract class MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs
    implements
        $MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsInterface,
        Built<MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs,
            MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder> {
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs([
    void Function(MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeGetBridgeOfRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterface {
  MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs get ocs;
}

abstract class MatterbridgeGetBridgeOfRoomResponseApplicationJson
    implements
        $MatterbridgeGetBridgeOfRoomResponseApplicationJsonInterface,
        Built<MatterbridgeGetBridgeOfRoomResponseApplicationJson,
            MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder> {
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson([
    void Function(MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeGetBridgeOfRoomResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeGetBridgeOfRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeGetBridgeOfRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeGetBridgeOfRoomResponseApplicationJson> get serializer =>
      _$matterbridgeGetBridgeOfRoomResponseApplicationJsonSerializer;
}

class MatterbridgeEditBridgeOfRoomApiVersion extends EnumClass {
  const MatterbridgeEditBridgeOfRoomApiVersion._(super.name);

  static const MatterbridgeEditBridgeOfRoomApiVersion v1 = _$matterbridgeEditBridgeOfRoomApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<MatterbridgeEditBridgeOfRoomApiVersion> get values => _$matterbridgeEditBridgeOfRoomApiVersionValues;
  // coverage:ignore-end

  static MatterbridgeEditBridgeOfRoomApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeEditBridgeOfRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeEditBridgeOfRoomApiVersion> get serializer =>
      const _$MatterbridgeEditBridgeOfRoomApiVersionSerializer();
}

class _$MatterbridgeEditBridgeOfRoomApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeEditBridgeOfRoomApiVersion> {
  const _$MatterbridgeEditBridgeOfRoomApiVersionSerializer();

  static const Map<MatterbridgeEditBridgeOfRoomApiVersion, Object> _toWire =
      <MatterbridgeEditBridgeOfRoomApiVersion, Object>{
    MatterbridgeEditBridgeOfRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeEditBridgeOfRoomApiVersion> _fromWire =
      <Object, MatterbridgeEditBridgeOfRoomApiVersion>{
    'v1': MatterbridgeEditBridgeOfRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeEditBridgeOfRoomApiVersion];

  @override
  String get wireName => 'MatterbridgeEditBridgeOfRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeEditBridgeOfRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeEditBridgeOfRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeProcessState get data;
}

abstract class MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs
    implements
        $MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsInterface,
        Built<MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs,
            MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder> {
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs([
    void Function(MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeEditBridgeOfRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterface {
  MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs get ocs;
}

abstract class MatterbridgeEditBridgeOfRoomResponseApplicationJson
    implements
        $MatterbridgeEditBridgeOfRoomResponseApplicationJsonInterface,
        Built<MatterbridgeEditBridgeOfRoomResponseApplicationJson,
            MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder> {
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson([
    void Function(MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeEditBridgeOfRoomResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeEditBridgeOfRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeEditBridgeOfRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeEditBridgeOfRoomResponseApplicationJson> get serializer =>
      _$matterbridgeEditBridgeOfRoomResponseApplicationJsonSerializer;
}

class MatterbridgeDeleteBridgeOfRoomApiVersion extends EnumClass {
  const MatterbridgeDeleteBridgeOfRoomApiVersion._(super.name);

  static const MatterbridgeDeleteBridgeOfRoomApiVersion v1 = _$matterbridgeDeleteBridgeOfRoomApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<MatterbridgeDeleteBridgeOfRoomApiVersion> get values =>
      _$matterbridgeDeleteBridgeOfRoomApiVersionValues;
  // coverage:ignore-end

  static MatterbridgeDeleteBridgeOfRoomApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeDeleteBridgeOfRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeDeleteBridgeOfRoomApiVersion> get serializer =>
      const _$MatterbridgeDeleteBridgeOfRoomApiVersionSerializer();
}

class _$MatterbridgeDeleteBridgeOfRoomApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeDeleteBridgeOfRoomApiVersion> {
  const _$MatterbridgeDeleteBridgeOfRoomApiVersionSerializer();

  static const Map<MatterbridgeDeleteBridgeOfRoomApiVersion, Object> _toWire =
      <MatterbridgeDeleteBridgeOfRoomApiVersion, Object>{
    MatterbridgeDeleteBridgeOfRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeDeleteBridgeOfRoomApiVersion> _fromWire =
      <Object, MatterbridgeDeleteBridgeOfRoomApiVersion>{
    'v1': MatterbridgeDeleteBridgeOfRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeDeleteBridgeOfRoomApiVersion];

  @override
  String get wireName => 'MatterbridgeDeleteBridgeOfRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeDeleteBridgeOfRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeDeleteBridgeOfRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  bool get data;
}

abstract class MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs
    implements
        $MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsInterface,
        Built<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs,
            MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder> {
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs([
    void Function(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeDeleteBridgeOfRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterface {
  MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs get ocs;
}

abstract class MatterbridgeDeleteBridgeOfRoomResponseApplicationJson
    implements
        $MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonInterface,
        Built<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson,
            MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder> {
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson([
    void Function(MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeDeleteBridgeOfRoomResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeDeleteBridgeOfRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeDeleteBridgeOfRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeDeleteBridgeOfRoomResponseApplicationJson> get serializer =>
      _$matterbridgeDeleteBridgeOfRoomResponseApplicationJsonSerializer;
}

class MatterbridgeGetBridgeProcessStateApiVersion extends EnumClass {
  const MatterbridgeGetBridgeProcessStateApiVersion._(super.name);

  static const MatterbridgeGetBridgeProcessStateApiVersion v1 = _$matterbridgeGetBridgeProcessStateApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<MatterbridgeGetBridgeProcessStateApiVersion> get values =>
      _$matterbridgeGetBridgeProcessStateApiVersionValues;
  // coverage:ignore-end

  static MatterbridgeGetBridgeProcessStateApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeGetBridgeProcessStateApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeGetBridgeProcessStateApiVersion> get serializer =>
      const _$MatterbridgeGetBridgeProcessStateApiVersionSerializer();
}

class _$MatterbridgeGetBridgeProcessStateApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeGetBridgeProcessStateApiVersion> {
  const _$MatterbridgeGetBridgeProcessStateApiVersionSerializer();

  static const Map<MatterbridgeGetBridgeProcessStateApiVersion, Object> _toWire =
      <MatterbridgeGetBridgeProcessStateApiVersion, Object>{
    MatterbridgeGetBridgeProcessStateApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeGetBridgeProcessStateApiVersion> _fromWire =
      <Object, MatterbridgeGetBridgeProcessStateApiVersion>{
    'v1': MatterbridgeGetBridgeProcessStateApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeGetBridgeProcessStateApiVersion];

  @override
  String get wireName => 'MatterbridgeGetBridgeProcessStateApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeGetBridgeProcessStateApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeGetBridgeProcessStateApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeProcessState get data;
}

abstract class MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs
    implements
        $MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsInterface,
        Built<MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs,
            MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder> {
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs([
    void Function(MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeGetBridgeProcessStateResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterface {
  MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs get ocs;
}

abstract class MatterbridgeGetBridgeProcessStateResponseApplicationJson
    implements
        $MatterbridgeGetBridgeProcessStateResponseApplicationJsonInterface,
        Built<MatterbridgeGetBridgeProcessStateResponseApplicationJson,
            MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder> {
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson([
    void Function(MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeGetBridgeProcessStateResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeGetBridgeProcessStateResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeGetBridgeProcessStateResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeGetBridgeProcessStateResponseApplicationJson> get serializer =>
      _$matterbridgeGetBridgeProcessStateResponseApplicationJsonSerializer;
}

class MatterbridgeSettingsStopAllBridgesApiVersion extends EnumClass {
  const MatterbridgeSettingsStopAllBridgesApiVersion._(super.name);

  static const MatterbridgeSettingsStopAllBridgesApiVersion v1 = _$matterbridgeSettingsStopAllBridgesApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<MatterbridgeSettingsStopAllBridgesApiVersion> get values =>
      _$matterbridgeSettingsStopAllBridgesApiVersionValues;
  // coverage:ignore-end

  static MatterbridgeSettingsStopAllBridgesApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeSettingsStopAllBridgesApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeSettingsStopAllBridgesApiVersion> get serializer =>
      const _$MatterbridgeSettingsStopAllBridgesApiVersionSerializer();
}

class _$MatterbridgeSettingsStopAllBridgesApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeSettingsStopAllBridgesApiVersion> {
  const _$MatterbridgeSettingsStopAllBridgesApiVersionSerializer();

  static const Map<MatterbridgeSettingsStopAllBridgesApiVersion, Object> _toWire =
      <MatterbridgeSettingsStopAllBridgesApiVersion, Object>{
    MatterbridgeSettingsStopAllBridgesApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeSettingsStopAllBridgesApiVersion> _fromWire =
      <Object, MatterbridgeSettingsStopAllBridgesApiVersion>{
    'v1': MatterbridgeSettingsStopAllBridgesApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeSettingsStopAllBridgesApiVersion];

  @override
  String get wireName => 'MatterbridgeSettingsStopAllBridgesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeSettingsStopAllBridgesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeSettingsStopAllBridgesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  bool get data;
}

abstract class MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs
    implements
        $MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsInterface,
        Built<MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs,
            MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder> {
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs([
    void Function(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeSettingsStopAllBridgesResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterface {
  MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs get ocs;
}

abstract class MatterbridgeSettingsStopAllBridgesResponseApplicationJson
    implements
        $MatterbridgeSettingsStopAllBridgesResponseApplicationJsonInterface,
        Built<MatterbridgeSettingsStopAllBridgesResponseApplicationJson,
            MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder> {
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson([
    void Function(MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeSettingsStopAllBridgesResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeSettingsStopAllBridgesResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeSettingsStopAllBridgesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeSettingsStopAllBridgesResponseApplicationJson> get serializer =>
      _$matterbridgeSettingsStopAllBridgesResponseApplicationJsonSerializer;
}

class MatterbridgeSettingsGetMatterbridgeVersionApiVersion extends EnumClass {
  const MatterbridgeSettingsGetMatterbridgeVersionApiVersion._(super.name);

  static const MatterbridgeSettingsGetMatterbridgeVersionApiVersion v1 =
      _$matterbridgeSettingsGetMatterbridgeVersionApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<MatterbridgeSettingsGetMatterbridgeVersionApiVersion> get values =>
      _$matterbridgeSettingsGetMatterbridgeVersionApiVersionValues;
  // coverage:ignore-end

  static MatterbridgeSettingsGetMatterbridgeVersionApiVersion valueOf(String name) =>
      _$valueOfMatterbridgeSettingsGetMatterbridgeVersionApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionApiVersion> get serializer =>
      const _$MatterbridgeSettingsGetMatterbridgeVersionApiVersionSerializer();
}

class _$MatterbridgeSettingsGetMatterbridgeVersionApiVersionSerializer
    implements PrimitiveSerializer<MatterbridgeSettingsGetMatterbridgeVersionApiVersion> {
  const _$MatterbridgeSettingsGetMatterbridgeVersionApiVersionSerializer();

  static const Map<MatterbridgeSettingsGetMatterbridgeVersionApiVersion, Object> _toWire =
      <MatterbridgeSettingsGetMatterbridgeVersionApiVersion, Object>{
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion.v1: 'v1',
  };

  static const Map<Object, MatterbridgeSettingsGetMatterbridgeVersionApiVersion> _fromWire =
      <Object, MatterbridgeSettingsGetMatterbridgeVersionApiVersion>{
    'v1': MatterbridgeSettingsGetMatterbridgeVersionApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [MatterbridgeSettingsGetMatterbridgeVersionApiVersion];

  @override
  String get wireName => 'MatterbridgeSettingsGetMatterbridgeVersionApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    MatterbridgeSettingsGetMatterbridgeVersionApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  MatterbridgeSettingsGetMatterbridgeVersionApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterface {
  String get version;
}

abstract class MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data
    implements
        $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataInterface,
        Built<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data,
            MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder> {
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data([
    void Function(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data.fromJson(
    Map<String, dynamic> json,
  ) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data> get serializer =>
      _$matterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonOcsDataSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data get data;
}

abstract class MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs
    implements
        $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsInterface,
        Built<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs,
            MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder> {
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs([
    void Function(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs> get serializer =>
      _$matterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterface {
  MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs get ocs;
}

abstract class MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson
    implements
        $MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonInterface,
        Built<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson,
            MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder> {
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson([
    void Function(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder)? b,
  ]) = _$MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson;

  // coverage:ignore-start
  const MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson> get serializer =>
      _$matterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonSerializer;
}

class PollCreatePollResultMode extends EnumClass {
  const PollCreatePollResultMode._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const PollCreatePollResultMode $0 = _$pollCreatePollResultMode$0;

  @BuiltValueEnumConst(wireName: '1')
  static const PollCreatePollResultMode $1 = _$pollCreatePollResultMode$1;

  // coverage:ignore-start
  static BuiltSet<PollCreatePollResultMode> get values => _$pollCreatePollResultModeValues;
  // coverage:ignore-end

  static PollCreatePollResultMode valueOf(String name) => _$valueOfPollCreatePollResultMode(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<PollCreatePollResultMode> get serializer => const _$PollCreatePollResultModeSerializer();
}

class _$PollCreatePollResultModeSerializer implements PrimitiveSerializer<PollCreatePollResultMode> {
  const _$PollCreatePollResultModeSerializer();

  static const Map<PollCreatePollResultMode, Object> _toWire = <PollCreatePollResultMode, Object>{
    PollCreatePollResultMode.$0: 0,
    PollCreatePollResultMode.$1: 1,
  };

  static const Map<Object, PollCreatePollResultMode> _fromWire = <Object, PollCreatePollResultMode>{
    0: PollCreatePollResultMode.$0,
    1: PollCreatePollResultMode.$1,
  };

  @override
  Iterable<Type> get types => const [PollCreatePollResultMode];

  @override
  String get wireName => 'PollCreatePollResultMode';

  @override
  Object serialize(
    Serializers serializers,
    PollCreatePollResultMode object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollCreatePollResultMode deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class PollCreatePollApiVersion extends EnumClass {
  const PollCreatePollApiVersion._(super.name);

  static const PollCreatePollApiVersion v1 = _$pollCreatePollApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<PollCreatePollApiVersion> get values => _$pollCreatePollApiVersionValues;
  // coverage:ignore-end

  static PollCreatePollApiVersion valueOf(String name) => _$valueOfPollCreatePollApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<PollCreatePollApiVersion> get serializer => const _$PollCreatePollApiVersionSerializer();
}

class _$PollCreatePollApiVersionSerializer implements PrimitiveSerializer<PollCreatePollApiVersion> {
  const _$PollCreatePollApiVersionSerializer();

  static const Map<PollCreatePollApiVersion, Object> _toWire = <PollCreatePollApiVersion, Object>{
    PollCreatePollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollCreatePollApiVersion> _fromWire = <Object, PollCreatePollApiVersion>{
    'v1': PollCreatePollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollCreatePollApiVersion];

  @override
  String get wireName => 'PollCreatePollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollCreatePollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollCreatePollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollVoteInterface {
  String get actorDisplayName;
  String get actorId;
  String get actorType;
  int get optionId;
}

abstract class PollVote implements $PollVoteInterface, Built<PollVote, PollVoteBuilder> {
  factory PollVote([void Function(PollVoteBuilder)? b]) = _$PollVote;

  // coverage:ignore-start
  const PollVote._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollVote.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollVote> get serializer => _$pollVoteSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PollInterface {
  String get actorDisplayName;
  String get actorId;
  String get actorType;
  BuiltList<PollVote>? get details;
  int get id;
  int get maxVotes;
  int? get numVoters;
  BuiltList<String> get options;
  String get question;
  int get resultMode;
  int get status;
  BuiltList<int>? get votedSelf;
  BuiltMap<String, int>? get votes;
}

abstract class Poll implements $PollInterface, Built<Poll, PollBuilder> {
  factory Poll([void Function(PollBuilder)? b]) = _$Poll;

  // coverage:ignore-start
  const Poll._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory Poll.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<Poll> get serializer => _$pollSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PollCreatePollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
}

abstract class PollCreatePollResponseApplicationJson_Ocs
    implements
        $PollCreatePollResponseApplicationJson_OcsInterface,
        Built<PollCreatePollResponseApplicationJson_Ocs, PollCreatePollResponseApplicationJson_OcsBuilder> {
  factory PollCreatePollResponseApplicationJson_Ocs([
    void Function(PollCreatePollResponseApplicationJson_OcsBuilder)? b,
  ]) = _$PollCreatePollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollCreatePollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollCreatePollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollCreatePollResponseApplicationJson_Ocs> get serializer =>
      _$pollCreatePollResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PollCreatePollResponseApplicationJsonInterface {
  PollCreatePollResponseApplicationJson_Ocs get ocs;
}

abstract class PollCreatePollResponseApplicationJson
    implements
        $PollCreatePollResponseApplicationJsonInterface,
        Built<PollCreatePollResponseApplicationJson, PollCreatePollResponseApplicationJsonBuilder> {
  factory PollCreatePollResponseApplicationJson([void Function(PollCreatePollResponseApplicationJsonBuilder)? b]) =
      _$PollCreatePollResponseApplicationJson;

  // coverage:ignore-start
  const PollCreatePollResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollCreatePollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollCreatePollResponseApplicationJson> get serializer =>
      _$pollCreatePollResponseApplicationJsonSerializer;
}

class PollShowPollApiVersion extends EnumClass {
  const PollShowPollApiVersion._(super.name);

  static const PollShowPollApiVersion v1 = _$pollShowPollApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<PollShowPollApiVersion> get values => _$pollShowPollApiVersionValues;
  // coverage:ignore-end

  static PollShowPollApiVersion valueOf(String name) => _$valueOfPollShowPollApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<PollShowPollApiVersion> get serializer => const _$PollShowPollApiVersionSerializer();
}

class _$PollShowPollApiVersionSerializer implements PrimitiveSerializer<PollShowPollApiVersion> {
  const _$PollShowPollApiVersionSerializer();

  static const Map<PollShowPollApiVersion, Object> _toWire = <PollShowPollApiVersion, Object>{
    PollShowPollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollShowPollApiVersion> _fromWire = <Object, PollShowPollApiVersion>{
    'v1': PollShowPollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollShowPollApiVersion];

  @override
  String get wireName => 'PollShowPollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollShowPollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollShowPollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollShowPollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
}

abstract class PollShowPollResponseApplicationJson_Ocs
    implements
        $PollShowPollResponseApplicationJson_OcsInterface,
        Built<PollShowPollResponseApplicationJson_Ocs, PollShowPollResponseApplicationJson_OcsBuilder> {
  factory PollShowPollResponseApplicationJson_Ocs([void Function(PollShowPollResponseApplicationJson_OcsBuilder)? b]) =
      _$PollShowPollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollShowPollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollShowPollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollShowPollResponseApplicationJson_Ocs> get serializer =>
      _$pollShowPollResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PollShowPollResponseApplicationJsonInterface {
  PollShowPollResponseApplicationJson_Ocs get ocs;
}

abstract class PollShowPollResponseApplicationJson
    implements
        $PollShowPollResponseApplicationJsonInterface,
        Built<PollShowPollResponseApplicationJson, PollShowPollResponseApplicationJsonBuilder> {
  factory PollShowPollResponseApplicationJson([void Function(PollShowPollResponseApplicationJsonBuilder)? b]) =
      _$PollShowPollResponseApplicationJson;

  // coverage:ignore-start
  const PollShowPollResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollShowPollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollShowPollResponseApplicationJson> get serializer =>
      _$pollShowPollResponseApplicationJsonSerializer;
}

class PollVotePollApiVersion extends EnumClass {
  const PollVotePollApiVersion._(super.name);

  static const PollVotePollApiVersion v1 = _$pollVotePollApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<PollVotePollApiVersion> get values => _$pollVotePollApiVersionValues;
  // coverage:ignore-end

  static PollVotePollApiVersion valueOf(String name) => _$valueOfPollVotePollApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<PollVotePollApiVersion> get serializer => const _$PollVotePollApiVersionSerializer();
}

class _$PollVotePollApiVersionSerializer implements PrimitiveSerializer<PollVotePollApiVersion> {
  const _$PollVotePollApiVersionSerializer();

  static const Map<PollVotePollApiVersion, Object> _toWire = <PollVotePollApiVersion, Object>{
    PollVotePollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollVotePollApiVersion> _fromWire = <Object, PollVotePollApiVersion>{
    'v1': PollVotePollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollVotePollApiVersion];

  @override
  String get wireName => 'PollVotePollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollVotePollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollVotePollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollVotePollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
}

abstract class PollVotePollResponseApplicationJson_Ocs
    implements
        $PollVotePollResponseApplicationJson_OcsInterface,
        Built<PollVotePollResponseApplicationJson_Ocs, PollVotePollResponseApplicationJson_OcsBuilder> {
  factory PollVotePollResponseApplicationJson_Ocs([void Function(PollVotePollResponseApplicationJson_OcsBuilder)? b]) =
      _$PollVotePollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollVotePollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollVotePollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollVotePollResponseApplicationJson_Ocs> get serializer =>
      _$pollVotePollResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PollVotePollResponseApplicationJsonInterface {
  PollVotePollResponseApplicationJson_Ocs get ocs;
}

abstract class PollVotePollResponseApplicationJson
    implements
        $PollVotePollResponseApplicationJsonInterface,
        Built<PollVotePollResponseApplicationJson, PollVotePollResponseApplicationJsonBuilder> {
  factory PollVotePollResponseApplicationJson([void Function(PollVotePollResponseApplicationJsonBuilder)? b]) =
      _$PollVotePollResponseApplicationJson;

  // coverage:ignore-start
  const PollVotePollResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollVotePollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollVotePollResponseApplicationJson> get serializer =>
      _$pollVotePollResponseApplicationJsonSerializer;
}

class PollClosePollApiVersion extends EnumClass {
  const PollClosePollApiVersion._(super.name);

  static const PollClosePollApiVersion v1 = _$pollClosePollApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<PollClosePollApiVersion> get values => _$pollClosePollApiVersionValues;
  // coverage:ignore-end

  static PollClosePollApiVersion valueOf(String name) => _$valueOfPollClosePollApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<PollClosePollApiVersion> get serializer => const _$PollClosePollApiVersionSerializer();
}

class _$PollClosePollApiVersionSerializer implements PrimitiveSerializer<PollClosePollApiVersion> {
  const _$PollClosePollApiVersionSerializer();

  static const Map<PollClosePollApiVersion, Object> _toWire = <PollClosePollApiVersion, Object>{
    PollClosePollApiVersion.v1: 'v1',
  };

  static const Map<Object, PollClosePollApiVersion> _fromWire = <Object, PollClosePollApiVersion>{
    'v1': PollClosePollApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PollClosePollApiVersion];

  @override
  String get wireName => 'PollClosePollApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PollClosePollApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PollClosePollApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PollClosePollResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Poll get data;
}

abstract class PollClosePollResponseApplicationJson_Ocs
    implements
        $PollClosePollResponseApplicationJson_OcsInterface,
        Built<PollClosePollResponseApplicationJson_Ocs, PollClosePollResponseApplicationJson_OcsBuilder> {
  factory PollClosePollResponseApplicationJson_Ocs([
    void Function(PollClosePollResponseApplicationJson_OcsBuilder)? b,
  ]) = _$PollClosePollResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PollClosePollResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollClosePollResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollClosePollResponseApplicationJson_Ocs> get serializer =>
      _$pollClosePollResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PollClosePollResponseApplicationJsonInterface {
  PollClosePollResponseApplicationJson_Ocs get ocs;
}

abstract class PollClosePollResponseApplicationJson
    implements
        $PollClosePollResponseApplicationJsonInterface,
        Built<PollClosePollResponseApplicationJson, PollClosePollResponseApplicationJsonBuilder> {
  factory PollClosePollResponseApplicationJson([void Function(PollClosePollResponseApplicationJsonBuilder)? b]) =
      _$PollClosePollResponseApplicationJson;

  // coverage:ignore-start
  const PollClosePollResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PollClosePollResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PollClosePollResponseApplicationJson> get serializer =>
      _$pollClosePollResponseApplicationJsonSerializer;
}

class PublicShareAuthCreateRoomApiVersion extends EnumClass {
  const PublicShareAuthCreateRoomApiVersion._(super.name);

  static const PublicShareAuthCreateRoomApiVersion v1 = _$publicShareAuthCreateRoomApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<PublicShareAuthCreateRoomApiVersion> get values => _$publicShareAuthCreateRoomApiVersionValues;
  // coverage:ignore-end

  static PublicShareAuthCreateRoomApiVersion valueOf(String name) => _$valueOfPublicShareAuthCreateRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<PublicShareAuthCreateRoomApiVersion> get serializer =>
      const _$PublicShareAuthCreateRoomApiVersionSerializer();
}

class _$PublicShareAuthCreateRoomApiVersionSerializer
    implements PrimitiveSerializer<PublicShareAuthCreateRoomApiVersion> {
  const _$PublicShareAuthCreateRoomApiVersionSerializer();

  static const Map<PublicShareAuthCreateRoomApiVersion, Object> _toWire = <PublicShareAuthCreateRoomApiVersion, Object>{
    PublicShareAuthCreateRoomApiVersion.v1: 'v1',
  };

  static const Map<Object, PublicShareAuthCreateRoomApiVersion> _fromWire =
      <Object, PublicShareAuthCreateRoomApiVersion>{
    'v1': PublicShareAuthCreateRoomApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [PublicShareAuthCreateRoomApiVersion];

  @override
  String get wireName => 'PublicShareAuthCreateRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    PublicShareAuthCreateRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  PublicShareAuthCreateRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterface {
  String get token;
  String get name;
  String get displayName;
}

abstract class PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data
    implements
        $PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataInterface,
        Built<PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data,
            PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder> {
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data([
    void Function(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data> get serializer =>
      _$publicShareAuthCreateRoomResponseApplicationJsonOcsDataSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicShareAuthCreateRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data get data;
}

abstract class PublicShareAuthCreateRoomResponseApplicationJson_Ocs
    implements
        $PublicShareAuthCreateRoomResponseApplicationJson_OcsInterface,
        Built<PublicShareAuthCreateRoomResponseApplicationJson_Ocs,
            PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder> {
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs([
    void Function(PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$PublicShareAuthCreateRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const PublicShareAuthCreateRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicShareAuthCreateRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicShareAuthCreateRoomResponseApplicationJson_Ocs> get serializer =>
      _$publicShareAuthCreateRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicShareAuthCreateRoomResponseApplicationJsonInterface {
  PublicShareAuthCreateRoomResponseApplicationJson_Ocs get ocs;
}

abstract class PublicShareAuthCreateRoomResponseApplicationJson
    implements
        $PublicShareAuthCreateRoomResponseApplicationJsonInterface,
        Built<PublicShareAuthCreateRoomResponseApplicationJson,
            PublicShareAuthCreateRoomResponseApplicationJsonBuilder> {
  factory PublicShareAuthCreateRoomResponseApplicationJson([
    void Function(PublicShareAuthCreateRoomResponseApplicationJsonBuilder)? b,
  ]) = _$PublicShareAuthCreateRoomResponseApplicationJson;

  // coverage:ignore-start
  const PublicShareAuthCreateRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicShareAuthCreateRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicShareAuthCreateRoomResponseApplicationJson> get serializer =>
      _$publicShareAuthCreateRoomResponseApplicationJsonSerializer;
}

class ReactionGetReactionsApiVersion extends EnumClass {
  const ReactionGetReactionsApiVersion._(super.name);

  static const ReactionGetReactionsApiVersion v1 = _$reactionGetReactionsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ReactionGetReactionsApiVersion> get values => _$reactionGetReactionsApiVersionValues;
  // coverage:ignore-end

  static ReactionGetReactionsApiVersion valueOf(String name) => _$valueOfReactionGetReactionsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ReactionGetReactionsApiVersion> get serializer =>
      const _$ReactionGetReactionsApiVersionSerializer();
}

class _$ReactionGetReactionsApiVersionSerializer implements PrimitiveSerializer<ReactionGetReactionsApiVersion> {
  const _$ReactionGetReactionsApiVersionSerializer();

  static const Map<ReactionGetReactionsApiVersion, Object> _toWire = <ReactionGetReactionsApiVersion, Object>{
    ReactionGetReactionsApiVersion.v1: 'v1',
  };

  static const Map<Object, ReactionGetReactionsApiVersion> _fromWire = <Object, ReactionGetReactionsApiVersion>{
    'v1': ReactionGetReactionsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ReactionGetReactionsApiVersion];

  @override
  String get wireName => 'ReactionGetReactionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ReactionGetReactionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ReactionGetReactionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionInterface {
  String get actorDisplayName;
  String get actorId;
  String get actorType;
  int get timestamp;
}

abstract class Reaction implements $ReactionInterface, Built<Reaction, ReactionBuilder> {
  factory Reaction([void Function(ReactionBuilder)? b]) = _$Reaction;

  // coverage:ignore-start
  const Reaction._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory Reaction.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<Reaction> get serializer => _$reactionSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionGetReactionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<Reaction>> get data;
}

abstract class ReactionGetReactionsResponseApplicationJson_Ocs
    implements
        $ReactionGetReactionsResponseApplicationJson_OcsInterface,
        Built<ReactionGetReactionsResponseApplicationJson_Ocs, ReactionGetReactionsResponseApplicationJson_OcsBuilder> {
  factory ReactionGetReactionsResponseApplicationJson_Ocs([
    void Function(ReactionGetReactionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReactionGetReactionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReactionGetReactionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ReactionGetReactionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ReactionGetReactionsResponseApplicationJson_Ocs> get serializer =>
      _$reactionGetReactionsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionGetReactionsResponseApplicationJsonInterface {
  ReactionGetReactionsResponseApplicationJson_Ocs get ocs;
}

abstract class ReactionGetReactionsResponseApplicationJson
    implements
        $ReactionGetReactionsResponseApplicationJsonInterface,
        Built<ReactionGetReactionsResponseApplicationJson, ReactionGetReactionsResponseApplicationJsonBuilder> {
  factory ReactionGetReactionsResponseApplicationJson([
    void Function(ReactionGetReactionsResponseApplicationJsonBuilder)? b,
  ]) = _$ReactionGetReactionsResponseApplicationJson;

  // coverage:ignore-start
  const ReactionGetReactionsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ReactionGetReactionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ReactionGetReactionsResponseApplicationJson> get serializer =>
      _$reactionGetReactionsResponseApplicationJsonSerializer;
}

class ReactionReactApiVersion extends EnumClass {
  const ReactionReactApiVersion._(super.name);

  static const ReactionReactApiVersion v1 = _$reactionReactApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ReactionReactApiVersion> get values => _$reactionReactApiVersionValues;
  // coverage:ignore-end

  static ReactionReactApiVersion valueOf(String name) => _$valueOfReactionReactApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ReactionReactApiVersion> get serializer => const _$ReactionReactApiVersionSerializer();
}

class _$ReactionReactApiVersionSerializer implements PrimitiveSerializer<ReactionReactApiVersion> {
  const _$ReactionReactApiVersionSerializer();

  static const Map<ReactionReactApiVersion, Object> _toWire = <ReactionReactApiVersion, Object>{
    ReactionReactApiVersion.v1: 'v1',
  };

  static const Map<Object, ReactionReactApiVersion> _fromWire = <Object, ReactionReactApiVersion>{
    'v1': ReactionReactApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ReactionReactApiVersion];

  @override
  String get wireName => 'ReactionReactApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ReactionReactApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ReactionReactApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionReactResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<Reaction>> get data;
}

abstract class ReactionReactResponseApplicationJson_Ocs
    implements
        $ReactionReactResponseApplicationJson_OcsInterface,
        Built<ReactionReactResponseApplicationJson_Ocs, ReactionReactResponseApplicationJson_OcsBuilder> {
  factory ReactionReactResponseApplicationJson_Ocs([
    void Function(ReactionReactResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReactionReactResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReactionReactResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ReactionReactResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ReactionReactResponseApplicationJson_Ocs> get serializer =>
      _$reactionReactResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionReactResponseApplicationJsonInterface {
  ReactionReactResponseApplicationJson_Ocs get ocs;
}

abstract class ReactionReactResponseApplicationJson
    implements
        $ReactionReactResponseApplicationJsonInterface,
        Built<ReactionReactResponseApplicationJson, ReactionReactResponseApplicationJsonBuilder> {
  factory ReactionReactResponseApplicationJson([void Function(ReactionReactResponseApplicationJsonBuilder)? b]) =
      _$ReactionReactResponseApplicationJson;

  // coverage:ignore-start
  const ReactionReactResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ReactionReactResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ReactionReactResponseApplicationJson> get serializer =>
      _$reactionReactResponseApplicationJsonSerializer;
}

class ReactionDeleteApiVersion extends EnumClass {
  const ReactionDeleteApiVersion._(super.name);

  static const ReactionDeleteApiVersion v1 = _$reactionDeleteApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<ReactionDeleteApiVersion> get values => _$reactionDeleteApiVersionValues;
  // coverage:ignore-end

  static ReactionDeleteApiVersion valueOf(String name) => _$valueOfReactionDeleteApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<ReactionDeleteApiVersion> get serializer => const _$ReactionDeleteApiVersionSerializer();
}

class _$ReactionDeleteApiVersionSerializer implements PrimitiveSerializer<ReactionDeleteApiVersion> {
  const _$ReactionDeleteApiVersionSerializer();

  static const Map<ReactionDeleteApiVersion, Object> _toWire = <ReactionDeleteApiVersion, Object>{
    ReactionDeleteApiVersion.v1: 'v1',
  };

  static const Map<Object, ReactionDeleteApiVersion> _fromWire = <Object, ReactionDeleteApiVersion>{
    'v1': ReactionDeleteApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [ReactionDeleteApiVersion];

  @override
  String get wireName => 'ReactionDeleteApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    ReactionDeleteApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  ReactionDeleteApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionDeleteResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, BuiltList<Reaction>> get data;
}

abstract class ReactionDeleteResponseApplicationJson_Ocs
    implements
        $ReactionDeleteResponseApplicationJson_OcsInterface,
        Built<ReactionDeleteResponseApplicationJson_Ocs, ReactionDeleteResponseApplicationJson_OcsBuilder> {
  factory ReactionDeleteResponseApplicationJson_Ocs([
    void Function(ReactionDeleteResponseApplicationJson_OcsBuilder)? b,
  ]) = _$ReactionDeleteResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const ReactionDeleteResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ReactionDeleteResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ReactionDeleteResponseApplicationJson_Ocs> get serializer =>
      _$reactionDeleteResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ReactionDeleteResponseApplicationJsonInterface {
  ReactionDeleteResponseApplicationJson_Ocs get ocs;
}

abstract class ReactionDeleteResponseApplicationJson
    implements
        $ReactionDeleteResponseApplicationJsonInterface,
        Built<ReactionDeleteResponseApplicationJson, ReactionDeleteResponseApplicationJsonBuilder> {
  factory ReactionDeleteResponseApplicationJson([void Function(ReactionDeleteResponseApplicationJsonBuilder)? b]) =
      _$ReactionDeleteResponseApplicationJson;

  // coverage:ignore-start
  const ReactionDeleteResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory ReactionDeleteResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<ReactionDeleteResponseApplicationJson> get serializer =>
      _$reactionDeleteResponseApplicationJsonSerializer;
}

class RecordingGetWelcomeMessageApiVersion extends EnumClass {
  const RecordingGetWelcomeMessageApiVersion._(super.name);

  static const RecordingGetWelcomeMessageApiVersion v1 = _$recordingGetWelcomeMessageApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<RecordingGetWelcomeMessageApiVersion> get values => _$recordingGetWelcomeMessageApiVersionValues;
  // coverage:ignore-end

  static RecordingGetWelcomeMessageApiVersion valueOf(String name) =>
      _$valueOfRecordingGetWelcomeMessageApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingGetWelcomeMessageApiVersion> get serializer =>
      const _$RecordingGetWelcomeMessageApiVersionSerializer();
}

class _$RecordingGetWelcomeMessageApiVersionSerializer
    implements PrimitiveSerializer<RecordingGetWelcomeMessageApiVersion> {
  const _$RecordingGetWelcomeMessageApiVersionSerializer();

  static const Map<RecordingGetWelcomeMessageApiVersion, Object> _toWire =
      <RecordingGetWelcomeMessageApiVersion, Object>{
    RecordingGetWelcomeMessageApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingGetWelcomeMessageApiVersion> _fromWire =
      <Object, RecordingGetWelcomeMessageApiVersion>{
    'v1': RecordingGetWelcomeMessageApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingGetWelcomeMessageApiVersion];

  @override
  String get wireName => 'RecordingGetWelcomeMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingGetWelcomeMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingGetWelcomeMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterface {
  double get version;
}

abstract class RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data
    implements
        $RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataInterface,
        Built<RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data,
            RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder> {
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data([
    void Function(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data> get serializer =>
      _$recordingGetWelcomeMessageResponseApplicationJsonOcsDataSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingGetWelcomeMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data get data;
}

abstract class RecordingGetWelcomeMessageResponseApplicationJson_Ocs
    implements
        $RecordingGetWelcomeMessageResponseApplicationJson_OcsInterface,
        Built<RecordingGetWelcomeMessageResponseApplicationJson_Ocs,
            RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder> {
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs([
    void Function(RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingGetWelcomeMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingGetWelcomeMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingGetWelcomeMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingGetWelcomeMessageResponseApplicationJson_Ocs> get serializer =>
      _$recordingGetWelcomeMessageResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingGetWelcomeMessageResponseApplicationJsonInterface {
  RecordingGetWelcomeMessageResponseApplicationJson_Ocs get ocs;
}

abstract class RecordingGetWelcomeMessageResponseApplicationJson
    implements
        $RecordingGetWelcomeMessageResponseApplicationJsonInterface,
        Built<RecordingGetWelcomeMessageResponseApplicationJson,
            RecordingGetWelcomeMessageResponseApplicationJsonBuilder> {
  factory RecordingGetWelcomeMessageResponseApplicationJson([
    void Function(RecordingGetWelcomeMessageResponseApplicationJsonBuilder)? b,
  ]) = _$RecordingGetWelcomeMessageResponseApplicationJson;

  // coverage:ignore-start
  const RecordingGetWelcomeMessageResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingGetWelcomeMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingGetWelcomeMessageResponseApplicationJson> get serializer =>
      _$recordingGetWelcomeMessageResponseApplicationJsonSerializer;
}

class RecordingStartApiVersion extends EnumClass {
  const RecordingStartApiVersion._(super.name);

  static const RecordingStartApiVersion v1 = _$recordingStartApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<RecordingStartApiVersion> get values => _$recordingStartApiVersionValues;
  // coverage:ignore-end

  static RecordingStartApiVersion valueOf(String name) => _$valueOfRecordingStartApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingStartApiVersion> get serializer => const _$RecordingStartApiVersionSerializer();
}

class _$RecordingStartApiVersionSerializer implements PrimitiveSerializer<RecordingStartApiVersion> {
  const _$RecordingStartApiVersionSerializer();

  static const Map<RecordingStartApiVersion, Object> _toWire = <RecordingStartApiVersion, Object>{
    RecordingStartApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingStartApiVersion> _fromWire = <Object, RecordingStartApiVersion>{
    'v1': RecordingStartApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingStartApiVersion];

  @override
  String get wireName => 'RecordingStartApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingStartApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingStartApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStartResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RecordingStartResponseApplicationJson_Ocs
    implements
        $RecordingStartResponseApplicationJson_OcsInterface,
        Built<RecordingStartResponseApplicationJson_Ocs, RecordingStartResponseApplicationJson_OcsBuilder> {
  factory RecordingStartResponseApplicationJson_Ocs([
    void Function(RecordingStartResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingStartResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingStartResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingStartResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingStartResponseApplicationJson_Ocs> get serializer =>
      _$recordingStartResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStartResponseApplicationJsonInterface {
  RecordingStartResponseApplicationJson_Ocs get ocs;
}

abstract class RecordingStartResponseApplicationJson
    implements
        $RecordingStartResponseApplicationJsonInterface,
        Built<RecordingStartResponseApplicationJson, RecordingStartResponseApplicationJsonBuilder> {
  factory RecordingStartResponseApplicationJson([void Function(RecordingStartResponseApplicationJsonBuilder)? b]) =
      _$RecordingStartResponseApplicationJson;

  // coverage:ignore-start
  const RecordingStartResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingStartResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingStartResponseApplicationJson> get serializer =>
      _$recordingStartResponseApplicationJsonSerializer;
}

class RecordingStopApiVersion extends EnumClass {
  const RecordingStopApiVersion._(super.name);

  static const RecordingStopApiVersion v1 = _$recordingStopApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<RecordingStopApiVersion> get values => _$recordingStopApiVersionValues;
  // coverage:ignore-end

  static RecordingStopApiVersion valueOf(String name) => _$valueOfRecordingStopApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingStopApiVersion> get serializer => const _$RecordingStopApiVersionSerializer();
}

class _$RecordingStopApiVersionSerializer implements PrimitiveSerializer<RecordingStopApiVersion> {
  const _$RecordingStopApiVersionSerializer();

  static const Map<RecordingStopApiVersion, Object> _toWire = <RecordingStopApiVersion, Object>{
    RecordingStopApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingStopApiVersion> _fromWire = <Object, RecordingStopApiVersion>{
    'v1': RecordingStopApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingStopApiVersion];

  @override
  String get wireName => 'RecordingStopApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingStopApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingStopApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStopResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RecordingStopResponseApplicationJson_Ocs
    implements
        $RecordingStopResponseApplicationJson_OcsInterface,
        Built<RecordingStopResponseApplicationJson_Ocs, RecordingStopResponseApplicationJson_OcsBuilder> {
  factory RecordingStopResponseApplicationJson_Ocs([
    void Function(RecordingStopResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingStopResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingStopResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingStopResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingStopResponseApplicationJson_Ocs> get serializer =>
      _$recordingStopResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStopResponseApplicationJsonInterface {
  RecordingStopResponseApplicationJson_Ocs get ocs;
}

abstract class RecordingStopResponseApplicationJson
    implements
        $RecordingStopResponseApplicationJsonInterface,
        Built<RecordingStopResponseApplicationJson, RecordingStopResponseApplicationJsonBuilder> {
  factory RecordingStopResponseApplicationJson([void Function(RecordingStopResponseApplicationJsonBuilder)? b]) =
      _$RecordingStopResponseApplicationJson;

  // coverage:ignore-start
  const RecordingStopResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingStopResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingStopResponseApplicationJson> get serializer =>
      _$recordingStopResponseApplicationJsonSerializer;
}

class RecordingStoreApiVersion extends EnumClass {
  const RecordingStoreApiVersion._(super.name);

  static const RecordingStoreApiVersion v1 = _$recordingStoreApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<RecordingStoreApiVersion> get values => _$recordingStoreApiVersionValues;
  // coverage:ignore-end

  static RecordingStoreApiVersion valueOf(String name) => _$valueOfRecordingStoreApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingStoreApiVersion> get serializer => const _$RecordingStoreApiVersionSerializer();
}

class _$RecordingStoreApiVersionSerializer implements PrimitiveSerializer<RecordingStoreApiVersion> {
  const _$RecordingStoreApiVersionSerializer();

  static const Map<RecordingStoreApiVersion, Object> _toWire = <RecordingStoreApiVersion, Object>{
    RecordingStoreApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingStoreApiVersion> _fromWire = <Object, RecordingStoreApiVersion>{
    'v1': RecordingStoreApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingStoreApiVersion];

  @override
  String get wireName => 'RecordingStoreApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingStoreApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingStoreApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStoreResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RecordingStoreResponseApplicationJson_Ocs
    implements
        $RecordingStoreResponseApplicationJson_OcsInterface,
        Built<RecordingStoreResponseApplicationJson_Ocs, RecordingStoreResponseApplicationJson_OcsBuilder> {
  factory RecordingStoreResponseApplicationJson_Ocs([
    void Function(RecordingStoreResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingStoreResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingStoreResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingStoreResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingStoreResponseApplicationJson_Ocs> get serializer =>
      _$recordingStoreResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingStoreResponseApplicationJsonInterface {
  RecordingStoreResponseApplicationJson_Ocs get ocs;
}

abstract class RecordingStoreResponseApplicationJson
    implements
        $RecordingStoreResponseApplicationJsonInterface,
        Built<RecordingStoreResponseApplicationJson, RecordingStoreResponseApplicationJsonBuilder> {
  factory RecordingStoreResponseApplicationJson([void Function(RecordingStoreResponseApplicationJsonBuilder)? b]) =
      _$RecordingStoreResponseApplicationJson;

  // coverage:ignore-start
  const RecordingStoreResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingStoreResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingStoreResponseApplicationJson> get serializer =>
      _$recordingStoreResponseApplicationJsonSerializer;
}

class RecordingNotificationDismissApiVersion extends EnumClass {
  const RecordingNotificationDismissApiVersion._(super.name);

  static const RecordingNotificationDismissApiVersion v1 = _$recordingNotificationDismissApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<RecordingNotificationDismissApiVersion> get values => _$recordingNotificationDismissApiVersionValues;
  // coverage:ignore-end

  static RecordingNotificationDismissApiVersion valueOf(String name) =>
      _$valueOfRecordingNotificationDismissApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingNotificationDismissApiVersion> get serializer =>
      const _$RecordingNotificationDismissApiVersionSerializer();
}

class _$RecordingNotificationDismissApiVersionSerializer
    implements PrimitiveSerializer<RecordingNotificationDismissApiVersion> {
  const _$RecordingNotificationDismissApiVersionSerializer();

  static const Map<RecordingNotificationDismissApiVersion, Object> _toWire =
      <RecordingNotificationDismissApiVersion, Object>{
    RecordingNotificationDismissApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingNotificationDismissApiVersion> _fromWire =
      <Object, RecordingNotificationDismissApiVersion>{
    'v1': RecordingNotificationDismissApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingNotificationDismissApiVersion];

  @override
  String get wireName => 'RecordingNotificationDismissApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingNotificationDismissApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingNotificationDismissApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingNotificationDismissResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RecordingNotificationDismissResponseApplicationJson_Ocs
    implements
        $RecordingNotificationDismissResponseApplicationJson_OcsInterface,
        Built<RecordingNotificationDismissResponseApplicationJson_Ocs,
            RecordingNotificationDismissResponseApplicationJson_OcsBuilder> {
  factory RecordingNotificationDismissResponseApplicationJson_Ocs([
    void Function(RecordingNotificationDismissResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingNotificationDismissResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingNotificationDismissResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingNotificationDismissResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingNotificationDismissResponseApplicationJson_Ocs> get serializer =>
      _$recordingNotificationDismissResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingNotificationDismissResponseApplicationJsonInterface {
  RecordingNotificationDismissResponseApplicationJson_Ocs get ocs;
}

abstract class RecordingNotificationDismissResponseApplicationJson
    implements
        $RecordingNotificationDismissResponseApplicationJsonInterface,
        Built<RecordingNotificationDismissResponseApplicationJson,
            RecordingNotificationDismissResponseApplicationJsonBuilder> {
  factory RecordingNotificationDismissResponseApplicationJson([
    void Function(RecordingNotificationDismissResponseApplicationJsonBuilder)? b,
  ]) = _$RecordingNotificationDismissResponseApplicationJson;

  // coverage:ignore-start
  const RecordingNotificationDismissResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingNotificationDismissResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingNotificationDismissResponseApplicationJson> get serializer =>
      _$recordingNotificationDismissResponseApplicationJsonSerializer;
}

class RecordingShareToChatApiVersion extends EnumClass {
  const RecordingShareToChatApiVersion._(super.name);

  static const RecordingShareToChatApiVersion v1 = _$recordingShareToChatApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<RecordingShareToChatApiVersion> get values => _$recordingShareToChatApiVersionValues;
  // coverage:ignore-end

  static RecordingShareToChatApiVersion valueOf(String name) => _$valueOfRecordingShareToChatApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RecordingShareToChatApiVersion> get serializer =>
      const _$RecordingShareToChatApiVersionSerializer();
}

class _$RecordingShareToChatApiVersionSerializer implements PrimitiveSerializer<RecordingShareToChatApiVersion> {
  const _$RecordingShareToChatApiVersionSerializer();

  static const Map<RecordingShareToChatApiVersion, Object> _toWire = <RecordingShareToChatApiVersion, Object>{
    RecordingShareToChatApiVersion.v1: 'v1',
  };

  static const Map<Object, RecordingShareToChatApiVersion> _fromWire = <Object, RecordingShareToChatApiVersion>{
    'v1': RecordingShareToChatApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [RecordingShareToChatApiVersion];

  @override
  String get wireName => 'RecordingShareToChatApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RecordingShareToChatApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RecordingShareToChatApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingShareToChatResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RecordingShareToChatResponseApplicationJson_Ocs
    implements
        $RecordingShareToChatResponseApplicationJson_OcsInterface,
        Built<RecordingShareToChatResponseApplicationJson_Ocs, RecordingShareToChatResponseApplicationJson_OcsBuilder> {
  factory RecordingShareToChatResponseApplicationJson_Ocs([
    void Function(RecordingShareToChatResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RecordingShareToChatResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RecordingShareToChatResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingShareToChatResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingShareToChatResponseApplicationJson_Ocs> get serializer =>
      _$recordingShareToChatResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RecordingShareToChatResponseApplicationJsonInterface {
  RecordingShareToChatResponseApplicationJson_Ocs get ocs;
}

abstract class RecordingShareToChatResponseApplicationJson
    implements
        $RecordingShareToChatResponseApplicationJsonInterface,
        Built<RecordingShareToChatResponseApplicationJson, RecordingShareToChatResponseApplicationJsonBuilder> {
  factory RecordingShareToChatResponseApplicationJson([
    void Function(RecordingShareToChatResponseApplicationJsonBuilder)? b,
  ]) = _$RecordingShareToChatResponseApplicationJson;

  // coverage:ignore-start
  const RecordingShareToChatResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RecordingShareToChatResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RecordingShareToChatResponseApplicationJson> get serializer =>
      _$recordingShareToChatResponseApplicationJsonSerializer;
}

class RoomGetRoomsNoStatusUpdate extends EnumClass {
  const RoomGetRoomsNoStatusUpdate._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomGetRoomsNoStatusUpdate $0 = _$roomGetRoomsNoStatusUpdate$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomGetRoomsNoStatusUpdate $1 = _$roomGetRoomsNoStatusUpdate$1;

  // coverage:ignore-start
  static BuiltSet<RoomGetRoomsNoStatusUpdate> get values => _$roomGetRoomsNoStatusUpdateValues;
  // coverage:ignore-end

  static RoomGetRoomsNoStatusUpdate valueOf(String name) => _$valueOfRoomGetRoomsNoStatusUpdate(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetRoomsNoStatusUpdate> get serializer => const _$RoomGetRoomsNoStatusUpdateSerializer();
}

class _$RoomGetRoomsNoStatusUpdateSerializer implements PrimitiveSerializer<RoomGetRoomsNoStatusUpdate> {
  const _$RoomGetRoomsNoStatusUpdateSerializer();

  static const Map<RoomGetRoomsNoStatusUpdate, Object> _toWire = <RoomGetRoomsNoStatusUpdate, Object>{
    RoomGetRoomsNoStatusUpdate.$0: 0,
    RoomGetRoomsNoStatusUpdate.$1: 1,
  };

  static const Map<Object, RoomGetRoomsNoStatusUpdate> _fromWire = <Object, RoomGetRoomsNoStatusUpdate>{
    0: RoomGetRoomsNoStatusUpdate.$0,
    1: RoomGetRoomsNoStatusUpdate.$1,
  };

  @override
  Iterable<Type> get types => const [RoomGetRoomsNoStatusUpdate];

  @override
  String get wireName => 'RoomGetRoomsNoStatusUpdate';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetRoomsNoStatusUpdate object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetRoomsNoStatusUpdate deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomGetRoomsApiVersion extends EnumClass {
  const RoomGetRoomsApiVersion._(super.name);

  static const RoomGetRoomsApiVersion v4 = _$roomGetRoomsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomGetRoomsApiVersion> get values => _$roomGetRoomsApiVersionValues;
  // coverage:ignore-end

  static RoomGetRoomsApiVersion valueOf(String name) => _$valueOfRoomGetRoomsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetRoomsApiVersion> get serializer => const _$RoomGetRoomsApiVersionSerializer();
}

class _$RoomGetRoomsApiVersionSerializer implements PrimitiveSerializer<RoomGetRoomsApiVersion> {
  const _$RoomGetRoomsApiVersionSerializer();

  static const Map<RoomGetRoomsApiVersion, Object> _toWire = <RoomGetRoomsApiVersion, Object>{
    RoomGetRoomsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetRoomsApiVersion> _fromWire = <Object, RoomGetRoomsApiVersion>{
    'v4': RoomGetRoomsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetRoomsApiVersion];

  @override
  String get wireName => 'RoomGetRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetRoomsHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
  @BuiltValueField(wireName: 'x-nextcloud-talk-modified-before')
  String? get xNextcloudTalkModifiedBefore;
}

abstract class RoomRoomGetRoomsHeaders
    implements $RoomRoomGetRoomsHeadersInterface, Built<RoomRoomGetRoomsHeaders, RoomRoomGetRoomsHeadersBuilder> {
  factory RoomRoomGetRoomsHeaders([void Function(RoomRoomGetRoomsHeadersBuilder)? b]) = _$RoomRoomGetRoomsHeaders;

  // coverage:ignore-start
  const RoomRoomGetRoomsHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRoomGetRoomsHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRoomGetRoomsHeaders> get serializer => _$roomRoomGetRoomsHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class RoomGetRoomsResponseApplicationJson_Ocs
    implements
        $RoomGetRoomsResponseApplicationJson_OcsInterface,
        Built<RoomGetRoomsResponseApplicationJson_Ocs, RoomGetRoomsResponseApplicationJson_OcsBuilder> {
  factory RoomGetRoomsResponseApplicationJson_Ocs([void Function(RoomGetRoomsResponseApplicationJson_OcsBuilder)? b]) =
      _$RoomGetRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetRoomsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetRoomsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetRoomsResponseApplicationJsonInterface {
  RoomGetRoomsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomGetRoomsResponseApplicationJson
    implements
        $RoomGetRoomsResponseApplicationJsonInterface,
        Built<RoomGetRoomsResponseApplicationJson, RoomGetRoomsResponseApplicationJsonBuilder> {
  factory RoomGetRoomsResponseApplicationJson([void Function(RoomGetRoomsResponseApplicationJsonBuilder)? b]) =
      _$RoomGetRoomsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetRoomsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetRoomsResponseApplicationJson> get serializer =>
      _$roomGetRoomsResponseApplicationJsonSerializer;
}

class RoomCreateRoomApiVersion extends EnumClass {
  const RoomCreateRoomApiVersion._(super.name);

  static const RoomCreateRoomApiVersion v4 = _$roomCreateRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomCreateRoomApiVersion> get values => _$roomCreateRoomApiVersionValues;
  // coverage:ignore-end

  static RoomCreateRoomApiVersion valueOf(String name) => _$valueOfRoomCreateRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomCreateRoomApiVersion> get serializer => const _$RoomCreateRoomApiVersionSerializer();
}

class _$RoomCreateRoomApiVersionSerializer implements PrimitiveSerializer<RoomCreateRoomApiVersion> {
  const _$RoomCreateRoomApiVersionSerializer();

  static const Map<RoomCreateRoomApiVersion, Object> _toWire = <RoomCreateRoomApiVersion, Object>{
    RoomCreateRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomCreateRoomApiVersion> _fromWire = <Object, RoomCreateRoomApiVersion>{
    'v4': RoomCreateRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomCreateRoomApiVersion];

  @override
  String get wireName => 'RoomCreateRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomCreateRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomCreateRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomCreateRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomCreateRoomResponseApplicationJson_Ocs
    implements
        $RoomCreateRoomResponseApplicationJson_OcsInterface,
        Built<RoomCreateRoomResponseApplicationJson_Ocs, RoomCreateRoomResponseApplicationJson_OcsBuilder> {
  factory RoomCreateRoomResponseApplicationJson_Ocs([
    void Function(RoomCreateRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomCreateRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomCreateRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomCreateRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomCreateRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomCreateRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomCreateRoomResponseApplicationJsonInterface {
  RoomCreateRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomCreateRoomResponseApplicationJson
    implements
        $RoomCreateRoomResponseApplicationJsonInterface,
        Built<RoomCreateRoomResponseApplicationJson, RoomCreateRoomResponseApplicationJsonBuilder> {
  factory RoomCreateRoomResponseApplicationJson([void Function(RoomCreateRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomCreateRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomCreateRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomCreateRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomCreateRoomResponseApplicationJson> get serializer =>
      _$roomCreateRoomResponseApplicationJsonSerializer;
}

class RoomGetListedRoomsApiVersion extends EnumClass {
  const RoomGetListedRoomsApiVersion._(super.name);

  static const RoomGetListedRoomsApiVersion v4 = _$roomGetListedRoomsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomGetListedRoomsApiVersion> get values => _$roomGetListedRoomsApiVersionValues;
  // coverage:ignore-end

  static RoomGetListedRoomsApiVersion valueOf(String name) => _$valueOfRoomGetListedRoomsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetListedRoomsApiVersion> get serializer => const _$RoomGetListedRoomsApiVersionSerializer();
}

class _$RoomGetListedRoomsApiVersionSerializer implements PrimitiveSerializer<RoomGetListedRoomsApiVersion> {
  const _$RoomGetListedRoomsApiVersionSerializer();

  static const Map<RoomGetListedRoomsApiVersion, Object> _toWire = <RoomGetListedRoomsApiVersion, Object>{
    RoomGetListedRoomsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetListedRoomsApiVersion> _fromWire = <Object, RoomGetListedRoomsApiVersion>{
    'v4': RoomGetListedRoomsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetListedRoomsApiVersion];

  @override
  String get wireName => 'RoomGetListedRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetListedRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetListedRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetListedRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class RoomGetListedRoomsResponseApplicationJson_Ocs
    implements
        $RoomGetListedRoomsResponseApplicationJson_OcsInterface,
        Built<RoomGetListedRoomsResponseApplicationJson_Ocs, RoomGetListedRoomsResponseApplicationJson_OcsBuilder> {
  factory RoomGetListedRoomsResponseApplicationJson_Ocs([
    void Function(RoomGetListedRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetListedRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetListedRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetListedRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetListedRoomsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetListedRoomsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetListedRoomsResponseApplicationJsonInterface {
  RoomGetListedRoomsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomGetListedRoomsResponseApplicationJson
    implements
        $RoomGetListedRoomsResponseApplicationJsonInterface,
        Built<RoomGetListedRoomsResponseApplicationJson, RoomGetListedRoomsResponseApplicationJsonBuilder> {
  factory RoomGetListedRoomsResponseApplicationJson([
    void Function(RoomGetListedRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetListedRoomsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetListedRoomsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetListedRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetListedRoomsResponseApplicationJson> get serializer =>
      _$roomGetListedRoomsResponseApplicationJsonSerializer;
}

class RoomGetNoteToSelfConversationApiVersion extends EnumClass {
  const RoomGetNoteToSelfConversationApiVersion._(super.name);

  static const RoomGetNoteToSelfConversationApiVersion v4 = _$roomGetNoteToSelfConversationApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomGetNoteToSelfConversationApiVersion> get values =>
      _$roomGetNoteToSelfConversationApiVersionValues;
  // coverage:ignore-end

  static RoomGetNoteToSelfConversationApiVersion valueOf(String name) =>
      _$valueOfRoomGetNoteToSelfConversationApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetNoteToSelfConversationApiVersion> get serializer =>
      const _$RoomGetNoteToSelfConversationApiVersionSerializer();
}

class _$RoomGetNoteToSelfConversationApiVersionSerializer
    implements PrimitiveSerializer<RoomGetNoteToSelfConversationApiVersion> {
  const _$RoomGetNoteToSelfConversationApiVersionSerializer();

  static const Map<RoomGetNoteToSelfConversationApiVersion, Object> _toWire =
      <RoomGetNoteToSelfConversationApiVersion, Object>{
    RoomGetNoteToSelfConversationApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetNoteToSelfConversationApiVersion> _fromWire =
      <Object, RoomGetNoteToSelfConversationApiVersion>{
    'v4': RoomGetNoteToSelfConversationApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetNoteToSelfConversationApiVersion];

  @override
  String get wireName => 'RoomGetNoteToSelfConversationApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetNoteToSelfConversationApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetNoteToSelfConversationApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetNoteToSelfConversationHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
}

abstract class RoomRoomGetNoteToSelfConversationHeaders
    implements
        $RoomRoomGetNoteToSelfConversationHeadersInterface,
        Built<RoomRoomGetNoteToSelfConversationHeaders, RoomRoomGetNoteToSelfConversationHeadersBuilder> {
  factory RoomRoomGetNoteToSelfConversationHeaders([
    void Function(RoomRoomGetNoteToSelfConversationHeadersBuilder)? b,
  ]) = _$RoomRoomGetNoteToSelfConversationHeaders;

  // coverage:ignore-start
  const RoomRoomGetNoteToSelfConversationHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRoomGetNoteToSelfConversationHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRoomGetNoteToSelfConversationHeaders> get serializer =>
      _$roomRoomGetNoteToSelfConversationHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomGetNoteToSelfConversationResponseApplicationJson_Ocs
    implements
        $RoomGetNoteToSelfConversationResponseApplicationJson_OcsInterface,
        Built<RoomGetNoteToSelfConversationResponseApplicationJson_Ocs,
            RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder> {
  factory RoomGetNoteToSelfConversationResponseApplicationJson_Ocs([
    void Function(RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetNoteToSelfConversationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetNoteToSelfConversationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetNoteToSelfConversationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetNoteToSelfConversationResponseApplicationJson_Ocs> get serializer =>
      _$roomGetNoteToSelfConversationResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetNoteToSelfConversationResponseApplicationJsonInterface {
  RoomGetNoteToSelfConversationResponseApplicationJson_Ocs get ocs;
}

abstract class RoomGetNoteToSelfConversationResponseApplicationJson
    implements
        $RoomGetNoteToSelfConversationResponseApplicationJsonInterface,
        Built<RoomGetNoteToSelfConversationResponseApplicationJson,
            RoomGetNoteToSelfConversationResponseApplicationJsonBuilder> {
  factory RoomGetNoteToSelfConversationResponseApplicationJson([
    void Function(RoomGetNoteToSelfConversationResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetNoteToSelfConversationResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetNoteToSelfConversationResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetNoteToSelfConversationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetNoteToSelfConversationResponseApplicationJson> get serializer =>
      _$roomGetNoteToSelfConversationResponseApplicationJsonSerializer;
}

class RoomGetSingleRoomApiVersion extends EnumClass {
  const RoomGetSingleRoomApiVersion._(super.name);

  static const RoomGetSingleRoomApiVersion v4 = _$roomGetSingleRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomGetSingleRoomApiVersion> get values => _$roomGetSingleRoomApiVersionValues;
  // coverage:ignore-end

  static RoomGetSingleRoomApiVersion valueOf(String name) => _$valueOfRoomGetSingleRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetSingleRoomApiVersion> get serializer => const _$RoomGetSingleRoomApiVersionSerializer();
}

class _$RoomGetSingleRoomApiVersionSerializer implements PrimitiveSerializer<RoomGetSingleRoomApiVersion> {
  const _$RoomGetSingleRoomApiVersionSerializer();

  static const Map<RoomGetSingleRoomApiVersion, Object> _toWire = <RoomGetSingleRoomApiVersion, Object>{
    RoomGetSingleRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetSingleRoomApiVersion> _fromWire = <Object, RoomGetSingleRoomApiVersion>{
    'v4': RoomGetSingleRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetSingleRoomApiVersion];

  @override
  String get wireName => 'RoomGetSingleRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetSingleRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetSingleRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetSingleRoomHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-talk-hash')
  String? get xNextcloudTalkHash;
}

abstract class RoomRoomGetSingleRoomHeaders
    implements
        $RoomRoomGetSingleRoomHeadersInterface,
        Built<RoomRoomGetSingleRoomHeaders, RoomRoomGetSingleRoomHeadersBuilder> {
  factory RoomRoomGetSingleRoomHeaders([void Function(RoomRoomGetSingleRoomHeadersBuilder)? b]) =
      _$RoomRoomGetSingleRoomHeaders;

  // coverage:ignore-start
  const RoomRoomGetSingleRoomHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRoomGetSingleRoomHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRoomGetSingleRoomHeaders> get serializer => _$roomRoomGetSingleRoomHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetSingleRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomGetSingleRoomResponseApplicationJson_Ocs
    implements
        $RoomGetSingleRoomResponseApplicationJson_OcsInterface,
        Built<RoomGetSingleRoomResponseApplicationJson_Ocs, RoomGetSingleRoomResponseApplicationJson_OcsBuilder> {
  factory RoomGetSingleRoomResponseApplicationJson_Ocs([
    void Function(RoomGetSingleRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetSingleRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetSingleRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetSingleRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetSingleRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomGetSingleRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetSingleRoomResponseApplicationJsonInterface {
  RoomGetSingleRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomGetSingleRoomResponseApplicationJson
    implements
        $RoomGetSingleRoomResponseApplicationJsonInterface,
        Built<RoomGetSingleRoomResponseApplicationJson, RoomGetSingleRoomResponseApplicationJsonBuilder> {
  factory RoomGetSingleRoomResponseApplicationJson([
    void Function(RoomGetSingleRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetSingleRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetSingleRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetSingleRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetSingleRoomResponseApplicationJson> get serializer =>
      _$roomGetSingleRoomResponseApplicationJsonSerializer;
}

class RoomRenameRoomApiVersion extends EnumClass {
  const RoomRenameRoomApiVersion._(super.name);

  static const RoomRenameRoomApiVersion v4 = _$roomRenameRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomRenameRoomApiVersion> get values => _$roomRenameRoomApiVersionValues;
  // coverage:ignore-end

  static RoomRenameRoomApiVersion valueOf(String name) => _$valueOfRoomRenameRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRenameRoomApiVersion> get serializer => const _$RoomRenameRoomApiVersionSerializer();
}

class _$RoomRenameRoomApiVersionSerializer implements PrimitiveSerializer<RoomRenameRoomApiVersion> {
  const _$RoomRenameRoomApiVersionSerializer();

  static const Map<RoomRenameRoomApiVersion, Object> _toWire = <RoomRenameRoomApiVersion, Object>{
    RoomRenameRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRenameRoomApiVersion> _fromWire = <Object, RoomRenameRoomApiVersion>{
    'v4': RoomRenameRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRenameRoomApiVersion];

  @override
  String get wireName => 'RoomRenameRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRenameRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRenameRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRenameRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomRenameRoomResponseApplicationJson_Ocs
    implements
        $RoomRenameRoomResponseApplicationJson_OcsInterface,
        Built<RoomRenameRoomResponseApplicationJson_Ocs, RoomRenameRoomResponseApplicationJson_OcsBuilder> {
  factory RoomRenameRoomResponseApplicationJson_Ocs([
    void Function(RoomRenameRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRenameRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRenameRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRenameRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRenameRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomRenameRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRenameRoomResponseApplicationJsonInterface {
  RoomRenameRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomRenameRoomResponseApplicationJson
    implements
        $RoomRenameRoomResponseApplicationJsonInterface,
        Built<RoomRenameRoomResponseApplicationJson, RoomRenameRoomResponseApplicationJsonBuilder> {
  factory RoomRenameRoomResponseApplicationJson([void Function(RoomRenameRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomRenameRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomRenameRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRenameRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRenameRoomResponseApplicationJson> get serializer =>
      _$roomRenameRoomResponseApplicationJsonSerializer;
}

class RoomDeleteRoomApiVersion extends EnumClass {
  const RoomDeleteRoomApiVersion._(super.name);

  static const RoomDeleteRoomApiVersion v4 = _$roomDeleteRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomDeleteRoomApiVersion> get values => _$roomDeleteRoomApiVersionValues;
  // coverage:ignore-end

  static RoomDeleteRoomApiVersion valueOf(String name) => _$valueOfRoomDeleteRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomDeleteRoomApiVersion> get serializer => const _$RoomDeleteRoomApiVersionSerializer();
}

class _$RoomDeleteRoomApiVersionSerializer implements PrimitiveSerializer<RoomDeleteRoomApiVersion> {
  const _$RoomDeleteRoomApiVersionSerializer();

  static const Map<RoomDeleteRoomApiVersion, Object> _toWire = <RoomDeleteRoomApiVersion, Object>{
    RoomDeleteRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomDeleteRoomApiVersion> _fromWire = <Object, RoomDeleteRoomApiVersion>{
    'v4': RoomDeleteRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomDeleteRoomApiVersion];

  @override
  String get wireName => 'RoomDeleteRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomDeleteRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomDeleteRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomDeleteRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomDeleteRoomResponseApplicationJson_Ocs
    implements
        $RoomDeleteRoomResponseApplicationJson_OcsInterface,
        Built<RoomDeleteRoomResponseApplicationJson_Ocs, RoomDeleteRoomResponseApplicationJson_OcsBuilder> {
  factory RoomDeleteRoomResponseApplicationJson_Ocs([
    void Function(RoomDeleteRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomDeleteRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomDeleteRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomDeleteRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomDeleteRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomDeleteRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomDeleteRoomResponseApplicationJsonInterface {
  RoomDeleteRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomDeleteRoomResponseApplicationJson
    implements
        $RoomDeleteRoomResponseApplicationJsonInterface,
        Built<RoomDeleteRoomResponseApplicationJson, RoomDeleteRoomResponseApplicationJsonBuilder> {
  factory RoomDeleteRoomResponseApplicationJson([void Function(RoomDeleteRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomDeleteRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomDeleteRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomDeleteRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomDeleteRoomResponseApplicationJson> get serializer =>
      _$roomDeleteRoomResponseApplicationJsonSerializer;
}

class RoomGetBreakoutRoomsApiVersion extends EnumClass {
  const RoomGetBreakoutRoomsApiVersion._(super.name);

  static const RoomGetBreakoutRoomsApiVersion v4 = _$roomGetBreakoutRoomsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomGetBreakoutRoomsApiVersion> get values => _$roomGetBreakoutRoomsApiVersionValues;
  // coverage:ignore-end

  static RoomGetBreakoutRoomsApiVersion valueOf(String name) => _$valueOfRoomGetBreakoutRoomsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetBreakoutRoomsApiVersion> get serializer =>
      const _$RoomGetBreakoutRoomsApiVersionSerializer();
}

class _$RoomGetBreakoutRoomsApiVersionSerializer implements PrimitiveSerializer<RoomGetBreakoutRoomsApiVersion> {
  const _$RoomGetBreakoutRoomsApiVersionSerializer();

  static const Map<RoomGetBreakoutRoomsApiVersion, Object> _toWire = <RoomGetBreakoutRoomsApiVersion, Object>{
    RoomGetBreakoutRoomsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetBreakoutRoomsApiVersion> _fromWire = <Object, RoomGetBreakoutRoomsApiVersion>{
    'v4': RoomGetBreakoutRoomsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetBreakoutRoomsApiVersion];

  @override
  String get wireName => 'RoomGetBreakoutRoomsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetBreakoutRoomsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetBreakoutRoomsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Room> get data;
}

abstract class RoomGetBreakoutRoomsResponseApplicationJson_Ocs
    implements
        $RoomGetBreakoutRoomsResponseApplicationJson_OcsInterface,
        Built<RoomGetBreakoutRoomsResponseApplicationJson_Ocs, RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder> {
  factory RoomGetBreakoutRoomsResponseApplicationJson_Ocs([
    void Function(RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetBreakoutRoomsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetBreakoutRoomsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetBreakoutRoomsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetBreakoutRoomsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetBreakoutRoomsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomsResponseApplicationJsonInterface {
  RoomGetBreakoutRoomsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomGetBreakoutRoomsResponseApplicationJson
    implements
        $RoomGetBreakoutRoomsResponseApplicationJsonInterface,
        Built<RoomGetBreakoutRoomsResponseApplicationJson, RoomGetBreakoutRoomsResponseApplicationJsonBuilder> {
  factory RoomGetBreakoutRoomsResponseApplicationJson([
    void Function(RoomGetBreakoutRoomsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetBreakoutRoomsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetBreakoutRoomsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetBreakoutRoomsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetBreakoutRoomsResponseApplicationJson> get serializer =>
      _$roomGetBreakoutRoomsResponseApplicationJsonSerializer;
}

class RoomMakePublicApiVersion extends EnumClass {
  const RoomMakePublicApiVersion._(super.name);

  static const RoomMakePublicApiVersion v4 = _$roomMakePublicApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomMakePublicApiVersion> get values => _$roomMakePublicApiVersionValues;
  // coverage:ignore-end

  static RoomMakePublicApiVersion valueOf(String name) => _$valueOfRoomMakePublicApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomMakePublicApiVersion> get serializer => const _$RoomMakePublicApiVersionSerializer();
}

class _$RoomMakePublicApiVersionSerializer implements PrimitiveSerializer<RoomMakePublicApiVersion> {
  const _$RoomMakePublicApiVersionSerializer();

  static const Map<RoomMakePublicApiVersion, Object> _toWire = <RoomMakePublicApiVersion, Object>{
    RoomMakePublicApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomMakePublicApiVersion> _fromWire = <Object, RoomMakePublicApiVersion>{
    'v4': RoomMakePublicApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomMakePublicApiVersion];

  @override
  String get wireName => 'RoomMakePublicApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomMakePublicApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomMakePublicApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePublicResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomMakePublicResponseApplicationJson_Ocs
    implements
        $RoomMakePublicResponseApplicationJson_OcsInterface,
        Built<RoomMakePublicResponseApplicationJson_Ocs, RoomMakePublicResponseApplicationJson_OcsBuilder> {
  factory RoomMakePublicResponseApplicationJson_Ocs([
    void Function(RoomMakePublicResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomMakePublicResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomMakePublicResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomMakePublicResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomMakePublicResponseApplicationJson_Ocs> get serializer =>
      _$roomMakePublicResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePublicResponseApplicationJsonInterface {
  RoomMakePublicResponseApplicationJson_Ocs get ocs;
}

abstract class RoomMakePublicResponseApplicationJson
    implements
        $RoomMakePublicResponseApplicationJsonInterface,
        Built<RoomMakePublicResponseApplicationJson, RoomMakePublicResponseApplicationJsonBuilder> {
  factory RoomMakePublicResponseApplicationJson([void Function(RoomMakePublicResponseApplicationJsonBuilder)? b]) =
      _$RoomMakePublicResponseApplicationJson;

  // coverage:ignore-start
  const RoomMakePublicResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomMakePublicResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomMakePublicResponseApplicationJson> get serializer =>
      _$roomMakePublicResponseApplicationJsonSerializer;
}

class RoomMakePrivateApiVersion extends EnumClass {
  const RoomMakePrivateApiVersion._(super.name);

  static const RoomMakePrivateApiVersion v4 = _$roomMakePrivateApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomMakePrivateApiVersion> get values => _$roomMakePrivateApiVersionValues;
  // coverage:ignore-end

  static RoomMakePrivateApiVersion valueOf(String name) => _$valueOfRoomMakePrivateApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomMakePrivateApiVersion> get serializer => const _$RoomMakePrivateApiVersionSerializer();
}

class _$RoomMakePrivateApiVersionSerializer implements PrimitiveSerializer<RoomMakePrivateApiVersion> {
  const _$RoomMakePrivateApiVersionSerializer();

  static const Map<RoomMakePrivateApiVersion, Object> _toWire = <RoomMakePrivateApiVersion, Object>{
    RoomMakePrivateApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomMakePrivateApiVersion> _fromWire = <Object, RoomMakePrivateApiVersion>{
    'v4': RoomMakePrivateApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomMakePrivateApiVersion];

  @override
  String get wireName => 'RoomMakePrivateApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomMakePrivateApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomMakePrivateApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePrivateResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomMakePrivateResponseApplicationJson_Ocs
    implements
        $RoomMakePrivateResponseApplicationJson_OcsInterface,
        Built<RoomMakePrivateResponseApplicationJson_Ocs, RoomMakePrivateResponseApplicationJson_OcsBuilder> {
  factory RoomMakePrivateResponseApplicationJson_Ocs([
    void Function(RoomMakePrivateResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomMakePrivateResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomMakePrivateResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomMakePrivateResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomMakePrivateResponseApplicationJson_Ocs> get serializer =>
      _$roomMakePrivateResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomMakePrivateResponseApplicationJsonInterface {
  RoomMakePrivateResponseApplicationJson_Ocs get ocs;
}

abstract class RoomMakePrivateResponseApplicationJson
    implements
        $RoomMakePrivateResponseApplicationJsonInterface,
        Built<RoomMakePrivateResponseApplicationJson, RoomMakePrivateResponseApplicationJsonBuilder> {
  factory RoomMakePrivateResponseApplicationJson([void Function(RoomMakePrivateResponseApplicationJsonBuilder)? b]) =
      _$RoomMakePrivateResponseApplicationJson;

  // coverage:ignore-start
  const RoomMakePrivateResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomMakePrivateResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomMakePrivateResponseApplicationJson> get serializer =>
      _$roomMakePrivateResponseApplicationJsonSerializer;
}

class RoomSetDescriptionApiVersion extends EnumClass {
  const RoomSetDescriptionApiVersion._(super.name);

  static const RoomSetDescriptionApiVersion v4 = _$roomSetDescriptionApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetDescriptionApiVersion> get values => _$roomSetDescriptionApiVersionValues;
  // coverage:ignore-end

  static RoomSetDescriptionApiVersion valueOf(String name) => _$valueOfRoomSetDescriptionApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetDescriptionApiVersion> get serializer => const _$RoomSetDescriptionApiVersionSerializer();
}

class _$RoomSetDescriptionApiVersionSerializer implements PrimitiveSerializer<RoomSetDescriptionApiVersion> {
  const _$RoomSetDescriptionApiVersionSerializer();

  static const Map<RoomSetDescriptionApiVersion, Object> _toWire = <RoomSetDescriptionApiVersion, Object>{
    RoomSetDescriptionApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetDescriptionApiVersion> _fromWire = <Object, RoomSetDescriptionApiVersion>{
    'v4': RoomSetDescriptionApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetDescriptionApiVersion];

  @override
  String get wireName => 'RoomSetDescriptionApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetDescriptionApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetDescriptionApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetDescriptionResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetDescriptionResponseApplicationJson_Ocs
    implements
        $RoomSetDescriptionResponseApplicationJson_OcsInterface,
        Built<RoomSetDescriptionResponseApplicationJson_Ocs, RoomSetDescriptionResponseApplicationJson_OcsBuilder> {
  factory RoomSetDescriptionResponseApplicationJson_Ocs([
    void Function(RoomSetDescriptionResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetDescriptionResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetDescriptionResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetDescriptionResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetDescriptionResponseApplicationJson_Ocs> get serializer =>
      _$roomSetDescriptionResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetDescriptionResponseApplicationJsonInterface {
  RoomSetDescriptionResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetDescriptionResponseApplicationJson
    implements
        $RoomSetDescriptionResponseApplicationJsonInterface,
        Built<RoomSetDescriptionResponseApplicationJson, RoomSetDescriptionResponseApplicationJsonBuilder> {
  factory RoomSetDescriptionResponseApplicationJson([
    void Function(RoomSetDescriptionResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetDescriptionResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetDescriptionResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetDescriptionResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetDescriptionResponseApplicationJson> get serializer =>
      _$roomSetDescriptionResponseApplicationJsonSerializer;
}

class RoomSetReadOnlyState extends EnumClass {
  const RoomSetReadOnlyState._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetReadOnlyState $0 = _$roomSetReadOnlyState$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetReadOnlyState $1 = _$roomSetReadOnlyState$1;

  // coverage:ignore-start
  static BuiltSet<RoomSetReadOnlyState> get values => _$roomSetReadOnlyStateValues;
  // coverage:ignore-end

  static RoomSetReadOnlyState valueOf(String name) => _$valueOfRoomSetReadOnlyState(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetReadOnlyState> get serializer => const _$RoomSetReadOnlyStateSerializer();
}

class _$RoomSetReadOnlyStateSerializer implements PrimitiveSerializer<RoomSetReadOnlyState> {
  const _$RoomSetReadOnlyStateSerializer();

  static const Map<RoomSetReadOnlyState, Object> _toWire = <RoomSetReadOnlyState, Object>{
    RoomSetReadOnlyState.$0: 0,
    RoomSetReadOnlyState.$1: 1,
  };

  static const Map<Object, RoomSetReadOnlyState> _fromWire = <Object, RoomSetReadOnlyState>{
    0: RoomSetReadOnlyState.$0,
    1: RoomSetReadOnlyState.$1,
  };

  @override
  Iterable<Type> get types => const [RoomSetReadOnlyState];

  @override
  String get wireName => 'RoomSetReadOnlyState';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetReadOnlyState object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetReadOnlyState deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetReadOnlyApiVersion extends EnumClass {
  const RoomSetReadOnlyApiVersion._(super.name);

  static const RoomSetReadOnlyApiVersion v4 = _$roomSetReadOnlyApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetReadOnlyApiVersion> get values => _$roomSetReadOnlyApiVersionValues;
  // coverage:ignore-end

  static RoomSetReadOnlyApiVersion valueOf(String name) => _$valueOfRoomSetReadOnlyApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetReadOnlyApiVersion> get serializer => const _$RoomSetReadOnlyApiVersionSerializer();
}

class _$RoomSetReadOnlyApiVersionSerializer implements PrimitiveSerializer<RoomSetReadOnlyApiVersion> {
  const _$RoomSetReadOnlyApiVersionSerializer();

  static const Map<RoomSetReadOnlyApiVersion, Object> _toWire = <RoomSetReadOnlyApiVersion, Object>{
    RoomSetReadOnlyApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetReadOnlyApiVersion> _fromWire = <Object, RoomSetReadOnlyApiVersion>{
    'v4': RoomSetReadOnlyApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetReadOnlyApiVersion];

  @override
  String get wireName => 'RoomSetReadOnlyApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetReadOnlyApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetReadOnlyApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetReadOnlyResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetReadOnlyResponseApplicationJson_Ocs
    implements
        $RoomSetReadOnlyResponseApplicationJson_OcsInterface,
        Built<RoomSetReadOnlyResponseApplicationJson_Ocs, RoomSetReadOnlyResponseApplicationJson_OcsBuilder> {
  factory RoomSetReadOnlyResponseApplicationJson_Ocs([
    void Function(RoomSetReadOnlyResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetReadOnlyResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetReadOnlyResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetReadOnlyResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetReadOnlyResponseApplicationJson_Ocs> get serializer =>
      _$roomSetReadOnlyResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetReadOnlyResponseApplicationJsonInterface {
  RoomSetReadOnlyResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetReadOnlyResponseApplicationJson
    implements
        $RoomSetReadOnlyResponseApplicationJsonInterface,
        Built<RoomSetReadOnlyResponseApplicationJson, RoomSetReadOnlyResponseApplicationJsonBuilder> {
  factory RoomSetReadOnlyResponseApplicationJson([void Function(RoomSetReadOnlyResponseApplicationJsonBuilder)? b]) =
      _$RoomSetReadOnlyResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetReadOnlyResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetReadOnlyResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetReadOnlyResponseApplicationJson> get serializer =>
      _$roomSetReadOnlyResponseApplicationJsonSerializer;
}

class RoomSetListableScope extends EnumClass {
  const RoomSetListableScope._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetListableScope $0 = _$roomSetListableScope$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetListableScope $1 = _$roomSetListableScope$1;

  @BuiltValueEnumConst(wireName: '2')
  static const RoomSetListableScope $2 = _$roomSetListableScope$2;

  // coverage:ignore-start
  static BuiltSet<RoomSetListableScope> get values => _$roomSetListableScopeValues;
  // coverage:ignore-end

  static RoomSetListableScope valueOf(String name) => _$valueOfRoomSetListableScope(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetListableScope> get serializer => const _$RoomSetListableScopeSerializer();
}

class _$RoomSetListableScopeSerializer implements PrimitiveSerializer<RoomSetListableScope> {
  const _$RoomSetListableScopeSerializer();

  static const Map<RoomSetListableScope, Object> _toWire = <RoomSetListableScope, Object>{
    RoomSetListableScope.$0: 0,
    RoomSetListableScope.$1: 1,
    RoomSetListableScope.$2: 2,
  };

  static const Map<Object, RoomSetListableScope> _fromWire = <Object, RoomSetListableScope>{
    0: RoomSetListableScope.$0,
    1: RoomSetListableScope.$1,
    2: RoomSetListableScope.$2,
  };

  @override
  Iterable<Type> get types => const [RoomSetListableScope];

  @override
  String get wireName => 'RoomSetListableScope';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetListableScope object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetListableScope deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetListableApiVersion extends EnumClass {
  const RoomSetListableApiVersion._(super.name);

  static const RoomSetListableApiVersion v4 = _$roomSetListableApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetListableApiVersion> get values => _$roomSetListableApiVersionValues;
  // coverage:ignore-end

  static RoomSetListableApiVersion valueOf(String name) => _$valueOfRoomSetListableApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetListableApiVersion> get serializer => const _$RoomSetListableApiVersionSerializer();
}

class _$RoomSetListableApiVersionSerializer implements PrimitiveSerializer<RoomSetListableApiVersion> {
  const _$RoomSetListableApiVersionSerializer();

  static const Map<RoomSetListableApiVersion, Object> _toWire = <RoomSetListableApiVersion, Object>{
    RoomSetListableApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetListableApiVersion> _fromWire = <Object, RoomSetListableApiVersion>{
    'v4': RoomSetListableApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetListableApiVersion];

  @override
  String get wireName => 'RoomSetListableApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetListableApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetListableApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetListableResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetListableResponseApplicationJson_Ocs
    implements
        $RoomSetListableResponseApplicationJson_OcsInterface,
        Built<RoomSetListableResponseApplicationJson_Ocs, RoomSetListableResponseApplicationJson_OcsBuilder> {
  factory RoomSetListableResponseApplicationJson_Ocs([
    void Function(RoomSetListableResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetListableResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetListableResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetListableResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetListableResponseApplicationJson_Ocs> get serializer =>
      _$roomSetListableResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetListableResponseApplicationJsonInterface {
  RoomSetListableResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetListableResponseApplicationJson
    implements
        $RoomSetListableResponseApplicationJsonInterface,
        Built<RoomSetListableResponseApplicationJson, RoomSetListableResponseApplicationJsonBuilder> {
  factory RoomSetListableResponseApplicationJson([void Function(RoomSetListableResponseApplicationJsonBuilder)? b]) =
      _$RoomSetListableResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetListableResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetListableResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetListableResponseApplicationJson> get serializer =>
      _$roomSetListableResponseApplicationJsonSerializer;
}

class RoomSetPasswordApiVersion extends EnumClass {
  const RoomSetPasswordApiVersion._(super.name);

  static const RoomSetPasswordApiVersion v4 = _$roomSetPasswordApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetPasswordApiVersion> get values => _$roomSetPasswordApiVersionValues;
  // coverage:ignore-end

  static RoomSetPasswordApiVersion valueOf(String name) => _$valueOfRoomSetPasswordApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetPasswordApiVersion> get serializer => const _$RoomSetPasswordApiVersionSerializer();
}

class _$RoomSetPasswordApiVersionSerializer implements PrimitiveSerializer<RoomSetPasswordApiVersion> {
  const _$RoomSetPasswordApiVersionSerializer();

  static const Map<RoomSetPasswordApiVersion, Object> _toWire = <RoomSetPasswordApiVersion, Object>{
    RoomSetPasswordApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetPasswordApiVersion> _fromWire = <Object, RoomSetPasswordApiVersion>{
    'v4': RoomSetPasswordApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetPasswordApiVersion];

  @override
  String get wireName => 'RoomSetPasswordApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetPasswordApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetPasswordApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPasswordResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetPasswordResponseApplicationJson_Ocs
    implements
        $RoomSetPasswordResponseApplicationJson_OcsInterface,
        Built<RoomSetPasswordResponseApplicationJson_Ocs, RoomSetPasswordResponseApplicationJson_OcsBuilder> {
  factory RoomSetPasswordResponseApplicationJson_Ocs([
    void Function(RoomSetPasswordResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetPasswordResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetPasswordResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetPasswordResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetPasswordResponseApplicationJson_Ocs> get serializer =>
      _$roomSetPasswordResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPasswordResponseApplicationJsonInterface {
  RoomSetPasswordResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetPasswordResponseApplicationJson
    implements
        $RoomSetPasswordResponseApplicationJsonInterface,
        Built<RoomSetPasswordResponseApplicationJson, RoomSetPasswordResponseApplicationJsonBuilder> {
  factory RoomSetPasswordResponseApplicationJson([void Function(RoomSetPasswordResponseApplicationJsonBuilder)? b]) =
      _$RoomSetPasswordResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetPasswordResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetPasswordResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetPasswordResponseApplicationJson> get serializer =>
      _$roomSetPasswordResponseApplicationJsonSerializer;
}

class RoomSetPermissionsPermissions extends EnumClass {
  const RoomSetPermissionsPermissions._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetPermissionsPermissions $0 = _$roomSetPermissionsPermissions$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetPermissionsPermissions $1 = _$roomSetPermissionsPermissions$1;

  @BuiltValueEnumConst(wireName: '2')
  static const RoomSetPermissionsPermissions $2 = _$roomSetPermissionsPermissions$2;

  @BuiltValueEnumConst(wireName: '3')
  static const RoomSetPermissionsPermissions $3 = _$roomSetPermissionsPermissions$3;

  @BuiltValueEnumConst(wireName: '4')
  static const RoomSetPermissionsPermissions $4 = _$roomSetPermissionsPermissions$4;

  @BuiltValueEnumConst(wireName: '5')
  static const RoomSetPermissionsPermissions $5 = _$roomSetPermissionsPermissions$5;

  @BuiltValueEnumConst(wireName: '6')
  static const RoomSetPermissionsPermissions $6 = _$roomSetPermissionsPermissions$6;

  @BuiltValueEnumConst(wireName: '7')
  static const RoomSetPermissionsPermissions $7 = _$roomSetPermissionsPermissions$7;

  @BuiltValueEnumConst(wireName: '8')
  static const RoomSetPermissionsPermissions $8 = _$roomSetPermissionsPermissions$8;

  @BuiltValueEnumConst(wireName: '9')
  static const RoomSetPermissionsPermissions $9 = _$roomSetPermissionsPermissions$9;

  @BuiltValueEnumConst(wireName: '10')
  static const RoomSetPermissionsPermissions $10 = _$roomSetPermissionsPermissions$10;

  @BuiltValueEnumConst(wireName: '11')
  static const RoomSetPermissionsPermissions $11 = _$roomSetPermissionsPermissions$11;

  @BuiltValueEnumConst(wireName: '12')
  static const RoomSetPermissionsPermissions $12 = _$roomSetPermissionsPermissions$12;

  @BuiltValueEnumConst(wireName: '13')
  static const RoomSetPermissionsPermissions $13 = _$roomSetPermissionsPermissions$13;

  @BuiltValueEnumConst(wireName: '14')
  static const RoomSetPermissionsPermissions $14 = _$roomSetPermissionsPermissions$14;

  @BuiltValueEnumConst(wireName: '15')
  static const RoomSetPermissionsPermissions $15 = _$roomSetPermissionsPermissions$15;

  @BuiltValueEnumConst(wireName: '16')
  static const RoomSetPermissionsPermissions $16 = _$roomSetPermissionsPermissions$16;

  @BuiltValueEnumConst(wireName: '17')
  static const RoomSetPermissionsPermissions $17 = _$roomSetPermissionsPermissions$17;

  @BuiltValueEnumConst(wireName: '18')
  static const RoomSetPermissionsPermissions $18 = _$roomSetPermissionsPermissions$18;

  @BuiltValueEnumConst(wireName: '19')
  static const RoomSetPermissionsPermissions $19 = _$roomSetPermissionsPermissions$19;

  @BuiltValueEnumConst(wireName: '20')
  static const RoomSetPermissionsPermissions $20 = _$roomSetPermissionsPermissions$20;

  @BuiltValueEnumConst(wireName: '21')
  static const RoomSetPermissionsPermissions $21 = _$roomSetPermissionsPermissions$21;

  @BuiltValueEnumConst(wireName: '22')
  static const RoomSetPermissionsPermissions $22 = _$roomSetPermissionsPermissions$22;

  @BuiltValueEnumConst(wireName: '23')
  static const RoomSetPermissionsPermissions $23 = _$roomSetPermissionsPermissions$23;

  @BuiltValueEnumConst(wireName: '24')
  static const RoomSetPermissionsPermissions $24 = _$roomSetPermissionsPermissions$24;

  @BuiltValueEnumConst(wireName: '25')
  static const RoomSetPermissionsPermissions $25 = _$roomSetPermissionsPermissions$25;

  @BuiltValueEnumConst(wireName: '26')
  static const RoomSetPermissionsPermissions $26 = _$roomSetPermissionsPermissions$26;

  @BuiltValueEnumConst(wireName: '27')
  static const RoomSetPermissionsPermissions $27 = _$roomSetPermissionsPermissions$27;

  @BuiltValueEnumConst(wireName: '28')
  static const RoomSetPermissionsPermissions $28 = _$roomSetPermissionsPermissions$28;

  @BuiltValueEnumConst(wireName: '29')
  static const RoomSetPermissionsPermissions $29 = _$roomSetPermissionsPermissions$29;

  @BuiltValueEnumConst(wireName: '30')
  static const RoomSetPermissionsPermissions $30 = _$roomSetPermissionsPermissions$30;

  @BuiltValueEnumConst(wireName: '31')
  static const RoomSetPermissionsPermissions $31 = _$roomSetPermissionsPermissions$31;

  @BuiltValueEnumConst(wireName: '32')
  static const RoomSetPermissionsPermissions $32 = _$roomSetPermissionsPermissions$32;

  @BuiltValueEnumConst(wireName: '33')
  static const RoomSetPermissionsPermissions $33 = _$roomSetPermissionsPermissions$33;

  @BuiltValueEnumConst(wireName: '34')
  static const RoomSetPermissionsPermissions $34 = _$roomSetPermissionsPermissions$34;

  @BuiltValueEnumConst(wireName: '35')
  static const RoomSetPermissionsPermissions $35 = _$roomSetPermissionsPermissions$35;

  @BuiltValueEnumConst(wireName: '36')
  static const RoomSetPermissionsPermissions $36 = _$roomSetPermissionsPermissions$36;

  @BuiltValueEnumConst(wireName: '37')
  static const RoomSetPermissionsPermissions $37 = _$roomSetPermissionsPermissions$37;

  @BuiltValueEnumConst(wireName: '38')
  static const RoomSetPermissionsPermissions $38 = _$roomSetPermissionsPermissions$38;

  @BuiltValueEnumConst(wireName: '39')
  static const RoomSetPermissionsPermissions $39 = _$roomSetPermissionsPermissions$39;

  @BuiltValueEnumConst(wireName: '40')
  static const RoomSetPermissionsPermissions $40 = _$roomSetPermissionsPermissions$40;

  @BuiltValueEnumConst(wireName: '41')
  static const RoomSetPermissionsPermissions $41 = _$roomSetPermissionsPermissions$41;

  @BuiltValueEnumConst(wireName: '42')
  static const RoomSetPermissionsPermissions $42 = _$roomSetPermissionsPermissions$42;

  @BuiltValueEnumConst(wireName: '43')
  static const RoomSetPermissionsPermissions $43 = _$roomSetPermissionsPermissions$43;

  @BuiltValueEnumConst(wireName: '44')
  static const RoomSetPermissionsPermissions $44 = _$roomSetPermissionsPermissions$44;

  @BuiltValueEnumConst(wireName: '45')
  static const RoomSetPermissionsPermissions $45 = _$roomSetPermissionsPermissions$45;

  @BuiltValueEnumConst(wireName: '46')
  static const RoomSetPermissionsPermissions $46 = _$roomSetPermissionsPermissions$46;

  @BuiltValueEnumConst(wireName: '47')
  static const RoomSetPermissionsPermissions $47 = _$roomSetPermissionsPermissions$47;

  @BuiltValueEnumConst(wireName: '48')
  static const RoomSetPermissionsPermissions $48 = _$roomSetPermissionsPermissions$48;

  @BuiltValueEnumConst(wireName: '49')
  static const RoomSetPermissionsPermissions $49 = _$roomSetPermissionsPermissions$49;

  @BuiltValueEnumConst(wireName: '50')
  static const RoomSetPermissionsPermissions $50 = _$roomSetPermissionsPermissions$50;

  @BuiltValueEnumConst(wireName: '51')
  static const RoomSetPermissionsPermissions $51 = _$roomSetPermissionsPermissions$51;

  @BuiltValueEnumConst(wireName: '52')
  static const RoomSetPermissionsPermissions $52 = _$roomSetPermissionsPermissions$52;

  @BuiltValueEnumConst(wireName: '53')
  static const RoomSetPermissionsPermissions $53 = _$roomSetPermissionsPermissions$53;

  @BuiltValueEnumConst(wireName: '54')
  static const RoomSetPermissionsPermissions $54 = _$roomSetPermissionsPermissions$54;

  @BuiltValueEnumConst(wireName: '55')
  static const RoomSetPermissionsPermissions $55 = _$roomSetPermissionsPermissions$55;

  @BuiltValueEnumConst(wireName: '56')
  static const RoomSetPermissionsPermissions $56 = _$roomSetPermissionsPermissions$56;

  @BuiltValueEnumConst(wireName: '57')
  static const RoomSetPermissionsPermissions $57 = _$roomSetPermissionsPermissions$57;

  @BuiltValueEnumConst(wireName: '58')
  static const RoomSetPermissionsPermissions $58 = _$roomSetPermissionsPermissions$58;

  @BuiltValueEnumConst(wireName: '59')
  static const RoomSetPermissionsPermissions $59 = _$roomSetPermissionsPermissions$59;

  @BuiltValueEnumConst(wireName: '60')
  static const RoomSetPermissionsPermissions $60 = _$roomSetPermissionsPermissions$60;

  @BuiltValueEnumConst(wireName: '61')
  static const RoomSetPermissionsPermissions $61 = _$roomSetPermissionsPermissions$61;

  @BuiltValueEnumConst(wireName: '62')
  static const RoomSetPermissionsPermissions $62 = _$roomSetPermissionsPermissions$62;

  @BuiltValueEnumConst(wireName: '63')
  static const RoomSetPermissionsPermissions $63 = _$roomSetPermissionsPermissions$63;

  @BuiltValueEnumConst(wireName: '64')
  static const RoomSetPermissionsPermissions $64 = _$roomSetPermissionsPermissions$64;

  @BuiltValueEnumConst(wireName: '65')
  static const RoomSetPermissionsPermissions $65 = _$roomSetPermissionsPermissions$65;

  @BuiltValueEnumConst(wireName: '66')
  static const RoomSetPermissionsPermissions $66 = _$roomSetPermissionsPermissions$66;

  @BuiltValueEnumConst(wireName: '67')
  static const RoomSetPermissionsPermissions $67 = _$roomSetPermissionsPermissions$67;

  @BuiltValueEnumConst(wireName: '68')
  static const RoomSetPermissionsPermissions $68 = _$roomSetPermissionsPermissions$68;

  @BuiltValueEnumConst(wireName: '69')
  static const RoomSetPermissionsPermissions $69 = _$roomSetPermissionsPermissions$69;

  @BuiltValueEnumConst(wireName: '70')
  static const RoomSetPermissionsPermissions $70 = _$roomSetPermissionsPermissions$70;

  @BuiltValueEnumConst(wireName: '71')
  static const RoomSetPermissionsPermissions $71 = _$roomSetPermissionsPermissions$71;

  @BuiltValueEnumConst(wireName: '72')
  static const RoomSetPermissionsPermissions $72 = _$roomSetPermissionsPermissions$72;

  @BuiltValueEnumConst(wireName: '73')
  static const RoomSetPermissionsPermissions $73 = _$roomSetPermissionsPermissions$73;

  @BuiltValueEnumConst(wireName: '74')
  static const RoomSetPermissionsPermissions $74 = _$roomSetPermissionsPermissions$74;

  @BuiltValueEnumConst(wireName: '75')
  static const RoomSetPermissionsPermissions $75 = _$roomSetPermissionsPermissions$75;

  @BuiltValueEnumConst(wireName: '76')
  static const RoomSetPermissionsPermissions $76 = _$roomSetPermissionsPermissions$76;

  @BuiltValueEnumConst(wireName: '77')
  static const RoomSetPermissionsPermissions $77 = _$roomSetPermissionsPermissions$77;

  @BuiltValueEnumConst(wireName: '78')
  static const RoomSetPermissionsPermissions $78 = _$roomSetPermissionsPermissions$78;

  @BuiltValueEnumConst(wireName: '79')
  static const RoomSetPermissionsPermissions $79 = _$roomSetPermissionsPermissions$79;

  @BuiltValueEnumConst(wireName: '80')
  static const RoomSetPermissionsPermissions $80 = _$roomSetPermissionsPermissions$80;

  @BuiltValueEnumConst(wireName: '81')
  static const RoomSetPermissionsPermissions $81 = _$roomSetPermissionsPermissions$81;

  @BuiltValueEnumConst(wireName: '82')
  static const RoomSetPermissionsPermissions $82 = _$roomSetPermissionsPermissions$82;

  @BuiltValueEnumConst(wireName: '83')
  static const RoomSetPermissionsPermissions $83 = _$roomSetPermissionsPermissions$83;

  @BuiltValueEnumConst(wireName: '84')
  static const RoomSetPermissionsPermissions $84 = _$roomSetPermissionsPermissions$84;

  @BuiltValueEnumConst(wireName: '85')
  static const RoomSetPermissionsPermissions $85 = _$roomSetPermissionsPermissions$85;

  @BuiltValueEnumConst(wireName: '86')
  static const RoomSetPermissionsPermissions $86 = _$roomSetPermissionsPermissions$86;

  @BuiltValueEnumConst(wireName: '87')
  static const RoomSetPermissionsPermissions $87 = _$roomSetPermissionsPermissions$87;

  @BuiltValueEnumConst(wireName: '88')
  static const RoomSetPermissionsPermissions $88 = _$roomSetPermissionsPermissions$88;

  @BuiltValueEnumConst(wireName: '89')
  static const RoomSetPermissionsPermissions $89 = _$roomSetPermissionsPermissions$89;

  @BuiltValueEnumConst(wireName: '90')
  static const RoomSetPermissionsPermissions $90 = _$roomSetPermissionsPermissions$90;

  @BuiltValueEnumConst(wireName: '91')
  static const RoomSetPermissionsPermissions $91 = _$roomSetPermissionsPermissions$91;

  @BuiltValueEnumConst(wireName: '92')
  static const RoomSetPermissionsPermissions $92 = _$roomSetPermissionsPermissions$92;

  @BuiltValueEnumConst(wireName: '93')
  static const RoomSetPermissionsPermissions $93 = _$roomSetPermissionsPermissions$93;

  @BuiltValueEnumConst(wireName: '94')
  static const RoomSetPermissionsPermissions $94 = _$roomSetPermissionsPermissions$94;

  @BuiltValueEnumConst(wireName: '95')
  static const RoomSetPermissionsPermissions $95 = _$roomSetPermissionsPermissions$95;

  @BuiltValueEnumConst(wireName: '96')
  static const RoomSetPermissionsPermissions $96 = _$roomSetPermissionsPermissions$96;

  @BuiltValueEnumConst(wireName: '97')
  static const RoomSetPermissionsPermissions $97 = _$roomSetPermissionsPermissions$97;

  @BuiltValueEnumConst(wireName: '98')
  static const RoomSetPermissionsPermissions $98 = _$roomSetPermissionsPermissions$98;

  @BuiltValueEnumConst(wireName: '99')
  static const RoomSetPermissionsPermissions $99 = _$roomSetPermissionsPermissions$99;

  @BuiltValueEnumConst(wireName: '100')
  static const RoomSetPermissionsPermissions $100 = _$roomSetPermissionsPermissions$100;

  @BuiltValueEnumConst(wireName: '101')
  static const RoomSetPermissionsPermissions $101 = _$roomSetPermissionsPermissions$101;

  @BuiltValueEnumConst(wireName: '102')
  static const RoomSetPermissionsPermissions $102 = _$roomSetPermissionsPermissions$102;

  @BuiltValueEnumConst(wireName: '103')
  static const RoomSetPermissionsPermissions $103 = _$roomSetPermissionsPermissions$103;

  @BuiltValueEnumConst(wireName: '104')
  static const RoomSetPermissionsPermissions $104 = _$roomSetPermissionsPermissions$104;

  @BuiltValueEnumConst(wireName: '105')
  static const RoomSetPermissionsPermissions $105 = _$roomSetPermissionsPermissions$105;

  @BuiltValueEnumConst(wireName: '106')
  static const RoomSetPermissionsPermissions $106 = _$roomSetPermissionsPermissions$106;

  @BuiltValueEnumConst(wireName: '107')
  static const RoomSetPermissionsPermissions $107 = _$roomSetPermissionsPermissions$107;

  @BuiltValueEnumConst(wireName: '108')
  static const RoomSetPermissionsPermissions $108 = _$roomSetPermissionsPermissions$108;

  @BuiltValueEnumConst(wireName: '109')
  static const RoomSetPermissionsPermissions $109 = _$roomSetPermissionsPermissions$109;

  @BuiltValueEnumConst(wireName: '110')
  static const RoomSetPermissionsPermissions $110 = _$roomSetPermissionsPermissions$110;

  @BuiltValueEnumConst(wireName: '111')
  static const RoomSetPermissionsPermissions $111 = _$roomSetPermissionsPermissions$111;

  @BuiltValueEnumConst(wireName: '112')
  static const RoomSetPermissionsPermissions $112 = _$roomSetPermissionsPermissions$112;

  @BuiltValueEnumConst(wireName: '113')
  static const RoomSetPermissionsPermissions $113 = _$roomSetPermissionsPermissions$113;

  @BuiltValueEnumConst(wireName: '114')
  static const RoomSetPermissionsPermissions $114 = _$roomSetPermissionsPermissions$114;

  @BuiltValueEnumConst(wireName: '115')
  static const RoomSetPermissionsPermissions $115 = _$roomSetPermissionsPermissions$115;

  @BuiltValueEnumConst(wireName: '116')
  static const RoomSetPermissionsPermissions $116 = _$roomSetPermissionsPermissions$116;

  @BuiltValueEnumConst(wireName: '117')
  static const RoomSetPermissionsPermissions $117 = _$roomSetPermissionsPermissions$117;

  @BuiltValueEnumConst(wireName: '118')
  static const RoomSetPermissionsPermissions $118 = _$roomSetPermissionsPermissions$118;

  @BuiltValueEnumConst(wireName: '119')
  static const RoomSetPermissionsPermissions $119 = _$roomSetPermissionsPermissions$119;

  @BuiltValueEnumConst(wireName: '120')
  static const RoomSetPermissionsPermissions $120 = _$roomSetPermissionsPermissions$120;

  @BuiltValueEnumConst(wireName: '121')
  static const RoomSetPermissionsPermissions $121 = _$roomSetPermissionsPermissions$121;

  @BuiltValueEnumConst(wireName: '122')
  static const RoomSetPermissionsPermissions $122 = _$roomSetPermissionsPermissions$122;

  @BuiltValueEnumConst(wireName: '123')
  static const RoomSetPermissionsPermissions $123 = _$roomSetPermissionsPermissions$123;

  @BuiltValueEnumConst(wireName: '124')
  static const RoomSetPermissionsPermissions $124 = _$roomSetPermissionsPermissions$124;

  @BuiltValueEnumConst(wireName: '125')
  static const RoomSetPermissionsPermissions $125 = _$roomSetPermissionsPermissions$125;

  @BuiltValueEnumConst(wireName: '126')
  static const RoomSetPermissionsPermissions $126 = _$roomSetPermissionsPermissions$126;

  @BuiltValueEnumConst(wireName: '127')
  static const RoomSetPermissionsPermissions $127 = _$roomSetPermissionsPermissions$127;

  @BuiltValueEnumConst(wireName: '128')
  static const RoomSetPermissionsPermissions $128 = _$roomSetPermissionsPermissions$128;

  @BuiltValueEnumConst(wireName: '129')
  static const RoomSetPermissionsPermissions $129 = _$roomSetPermissionsPermissions$129;

  @BuiltValueEnumConst(wireName: '130')
  static const RoomSetPermissionsPermissions $130 = _$roomSetPermissionsPermissions$130;

  @BuiltValueEnumConst(wireName: '131')
  static const RoomSetPermissionsPermissions $131 = _$roomSetPermissionsPermissions$131;

  @BuiltValueEnumConst(wireName: '132')
  static const RoomSetPermissionsPermissions $132 = _$roomSetPermissionsPermissions$132;

  @BuiltValueEnumConst(wireName: '133')
  static const RoomSetPermissionsPermissions $133 = _$roomSetPermissionsPermissions$133;

  @BuiltValueEnumConst(wireName: '134')
  static const RoomSetPermissionsPermissions $134 = _$roomSetPermissionsPermissions$134;

  @BuiltValueEnumConst(wireName: '135')
  static const RoomSetPermissionsPermissions $135 = _$roomSetPermissionsPermissions$135;

  @BuiltValueEnumConst(wireName: '136')
  static const RoomSetPermissionsPermissions $136 = _$roomSetPermissionsPermissions$136;

  @BuiltValueEnumConst(wireName: '137')
  static const RoomSetPermissionsPermissions $137 = _$roomSetPermissionsPermissions$137;

  @BuiltValueEnumConst(wireName: '138')
  static const RoomSetPermissionsPermissions $138 = _$roomSetPermissionsPermissions$138;

  @BuiltValueEnumConst(wireName: '139')
  static const RoomSetPermissionsPermissions $139 = _$roomSetPermissionsPermissions$139;

  @BuiltValueEnumConst(wireName: '140')
  static const RoomSetPermissionsPermissions $140 = _$roomSetPermissionsPermissions$140;

  @BuiltValueEnumConst(wireName: '141')
  static const RoomSetPermissionsPermissions $141 = _$roomSetPermissionsPermissions$141;

  @BuiltValueEnumConst(wireName: '142')
  static const RoomSetPermissionsPermissions $142 = _$roomSetPermissionsPermissions$142;

  @BuiltValueEnumConst(wireName: '143')
  static const RoomSetPermissionsPermissions $143 = _$roomSetPermissionsPermissions$143;

  @BuiltValueEnumConst(wireName: '144')
  static const RoomSetPermissionsPermissions $144 = _$roomSetPermissionsPermissions$144;

  @BuiltValueEnumConst(wireName: '145')
  static const RoomSetPermissionsPermissions $145 = _$roomSetPermissionsPermissions$145;

  @BuiltValueEnumConst(wireName: '146')
  static const RoomSetPermissionsPermissions $146 = _$roomSetPermissionsPermissions$146;

  @BuiltValueEnumConst(wireName: '147')
  static const RoomSetPermissionsPermissions $147 = _$roomSetPermissionsPermissions$147;

  @BuiltValueEnumConst(wireName: '148')
  static const RoomSetPermissionsPermissions $148 = _$roomSetPermissionsPermissions$148;

  @BuiltValueEnumConst(wireName: '149')
  static const RoomSetPermissionsPermissions $149 = _$roomSetPermissionsPermissions$149;

  @BuiltValueEnumConst(wireName: '150')
  static const RoomSetPermissionsPermissions $150 = _$roomSetPermissionsPermissions$150;

  @BuiltValueEnumConst(wireName: '151')
  static const RoomSetPermissionsPermissions $151 = _$roomSetPermissionsPermissions$151;

  @BuiltValueEnumConst(wireName: '152')
  static const RoomSetPermissionsPermissions $152 = _$roomSetPermissionsPermissions$152;

  @BuiltValueEnumConst(wireName: '153')
  static const RoomSetPermissionsPermissions $153 = _$roomSetPermissionsPermissions$153;

  @BuiltValueEnumConst(wireName: '154')
  static const RoomSetPermissionsPermissions $154 = _$roomSetPermissionsPermissions$154;

  @BuiltValueEnumConst(wireName: '155')
  static const RoomSetPermissionsPermissions $155 = _$roomSetPermissionsPermissions$155;

  @BuiltValueEnumConst(wireName: '156')
  static const RoomSetPermissionsPermissions $156 = _$roomSetPermissionsPermissions$156;

  @BuiltValueEnumConst(wireName: '157')
  static const RoomSetPermissionsPermissions $157 = _$roomSetPermissionsPermissions$157;

  @BuiltValueEnumConst(wireName: '158')
  static const RoomSetPermissionsPermissions $158 = _$roomSetPermissionsPermissions$158;

  @BuiltValueEnumConst(wireName: '159')
  static const RoomSetPermissionsPermissions $159 = _$roomSetPermissionsPermissions$159;

  @BuiltValueEnumConst(wireName: '160')
  static const RoomSetPermissionsPermissions $160 = _$roomSetPermissionsPermissions$160;

  @BuiltValueEnumConst(wireName: '161')
  static const RoomSetPermissionsPermissions $161 = _$roomSetPermissionsPermissions$161;

  @BuiltValueEnumConst(wireName: '162')
  static const RoomSetPermissionsPermissions $162 = _$roomSetPermissionsPermissions$162;

  @BuiltValueEnumConst(wireName: '163')
  static const RoomSetPermissionsPermissions $163 = _$roomSetPermissionsPermissions$163;

  @BuiltValueEnumConst(wireName: '164')
  static const RoomSetPermissionsPermissions $164 = _$roomSetPermissionsPermissions$164;

  @BuiltValueEnumConst(wireName: '165')
  static const RoomSetPermissionsPermissions $165 = _$roomSetPermissionsPermissions$165;

  @BuiltValueEnumConst(wireName: '166')
  static const RoomSetPermissionsPermissions $166 = _$roomSetPermissionsPermissions$166;

  @BuiltValueEnumConst(wireName: '167')
  static const RoomSetPermissionsPermissions $167 = _$roomSetPermissionsPermissions$167;

  @BuiltValueEnumConst(wireName: '168')
  static const RoomSetPermissionsPermissions $168 = _$roomSetPermissionsPermissions$168;

  @BuiltValueEnumConst(wireName: '169')
  static const RoomSetPermissionsPermissions $169 = _$roomSetPermissionsPermissions$169;

  @BuiltValueEnumConst(wireName: '170')
  static const RoomSetPermissionsPermissions $170 = _$roomSetPermissionsPermissions$170;

  @BuiltValueEnumConst(wireName: '171')
  static const RoomSetPermissionsPermissions $171 = _$roomSetPermissionsPermissions$171;

  @BuiltValueEnumConst(wireName: '172')
  static const RoomSetPermissionsPermissions $172 = _$roomSetPermissionsPermissions$172;

  @BuiltValueEnumConst(wireName: '173')
  static const RoomSetPermissionsPermissions $173 = _$roomSetPermissionsPermissions$173;

  @BuiltValueEnumConst(wireName: '174')
  static const RoomSetPermissionsPermissions $174 = _$roomSetPermissionsPermissions$174;

  @BuiltValueEnumConst(wireName: '175')
  static const RoomSetPermissionsPermissions $175 = _$roomSetPermissionsPermissions$175;

  @BuiltValueEnumConst(wireName: '176')
  static const RoomSetPermissionsPermissions $176 = _$roomSetPermissionsPermissions$176;

  @BuiltValueEnumConst(wireName: '177')
  static const RoomSetPermissionsPermissions $177 = _$roomSetPermissionsPermissions$177;

  @BuiltValueEnumConst(wireName: '178')
  static const RoomSetPermissionsPermissions $178 = _$roomSetPermissionsPermissions$178;

  @BuiltValueEnumConst(wireName: '179')
  static const RoomSetPermissionsPermissions $179 = _$roomSetPermissionsPermissions$179;

  @BuiltValueEnumConst(wireName: '180')
  static const RoomSetPermissionsPermissions $180 = _$roomSetPermissionsPermissions$180;

  @BuiltValueEnumConst(wireName: '181')
  static const RoomSetPermissionsPermissions $181 = _$roomSetPermissionsPermissions$181;

  @BuiltValueEnumConst(wireName: '182')
  static const RoomSetPermissionsPermissions $182 = _$roomSetPermissionsPermissions$182;

  @BuiltValueEnumConst(wireName: '183')
  static const RoomSetPermissionsPermissions $183 = _$roomSetPermissionsPermissions$183;

  @BuiltValueEnumConst(wireName: '184')
  static const RoomSetPermissionsPermissions $184 = _$roomSetPermissionsPermissions$184;

  @BuiltValueEnumConst(wireName: '185')
  static const RoomSetPermissionsPermissions $185 = _$roomSetPermissionsPermissions$185;

  @BuiltValueEnumConst(wireName: '186')
  static const RoomSetPermissionsPermissions $186 = _$roomSetPermissionsPermissions$186;

  @BuiltValueEnumConst(wireName: '187')
  static const RoomSetPermissionsPermissions $187 = _$roomSetPermissionsPermissions$187;

  @BuiltValueEnumConst(wireName: '188')
  static const RoomSetPermissionsPermissions $188 = _$roomSetPermissionsPermissions$188;

  @BuiltValueEnumConst(wireName: '189')
  static const RoomSetPermissionsPermissions $189 = _$roomSetPermissionsPermissions$189;

  @BuiltValueEnumConst(wireName: '190')
  static const RoomSetPermissionsPermissions $190 = _$roomSetPermissionsPermissions$190;

  @BuiltValueEnumConst(wireName: '191')
  static const RoomSetPermissionsPermissions $191 = _$roomSetPermissionsPermissions$191;

  @BuiltValueEnumConst(wireName: '192')
  static const RoomSetPermissionsPermissions $192 = _$roomSetPermissionsPermissions$192;

  @BuiltValueEnumConst(wireName: '193')
  static const RoomSetPermissionsPermissions $193 = _$roomSetPermissionsPermissions$193;

  @BuiltValueEnumConst(wireName: '194')
  static const RoomSetPermissionsPermissions $194 = _$roomSetPermissionsPermissions$194;

  @BuiltValueEnumConst(wireName: '195')
  static const RoomSetPermissionsPermissions $195 = _$roomSetPermissionsPermissions$195;

  @BuiltValueEnumConst(wireName: '196')
  static const RoomSetPermissionsPermissions $196 = _$roomSetPermissionsPermissions$196;

  @BuiltValueEnumConst(wireName: '197')
  static const RoomSetPermissionsPermissions $197 = _$roomSetPermissionsPermissions$197;

  @BuiltValueEnumConst(wireName: '198')
  static const RoomSetPermissionsPermissions $198 = _$roomSetPermissionsPermissions$198;

  @BuiltValueEnumConst(wireName: '199')
  static const RoomSetPermissionsPermissions $199 = _$roomSetPermissionsPermissions$199;

  @BuiltValueEnumConst(wireName: '200')
  static const RoomSetPermissionsPermissions $200 = _$roomSetPermissionsPermissions$200;

  @BuiltValueEnumConst(wireName: '201')
  static const RoomSetPermissionsPermissions $201 = _$roomSetPermissionsPermissions$201;

  @BuiltValueEnumConst(wireName: '202')
  static const RoomSetPermissionsPermissions $202 = _$roomSetPermissionsPermissions$202;

  @BuiltValueEnumConst(wireName: '203')
  static const RoomSetPermissionsPermissions $203 = _$roomSetPermissionsPermissions$203;

  @BuiltValueEnumConst(wireName: '204')
  static const RoomSetPermissionsPermissions $204 = _$roomSetPermissionsPermissions$204;

  @BuiltValueEnumConst(wireName: '205')
  static const RoomSetPermissionsPermissions $205 = _$roomSetPermissionsPermissions$205;

  @BuiltValueEnumConst(wireName: '206')
  static const RoomSetPermissionsPermissions $206 = _$roomSetPermissionsPermissions$206;

  @BuiltValueEnumConst(wireName: '207')
  static const RoomSetPermissionsPermissions $207 = _$roomSetPermissionsPermissions$207;

  @BuiltValueEnumConst(wireName: '208')
  static const RoomSetPermissionsPermissions $208 = _$roomSetPermissionsPermissions$208;

  @BuiltValueEnumConst(wireName: '209')
  static const RoomSetPermissionsPermissions $209 = _$roomSetPermissionsPermissions$209;

  @BuiltValueEnumConst(wireName: '210')
  static const RoomSetPermissionsPermissions $210 = _$roomSetPermissionsPermissions$210;

  @BuiltValueEnumConst(wireName: '211')
  static const RoomSetPermissionsPermissions $211 = _$roomSetPermissionsPermissions$211;

  @BuiltValueEnumConst(wireName: '212')
  static const RoomSetPermissionsPermissions $212 = _$roomSetPermissionsPermissions$212;

  @BuiltValueEnumConst(wireName: '213')
  static const RoomSetPermissionsPermissions $213 = _$roomSetPermissionsPermissions$213;

  @BuiltValueEnumConst(wireName: '214')
  static const RoomSetPermissionsPermissions $214 = _$roomSetPermissionsPermissions$214;

  @BuiltValueEnumConst(wireName: '215')
  static const RoomSetPermissionsPermissions $215 = _$roomSetPermissionsPermissions$215;

  @BuiltValueEnumConst(wireName: '216')
  static const RoomSetPermissionsPermissions $216 = _$roomSetPermissionsPermissions$216;

  @BuiltValueEnumConst(wireName: '217')
  static const RoomSetPermissionsPermissions $217 = _$roomSetPermissionsPermissions$217;

  @BuiltValueEnumConst(wireName: '218')
  static const RoomSetPermissionsPermissions $218 = _$roomSetPermissionsPermissions$218;

  @BuiltValueEnumConst(wireName: '219')
  static const RoomSetPermissionsPermissions $219 = _$roomSetPermissionsPermissions$219;

  @BuiltValueEnumConst(wireName: '220')
  static const RoomSetPermissionsPermissions $220 = _$roomSetPermissionsPermissions$220;

  @BuiltValueEnumConst(wireName: '221')
  static const RoomSetPermissionsPermissions $221 = _$roomSetPermissionsPermissions$221;

  @BuiltValueEnumConst(wireName: '222')
  static const RoomSetPermissionsPermissions $222 = _$roomSetPermissionsPermissions$222;

  @BuiltValueEnumConst(wireName: '223')
  static const RoomSetPermissionsPermissions $223 = _$roomSetPermissionsPermissions$223;

  @BuiltValueEnumConst(wireName: '224')
  static const RoomSetPermissionsPermissions $224 = _$roomSetPermissionsPermissions$224;

  @BuiltValueEnumConst(wireName: '225')
  static const RoomSetPermissionsPermissions $225 = _$roomSetPermissionsPermissions$225;

  @BuiltValueEnumConst(wireName: '226')
  static const RoomSetPermissionsPermissions $226 = _$roomSetPermissionsPermissions$226;

  @BuiltValueEnumConst(wireName: '227')
  static const RoomSetPermissionsPermissions $227 = _$roomSetPermissionsPermissions$227;

  @BuiltValueEnumConst(wireName: '228')
  static const RoomSetPermissionsPermissions $228 = _$roomSetPermissionsPermissions$228;

  @BuiltValueEnumConst(wireName: '229')
  static const RoomSetPermissionsPermissions $229 = _$roomSetPermissionsPermissions$229;

  @BuiltValueEnumConst(wireName: '230')
  static const RoomSetPermissionsPermissions $230 = _$roomSetPermissionsPermissions$230;

  @BuiltValueEnumConst(wireName: '231')
  static const RoomSetPermissionsPermissions $231 = _$roomSetPermissionsPermissions$231;

  @BuiltValueEnumConst(wireName: '232')
  static const RoomSetPermissionsPermissions $232 = _$roomSetPermissionsPermissions$232;

  @BuiltValueEnumConst(wireName: '233')
  static const RoomSetPermissionsPermissions $233 = _$roomSetPermissionsPermissions$233;

  @BuiltValueEnumConst(wireName: '234')
  static const RoomSetPermissionsPermissions $234 = _$roomSetPermissionsPermissions$234;

  @BuiltValueEnumConst(wireName: '235')
  static const RoomSetPermissionsPermissions $235 = _$roomSetPermissionsPermissions$235;

  @BuiltValueEnumConst(wireName: '236')
  static const RoomSetPermissionsPermissions $236 = _$roomSetPermissionsPermissions$236;

  @BuiltValueEnumConst(wireName: '237')
  static const RoomSetPermissionsPermissions $237 = _$roomSetPermissionsPermissions$237;

  @BuiltValueEnumConst(wireName: '238')
  static const RoomSetPermissionsPermissions $238 = _$roomSetPermissionsPermissions$238;

  @BuiltValueEnumConst(wireName: '239')
  static const RoomSetPermissionsPermissions $239 = _$roomSetPermissionsPermissions$239;

  @BuiltValueEnumConst(wireName: '240')
  static const RoomSetPermissionsPermissions $240 = _$roomSetPermissionsPermissions$240;

  @BuiltValueEnumConst(wireName: '241')
  static const RoomSetPermissionsPermissions $241 = _$roomSetPermissionsPermissions$241;

  @BuiltValueEnumConst(wireName: '242')
  static const RoomSetPermissionsPermissions $242 = _$roomSetPermissionsPermissions$242;

  @BuiltValueEnumConst(wireName: '243')
  static const RoomSetPermissionsPermissions $243 = _$roomSetPermissionsPermissions$243;

  @BuiltValueEnumConst(wireName: '244')
  static const RoomSetPermissionsPermissions $244 = _$roomSetPermissionsPermissions$244;

  @BuiltValueEnumConst(wireName: '245')
  static const RoomSetPermissionsPermissions $245 = _$roomSetPermissionsPermissions$245;

  @BuiltValueEnumConst(wireName: '246')
  static const RoomSetPermissionsPermissions $246 = _$roomSetPermissionsPermissions$246;

  @BuiltValueEnumConst(wireName: '247')
  static const RoomSetPermissionsPermissions $247 = _$roomSetPermissionsPermissions$247;

  @BuiltValueEnumConst(wireName: '248')
  static const RoomSetPermissionsPermissions $248 = _$roomSetPermissionsPermissions$248;

  @BuiltValueEnumConst(wireName: '249')
  static const RoomSetPermissionsPermissions $249 = _$roomSetPermissionsPermissions$249;

  @BuiltValueEnumConst(wireName: '250')
  static const RoomSetPermissionsPermissions $250 = _$roomSetPermissionsPermissions$250;

  @BuiltValueEnumConst(wireName: '251')
  static const RoomSetPermissionsPermissions $251 = _$roomSetPermissionsPermissions$251;

  @BuiltValueEnumConst(wireName: '252')
  static const RoomSetPermissionsPermissions $252 = _$roomSetPermissionsPermissions$252;

  @BuiltValueEnumConst(wireName: '253')
  static const RoomSetPermissionsPermissions $253 = _$roomSetPermissionsPermissions$253;

  @BuiltValueEnumConst(wireName: '254')
  static const RoomSetPermissionsPermissions $254 = _$roomSetPermissionsPermissions$254;

  @BuiltValueEnumConst(wireName: '255')
  static const RoomSetPermissionsPermissions $255 = _$roomSetPermissionsPermissions$255;

  // coverage:ignore-start
  static BuiltSet<RoomSetPermissionsPermissions> get values => _$roomSetPermissionsPermissionsValues;
  // coverage:ignore-end

  static RoomSetPermissionsPermissions valueOf(String name) => _$valueOfRoomSetPermissionsPermissions(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetPermissionsPermissions> get serializer => const _$RoomSetPermissionsPermissionsSerializer();
}

class _$RoomSetPermissionsPermissionsSerializer implements PrimitiveSerializer<RoomSetPermissionsPermissions> {
  const _$RoomSetPermissionsPermissionsSerializer();

  static const Map<RoomSetPermissionsPermissions, Object> _toWire = <RoomSetPermissionsPermissions, Object>{
    RoomSetPermissionsPermissions.$0: 0,
    RoomSetPermissionsPermissions.$1: 1,
    RoomSetPermissionsPermissions.$2: 2,
    RoomSetPermissionsPermissions.$3: 3,
    RoomSetPermissionsPermissions.$4: 4,
    RoomSetPermissionsPermissions.$5: 5,
    RoomSetPermissionsPermissions.$6: 6,
    RoomSetPermissionsPermissions.$7: 7,
    RoomSetPermissionsPermissions.$8: 8,
    RoomSetPermissionsPermissions.$9: 9,
    RoomSetPermissionsPermissions.$10: 10,
    RoomSetPermissionsPermissions.$11: 11,
    RoomSetPermissionsPermissions.$12: 12,
    RoomSetPermissionsPermissions.$13: 13,
    RoomSetPermissionsPermissions.$14: 14,
    RoomSetPermissionsPermissions.$15: 15,
    RoomSetPermissionsPermissions.$16: 16,
    RoomSetPermissionsPermissions.$17: 17,
    RoomSetPermissionsPermissions.$18: 18,
    RoomSetPermissionsPermissions.$19: 19,
    RoomSetPermissionsPermissions.$20: 20,
    RoomSetPermissionsPermissions.$21: 21,
    RoomSetPermissionsPermissions.$22: 22,
    RoomSetPermissionsPermissions.$23: 23,
    RoomSetPermissionsPermissions.$24: 24,
    RoomSetPermissionsPermissions.$25: 25,
    RoomSetPermissionsPermissions.$26: 26,
    RoomSetPermissionsPermissions.$27: 27,
    RoomSetPermissionsPermissions.$28: 28,
    RoomSetPermissionsPermissions.$29: 29,
    RoomSetPermissionsPermissions.$30: 30,
    RoomSetPermissionsPermissions.$31: 31,
    RoomSetPermissionsPermissions.$32: 32,
    RoomSetPermissionsPermissions.$33: 33,
    RoomSetPermissionsPermissions.$34: 34,
    RoomSetPermissionsPermissions.$35: 35,
    RoomSetPermissionsPermissions.$36: 36,
    RoomSetPermissionsPermissions.$37: 37,
    RoomSetPermissionsPermissions.$38: 38,
    RoomSetPermissionsPermissions.$39: 39,
    RoomSetPermissionsPermissions.$40: 40,
    RoomSetPermissionsPermissions.$41: 41,
    RoomSetPermissionsPermissions.$42: 42,
    RoomSetPermissionsPermissions.$43: 43,
    RoomSetPermissionsPermissions.$44: 44,
    RoomSetPermissionsPermissions.$45: 45,
    RoomSetPermissionsPermissions.$46: 46,
    RoomSetPermissionsPermissions.$47: 47,
    RoomSetPermissionsPermissions.$48: 48,
    RoomSetPermissionsPermissions.$49: 49,
    RoomSetPermissionsPermissions.$50: 50,
    RoomSetPermissionsPermissions.$51: 51,
    RoomSetPermissionsPermissions.$52: 52,
    RoomSetPermissionsPermissions.$53: 53,
    RoomSetPermissionsPermissions.$54: 54,
    RoomSetPermissionsPermissions.$55: 55,
    RoomSetPermissionsPermissions.$56: 56,
    RoomSetPermissionsPermissions.$57: 57,
    RoomSetPermissionsPermissions.$58: 58,
    RoomSetPermissionsPermissions.$59: 59,
    RoomSetPermissionsPermissions.$60: 60,
    RoomSetPermissionsPermissions.$61: 61,
    RoomSetPermissionsPermissions.$62: 62,
    RoomSetPermissionsPermissions.$63: 63,
    RoomSetPermissionsPermissions.$64: 64,
    RoomSetPermissionsPermissions.$65: 65,
    RoomSetPermissionsPermissions.$66: 66,
    RoomSetPermissionsPermissions.$67: 67,
    RoomSetPermissionsPermissions.$68: 68,
    RoomSetPermissionsPermissions.$69: 69,
    RoomSetPermissionsPermissions.$70: 70,
    RoomSetPermissionsPermissions.$71: 71,
    RoomSetPermissionsPermissions.$72: 72,
    RoomSetPermissionsPermissions.$73: 73,
    RoomSetPermissionsPermissions.$74: 74,
    RoomSetPermissionsPermissions.$75: 75,
    RoomSetPermissionsPermissions.$76: 76,
    RoomSetPermissionsPermissions.$77: 77,
    RoomSetPermissionsPermissions.$78: 78,
    RoomSetPermissionsPermissions.$79: 79,
    RoomSetPermissionsPermissions.$80: 80,
    RoomSetPermissionsPermissions.$81: 81,
    RoomSetPermissionsPermissions.$82: 82,
    RoomSetPermissionsPermissions.$83: 83,
    RoomSetPermissionsPermissions.$84: 84,
    RoomSetPermissionsPermissions.$85: 85,
    RoomSetPermissionsPermissions.$86: 86,
    RoomSetPermissionsPermissions.$87: 87,
    RoomSetPermissionsPermissions.$88: 88,
    RoomSetPermissionsPermissions.$89: 89,
    RoomSetPermissionsPermissions.$90: 90,
    RoomSetPermissionsPermissions.$91: 91,
    RoomSetPermissionsPermissions.$92: 92,
    RoomSetPermissionsPermissions.$93: 93,
    RoomSetPermissionsPermissions.$94: 94,
    RoomSetPermissionsPermissions.$95: 95,
    RoomSetPermissionsPermissions.$96: 96,
    RoomSetPermissionsPermissions.$97: 97,
    RoomSetPermissionsPermissions.$98: 98,
    RoomSetPermissionsPermissions.$99: 99,
    RoomSetPermissionsPermissions.$100: 100,
    RoomSetPermissionsPermissions.$101: 101,
    RoomSetPermissionsPermissions.$102: 102,
    RoomSetPermissionsPermissions.$103: 103,
    RoomSetPermissionsPermissions.$104: 104,
    RoomSetPermissionsPermissions.$105: 105,
    RoomSetPermissionsPermissions.$106: 106,
    RoomSetPermissionsPermissions.$107: 107,
    RoomSetPermissionsPermissions.$108: 108,
    RoomSetPermissionsPermissions.$109: 109,
    RoomSetPermissionsPermissions.$110: 110,
    RoomSetPermissionsPermissions.$111: 111,
    RoomSetPermissionsPermissions.$112: 112,
    RoomSetPermissionsPermissions.$113: 113,
    RoomSetPermissionsPermissions.$114: 114,
    RoomSetPermissionsPermissions.$115: 115,
    RoomSetPermissionsPermissions.$116: 116,
    RoomSetPermissionsPermissions.$117: 117,
    RoomSetPermissionsPermissions.$118: 118,
    RoomSetPermissionsPermissions.$119: 119,
    RoomSetPermissionsPermissions.$120: 120,
    RoomSetPermissionsPermissions.$121: 121,
    RoomSetPermissionsPermissions.$122: 122,
    RoomSetPermissionsPermissions.$123: 123,
    RoomSetPermissionsPermissions.$124: 124,
    RoomSetPermissionsPermissions.$125: 125,
    RoomSetPermissionsPermissions.$126: 126,
    RoomSetPermissionsPermissions.$127: 127,
    RoomSetPermissionsPermissions.$128: 128,
    RoomSetPermissionsPermissions.$129: 129,
    RoomSetPermissionsPermissions.$130: 130,
    RoomSetPermissionsPermissions.$131: 131,
    RoomSetPermissionsPermissions.$132: 132,
    RoomSetPermissionsPermissions.$133: 133,
    RoomSetPermissionsPermissions.$134: 134,
    RoomSetPermissionsPermissions.$135: 135,
    RoomSetPermissionsPermissions.$136: 136,
    RoomSetPermissionsPermissions.$137: 137,
    RoomSetPermissionsPermissions.$138: 138,
    RoomSetPermissionsPermissions.$139: 139,
    RoomSetPermissionsPermissions.$140: 140,
    RoomSetPermissionsPermissions.$141: 141,
    RoomSetPermissionsPermissions.$142: 142,
    RoomSetPermissionsPermissions.$143: 143,
    RoomSetPermissionsPermissions.$144: 144,
    RoomSetPermissionsPermissions.$145: 145,
    RoomSetPermissionsPermissions.$146: 146,
    RoomSetPermissionsPermissions.$147: 147,
    RoomSetPermissionsPermissions.$148: 148,
    RoomSetPermissionsPermissions.$149: 149,
    RoomSetPermissionsPermissions.$150: 150,
    RoomSetPermissionsPermissions.$151: 151,
    RoomSetPermissionsPermissions.$152: 152,
    RoomSetPermissionsPermissions.$153: 153,
    RoomSetPermissionsPermissions.$154: 154,
    RoomSetPermissionsPermissions.$155: 155,
    RoomSetPermissionsPermissions.$156: 156,
    RoomSetPermissionsPermissions.$157: 157,
    RoomSetPermissionsPermissions.$158: 158,
    RoomSetPermissionsPermissions.$159: 159,
    RoomSetPermissionsPermissions.$160: 160,
    RoomSetPermissionsPermissions.$161: 161,
    RoomSetPermissionsPermissions.$162: 162,
    RoomSetPermissionsPermissions.$163: 163,
    RoomSetPermissionsPermissions.$164: 164,
    RoomSetPermissionsPermissions.$165: 165,
    RoomSetPermissionsPermissions.$166: 166,
    RoomSetPermissionsPermissions.$167: 167,
    RoomSetPermissionsPermissions.$168: 168,
    RoomSetPermissionsPermissions.$169: 169,
    RoomSetPermissionsPermissions.$170: 170,
    RoomSetPermissionsPermissions.$171: 171,
    RoomSetPermissionsPermissions.$172: 172,
    RoomSetPermissionsPermissions.$173: 173,
    RoomSetPermissionsPermissions.$174: 174,
    RoomSetPermissionsPermissions.$175: 175,
    RoomSetPermissionsPermissions.$176: 176,
    RoomSetPermissionsPermissions.$177: 177,
    RoomSetPermissionsPermissions.$178: 178,
    RoomSetPermissionsPermissions.$179: 179,
    RoomSetPermissionsPermissions.$180: 180,
    RoomSetPermissionsPermissions.$181: 181,
    RoomSetPermissionsPermissions.$182: 182,
    RoomSetPermissionsPermissions.$183: 183,
    RoomSetPermissionsPermissions.$184: 184,
    RoomSetPermissionsPermissions.$185: 185,
    RoomSetPermissionsPermissions.$186: 186,
    RoomSetPermissionsPermissions.$187: 187,
    RoomSetPermissionsPermissions.$188: 188,
    RoomSetPermissionsPermissions.$189: 189,
    RoomSetPermissionsPermissions.$190: 190,
    RoomSetPermissionsPermissions.$191: 191,
    RoomSetPermissionsPermissions.$192: 192,
    RoomSetPermissionsPermissions.$193: 193,
    RoomSetPermissionsPermissions.$194: 194,
    RoomSetPermissionsPermissions.$195: 195,
    RoomSetPermissionsPermissions.$196: 196,
    RoomSetPermissionsPermissions.$197: 197,
    RoomSetPermissionsPermissions.$198: 198,
    RoomSetPermissionsPermissions.$199: 199,
    RoomSetPermissionsPermissions.$200: 200,
    RoomSetPermissionsPermissions.$201: 201,
    RoomSetPermissionsPermissions.$202: 202,
    RoomSetPermissionsPermissions.$203: 203,
    RoomSetPermissionsPermissions.$204: 204,
    RoomSetPermissionsPermissions.$205: 205,
    RoomSetPermissionsPermissions.$206: 206,
    RoomSetPermissionsPermissions.$207: 207,
    RoomSetPermissionsPermissions.$208: 208,
    RoomSetPermissionsPermissions.$209: 209,
    RoomSetPermissionsPermissions.$210: 210,
    RoomSetPermissionsPermissions.$211: 211,
    RoomSetPermissionsPermissions.$212: 212,
    RoomSetPermissionsPermissions.$213: 213,
    RoomSetPermissionsPermissions.$214: 214,
    RoomSetPermissionsPermissions.$215: 215,
    RoomSetPermissionsPermissions.$216: 216,
    RoomSetPermissionsPermissions.$217: 217,
    RoomSetPermissionsPermissions.$218: 218,
    RoomSetPermissionsPermissions.$219: 219,
    RoomSetPermissionsPermissions.$220: 220,
    RoomSetPermissionsPermissions.$221: 221,
    RoomSetPermissionsPermissions.$222: 222,
    RoomSetPermissionsPermissions.$223: 223,
    RoomSetPermissionsPermissions.$224: 224,
    RoomSetPermissionsPermissions.$225: 225,
    RoomSetPermissionsPermissions.$226: 226,
    RoomSetPermissionsPermissions.$227: 227,
    RoomSetPermissionsPermissions.$228: 228,
    RoomSetPermissionsPermissions.$229: 229,
    RoomSetPermissionsPermissions.$230: 230,
    RoomSetPermissionsPermissions.$231: 231,
    RoomSetPermissionsPermissions.$232: 232,
    RoomSetPermissionsPermissions.$233: 233,
    RoomSetPermissionsPermissions.$234: 234,
    RoomSetPermissionsPermissions.$235: 235,
    RoomSetPermissionsPermissions.$236: 236,
    RoomSetPermissionsPermissions.$237: 237,
    RoomSetPermissionsPermissions.$238: 238,
    RoomSetPermissionsPermissions.$239: 239,
    RoomSetPermissionsPermissions.$240: 240,
    RoomSetPermissionsPermissions.$241: 241,
    RoomSetPermissionsPermissions.$242: 242,
    RoomSetPermissionsPermissions.$243: 243,
    RoomSetPermissionsPermissions.$244: 244,
    RoomSetPermissionsPermissions.$245: 245,
    RoomSetPermissionsPermissions.$246: 246,
    RoomSetPermissionsPermissions.$247: 247,
    RoomSetPermissionsPermissions.$248: 248,
    RoomSetPermissionsPermissions.$249: 249,
    RoomSetPermissionsPermissions.$250: 250,
    RoomSetPermissionsPermissions.$251: 251,
    RoomSetPermissionsPermissions.$252: 252,
    RoomSetPermissionsPermissions.$253: 253,
    RoomSetPermissionsPermissions.$254: 254,
    RoomSetPermissionsPermissions.$255: 255,
  };

  static const Map<Object, RoomSetPermissionsPermissions> _fromWire = <Object, RoomSetPermissionsPermissions>{
    0: RoomSetPermissionsPermissions.$0,
    1: RoomSetPermissionsPermissions.$1,
    2: RoomSetPermissionsPermissions.$2,
    3: RoomSetPermissionsPermissions.$3,
    4: RoomSetPermissionsPermissions.$4,
    5: RoomSetPermissionsPermissions.$5,
    6: RoomSetPermissionsPermissions.$6,
    7: RoomSetPermissionsPermissions.$7,
    8: RoomSetPermissionsPermissions.$8,
    9: RoomSetPermissionsPermissions.$9,
    10: RoomSetPermissionsPermissions.$10,
    11: RoomSetPermissionsPermissions.$11,
    12: RoomSetPermissionsPermissions.$12,
    13: RoomSetPermissionsPermissions.$13,
    14: RoomSetPermissionsPermissions.$14,
    15: RoomSetPermissionsPermissions.$15,
    16: RoomSetPermissionsPermissions.$16,
    17: RoomSetPermissionsPermissions.$17,
    18: RoomSetPermissionsPermissions.$18,
    19: RoomSetPermissionsPermissions.$19,
    20: RoomSetPermissionsPermissions.$20,
    21: RoomSetPermissionsPermissions.$21,
    22: RoomSetPermissionsPermissions.$22,
    23: RoomSetPermissionsPermissions.$23,
    24: RoomSetPermissionsPermissions.$24,
    25: RoomSetPermissionsPermissions.$25,
    26: RoomSetPermissionsPermissions.$26,
    27: RoomSetPermissionsPermissions.$27,
    28: RoomSetPermissionsPermissions.$28,
    29: RoomSetPermissionsPermissions.$29,
    30: RoomSetPermissionsPermissions.$30,
    31: RoomSetPermissionsPermissions.$31,
    32: RoomSetPermissionsPermissions.$32,
    33: RoomSetPermissionsPermissions.$33,
    34: RoomSetPermissionsPermissions.$34,
    35: RoomSetPermissionsPermissions.$35,
    36: RoomSetPermissionsPermissions.$36,
    37: RoomSetPermissionsPermissions.$37,
    38: RoomSetPermissionsPermissions.$38,
    39: RoomSetPermissionsPermissions.$39,
    40: RoomSetPermissionsPermissions.$40,
    41: RoomSetPermissionsPermissions.$41,
    42: RoomSetPermissionsPermissions.$42,
    43: RoomSetPermissionsPermissions.$43,
    44: RoomSetPermissionsPermissions.$44,
    45: RoomSetPermissionsPermissions.$45,
    46: RoomSetPermissionsPermissions.$46,
    47: RoomSetPermissionsPermissions.$47,
    48: RoomSetPermissionsPermissions.$48,
    49: RoomSetPermissionsPermissions.$49,
    50: RoomSetPermissionsPermissions.$50,
    51: RoomSetPermissionsPermissions.$51,
    52: RoomSetPermissionsPermissions.$52,
    53: RoomSetPermissionsPermissions.$53,
    54: RoomSetPermissionsPermissions.$54,
    55: RoomSetPermissionsPermissions.$55,
    56: RoomSetPermissionsPermissions.$56,
    57: RoomSetPermissionsPermissions.$57,
    58: RoomSetPermissionsPermissions.$58,
    59: RoomSetPermissionsPermissions.$59,
    60: RoomSetPermissionsPermissions.$60,
    61: RoomSetPermissionsPermissions.$61,
    62: RoomSetPermissionsPermissions.$62,
    63: RoomSetPermissionsPermissions.$63,
    64: RoomSetPermissionsPermissions.$64,
    65: RoomSetPermissionsPermissions.$65,
    66: RoomSetPermissionsPermissions.$66,
    67: RoomSetPermissionsPermissions.$67,
    68: RoomSetPermissionsPermissions.$68,
    69: RoomSetPermissionsPermissions.$69,
    70: RoomSetPermissionsPermissions.$70,
    71: RoomSetPermissionsPermissions.$71,
    72: RoomSetPermissionsPermissions.$72,
    73: RoomSetPermissionsPermissions.$73,
    74: RoomSetPermissionsPermissions.$74,
    75: RoomSetPermissionsPermissions.$75,
    76: RoomSetPermissionsPermissions.$76,
    77: RoomSetPermissionsPermissions.$77,
    78: RoomSetPermissionsPermissions.$78,
    79: RoomSetPermissionsPermissions.$79,
    80: RoomSetPermissionsPermissions.$80,
    81: RoomSetPermissionsPermissions.$81,
    82: RoomSetPermissionsPermissions.$82,
    83: RoomSetPermissionsPermissions.$83,
    84: RoomSetPermissionsPermissions.$84,
    85: RoomSetPermissionsPermissions.$85,
    86: RoomSetPermissionsPermissions.$86,
    87: RoomSetPermissionsPermissions.$87,
    88: RoomSetPermissionsPermissions.$88,
    89: RoomSetPermissionsPermissions.$89,
    90: RoomSetPermissionsPermissions.$90,
    91: RoomSetPermissionsPermissions.$91,
    92: RoomSetPermissionsPermissions.$92,
    93: RoomSetPermissionsPermissions.$93,
    94: RoomSetPermissionsPermissions.$94,
    95: RoomSetPermissionsPermissions.$95,
    96: RoomSetPermissionsPermissions.$96,
    97: RoomSetPermissionsPermissions.$97,
    98: RoomSetPermissionsPermissions.$98,
    99: RoomSetPermissionsPermissions.$99,
    100: RoomSetPermissionsPermissions.$100,
    101: RoomSetPermissionsPermissions.$101,
    102: RoomSetPermissionsPermissions.$102,
    103: RoomSetPermissionsPermissions.$103,
    104: RoomSetPermissionsPermissions.$104,
    105: RoomSetPermissionsPermissions.$105,
    106: RoomSetPermissionsPermissions.$106,
    107: RoomSetPermissionsPermissions.$107,
    108: RoomSetPermissionsPermissions.$108,
    109: RoomSetPermissionsPermissions.$109,
    110: RoomSetPermissionsPermissions.$110,
    111: RoomSetPermissionsPermissions.$111,
    112: RoomSetPermissionsPermissions.$112,
    113: RoomSetPermissionsPermissions.$113,
    114: RoomSetPermissionsPermissions.$114,
    115: RoomSetPermissionsPermissions.$115,
    116: RoomSetPermissionsPermissions.$116,
    117: RoomSetPermissionsPermissions.$117,
    118: RoomSetPermissionsPermissions.$118,
    119: RoomSetPermissionsPermissions.$119,
    120: RoomSetPermissionsPermissions.$120,
    121: RoomSetPermissionsPermissions.$121,
    122: RoomSetPermissionsPermissions.$122,
    123: RoomSetPermissionsPermissions.$123,
    124: RoomSetPermissionsPermissions.$124,
    125: RoomSetPermissionsPermissions.$125,
    126: RoomSetPermissionsPermissions.$126,
    127: RoomSetPermissionsPermissions.$127,
    128: RoomSetPermissionsPermissions.$128,
    129: RoomSetPermissionsPermissions.$129,
    130: RoomSetPermissionsPermissions.$130,
    131: RoomSetPermissionsPermissions.$131,
    132: RoomSetPermissionsPermissions.$132,
    133: RoomSetPermissionsPermissions.$133,
    134: RoomSetPermissionsPermissions.$134,
    135: RoomSetPermissionsPermissions.$135,
    136: RoomSetPermissionsPermissions.$136,
    137: RoomSetPermissionsPermissions.$137,
    138: RoomSetPermissionsPermissions.$138,
    139: RoomSetPermissionsPermissions.$139,
    140: RoomSetPermissionsPermissions.$140,
    141: RoomSetPermissionsPermissions.$141,
    142: RoomSetPermissionsPermissions.$142,
    143: RoomSetPermissionsPermissions.$143,
    144: RoomSetPermissionsPermissions.$144,
    145: RoomSetPermissionsPermissions.$145,
    146: RoomSetPermissionsPermissions.$146,
    147: RoomSetPermissionsPermissions.$147,
    148: RoomSetPermissionsPermissions.$148,
    149: RoomSetPermissionsPermissions.$149,
    150: RoomSetPermissionsPermissions.$150,
    151: RoomSetPermissionsPermissions.$151,
    152: RoomSetPermissionsPermissions.$152,
    153: RoomSetPermissionsPermissions.$153,
    154: RoomSetPermissionsPermissions.$154,
    155: RoomSetPermissionsPermissions.$155,
    156: RoomSetPermissionsPermissions.$156,
    157: RoomSetPermissionsPermissions.$157,
    158: RoomSetPermissionsPermissions.$158,
    159: RoomSetPermissionsPermissions.$159,
    160: RoomSetPermissionsPermissions.$160,
    161: RoomSetPermissionsPermissions.$161,
    162: RoomSetPermissionsPermissions.$162,
    163: RoomSetPermissionsPermissions.$163,
    164: RoomSetPermissionsPermissions.$164,
    165: RoomSetPermissionsPermissions.$165,
    166: RoomSetPermissionsPermissions.$166,
    167: RoomSetPermissionsPermissions.$167,
    168: RoomSetPermissionsPermissions.$168,
    169: RoomSetPermissionsPermissions.$169,
    170: RoomSetPermissionsPermissions.$170,
    171: RoomSetPermissionsPermissions.$171,
    172: RoomSetPermissionsPermissions.$172,
    173: RoomSetPermissionsPermissions.$173,
    174: RoomSetPermissionsPermissions.$174,
    175: RoomSetPermissionsPermissions.$175,
    176: RoomSetPermissionsPermissions.$176,
    177: RoomSetPermissionsPermissions.$177,
    178: RoomSetPermissionsPermissions.$178,
    179: RoomSetPermissionsPermissions.$179,
    180: RoomSetPermissionsPermissions.$180,
    181: RoomSetPermissionsPermissions.$181,
    182: RoomSetPermissionsPermissions.$182,
    183: RoomSetPermissionsPermissions.$183,
    184: RoomSetPermissionsPermissions.$184,
    185: RoomSetPermissionsPermissions.$185,
    186: RoomSetPermissionsPermissions.$186,
    187: RoomSetPermissionsPermissions.$187,
    188: RoomSetPermissionsPermissions.$188,
    189: RoomSetPermissionsPermissions.$189,
    190: RoomSetPermissionsPermissions.$190,
    191: RoomSetPermissionsPermissions.$191,
    192: RoomSetPermissionsPermissions.$192,
    193: RoomSetPermissionsPermissions.$193,
    194: RoomSetPermissionsPermissions.$194,
    195: RoomSetPermissionsPermissions.$195,
    196: RoomSetPermissionsPermissions.$196,
    197: RoomSetPermissionsPermissions.$197,
    198: RoomSetPermissionsPermissions.$198,
    199: RoomSetPermissionsPermissions.$199,
    200: RoomSetPermissionsPermissions.$200,
    201: RoomSetPermissionsPermissions.$201,
    202: RoomSetPermissionsPermissions.$202,
    203: RoomSetPermissionsPermissions.$203,
    204: RoomSetPermissionsPermissions.$204,
    205: RoomSetPermissionsPermissions.$205,
    206: RoomSetPermissionsPermissions.$206,
    207: RoomSetPermissionsPermissions.$207,
    208: RoomSetPermissionsPermissions.$208,
    209: RoomSetPermissionsPermissions.$209,
    210: RoomSetPermissionsPermissions.$210,
    211: RoomSetPermissionsPermissions.$211,
    212: RoomSetPermissionsPermissions.$212,
    213: RoomSetPermissionsPermissions.$213,
    214: RoomSetPermissionsPermissions.$214,
    215: RoomSetPermissionsPermissions.$215,
    216: RoomSetPermissionsPermissions.$216,
    217: RoomSetPermissionsPermissions.$217,
    218: RoomSetPermissionsPermissions.$218,
    219: RoomSetPermissionsPermissions.$219,
    220: RoomSetPermissionsPermissions.$220,
    221: RoomSetPermissionsPermissions.$221,
    222: RoomSetPermissionsPermissions.$222,
    223: RoomSetPermissionsPermissions.$223,
    224: RoomSetPermissionsPermissions.$224,
    225: RoomSetPermissionsPermissions.$225,
    226: RoomSetPermissionsPermissions.$226,
    227: RoomSetPermissionsPermissions.$227,
    228: RoomSetPermissionsPermissions.$228,
    229: RoomSetPermissionsPermissions.$229,
    230: RoomSetPermissionsPermissions.$230,
    231: RoomSetPermissionsPermissions.$231,
    232: RoomSetPermissionsPermissions.$232,
    233: RoomSetPermissionsPermissions.$233,
    234: RoomSetPermissionsPermissions.$234,
    235: RoomSetPermissionsPermissions.$235,
    236: RoomSetPermissionsPermissions.$236,
    237: RoomSetPermissionsPermissions.$237,
    238: RoomSetPermissionsPermissions.$238,
    239: RoomSetPermissionsPermissions.$239,
    240: RoomSetPermissionsPermissions.$240,
    241: RoomSetPermissionsPermissions.$241,
    242: RoomSetPermissionsPermissions.$242,
    243: RoomSetPermissionsPermissions.$243,
    244: RoomSetPermissionsPermissions.$244,
    245: RoomSetPermissionsPermissions.$245,
    246: RoomSetPermissionsPermissions.$246,
    247: RoomSetPermissionsPermissions.$247,
    248: RoomSetPermissionsPermissions.$248,
    249: RoomSetPermissionsPermissions.$249,
    250: RoomSetPermissionsPermissions.$250,
    251: RoomSetPermissionsPermissions.$251,
    252: RoomSetPermissionsPermissions.$252,
    253: RoomSetPermissionsPermissions.$253,
    254: RoomSetPermissionsPermissions.$254,
    255: RoomSetPermissionsPermissions.$255,
  };

  @override
  Iterable<Type> get types => const [RoomSetPermissionsPermissions];

  @override
  String get wireName => 'RoomSetPermissionsPermissions';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetPermissionsPermissions object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetPermissionsPermissions deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetPermissionsMode extends EnumClass {
  const RoomSetPermissionsMode._(super.name);

  static const RoomSetPermissionsMode call = _$roomSetPermissionsModeCall;

  @BuiltValueEnumConst(wireName: 'default')
  static const RoomSetPermissionsMode $default = _$roomSetPermissionsMode$default;

  // coverage:ignore-start
  static BuiltSet<RoomSetPermissionsMode> get values => _$roomSetPermissionsModeValues;
  // coverage:ignore-end

  static RoomSetPermissionsMode valueOf(String name) => _$valueOfRoomSetPermissionsMode(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetPermissionsMode> get serializer => const _$RoomSetPermissionsModeSerializer();
}

class _$RoomSetPermissionsModeSerializer implements PrimitiveSerializer<RoomSetPermissionsMode> {
  const _$RoomSetPermissionsModeSerializer();

  static const Map<RoomSetPermissionsMode, Object> _toWire = <RoomSetPermissionsMode, Object>{
    RoomSetPermissionsMode.call: 'call',
    RoomSetPermissionsMode.$default: 'default',
  };

  static const Map<Object, RoomSetPermissionsMode> _fromWire = <Object, RoomSetPermissionsMode>{
    'call': RoomSetPermissionsMode.call,
    'default': RoomSetPermissionsMode.$default,
  };

  @override
  Iterable<Type> get types => const [RoomSetPermissionsMode];

  @override
  String get wireName => 'RoomSetPermissionsMode';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetPermissionsMode object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetPermissionsMode deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetPermissionsApiVersion extends EnumClass {
  const RoomSetPermissionsApiVersion._(super.name);

  static const RoomSetPermissionsApiVersion v4 = _$roomSetPermissionsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetPermissionsApiVersion> get values => _$roomSetPermissionsApiVersionValues;
  // coverage:ignore-end

  static RoomSetPermissionsApiVersion valueOf(String name) => _$valueOfRoomSetPermissionsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetPermissionsApiVersion> get serializer => const _$RoomSetPermissionsApiVersionSerializer();
}

class _$RoomSetPermissionsApiVersionSerializer implements PrimitiveSerializer<RoomSetPermissionsApiVersion> {
  const _$RoomSetPermissionsApiVersionSerializer();

  static const Map<RoomSetPermissionsApiVersion, Object> _toWire = <RoomSetPermissionsApiVersion, Object>{
    RoomSetPermissionsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetPermissionsApiVersion> _fromWire = <Object, RoomSetPermissionsApiVersion>{
    'v4': RoomSetPermissionsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetPermissionsApiVersion];

  @override
  String get wireName => 'RoomSetPermissionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetPermissionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetPermissionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPermissionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomSetPermissionsResponseApplicationJson_Ocs
    implements
        $RoomSetPermissionsResponseApplicationJson_OcsInterface,
        Built<RoomSetPermissionsResponseApplicationJson_Ocs, RoomSetPermissionsResponseApplicationJson_OcsBuilder> {
  factory RoomSetPermissionsResponseApplicationJson_Ocs([
    void Function(RoomSetPermissionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetPermissionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetPermissionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetPermissionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetPermissionsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetPermissionsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetPermissionsResponseApplicationJsonInterface {
  RoomSetPermissionsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetPermissionsResponseApplicationJson
    implements
        $RoomSetPermissionsResponseApplicationJsonInterface,
        Built<RoomSetPermissionsResponseApplicationJson, RoomSetPermissionsResponseApplicationJsonBuilder> {
  factory RoomSetPermissionsResponseApplicationJson([
    void Function(RoomSetPermissionsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetPermissionsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetPermissionsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetPermissionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetPermissionsResponseApplicationJson> get serializer =>
      _$roomSetPermissionsResponseApplicationJsonSerializer;
}

class RoomGetParticipantsApiVersion extends EnumClass {
  const RoomGetParticipantsApiVersion._(super.name);

  static const RoomGetParticipantsApiVersion v4 = _$roomGetParticipantsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomGetParticipantsApiVersion> get values => _$roomGetParticipantsApiVersionValues;
  // coverage:ignore-end

  static RoomGetParticipantsApiVersion valueOf(String name) => _$valueOfRoomGetParticipantsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetParticipantsApiVersion> get serializer => const _$RoomGetParticipantsApiVersionSerializer();
}

class _$RoomGetParticipantsApiVersionSerializer implements PrimitiveSerializer<RoomGetParticipantsApiVersion> {
  const _$RoomGetParticipantsApiVersionSerializer();

  static const Map<RoomGetParticipantsApiVersion, Object> _toWire = <RoomGetParticipantsApiVersion, Object>{
    RoomGetParticipantsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetParticipantsApiVersion> _fromWire = <Object, RoomGetParticipantsApiVersion>{
    'v4': RoomGetParticipantsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetParticipantsApiVersion];

  @override
  String get wireName => 'RoomGetParticipantsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetParticipantsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetParticipantsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetParticipantsHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-has-user-statuses')
  Header<bool>? get xNextcloudHasUserStatuses;
}

abstract class RoomRoomGetParticipantsHeaders
    implements
        $RoomRoomGetParticipantsHeadersInterface,
        Built<RoomRoomGetParticipantsHeaders, RoomRoomGetParticipantsHeadersBuilder> {
  factory RoomRoomGetParticipantsHeaders([void Function(RoomRoomGetParticipantsHeadersBuilder)? b]) =
      _$RoomRoomGetParticipantsHeaders;

  // coverage:ignore-start
  const RoomRoomGetParticipantsHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRoomGetParticipantsHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRoomGetParticipantsHeaders> get serializer => _$roomRoomGetParticipantsHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $ParticipantInterface {
  String get actorId;
  String get actorType;
  int get attendeeId;
  int get attendeePermissions;
  String get attendeePin;
  String get displayName;
  int get inCall;
  int get lastPing;
  int get participantType;
  int get permissions;
  String get roomToken;
  BuiltList<String> get sessionIds;
  String? get status;
  int? get statusClearAt;
  String? get statusIcon;
  String? get statusMessage;
  String? get phoneNumber;
  String? get callId;
}

abstract class Participant implements $ParticipantInterface, Built<Participant, ParticipantBuilder> {
  factory Participant([void Function(ParticipantBuilder)? b]) = _$Participant;

  // coverage:ignore-start
  const Participant._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory Participant.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<Participant> get serializer => _$participantSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetParticipantsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Participant> get data;
}

abstract class RoomGetParticipantsResponseApplicationJson_Ocs
    implements
        $RoomGetParticipantsResponseApplicationJson_OcsInterface,
        Built<RoomGetParticipantsResponseApplicationJson_Ocs, RoomGetParticipantsResponseApplicationJson_OcsBuilder> {
  factory RoomGetParticipantsResponseApplicationJson_Ocs([
    void Function(RoomGetParticipantsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetParticipantsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetParticipantsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetParticipantsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetParticipantsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetParticipantsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetParticipantsResponseApplicationJsonInterface {
  RoomGetParticipantsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomGetParticipantsResponseApplicationJson
    implements
        $RoomGetParticipantsResponseApplicationJsonInterface,
        Built<RoomGetParticipantsResponseApplicationJson, RoomGetParticipantsResponseApplicationJsonBuilder> {
  factory RoomGetParticipantsResponseApplicationJson([
    void Function(RoomGetParticipantsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetParticipantsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetParticipantsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetParticipantsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetParticipantsResponseApplicationJson> get serializer =>
      _$roomGetParticipantsResponseApplicationJsonSerializer;
}

class RoomAddParticipantToRoomSource extends EnumClass {
  const RoomAddParticipantToRoomSource._(super.name);

  static const RoomAddParticipantToRoomSource users = _$roomAddParticipantToRoomSourceUsers;

  static const RoomAddParticipantToRoomSource groups = _$roomAddParticipantToRoomSourceGroups;

  static const RoomAddParticipantToRoomSource circles = _$roomAddParticipantToRoomSourceCircles;

  static const RoomAddParticipantToRoomSource emails = _$roomAddParticipantToRoomSourceEmails;

  static const RoomAddParticipantToRoomSource remotes = _$roomAddParticipantToRoomSourceRemotes;

  static const RoomAddParticipantToRoomSource phones = _$roomAddParticipantToRoomSourcePhones;

  // coverage:ignore-start
  static BuiltSet<RoomAddParticipantToRoomSource> get values => _$roomAddParticipantToRoomSourceValues;
  // coverage:ignore-end

  static RoomAddParticipantToRoomSource valueOf(String name) => _$valueOfRoomAddParticipantToRoomSource(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomAddParticipantToRoomSource> get serializer =>
      const _$RoomAddParticipantToRoomSourceSerializer();
}

class _$RoomAddParticipantToRoomSourceSerializer implements PrimitiveSerializer<RoomAddParticipantToRoomSource> {
  const _$RoomAddParticipantToRoomSourceSerializer();

  static const Map<RoomAddParticipantToRoomSource, Object> _toWire = <RoomAddParticipantToRoomSource, Object>{
    RoomAddParticipantToRoomSource.users: 'users',
    RoomAddParticipantToRoomSource.groups: 'groups',
    RoomAddParticipantToRoomSource.circles: 'circles',
    RoomAddParticipantToRoomSource.emails: 'emails',
    RoomAddParticipantToRoomSource.remotes: 'remotes',
    RoomAddParticipantToRoomSource.phones: 'phones',
  };

  static const Map<Object, RoomAddParticipantToRoomSource> _fromWire = <Object, RoomAddParticipantToRoomSource>{
    'users': RoomAddParticipantToRoomSource.users,
    'groups': RoomAddParticipantToRoomSource.groups,
    'circles': RoomAddParticipantToRoomSource.circles,
    'emails': RoomAddParticipantToRoomSource.emails,
    'remotes': RoomAddParticipantToRoomSource.remotes,
    'phones': RoomAddParticipantToRoomSource.phones,
  };

  @override
  Iterable<Type> get types => const [RoomAddParticipantToRoomSource];

  @override
  String get wireName => 'RoomAddParticipantToRoomSource';

  @override
  Object serialize(
    Serializers serializers,
    RoomAddParticipantToRoomSource object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomAddParticipantToRoomSource deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomAddParticipantToRoomApiVersion extends EnumClass {
  const RoomAddParticipantToRoomApiVersion._(super.name);

  static const RoomAddParticipantToRoomApiVersion v4 = _$roomAddParticipantToRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomAddParticipantToRoomApiVersion> get values => _$roomAddParticipantToRoomApiVersionValues;
  // coverage:ignore-end

  static RoomAddParticipantToRoomApiVersion valueOf(String name) => _$valueOfRoomAddParticipantToRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomAddParticipantToRoomApiVersion> get serializer =>
      const _$RoomAddParticipantToRoomApiVersionSerializer();
}

class _$RoomAddParticipantToRoomApiVersionSerializer
    implements PrimitiveSerializer<RoomAddParticipantToRoomApiVersion> {
  const _$RoomAddParticipantToRoomApiVersionSerializer();

  static const Map<RoomAddParticipantToRoomApiVersion, Object> _toWire = <RoomAddParticipantToRoomApiVersion, Object>{
    RoomAddParticipantToRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomAddParticipantToRoomApiVersion> _fromWire = <Object, RoomAddParticipantToRoomApiVersion>{
    'v4': RoomAddParticipantToRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomAddParticipantToRoomApiVersion];

  @override
  String get wireName => 'RoomAddParticipantToRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomAddParticipantToRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomAddParticipantToRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Interface {
  int get type;
}

abstract class RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0
    implements
        $RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Interface,
        Built<RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0,
            RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder> {
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0([
    void Function(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder)? b,
  ]) = _$RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0;

  // coverage:ignore-start
  const RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0> get serializer =>
      _$roomAddParticipantToRoomResponseApplicationJsonOcsData0Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddParticipantToRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data get data;
}

abstract class RoomAddParticipantToRoomResponseApplicationJson_Ocs
    implements
        $RoomAddParticipantToRoomResponseApplicationJson_OcsInterface,
        Built<RoomAddParticipantToRoomResponseApplicationJson_Ocs,
            RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder> {
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs([
    void Function(RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomAddParticipantToRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomAddParticipantToRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomAddParticipantToRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomAddParticipantToRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomAddParticipantToRoomResponseApplicationJsonOcsSerializer;

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder b) {
    b.data?.validateOneOf();
  }
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddParticipantToRoomResponseApplicationJsonInterface {
  RoomAddParticipantToRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomAddParticipantToRoomResponseApplicationJson
    implements
        $RoomAddParticipantToRoomResponseApplicationJsonInterface,
        Built<RoomAddParticipantToRoomResponseApplicationJson, RoomAddParticipantToRoomResponseApplicationJsonBuilder> {
  factory RoomAddParticipantToRoomResponseApplicationJson([
    void Function(RoomAddParticipantToRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomAddParticipantToRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomAddParticipantToRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomAddParticipantToRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomAddParticipantToRoomResponseApplicationJson> get serializer =>
      _$roomAddParticipantToRoomResponseApplicationJsonSerializer;
}

class RoomGetBreakoutRoomParticipantsApiVersion extends EnumClass {
  const RoomGetBreakoutRoomParticipantsApiVersion._(super.name);

  static const RoomGetBreakoutRoomParticipantsApiVersion v4 = _$roomGetBreakoutRoomParticipantsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomGetBreakoutRoomParticipantsApiVersion> get values =>
      _$roomGetBreakoutRoomParticipantsApiVersionValues;
  // coverage:ignore-end

  static RoomGetBreakoutRoomParticipantsApiVersion valueOf(String name) =>
      _$valueOfRoomGetBreakoutRoomParticipantsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomGetBreakoutRoomParticipantsApiVersion> get serializer =>
      const _$RoomGetBreakoutRoomParticipantsApiVersionSerializer();
}

class _$RoomGetBreakoutRoomParticipantsApiVersionSerializer
    implements PrimitiveSerializer<RoomGetBreakoutRoomParticipantsApiVersion> {
  const _$RoomGetBreakoutRoomParticipantsApiVersionSerializer();

  static const Map<RoomGetBreakoutRoomParticipantsApiVersion, Object> _toWire =
      <RoomGetBreakoutRoomParticipantsApiVersion, Object>{
    RoomGetBreakoutRoomParticipantsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomGetBreakoutRoomParticipantsApiVersion> _fromWire =
      <Object, RoomGetBreakoutRoomParticipantsApiVersion>{
    'v4': RoomGetBreakoutRoomParticipantsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomGetBreakoutRoomParticipantsApiVersion];

  @override
  String get wireName => 'RoomGetBreakoutRoomParticipantsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomGetBreakoutRoomParticipantsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomGetBreakoutRoomParticipantsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRoomGetBreakoutRoomParticipantsHeadersInterface {
  @BuiltValueField(wireName: 'x-nextcloud-has-user-statuses')
  Header<bool>? get xNextcloudHasUserStatuses;
}

abstract class RoomRoomGetBreakoutRoomParticipantsHeaders
    implements
        $RoomRoomGetBreakoutRoomParticipantsHeadersInterface,
        Built<RoomRoomGetBreakoutRoomParticipantsHeaders, RoomRoomGetBreakoutRoomParticipantsHeadersBuilder> {
  factory RoomRoomGetBreakoutRoomParticipantsHeaders([
    void Function(RoomRoomGetBreakoutRoomParticipantsHeadersBuilder)? b,
  ]) = _$RoomRoomGetBreakoutRoomParticipantsHeaders;

  // coverage:ignore-start
  const RoomRoomGetBreakoutRoomParticipantsHeaders._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRoomGetBreakoutRoomParticipantsHeaders.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRoomGetBreakoutRoomParticipantsHeaders> get serializer =>
      _$roomRoomGetBreakoutRoomParticipantsHeadersSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<Participant> get data;
}

abstract class RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs
    implements
        $RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsInterface,
        Built<RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs,
            RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder> {
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs([
    void Function(RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs> get serializer =>
      _$roomGetBreakoutRoomParticipantsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterface {
  RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomGetBreakoutRoomParticipantsResponseApplicationJson
    implements
        $RoomGetBreakoutRoomParticipantsResponseApplicationJsonInterface,
        Built<RoomGetBreakoutRoomParticipantsResponseApplicationJson,
            RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder> {
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson([
    void Function(RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomGetBreakoutRoomParticipantsResponseApplicationJson;

  // coverage:ignore-start
  const RoomGetBreakoutRoomParticipantsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomGetBreakoutRoomParticipantsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomGetBreakoutRoomParticipantsResponseApplicationJson> get serializer =>
      _$roomGetBreakoutRoomParticipantsResponseApplicationJsonSerializer;
}

class RoomRemoveSelfFromRoomApiVersion extends EnumClass {
  const RoomRemoveSelfFromRoomApiVersion._(super.name);

  static const RoomRemoveSelfFromRoomApiVersion v4 = _$roomRemoveSelfFromRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomRemoveSelfFromRoomApiVersion> get values => _$roomRemoveSelfFromRoomApiVersionValues;
  // coverage:ignore-end

  static RoomRemoveSelfFromRoomApiVersion valueOf(String name) => _$valueOfRoomRemoveSelfFromRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRemoveSelfFromRoomApiVersion> get serializer =>
      const _$RoomRemoveSelfFromRoomApiVersionSerializer();
}

class _$RoomRemoveSelfFromRoomApiVersionSerializer implements PrimitiveSerializer<RoomRemoveSelfFromRoomApiVersion> {
  const _$RoomRemoveSelfFromRoomApiVersionSerializer();

  static const Map<RoomRemoveSelfFromRoomApiVersion, Object> _toWire = <RoomRemoveSelfFromRoomApiVersion, Object>{
    RoomRemoveSelfFromRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRemoveSelfFromRoomApiVersion> _fromWire = <Object, RoomRemoveSelfFromRoomApiVersion>{
    'v4': RoomRemoveSelfFromRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRemoveSelfFromRoomApiVersion];

  @override
  String get wireName => 'RoomRemoveSelfFromRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRemoveSelfFromRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRemoveSelfFromRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomRemoveSelfFromRoomResponseApplicationJson_Ocs
    implements
        $RoomRemoveSelfFromRoomResponseApplicationJson_OcsInterface,
        Built<RoomRemoveSelfFromRoomResponseApplicationJson_Ocs,
            RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder> {
  factory RoomRemoveSelfFromRoomResponseApplicationJson_Ocs([
    void Function(RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRemoveSelfFromRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRemoveSelfFromRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRemoveSelfFromRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRemoveSelfFromRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomRemoveSelfFromRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveSelfFromRoomResponseApplicationJsonInterface {
  RoomRemoveSelfFromRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomRemoveSelfFromRoomResponseApplicationJson
    implements
        $RoomRemoveSelfFromRoomResponseApplicationJsonInterface,
        Built<RoomRemoveSelfFromRoomResponseApplicationJson, RoomRemoveSelfFromRoomResponseApplicationJsonBuilder> {
  factory RoomRemoveSelfFromRoomResponseApplicationJson([
    void Function(RoomRemoveSelfFromRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomRemoveSelfFromRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomRemoveSelfFromRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRemoveSelfFromRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRemoveSelfFromRoomResponseApplicationJson> get serializer =>
      _$roomRemoveSelfFromRoomResponseApplicationJsonSerializer;
}

class RoomRemoveAttendeeFromRoomApiVersion extends EnumClass {
  const RoomRemoveAttendeeFromRoomApiVersion._(super.name);

  static const RoomRemoveAttendeeFromRoomApiVersion v4 = _$roomRemoveAttendeeFromRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomRemoveAttendeeFromRoomApiVersion> get values => _$roomRemoveAttendeeFromRoomApiVersionValues;
  // coverage:ignore-end

  static RoomRemoveAttendeeFromRoomApiVersion valueOf(String name) =>
      _$valueOfRoomRemoveAttendeeFromRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRemoveAttendeeFromRoomApiVersion> get serializer =>
      const _$RoomRemoveAttendeeFromRoomApiVersionSerializer();
}

class _$RoomRemoveAttendeeFromRoomApiVersionSerializer
    implements PrimitiveSerializer<RoomRemoveAttendeeFromRoomApiVersion> {
  const _$RoomRemoveAttendeeFromRoomApiVersionSerializer();

  static const Map<RoomRemoveAttendeeFromRoomApiVersion, Object> _toWire =
      <RoomRemoveAttendeeFromRoomApiVersion, Object>{
    RoomRemoveAttendeeFromRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRemoveAttendeeFromRoomApiVersion> _fromWire =
      <Object, RoomRemoveAttendeeFromRoomApiVersion>{
    'v4': RoomRemoveAttendeeFromRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRemoveAttendeeFromRoomApiVersion];

  @override
  String get wireName => 'RoomRemoveAttendeeFromRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRemoveAttendeeFromRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRemoveAttendeeFromRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs
    implements
        $RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsInterface,
        Built<RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs,
            RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder> {
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs([
    void Function(RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomRemoveAttendeeFromRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveAttendeeFromRoomResponseApplicationJsonInterface {
  RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomRemoveAttendeeFromRoomResponseApplicationJson
    implements
        $RoomRemoveAttendeeFromRoomResponseApplicationJsonInterface,
        Built<RoomRemoveAttendeeFromRoomResponseApplicationJson,
            RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder> {
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson([
    void Function(RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder)? b,
  ]) = _$RoomRemoveAttendeeFromRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomRemoveAttendeeFromRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRemoveAttendeeFromRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRemoveAttendeeFromRoomResponseApplicationJson> get serializer =>
      _$roomRemoveAttendeeFromRoomResponseApplicationJsonSerializer;
}

class RoomSetAttendeePermissionsMethod extends EnumClass {
  const RoomSetAttendeePermissionsMethod._(super.name);

  @BuiltValueEnumConst(wireName: 'set')
  static const RoomSetAttendeePermissionsMethod $set = _$roomSetAttendeePermissionsMethod$set;

  static const RoomSetAttendeePermissionsMethod remove = _$roomSetAttendeePermissionsMethodRemove;

  static const RoomSetAttendeePermissionsMethod add = _$roomSetAttendeePermissionsMethodAdd;

  // coverage:ignore-start
  static BuiltSet<RoomSetAttendeePermissionsMethod> get values => _$roomSetAttendeePermissionsMethodValues;
  // coverage:ignore-end

  static RoomSetAttendeePermissionsMethod valueOf(String name) => _$valueOfRoomSetAttendeePermissionsMethod(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAttendeePermissionsMethod> get serializer =>
      const _$RoomSetAttendeePermissionsMethodSerializer();
}

class _$RoomSetAttendeePermissionsMethodSerializer implements PrimitiveSerializer<RoomSetAttendeePermissionsMethod> {
  const _$RoomSetAttendeePermissionsMethodSerializer();

  static const Map<RoomSetAttendeePermissionsMethod, Object> _toWire = <RoomSetAttendeePermissionsMethod, Object>{
    RoomSetAttendeePermissionsMethod.$set: 'set',
    RoomSetAttendeePermissionsMethod.remove: 'remove',
    RoomSetAttendeePermissionsMethod.add: 'add',
  };

  static const Map<Object, RoomSetAttendeePermissionsMethod> _fromWire = <Object, RoomSetAttendeePermissionsMethod>{
    'set': RoomSetAttendeePermissionsMethod.$set,
    'remove': RoomSetAttendeePermissionsMethod.remove,
    'add': RoomSetAttendeePermissionsMethod.add,
  };

  @override
  Iterable<Type> get types => const [RoomSetAttendeePermissionsMethod];

  @override
  String get wireName => 'RoomSetAttendeePermissionsMethod';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAttendeePermissionsMethod object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAttendeePermissionsMethod deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetAttendeePermissionsPermissions extends EnumClass {
  const RoomSetAttendeePermissionsPermissions._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetAttendeePermissionsPermissions $0 = _$roomSetAttendeePermissionsPermissions$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetAttendeePermissionsPermissions $1 = _$roomSetAttendeePermissionsPermissions$1;

  @BuiltValueEnumConst(wireName: '2')
  static const RoomSetAttendeePermissionsPermissions $2 = _$roomSetAttendeePermissionsPermissions$2;

  @BuiltValueEnumConst(wireName: '3')
  static const RoomSetAttendeePermissionsPermissions $3 = _$roomSetAttendeePermissionsPermissions$3;

  @BuiltValueEnumConst(wireName: '4')
  static const RoomSetAttendeePermissionsPermissions $4 = _$roomSetAttendeePermissionsPermissions$4;

  @BuiltValueEnumConst(wireName: '5')
  static const RoomSetAttendeePermissionsPermissions $5 = _$roomSetAttendeePermissionsPermissions$5;

  @BuiltValueEnumConst(wireName: '6')
  static const RoomSetAttendeePermissionsPermissions $6 = _$roomSetAttendeePermissionsPermissions$6;

  @BuiltValueEnumConst(wireName: '7')
  static const RoomSetAttendeePermissionsPermissions $7 = _$roomSetAttendeePermissionsPermissions$7;

  @BuiltValueEnumConst(wireName: '8')
  static const RoomSetAttendeePermissionsPermissions $8 = _$roomSetAttendeePermissionsPermissions$8;

  @BuiltValueEnumConst(wireName: '9')
  static const RoomSetAttendeePermissionsPermissions $9 = _$roomSetAttendeePermissionsPermissions$9;

  @BuiltValueEnumConst(wireName: '10')
  static const RoomSetAttendeePermissionsPermissions $10 = _$roomSetAttendeePermissionsPermissions$10;

  @BuiltValueEnumConst(wireName: '11')
  static const RoomSetAttendeePermissionsPermissions $11 = _$roomSetAttendeePermissionsPermissions$11;

  @BuiltValueEnumConst(wireName: '12')
  static const RoomSetAttendeePermissionsPermissions $12 = _$roomSetAttendeePermissionsPermissions$12;

  @BuiltValueEnumConst(wireName: '13')
  static const RoomSetAttendeePermissionsPermissions $13 = _$roomSetAttendeePermissionsPermissions$13;

  @BuiltValueEnumConst(wireName: '14')
  static const RoomSetAttendeePermissionsPermissions $14 = _$roomSetAttendeePermissionsPermissions$14;

  @BuiltValueEnumConst(wireName: '15')
  static const RoomSetAttendeePermissionsPermissions $15 = _$roomSetAttendeePermissionsPermissions$15;

  @BuiltValueEnumConst(wireName: '16')
  static const RoomSetAttendeePermissionsPermissions $16 = _$roomSetAttendeePermissionsPermissions$16;

  @BuiltValueEnumConst(wireName: '17')
  static const RoomSetAttendeePermissionsPermissions $17 = _$roomSetAttendeePermissionsPermissions$17;

  @BuiltValueEnumConst(wireName: '18')
  static const RoomSetAttendeePermissionsPermissions $18 = _$roomSetAttendeePermissionsPermissions$18;

  @BuiltValueEnumConst(wireName: '19')
  static const RoomSetAttendeePermissionsPermissions $19 = _$roomSetAttendeePermissionsPermissions$19;

  @BuiltValueEnumConst(wireName: '20')
  static const RoomSetAttendeePermissionsPermissions $20 = _$roomSetAttendeePermissionsPermissions$20;

  @BuiltValueEnumConst(wireName: '21')
  static const RoomSetAttendeePermissionsPermissions $21 = _$roomSetAttendeePermissionsPermissions$21;

  @BuiltValueEnumConst(wireName: '22')
  static const RoomSetAttendeePermissionsPermissions $22 = _$roomSetAttendeePermissionsPermissions$22;

  @BuiltValueEnumConst(wireName: '23')
  static const RoomSetAttendeePermissionsPermissions $23 = _$roomSetAttendeePermissionsPermissions$23;

  @BuiltValueEnumConst(wireName: '24')
  static const RoomSetAttendeePermissionsPermissions $24 = _$roomSetAttendeePermissionsPermissions$24;

  @BuiltValueEnumConst(wireName: '25')
  static const RoomSetAttendeePermissionsPermissions $25 = _$roomSetAttendeePermissionsPermissions$25;

  @BuiltValueEnumConst(wireName: '26')
  static const RoomSetAttendeePermissionsPermissions $26 = _$roomSetAttendeePermissionsPermissions$26;

  @BuiltValueEnumConst(wireName: '27')
  static const RoomSetAttendeePermissionsPermissions $27 = _$roomSetAttendeePermissionsPermissions$27;

  @BuiltValueEnumConst(wireName: '28')
  static const RoomSetAttendeePermissionsPermissions $28 = _$roomSetAttendeePermissionsPermissions$28;

  @BuiltValueEnumConst(wireName: '29')
  static const RoomSetAttendeePermissionsPermissions $29 = _$roomSetAttendeePermissionsPermissions$29;

  @BuiltValueEnumConst(wireName: '30')
  static const RoomSetAttendeePermissionsPermissions $30 = _$roomSetAttendeePermissionsPermissions$30;

  @BuiltValueEnumConst(wireName: '31')
  static const RoomSetAttendeePermissionsPermissions $31 = _$roomSetAttendeePermissionsPermissions$31;

  @BuiltValueEnumConst(wireName: '32')
  static const RoomSetAttendeePermissionsPermissions $32 = _$roomSetAttendeePermissionsPermissions$32;

  @BuiltValueEnumConst(wireName: '33')
  static const RoomSetAttendeePermissionsPermissions $33 = _$roomSetAttendeePermissionsPermissions$33;

  @BuiltValueEnumConst(wireName: '34')
  static const RoomSetAttendeePermissionsPermissions $34 = _$roomSetAttendeePermissionsPermissions$34;

  @BuiltValueEnumConst(wireName: '35')
  static const RoomSetAttendeePermissionsPermissions $35 = _$roomSetAttendeePermissionsPermissions$35;

  @BuiltValueEnumConst(wireName: '36')
  static const RoomSetAttendeePermissionsPermissions $36 = _$roomSetAttendeePermissionsPermissions$36;

  @BuiltValueEnumConst(wireName: '37')
  static const RoomSetAttendeePermissionsPermissions $37 = _$roomSetAttendeePermissionsPermissions$37;

  @BuiltValueEnumConst(wireName: '38')
  static const RoomSetAttendeePermissionsPermissions $38 = _$roomSetAttendeePermissionsPermissions$38;

  @BuiltValueEnumConst(wireName: '39')
  static const RoomSetAttendeePermissionsPermissions $39 = _$roomSetAttendeePermissionsPermissions$39;

  @BuiltValueEnumConst(wireName: '40')
  static const RoomSetAttendeePermissionsPermissions $40 = _$roomSetAttendeePermissionsPermissions$40;

  @BuiltValueEnumConst(wireName: '41')
  static const RoomSetAttendeePermissionsPermissions $41 = _$roomSetAttendeePermissionsPermissions$41;

  @BuiltValueEnumConst(wireName: '42')
  static const RoomSetAttendeePermissionsPermissions $42 = _$roomSetAttendeePermissionsPermissions$42;

  @BuiltValueEnumConst(wireName: '43')
  static const RoomSetAttendeePermissionsPermissions $43 = _$roomSetAttendeePermissionsPermissions$43;

  @BuiltValueEnumConst(wireName: '44')
  static const RoomSetAttendeePermissionsPermissions $44 = _$roomSetAttendeePermissionsPermissions$44;

  @BuiltValueEnumConst(wireName: '45')
  static const RoomSetAttendeePermissionsPermissions $45 = _$roomSetAttendeePermissionsPermissions$45;

  @BuiltValueEnumConst(wireName: '46')
  static const RoomSetAttendeePermissionsPermissions $46 = _$roomSetAttendeePermissionsPermissions$46;

  @BuiltValueEnumConst(wireName: '47')
  static const RoomSetAttendeePermissionsPermissions $47 = _$roomSetAttendeePermissionsPermissions$47;

  @BuiltValueEnumConst(wireName: '48')
  static const RoomSetAttendeePermissionsPermissions $48 = _$roomSetAttendeePermissionsPermissions$48;

  @BuiltValueEnumConst(wireName: '49')
  static const RoomSetAttendeePermissionsPermissions $49 = _$roomSetAttendeePermissionsPermissions$49;

  @BuiltValueEnumConst(wireName: '50')
  static const RoomSetAttendeePermissionsPermissions $50 = _$roomSetAttendeePermissionsPermissions$50;

  @BuiltValueEnumConst(wireName: '51')
  static const RoomSetAttendeePermissionsPermissions $51 = _$roomSetAttendeePermissionsPermissions$51;

  @BuiltValueEnumConst(wireName: '52')
  static const RoomSetAttendeePermissionsPermissions $52 = _$roomSetAttendeePermissionsPermissions$52;

  @BuiltValueEnumConst(wireName: '53')
  static const RoomSetAttendeePermissionsPermissions $53 = _$roomSetAttendeePermissionsPermissions$53;

  @BuiltValueEnumConst(wireName: '54')
  static const RoomSetAttendeePermissionsPermissions $54 = _$roomSetAttendeePermissionsPermissions$54;

  @BuiltValueEnumConst(wireName: '55')
  static const RoomSetAttendeePermissionsPermissions $55 = _$roomSetAttendeePermissionsPermissions$55;

  @BuiltValueEnumConst(wireName: '56')
  static const RoomSetAttendeePermissionsPermissions $56 = _$roomSetAttendeePermissionsPermissions$56;

  @BuiltValueEnumConst(wireName: '57')
  static const RoomSetAttendeePermissionsPermissions $57 = _$roomSetAttendeePermissionsPermissions$57;

  @BuiltValueEnumConst(wireName: '58')
  static const RoomSetAttendeePermissionsPermissions $58 = _$roomSetAttendeePermissionsPermissions$58;

  @BuiltValueEnumConst(wireName: '59')
  static const RoomSetAttendeePermissionsPermissions $59 = _$roomSetAttendeePermissionsPermissions$59;

  @BuiltValueEnumConst(wireName: '60')
  static const RoomSetAttendeePermissionsPermissions $60 = _$roomSetAttendeePermissionsPermissions$60;

  @BuiltValueEnumConst(wireName: '61')
  static const RoomSetAttendeePermissionsPermissions $61 = _$roomSetAttendeePermissionsPermissions$61;

  @BuiltValueEnumConst(wireName: '62')
  static const RoomSetAttendeePermissionsPermissions $62 = _$roomSetAttendeePermissionsPermissions$62;

  @BuiltValueEnumConst(wireName: '63')
  static const RoomSetAttendeePermissionsPermissions $63 = _$roomSetAttendeePermissionsPermissions$63;

  @BuiltValueEnumConst(wireName: '64')
  static const RoomSetAttendeePermissionsPermissions $64 = _$roomSetAttendeePermissionsPermissions$64;

  @BuiltValueEnumConst(wireName: '65')
  static const RoomSetAttendeePermissionsPermissions $65 = _$roomSetAttendeePermissionsPermissions$65;

  @BuiltValueEnumConst(wireName: '66')
  static const RoomSetAttendeePermissionsPermissions $66 = _$roomSetAttendeePermissionsPermissions$66;

  @BuiltValueEnumConst(wireName: '67')
  static const RoomSetAttendeePermissionsPermissions $67 = _$roomSetAttendeePermissionsPermissions$67;

  @BuiltValueEnumConst(wireName: '68')
  static const RoomSetAttendeePermissionsPermissions $68 = _$roomSetAttendeePermissionsPermissions$68;

  @BuiltValueEnumConst(wireName: '69')
  static const RoomSetAttendeePermissionsPermissions $69 = _$roomSetAttendeePermissionsPermissions$69;

  @BuiltValueEnumConst(wireName: '70')
  static const RoomSetAttendeePermissionsPermissions $70 = _$roomSetAttendeePermissionsPermissions$70;

  @BuiltValueEnumConst(wireName: '71')
  static const RoomSetAttendeePermissionsPermissions $71 = _$roomSetAttendeePermissionsPermissions$71;

  @BuiltValueEnumConst(wireName: '72')
  static const RoomSetAttendeePermissionsPermissions $72 = _$roomSetAttendeePermissionsPermissions$72;

  @BuiltValueEnumConst(wireName: '73')
  static const RoomSetAttendeePermissionsPermissions $73 = _$roomSetAttendeePermissionsPermissions$73;

  @BuiltValueEnumConst(wireName: '74')
  static const RoomSetAttendeePermissionsPermissions $74 = _$roomSetAttendeePermissionsPermissions$74;

  @BuiltValueEnumConst(wireName: '75')
  static const RoomSetAttendeePermissionsPermissions $75 = _$roomSetAttendeePermissionsPermissions$75;

  @BuiltValueEnumConst(wireName: '76')
  static const RoomSetAttendeePermissionsPermissions $76 = _$roomSetAttendeePermissionsPermissions$76;

  @BuiltValueEnumConst(wireName: '77')
  static const RoomSetAttendeePermissionsPermissions $77 = _$roomSetAttendeePermissionsPermissions$77;

  @BuiltValueEnumConst(wireName: '78')
  static const RoomSetAttendeePermissionsPermissions $78 = _$roomSetAttendeePermissionsPermissions$78;

  @BuiltValueEnumConst(wireName: '79')
  static const RoomSetAttendeePermissionsPermissions $79 = _$roomSetAttendeePermissionsPermissions$79;

  @BuiltValueEnumConst(wireName: '80')
  static const RoomSetAttendeePermissionsPermissions $80 = _$roomSetAttendeePermissionsPermissions$80;

  @BuiltValueEnumConst(wireName: '81')
  static const RoomSetAttendeePermissionsPermissions $81 = _$roomSetAttendeePermissionsPermissions$81;

  @BuiltValueEnumConst(wireName: '82')
  static const RoomSetAttendeePermissionsPermissions $82 = _$roomSetAttendeePermissionsPermissions$82;

  @BuiltValueEnumConst(wireName: '83')
  static const RoomSetAttendeePermissionsPermissions $83 = _$roomSetAttendeePermissionsPermissions$83;

  @BuiltValueEnumConst(wireName: '84')
  static const RoomSetAttendeePermissionsPermissions $84 = _$roomSetAttendeePermissionsPermissions$84;

  @BuiltValueEnumConst(wireName: '85')
  static const RoomSetAttendeePermissionsPermissions $85 = _$roomSetAttendeePermissionsPermissions$85;

  @BuiltValueEnumConst(wireName: '86')
  static const RoomSetAttendeePermissionsPermissions $86 = _$roomSetAttendeePermissionsPermissions$86;

  @BuiltValueEnumConst(wireName: '87')
  static const RoomSetAttendeePermissionsPermissions $87 = _$roomSetAttendeePermissionsPermissions$87;

  @BuiltValueEnumConst(wireName: '88')
  static const RoomSetAttendeePermissionsPermissions $88 = _$roomSetAttendeePermissionsPermissions$88;

  @BuiltValueEnumConst(wireName: '89')
  static const RoomSetAttendeePermissionsPermissions $89 = _$roomSetAttendeePermissionsPermissions$89;

  @BuiltValueEnumConst(wireName: '90')
  static const RoomSetAttendeePermissionsPermissions $90 = _$roomSetAttendeePermissionsPermissions$90;

  @BuiltValueEnumConst(wireName: '91')
  static const RoomSetAttendeePermissionsPermissions $91 = _$roomSetAttendeePermissionsPermissions$91;

  @BuiltValueEnumConst(wireName: '92')
  static const RoomSetAttendeePermissionsPermissions $92 = _$roomSetAttendeePermissionsPermissions$92;

  @BuiltValueEnumConst(wireName: '93')
  static const RoomSetAttendeePermissionsPermissions $93 = _$roomSetAttendeePermissionsPermissions$93;

  @BuiltValueEnumConst(wireName: '94')
  static const RoomSetAttendeePermissionsPermissions $94 = _$roomSetAttendeePermissionsPermissions$94;

  @BuiltValueEnumConst(wireName: '95')
  static const RoomSetAttendeePermissionsPermissions $95 = _$roomSetAttendeePermissionsPermissions$95;

  @BuiltValueEnumConst(wireName: '96')
  static const RoomSetAttendeePermissionsPermissions $96 = _$roomSetAttendeePermissionsPermissions$96;

  @BuiltValueEnumConst(wireName: '97')
  static const RoomSetAttendeePermissionsPermissions $97 = _$roomSetAttendeePermissionsPermissions$97;

  @BuiltValueEnumConst(wireName: '98')
  static const RoomSetAttendeePermissionsPermissions $98 = _$roomSetAttendeePermissionsPermissions$98;

  @BuiltValueEnumConst(wireName: '99')
  static const RoomSetAttendeePermissionsPermissions $99 = _$roomSetAttendeePermissionsPermissions$99;

  @BuiltValueEnumConst(wireName: '100')
  static const RoomSetAttendeePermissionsPermissions $100 = _$roomSetAttendeePermissionsPermissions$100;

  @BuiltValueEnumConst(wireName: '101')
  static const RoomSetAttendeePermissionsPermissions $101 = _$roomSetAttendeePermissionsPermissions$101;

  @BuiltValueEnumConst(wireName: '102')
  static const RoomSetAttendeePermissionsPermissions $102 = _$roomSetAttendeePermissionsPermissions$102;

  @BuiltValueEnumConst(wireName: '103')
  static const RoomSetAttendeePermissionsPermissions $103 = _$roomSetAttendeePermissionsPermissions$103;

  @BuiltValueEnumConst(wireName: '104')
  static const RoomSetAttendeePermissionsPermissions $104 = _$roomSetAttendeePermissionsPermissions$104;

  @BuiltValueEnumConst(wireName: '105')
  static const RoomSetAttendeePermissionsPermissions $105 = _$roomSetAttendeePermissionsPermissions$105;

  @BuiltValueEnumConst(wireName: '106')
  static const RoomSetAttendeePermissionsPermissions $106 = _$roomSetAttendeePermissionsPermissions$106;

  @BuiltValueEnumConst(wireName: '107')
  static const RoomSetAttendeePermissionsPermissions $107 = _$roomSetAttendeePermissionsPermissions$107;

  @BuiltValueEnumConst(wireName: '108')
  static const RoomSetAttendeePermissionsPermissions $108 = _$roomSetAttendeePermissionsPermissions$108;

  @BuiltValueEnumConst(wireName: '109')
  static const RoomSetAttendeePermissionsPermissions $109 = _$roomSetAttendeePermissionsPermissions$109;

  @BuiltValueEnumConst(wireName: '110')
  static const RoomSetAttendeePermissionsPermissions $110 = _$roomSetAttendeePermissionsPermissions$110;

  @BuiltValueEnumConst(wireName: '111')
  static const RoomSetAttendeePermissionsPermissions $111 = _$roomSetAttendeePermissionsPermissions$111;

  @BuiltValueEnumConst(wireName: '112')
  static const RoomSetAttendeePermissionsPermissions $112 = _$roomSetAttendeePermissionsPermissions$112;

  @BuiltValueEnumConst(wireName: '113')
  static const RoomSetAttendeePermissionsPermissions $113 = _$roomSetAttendeePermissionsPermissions$113;

  @BuiltValueEnumConst(wireName: '114')
  static const RoomSetAttendeePermissionsPermissions $114 = _$roomSetAttendeePermissionsPermissions$114;

  @BuiltValueEnumConst(wireName: '115')
  static const RoomSetAttendeePermissionsPermissions $115 = _$roomSetAttendeePermissionsPermissions$115;

  @BuiltValueEnumConst(wireName: '116')
  static const RoomSetAttendeePermissionsPermissions $116 = _$roomSetAttendeePermissionsPermissions$116;

  @BuiltValueEnumConst(wireName: '117')
  static const RoomSetAttendeePermissionsPermissions $117 = _$roomSetAttendeePermissionsPermissions$117;

  @BuiltValueEnumConst(wireName: '118')
  static const RoomSetAttendeePermissionsPermissions $118 = _$roomSetAttendeePermissionsPermissions$118;

  @BuiltValueEnumConst(wireName: '119')
  static const RoomSetAttendeePermissionsPermissions $119 = _$roomSetAttendeePermissionsPermissions$119;

  @BuiltValueEnumConst(wireName: '120')
  static const RoomSetAttendeePermissionsPermissions $120 = _$roomSetAttendeePermissionsPermissions$120;

  @BuiltValueEnumConst(wireName: '121')
  static const RoomSetAttendeePermissionsPermissions $121 = _$roomSetAttendeePermissionsPermissions$121;

  @BuiltValueEnumConst(wireName: '122')
  static const RoomSetAttendeePermissionsPermissions $122 = _$roomSetAttendeePermissionsPermissions$122;

  @BuiltValueEnumConst(wireName: '123')
  static const RoomSetAttendeePermissionsPermissions $123 = _$roomSetAttendeePermissionsPermissions$123;

  @BuiltValueEnumConst(wireName: '124')
  static const RoomSetAttendeePermissionsPermissions $124 = _$roomSetAttendeePermissionsPermissions$124;

  @BuiltValueEnumConst(wireName: '125')
  static const RoomSetAttendeePermissionsPermissions $125 = _$roomSetAttendeePermissionsPermissions$125;

  @BuiltValueEnumConst(wireName: '126')
  static const RoomSetAttendeePermissionsPermissions $126 = _$roomSetAttendeePermissionsPermissions$126;

  @BuiltValueEnumConst(wireName: '127')
  static const RoomSetAttendeePermissionsPermissions $127 = _$roomSetAttendeePermissionsPermissions$127;

  @BuiltValueEnumConst(wireName: '128')
  static const RoomSetAttendeePermissionsPermissions $128 = _$roomSetAttendeePermissionsPermissions$128;

  @BuiltValueEnumConst(wireName: '129')
  static const RoomSetAttendeePermissionsPermissions $129 = _$roomSetAttendeePermissionsPermissions$129;

  @BuiltValueEnumConst(wireName: '130')
  static const RoomSetAttendeePermissionsPermissions $130 = _$roomSetAttendeePermissionsPermissions$130;

  @BuiltValueEnumConst(wireName: '131')
  static const RoomSetAttendeePermissionsPermissions $131 = _$roomSetAttendeePermissionsPermissions$131;

  @BuiltValueEnumConst(wireName: '132')
  static const RoomSetAttendeePermissionsPermissions $132 = _$roomSetAttendeePermissionsPermissions$132;

  @BuiltValueEnumConst(wireName: '133')
  static const RoomSetAttendeePermissionsPermissions $133 = _$roomSetAttendeePermissionsPermissions$133;

  @BuiltValueEnumConst(wireName: '134')
  static const RoomSetAttendeePermissionsPermissions $134 = _$roomSetAttendeePermissionsPermissions$134;

  @BuiltValueEnumConst(wireName: '135')
  static const RoomSetAttendeePermissionsPermissions $135 = _$roomSetAttendeePermissionsPermissions$135;

  @BuiltValueEnumConst(wireName: '136')
  static const RoomSetAttendeePermissionsPermissions $136 = _$roomSetAttendeePermissionsPermissions$136;

  @BuiltValueEnumConst(wireName: '137')
  static const RoomSetAttendeePermissionsPermissions $137 = _$roomSetAttendeePermissionsPermissions$137;

  @BuiltValueEnumConst(wireName: '138')
  static const RoomSetAttendeePermissionsPermissions $138 = _$roomSetAttendeePermissionsPermissions$138;

  @BuiltValueEnumConst(wireName: '139')
  static const RoomSetAttendeePermissionsPermissions $139 = _$roomSetAttendeePermissionsPermissions$139;

  @BuiltValueEnumConst(wireName: '140')
  static const RoomSetAttendeePermissionsPermissions $140 = _$roomSetAttendeePermissionsPermissions$140;

  @BuiltValueEnumConst(wireName: '141')
  static const RoomSetAttendeePermissionsPermissions $141 = _$roomSetAttendeePermissionsPermissions$141;

  @BuiltValueEnumConst(wireName: '142')
  static const RoomSetAttendeePermissionsPermissions $142 = _$roomSetAttendeePermissionsPermissions$142;

  @BuiltValueEnumConst(wireName: '143')
  static const RoomSetAttendeePermissionsPermissions $143 = _$roomSetAttendeePermissionsPermissions$143;

  @BuiltValueEnumConst(wireName: '144')
  static const RoomSetAttendeePermissionsPermissions $144 = _$roomSetAttendeePermissionsPermissions$144;

  @BuiltValueEnumConst(wireName: '145')
  static const RoomSetAttendeePermissionsPermissions $145 = _$roomSetAttendeePermissionsPermissions$145;

  @BuiltValueEnumConst(wireName: '146')
  static const RoomSetAttendeePermissionsPermissions $146 = _$roomSetAttendeePermissionsPermissions$146;

  @BuiltValueEnumConst(wireName: '147')
  static const RoomSetAttendeePermissionsPermissions $147 = _$roomSetAttendeePermissionsPermissions$147;

  @BuiltValueEnumConst(wireName: '148')
  static const RoomSetAttendeePermissionsPermissions $148 = _$roomSetAttendeePermissionsPermissions$148;

  @BuiltValueEnumConst(wireName: '149')
  static const RoomSetAttendeePermissionsPermissions $149 = _$roomSetAttendeePermissionsPermissions$149;

  @BuiltValueEnumConst(wireName: '150')
  static const RoomSetAttendeePermissionsPermissions $150 = _$roomSetAttendeePermissionsPermissions$150;

  @BuiltValueEnumConst(wireName: '151')
  static const RoomSetAttendeePermissionsPermissions $151 = _$roomSetAttendeePermissionsPermissions$151;

  @BuiltValueEnumConst(wireName: '152')
  static const RoomSetAttendeePermissionsPermissions $152 = _$roomSetAttendeePermissionsPermissions$152;

  @BuiltValueEnumConst(wireName: '153')
  static const RoomSetAttendeePermissionsPermissions $153 = _$roomSetAttendeePermissionsPermissions$153;

  @BuiltValueEnumConst(wireName: '154')
  static const RoomSetAttendeePermissionsPermissions $154 = _$roomSetAttendeePermissionsPermissions$154;

  @BuiltValueEnumConst(wireName: '155')
  static const RoomSetAttendeePermissionsPermissions $155 = _$roomSetAttendeePermissionsPermissions$155;

  @BuiltValueEnumConst(wireName: '156')
  static const RoomSetAttendeePermissionsPermissions $156 = _$roomSetAttendeePermissionsPermissions$156;

  @BuiltValueEnumConst(wireName: '157')
  static const RoomSetAttendeePermissionsPermissions $157 = _$roomSetAttendeePermissionsPermissions$157;

  @BuiltValueEnumConst(wireName: '158')
  static const RoomSetAttendeePermissionsPermissions $158 = _$roomSetAttendeePermissionsPermissions$158;

  @BuiltValueEnumConst(wireName: '159')
  static const RoomSetAttendeePermissionsPermissions $159 = _$roomSetAttendeePermissionsPermissions$159;

  @BuiltValueEnumConst(wireName: '160')
  static const RoomSetAttendeePermissionsPermissions $160 = _$roomSetAttendeePermissionsPermissions$160;

  @BuiltValueEnumConst(wireName: '161')
  static const RoomSetAttendeePermissionsPermissions $161 = _$roomSetAttendeePermissionsPermissions$161;

  @BuiltValueEnumConst(wireName: '162')
  static const RoomSetAttendeePermissionsPermissions $162 = _$roomSetAttendeePermissionsPermissions$162;

  @BuiltValueEnumConst(wireName: '163')
  static const RoomSetAttendeePermissionsPermissions $163 = _$roomSetAttendeePermissionsPermissions$163;

  @BuiltValueEnumConst(wireName: '164')
  static const RoomSetAttendeePermissionsPermissions $164 = _$roomSetAttendeePermissionsPermissions$164;

  @BuiltValueEnumConst(wireName: '165')
  static const RoomSetAttendeePermissionsPermissions $165 = _$roomSetAttendeePermissionsPermissions$165;

  @BuiltValueEnumConst(wireName: '166')
  static const RoomSetAttendeePermissionsPermissions $166 = _$roomSetAttendeePermissionsPermissions$166;

  @BuiltValueEnumConst(wireName: '167')
  static const RoomSetAttendeePermissionsPermissions $167 = _$roomSetAttendeePermissionsPermissions$167;

  @BuiltValueEnumConst(wireName: '168')
  static const RoomSetAttendeePermissionsPermissions $168 = _$roomSetAttendeePermissionsPermissions$168;

  @BuiltValueEnumConst(wireName: '169')
  static const RoomSetAttendeePermissionsPermissions $169 = _$roomSetAttendeePermissionsPermissions$169;

  @BuiltValueEnumConst(wireName: '170')
  static const RoomSetAttendeePermissionsPermissions $170 = _$roomSetAttendeePermissionsPermissions$170;

  @BuiltValueEnumConst(wireName: '171')
  static const RoomSetAttendeePermissionsPermissions $171 = _$roomSetAttendeePermissionsPermissions$171;

  @BuiltValueEnumConst(wireName: '172')
  static const RoomSetAttendeePermissionsPermissions $172 = _$roomSetAttendeePermissionsPermissions$172;

  @BuiltValueEnumConst(wireName: '173')
  static const RoomSetAttendeePermissionsPermissions $173 = _$roomSetAttendeePermissionsPermissions$173;

  @BuiltValueEnumConst(wireName: '174')
  static const RoomSetAttendeePermissionsPermissions $174 = _$roomSetAttendeePermissionsPermissions$174;

  @BuiltValueEnumConst(wireName: '175')
  static const RoomSetAttendeePermissionsPermissions $175 = _$roomSetAttendeePermissionsPermissions$175;

  @BuiltValueEnumConst(wireName: '176')
  static const RoomSetAttendeePermissionsPermissions $176 = _$roomSetAttendeePermissionsPermissions$176;

  @BuiltValueEnumConst(wireName: '177')
  static const RoomSetAttendeePermissionsPermissions $177 = _$roomSetAttendeePermissionsPermissions$177;

  @BuiltValueEnumConst(wireName: '178')
  static const RoomSetAttendeePermissionsPermissions $178 = _$roomSetAttendeePermissionsPermissions$178;

  @BuiltValueEnumConst(wireName: '179')
  static const RoomSetAttendeePermissionsPermissions $179 = _$roomSetAttendeePermissionsPermissions$179;

  @BuiltValueEnumConst(wireName: '180')
  static const RoomSetAttendeePermissionsPermissions $180 = _$roomSetAttendeePermissionsPermissions$180;

  @BuiltValueEnumConst(wireName: '181')
  static const RoomSetAttendeePermissionsPermissions $181 = _$roomSetAttendeePermissionsPermissions$181;

  @BuiltValueEnumConst(wireName: '182')
  static const RoomSetAttendeePermissionsPermissions $182 = _$roomSetAttendeePermissionsPermissions$182;

  @BuiltValueEnumConst(wireName: '183')
  static const RoomSetAttendeePermissionsPermissions $183 = _$roomSetAttendeePermissionsPermissions$183;

  @BuiltValueEnumConst(wireName: '184')
  static const RoomSetAttendeePermissionsPermissions $184 = _$roomSetAttendeePermissionsPermissions$184;

  @BuiltValueEnumConst(wireName: '185')
  static const RoomSetAttendeePermissionsPermissions $185 = _$roomSetAttendeePermissionsPermissions$185;

  @BuiltValueEnumConst(wireName: '186')
  static const RoomSetAttendeePermissionsPermissions $186 = _$roomSetAttendeePermissionsPermissions$186;

  @BuiltValueEnumConst(wireName: '187')
  static const RoomSetAttendeePermissionsPermissions $187 = _$roomSetAttendeePermissionsPermissions$187;

  @BuiltValueEnumConst(wireName: '188')
  static const RoomSetAttendeePermissionsPermissions $188 = _$roomSetAttendeePermissionsPermissions$188;

  @BuiltValueEnumConst(wireName: '189')
  static const RoomSetAttendeePermissionsPermissions $189 = _$roomSetAttendeePermissionsPermissions$189;

  @BuiltValueEnumConst(wireName: '190')
  static const RoomSetAttendeePermissionsPermissions $190 = _$roomSetAttendeePermissionsPermissions$190;

  @BuiltValueEnumConst(wireName: '191')
  static const RoomSetAttendeePermissionsPermissions $191 = _$roomSetAttendeePermissionsPermissions$191;

  @BuiltValueEnumConst(wireName: '192')
  static const RoomSetAttendeePermissionsPermissions $192 = _$roomSetAttendeePermissionsPermissions$192;

  @BuiltValueEnumConst(wireName: '193')
  static const RoomSetAttendeePermissionsPermissions $193 = _$roomSetAttendeePermissionsPermissions$193;

  @BuiltValueEnumConst(wireName: '194')
  static const RoomSetAttendeePermissionsPermissions $194 = _$roomSetAttendeePermissionsPermissions$194;

  @BuiltValueEnumConst(wireName: '195')
  static const RoomSetAttendeePermissionsPermissions $195 = _$roomSetAttendeePermissionsPermissions$195;

  @BuiltValueEnumConst(wireName: '196')
  static const RoomSetAttendeePermissionsPermissions $196 = _$roomSetAttendeePermissionsPermissions$196;

  @BuiltValueEnumConst(wireName: '197')
  static const RoomSetAttendeePermissionsPermissions $197 = _$roomSetAttendeePermissionsPermissions$197;

  @BuiltValueEnumConst(wireName: '198')
  static const RoomSetAttendeePermissionsPermissions $198 = _$roomSetAttendeePermissionsPermissions$198;

  @BuiltValueEnumConst(wireName: '199')
  static const RoomSetAttendeePermissionsPermissions $199 = _$roomSetAttendeePermissionsPermissions$199;

  @BuiltValueEnumConst(wireName: '200')
  static const RoomSetAttendeePermissionsPermissions $200 = _$roomSetAttendeePermissionsPermissions$200;

  @BuiltValueEnumConst(wireName: '201')
  static const RoomSetAttendeePermissionsPermissions $201 = _$roomSetAttendeePermissionsPermissions$201;

  @BuiltValueEnumConst(wireName: '202')
  static const RoomSetAttendeePermissionsPermissions $202 = _$roomSetAttendeePermissionsPermissions$202;

  @BuiltValueEnumConst(wireName: '203')
  static const RoomSetAttendeePermissionsPermissions $203 = _$roomSetAttendeePermissionsPermissions$203;

  @BuiltValueEnumConst(wireName: '204')
  static const RoomSetAttendeePermissionsPermissions $204 = _$roomSetAttendeePermissionsPermissions$204;

  @BuiltValueEnumConst(wireName: '205')
  static const RoomSetAttendeePermissionsPermissions $205 = _$roomSetAttendeePermissionsPermissions$205;

  @BuiltValueEnumConst(wireName: '206')
  static const RoomSetAttendeePermissionsPermissions $206 = _$roomSetAttendeePermissionsPermissions$206;

  @BuiltValueEnumConst(wireName: '207')
  static const RoomSetAttendeePermissionsPermissions $207 = _$roomSetAttendeePermissionsPermissions$207;

  @BuiltValueEnumConst(wireName: '208')
  static const RoomSetAttendeePermissionsPermissions $208 = _$roomSetAttendeePermissionsPermissions$208;

  @BuiltValueEnumConst(wireName: '209')
  static const RoomSetAttendeePermissionsPermissions $209 = _$roomSetAttendeePermissionsPermissions$209;

  @BuiltValueEnumConst(wireName: '210')
  static const RoomSetAttendeePermissionsPermissions $210 = _$roomSetAttendeePermissionsPermissions$210;

  @BuiltValueEnumConst(wireName: '211')
  static const RoomSetAttendeePermissionsPermissions $211 = _$roomSetAttendeePermissionsPermissions$211;

  @BuiltValueEnumConst(wireName: '212')
  static const RoomSetAttendeePermissionsPermissions $212 = _$roomSetAttendeePermissionsPermissions$212;

  @BuiltValueEnumConst(wireName: '213')
  static const RoomSetAttendeePermissionsPermissions $213 = _$roomSetAttendeePermissionsPermissions$213;

  @BuiltValueEnumConst(wireName: '214')
  static const RoomSetAttendeePermissionsPermissions $214 = _$roomSetAttendeePermissionsPermissions$214;

  @BuiltValueEnumConst(wireName: '215')
  static const RoomSetAttendeePermissionsPermissions $215 = _$roomSetAttendeePermissionsPermissions$215;

  @BuiltValueEnumConst(wireName: '216')
  static const RoomSetAttendeePermissionsPermissions $216 = _$roomSetAttendeePermissionsPermissions$216;

  @BuiltValueEnumConst(wireName: '217')
  static const RoomSetAttendeePermissionsPermissions $217 = _$roomSetAttendeePermissionsPermissions$217;

  @BuiltValueEnumConst(wireName: '218')
  static const RoomSetAttendeePermissionsPermissions $218 = _$roomSetAttendeePermissionsPermissions$218;

  @BuiltValueEnumConst(wireName: '219')
  static const RoomSetAttendeePermissionsPermissions $219 = _$roomSetAttendeePermissionsPermissions$219;

  @BuiltValueEnumConst(wireName: '220')
  static const RoomSetAttendeePermissionsPermissions $220 = _$roomSetAttendeePermissionsPermissions$220;

  @BuiltValueEnumConst(wireName: '221')
  static const RoomSetAttendeePermissionsPermissions $221 = _$roomSetAttendeePermissionsPermissions$221;

  @BuiltValueEnumConst(wireName: '222')
  static const RoomSetAttendeePermissionsPermissions $222 = _$roomSetAttendeePermissionsPermissions$222;

  @BuiltValueEnumConst(wireName: '223')
  static const RoomSetAttendeePermissionsPermissions $223 = _$roomSetAttendeePermissionsPermissions$223;

  @BuiltValueEnumConst(wireName: '224')
  static const RoomSetAttendeePermissionsPermissions $224 = _$roomSetAttendeePermissionsPermissions$224;

  @BuiltValueEnumConst(wireName: '225')
  static const RoomSetAttendeePermissionsPermissions $225 = _$roomSetAttendeePermissionsPermissions$225;

  @BuiltValueEnumConst(wireName: '226')
  static const RoomSetAttendeePermissionsPermissions $226 = _$roomSetAttendeePermissionsPermissions$226;

  @BuiltValueEnumConst(wireName: '227')
  static const RoomSetAttendeePermissionsPermissions $227 = _$roomSetAttendeePermissionsPermissions$227;

  @BuiltValueEnumConst(wireName: '228')
  static const RoomSetAttendeePermissionsPermissions $228 = _$roomSetAttendeePermissionsPermissions$228;

  @BuiltValueEnumConst(wireName: '229')
  static const RoomSetAttendeePermissionsPermissions $229 = _$roomSetAttendeePermissionsPermissions$229;

  @BuiltValueEnumConst(wireName: '230')
  static const RoomSetAttendeePermissionsPermissions $230 = _$roomSetAttendeePermissionsPermissions$230;

  @BuiltValueEnumConst(wireName: '231')
  static const RoomSetAttendeePermissionsPermissions $231 = _$roomSetAttendeePermissionsPermissions$231;

  @BuiltValueEnumConst(wireName: '232')
  static const RoomSetAttendeePermissionsPermissions $232 = _$roomSetAttendeePermissionsPermissions$232;

  @BuiltValueEnumConst(wireName: '233')
  static const RoomSetAttendeePermissionsPermissions $233 = _$roomSetAttendeePermissionsPermissions$233;

  @BuiltValueEnumConst(wireName: '234')
  static const RoomSetAttendeePermissionsPermissions $234 = _$roomSetAttendeePermissionsPermissions$234;

  @BuiltValueEnumConst(wireName: '235')
  static const RoomSetAttendeePermissionsPermissions $235 = _$roomSetAttendeePermissionsPermissions$235;

  @BuiltValueEnumConst(wireName: '236')
  static const RoomSetAttendeePermissionsPermissions $236 = _$roomSetAttendeePermissionsPermissions$236;

  @BuiltValueEnumConst(wireName: '237')
  static const RoomSetAttendeePermissionsPermissions $237 = _$roomSetAttendeePermissionsPermissions$237;

  @BuiltValueEnumConst(wireName: '238')
  static const RoomSetAttendeePermissionsPermissions $238 = _$roomSetAttendeePermissionsPermissions$238;

  @BuiltValueEnumConst(wireName: '239')
  static const RoomSetAttendeePermissionsPermissions $239 = _$roomSetAttendeePermissionsPermissions$239;

  @BuiltValueEnumConst(wireName: '240')
  static const RoomSetAttendeePermissionsPermissions $240 = _$roomSetAttendeePermissionsPermissions$240;

  @BuiltValueEnumConst(wireName: '241')
  static const RoomSetAttendeePermissionsPermissions $241 = _$roomSetAttendeePermissionsPermissions$241;

  @BuiltValueEnumConst(wireName: '242')
  static const RoomSetAttendeePermissionsPermissions $242 = _$roomSetAttendeePermissionsPermissions$242;

  @BuiltValueEnumConst(wireName: '243')
  static const RoomSetAttendeePermissionsPermissions $243 = _$roomSetAttendeePermissionsPermissions$243;

  @BuiltValueEnumConst(wireName: '244')
  static const RoomSetAttendeePermissionsPermissions $244 = _$roomSetAttendeePermissionsPermissions$244;

  @BuiltValueEnumConst(wireName: '245')
  static const RoomSetAttendeePermissionsPermissions $245 = _$roomSetAttendeePermissionsPermissions$245;

  @BuiltValueEnumConst(wireName: '246')
  static const RoomSetAttendeePermissionsPermissions $246 = _$roomSetAttendeePermissionsPermissions$246;

  @BuiltValueEnumConst(wireName: '247')
  static const RoomSetAttendeePermissionsPermissions $247 = _$roomSetAttendeePermissionsPermissions$247;

  @BuiltValueEnumConst(wireName: '248')
  static const RoomSetAttendeePermissionsPermissions $248 = _$roomSetAttendeePermissionsPermissions$248;

  @BuiltValueEnumConst(wireName: '249')
  static const RoomSetAttendeePermissionsPermissions $249 = _$roomSetAttendeePermissionsPermissions$249;

  @BuiltValueEnumConst(wireName: '250')
  static const RoomSetAttendeePermissionsPermissions $250 = _$roomSetAttendeePermissionsPermissions$250;

  @BuiltValueEnumConst(wireName: '251')
  static const RoomSetAttendeePermissionsPermissions $251 = _$roomSetAttendeePermissionsPermissions$251;

  @BuiltValueEnumConst(wireName: '252')
  static const RoomSetAttendeePermissionsPermissions $252 = _$roomSetAttendeePermissionsPermissions$252;

  @BuiltValueEnumConst(wireName: '253')
  static const RoomSetAttendeePermissionsPermissions $253 = _$roomSetAttendeePermissionsPermissions$253;

  @BuiltValueEnumConst(wireName: '254')
  static const RoomSetAttendeePermissionsPermissions $254 = _$roomSetAttendeePermissionsPermissions$254;

  @BuiltValueEnumConst(wireName: '255')
  static const RoomSetAttendeePermissionsPermissions $255 = _$roomSetAttendeePermissionsPermissions$255;

  // coverage:ignore-start
  static BuiltSet<RoomSetAttendeePermissionsPermissions> get values => _$roomSetAttendeePermissionsPermissionsValues;
  // coverage:ignore-end

  static RoomSetAttendeePermissionsPermissions valueOf(String name) =>
      _$valueOfRoomSetAttendeePermissionsPermissions(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAttendeePermissionsPermissions> get serializer =>
      const _$RoomSetAttendeePermissionsPermissionsSerializer();
}

class _$RoomSetAttendeePermissionsPermissionsSerializer
    implements PrimitiveSerializer<RoomSetAttendeePermissionsPermissions> {
  const _$RoomSetAttendeePermissionsPermissionsSerializer();

  static const Map<RoomSetAttendeePermissionsPermissions, Object> _toWire =
      <RoomSetAttendeePermissionsPermissions, Object>{
    RoomSetAttendeePermissionsPermissions.$0: 0,
    RoomSetAttendeePermissionsPermissions.$1: 1,
    RoomSetAttendeePermissionsPermissions.$2: 2,
    RoomSetAttendeePermissionsPermissions.$3: 3,
    RoomSetAttendeePermissionsPermissions.$4: 4,
    RoomSetAttendeePermissionsPermissions.$5: 5,
    RoomSetAttendeePermissionsPermissions.$6: 6,
    RoomSetAttendeePermissionsPermissions.$7: 7,
    RoomSetAttendeePermissionsPermissions.$8: 8,
    RoomSetAttendeePermissionsPermissions.$9: 9,
    RoomSetAttendeePermissionsPermissions.$10: 10,
    RoomSetAttendeePermissionsPermissions.$11: 11,
    RoomSetAttendeePermissionsPermissions.$12: 12,
    RoomSetAttendeePermissionsPermissions.$13: 13,
    RoomSetAttendeePermissionsPermissions.$14: 14,
    RoomSetAttendeePermissionsPermissions.$15: 15,
    RoomSetAttendeePermissionsPermissions.$16: 16,
    RoomSetAttendeePermissionsPermissions.$17: 17,
    RoomSetAttendeePermissionsPermissions.$18: 18,
    RoomSetAttendeePermissionsPermissions.$19: 19,
    RoomSetAttendeePermissionsPermissions.$20: 20,
    RoomSetAttendeePermissionsPermissions.$21: 21,
    RoomSetAttendeePermissionsPermissions.$22: 22,
    RoomSetAttendeePermissionsPermissions.$23: 23,
    RoomSetAttendeePermissionsPermissions.$24: 24,
    RoomSetAttendeePermissionsPermissions.$25: 25,
    RoomSetAttendeePermissionsPermissions.$26: 26,
    RoomSetAttendeePermissionsPermissions.$27: 27,
    RoomSetAttendeePermissionsPermissions.$28: 28,
    RoomSetAttendeePermissionsPermissions.$29: 29,
    RoomSetAttendeePermissionsPermissions.$30: 30,
    RoomSetAttendeePermissionsPermissions.$31: 31,
    RoomSetAttendeePermissionsPermissions.$32: 32,
    RoomSetAttendeePermissionsPermissions.$33: 33,
    RoomSetAttendeePermissionsPermissions.$34: 34,
    RoomSetAttendeePermissionsPermissions.$35: 35,
    RoomSetAttendeePermissionsPermissions.$36: 36,
    RoomSetAttendeePermissionsPermissions.$37: 37,
    RoomSetAttendeePermissionsPermissions.$38: 38,
    RoomSetAttendeePermissionsPermissions.$39: 39,
    RoomSetAttendeePermissionsPermissions.$40: 40,
    RoomSetAttendeePermissionsPermissions.$41: 41,
    RoomSetAttendeePermissionsPermissions.$42: 42,
    RoomSetAttendeePermissionsPermissions.$43: 43,
    RoomSetAttendeePermissionsPermissions.$44: 44,
    RoomSetAttendeePermissionsPermissions.$45: 45,
    RoomSetAttendeePermissionsPermissions.$46: 46,
    RoomSetAttendeePermissionsPermissions.$47: 47,
    RoomSetAttendeePermissionsPermissions.$48: 48,
    RoomSetAttendeePermissionsPermissions.$49: 49,
    RoomSetAttendeePermissionsPermissions.$50: 50,
    RoomSetAttendeePermissionsPermissions.$51: 51,
    RoomSetAttendeePermissionsPermissions.$52: 52,
    RoomSetAttendeePermissionsPermissions.$53: 53,
    RoomSetAttendeePermissionsPermissions.$54: 54,
    RoomSetAttendeePermissionsPermissions.$55: 55,
    RoomSetAttendeePermissionsPermissions.$56: 56,
    RoomSetAttendeePermissionsPermissions.$57: 57,
    RoomSetAttendeePermissionsPermissions.$58: 58,
    RoomSetAttendeePermissionsPermissions.$59: 59,
    RoomSetAttendeePermissionsPermissions.$60: 60,
    RoomSetAttendeePermissionsPermissions.$61: 61,
    RoomSetAttendeePermissionsPermissions.$62: 62,
    RoomSetAttendeePermissionsPermissions.$63: 63,
    RoomSetAttendeePermissionsPermissions.$64: 64,
    RoomSetAttendeePermissionsPermissions.$65: 65,
    RoomSetAttendeePermissionsPermissions.$66: 66,
    RoomSetAttendeePermissionsPermissions.$67: 67,
    RoomSetAttendeePermissionsPermissions.$68: 68,
    RoomSetAttendeePermissionsPermissions.$69: 69,
    RoomSetAttendeePermissionsPermissions.$70: 70,
    RoomSetAttendeePermissionsPermissions.$71: 71,
    RoomSetAttendeePermissionsPermissions.$72: 72,
    RoomSetAttendeePermissionsPermissions.$73: 73,
    RoomSetAttendeePermissionsPermissions.$74: 74,
    RoomSetAttendeePermissionsPermissions.$75: 75,
    RoomSetAttendeePermissionsPermissions.$76: 76,
    RoomSetAttendeePermissionsPermissions.$77: 77,
    RoomSetAttendeePermissionsPermissions.$78: 78,
    RoomSetAttendeePermissionsPermissions.$79: 79,
    RoomSetAttendeePermissionsPermissions.$80: 80,
    RoomSetAttendeePermissionsPermissions.$81: 81,
    RoomSetAttendeePermissionsPermissions.$82: 82,
    RoomSetAttendeePermissionsPermissions.$83: 83,
    RoomSetAttendeePermissionsPermissions.$84: 84,
    RoomSetAttendeePermissionsPermissions.$85: 85,
    RoomSetAttendeePermissionsPermissions.$86: 86,
    RoomSetAttendeePermissionsPermissions.$87: 87,
    RoomSetAttendeePermissionsPermissions.$88: 88,
    RoomSetAttendeePermissionsPermissions.$89: 89,
    RoomSetAttendeePermissionsPermissions.$90: 90,
    RoomSetAttendeePermissionsPermissions.$91: 91,
    RoomSetAttendeePermissionsPermissions.$92: 92,
    RoomSetAttendeePermissionsPermissions.$93: 93,
    RoomSetAttendeePermissionsPermissions.$94: 94,
    RoomSetAttendeePermissionsPermissions.$95: 95,
    RoomSetAttendeePermissionsPermissions.$96: 96,
    RoomSetAttendeePermissionsPermissions.$97: 97,
    RoomSetAttendeePermissionsPermissions.$98: 98,
    RoomSetAttendeePermissionsPermissions.$99: 99,
    RoomSetAttendeePermissionsPermissions.$100: 100,
    RoomSetAttendeePermissionsPermissions.$101: 101,
    RoomSetAttendeePermissionsPermissions.$102: 102,
    RoomSetAttendeePermissionsPermissions.$103: 103,
    RoomSetAttendeePermissionsPermissions.$104: 104,
    RoomSetAttendeePermissionsPermissions.$105: 105,
    RoomSetAttendeePermissionsPermissions.$106: 106,
    RoomSetAttendeePermissionsPermissions.$107: 107,
    RoomSetAttendeePermissionsPermissions.$108: 108,
    RoomSetAttendeePermissionsPermissions.$109: 109,
    RoomSetAttendeePermissionsPermissions.$110: 110,
    RoomSetAttendeePermissionsPermissions.$111: 111,
    RoomSetAttendeePermissionsPermissions.$112: 112,
    RoomSetAttendeePermissionsPermissions.$113: 113,
    RoomSetAttendeePermissionsPermissions.$114: 114,
    RoomSetAttendeePermissionsPermissions.$115: 115,
    RoomSetAttendeePermissionsPermissions.$116: 116,
    RoomSetAttendeePermissionsPermissions.$117: 117,
    RoomSetAttendeePermissionsPermissions.$118: 118,
    RoomSetAttendeePermissionsPermissions.$119: 119,
    RoomSetAttendeePermissionsPermissions.$120: 120,
    RoomSetAttendeePermissionsPermissions.$121: 121,
    RoomSetAttendeePermissionsPermissions.$122: 122,
    RoomSetAttendeePermissionsPermissions.$123: 123,
    RoomSetAttendeePermissionsPermissions.$124: 124,
    RoomSetAttendeePermissionsPermissions.$125: 125,
    RoomSetAttendeePermissionsPermissions.$126: 126,
    RoomSetAttendeePermissionsPermissions.$127: 127,
    RoomSetAttendeePermissionsPermissions.$128: 128,
    RoomSetAttendeePermissionsPermissions.$129: 129,
    RoomSetAttendeePermissionsPermissions.$130: 130,
    RoomSetAttendeePermissionsPermissions.$131: 131,
    RoomSetAttendeePermissionsPermissions.$132: 132,
    RoomSetAttendeePermissionsPermissions.$133: 133,
    RoomSetAttendeePermissionsPermissions.$134: 134,
    RoomSetAttendeePermissionsPermissions.$135: 135,
    RoomSetAttendeePermissionsPermissions.$136: 136,
    RoomSetAttendeePermissionsPermissions.$137: 137,
    RoomSetAttendeePermissionsPermissions.$138: 138,
    RoomSetAttendeePermissionsPermissions.$139: 139,
    RoomSetAttendeePermissionsPermissions.$140: 140,
    RoomSetAttendeePermissionsPermissions.$141: 141,
    RoomSetAttendeePermissionsPermissions.$142: 142,
    RoomSetAttendeePermissionsPermissions.$143: 143,
    RoomSetAttendeePermissionsPermissions.$144: 144,
    RoomSetAttendeePermissionsPermissions.$145: 145,
    RoomSetAttendeePermissionsPermissions.$146: 146,
    RoomSetAttendeePermissionsPermissions.$147: 147,
    RoomSetAttendeePermissionsPermissions.$148: 148,
    RoomSetAttendeePermissionsPermissions.$149: 149,
    RoomSetAttendeePermissionsPermissions.$150: 150,
    RoomSetAttendeePermissionsPermissions.$151: 151,
    RoomSetAttendeePermissionsPermissions.$152: 152,
    RoomSetAttendeePermissionsPermissions.$153: 153,
    RoomSetAttendeePermissionsPermissions.$154: 154,
    RoomSetAttendeePermissionsPermissions.$155: 155,
    RoomSetAttendeePermissionsPermissions.$156: 156,
    RoomSetAttendeePermissionsPermissions.$157: 157,
    RoomSetAttendeePermissionsPermissions.$158: 158,
    RoomSetAttendeePermissionsPermissions.$159: 159,
    RoomSetAttendeePermissionsPermissions.$160: 160,
    RoomSetAttendeePermissionsPermissions.$161: 161,
    RoomSetAttendeePermissionsPermissions.$162: 162,
    RoomSetAttendeePermissionsPermissions.$163: 163,
    RoomSetAttendeePermissionsPermissions.$164: 164,
    RoomSetAttendeePermissionsPermissions.$165: 165,
    RoomSetAttendeePermissionsPermissions.$166: 166,
    RoomSetAttendeePermissionsPermissions.$167: 167,
    RoomSetAttendeePermissionsPermissions.$168: 168,
    RoomSetAttendeePermissionsPermissions.$169: 169,
    RoomSetAttendeePermissionsPermissions.$170: 170,
    RoomSetAttendeePermissionsPermissions.$171: 171,
    RoomSetAttendeePermissionsPermissions.$172: 172,
    RoomSetAttendeePermissionsPermissions.$173: 173,
    RoomSetAttendeePermissionsPermissions.$174: 174,
    RoomSetAttendeePermissionsPermissions.$175: 175,
    RoomSetAttendeePermissionsPermissions.$176: 176,
    RoomSetAttendeePermissionsPermissions.$177: 177,
    RoomSetAttendeePermissionsPermissions.$178: 178,
    RoomSetAttendeePermissionsPermissions.$179: 179,
    RoomSetAttendeePermissionsPermissions.$180: 180,
    RoomSetAttendeePermissionsPermissions.$181: 181,
    RoomSetAttendeePermissionsPermissions.$182: 182,
    RoomSetAttendeePermissionsPermissions.$183: 183,
    RoomSetAttendeePermissionsPermissions.$184: 184,
    RoomSetAttendeePermissionsPermissions.$185: 185,
    RoomSetAttendeePermissionsPermissions.$186: 186,
    RoomSetAttendeePermissionsPermissions.$187: 187,
    RoomSetAttendeePermissionsPermissions.$188: 188,
    RoomSetAttendeePermissionsPermissions.$189: 189,
    RoomSetAttendeePermissionsPermissions.$190: 190,
    RoomSetAttendeePermissionsPermissions.$191: 191,
    RoomSetAttendeePermissionsPermissions.$192: 192,
    RoomSetAttendeePermissionsPermissions.$193: 193,
    RoomSetAttendeePermissionsPermissions.$194: 194,
    RoomSetAttendeePermissionsPermissions.$195: 195,
    RoomSetAttendeePermissionsPermissions.$196: 196,
    RoomSetAttendeePermissionsPermissions.$197: 197,
    RoomSetAttendeePermissionsPermissions.$198: 198,
    RoomSetAttendeePermissionsPermissions.$199: 199,
    RoomSetAttendeePermissionsPermissions.$200: 200,
    RoomSetAttendeePermissionsPermissions.$201: 201,
    RoomSetAttendeePermissionsPermissions.$202: 202,
    RoomSetAttendeePermissionsPermissions.$203: 203,
    RoomSetAttendeePermissionsPermissions.$204: 204,
    RoomSetAttendeePermissionsPermissions.$205: 205,
    RoomSetAttendeePermissionsPermissions.$206: 206,
    RoomSetAttendeePermissionsPermissions.$207: 207,
    RoomSetAttendeePermissionsPermissions.$208: 208,
    RoomSetAttendeePermissionsPermissions.$209: 209,
    RoomSetAttendeePermissionsPermissions.$210: 210,
    RoomSetAttendeePermissionsPermissions.$211: 211,
    RoomSetAttendeePermissionsPermissions.$212: 212,
    RoomSetAttendeePermissionsPermissions.$213: 213,
    RoomSetAttendeePermissionsPermissions.$214: 214,
    RoomSetAttendeePermissionsPermissions.$215: 215,
    RoomSetAttendeePermissionsPermissions.$216: 216,
    RoomSetAttendeePermissionsPermissions.$217: 217,
    RoomSetAttendeePermissionsPermissions.$218: 218,
    RoomSetAttendeePermissionsPermissions.$219: 219,
    RoomSetAttendeePermissionsPermissions.$220: 220,
    RoomSetAttendeePermissionsPermissions.$221: 221,
    RoomSetAttendeePermissionsPermissions.$222: 222,
    RoomSetAttendeePermissionsPermissions.$223: 223,
    RoomSetAttendeePermissionsPermissions.$224: 224,
    RoomSetAttendeePermissionsPermissions.$225: 225,
    RoomSetAttendeePermissionsPermissions.$226: 226,
    RoomSetAttendeePermissionsPermissions.$227: 227,
    RoomSetAttendeePermissionsPermissions.$228: 228,
    RoomSetAttendeePermissionsPermissions.$229: 229,
    RoomSetAttendeePermissionsPermissions.$230: 230,
    RoomSetAttendeePermissionsPermissions.$231: 231,
    RoomSetAttendeePermissionsPermissions.$232: 232,
    RoomSetAttendeePermissionsPermissions.$233: 233,
    RoomSetAttendeePermissionsPermissions.$234: 234,
    RoomSetAttendeePermissionsPermissions.$235: 235,
    RoomSetAttendeePermissionsPermissions.$236: 236,
    RoomSetAttendeePermissionsPermissions.$237: 237,
    RoomSetAttendeePermissionsPermissions.$238: 238,
    RoomSetAttendeePermissionsPermissions.$239: 239,
    RoomSetAttendeePermissionsPermissions.$240: 240,
    RoomSetAttendeePermissionsPermissions.$241: 241,
    RoomSetAttendeePermissionsPermissions.$242: 242,
    RoomSetAttendeePermissionsPermissions.$243: 243,
    RoomSetAttendeePermissionsPermissions.$244: 244,
    RoomSetAttendeePermissionsPermissions.$245: 245,
    RoomSetAttendeePermissionsPermissions.$246: 246,
    RoomSetAttendeePermissionsPermissions.$247: 247,
    RoomSetAttendeePermissionsPermissions.$248: 248,
    RoomSetAttendeePermissionsPermissions.$249: 249,
    RoomSetAttendeePermissionsPermissions.$250: 250,
    RoomSetAttendeePermissionsPermissions.$251: 251,
    RoomSetAttendeePermissionsPermissions.$252: 252,
    RoomSetAttendeePermissionsPermissions.$253: 253,
    RoomSetAttendeePermissionsPermissions.$254: 254,
    RoomSetAttendeePermissionsPermissions.$255: 255,
  };

  static const Map<Object, RoomSetAttendeePermissionsPermissions> _fromWire =
      <Object, RoomSetAttendeePermissionsPermissions>{
    0: RoomSetAttendeePermissionsPermissions.$0,
    1: RoomSetAttendeePermissionsPermissions.$1,
    2: RoomSetAttendeePermissionsPermissions.$2,
    3: RoomSetAttendeePermissionsPermissions.$3,
    4: RoomSetAttendeePermissionsPermissions.$4,
    5: RoomSetAttendeePermissionsPermissions.$5,
    6: RoomSetAttendeePermissionsPermissions.$6,
    7: RoomSetAttendeePermissionsPermissions.$7,
    8: RoomSetAttendeePermissionsPermissions.$8,
    9: RoomSetAttendeePermissionsPermissions.$9,
    10: RoomSetAttendeePermissionsPermissions.$10,
    11: RoomSetAttendeePermissionsPermissions.$11,
    12: RoomSetAttendeePermissionsPermissions.$12,
    13: RoomSetAttendeePermissionsPermissions.$13,
    14: RoomSetAttendeePermissionsPermissions.$14,
    15: RoomSetAttendeePermissionsPermissions.$15,
    16: RoomSetAttendeePermissionsPermissions.$16,
    17: RoomSetAttendeePermissionsPermissions.$17,
    18: RoomSetAttendeePermissionsPermissions.$18,
    19: RoomSetAttendeePermissionsPermissions.$19,
    20: RoomSetAttendeePermissionsPermissions.$20,
    21: RoomSetAttendeePermissionsPermissions.$21,
    22: RoomSetAttendeePermissionsPermissions.$22,
    23: RoomSetAttendeePermissionsPermissions.$23,
    24: RoomSetAttendeePermissionsPermissions.$24,
    25: RoomSetAttendeePermissionsPermissions.$25,
    26: RoomSetAttendeePermissionsPermissions.$26,
    27: RoomSetAttendeePermissionsPermissions.$27,
    28: RoomSetAttendeePermissionsPermissions.$28,
    29: RoomSetAttendeePermissionsPermissions.$29,
    30: RoomSetAttendeePermissionsPermissions.$30,
    31: RoomSetAttendeePermissionsPermissions.$31,
    32: RoomSetAttendeePermissionsPermissions.$32,
    33: RoomSetAttendeePermissionsPermissions.$33,
    34: RoomSetAttendeePermissionsPermissions.$34,
    35: RoomSetAttendeePermissionsPermissions.$35,
    36: RoomSetAttendeePermissionsPermissions.$36,
    37: RoomSetAttendeePermissionsPermissions.$37,
    38: RoomSetAttendeePermissionsPermissions.$38,
    39: RoomSetAttendeePermissionsPermissions.$39,
    40: RoomSetAttendeePermissionsPermissions.$40,
    41: RoomSetAttendeePermissionsPermissions.$41,
    42: RoomSetAttendeePermissionsPermissions.$42,
    43: RoomSetAttendeePermissionsPermissions.$43,
    44: RoomSetAttendeePermissionsPermissions.$44,
    45: RoomSetAttendeePermissionsPermissions.$45,
    46: RoomSetAttendeePermissionsPermissions.$46,
    47: RoomSetAttendeePermissionsPermissions.$47,
    48: RoomSetAttendeePermissionsPermissions.$48,
    49: RoomSetAttendeePermissionsPermissions.$49,
    50: RoomSetAttendeePermissionsPermissions.$50,
    51: RoomSetAttendeePermissionsPermissions.$51,
    52: RoomSetAttendeePermissionsPermissions.$52,
    53: RoomSetAttendeePermissionsPermissions.$53,
    54: RoomSetAttendeePermissionsPermissions.$54,
    55: RoomSetAttendeePermissionsPermissions.$55,
    56: RoomSetAttendeePermissionsPermissions.$56,
    57: RoomSetAttendeePermissionsPermissions.$57,
    58: RoomSetAttendeePermissionsPermissions.$58,
    59: RoomSetAttendeePermissionsPermissions.$59,
    60: RoomSetAttendeePermissionsPermissions.$60,
    61: RoomSetAttendeePermissionsPermissions.$61,
    62: RoomSetAttendeePermissionsPermissions.$62,
    63: RoomSetAttendeePermissionsPermissions.$63,
    64: RoomSetAttendeePermissionsPermissions.$64,
    65: RoomSetAttendeePermissionsPermissions.$65,
    66: RoomSetAttendeePermissionsPermissions.$66,
    67: RoomSetAttendeePermissionsPermissions.$67,
    68: RoomSetAttendeePermissionsPermissions.$68,
    69: RoomSetAttendeePermissionsPermissions.$69,
    70: RoomSetAttendeePermissionsPermissions.$70,
    71: RoomSetAttendeePermissionsPermissions.$71,
    72: RoomSetAttendeePermissionsPermissions.$72,
    73: RoomSetAttendeePermissionsPermissions.$73,
    74: RoomSetAttendeePermissionsPermissions.$74,
    75: RoomSetAttendeePermissionsPermissions.$75,
    76: RoomSetAttendeePermissionsPermissions.$76,
    77: RoomSetAttendeePermissionsPermissions.$77,
    78: RoomSetAttendeePermissionsPermissions.$78,
    79: RoomSetAttendeePermissionsPermissions.$79,
    80: RoomSetAttendeePermissionsPermissions.$80,
    81: RoomSetAttendeePermissionsPermissions.$81,
    82: RoomSetAttendeePermissionsPermissions.$82,
    83: RoomSetAttendeePermissionsPermissions.$83,
    84: RoomSetAttendeePermissionsPermissions.$84,
    85: RoomSetAttendeePermissionsPermissions.$85,
    86: RoomSetAttendeePermissionsPermissions.$86,
    87: RoomSetAttendeePermissionsPermissions.$87,
    88: RoomSetAttendeePermissionsPermissions.$88,
    89: RoomSetAttendeePermissionsPermissions.$89,
    90: RoomSetAttendeePermissionsPermissions.$90,
    91: RoomSetAttendeePermissionsPermissions.$91,
    92: RoomSetAttendeePermissionsPermissions.$92,
    93: RoomSetAttendeePermissionsPermissions.$93,
    94: RoomSetAttendeePermissionsPermissions.$94,
    95: RoomSetAttendeePermissionsPermissions.$95,
    96: RoomSetAttendeePermissionsPermissions.$96,
    97: RoomSetAttendeePermissionsPermissions.$97,
    98: RoomSetAttendeePermissionsPermissions.$98,
    99: RoomSetAttendeePermissionsPermissions.$99,
    100: RoomSetAttendeePermissionsPermissions.$100,
    101: RoomSetAttendeePermissionsPermissions.$101,
    102: RoomSetAttendeePermissionsPermissions.$102,
    103: RoomSetAttendeePermissionsPermissions.$103,
    104: RoomSetAttendeePermissionsPermissions.$104,
    105: RoomSetAttendeePermissionsPermissions.$105,
    106: RoomSetAttendeePermissionsPermissions.$106,
    107: RoomSetAttendeePermissionsPermissions.$107,
    108: RoomSetAttendeePermissionsPermissions.$108,
    109: RoomSetAttendeePermissionsPermissions.$109,
    110: RoomSetAttendeePermissionsPermissions.$110,
    111: RoomSetAttendeePermissionsPermissions.$111,
    112: RoomSetAttendeePermissionsPermissions.$112,
    113: RoomSetAttendeePermissionsPermissions.$113,
    114: RoomSetAttendeePermissionsPermissions.$114,
    115: RoomSetAttendeePermissionsPermissions.$115,
    116: RoomSetAttendeePermissionsPermissions.$116,
    117: RoomSetAttendeePermissionsPermissions.$117,
    118: RoomSetAttendeePermissionsPermissions.$118,
    119: RoomSetAttendeePermissionsPermissions.$119,
    120: RoomSetAttendeePermissionsPermissions.$120,
    121: RoomSetAttendeePermissionsPermissions.$121,
    122: RoomSetAttendeePermissionsPermissions.$122,
    123: RoomSetAttendeePermissionsPermissions.$123,
    124: RoomSetAttendeePermissionsPermissions.$124,
    125: RoomSetAttendeePermissionsPermissions.$125,
    126: RoomSetAttendeePermissionsPermissions.$126,
    127: RoomSetAttendeePermissionsPermissions.$127,
    128: RoomSetAttendeePermissionsPermissions.$128,
    129: RoomSetAttendeePermissionsPermissions.$129,
    130: RoomSetAttendeePermissionsPermissions.$130,
    131: RoomSetAttendeePermissionsPermissions.$131,
    132: RoomSetAttendeePermissionsPermissions.$132,
    133: RoomSetAttendeePermissionsPermissions.$133,
    134: RoomSetAttendeePermissionsPermissions.$134,
    135: RoomSetAttendeePermissionsPermissions.$135,
    136: RoomSetAttendeePermissionsPermissions.$136,
    137: RoomSetAttendeePermissionsPermissions.$137,
    138: RoomSetAttendeePermissionsPermissions.$138,
    139: RoomSetAttendeePermissionsPermissions.$139,
    140: RoomSetAttendeePermissionsPermissions.$140,
    141: RoomSetAttendeePermissionsPermissions.$141,
    142: RoomSetAttendeePermissionsPermissions.$142,
    143: RoomSetAttendeePermissionsPermissions.$143,
    144: RoomSetAttendeePermissionsPermissions.$144,
    145: RoomSetAttendeePermissionsPermissions.$145,
    146: RoomSetAttendeePermissionsPermissions.$146,
    147: RoomSetAttendeePermissionsPermissions.$147,
    148: RoomSetAttendeePermissionsPermissions.$148,
    149: RoomSetAttendeePermissionsPermissions.$149,
    150: RoomSetAttendeePermissionsPermissions.$150,
    151: RoomSetAttendeePermissionsPermissions.$151,
    152: RoomSetAttendeePermissionsPermissions.$152,
    153: RoomSetAttendeePermissionsPermissions.$153,
    154: RoomSetAttendeePermissionsPermissions.$154,
    155: RoomSetAttendeePermissionsPermissions.$155,
    156: RoomSetAttendeePermissionsPermissions.$156,
    157: RoomSetAttendeePermissionsPermissions.$157,
    158: RoomSetAttendeePermissionsPermissions.$158,
    159: RoomSetAttendeePermissionsPermissions.$159,
    160: RoomSetAttendeePermissionsPermissions.$160,
    161: RoomSetAttendeePermissionsPermissions.$161,
    162: RoomSetAttendeePermissionsPermissions.$162,
    163: RoomSetAttendeePermissionsPermissions.$163,
    164: RoomSetAttendeePermissionsPermissions.$164,
    165: RoomSetAttendeePermissionsPermissions.$165,
    166: RoomSetAttendeePermissionsPermissions.$166,
    167: RoomSetAttendeePermissionsPermissions.$167,
    168: RoomSetAttendeePermissionsPermissions.$168,
    169: RoomSetAttendeePermissionsPermissions.$169,
    170: RoomSetAttendeePermissionsPermissions.$170,
    171: RoomSetAttendeePermissionsPermissions.$171,
    172: RoomSetAttendeePermissionsPermissions.$172,
    173: RoomSetAttendeePermissionsPermissions.$173,
    174: RoomSetAttendeePermissionsPermissions.$174,
    175: RoomSetAttendeePermissionsPermissions.$175,
    176: RoomSetAttendeePermissionsPermissions.$176,
    177: RoomSetAttendeePermissionsPermissions.$177,
    178: RoomSetAttendeePermissionsPermissions.$178,
    179: RoomSetAttendeePermissionsPermissions.$179,
    180: RoomSetAttendeePermissionsPermissions.$180,
    181: RoomSetAttendeePermissionsPermissions.$181,
    182: RoomSetAttendeePermissionsPermissions.$182,
    183: RoomSetAttendeePermissionsPermissions.$183,
    184: RoomSetAttendeePermissionsPermissions.$184,
    185: RoomSetAttendeePermissionsPermissions.$185,
    186: RoomSetAttendeePermissionsPermissions.$186,
    187: RoomSetAttendeePermissionsPermissions.$187,
    188: RoomSetAttendeePermissionsPermissions.$188,
    189: RoomSetAttendeePermissionsPermissions.$189,
    190: RoomSetAttendeePermissionsPermissions.$190,
    191: RoomSetAttendeePermissionsPermissions.$191,
    192: RoomSetAttendeePermissionsPermissions.$192,
    193: RoomSetAttendeePermissionsPermissions.$193,
    194: RoomSetAttendeePermissionsPermissions.$194,
    195: RoomSetAttendeePermissionsPermissions.$195,
    196: RoomSetAttendeePermissionsPermissions.$196,
    197: RoomSetAttendeePermissionsPermissions.$197,
    198: RoomSetAttendeePermissionsPermissions.$198,
    199: RoomSetAttendeePermissionsPermissions.$199,
    200: RoomSetAttendeePermissionsPermissions.$200,
    201: RoomSetAttendeePermissionsPermissions.$201,
    202: RoomSetAttendeePermissionsPermissions.$202,
    203: RoomSetAttendeePermissionsPermissions.$203,
    204: RoomSetAttendeePermissionsPermissions.$204,
    205: RoomSetAttendeePermissionsPermissions.$205,
    206: RoomSetAttendeePermissionsPermissions.$206,
    207: RoomSetAttendeePermissionsPermissions.$207,
    208: RoomSetAttendeePermissionsPermissions.$208,
    209: RoomSetAttendeePermissionsPermissions.$209,
    210: RoomSetAttendeePermissionsPermissions.$210,
    211: RoomSetAttendeePermissionsPermissions.$211,
    212: RoomSetAttendeePermissionsPermissions.$212,
    213: RoomSetAttendeePermissionsPermissions.$213,
    214: RoomSetAttendeePermissionsPermissions.$214,
    215: RoomSetAttendeePermissionsPermissions.$215,
    216: RoomSetAttendeePermissionsPermissions.$216,
    217: RoomSetAttendeePermissionsPermissions.$217,
    218: RoomSetAttendeePermissionsPermissions.$218,
    219: RoomSetAttendeePermissionsPermissions.$219,
    220: RoomSetAttendeePermissionsPermissions.$220,
    221: RoomSetAttendeePermissionsPermissions.$221,
    222: RoomSetAttendeePermissionsPermissions.$222,
    223: RoomSetAttendeePermissionsPermissions.$223,
    224: RoomSetAttendeePermissionsPermissions.$224,
    225: RoomSetAttendeePermissionsPermissions.$225,
    226: RoomSetAttendeePermissionsPermissions.$226,
    227: RoomSetAttendeePermissionsPermissions.$227,
    228: RoomSetAttendeePermissionsPermissions.$228,
    229: RoomSetAttendeePermissionsPermissions.$229,
    230: RoomSetAttendeePermissionsPermissions.$230,
    231: RoomSetAttendeePermissionsPermissions.$231,
    232: RoomSetAttendeePermissionsPermissions.$232,
    233: RoomSetAttendeePermissionsPermissions.$233,
    234: RoomSetAttendeePermissionsPermissions.$234,
    235: RoomSetAttendeePermissionsPermissions.$235,
    236: RoomSetAttendeePermissionsPermissions.$236,
    237: RoomSetAttendeePermissionsPermissions.$237,
    238: RoomSetAttendeePermissionsPermissions.$238,
    239: RoomSetAttendeePermissionsPermissions.$239,
    240: RoomSetAttendeePermissionsPermissions.$240,
    241: RoomSetAttendeePermissionsPermissions.$241,
    242: RoomSetAttendeePermissionsPermissions.$242,
    243: RoomSetAttendeePermissionsPermissions.$243,
    244: RoomSetAttendeePermissionsPermissions.$244,
    245: RoomSetAttendeePermissionsPermissions.$245,
    246: RoomSetAttendeePermissionsPermissions.$246,
    247: RoomSetAttendeePermissionsPermissions.$247,
    248: RoomSetAttendeePermissionsPermissions.$248,
    249: RoomSetAttendeePermissionsPermissions.$249,
    250: RoomSetAttendeePermissionsPermissions.$250,
    251: RoomSetAttendeePermissionsPermissions.$251,
    252: RoomSetAttendeePermissionsPermissions.$252,
    253: RoomSetAttendeePermissionsPermissions.$253,
    254: RoomSetAttendeePermissionsPermissions.$254,
    255: RoomSetAttendeePermissionsPermissions.$255,
  };

  @override
  Iterable<Type> get types => const [RoomSetAttendeePermissionsPermissions];

  @override
  String get wireName => 'RoomSetAttendeePermissionsPermissions';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAttendeePermissionsPermissions object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAttendeePermissionsPermissions deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetAttendeePermissionsApiVersion extends EnumClass {
  const RoomSetAttendeePermissionsApiVersion._(super.name);

  static const RoomSetAttendeePermissionsApiVersion v4 = _$roomSetAttendeePermissionsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetAttendeePermissionsApiVersion> get values => _$roomSetAttendeePermissionsApiVersionValues;
  // coverage:ignore-end

  static RoomSetAttendeePermissionsApiVersion valueOf(String name) =>
      _$valueOfRoomSetAttendeePermissionsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAttendeePermissionsApiVersion> get serializer =>
      const _$RoomSetAttendeePermissionsApiVersionSerializer();
}

class _$RoomSetAttendeePermissionsApiVersionSerializer
    implements PrimitiveSerializer<RoomSetAttendeePermissionsApiVersion> {
  const _$RoomSetAttendeePermissionsApiVersionSerializer();

  static const Map<RoomSetAttendeePermissionsApiVersion, Object> _toWire =
      <RoomSetAttendeePermissionsApiVersion, Object>{
    RoomSetAttendeePermissionsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetAttendeePermissionsApiVersion> _fromWire =
      <Object, RoomSetAttendeePermissionsApiVersion>{
    'v4': RoomSetAttendeePermissionsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetAttendeePermissionsApiVersion];

  @override
  String get wireName => 'RoomSetAttendeePermissionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAttendeePermissionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAttendeePermissionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAttendeePermissionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetAttendeePermissionsResponseApplicationJson_Ocs
    implements
        $RoomSetAttendeePermissionsResponseApplicationJson_OcsInterface,
        Built<RoomSetAttendeePermissionsResponseApplicationJson_Ocs,
            RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder> {
  factory RoomSetAttendeePermissionsResponseApplicationJson_Ocs([
    void Function(RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetAttendeePermissionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetAttendeePermissionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetAttendeePermissionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetAttendeePermissionsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetAttendeePermissionsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAttendeePermissionsResponseApplicationJsonInterface {
  RoomSetAttendeePermissionsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetAttendeePermissionsResponseApplicationJson
    implements
        $RoomSetAttendeePermissionsResponseApplicationJsonInterface,
        Built<RoomSetAttendeePermissionsResponseApplicationJson,
            RoomSetAttendeePermissionsResponseApplicationJsonBuilder> {
  factory RoomSetAttendeePermissionsResponseApplicationJson([
    void Function(RoomSetAttendeePermissionsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetAttendeePermissionsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetAttendeePermissionsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetAttendeePermissionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetAttendeePermissionsResponseApplicationJson> get serializer =>
      _$roomSetAttendeePermissionsResponseApplicationJsonSerializer;
}

class RoomSetAllAttendeesPermissionsMethod extends EnumClass {
  const RoomSetAllAttendeesPermissionsMethod._(super.name);

  @BuiltValueEnumConst(wireName: 'set')
  static const RoomSetAllAttendeesPermissionsMethod $set = _$roomSetAllAttendeesPermissionsMethod$set;

  static const RoomSetAllAttendeesPermissionsMethod remove = _$roomSetAllAttendeesPermissionsMethodRemove;

  static const RoomSetAllAttendeesPermissionsMethod add = _$roomSetAllAttendeesPermissionsMethodAdd;

  // coverage:ignore-start
  static BuiltSet<RoomSetAllAttendeesPermissionsMethod> get values => _$roomSetAllAttendeesPermissionsMethodValues;
  // coverage:ignore-end

  static RoomSetAllAttendeesPermissionsMethod valueOf(String name) =>
      _$valueOfRoomSetAllAttendeesPermissionsMethod(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAllAttendeesPermissionsMethod> get serializer =>
      const _$RoomSetAllAttendeesPermissionsMethodSerializer();
}

class _$RoomSetAllAttendeesPermissionsMethodSerializer
    implements PrimitiveSerializer<RoomSetAllAttendeesPermissionsMethod> {
  const _$RoomSetAllAttendeesPermissionsMethodSerializer();

  static const Map<RoomSetAllAttendeesPermissionsMethod, Object> _toWire =
      <RoomSetAllAttendeesPermissionsMethod, Object>{
    RoomSetAllAttendeesPermissionsMethod.$set: 'set',
    RoomSetAllAttendeesPermissionsMethod.remove: 'remove',
    RoomSetAllAttendeesPermissionsMethod.add: 'add',
  };

  static const Map<Object, RoomSetAllAttendeesPermissionsMethod> _fromWire =
      <Object, RoomSetAllAttendeesPermissionsMethod>{
    'set': RoomSetAllAttendeesPermissionsMethod.$set,
    'remove': RoomSetAllAttendeesPermissionsMethod.remove,
    'add': RoomSetAllAttendeesPermissionsMethod.add,
  };

  @override
  Iterable<Type> get types => const [RoomSetAllAttendeesPermissionsMethod];

  @override
  String get wireName => 'RoomSetAllAttendeesPermissionsMethod';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAllAttendeesPermissionsMethod object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAllAttendeesPermissionsMethod deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetAllAttendeesPermissionsPermissions extends EnumClass {
  const RoomSetAllAttendeesPermissionsPermissions._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetAllAttendeesPermissionsPermissions $0 = _$roomSetAllAttendeesPermissionsPermissions$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetAllAttendeesPermissionsPermissions $1 = _$roomSetAllAttendeesPermissionsPermissions$1;

  @BuiltValueEnumConst(wireName: '2')
  static const RoomSetAllAttendeesPermissionsPermissions $2 = _$roomSetAllAttendeesPermissionsPermissions$2;

  @BuiltValueEnumConst(wireName: '3')
  static const RoomSetAllAttendeesPermissionsPermissions $3 = _$roomSetAllAttendeesPermissionsPermissions$3;

  @BuiltValueEnumConst(wireName: '4')
  static const RoomSetAllAttendeesPermissionsPermissions $4 = _$roomSetAllAttendeesPermissionsPermissions$4;

  @BuiltValueEnumConst(wireName: '5')
  static const RoomSetAllAttendeesPermissionsPermissions $5 = _$roomSetAllAttendeesPermissionsPermissions$5;

  @BuiltValueEnumConst(wireName: '6')
  static const RoomSetAllAttendeesPermissionsPermissions $6 = _$roomSetAllAttendeesPermissionsPermissions$6;

  @BuiltValueEnumConst(wireName: '7')
  static const RoomSetAllAttendeesPermissionsPermissions $7 = _$roomSetAllAttendeesPermissionsPermissions$7;

  @BuiltValueEnumConst(wireName: '8')
  static const RoomSetAllAttendeesPermissionsPermissions $8 = _$roomSetAllAttendeesPermissionsPermissions$8;

  @BuiltValueEnumConst(wireName: '9')
  static const RoomSetAllAttendeesPermissionsPermissions $9 = _$roomSetAllAttendeesPermissionsPermissions$9;

  @BuiltValueEnumConst(wireName: '10')
  static const RoomSetAllAttendeesPermissionsPermissions $10 = _$roomSetAllAttendeesPermissionsPermissions$10;

  @BuiltValueEnumConst(wireName: '11')
  static const RoomSetAllAttendeesPermissionsPermissions $11 = _$roomSetAllAttendeesPermissionsPermissions$11;

  @BuiltValueEnumConst(wireName: '12')
  static const RoomSetAllAttendeesPermissionsPermissions $12 = _$roomSetAllAttendeesPermissionsPermissions$12;

  @BuiltValueEnumConst(wireName: '13')
  static const RoomSetAllAttendeesPermissionsPermissions $13 = _$roomSetAllAttendeesPermissionsPermissions$13;

  @BuiltValueEnumConst(wireName: '14')
  static const RoomSetAllAttendeesPermissionsPermissions $14 = _$roomSetAllAttendeesPermissionsPermissions$14;

  @BuiltValueEnumConst(wireName: '15')
  static const RoomSetAllAttendeesPermissionsPermissions $15 = _$roomSetAllAttendeesPermissionsPermissions$15;

  @BuiltValueEnumConst(wireName: '16')
  static const RoomSetAllAttendeesPermissionsPermissions $16 = _$roomSetAllAttendeesPermissionsPermissions$16;

  @BuiltValueEnumConst(wireName: '17')
  static const RoomSetAllAttendeesPermissionsPermissions $17 = _$roomSetAllAttendeesPermissionsPermissions$17;

  @BuiltValueEnumConst(wireName: '18')
  static const RoomSetAllAttendeesPermissionsPermissions $18 = _$roomSetAllAttendeesPermissionsPermissions$18;

  @BuiltValueEnumConst(wireName: '19')
  static const RoomSetAllAttendeesPermissionsPermissions $19 = _$roomSetAllAttendeesPermissionsPermissions$19;

  @BuiltValueEnumConst(wireName: '20')
  static const RoomSetAllAttendeesPermissionsPermissions $20 = _$roomSetAllAttendeesPermissionsPermissions$20;

  @BuiltValueEnumConst(wireName: '21')
  static const RoomSetAllAttendeesPermissionsPermissions $21 = _$roomSetAllAttendeesPermissionsPermissions$21;

  @BuiltValueEnumConst(wireName: '22')
  static const RoomSetAllAttendeesPermissionsPermissions $22 = _$roomSetAllAttendeesPermissionsPermissions$22;

  @BuiltValueEnumConst(wireName: '23')
  static const RoomSetAllAttendeesPermissionsPermissions $23 = _$roomSetAllAttendeesPermissionsPermissions$23;

  @BuiltValueEnumConst(wireName: '24')
  static const RoomSetAllAttendeesPermissionsPermissions $24 = _$roomSetAllAttendeesPermissionsPermissions$24;

  @BuiltValueEnumConst(wireName: '25')
  static const RoomSetAllAttendeesPermissionsPermissions $25 = _$roomSetAllAttendeesPermissionsPermissions$25;

  @BuiltValueEnumConst(wireName: '26')
  static const RoomSetAllAttendeesPermissionsPermissions $26 = _$roomSetAllAttendeesPermissionsPermissions$26;

  @BuiltValueEnumConst(wireName: '27')
  static const RoomSetAllAttendeesPermissionsPermissions $27 = _$roomSetAllAttendeesPermissionsPermissions$27;

  @BuiltValueEnumConst(wireName: '28')
  static const RoomSetAllAttendeesPermissionsPermissions $28 = _$roomSetAllAttendeesPermissionsPermissions$28;

  @BuiltValueEnumConst(wireName: '29')
  static const RoomSetAllAttendeesPermissionsPermissions $29 = _$roomSetAllAttendeesPermissionsPermissions$29;

  @BuiltValueEnumConst(wireName: '30')
  static const RoomSetAllAttendeesPermissionsPermissions $30 = _$roomSetAllAttendeesPermissionsPermissions$30;

  @BuiltValueEnumConst(wireName: '31')
  static const RoomSetAllAttendeesPermissionsPermissions $31 = _$roomSetAllAttendeesPermissionsPermissions$31;

  @BuiltValueEnumConst(wireName: '32')
  static const RoomSetAllAttendeesPermissionsPermissions $32 = _$roomSetAllAttendeesPermissionsPermissions$32;

  @BuiltValueEnumConst(wireName: '33')
  static const RoomSetAllAttendeesPermissionsPermissions $33 = _$roomSetAllAttendeesPermissionsPermissions$33;

  @BuiltValueEnumConst(wireName: '34')
  static const RoomSetAllAttendeesPermissionsPermissions $34 = _$roomSetAllAttendeesPermissionsPermissions$34;

  @BuiltValueEnumConst(wireName: '35')
  static const RoomSetAllAttendeesPermissionsPermissions $35 = _$roomSetAllAttendeesPermissionsPermissions$35;

  @BuiltValueEnumConst(wireName: '36')
  static const RoomSetAllAttendeesPermissionsPermissions $36 = _$roomSetAllAttendeesPermissionsPermissions$36;

  @BuiltValueEnumConst(wireName: '37')
  static const RoomSetAllAttendeesPermissionsPermissions $37 = _$roomSetAllAttendeesPermissionsPermissions$37;

  @BuiltValueEnumConst(wireName: '38')
  static const RoomSetAllAttendeesPermissionsPermissions $38 = _$roomSetAllAttendeesPermissionsPermissions$38;

  @BuiltValueEnumConst(wireName: '39')
  static const RoomSetAllAttendeesPermissionsPermissions $39 = _$roomSetAllAttendeesPermissionsPermissions$39;

  @BuiltValueEnumConst(wireName: '40')
  static const RoomSetAllAttendeesPermissionsPermissions $40 = _$roomSetAllAttendeesPermissionsPermissions$40;

  @BuiltValueEnumConst(wireName: '41')
  static const RoomSetAllAttendeesPermissionsPermissions $41 = _$roomSetAllAttendeesPermissionsPermissions$41;

  @BuiltValueEnumConst(wireName: '42')
  static const RoomSetAllAttendeesPermissionsPermissions $42 = _$roomSetAllAttendeesPermissionsPermissions$42;

  @BuiltValueEnumConst(wireName: '43')
  static const RoomSetAllAttendeesPermissionsPermissions $43 = _$roomSetAllAttendeesPermissionsPermissions$43;

  @BuiltValueEnumConst(wireName: '44')
  static const RoomSetAllAttendeesPermissionsPermissions $44 = _$roomSetAllAttendeesPermissionsPermissions$44;

  @BuiltValueEnumConst(wireName: '45')
  static const RoomSetAllAttendeesPermissionsPermissions $45 = _$roomSetAllAttendeesPermissionsPermissions$45;

  @BuiltValueEnumConst(wireName: '46')
  static const RoomSetAllAttendeesPermissionsPermissions $46 = _$roomSetAllAttendeesPermissionsPermissions$46;

  @BuiltValueEnumConst(wireName: '47')
  static const RoomSetAllAttendeesPermissionsPermissions $47 = _$roomSetAllAttendeesPermissionsPermissions$47;

  @BuiltValueEnumConst(wireName: '48')
  static const RoomSetAllAttendeesPermissionsPermissions $48 = _$roomSetAllAttendeesPermissionsPermissions$48;

  @BuiltValueEnumConst(wireName: '49')
  static const RoomSetAllAttendeesPermissionsPermissions $49 = _$roomSetAllAttendeesPermissionsPermissions$49;

  @BuiltValueEnumConst(wireName: '50')
  static const RoomSetAllAttendeesPermissionsPermissions $50 = _$roomSetAllAttendeesPermissionsPermissions$50;

  @BuiltValueEnumConst(wireName: '51')
  static const RoomSetAllAttendeesPermissionsPermissions $51 = _$roomSetAllAttendeesPermissionsPermissions$51;

  @BuiltValueEnumConst(wireName: '52')
  static const RoomSetAllAttendeesPermissionsPermissions $52 = _$roomSetAllAttendeesPermissionsPermissions$52;

  @BuiltValueEnumConst(wireName: '53')
  static const RoomSetAllAttendeesPermissionsPermissions $53 = _$roomSetAllAttendeesPermissionsPermissions$53;

  @BuiltValueEnumConst(wireName: '54')
  static const RoomSetAllAttendeesPermissionsPermissions $54 = _$roomSetAllAttendeesPermissionsPermissions$54;

  @BuiltValueEnumConst(wireName: '55')
  static const RoomSetAllAttendeesPermissionsPermissions $55 = _$roomSetAllAttendeesPermissionsPermissions$55;

  @BuiltValueEnumConst(wireName: '56')
  static const RoomSetAllAttendeesPermissionsPermissions $56 = _$roomSetAllAttendeesPermissionsPermissions$56;

  @BuiltValueEnumConst(wireName: '57')
  static const RoomSetAllAttendeesPermissionsPermissions $57 = _$roomSetAllAttendeesPermissionsPermissions$57;

  @BuiltValueEnumConst(wireName: '58')
  static const RoomSetAllAttendeesPermissionsPermissions $58 = _$roomSetAllAttendeesPermissionsPermissions$58;

  @BuiltValueEnumConst(wireName: '59')
  static const RoomSetAllAttendeesPermissionsPermissions $59 = _$roomSetAllAttendeesPermissionsPermissions$59;

  @BuiltValueEnumConst(wireName: '60')
  static const RoomSetAllAttendeesPermissionsPermissions $60 = _$roomSetAllAttendeesPermissionsPermissions$60;

  @BuiltValueEnumConst(wireName: '61')
  static const RoomSetAllAttendeesPermissionsPermissions $61 = _$roomSetAllAttendeesPermissionsPermissions$61;

  @BuiltValueEnumConst(wireName: '62')
  static const RoomSetAllAttendeesPermissionsPermissions $62 = _$roomSetAllAttendeesPermissionsPermissions$62;

  @BuiltValueEnumConst(wireName: '63')
  static const RoomSetAllAttendeesPermissionsPermissions $63 = _$roomSetAllAttendeesPermissionsPermissions$63;

  @BuiltValueEnumConst(wireName: '64')
  static const RoomSetAllAttendeesPermissionsPermissions $64 = _$roomSetAllAttendeesPermissionsPermissions$64;

  @BuiltValueEnumConst(wireName: '65')
  static const RoomSetAllAttendeesPermissionsPermissions $65 = _$roomSetAllAttendeesPermissionsPermissions$65;

  @BuiltValueEnumConst(wireName: '66')
  static const RoomSetAllAttendeesPermissionsPermissions $66 = _$roomSetAllAttendeesPermissionsPermissions$66;

  @BuiltValueEnumConst(wireName: '67')
  static const RoomSetAllAttendeesPermissionsPermissions $67 = _$roomSetAllAttendeesPermissionsPermissions$67;

  @BuiltValueEnumConst(wireName: '68')
  static const RoomSetAllAttendeesPermissionsPermissions $68 = _$roomSetAllAttendeesPermissionsPermissions$68;

  @BuiltValueEnumConst(wireName: '69')
  static const RoomSetAllAttendeesPermissionsPermissions $69 = _$roomSetAllAttendeesPermissionsPermissions$69;

  @BuiltValueEnumConst(wireName: '70')
  static const RoomSetAllAttendeesPermissionsPermissions $70 = _$roomSetAllAttendeesPermissionsPermissions$70;

  @BuiltValueEnumConst(wireName: '71')
  static const RoomSetAllAttendeesPermissionsPermissions $71 = _$roomSetAllAttendeesPermissionsPermissions$71;

  @BuiltValueEnumConst(wireName: '72')
  static const RoomSetAllAttendeesPermissionsPermissions $72 = _$roomSetAllAttendeesPermissionsPermissions$72;

  @BuiltValueEnumConst(wireName: '73')
  static const RoomSetAllAttendeesPermissionsPermissions $73 = _$roomSetAllAttendeesPermissionsPermissions$73;

  @BuiltValueEnumConst(wireName: '74')
  static const RoomSetAllAttendeesPermissionsPermissions $74 = _$roomSetAllAttendeesPermissionsPermissions$74;

  @BuiltValueEnumConst(wireName: '75')
  static const RoomSetAllAttendeesPermissionsPermissions $75 = _$roomSetAllAttendeesPermissionsPermissions$75;

  @BuiltValueEnumConst(wireName: '76')
  static const RoomSetAllAttendeesPermissionsPermissions $76 = _$roomSetAllAttendeesPermissionsPermissions$76;

  @BuiltValueEnumConst(wireName: '77')
  static const RoomSetAllAttendeesPermissionsPermissions $77 = _$roomSetAllAttendeesPermissionsPermissions$77;

  @BuiltValueEnumConst(wireName: '78')
  static const RoomSetAllAttendeesPermissionsPermissions $78 = _$roomSetAllAttendeesPermissionsPermissions$78;

  @BuiltValueEnumConst(wireName: '79')
  static const RoomSetAllAttendeesPermissionsPermissions $79 = _$roomSetAllAttendeesPermissionsPermissions$79;

  @BuiltValueEnumConst(wireName: '80')
  static const RoomSetAllAttendeesPermissionsPermissions $80 = _$roomSetAllAttendeesPermissionsPermissions$80;

  @BuiltValueEnumConst(wireName: '81')
  static const RoomSetAllAttendeesPermissionsPermissions $81 = _$roomSetAllAttendeesPermissionsPermissions$81;

  @BuiltValueEnumConst(wireName: '82')
  static const RoomSetAllAttendeesPermissionsPermissions $82 = _$roomSetAllAttendeesPermissionsPermissions$82;

  @BuiltValueEnumConst(wireName: '83')
  static const RoomSetAllAttendeesPermissionsPermissions $83 = _$roomSetAllAttendeesPermissionsPermissions$83;

  @BuiltValueEnumConst(wireName: '84')
  static const RoomSetAllAttendeesPermissionsPermissions $84 = _$roomSetAllAttendeesPermissionsPermissions$84;

  @BuiltValueEnumConst(wireName: '85')
  static const RoomSetAllAttendeesPermissionsPermissions $85 = _$roomSetAllAttendeesPermissionsPermissions$85;

  @BuiltValueEnumConst(wireName: '86')
  static const RoomSetAllAttendeesPermissionsPermissions $86 = _$roomSetAllAttendeesPermissionsPermissions$86;

  @BuiltValueEnumConst(wireName: '87')
  static const RoomSetAllAttendeesPermissionsPermissions $87 = _$roomSetAllAttendeesPermissionsPermissions$87;

  @BuiltValueEnumConst(wireName: '88')
  static const RoomSetAllAttendeesPermissionsPermissions $88 = _$roomSetAllAttendeesPermissionsPermissions$88;

  @BuiltValueEnumConst(wireName: '89')
  static const RoomSetAllAttendeesPermissionsPermissions $89 = _$roomSetAllAttendeesPermissionsPermissions$89;

  @BuiltValueEnumConst(wireName: '90')
  static const RoomSetAllAttendeesPermissionsPermissions $90 = _$roomSetAllAttendeesPermissionsPermissions$90;

  @BuiltValueEnumConst(wireName: '91')
  static const RoomSetAllAttendeesPermissionsPermissions $91 = _$roomSetAllAttendeesPermissionsPermissions$91;

  @BuiltValueEnumConst(wireName: '92')
  static const RoomSetAllAttendeesPermissionsPermissions $92 = _$roomSetAllAttendeesPermissionsPermissions$92;

  @BuiltValueEnumConst(wireName: '93')
  static const RoomSetAllAttendeesPermissionsPermissions $93 = _$roomSetAllAttendeesPermissionsPermissions$93;

  @BuiltValueEnumConst(wireName: '94')
  static const RoomSetAllAttendeesPermissionsPermissions $94 = _$roomSetAllAttendeesPermissionsPermissions$94;

  @BuiltValueEnumConst(wireName: '95')
  static const RoomSetAllAttendeesPermissionsPermissions $95 = _$roomSetAllAttendeesPermissionsPermissions$95;

  @BuiltValueEnumConst(wireName: '96')
  static const RoomSetAllAttendeesPermissionsPermissions $96 = _$roomSetAllAttendeesPermissionsPermissions$96;

  @BuiltValueEnumConst(wireName: '97')
  static const RoomSetAllAttendeesPermissionsPermissions $97 = _$roomSetAllAttendeesPermissionsPermissions$97;

  @BuiltValueEnumConst(wireName: '98')
  static const RoomSetAllAttendeesPermissionsPermissions $98 = _$roomSetAllAttendeesPermissionsPermissions$98;

  @BuiltValueEnumConst(wireName: '99')
  static const RoomSetAllAttendeesPermissionsPermissions $99 = _$roomSetAllAttendeesPermissionsPermissions$99;

  @BuiltValueEnumConst(wireName: '100')
  static const RoomSetAllAttendeesPermissionsPermissions $100 = _$roomSetAllAttendeesPermissionsPermissions$100;

  @BuiltValueEnumConst(wireName: '101')
  static const RoomSetAllAttendeesPermissionsPermissions $101 = _$roomSetAllAttendeesPermissionsPermissions$101;

  @BuiltValueEnumConst(wireName: '102')
  static const RoomSetAllAttendeesPermissionsPermissions $102 = _$roomSetAllAttendeesPermissionsPermissions$102;

  @BuiltValueEnumConst(wireName: '103')
  static const RoomSetAllAttendeesPermissionsPermissions $103 = _$roomSetAllAttendeesPermissionsPermissions$103;

  @BuiltValueEnumConst(wireName: '104')
  static const RoomSetAllAttendeesPermissionsPermissions $104 = _$roomSetAllAttendeesPermissionsPermissions$104;

  @BuiltValueEnumConst(wireName: '105')
  static const RoomSetAllAttendeesPermissionsPermissions $105 = _$roomSetAllAttendeesPermissionsPermissions$105;

  @BuiltValueEnumConst(wireName: '106')
  static const RoomSetAllAttendeesPermissionsPermissions $106 = _$roomSetAllAttendeesPermissionsPermissions$106;

  @BuiltValueEnumConst(wireName: '107')
  static const RoomSetAllAttendeesPermissionsPermissions $107 = _$roomSetAllAttendeesPermissionsPermissions$107;

  @BuiltValueEnumConst(wireName: '108')
  static const RoomSetAllAttendeesPermissionsPermissions $108 = _$roomSetAllAttendeesPermissionsPermissions$108;

  @BuiltValueEnumConst(wireName: '109')
  static const RoomSetAllAttendeesPermissionsPermissions $109 = _$roomSetAllAttendeesPermissionsPermissions$109;

  @BuiltValueEnumConst(wireName: '110')
  static const RoomSetAllAttendeesPermissionsPermissions $110 = _$roomSetAllAttendeesPermissionsPermissions$110;

  @BuiltValueEnumConst(wireName: '111')
  static const RoomSetAllAttendeesPermissionsPermissions $111 = _$roomSetAllAttendeesPermissionsPermissions$111;

  @BuiltValueEnumConst(wireName: '112')
  static const RoomSetAllAttendeesPermissionsPermissions $112 = _$roomSetAllAttendeesPermissionsPermissions$112;

  @BuiltValueEnumConst(wireName: '113')
  static const RoomSetAllAttendeesPermissionsPermissions $113 = _$roomSetAllAttendeesPermissionsPermissions$113;

  @BuiltValueEnumConst(wireName: '114')
  static const RoomSetAllAttendeesPermissionsPermissions $114 = _$roomSetAllAttendeesPermissionsPermissions$114;

  @BuiltValueEnumConst(wireName: '115')
  static const RoomSetAllAttendeesPermissionsPermissions $115 = _$roomSetAllAttendeesPermissionsPermissions$115;

  @BuiltValueEnumConst(wireName: '116')
  static const RoomSetAllAttendeesPermissionsPermissions $116 = _$roomSetAllAttendeesPermissionsPermissions$116;

  @BuiltValueEnumConst(wireName: '117')
  static const RoomSetAllAttendeesPermissionsPermissions $117 = _$roomSetAllAttendeesPermissionsPermissions$117;

  @BuiltValueEnumConst(wireName: '118')
  static const RoomSetAllAttendeesPermissionsPermissions $118 = _$roomSetAllAttendeesPermissionsPermissions$118;

  @BuiltValueEnumConst(wireName: '119')
  static const RoomSetAllAttendeesPermissionsPermissions $119 = _$roomSetAllAttendeesPermissionsPermissions$119;

  @BuiltValueEnumConst(wireName: '120')
  static const RoomSetAllAttendeesPermissionsPermissions $120 = _$roomSetAllAttendeesPermissionsPermissions$120;

  @BuiltValueEnumConst(wireName: '121')
  static const RoomSetAllAttendeesPermissionsPermissions $121 = _$roomSetAllAttendeesPermissionsPermissions$121;

  @BuiltValueEnumConst(wireName: '122')
  static const RoomSetAllAttendeesPermissionsPermissions $122 = _$roomSetAllAttendeesPermissionsPermissions$122;

  @BuiltValueEnumConst(wireName: '123')
  static const RoomSetAllAttendeesPermissionsPermissions $123 = _$roomSetAllAttendeesPermissionsPermissions$123;

  @BuiltValueEnumConst(wireName: '124')
  static const RoomSetAllAttendeesPermissionsPermissions $124 = _$roomSetAllAttendeesPermissionsPermissions$124;

  @BuiltValueEnumConst(wireName: '125')
  static const RoomSetAllAttendeesPermissionsPermissions $125 = _$roomSetAllAttendeesPermissionsPermissions$125;

  @BuiltValueEnumConst(wireName: '126')
  static const RoomSetAllAttendeesPermissionsPermissions $126 = _$roomSetAllAttendeesPermissionsPermissions$126;

  @BuiltValueEnumConst(wireName: '127')
  static const RoomSetAllAttendeesPermissionsPermissions $127 = _$roomSetAllAttendeesPermissionsPermissions$127;

  @BuiltValueEnumConst(wireName: '128')
  static const RoomSetAllAttendeesPermissionsPermissions $128 = _$roomSetAllAttendeesPermissionsPermissions$128;

  @BuiltValueEnumConst(wireName: '129')
  static const RoomSetAllAttendeesPermissionsPermissions $129 = _$roomSetAllAttendeesPermissionsPermissions$129;

  @BuiltValueEnumConst(wireName: '130')
  static const RoomSetAllAttendeesPermissionsPermissions $130 = _$roomSetAllAttendeesPermissionsPermissions$130;

  @BuiltValueEnumConst(wireName: '131')
  static const RoomSetAllAttendeesPermissionsPermissions $131 = _$roomSetAllAttendeesPermissionsPermissions$131;

  @BuiltValueEnumConst(wireName: '132')
  static const RoomSetAllAttendeesPermissionsPermissions $132 = _$roomSetAllAttendeesPermissionsPermissions$132;

  @BuiltValueEnumConst(wireName: '133')
  static const RoomSetAllAttendeesPermissionsPermissions $133 = _$roomSetAllAttendeesPermissionsPermissions$133;

  @BuiltValueEnumConst(wireName: '134')
  static const RoomSetAllAttendeesPermissionsPermissions $134 = _$roomSetAllAttendeesPermissionsPermissions$134;

  @BuiltValueEnumConst(wireName: '135')
  static const RoomSetAllAttendeesPermissionsPermissions $135 = _$roomSetAllAttendeesPermissionsPermissions$135;

  @BuiltValueEnumConst(wireName: '136')
  static const RoomSetAllAttendeesPermissionsPermissions $136 = _$roomSetAllAttendeesPermissionsPermissions$136;

  @BuiltValueEnumConst(wireName: '137')
  static const RoomSetAllAttendeesPermissionsPermissions $137 = _$roomSetAllAttendeesPermissionsPermissions$137;

  @BuiltValueEnumConst(wireName: '138')
  static const RoomSetAllAttendeesPermissionsPermissions $138 = _$roomSetAllAttendeesPermissionsPermissions$138;

  @BuiltValueEnumConst(wireName: '139')
  static const RoomSetAllAttendeesPermissionsPermissions $139 = _$roomSetAllAttendeesPermissionsPermissions$139;

  @BuiltValueEnumConst(wireName: '140')
  static const RoomSetAllAttendeesPermissionsPermissions $140 = _$roomSetAllAttendeesPermissionsPermissions$140;

  @BuiltValueEnumConst(wireName: '141')
  static const RoomSetAllAttendeesPermissionsPermissions $141 = _$roomSetAllAttendeesPermissionsPermissions$141;

  @BuiltValueEnumConst(wireName: '142')
  static const RoomSetAllAttendeesPermissionsPermissions $142 = _$roomSetAllAttendeesPermissionsPermissions$142;

  @BuiltValueEnumConst(wireName: '143')
  static const RoomSetAllAttendeesPermissionsPermissions $143 = _$roomSetAllAttendeesPermissionsPermissions$143;

  @BuiltValueEnumConst(wireName: '144')
  static const RoomSetAllAttendeesPermissionsPermissions $144 = _$roomSetAllAttendeesPermissionsPermissions$144;

  @BuiltValueEnumConst(wireName: '145')
  static const RoomSetAllAttendeesPermissionsPermissions $145 = _$roomSetAllAttendeesPermissionsPermissions$145;

  @BuiltValueEnumConst(wireName: '146')
  static const RoomSetAllAttendeesPermissionsPermissions $146 = _$roomSetAllAttendeesPermissionsPermissions$146;

  @BuiltValueEnumConst(wireName: '147')
  static const RoomSetAllAttendeesPermissionsPermissions $147 = _$roomSetAllAttendeesPermissionsPermissions$147;

  @BuiltValueEnumConst(wireName: '148')
  static const RoomSetAllAttendeesPermissionsPermissions $148 = _$roomSetAllAttendeesPermissionsPermissions$148;

  @BuiltValueEnumConst(wireName: '149')
  static const RoomSetAllAttendeesPermissionsPermissions $149 = _$roomSetAllAttendeesPermissionsPermissions$149;

  @BuiltValueEnumConst(wireName: '150')
  static const RoomSetAllAttendeesPermissionsPermissions $150 = _$roomSetAllAttendeesPermissionsPermissions$150;

  @BuiltValueEnumConst(wireName: '151')
  static const RoomSetAllAttendeesPermissionsPermissions $151 = _$roomSetAllAttendeesPermissionsPermissions$151;

  @BuiltValueEnumConst(wireName: '152')
  static const RoomSetAllAttendeesPermissionsPermissions $152 = _$roomSetAllAttendeesPermissionsPermissions$152;

  @BuiltValueEnumConst(wireName: '153')
  static const RoomSetAllAttendeesPermissionsPermissions $153 = _$roomSetAllAttendeesPermissionsPermissions$153;

  @BuiltValueEnumConst(wireName: '154')
  static const RoomSetAllAttendeesPermissionsPermissions $154 = _$roomSetAllAttendeesPermissionsPermissions$154;

  @BuiltValueEnumConst(wireName: '155')
  static const RoomSetAllAttendeesPermissionsPermissions $155 = _$roomSetAllAttendeesPermissionsPermissions$155;

  @BuiltValueEnumConst(wireName: '156')
  static const RoomSetAllAttendeesPermissionsPermissions $156 = _$roomSetAllAttendeesPermissionsPermissions$156;

  @BuiltValueEnumConst(wireName: '157')
  static const RoomSetAllAttendeesPermissionsPermissions $157 = _$roomSetAllAttendeesPermissionsPermissions$157;

  @BuiltValueEnumConst(wireName: '158')
  static const RoomSetAllAttendeesPermissionsPermissions $158 = _$roomSetAllAttendeesPermissionsPermissions$158;

  @BuiltValueEnumConst(wireName: '159')
  static const RoomSetAllAttendeesPermissionsPermissions $159 = _$roomSetAllAttendeesPermissionsPermissions$159;

  @BuiltValueEnumConst(wireName: '160')
  static const RoomSetAllAttendeesPermissionsPermissions $160 = _$roomSetAllAttendeesPermissionsPermissions$160;

  @BuiltValueEnumConst(wireName: '161')
  static const RoomSetAllAttendeesPermissionsPermissions $161 = _$roomSetAllAttendeesPermissionsPermissions$161;

  @BuiltValueEnumConst(wireName: '162')
  static const RoomSetAllAttendeesPermissionsPermissions $162 = _$roomSetAllAttendeesPermissionsPermissions$162;

  @BuiltValueEnumConst(wireName: '163')
  static const RoomSetAllAttendeesPermissionsPermissions $163 = _$roomSetAllAttendeesPermissionsPermissions$163;

  @BuiltValueEnumConst(wireName: '164')
  static const RoomSetAllAttendeesPermissionsPermissions $164 = _$roomSetAllAttendeesPermissionsPermissions$164;

  @BuiltValueEnumConst(wireName: '165')
  static const RoomSetAllAttendeesPermissionsPermissions $165 = _$roomSetAllAttendeesPermissionsPermissions$165;

  @BuiltValueEnumConst(wireName: '166')
  static const RoomSetAllAttendeesPermissionsPermissions $166 = _$roomSetAllAttendeesPermissionsPermissions$166;

  @BuiltValueEnumConst(wireName: '167')
  static const RoomSetAllAttendeesPermissionsPermissions $167 = _$roomSetAllAttendeesPermissionsPermissions$167;

  @BuiltValueEnumConst(wireName: '168')
  static const RoomSetAllAttendeesPermissionsPermissions $168 = _$roomSetAllAttendeesPermissionsPermissions$168;

  @BuiltValueEnumConst(wireName: '169')
  static const RoomSetAllAttendeesPermissionsPermissions $169 = _$roomSetAllAttendeesPermissionsPermissions$169;

  @BuiltValueEnumConst(wireName: '170')
  static const RoomSetAllAttendeesPermissionsPermissions $170 = _$roomSetAllAttendeesPermissionsPermissions$170;

  @BuiltValueEnumConst(wireName: '171')
  static const RoomSetAllAttendeesPermissionsPermissions $171 = _$roomSetAllAttendeesPermissionsPermissions$171;

  @BuiltValueEnumConst(wireName: '172')
  static const RoomSetAllAttendeesPermissionsPermissions $172 = _$roomSetAllAttendeesPermissionsPermissions$172;

  @BuiltValueEnumConst(wireName: '173')
  static const RoomSetAllAttendeesPermissionsPermissions $173 = _$roomSetAllAttendeesPermissionsPermissions$173;

  @BuiltValueEnumConst(wireName: '174')
  static const RoomSetAllAttendeesPermissionsPermissions $174 = _$roomSetAllAttendeesPermissionsPermissions$174;

  @BuiltValueEnumConst(wireName: '175')
  static const RoomSetAllAttendeesPermissionsPermissions $175 = _$roomSetAllAttendeesPermissionsPermissions$175;

  @BuiltValueEnumConst(wireName: '176')
  static const RoomSetAllAttendeesPermissionsPermissions $176 = _$roomSetAllAttendeesPermissionsPermissions$176;

  @BuiltValueEnumConst(wireName: '177')
  static const RoomSetAllAttendeesPermissionsPermissions $177 = _$roomSetAllAttendeesPermissionsPermissions$177;

  @BuiltValueEnumConst(wireName: '178')
  static const RoomSetAllAttendeesPermissionsPermissions $178 = _$roomSetAllAttendeesPermissionsPermissions$178;

  @BuiltValueEnumConst(wireName: '179')
  static const RoomSetAllAttendeesPermissionsPermissions $179 = _$roomSetAllAttendeesPermissionsPermissions$179;

  @BuiltValueEnumConst(wireName: '180')
  static const RoomSetAllAttendeesPermissionsPermissions $180 = _$roomSetAllAttendeesPermissionsPermissions$180;

  @BuiltValueEnumConst(wireName: '181')
  static const RoomSetAllAttendeesPermissionsPermissions $181 = _$roomSetAllAttendeesPermissionsPermissions$181;

  @BuiltValueEnumConst(wireName: '182')
  static const RoomSetAllAttendeesPermissionsPermissions $182 = _$roomSetAllAttendeesPermissionsPermissions$182;

  @BuiltValueEnumConst(wireName: '183')
  static const RoomSetAllAttendeesPermissionsPermissions $183 = _$roomSetAllAttendeesPermissionsPermissions$183;

  @BuiltValueEnumConst(wireName: '184')
  static const RoomSetAllAttendeesPermissionsPermissions $184 = _$roomSetAllAttendeesPermissionsPermissions$184;

  @BuiltValueEnumConst(wireName: '185')
  static const RoomSetAllAttendeesPermissionsPermissions $185 = _$roomSetAllAttendeesPermissionsPermissions$185;

  @BuiltValueEnumConst(wireName: '186')
  static const RoomSetAllAttendeesPermissionsPermissions $186 = _$roomSetAllAttendeesPermissionsPermissions$186;

  @BuiltValueEnumConst(wireName: '187')
  static const RoomSetAllAttendeesPermissionsPermissions $187 = _$roomSetAllAttendeesPermissionsPermissions$187;

  @BuiltValueEnumConst(wireName: '188')
  static const RoomSetAllAttendeesPermissionsPermissions $188 = _$roomSetAllAttendeesPermissionsPermissions$188;

  @BuiltValueEnumConst(wireName: '189')
  static const RoomSetAllAttendeesPermissionsPermissions $189 = _$roomSetAllAttendeesPermissionsPermissions$189;

  @BuiltValueEnumConst(wireName: '190')
  static const RoomSetAllAttendeesPermissionsPermissions $190 = _$roomSetAllAttendeesPermissionsPermissions$190;

  @BuiltValueEnumConst(wireName: '191')
  static const RoomSetAllAttendeesPermissionsPermissions $191 = _$roomSetAllAttendeesPermissionsPermissions$191;

  @BuiltValueEnumConst(wireName: '192')
  static const RoomSetAllAttendeesPermissionsPermissions $192 = _$roomSetAllAttendeesPermissionsPermissions$192;

  @BuiltValueEnumConst(wireName: '193')
  static const RoomSetAllAttendeesPermissionsPermissions $193 = _$roomSetAllAttendeesPermissionsPermissions$193;

  @BuiltValueEnumConst(wireName: '194')
  static const RoomSetAllAttendeesPermissionsPermissions $194 = _$roomSetAllAttendeesPermissionsPermissions$194;

  @BuiltValueEnumConst(wireName: '195')
  static const RoomSetAllAttendeesPermissionsPermissions $195 = _$roomSetAllAttendeesPermissionsPermissions$195;

  @BuiltValueEnumConst(wireName: '196')
  static const RoomSetAllAttendeesPermissionsPermissions $196 = _$roomSetAllAttendeesPermissionsPermissions$196;

  @BuiltValueEnumConst(wireName: '197')
  static const RoomSetAllAttendeesPermissionsPermissions $197 = _$roomSetAllAttendeesPermissionsPermissions$197;

  @BuiltValueEnumConst(wireName: '198')
  static const RoomSetAllAttendeesPermissionsPermissions $198 = _$roomSetAllAttendeesPermissionsPermissions$198;

  @BuiltValueEnumConst(wireName: '199')
  static const RoomSetAllAttendeesPermissionsPermissions $199 = _$roomSetAllAttendeesPermissionsPermissions$199;

  @BuiltValueEnumConst(wireName: '200')
  static const RoomSetAllAttendeesPermissionsPermissions $200 = _$roomSetAllAttendeesPermissionsPermissions$200;

  @BuiltValueEnumConst(wireName: '201')
  static const RoomSetAllAttendeesPermissionsPermissions $201 = _$roomSetAllAttendeesPermissionsPermissions$201;

  @BuiltValueEnumConst(wireName: '202')
  static const RoomSetAllAttendeesPermissionsPermissions $202 = _$roomSetAllAttendeesPermissionsPermissions$202;

  @BuiltValueEnumConst(wireName: '203')
  static const RoomSetAllAttendeesPermissionsPermissions $203 = _$roomSetAllAttendeesPermissionsPermissions$203;

  @BuiltValueEnumConst(wireName: '204')
  static const RoomSetAllAttendeesPermissionsPermissions $204 = _$roomSetAllAttendeesPermissionsPermissions$204;

  @BuiltValueEnumConst(wireName: '205')
  static const RoomSetAllAttendeesPermissionsPermissions $205 = _$roomSetAllAttendeesPermissionsPermissions$205;

  @BuiltValueEnumConst(wireName: '206')
  static const RoomSetAllAttendeesPermissionsPermissions $206 = _$roomSetAllAttendeesPermissionsPermissions$206;

  @BuiltValueEnumConst(wireName: '207')
  static const RoomSetAllAttendeesPermissionsPermissions $207 = _$roomSetAllAttendeesPermissionsPermissions$207;

  @BuiltValueEnumConst(wireName: '208')
  static const RoomSetAllAttendeesPermissionsPermissions $208 = _$roomSetAllAttendeesPermissionsPermissions$208;

  @BuiltValueEnumConst(wireName: '209')
  static const RoomSetAllAttendeesPermissionsPermissions $209 = _$roomSetAllAttendeesPermissionsPermissions$209;

  @BuiltValueEnumConst(wireName: '210')
  static const RoomSetAllAttendeesPermissionsPermissions $210 = _$roomSetAllAttendeesPermissionsPermissions$210;

  @BuiltValueEnumConst(wireName: '211')
  static const RoomSetAllAttendeesPermissionsPermissions $211 = _$roomSetAllAttendeesPermissionsPermissions$211;

  @BuiltValueEnumConst(wireName: '212')
  static const RoomSetAllAttendeesPermissionsPermissions $212 = _$roomSetAllAttendeesPermissionsPermissions$212;

  @BuiltValueEnumConst(wireName: '213')
  static const RoomSetAllAttendeesPermissionsPermissions $213 = _$roomSetAllAttendeesPermissionsPermissions$213;

  @BuiltValueEnumConst(wireName: '214')
  static const RoomSetAllAttendeesPermissionsPermissions $214 = _$roomSetAllAttendeesPermissionsPermissions$214;

  @BuiltValueEnumConst(wireName: '215')
  static const RoomSetAllAttendeesPermissionsPermissions $215 = _$roomSetAllAttendeesPermissionsPermissions$215;

  @BuiltValueEnumConst(wireName: '216')
  static const RoomSetAllAttendeesPermissionsPermissions $216 = _$roomSetAllAttendeesPermissionsPermissions$216;

  @BuiltValueEnumConst(wireName: '217')
  static const RoomSetAllAttendeesPermissionsPermissions $217 = _$roomSetAllAttendeesPermissionsPermissions$217;

  @BuiltValueEnumConst(wireName: '218')
  static const RoomSetAllAttendeesPermissionsPermissions $218 = _$roomSetAllAttendeesPermissionsPermissions$218;

  @BuiltValueEnumConst(wireName: '219')
  static const RoomSetAllAttendeesPermissionsPermissions $219 = _$roomSetAllAttendeesPermissionsPermissions$219;

  @BuiltValueEnumConst(wireName: '220')
  static const RoomSetAllAttendeesPermissionsPermissions $220 = _$roomSetAllAttendeesPermissionsPermissions$220;

  @BuiltValueEnumConst(wireName: '221')
  static const RoomSetAllAttendeesPermissionsPermissions $221 = _$roomSetAllAttendeesPermissionsPermissions$221;

  @BuiltValueEnumConst(wireName: '222')
  static const RoomSetAllAttendeesPermissionsPermissions $222 = _$roomSetAllAttendeesPermissionsPermissions$222;

  @BuiltValueEnumConst(wireName: '223')
  static const RoomSetAllAttendeesPermissionsPermissions $223 = _$roomSetAllAttendeesPermissionsPermissions$223;

  @BuiltValueEnumConst(wireName: '224')
  static const RoomSetAllAttendeesPermissionsPermissions $224 = _$roomSetAllAttendeesPermissionsPermissions$224;

  @BuiltValueEnumConst(wireName: '225')
  static const RoomSetAllAttendeesPermissionsPermissions $225 = _$roomSetAllAttendeesPermissionsPermissions$225;

  @BuiltValueEnumConst(wireName: '226')
  static const RoomSetAllAttendeesPermissionsPermissions $226 = _$roomSetAllAttendeesPermissionsPermissions$226;

  @BuiltValueEnumConst(wireName: '227')
  static const RoomSetAllAttendeesPermissionsPermissions $227 = _$roomSetAllAttendeesPermissionsPermissions$227;

  @BuiltValueEnumConst(wireName: '228')
  static const RoomSetAllAttendeesPermissionsPermissions $228 = _$roomSetAllAttendeesPermissionsPermissions$228;

  @BuiltValueEnumConst(wireName: '229')
  static const RoomSetAllAttendeesPermissionsPermissions $229 = _$roomSetAllAttendeesPermissionsPermissions$229;

  @BuiltValueEnumConst(wireName: '230')
  static const RoomSetAllAttendeesPermissionsPermissions $230 = _$roomSetAllAttendeesPermissionsPermissions$230;

  @BuiltValueEnumConst(wireName: '231')
  static const RoomSetAllAttendeesPermissionsPermissions $231 = _$roomSetAllAttendeesPermissionsPermissions$231;

  @BuiltValueEnumConst(wireName: '232')
  static const RoomSetAllAttendeesPermissionsPermissions $232 = _$roomSetAllAttendeesPermissionsPermissions$232;

  @BuiltValueEnumConst(wireName: '233')
  static const RoomSetAllAttendeesPermissionsPermissions $233 = _$roomSetAllAttendeesPermissionsPermissions$233;

  @BuiltValueEnumConst(wireName: '234')
  static const RoomSetAllAttendeesPermissionsPermissions $234 = _$roomSetAllAttendeesPermissionsPermissions$234;

  @BuiltValueEnumConst(wireName: '235')
  static const RoomSetAllAttendeesPermissionsPermissions $235 = _$roomSetAllAttendeesPermissionsPermissions$235;

  @BuiltValueEnumConst(wireName: '236')
  static const RoomSetAllAttendeesPermissionsPermissions $236 = _$roomSetAllAttendeesPermissionsPermissions$236;

  @BuiltValueEnumConst(wireName: '237')
  static const RoomSetAllAttendeesPermissionsPermissions $237 = _$roomSetAllAttendeesPermissionsPermissions$237;

  @BuiltValueEnumConst(wireName: '238')
  static const RoomSetAllAttendeesPermissionsPermissions $238 = _$roomSetAllAttendeesPermissionsPermissions$238;

  @BuiltValueEnumConst(wireName: '239')
  static const RoomSetAllAttendeesPermissionsPermissions $239 = _$roomSetAllAttendeesPermissionsPermissions$239;

  @BuiltValueEnumConst(wireName: '240')
  static const RoomSetAllAttendeesPermissionsPermissions $240 = _$roomSetAllAttendeesPermissionsPermissions$240;

  @BuiltValueEnumConst(wireName: '241')
  static const RoomSetAllAttendeesPermissionsPermissions $241 = _$roomSetAllAttendeesPermissionsPermissions$241;

  @BuiltValueEnumConst(wireName: '242')
  static const RoomSetAllAttendeesPermissionsPermissions $242 = _$roomSetAllAttendeesPermissionsPermissions$242;

  @BuiltValueEnumConst(wireName: '243')
  static const RoomSetAllAttendeesPermissionsPermissions $243 = _$roomSetAllAttendeesPermissionsPermissions$243;

  @BuiltValueEnumConst(wireName: '244')
  static const RoomSetAllAttendeesPermissionsPermissions $244 = _$roomSetAllAttendeesPermissionsPermissions$244;

  @BuiltValueEnumConst(wireName: '245')
  static const RoomSetAllAttendeesPermissionsPermissions $245 = _$roomSetAllAttendeesPermissionsPermissions$245;

  @BuiltValueEnumConst(wireName: '246')
  static const RoomSetAllAttendeesPermissionsPermissions $246 = _$roomSetAllAttendeesPermissionsPermissions$246;

  @BuiltValueEnumConst(wireName: '247')
  static const RoomSetAllAttendeesPermissionsPermissions $247 = _$roomSetAllAttendeesPermissionsPermissions$247;

  @BuiltValueEnumConst(wireName: '248')
  static const RoomSetAllAttendeesPermissionsPermissions $248 = _$roomSetAllAttendeesPermissionsPermissions$248;

  @BuiltValueEnumConst(wireName: '249')
  static const RoomSetAllAttendeesPermissionsPermissions $249 = _$roomSetAllAttendeesPermissionsPermissions$249;

  @BuiltValueEnumConst(wireName: '250')
  static const RoomSetAllAttendeesPermissionsPermissions $250 = _$roomSetAllAttendeesPermissionsPermissions$250;

  @BuiltValueEnumConst(wireName: '251')
  static const RoomSetAllAttendeesPermissionsPermissions $251 = _$roomSetAllAttendeesPermissionsPermissions$251;

  @BuiltValueEnumConst(wireName: '252')
  static const RoomSetAllAttendeesPermissionsPermissions $252 = _$roomSetAllAttendeesPermissionsPermissions$252;

  @BuiltValueEnumConst(wireName: '253')
  static const RoomSetAllAttendeesPermissionsPermissions $253 = _$roomSetAllAttendeesPermissionsPermissions$253;

  @BuiltValueEnumConst(wireName: '254')
  static const RoomSetAllAttendeesPermissionsPermissions $254 = _$roomSetAllAttendeesPermissionsPermissions$254;

  @BuiltValueEnumConst(wireName: '255')
  static const RoomSetAllAttendeesPermissionsPermissions $255 = _$roomSetAllAttendeesPermissionsPermissions$255;

  // coverage:ignore-start
  static BuiltSet<RoomSetAllAttendeesPermissionsPermissions> get values =>
      _$roomSetAllAttendeesPermissionsPermissionsValues;
  // coverage:ignore-end

  static RoomSetAllAttendeesPermissionsPermissions valueOf(String name) =>
      _$valueOfRoomSetAllAttendeesPermissionsPermissions(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAllAttendeesPermissionsPermissions> get serializer =>
      const _$RoomSetAllAttendeesPermissionsPermissionsSerializer();
}

class _$RoomSetAllAttendeesPermissionsPermissionsSerializer
    implements PrimitiveSerializer<RoomSetAllAttendeesPermissionsPermissions> {
  const _$RoomSetAllAttendeesPermissionsPermissionsSerializer();

  static const Map<RoomSetAllAttendeesPermissionsPermissions, Object> _toWire =
      <RoomSetAllAttendeesPermissionsPermissions, Object>{
    RoomSetAllAttendeesPermissionsPermissions.$0: 0,
    RoomSetAllAttendeesPermissionsPermissions.$1: 1,
    RoomSetAllAttendeesPermissionsPermissions.$2: 2,
    RoomSetAllAttendeesPermissionsPermissions.$3: 3,
    RoomSetAllAttendeesPermissionsPermissions.$4: 4,
    RoomSetAllAttendeesPermissionsPermissions.$5: 5,
    RoomSetAllAttendeesPermissionsPermissions.$6: 6,
    RoomSetAllAttendeesPermissionsPermissions.$7: 7,
    RoomSetAllAttendeesPermissionsPermissions.$8: 8,
    RoomSetAllAttendeesPermissionsPermissions.$9: 9,
    RoomSetAllAttendeesPermissionsPermissions.$10: 10,
    RoomSetAllAttendeesPermissionsPermissions.$11: 11,
    RoomSetAllAttendeesPermissionsPermissions.$12: 12,
    RoomSetAllAttendeesPermissionsPermissions.$13: 13,
    RoomSetAllAttendeesPermissionsPermissions.$14: 14,
    RoomSetAllAttendeesPermissionsPermissions.$15: 15,
    RoomSetAllAttendeesPermissionsPermissions.$16: 16,
    RoomSetAllAttendeesPermissionsPermissions.$17: 17,
    RoomSetAllAttendeesPermissionsPermissions.$18: 18,
    RoomSetAllAttendeesPermissionsPermissions.$19: 19,
    RoomSetAllAttendeesPermissionsPermissions.$20: 20,
    RoomSetAllAttendeesPermissionsPermissions.$21: 21,
    RoomSetAllAttendeesPermissionsPermissions.$22: 22,
    RoomSetAllAttendeesPermissionsPermissions.$23: 23,
    RoomSetAllAttendeesPermissionsPermissions.$24: 24,
    RoomSetAllAttendeesPermissionsPermissions.$25: 25,
    RoomSetAllAttendeesPermissionsPermissions.$26: 26,
    RoomSetAllAttendeesPermissionsPermissions.$27: 27,
    RoomSetAllAttendeesPermissionsPermissions.$28: 28,
    RoomSetAllAttendeesPermissionsPermissions.$29: 29,
    RoomSetAllAttendeesPermissionsPermissions.$30: 30,
    RoomSetAllAttendeesPermissionsPermissions.$31: 31,
    RoomSetAllAttendeesPermissionsPermissions.$32: 32,
    RoomSetAllAttendeesPermissionsPermissions.$33: 33,
    RoomSetAllAttendeesPermissionsPermissions.$34: 34,
    RoomSetAllAttendeesPermissionsPermissions.$35: 35,
    RoomSetAllAttendeesPermissionsPermissions.$36: 36,
    RoomSetAllAttendeesPermissionsPermissions.$37: 37,
    RoomSetAllAttendeesPermissionsPermissions.$38: 38,
    RoomSetAllAttendeesPermissionsPermissions.$39: 39,
    RoomSetAllAttendeesPermissionsPermissions.$40: 40,
    RoomSetAllAttendeesPermissionsPermissions.$41: 41,
    RoomSetAllAttendeesPermissionsPermissions.$42: 42,
    RoomSetAllAttendeesPermissionsPermissions.$43: 43,
    RoomSetAllAttendeesPermissionsPermissions.$44: 44,
    RoomSetAllAttendeesPermissionsPermissions.$45: 45,
    RoomSetAllAttendeesPermissionsPermissions.$46: 46,
    RoomSetAllAttendeesPermissionsPermissions.$47: 47,
    RoomSetAllAttendeesPermissionsPermissions.$48: 48,
    RoomSetAllAttendeesPermissionsPermissions.$49: 49,
    RoomSetAllAttendeesPermissionsPermissions.$50: 50,
    RoomSetAllAttendeesPermissionsPermissions.$51: 51,
    RoomSetAllAttendeesPermissionsPermissions.$52: 52,
    RoomSetAllAttendeesPermissionsPermissions.$53: 53,
    RoomSetAllAttendeesPermissionsPermissions.$54: 54,
    RoomSetAllAttendeesPermissionsPermissions.$55: 55,
    RoomSetAllAttendeesPermissionsPermissions.$56: 56,
    RoomSetAllAttendeesPermissionsPermissions.$57: 57,
    RoomSetAllAttendeesPermissionsPermissions.$58: 58,
    RoomSetAllAttendeesPermissionsPermissions.$59: 59,
    RoomSetAllAttendeesPermissionsPermissions.$60: 60,
    RoomSetAllAttendeesPermissionsPermissions.$61: 61,
    RoomSetAllAttendeesPermissionsPermissions.$62: 62,
    RoomSetAllAttendeesPermissionsPermissions.$63: 63,
    RoomSetAllAttendeesPermissionsPermissions.$64: 64,
    RoomSetAllAttendeesPermissionsPermissions.$65: 65,
    RoomSetAllAttendeesPermissionsPermissions.$66: 66,
    RoomSetAllAttendeesPermissionsPermissions.$67: 67,
    RoomSetAllAttendeesPermissionsPermissions.$68: 68,
    RoomSetAllAttendeesPermissionsPermissions.$69: 69,
    RoomSetAllAttendeesPermissionsPermissions.$70: 70,
    RoomSetAllAttendeesPermissionsPermissions.$71: 71,
    RoomSetAllAttendeesPermissionsPermissions.$72: 72,
    RoomSetAllAttendeesPermissionsPermissions.$73: 73,
    RoomSetAllAttendeesPermissionsPermissions.$74: 74,
    RoomSetAllAttendeesPermissionsPermissions.$75: 75,
    RoomSetAllAttendeesPermissionsPermissions.$76: 76,
    RoomSetAllAttendeesPermissionsPermissions.$77: 77,
    RoomSetAllAttendeesPermissionsPermissions.$78: 78,
    RoomSetAllAttendeesPermissionsPermissions.$79: 79,
    RoomSetAllAttendeesPermissionsPermissions.$80: 80,
    RoomSetAllAttendeesPermissionsPermissions.$81: 81,
    RoomSetAllAttendeesPermissionsPermissions.$82: 82,
    RoomSetAllAttendeesPermissionsPermissions.$83: 83,
    RoomSetAllAttendeesPermissionsPermissions.$84: 84,
    RoomSetAllAttendeesPermissionsPermissions.$85: 85,
    RoomSetAllAttendeesPermissionsPermissions.$86: 86,
    RoomSetAllAttendeesPermissionsPermissions.$87: 87,
    RoomSetAllAttendeesPermissionsPermissions.$88: 88,
    RoomSetAllAttendeesPermissionsPermissions.$89: 89,
    RoomSetAllAttendeesPermissionsPermissions.$90: 90,
    RoomSetAllAttendeesPermissionsPermissions.$91: 91,
    RoomSetAllAttendeesPermissionsPermissions.$92: 92,
    RoomSetAllAttendeesPermissionsPermissions.$93: 93,
    RoomSetAllAttendeesPermissionsPermissions.$94: 94,
    RoomSetAllAttendeesPermissionsPermissions.$95: 95,
    RoomSetAllAttendeesPermissionsPermissions.$96: 96,
    RoomSetAllAttendeesPermissionsPermissions.$97: 97,
    RoomSetAllAttendeesPermissionsPermissions.$98: 98,
    RoomSetAllAttendeesPermissionsPermissions.$99: 99,
    RoomSetAllAttendeesPermissionsPermissions.$100: 100,
    RoomSetAllAttendeesPermissionsPermissions.$101: 101,
    RoomSetAllAttendeesPermissionsPermissions.$102: 102,
    RoomSetAllAttendeesPermissionsPermissions.$103: 103,
    RoomSetAllAttendeesPermissionsPermissions.$104: 104,
    RoomSetAllAttendeesPermissionsPermissions.$105: 105,
    RoomSetAllAttendeesPermissionsPermissions.$106: 106,
    RoomSetAllAttendeesPermissionsPermissions.$107: 107,
    RoomSetAllAttendeesPermissionsPermissions.$108: 108,
    RoomSetAllAttendeesPermissionsPermissions.$109: 109,
    RoomSetAllAttendeesPermissionsPermissions.$110: 110,
    RoomSetAllAttendeesPermissionsPermissions.$111: 111,
    RoomSetAllAttendeesPermissionsPermissions.$112: 112,
    RoomSetAllAttendeesPermissionsPermissions.$113: 113,
    RoomSetAllAttendeesPermissionsPermissions.$114: 114,
    RoomSetAllAttendeesPermissionsPermissions.$115: 115,
    RoomSetAllAttendeesPermissionsPermissions.$116: 116,
    RoomSetAllAttendeesPermissionsPermissions.$117: 117,
    RoomSetAllAttendeesPermissionsPermissions.$118: 118,
    RoomSetAllAttendeesPermissionsPermissions.$119: 119,
    RoomSetAllAttendeesPermissionsPermissions.$120: 120,
    RoomSetAllAttendeesPermissionsPermissions.$121: 121,
    RoomSetAllAttendeesPermissionsPermissions.$122: 122,
    RoomSetAllAttendeesPermissionsPermissions.$123: 123,
    RoomSetAllAttendeesPermissionsPermissions.$124: 124,
    RoomSetAllAttendeesPermissionsPermissions.$125: 125,
    RoomSetAllAttendeesPermissionsPermissions.$126: 126,
    RoomSetAllAttendeesPermissionsPermissions.$127: 127,
    RoomSetAllAttendeesPermissionsPermissions.$128: 128,
    RoomSetAllAttendeesPermissionsPermissions.$129: 129,
    RoomSetAllAttendeesPermissionsPermissions.$130: 130,
    RoomSetAllAttendeesPermissionsPermissions.$131: 131,
    RoomSetAllAttendeesPermissionsPermissions.$132: 132,
    RoomSetAllAttendeesPermissionsPermissions.$133: 133,
    RoomSetAllAttendeesPermissionsPermissions.$134: 134,
    RoomSetAllAttendeesPermissionsPermissions.$135: 135,
    RoomSetAllAttendeesPermissionsPermissions.$136: 136,
    RoomSetAllAttendeesPermissionsPermissions.$137: 137,
    RoomSetAllAttendeesPermissionsPermissions.$138: 138,
    RoomSetAllAttendeesPermissionsPermissions.$139: 139,
    RoomSetAllAttendeesPermissionsPermissions.$140: 140,
    RoomSetAllAttendeesPermissionsPermissions.$141: 141,
    RoomSetAllAttendeesPermissionsPermissions.$142: 142,
    RoomSetAllAttendeesPermissionsPermissions.$143: 143,
    RoomSetAllAttendeesPermissionsPermissions.$144: 144,
    RoomSetAllAttendeesPermissionsPermissions.$145: 145,
    RoomSetAllAttendeesPermissionsPermissions.$146: 146,
    RoomSetAllAttendeesPermissionsPermissions.$147: 147,
    RoomSetAllAttendeesPermissionsPermissions.$148: 148,
    RoomSetAllAttendeesPermissionsPermissions.$149: 149,
    RoomSetAllAttendeesPermissionsPermissions.$150: 150,
    RoomSetAllAttendeesPermissionsPermissions.$151: 151,
    RoomSetAllAttendeesPermissionsPermissions.$152: 152,
    RoomSetAllAttendeesPermissionsPermissions.$153: 153,
    RoomSetAllAttendeesPermissionsPermissions.$154: 154,
    RoomSetAllAttendeesPermissionsPermissions.$155: 155,
    RoomSetAllAttendeesPermissionsPermissions.$156: 156,
    RoomSetAllAttendeesPermissionsPermissions.$157: 157,
    RoomSetAllAttendeesPermissionsPermissions.$158: 158,
    RoomSetAllAttendeesPermissionsPermissions.$159: 159,
    RoomSetAllAttendeesPermissionsPermissions.$160: 160,
    RoomSetAllAttendeesPermissionsPermissions.$161: 161,
    RoomSetAllAttendeesPermissionsPermissions.$162: 162,
    RoomSetAllAttendeesPermissionsPermissions.$163: 163,
    RoomSetAllAttendeesPermissionsPermissions.$164: 164,
    RoomSetAllAttendeesPermissionsPermissions.$165: 165,
    RoomSetAllAttendeesPermissionsPermissions.$166: 166,
    RoomSetAllAttendeesPermissionsPermissions.$167: 167,
    RoomSetAllAttendeesPermissionsPermissions.$168: 168,
    RoomSetAllAttendeesPermissionsPermissions.$169: 169,
    RoomSetAllAttendeesPermissionsPermissions.$170: 170,
    RoomSetAllAttendeesPermissionsPermissions.$171: 171,
    RoomSetAllAttendeesPermissionsPermissions.$172: 172,
    RoomSetAllAttendeesPermissionsPermissions.$173: 173,
    RoomSetAllAttendeesPermissionsPermissions.$174: 174,
    RoomSetAllAttendeesPermissionsPermissions.$175: 175,
    RoomSetAllAttendeesPermissionsPermissions.$176: 176,
    RoomSetAllAttendeesPermissionsPermissions.$177: 177,
    RoomSetAllAttendeesPermissionsPermissions.$178: 178,
    RoomSetAllAttendeesPermissionsPermissions.$179: 179,
    RoomSetAllAttendeesPermissionsPermissions.$180: 180,
    RoomSetAllAttendeesPermissionsPermissions.$181: 181,
    RoomSetAllAttendeesPermissionsPermissions.$182: 182,
    RoomSetAllAttendeesPermissionsPermissions.$183: 183,
    RoomSetAllAttendeesPermissionsPermissions.$184: 184,
    RoomSetAllAttendeesPermissionsPermissions.$185: 185,
    RoomSetAllAttendeesPermissionsPermissions.$186: 186,
    RoomSetAllAttendeesPermissionsPermissions.$187: 187,
    RoomSetAllAttendeesPermissionsPermissions.$188: 188,
    RoomSetAllAttendeesPermissionsPermissions.$189: 189,
    RoomSetAllAttendeesPermissionsPermissions.$190: 190,
    RoomSetAllAttendeesPermissionsPermissions.$191: 191,
    RoomSetAllAttendeesPermissionsPermissions.$192: 192,
    RoomSetAllAttendeesPermissionsPermissions.$193: 193,
    RoomSetAllAttendeesPermissionsPermissions.$194: 194,
    RoomSetAllAttendeesPermissionsPermissions.$195: 195,
    RoomSetAllAttendeesPermissionsPermissions.$196: 196,
    RoomSetAllAttendeesPermissionsPermissions.$197: 197,
    RoomSetAllAttendeesPermissionsPermissions.$198: 198,
    RoomSetAllAttendeesPermissionsPermissions.$199: 199,
    RoomSetAllAttendeesPermissionsPermissions.$200: 200,
    RoomSetAllAttendeesPermissionsPermissions.$201: 201,
    RoomSetAllAttendeesPermissionsPermissions.$202: 202,
    RoomSetAllAttendeesPermissionsPermissions.$203: 203,
    RoomSetAllAttendeesPermissionsPermissions.$204: 204,
    RoomSetAllAttendeesPermissionsPermissions.$205: 205,
    RoomSetAllAttendeesPermissionsPermissions.$206: 206,
    RoomSetAllAttendeesPermissionsPermissions.$207: 207,
    RoomSetAllAttendeesPermissionsPermissions.$208: 208,
    RoomSetAllAttendeesPermissionsPermissions.$209: 209,
    RoomSetAllAttendeesPermissionsPermissions.$210: 210,
    RoomSetAllAttendeesPermissionsPermissions.$211: 211,
    RoomSetAllAttendeesPermissionsPermissions.$212: 212,
    RoomSetAllAttendeesPermissionsPermissions.$213: 213,
    RoomSetAllAttendeesPermissionsPermissions.$214: 214,
    RoomSetAllAttendeesPermissionsPermissions.$215: 215,
    RoomSetAllAttendeesPermissionsPermissions.$216: 216,
    RoomSetAllAttendeesPermissionsPermissions.$217: 217,
    RoomSetAllAttendeesPermissionsPermissions.$218: 218,
    RoomSetAllAttendeesPermissionsPermissions.$219: 219,
    RoomSetAllAttendeesPermissionsPermissions.$220: 220,
    RoomSetAllAttendeesPermissionsPermissions.$221: 221,
    RoomSetAllAttendeesPermissionsPermissions.$222: 222,
    RoomSetAllAttendeesPermissionsPermissions.$223: 223,
    RoomSetAllAttendeesPermissionsPermissions.$224: 224,
    RoomSetAllAttendeesPermissionsPermissions.$225: 225,
    RoomSetAllAttendeesPermissionsPermissions.$226: 226,
    RoomSetAllAttendeesPermissionsPermissions.$227: 227,
    RoomSetAllAttendeesPermissionsPermissions.$228: 228,
    RoomSetAllAttendeesPermissionsPermissions.$229: 229,
    RoomSetAllAttendeesPermissionsPermissions.$230: 230,
    RoomSetAllAttendeesPermissionsPermissions.$231: 231,
    RoomSetAllAttendeesPermissionsPermissions.$232: 232,
    RoomSetAllAttendeesPermissionsPermissions.$233: 233,
    RoomSetAllAttendeesPermissionsPermissions.$234: 234,
    RoomSetAllAttendeesPermissionsPermissions.$235: 235,
    RoomSetAllAttendeesPermissionsPermissions.$236: 236,
    RoomSetAllAttendeesPermissionsPermissions.$237: 237,
    RoomSetAllAttendeesPermissionsPermissions.$238: 238,
    RoomSetAllAttendeesPermissionsPermissions.$239: 239,
    RoomSetAllAttendeesPermissionsPermissions.$240: 240,
    RoomSetAllAttendeesPermissionsPermissions.$241: 241,
    RoomSetAllAttendeesPermissionsPermissions.$242: 242,
    RoomSetAllAttendeesPermissionsPermissions.$243: 243,
    RoomSetAllAttendeesPermissionsPermissions.$244: 244,
    RoomSetAllAttendeesPermissionsPermissions.$245: 245,
    RoomSetAllAttendeesPermissionsPermissions.$246: 246,
    RoomSetAllAttendeesPermissionsPermissions.$247: 247,
    RoomSetAllAttendeesPermissionsPermissions.$248: 248,
    RoomSetAllAttendeesPermissionsPermissions.$249: 249,
    RoomSetAllAttendeesPermissionsPermissions.$250: 250,
    RoomSetAllAttendeesPermissionsPermissions.$251: 251,
    RoomSetAllAttendeesPermissionsPermissions.$252: 252,
    RoomSetAllAttendeesPermissionsPermissions.$253: 253,
    RoomSetAllAttendeesPermissionsPermissions.$254: 254,
    RoomSetAllAttendeesPermissionsPermissions.$255: 255,
  };

  static const Map<Object, RoomSetAllAttendeesPermissionsPermissions> _fromWire =
      <Object, RoomSetAllAttendeesPermissionsPermissions>{
    0: RoomSetAllAttendeesPermissionsPermissions.$0,
    1: RoomSetAllAttendeesPermissionsPermissions.$1,
    2: RoomSetAllAttendeesPermissionsPermissions.$2,
    3: RoomSetAllAttendeesPermissionsPermissions.$3,
    4: RoomSetAllAttendeesPermissionsPermissions.$4,
    5: RoomSetAllAttendeesPermissionsPermissions.$5,
    6: RoomSetAllAttendeesPermissionsPermissions.$6,
    7: RoomSetAllAttendeesPermissionsPermissions.$7,
    8: RoomSetAllAttendeesPermissionsPermissions.$8,
    9: RoomSetAllAttendeesPermissionsPermissions.$9,
    10: RoomSetAllAttendeesPermissionsPermissions.$10,
    11: RoomSetAllAttendeesPermissionsPermissions.$11,
    12: RoomSetAllAttendeesPermissionsPermissions.$12,
    13: RoomSetAllAttendeesPermissionsPermissions.$13,
    14: RoomSetAllAttendeesPermissionsPermissions.$14,
    15: RoomSetAllAttendeesPermissionsPermissions.$15,
    16: RoomSetAllAttendeesPermissionsPermissions.$16,
    17: RoomSetAllAttendeesPermissionsPermissions.$17,
    18: RoomSetAllAttendeesPermissionsPermissions.$18,
    19: RoomSetAllAttendeesPermissionsPermissions.$19,
    20: RoomSetAllAttendeesPermissionsPermissions.$20,
    21: RoomSetAllAttendeesPermissionsPermissions.$21,
    22: RoomSetAllAttendeesPermissionsPermissions.$22,
    23: RoomSetAllAttendeesPermissionsPermissions.$23,
    24: RoomSetAllAttendeesPermissionsPermissions.$24,
    25: RoomSetAllAttendeesPermissionsPermissions.$25,
    26: RoomSetAllAttendeesPermissionsPermissions.$26,
    27: RoomSetAllAttendeesPermissionsPermissions.$27,
    28: RoomSetAllAttendeesPermissionsPermissions.$28,
    29: RoomSetAllAttendeesPermissionsPermissions.$29,
    30: RoomSetAllAttendeesPermissionsPermissions.$30,
    31: RoomSetAllAttendeesPermissionsPermissions.$31,
    32: RoomSetAllAttendeesPermissionsPermissions.$32,
    33: RoomSetAllAttendeesPermissionsPermissions.$33,
    34: RoomSetAllAttendeesPermissionsPermissions.$34,
    35: RoomSetAllAttendeesPermissionsPermissions.$35,
    36: RoomSetAllAttendeesPermissionsPermissions.$36,
    37: RoomSetAllAttendeesPermissionsPermissions.$37,
    38: RoomSetAllAttendeesPermissionsPermissions.$38,
    39: RoomSetAllAttendeesPermissionsPermissions.$39,
    40: RoomSetAllAttendeesPermissionsPermissions.$40,
    41: RoomSetAllAttendeesPermissionsPermissions.$41,
    42: RoomSetAllAttendeesPermissionsPermissions.$42,
    43: RoomSetAllAttendeesPermissionsPermissions.$43,
    44: RoomSetAllAttendeesPermissionsPermissions.$44,
    45: RoomSetAllAttendeesPermissionsPermissions.$45,
    46: RoomSetAllAttendeesPermissionsPermissions.$46,
    47: RoomSetAllAttendeesPermissionsPermissions.$47,
    48: RoomSetAllAttendeesPermissionsPermissions.$48,
    49: RoomSetAllAttendeesPermissionsPermissions.$49,
    50: RoomSetAllAttendeesPermissionsPermissions.$50,
    51: RoomSetAllAttendeesPermissionsPermissions.$51,
    52: RoomSetAllAttendeesPermissionsPermissions.$52,
    53: RoomSetAllAttendeesPermissionsPermissions.$53,
    54: RoomSetAllAttendeesPermissionsPermissions.$54,
    55: RoomSetAllAttendeesPermissionsPermissions.$55,
    56: RoomSetAllAttendeesPermissionsPermissions.$56,
    57: RoomSetAllAttendeesPermissionsPermissions.$57,
    58: RoomSetAllAttendeesPermissionsPermissions.$58,
    59: RoomSetAllAttendeesPermissionsPermissions.$59,
    60: RoomSetAllAttendeesPermissionsPermissions.$60,
    61: RoomSetAllAttendeesPermissionsPermissions.$61,
    62: RoomSetAllAttendeesPermissionsPermissions.$62,
    63: RoomSetAllAttendeesPermissionsPermissions.$63,
    64: RoomSetAllAttendeesPermissionsPermissions.$64,
    65: RoomSetAllAttendeesPermissionsPermissions.$65,
    66: RoomSetAllAttendeesPermissionsPermissions.$66,
    67: RoomSetAllAttendeesPermissionsPermissions.$67,
    68: RoomSetAllAttendeesPermissionsPermissions.$68,
    69: RoomSetAllAttendeesPermissionsPermissions.$69,
    70: RoomSetAllAttendeesPermissionsPermissions.$70,
    71: RoomSetAllAttendeesPermissionsPermissions.$71,
    72: RoomSetAllAttendeesPermissionsPermissions.$72,
    73: RoomSetAllAttendeesPermissionsPermissions.$73,
    74: RoomSetAllAttendeesPermissionsPermissions.$74,
    75: RoomSetAllAttendeesPermissionsPermissions.$75,
    76: RoomSetAllAttendeesPermissionsPermissions.$76,
    77: RoomSetAllAttendeesPermissionsPermissions.$77,
    78: RoomSetAllAttendeesPermissionsPermissions.$78,
    79: RoomSetAllAttendeesPermissionsPermissions.$79,
    80: RoomSetAllAttendeesPermissionsPermissions.$80,
    81: RoomSetAllAttendeesPermissionsPermissions.$81,
    82: RoomSetAllAttendeesPermissionsPermissions.$82,
    83: RoomSetAllAttendeesPermissionsPermissions.$83,
    84: RoomSetAllAttendeesPermissionsPermissions.$84,
    85: RoomSetAllAttendeesPermissionsPermissions.$85,
    86: RoomSetAllAttendeesPermissionsPermissions.$86,
    87: RoomSetAllAttendeesPermissionsPermissions.$87,
    88: RoomSetAllAttendeesPermissionsPermissions.$88,
    89: RoomSetAllAttendeesPermissionsPermissions.$89,
    90: RoomSetAllAttendeesPermissionsPermissions.$90,
    91: RoomSetAllAttendeesPermissionsPermissions.$91,
    92: RoomSetAllAttendeesPermissionsPermissions.$92,
    93: RoomSetAllAttendeesPermissionsPermissions.$93,
    94: RoomSetAllAttendeesPermissionsPermissions.$94,
    95: RoomSetAllAttendeesPermissionsPermissions.$95,
    96: RoomSetAllAttendeesPermissionsPermissions.$96,
    97: RoomSetAllAttendeesPermissionsPermissions.$97,
    98: RoomSetAllAttendeesPermissionsPermissions.$98,
    99: RoomSetAllAttendeesPermissionsPermissions.$99,
    100: RoomSetAllAttendeesPermissionsPermissions.$100,
    101: RoomSetAllAttendeesPermissionsPermissions.$101,
    102: RoomSetAllAttendeesPermissionsPermissions.$102,
    103: RoomSetAllAttendeesPermissionsPermissions.$103,
    104: RoomSetAllAttendeesPermissionsPermissions.$104,
    105: RoomSetAllAttendeesPermissionsPermissions.$105,
    106: RoomSetAllAttendeesPermissionsPermissions.$106,
    107: RoomSetAllAttendeesPermissionsPermissions.$107,
    108: RoomSetAllAttendeesPermissionsPermissions.$108,
    109: RoomSetAllAttendeesPermissionsPermissions.$109,
    110: RoomSetAllAttendeesPermissionsPermissions.$110,
    111: RoomSetAllAttendeesPermissionsPermissions.$111,
    112: RoomSetAllAttendeesPermissionsPermissions.$112,
    113: RoomSetAllAttendeesPermissionsPermissions.$113,
    114: RoomSetAllAttendeesPermissionsPermissions.$114,
    115: RoomSetAllAttendeesPermissionsPermissions.$115,
    116: RoomSetAllAttendeesPermissionsPermissions.$116,
    117: RoomSetAllAttendeesPermissionsPermissions.$117,
    118: RoomSetAllAttendeesPermissionsPermissions.$118,
    119: RoomSetAllAttendeesPermissionsPermissions.$119,
    120: RoomSetAllAttendeesPermissionsPermissions.$120,
    121: RoomSetAllAttendeesPermissionsPermissions.$121,
    122: RoomSetAllAttendeesPermissionsPermissions.$122,
    123: RoomSetAllAttendeesPermissionsPermissions.$123,
    124: RoomSetAllAttendeesPermissionsPermissions.$124,
    125: RoomSetAllAttendeesPermissionsPermissions.$125,
    126: RoomSetAllAttendeesPermissionsPermissions.$126,
    127: RoomSetAllAttendeesPermissionsPermissions.$127,
    128: RoomSetAllAttendeesPermissionsPermissions.$128,
    129: RoomSetAllAttendeesPermissionsPermissions.$129,
    130: RoomSetAllAttendeesPermissionsPermissions.$130,
    131: RoomSetAllAttendeesPermissionsPermissions.$131,
    132: RoomSetAllAttendeesPermissionsPermissions.$132,
    133: RoomSetAllAttendeesPermissionsPermissions.$133,
    134: RoomSetAllAttendeesPermissionsPermissions.$134,
    135: RoomSetAllAttendeesPermissionsPermissions.$135,
    136: RoomSetAllAttendeesPermissionsPermissions.$136,
    137: RoomSetAllAttendeesPermissionsPermissions.$137,
    138: RoomSetAllAttendeesPermissionsPermissions.$138,
    139: RoomSetAllAttendeesPermissionsPermissions.$139,
    140: RoomSetAllAttendeesPermissionsPermissions.$140,
    141: RoomSetAllAttendeesPermissionsPermissions.$141,
    142: RoomSetAllAttendeesPermissionsPermissions.$142,
    143: RoomSetAllAttendeesPermissionsPermissions.$143,
    144: RoomSetAllAttendeesPermissionsPermissions.$144,
    145: RoomSetAllAttendeesPermissionsPermissions.$145,
    146: RoomSetAllAttendeesPermissionsPermissions.$146,
    147: RoomSetAllAttendeesPermissionsPermissions.$147,
    148: RoomSetAllAttendeesPermissionsPermissions.$148,
    149: RoomSetAllAttendeesPermissionsPermissions.$149,
    150: RoomSetAllAttendeesPermissionsPermissions.$150,
    151: RoomSetAllAttendeesPermissionsPermissions.$151,
    152: RoomSetAllAttendeesPermissionsPermissions.$152,
    153: RoomSetAllAttendeesPermissionsPermissions.$153,
    154: RoomSetAllAttendeesPermissionsPermissions.$154,
    155: RoomSetAllAttendeesPermissionsPermissions.$155,
    156: RoomSetAllAttendeesPermissionsPermissions.$156,
    157: RoomSetAllAttendeesPermissionsPermissions.$157,
    158: RoomSetAllAttendeesPermissionsPermissions.$158,
    159: RoomSetAllAttendeesPermissionsPermissions.$159,
    160: RoomSetAllAttendeesPermissionsPermissions.$160,
    161: RoomSetAllAttendeesPermissionsPermissions.$161,
    162: RoomSetAllAttendeesPermissionsPermissions.$162,
    163: RoomSetAllAttendeesPermissionsPermissions.$163,
    164: RoomSetAllAttendeesPermissionsPermissions.$164,
    165: RoomSetAllAttendeesPermissionsPermissions.$165,
    166: RoomSetAllAttendeesPermissionsPermissions.$166,
    167: RoomSetAllAttendeesPermissionsPermissions.$167,
    168: RoomSetAllAttendeesPermissionsPermissions.$168,
    169: RoomSetAllAttendeesPermissionsPermissions.$169,
    170: RoomSetAllAttendeesPermissionsPermissions.$170,
    171: RoomSetAllAttendeesPermissionsPermissions.$171,
    172: RoomSetAllAttendeesPermissionsPermissions.$172,
    173: RoomSetAllAttendeesPermissionsPermissions.$173,
    174: RoomSetAllAttendeesPermissionsPermissions.$174,
    175: RoomSetAllAttendeesPermissionsPermissions.$175,
    176: RoomSetAllAttendeesPermissionsPermissions.$176,
    177: RoomSetAllAttendeesPermissionsPermissions.$177,
    178: RoomSetAllAttendeesPermissionsPermissions.$178,
    179: RoomSetAllAttendeesPermissionsPermissions.$179,
    180: RoomSetAllAttendeesPermissionsPermissions.$180,
    181: RoomSetAllAttendeesPermissionsPermissions.$181,
    182: RoomSetAllAttendeesPermissionsPermissions.$182,
    183: RoomSetAllAttendeesPermissionsPermissions.$183,
    184: RoomSetAllAttendeesPermissionsPermissions.$184,
    185: RoomSetAllAttendeesPermissionsPermissions.$185,
    186: RoomSetAllAttendeesPermissionsPermissions.$186,
    187: RoomSetAllAttendeesPermissionsPermissions.$187,
    188: RoomSetAllAttendeesPermissionsPermissions.$188,
    189: RoomSetAllAttendeesPermissionsPermissions.$189,
    190: RoomSetAllAttendeesPermissionsPermissions.$190,
    191: RoomSetAllAttendeesPermissionsPermissions.$191,
    192: RoomSetAllAttendeesPermissionsPermissions.$192,
    193: RoomSetAllAttendeesPermissionsPermissions.$193,
    194: RoomSetAllAttendeesPermissionsPermissions.$194,
    195: RoomSetAllAttendeesPermissionsPermissions.$195,
    196: RoomSetAllAttendeesPermissionsPermissions.$196,
    197: RoomSetAllAttendeesPermissionsPermissions.$197,
    198: RoomSetAllAttendeesPermissionsPermissions.$198,
    199: RoomSetAllAttendeesPermissionsPermissions.$199,
    200: RoomSetAllAttendeesPermissionsPermissions.$200,
    201: RoomSetAllAttendeesPermissionsPermissions.$201,
    202: RoomSetAllAttendeesPermissionsPermissions.$202,
    203: RoomSetAllAttendeesPermissionsPermissions.$203,
    204: RoomSetAllAttendeesPermissionsPermissions.$204,
    205: RoomSetAllAttendeesPermissionsPermissions.$205,
    206: RoomSetAllAttendeesPermissionsPermissions.$206,
    207: RoomSetAllAttendeesPermissionsPermissions.$207,
    208: RoomSetAllAttendeesPermissionsPermissions.$208,
    209: RoomSetAllAttendeesPermissionsPermissions.$209,
    210: RoomSetAllAttendeesPermissionsPermissions.$210,
    211: RoomSetAllAttendeesPermissionsPermissions.$211,
    212: RoomSetAllAttendeesPermissionsPermissions.$212,
    213: RoomSetAllAttendeesPermissionsPermissions.$213,
    214: RoomSetAllAttendeesPermissionsPermissions.$214,
    215: RoomSetAllAttendeesPermissionsPermissions.$215,
    216: RoomSetAllAttendeesPermissionsPermissions.$216,
    217: RoomSetAllAttendeesPermissionsPermissions.$217,
    218: RoomSetAllAttendeesPermissionsPermissions.$218,
    219: RoomSetAllAttendeesPermissionsPermissions.$219,
    220: RoomSetAllAttendeesPermissionsPermissions.$220,
    221: RoomSetAllAttendeesPermissionsPermissions.$221,
    222: RoomSetAllAttendeesPermissionsPermissions.$222,
    223: RoomSetAllAttendeesPermissionsPermissions.$223,
    224: RoomSetAllAttendeesPermissionsPermissions.$224,
    225: RoomSetAllAttendeesPermissionsPermissions.$225,
    226: RoomSetAllAttendeesPermissionsPermissions.$226,
    227: RoomSetAllAttendeesPermissionsPermissions.$227,
    228: RoomSetAllAttendeesPermissionsPermissions.$228,
    229: RoomSetAllAttendeesPermissionsPermissions.$229,
    230: RoomSetAllAttendeesPermissionsPermissions.$230,
    231: RoomSetAllAttendeesPermissionsPermissions.$231,
    232: RoomSetAllAttendeesPermissionsPermissions.$232,
    233: RoomSetAllAttendeesPermissionsPermissions.$233,
    234: RoomSetAllAttendeesPermissionsPermissions.$234,
    235: RoomSetAllAttendeesPermissionsPermissions.$235,
    236: RoomSetAllAttendeesPermissionsPermissions.$236,
    237: RoomSetAllAttendeesPermissionsPermissions.$237,
    238: RoomSetAllAttendeesPermissionsPermissions.$238,
    239: RoomSetAllAttendeesPermissionsPermissions.$239,
    240: RoomSetAllAttendeesPermissionsPermissions.$240,
    241: RoomSetAllAttendeesPermissionsPermissions.$241,
    242: RoomSetAllAttendeesPermissionsPermissions.$242,
    243: RoomSetAllAttendeesPermissionsPermissions.$243,
    244: RoomSetAllAttendeesPermissionsPermissions.$244,
    245: RoomSetAllAttendeesPermissionsPermissions.$245,
    246: RoomSetAllAttendeesPermissionsPermissions.$246,
    247: RoomSetAllAttendeesPermissionsPermissions.$247,
    248: RoomSetAllAttendeesPermissionsPermissions.$248,
    249: RoomSetAllAttendeesPermissionsPermissions.$249,
    250: RoomSetAllAttendeesPermissionsPermissions.$250,
    251: RoomSetAllAttendeesPermissionsPermissions.$251,
    252: RoomSetAllAttendeesPermissionsPermissions.$252,
    253: RoomSetAllAttendeesPermissionsPermissions.$253,
    254: RoomSetAllAttendeesPermissionsPermissions.$254,
    255: RoomSetAllAttendeesPermissionsPermissions.$255,
  };

  @override
  Iterable<Type> get types => const [RoomSetAllAttendeesPermissionsPermissions];

  @override
  String get wireName => 'RoomSetAllAttendeesPermissionsPermissions';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAllAttendeesPermissionsPermissions object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAllAttendeesPermissionsPermissions deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetAllAttendeesPermissionsApiVersion extends EnumClass {
  const RoomSetAllAttendeesPermissionsApiVersion._(super.name);

  static const RoomSetAllAttendeesPermissionsApiVersion v4 = _$roomSetAllAttendeesPermissionsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetAllAttendeesPermissionsApiVersion> get values =>
      _$roomSetAllAttendeesPermissionsApiVersionValues;
  // coverage:ignore-end

  static RoomSetAllAttendeesPermissionsApiVersion valueOf(String name) =>
      _$valueOfRoomSetAllAttendeesPermissionsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetAllAttendeesPermissionsApiVersion> get serializer =>
      const _$RoomSetAllAttendeesPermissionsApiVersionSerializer();
}

class _$RoomSetAllAttendeesPermissionsApiVersionSerializer
    implements PrimitiveSerializer<RoomSetAllAttendeesPermissionsApiVersion> {
  const _$RoomSetAllAttendeesPermissionsApiVersionSerializer();

  static const Map<RoomSetAllAttendeesPermissionsApiVersion, Object> _toWire =
      <RoomSetAllAttendeesPermissionsApiVersion, Object>{
    RoomSetAllAttendeesPermissionsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetAllAttendeesPermissionsApiVersion> _fromWire =
      <Object, RoomSetAllAttendeesPermissionsApiVersion>{
    'v4': RoomSetAllAttendeesPermissionsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetAllAttendeesPermissionsApiVersion];

  @override
  String get wireName => 'RoomSetAllAttendeesPermissionsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetAllAttendeesPermissionsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetAllAttendeesPermissionsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs
    implements
        $RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsInterface,
        Built<RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs,
            RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder> {
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs([
    void Function(RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetAllAttendeesPermissionsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetAllAttendeesPermissionsResponseApplicationJsonInterface {
  RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetAllAttendeesPermissionsResponseApplicationJson
    implements
        $RoomSetAllAttendeesPermissionsResponseApplicationJsonInterface,
        Built<RoomSetAllAttendeesPermissionsResponseApplicationJson,
            RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder> {
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson([
    void Function(RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetAllAttendeesPermissionsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetAllAttendeesPermissionsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetAllAttendeesPermissionsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetAllAttendeesPermissionsResponseApplicationJson> get serializer =>
      _$roomSetAllAttendeesPermissionsResponseApplicationJsonSerializer;
}

class RoomJoinRoomApiVersion extends EnumClass {
  const RoomJoinRoomApiVersion._(super.name);

  static const RoomJoinRoomApiVersion v4 = _$roomJoinRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomJoinRoomApiVersion> get values => _$roomJoinRoomApiVersionValues;
  // coverage:ignore-end

  static RoomJoinRoomApiVersion valueOf(String name) => _$valueOfRoomJoinRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomJoinRoomApiVersion> get serializer => const _$RoomJoinRoomApiVersionSerializer();
}

class _$RoomJoinRoomApiVersionSerializer implements PrimitiveSerializer<RoomJoinRoomApiVersion> {
  const _$RoomJoinRoomApiVersionSerializer();

  static const Map<RoomJoinRoomApiVersion, Object> _toWire = <RoomJoinRoomApiVersion, Object>{
    RoomJoinRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomJoinRoomApiVersion> _fromWire = <Object, RoomJoinRoomApiVersion>{
    'v4': RoomJoinRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomJoinRoomApiVersion];

  @override
  String get wireName => 'RoomJoinRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomJoinRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomJoinRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomJoinRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomJoinRoomResponseApplicationJson_Ocs
    implements
        $RoomJoinRoomResponseApplicationJson_OcsInterface,
        Built<RoomJoinRoomResponseApplicationJson_Ocs, RoomJoinRoomResponseApplicationJson_OcsBuilder> {
  factory RoomJoinRoomResponseApplicationJson_Ocs([void Function(RoomJoinRoomResponseApplicationJson_OcsBuilder)? b]) =
      _$RoomJoinRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomJoinRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomJoinRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomJoinRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomJoinRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomJoinRoomResponseApplicationJsonInterface {
  RoomJoinRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomJoinRoomResponseApplicationJson
    implements
        $RoomJoinRoomResponseApplicationJsonInterface,
        Built<RoomJoinRoomResponseApplicationJson, RoomJoinRoomResponseApplicationJsonBuilder> {
  factory RoomJoinRoomResponseApplicationJson([void Function(RoomJoinRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomJoinRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomJoinRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomJoinRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomJoinRoomResponseApplicationJson> get serializer =>
      _$roomJoinRoomResponseApplicationJsonSerializer;
}

class RoomLeaveRoomApiVersion extends EnumClass {
  const RoomLeaveRoomApiVersion._(super.name);

  static const RoomLeaveRoomApiVersion v4 = _$roomLeaveRoomApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomLeaveRoomApiVersion> get values => _$roomLeaveRoomApiVersionValues;
  // coverage:ignore-end

  static RoomLeaveRoomApiVersion valueOf(String name) => _$valueOfRoomLeaveRoomApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomLeaveRoomApiVersion> get serializer => const _$RoomLeaveRoomApiVersionSerializer();
}

class _$RoomLeaveRoomApiVersionSerializer implements PrimitiveSerializer<RoomLeaveRoomApiVersion> {
  const _$RoomLeaveRoomApiVersionSerializer();

  static const Map<RoomLeaveRoomApiVersion, Object> _toWire = <RoomLeaveRoomApiVersion, Object>{
    RoomLeaveRoomApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomLeaveRoomApiVersion> _fromWire = <Object, RoomLeaveRoomApiVersion>{
    'v4': RoomLeaveRoomApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomLeaveRoomApiVersion];

  @override
  String get wireName => 'RoomLeaveRoomApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomLeaveRoomApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomLeaveRoomApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomLeaveRoomResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomLeaveRoomResponseApplicationJson_Ocs
    implements
        $RoomLeaveRoomResponseApplicationJson_OcsInterface,
        Built<RoomLeaveRoomResponseApplicationJson_Ocs, RoomLeaveRoomResponseApplicationJson_OcsBuilder> {
  factory RoomLeaveRoomResponseApplicationJson_Ocs([
    void Function(RoomLeaveRoomResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomLeaveRoomResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomLeaveRoomResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomLeaveRoomResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomLeaveRoomResponseApplicationJson_Ocs> get serializer =>
      _$roomLeaveRoomResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomLeaveRoomResponseApplicationJsonInterface {
  RoomLeaveRoomResponseApplicationJson_Ocs get ocs;
}

abstract class RoomLeaveRoomResponseApplicationJson
    implements
        $RoomLeaveRoomResponseApplicationJsonInterface,
        Built<RoomLeaveRoomResponseApplicationJson, RoomLeaveRoomResponseApplicationJsonBuilder> {
  factory RoomLeaveRoomResponseApplicationJson([void Function(RoomLeaveRoomResponseApplicationJsonBuilder)? b]) =
      _$RoomLeaveRoomResponseApplicationJson;

  // coverage:ignore-start
  const RoomLeaveRoomResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomLeaveRoomResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomLeaveRoomResponseApplicationJson> get serializer =>
      _$roomLeaveRoomResponseApplicationJsonSerializer;
}

class RoomResendInvitationsApiVersion extends EnumClass {
  const RoomResendInvitationsApiVersion._(super.name);

  static const RoomResendInvitationsApiVersion v4 = _$roomResendInvitationsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomResendInvitationsApiVersion> get values => _$roomResendInvitationsApiVersionValues;
  // coverage:ignore-end

  static RoomResendInvitationsApiVersion valueOf(String name) => _$valueOfRoomResendInvitationsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomResendInvitationsApiVersion> get serializer =>
      const _$RoomResendInvitationsApiVersionSerializer();
}

class _$RoomResendInvitationsApiVersionSerializer implements PrimitiveSerializer<RoomResendInvitationsApiVersion> {
  const _$RoomResendInvitationsApiVersionSerializer();

  static const Map<RoomResendInvitationsApiVersion, Object> _toWire = <RoomResendInvitationsApiVersion, Object>{
    RoomResendInvitationsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomResendInvitationsApiVersion> _fromWire = <Object, RoomResendInvitationsApiVersion>{
    'v4': RoomResendInvitationsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomResendInvitationsApiVersion];

  @override
  String get wireName => 'RoomResendInvitationsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomResendInvitationsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomResendInvitationsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomResendInvitationsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomResendInvitationsResponseApplicationJson_Ocs
    implements
        $RoomResendInvitationsResponseApplicationJson_OcsInterface,
        Built<RoomResendInvitationsResponseApplicationJson_Ocs,
            RoomResendInvitationsResponseApplicationJson_OcsBuilder> {
  factory RoomResendInvitationsResponseApplicationJson_Ocs([
    void Function(RoomResendInvitationsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomResendInvitationsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomResendInvitationsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomResendInvitationsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomResendInvitationsResponseApplicationJson_Ocs> get serializer =>
      _$roomResendInvitationsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomResendInvitationsResponseApplicationJsonInterface {
  RoomResendInvitationsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomResendInvitationsResponseApplicationJson
    implements
        $RoomResendInvitationsResponseApplicationJsonInterface,
        Built<RoomResendInvitationsResponseApplicationJson, RoomResendInvitationsResponseApplicationJsonBuilder> {
  factory RoomResendInvitationsResponseApplicationJson([
    void Function(RoomResendInvitationsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomResendInvitationsResponseApplicationJson;

  // coverage:ignore-start
  const RoomResendInvitationsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomResendInvitationsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomResendInvitationsResponseApplicationJson> get serializer =>
      _$roomResendInvitationsResponseApplicationJsonSerializer;
}

class RoomSetSessionStateState extends EnumClass {
  const RoomSetSessionStateState._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetSessionStateState $0 = _$roomSetSessionStateState$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetSessionStateState $1 = _$roomSetSessionStateState$1;

  // coverage:ignore-start
  static BuiltSet<RoomSetSessionStateState> get values => _$roomSetSessionStateStateValues;
  // coverage:ignore-end

  static RoomSetSessionStateState valueOf(String name) => _$valueOfRoomSetSessionStateState(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetSessionStateState> get serializer => const _$RoomSetSessionStateStateSerializer();
}

class _$RoomSetSessionStateStateSerializer implements PrimitiveSerializer<RoomSetSessionStateState> {
  const _$RoomSetSessionStateStateSerializer();

  static const Map<RoomSetSessionStateState, Object> _toWire = <RoomSetSessionStateState, Object>{
    RoomSetSessionStateState.$0: 0,
    RoomSetSessionStateState.$1: 1,
  };

  static const Map<Object, RoomSetSessionStateState> _fromWire = <Object, RoomSetSessionStateState>{
    0: RoomSetSessionStateState.$0,
    1: RoomSetSessionStateState.$1,
  };

  @override
  Iterable<Type> get types => const [RoomSetSessionStateState];

  @override
  String get wireName => 'RoomSetSessionStateState';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetSessionStateState object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetSessionStateState deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetSessionStateApiVersion extends EnumClass {
  const RoomSetSessionStateApiVersion._(super.name);

  static const RoomSetSessionStateApiVersion v4 = _$roomSetSessionStateApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetSessionStateApiVersion> get values => _$roomSetSessionStateApiVersionValues;
  // coverage:ignore-end

  static RoomSetSessionStateApiVersion valueOf(String name) => _$valueOfRoomSetSessionStateApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetSessionStateApiVersion> get serializer => const _$RoomSetSessionStateApiVersionSerializer();
}

class _$RoomSetSessionStateApiVersionSerializer implements PrimitiveSerializer<RoomSetSessionStateApiVersion> {
  const _$RoomSetSessionStateApiVersionSerializer();

  static const Map<RoomSetSessionStateApiVersion, Object> _toWire = <RoomSetSessionStateApiVersion, Object>{
    RoomSetSessionStateApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetSessionStateApiVersion> _fromWire = <Object, RoomSetSessionStateApiVersion>{
    'v4': RoomSetSessionStateApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetSessionStateApiVersion];

  @override
  String get wireName => 'RoomSetSessionStateApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetSessionStateApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetSessionStateApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetSessionStateResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomSetSessionStateResponseApplicationJson_Ocs
    implements
        $RoomSetSessionStateResponseApplicationJson_OcsInterface,
        Built<RoomSetSessionStateResponseApplicationJson_Ocs, RoomSetSessionStateResponseApplicationJson_OcsBuilder> {
  factory RoomSetSessionStateResponseApplicationJson_Ocs([
    void Function(RoomSetSessionStateResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetSessionStateResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetSessionStateResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetSessionStateResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetSessionStateResponseApplicationJson_Ocs> get serializer =>
      _$roomSetSessionStateResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetSessionStateResponseApplicationJsonInterface {
  RoomSetSessionStateResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetSessionStateResponseApplicationJson
    implements
        $RoomSetSessionStateResponseApplicationJsonInterface,
        Built<RoomSetSessionStateResponseApplicationJson, RoomSetSessionStateResponseApplicationJsonBuilder> {
  factory RoomSetSessionStateResponseApplicationJson([
    void Function(RoomSetSessionStateResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetSessionStateResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetSessionStateResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetSessionStateResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetSessionStateResponseApplicationJson> get serializer =>
      _$roomSetSessionStateResponseApplicationJsonSerializer;
}

class RoomPromoteModeratorApiVersion extends EnumClass {
  const RoomPromoteModeratorApiVersion._(super.name);

  static const RoomPromoteModeratorApiVersion v4 = _$roomPromoteModeratorApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomPromoteModeratorApiVersion> get values => _$roomPromoteModeratorApiVersionValues;
  // coverage:ignore-end

  static RoomPromoteModeratorApiVersion valueOf(String name) => _$valueOfRoomPromoteModeratorApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomPromoteModeratorApiVersion> get serializer =>
      const _$RoomPromoteModeratorApiVersionSerializer();
}

class _$RoomPromoteModeratorApiVersionSerializer implements PrimitiveSerializer<RoomPromoteModeratorApiVersion> {
  const _$RoomPromoteModeratorApiVersionSerializer();

  static const Map<RoomPromoteModeratorApiVersion, Object> _toWire = <RoomPromoteModeratorApiVersion, Object>{
    RoomPromoteModeratorApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomPromoteModeratorApiVersion> _fromWire = <Object, RoomPromoteModeratorApiVersion>{
    'v4': RoomPromoteModeratorApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomPromoteModeratorApiVersion];

  @override
  String get wireName => 'RoomPromoteModeratorApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomPromoteModeratorApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomPromoteModeratorApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomPromoteModeratorResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomPromoteModeratorResponseApplicationJson_Ocs
    implements
        $RoomPromoteModeratorResponseApplicationJson_OcsInterface,
        Built<RoomPromoteModeratorResponseApplicationJson_Ocs, RoomPromoteModeratorResponseApplicationJson_OcsBuilder> {
  factory RoomPromoteModeratorResponseApplicationJson_Ocs([
    void Function(RoomPromoteModeratorResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomPromoteModeratorResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomPromoteModeratorResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomPromoteModeratorResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomPromoteModeratorResponseApplicationJson_Ocs> get serializer =>
      _$roomPromoteModeratorResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomPromoteModeratorResponseApplicationJsonInterface {
  RoomPromoteModeratorResponseApplicationJson_Ocs get ocs;
}

abstract class RoomPromoteModeratorResponseApplicationJson
    implements
        $RoomPromoteModeratorResponseApplicationJsonInterface,
        Built<RoomPromoteModeratorResponseApplicationJson, RoomPromoteModeratorResponseApplicationJsonBuilder> {
  factory RoomPromoteModeratorResponseApplicationJson([
    void Function(RoomPromoteModeratorResponseApplicationJsonBuilder)? b,
  ]) = _$RoomPromoteModeratorResponseApplicationJson;

  // coverage:ignore-start
  const RoomPromoteModeratorResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomPromoteModeratorResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomPromoteModeratorResponseApplicationJson> get serializer =>
      _$roomPromoteModeratorResponseApplicationJsonSerializer;
}

class RoomDemoteModeratorApiVersion extends EnumClass {
  const RoomDemoteModeratorApiVersion._(super.name);

  static const RoomDemoteModeratorApiVersion v4 = _$roomDemoteModeratorApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomDemoteModeratorApiVersion> get values => _$roomDemoteModeratorApiVersionValues;
  // coverage:ignore-end

  static RoomDemoteModeratorApiVersion valueOf(String name) => _$valueOfRoomDemoteModeratorApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomDemoteModeratorApiVersion> get serializer => const _$RoomDemoteModeratorApiVersionSerializer();
}

class _$RoomDemoteModeratorApiVersionSerializer implements PrimitiveSerializer<RoomDemoteModeratorApiVersion> {
  const _$RoomDemoteModeratorApiVersionSerializer();

  static const Map<RoomDemoteModeratorApiVersion, Object> _toWire = <RoomDemoteModeratorApiVersion, Object>{
    RoomDemoteModeratorApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomDemoteModeratorApiVersion> _fromWire = <Object, RoomDemoteModeratorApiVersion>{
    'v4': RoomDemoteModeratorApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomDemoteModeratorApiVersion];

  @override
  String get wireName => 'RoomDemoteModeratorApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomDemoteModeratorApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomDemoteModeratorApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomDemoteModeratorResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomDemoteModeratorResponseApplicationJson_Ocs
    implements
        $RoomDemoteModeratorResponseApplicationJson_OcsInterface,
        Built<RoomDemoteModeratorResponseApplicationJson_Ocs, RoomDemoteModeratorResponseApplicationJson_OcsBuilder> {
  factory RoomDemoteModeratorResponseApplicationJson_Ocs([
    void Function(RoomDemoteModeratorResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomDemoteModeratorResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomDemoteModeratorResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomDemoteModeratorResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomDemoteModeratorResponseApplicationJson_Ocs> get serializer =>
      _$roomDemoteModeratorResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomDemoteModeratorResponseApplicationJsonInterface {
  RoomDemoteModeratorResponseApplicationJson_Ocs get ocs;
}

abstract class RoomDemoteModeratorResponseApplicationJson
    implements
        $RoomDemoteModeratorResponseApplicationJsonInterface,
        Built<RoomDemoteModeratorResponseApplicationJson, RoomDemoteModeratorResponseApplicationJsonBuilder> {
  factory RoomDemoteModeratorResponseApplicationJson([
    void Function(RoomDemoteModeratorResponseApplicationJsonBuilder)? b,
  ]) = _$RoomDemoteModeratorResponseApplicationJson;

  // coverage:ignore-start
  const RoomDemoteModeratorResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomDemoteModeratorResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomDemoteModeratorResponseApplicationJson> get serializer =>
      _$roomDemoteModeratorResponseApplicationJsonSerializer;
}

class RoomAddToFavoritesApiVersion extends EnumClass {
  const RoomAddToFavoritesApiVersion._(super.name);

  static const RoomAddToFavoritesApiVersion v4 = _$roomAddToFavoritesApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomAddToFavoritesApiVersion> get values => _$roomAddToFavoritesApiVersionValues;
  // coverage:ignore-end

  static RoomAddToFavoritesApiVersion valueOf(String name) => _$valueOfRoomAddToFavoritesApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomAddToFavoritesApiVersion> get serializer => const _$RoomAddToFavoritesApiVersionSerializer();
}

class _$RoomAddToFavoritesApiVersionSerializer implements PrimitiveSerializer<RoomAddToFavoritesApiVersion> {
  const _$RoomAddToFavoritesApiVersionSerializer();

  static const Map<RoomAddToFavoritesApiVersion, Object> _toWire = <RoomAddToFavoritesApiVersion, Object>{
    RoomAddToFavoritesApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomAddToFavoritesApiVersion> _fromWire = <Object, RoomAddToFavoritesApiVersion>{
    'v4': RoomAddToFavoritesApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomAddToFavoritesApiVersion];

  @override
  String get wireName => 'RoomAddToFavoritesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomAddToFavoritesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomAddToFavoritesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddToFavoritesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomAddToFavoritesResponseApplicationJson_Ocs
    implements
        $RoomAddToFavoritesResponseApplicationJson_OcsInterface,
        Built<RoomAddToFavoritesResponseApplicationJson_Ocs, RoomAddToFavoritesResponseApplicationJson_OcsBuilder> {
  factory RoomAddToFavoritesResponseApplicationJson_Ocs([
    void Function(RoomAddToFavoritesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomAddToFavoritesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomAddToFavoritesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomAddToFavoritesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomAddToFavoritesResponseApplicationJson_Ocs> get serializer =>
      _$roomAddToFavoritesResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomAddToFavoritesResponseApplicationJsonInterface {
  RoomAddToFavoritesResponseApplicationJson_Ocs get ocs;
}

abstract class RoomAddToFavoritesResponseApplicationJson
    implements
        $RoomAddToFavoritesResponseApplicationJsonInterface,
        Built<RoomAddToFavoritesResponseApplicationJson, RoomAddToFavoritesResponseApplicationJsonBuilder> {
  factory RoomAddToFavoritesResponseApplicationJson([
    void Function(RoomAddToFavoritesResponseApplicationJsonBuilder)? b,
  ]) = _$RoomAddToFavoritesResponseApplicationJson;

  // coverage:ignore-start
  const RoomAddToFavoritesResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomAddToFavoritesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomAddToFavoritesResponseApplicationJson> get serializer =>
      _$roomAddToFavoritesResponseApplicationJsonSerializer;
}

class RoomRemoveFromFavoritesApiVersion extends EnumClass {
  const RoomRemoveFromFavoritesApiVersion._(super.name);

  static const RoomRemoveFromFavoritesApiVersion v4 = _$roomRemoveFromFavoritesApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomRemoveFromFavoritesApiVersion> get values => _$roomRemoveFromFavoritesApiVersionValues;
  // coverage:ignore-end

  static RoomRemoveFromFavoritesApiVersion valueOf(String name) => _$valueOfRoomRemoveFromFavoritesApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomRemoveFromFavoritesApiVersion> get serializer =>
      const _$RoomRemoveFromFavoritesApiVersionSerializer();
}

class _$RoomRemoveFromFavoritesApiVersionSerializer implements PrimitiveSerializer<RoomRemoveFromFavoritesApiVersion> {
  const _$RoomRemoveFromFavoritesApiVersionSerializer();

  static const Map<RoomRemoveFromFavoritesApiVersion, Object> _toWire = <RoomRemoveFromFavoritesApiVersion, Object>{
    RoomRemoveFromFavoritesApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomRemoveFromFavoritesApiVersion> _fromWire = <Object, RoomRemoveFromFavoritesApiVersion>{
    'v4': RoomRemoveFromFavoritesApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomRemoveFromFavoritesApiVersion];

  @override
  String get wireName => 'RoomRemoveFromFavoritesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomRemoveFromFavoritesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomRemoveFromFavoritesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveFromFavoritesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomRemoveFromFavoritesResponseApplicationJson_Ocs
    implements
        $RoomRemoveFromFavoritesResponseApplicationJson_OcsInterface,
        Built<RoomRemoveFromFavoritesResponseApplicationJson_Ocs,
            RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder> {
  factory RoomRemoveFromFavoritesResponseApplicationJson_Ocs([
    void Function(RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomRemoveFromFavoritesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomRemoveFromFavoritesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRemoveFromFavoritesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRemoveFromFavoritesResponseApplicationJson_Ocs> get serializer =>
      _$roomRemoveFromFavoritesResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomRemoveFromFavoritesResponseApplicationJsonInterface {
  RoomRemoveFromFavoritesResponseApplicationJson_Ocs get ocs;
}

abstract class RoomRemoveFromFavoritesResponseApplicationJson
    implements
        $RoomRemoveFromFavoritesResponseApplicationJsonInterface,
        Built<RoomRemoveFromFavoritesResponseApplicationJson, RoomRemoveFromFavoritesResponseApplicationJsonBuilder> {
  factory RoomRemoveFromFavoritesResponseApplicationJson([
    void Function(RoomRemoveFromFavoritesResponseApplicationJsonBuilder)? b,
  ]) = _$RoomRemoveFromFavoritesResponseApplicationJson;

  // coverage:ignore-start
  const RoomRemoveFromFavoritesResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomRemoveFromFavoritesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomRemoveFromFavoritesResponseApplicationJson> get serializer =>
      _$roomRemoveFromFavoritesResponseApplicationJsonSerializer;
}

class RoomSetNotificationLevelApiVersion extends EnumClass {
  const RoomSetNotificationLevelApiVersion._(super.name);

  static const RoomSetNotificationLevelApiVersion v4 = _$roomSetNotificationLevelApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetNotificationLevelApiVersion> get values => _$roomSetNotificationLevelApiVersionValues;
  // coverage:ignore-end

  static RoomSetNotificationLevelApiVersion valueOf(String name) => _$valueOfRoomSetNotificationLevelApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetNotificationLevelApiVersion> get serializer =>
      const _$RoomSetNotificationLevelApiVersionSerializer();
}

class _$RoomSetNotificationLevelApiVersionSerializer
    implements PrimitiveSerializer<RoomSetNotificationLevelApiVersion> {
  const _$RoomSetNotificationLevelApiVersionSerializer();

  static const Map<RoomSetNotificationLevelApiVersion, Object> _toWire = <RoomSetNotificationLevelApiVersion, Object>{
    RoomSetNotificationLevelApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetNotificationLevelApiVersion> _fromWire = <Object, RoomSetNotificationLevelApiVersion>{
    'v4': RoomSetNotificationLevelApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetNotificationLevelApiVersion];

  @override
  String get wireName => 'RoomSetNotificationLevelApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetNotificationLevelApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetNotificationLevelApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationLevelResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetNotificationLevelResponseApplicationJson_Ocs
    implements
        $RoomSetNotificationLevelResponseApplicationJson_OcsInterface,
        Built<RoomSetNotificationLevelResponseApplicationJson_Ocs,
            RoomSetNotificationLevelResponseApplicationJson_OcsBuilder> {
  factory RoomSetNotificationLevelResponseApplicationJson_Ocs([
    void Function(RoomSetNotificationLevelResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetNotificationLevelResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetNotificationLevelResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetNotificationLevelResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetNotificationLevelResponseApplicationJson_Ocs> get serializer =>
      _$roomSetNotificationLevelResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationLevelResponseApplicationJsonInterface {
  RoomSetNotificationLevelResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetNotificationLevelResponseApplicationJson
    implements
        $RoomSetNotificationLevelResponseApplicationJsonInterface,
        Built<RoomSetNotificationLevelResponseApplicationJson, RoomSetNotificationLevelResponseApplicationJsonBuilder> {
  factory RoomSetNotificationLevelResponseApplicationJson([
    void Function(RoomSetNotificationLevelResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetNotificationLevelResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetNotificationLevelResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetNotificationLevelResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetNotificationLevelResponseApplicationJson> get serializer =>
      _$roomSetNotificationLevelResponseApplicationJsonSerializer;
}

class RoomSetNotificationCallsApiVersion extends EnumClass {
  const RoomSetNotificationCallsApiVersion._(super.name);

  static const RoomSetNotificationCallsApiVersion v4 = _$roomSetNotificationCallsApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetNotificationCallsApiVersion> get values => _$roomSetNotificationCallsApiVersionValues;
  // coverage:ignore-end

  static RoomSetNotificationCallsApiVersion valueOf(String name) => _$valueOfRoomSetNotificationCallsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetNotificationCallsApiVersion> get serializer =>
      const _$RoomSetNotificationCallsApiVersionSerializer();
}

class _$RoomSetNotificationCallsApiVersionSerializer
    implements PrimitiveSerializer<RoomSetNotificationCallsApiVersion> {
  const _$RoomSetNotificationCallsApiVersionSerializer();

  static const Map<RoomSetNotificationCallsApiVersion, Object> _toWire = <RoomSetNotificationCallsApiVersion, Object>{
    RoomSetNotificationCallsApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetNotificationCallsApiVersion> _fromWire = <Object, RoomSetNotificationCallsApiVersion>{
    'v4': RoomSetNotificationCallsApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetNotificationCallsApiVersion];

  @override
  String get wireName => 'RoomSetNotificationCallsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetNotificationCallsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetNotificationCallsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationCallsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetNotificationCallsResponseApplicationJson_Ocs
    implements
        $RoomSetNotificationCallsResponseApplicationJson_OcsInterface,
        Built<RoomSetNotificationCallsResponseApplicationJson_Ocs,
            RoomSetNotificationCallsResponseApplicationJson_OcsBuilder> {
  factory RoomSetNotificationCallsResponseApplicationJson_Ocs([
    void Function(RoomSetNotificationCallsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetNotificationCallsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetNotificationCallsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetNotificationCallsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetNotificationCallsResponseApplicationJson_Ocs> get serializer =>
      _$roomSetNotificationCallsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetNotificationCallsResponseApplicationJsonInterface {
  RoomSetNotificationCallsResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetNotificationCallsResponseApplicationJson
    implements
        $RoomSetNotificationCallsResponseApplicationJsonInterface,
        Built<RoomSetNotificationCallsResponseApplicationJson, RoomSetNotificationCallsResponseApplicationJsonBuilder> {
  factory RoomSetNotificationCallsResponseApplicationJson([
    void Function(RoomSetNotificationCallsResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetNotificationCallsResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetNotificationCallsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetNotificationCallsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetNotificationCallsResponseApplicationJson> get serializer =>
      _$roomSetNotificationCallsResponseApplicationJsonSerializer;
}

class RoomSetLobbyApiVersion extends EnumClass {
  const RoomSetLobbyApiVersion._(super.name);

  static const RoomSetLobbyApiVersion v4 = _$roomSetLobbyApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetLobbyApiVersion> get values => _$roomSetLobbyApiVersionValues;
  // coverage:ignore-end

  static RoomSetLobbyApiVersion valueOf(String name) => _$valueOfRoomSetLobbyApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetLobbyApiVersion> get serializer => const _$RoomSetLobbyApiVersionSerializer();
}

class _$RoomSetLobbyApiVersionSerializer implements PrimitiveSerializer<RoomSetLobbyApiVersion> {
  const _$RoomSetLobbyApiVersionSerializer();

  static const Map<RoomSetLobbyApiVersion, Object> _toWire = <RoomSetLobbyApiVersion, Object>{
    RoomSetLobbyApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetLobbyApiVersion> _fromWire = <Object, RoomSetLobbyApiVersion>{
    'v4': RoomSetLobbyApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetLobbyApiVersion];

  @override
  String get wireName => 'RoomSetLobbyApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetLobbyApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetLobbyApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetLobbyResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomSetLobbyResponseApplicationJson_Ocs
    implements
        $RoomSetLobbyResponseApplicationJson_OcsInterface,
        Built<RoomSetLobbyResponseApplicationJson_Ocs, RoomSetLobbyResponseApplicationJson_OcsBuilder> {
  factory RoomSetLobbyResponseApplicationJson_Ocs([void Function(RoomSetLobbyResponseApplicationJson_OcsBuilder)? b]) =
      _$RoomSetLobbyResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetLobbyResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetLobbyResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetLobbyResponseApplicationJson_Ocs> get serializer =>
      _$roomSetLobbyResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetLobbyResponseApplicationJsonInterface {
  RoomSetLobbyResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetLobbyResponseApplicationJson
    implements
        $RoomSetLobbyResponseApplicationJsonInterface,
        Built<RoomSetLobbyResponseApplicationJson, RoomSetLobbyResponseApplicationJsonBuilder> {
  factory RoomSetLobbyResponseApplicationJson([void Function(RoomSetLobbyResponseApplicationJsonBuilder)? b]) =
      _$RoomSetLobbyResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetLobbyResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetLobbyResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetLobbyResponseApplicationJson> get serializer =>
      _$roomSetLobbyResponseApplicationJsonSerializer;
}

class RoomSetsipEnabledState extends EnumClass {
  const RoomSetsipEnabledState._(super.name);

  @BuiltValueEnumConst(wireName: '0')
  static const RoomSetsipEnabledState $0 = _$roomSetsipEnabledState$0;

  @BuiltValueEnumConst(wireName: '1')
  static const RoomSetsipEnabledState $1 = _$roomSetsipEnabledState$1;

  @BuiltValueEnumConst(wireName: '2')
  static const RoomSetsipEnabledState $2 = _$roomSetsipEnabledState$2;

  // coverage:ignore-start
  static BuiltSet<RoomSetsipEnabledState> get values => _$roomSetsipEnabledStateValues;
  // coverage:ignore-end

  static RoomSetsipEnabledState valueOf(String name) => _$valueOfRoomSetsipEnabledState(name);

  int get value => jsonSerializers.serializeWith(serializer, this)! as int;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetsipEnabledState> get serializer => const _$RoomSetsipEnabledStateSerializer();
}

class _$RoomSetsipEnabledStateSerializer implements PrimitiveSerializer<RoomSetsipEnabledState> {
  const _$RoomSetsipEnabledStateSerializer();

  static const Map<RoomSetsipEnabledState, Object> _toWire = <RoomSetsipEnabledState, Object>{
    RoomSetsipEnabledState.$0: 0,
    RoomSetsipEnabledState.$1: 1,
    RoomSetsipEnabledState.$2: 2,
  };

  static const Map<Object, RoomSetsipEnabledState> _fromWire = <Object, RoomSetsipEnabledState>{
    0: RoomSetsipEnabledState.$0,
    1: RoomSetsipEnabledState.$1,
    2: RoomSetsipEnabledState.$2,
  };

  @override
  Iterable<Type> get types => const [RoomSetsipEnabledState];

  @override
  String get wireName => 'RoomSetsipEnabledState';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetsipEnabledState object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetsipEnabledState deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class RoomSetsipEnabledApiVersion extends EnumClass {
  const RoomSetsipEnabledApiVersion._(super.name);

  static const RoomSetsipEnabledApiVersion v4 = _$roomSetsipEnabledApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetsipEnabledApiVersion> get values => _$roomSetsipEnabledApiVersionValues;
  // coverage:ignore-end

  static RoomSetsipEnabledApiVersion valueOf(String name) => _$valueOfRoomSetsipEnabledApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetsipEnabledApiVersion> get serializer => const _$RoomSetsipEnabledApiVersionSerializer();
}

class _$RoomSetsipEnabledApiVersionSerializer implements PrimitiveSerializer<RoomSetsipEnabledApiVersion> {
  const _$RoomSetsipEnabledApiVersionSerializer();

  static const Map<RoomSetsipEnabledApiVersion, Object> _toWire = <RoomSetsipEnabledApiVersion, Object>{
    RoomSetsipEnabledApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetsipEnabledApiVersion> _fromWire = <Object, RoomSetsipEnabledApiVersion>{
    'v4': RoomSetsipEnabledApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetsipEnabledApiVersion];

  @override
  String get wireName => 'RoomSetsipEnabledApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetsipEnabledApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetsipEnabledApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetsipEnabledResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomSetsipEnabledResponseApplicationJson_Ocs
    implements
        $RoomSetsipEnabledResponseApplicationJson_OcsInterface,
        Built<RoomSetsipEnabledResponseApplicationJson_Ocs, RoomSetsipEnabledResponseApplicationJson_OcsBuilder> {
  factory RoomSetsipEnabledResponseApplicationJson_Ocs([
    void Function(RoomSetsipEnabledResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetsipEnabledResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetsipEnabledResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetsipEnabledResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetsipEnabledResponseApplicationJson_Ocs> get serializer =>
      _$roomSetsipEnabledResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetsipEnabledResponseApplicationJsonInterface {
  RoomSetsipEnabledResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetsipEnabledResponseApplicationJson
    implements
        $RoomSetsipEnabledResponseApplicationJsonInterface,
        Built<RoomSetsipEnabledResponseApplicationJson, RoomSetsipEnabledResponseApplicationJsonBuilder> {
  factory RoomSetsipEnabledResponseApplicationJson([
    void Function(RoomSetsipEnabledResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetsipEnabledResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetsipEnabledResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetsipEnabledResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetsipEnabledResponseApplicationJson> get serializer =>
      _$roomSetsipEnabledResponseApplicationJsonSerializer;
}

class RoomSetRecordingConsentApiVersion extends EnumClass {
  const RoomSetRecordingConsentApiVersion._(super.name);

  static const RoomSetRecordingConsentApiVersion v4 = _$roomSetRecordingConsentApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetRecordingConsentApiVersion> get values => _$roomSetRecordingConsentApiVersionValues;
  // coverage:ignore-end

  static RoomSetRecordingConsentApiVersion valueOf(String name) => _$valueOfRoomSetRecordingConsentApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetRecordingConsentApiVersion> get serializer =>
      const _$RoomSetRecordingConsentApiVersionSerializer();
}

class _$RoomSetRecordingConsentApiVersionSerializer implements PrimitiveSerializer<RoomSetRecordingConsentApiVersion> {
  const _$RoomSetRecordingConsentApiVersionSerializer();

  static const Map<RoomSetRecordingConsentApiVersion, Object> _toWire = <RoomSetRecordingConsentApiVersion, Object>{
    RoomSetRecordingConsentApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetRecordingConsentApiVersion> _fromWire = <Object, RoomSetRecordingConsentApiVersion>{
    'v4': RoomSetRecordingConsentApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetRecordingConsentApiVersion];

  @override
  String get wireName => 'RoomSetRecordingConsentApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetRecordingConsentApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetRecordingConsentApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetRecordingConsentResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  Room get data;
}

abstract class RoomSetRecordingConsentResponseApplicationJson_Ocs
    implements
        $RoomSetRecordingConsentResponseApplicationJson_OcsInterface,
        Built<RoomSetRecordingConsentResponseApplicationJson_Ocs,
            RoomSetRecordingConsentResponseApplicationJson_OcsBuilder> {
  factory RoomSetRecordingConsentResponseApplicationJson_Ocs([
    void Function(RoomSetRecordingConsentResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetRecordingConsentResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetRecordingConsentResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetRecordingConsentResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetRecordingConsentResponseApplicationJson_Ocs> get serializer =>
      _$roomSetRecordingConsentResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetRecordingConsentResponseApplicationJsonInterface {
  RoomSetRecordingConsentResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetRecordingConsentResponseApplicationJson
    implements
        $RoomSetRecordingConsentResponseApplicationJsonInterface,
        Built<RoomSetRecordingConsentResponseApplicationJson, RoomSetRecordingConsentResponseApplicationJsonBuilder> {
  factory RoomSetRecordingConsentResponseApplicationJson([
    void Function(RoomSetRecordingConsentResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetRecordingConsentResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetRecordingConsentResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetRecordingConsentResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetRecordingConsentResponseApplicationJson> get serializer =>
      _$roomSetRecordingConsentResponseApplicationJsonSerializer;
}

class RoomSetMessageExpirationApiVersion extends EnumClass {
  const RoomSetMessageExpirationApiVersion._(super.name);

  static const RoomSetMessageExpirationApiVersion v4 = _$roomSetMessageExpirationApiVersionV4;

  // coverage:ignore-start
  static BuiltSet<RoomSetMessageExpirationApiVersion> get values => _$roomSetMessageExpirationApiVersionValues;
  // coverage:ignore-end

  static RoomSetMessageExpirationApiVersion valueOf(String name) => _$valueOfRoomSetMessageExpirationApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<RoomSetMessageExpirationApiVersion> get serializer =>
      const _$RoomSetMessageExpirationApiVersionSerializer();
}

class _$RoomSetMessageExpirationApiVersionSerializer
    implements PrimitiveSerializer<RoomSetMessageExpirationApiVersion> {
  const _$RoomSetMessageExpirationApiVersionSerializer();

  static const Map<RoomSetMessageExpirationApiVersion, Object> _toWire = <RoomSetMessageExpirationApiVersion, Object>{
    RoomSetMessageExpirationApiVersion.v4: 'v4',
  };

  static const Map<Object, RoomSetMessageExpirationApiVersion> _fromWire = <Object, RoomSetMessageExpirationApiVersion>{
    'v4': RoomSetMessageExpirationApiVersion.v4,
  };

  @override
  Iterable<Type> get types => const [RoomSetMessageExpirationApiVersion];

  @override
  String get wireName => 'RoomSetMessageExpirationApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    RoomSetMessageExpirationApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  RoomSetMessageExpirationApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetMessageExpirationResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class RoomSetMessageExpirationResponseApplicationJson_Ocs
    implements
        $RoomSetMessageExpirationResponseApplicationJson_OcsInterface,
        Built<RoomSetMessageExpirationResponseApplicationJson_Ocs,
            RoomSetMessageExpirationResponseApplicationJson_OcsBuilder> {
  factory RoomSetMessageExpirationResponseApplicationJson_Ocs([
    void Function(RoomSetMessageExpirationResponseApplicationJson_OcsBuilder)? b,
  ]) = _$RoomSetMessageExpirationResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const RoomSetMessageExpirationResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetMessageExpirationResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetMessageExpirationResponseApplicationJson_Ocs> get serializer =>
      _$roomSetMessageExpirationResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $RoomSetMessageExpirationResponseApplicationJsonInterface {
  RoomSetMessageExpirationResponseApplicationJson_Ocs get ocs;
}

abstract class RoomSetMessageExpirationResponseApplicationJson
    implements
        $RoomSetMessageExpirationResponseApplicationJsonInterface,
        Built<RoomSetMessageExpirationResponseApplicationJson, RoomSetMessageExpirationResponseApplicationJsonBuilder> {
  factory RoomSetMessageExpirationResponseApplicationJson([
    void Function(RoomSetMessageExpirationResponseApplicationJsonBuilder)? b,
  ]) = _$RoomSetMessageExpirationResponseApplicationJson;

  // coverage:ignore-start
  const RoomSetMessageExpirationResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory RoomSetMessageExpirationResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<RoomSetMessageExpirationResponseApplicationJson> get serializer =>
      _$roomSetMessageExpirationResponseApplicationJsonSerializer;
}

class SettingsSetsipSettingsApiVersion extends EnumClass {
  const SettingsSetsipSettingsApiVersion._(super.name);

  static const SettingsSetsipSettingsApiVersion v1 = _$settingsSetsipSettingsApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<SettingsSetsipSettingsApiVersion> get values => _$settingsSetsipSettingsApiVersionValues;
  // coverage:ignore-end

  static SettingsSetsipSettingsApiVersion valueOf(String name) => _$valueOfSettingsSetsipSettingsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<SettingsSetsipSettingsApiVersion> get serializer =>
      const _$SettingsSetsipSettingsApiVersionSerializer();
}

class _$SettingsSetsipSettingsApiVersionSerializer implements PrimitiveSerializer<SettingsSetsipSettingsApiVersion> {
  const _$SettingsSetsipSettingsApiVersionSerializer();

  static const Map<SettingsSetsipSettingsApiVersion, Object> _toWire = <SettingsSetsipSettingsApiVersion, Object>{
    SettingsSetsipSettingsApiVersion.v1: 'v1',
  };

  static const Map<Object, SettingsSetsipSettingsApiVersion> _fromWire = <Object, SettingsSetsipSettingsApiVersion>{
    'v1': SettingsSetsipSettingsApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [SettingsSetsipSettingsApiVersion];

  @override
  String get wireName => 'SettingsSetsipSettingsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SettingsSetsipSettingsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SettingsSetsipSettingsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetsipSettingsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class SettingsSetsipSettingsResponseApplicationJson_Ocs
    implements
        $SettingsSetsipSettingsResponseApplicationJson_OcsInterface,
        Built<SettingsSetsipSettingsResponseApplicationJson_Ocs,
            SettingsSetsipSettingsResponseApplicationJson_OcsBuilder> {
  factory SettingsSetsipSettingsResponseApplicationJson_Ocs([
    void Function(SettingsSetsipSettingsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SettingsSetsipSettingsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SettingsSetsipSettingsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SettingsSetsipSettingsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SettingsSetsipSettingsResponseApplicationJson_Ocs> get serializer =>
      _$settingsSetsipSettingsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetsipSettingsResponseApplicationJsonInterface {
  SettingsSetsipSettingsResponseApplicationJson_Ocs get ocs;
}

abstract class SettingsSetsipSettingsResponseApplicationJson
    implements
        $SettingsSetsipSettingsResponseApplicationJsonInterface,
        Built<SettingsSetsipSettingsResponseApplicationJson, SettingsSetsipSettingsResponseApplicationJsonBuilder> {
  factory SettingsSetsipSettingsResponseApplicationJson([
    void Function(SettingsSetsipSettingsResponseApplicationJsonBuilder)? b,
  ]) = _$SettingsSetsipSettingsResponseApplicationJson;

  // coverage:ignore-start
  const SettingsSetsipSettingsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SettingsSetsipSettingsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SettingsSetsipSettingsResponseApplicationJson> get serializer =>
      _$settingsSetsipSettingsResponseApplicationJsonSerializer;
}

class SettingsSetUserSettingKey extends EnumClass {
  const SettingsSetUserSettingKey._(super.name);

  @BuiltValueEnumConst(wireName: 'attachment_folder')
  static const SettingsSetUserSettingKey attachmentFolder = _$settingsSetUserSettingKeyAttachmentFolder;

  @BuiltValueEnumConst(wireName: 'read_status_privacy')
  static const SettingsSetUserSettingKey readStatusPrivacy = _$settingsSetUserSettingKeyReadStatusPrivacy;

  @BuiltValueEnumConst(wireName: 'typing_privacy')
  static const SettingsSetUserSettingKey typingPrivacy = _$settingsSetUserSettingKeyTypingPrivacy;

  @BuiltValueEnumConst(wireName: 'play_sounds')
  static const SettingsSetUserSettingKey playSounds = _$settingsSetUserSettingKeyPlaySounds;

  // coverage:ignore-start
  static BuiltSet<SettingsSetUserSettingKey> get values => _$settingsSetUserSettingKeyValues;
  // coverage:ignore-end

  static SettingsSetUserSettingKey valueOf(String name) => _$valueOfSettingsSetUserSettingKey(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<SettingsSetUserSettingKey> get serializer => const _$SettingsSetUserSettingKeySerializer();
}

class _$SettingsSetUserSettingKeySerializer implements PrimitiveSerializer<SettingsSetUserSettingKey> {
  const _$SettingsSetUserSettingKeySerializer();

  static const Map<SettingsSetUserSettingKey, Object> _toWire = <SettingsSetUserSettingKey, Object>{
    SettingsSetUserSettingKey.attachmentFolder: 'attachment_folder',
    SettingsSetUserSettingKey.readStatusPrivacy: 'read_status_privacy',
    SettingsSetUserSettingKey.typingPrivacy: 'typing_privacy',
    SettingsSetUserSettingKey.playSounds: 'play_sounds',
  };

  static const Map<Object, SettingsSetUserSettingKey> _fromWire = <Object, SettingsSetUserSettingKey>{
    'attachment_folder': SettingsSetUserSettingKey.attachmentFolder,
    'read_status_privacy': SettingsSetUserSettingKey.readStatusPrivacy,
    'typing_privacy': SettingsSetUserSettingKey.typingPrivacy,
    'play_sounds': SettingsSetUserSettingKey.playSounds,
  };

  @override
  Iterable<Type> get types => const [SettingsSetUserSettingKey];

  @override
  String get wireName => 'SettingsSetUserSettingKey';

  @override
  Object serialize(
    Serializers serializers,
    SettingsSetUserSettingKey object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SettingsSetUserSettingKey deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

class SettingsSetUserSettingApiVersion extends EnumClass {
  const SettingsSetUserSettingApiVersion._(super.name);

  static const SettingsSetUserSettingApiVersion v1 = _$settingsSetUserSettingApiVersionV1;

  // coverage:ignore-start
  static BuiltSet<SettingsSetUserSettingApiVersion> get values => _$settingsSetUserSettingApiVersionValues;
  // coverage:ignore-end

  static SettingsSetUserSettingApiVersion valueOf(String name) => _$valueOfSettingsSetUserSettingApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<SettingsSetUserSettingApiVersion> get serializer =>
      const _$SettingsSetUserSettingApiVersionSerializer();
}

class _$SettingsSetUserSettingApiVersionSerializer implements PrimitiveSerializer<SettingsSetUserSettingApiVersion> {
  const _$SettingsSetUserSettingApiVersionSerializer();

  static const Map<SettingsSetUserSettingApiVersion, Object> _toWire = <SettingsSetUserSettingApiVersion, Object>{
    SettingsSetUserSettingApiVersion.v1: 'v1',
  };

  static const Map<Object, SettingsSetUserSettingApiVersion> _fromWire = <Object, SettingsSetUserSettingApiVersion>{
    'v1': SettingsSetUserSettingApiVersion.v1,
  };

  @override
  Iterable<Type> get types => const [SettingsSetUserSettingApiVersion];

  @override
  String get wireName => 'SettingsSetUserSettingApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SettingsSetUserSettingApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SettingsSetUserSettingApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetUserSettingResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class SettingsSetUserSettingResponseApplicationJson_Ocs
    implements
        $SettingsSetUserSettingResponseApplicationJson_OcsInterface,
        Built<SettingsSetUserSettingResponseApplicationJson_Ocs,
            SettingsSetUserSettingResponseApplicationJson_OcsBuilder> {
  factory SettingsSetUserSettingResponseApplicationJson_Ocs([
    void Function(SettingsSetUserSettingResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SettingsSetUserSettingResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SettingsSetUserSettingResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SettingsSetUserSettingResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SettingsSetUserSettingResponseApplicationJson_Ocs> get serializer =>
      _$settingsSetUserSettingResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SettingsSetUserSettingResponseApplicationJsonInterface {
  SettingsSetUserSettingResponseApplicationJson_Ocs get ocs;
}

abstract class SettingsSetUserSettingResponseApplicationJson
    implements
        $SettingsSetUserSettingResponseApplicationJsonInterface,
        Built<SettingsSetUserSettingResponseApplicationJson, SettingsSetUserSettingResponseApplicationJsonBuilder> {
  factory SettingsSetUserSettingResponseApplicationJson([
    void Function(SettingsSetUserSettingResponseApplicationJsonBuilder)? b,
  ]) = _$SettingsSetUserSettingResponseApplicationJson;

  // coverage:ignore-start
  const SettingsSetUserSettingResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SettingsSetUserSettingResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SettingsSetUserSettingResponseApplicationJson> get serializer =>
      _$settingsSetUserSettingResponseApplicationJsonSerializer;
}

class SignalingGetSettingsApiVersion extends EnumClass {
  const SignalingGetSettingsApiVersion._(super.name);

  static const SignalingGetSettingsApiVersion v3 = _$signalingGetSettingsApiVersionV3;

  // coverage:ignore-start
  static BuiltSet<SignalingGetSettingsApiVersion> get values => _$signalingGetSettingsApiVersionValues;
  // coverage:ignore-end

  static SignalingGetSettingsApiVersion valueOf(String name) => _$valueOfSignalingGetSettingsApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingGetSettingsApiVersion> get serializer =>
      const _$SignalingGetSettingsApiVersionSerializer();
}

class _$SignalingGetSettingsApiVersionSerializer implements PrimitiveSerializer<SignalingGetSettingsApiVersion> {
  const _$SignalingGetSettingsApiVersionSerializer();

  static const Map<SignalingGetSettingsApiVersion, Object> _toWire = <SignalingGetSettingsApiVersion, Object>{
    SignalingGetSettingsApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingGetSettingsApiVersion> _fromWire = <Object, SignalingGetSettingsApiVersion>{
    'v3': SignalingGetSettingsApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingGetSettingsApiVersion];

  @override
  String get wireName => 'SignalingGetSettingsApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingGetSettingsApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingGetSettingsApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_HelloAuthParams_$10Interface {
  String? get userid;
  String get ticket;
}

abstract class SignalingSettings_HelloAuthParams_$10
    implements
        $SignalingSettings_HelloAuthParams_$10Interface,
        Built<SignalingSettings_HelloAuthParams_$10, SignalingSettings_HelloAuthParams_$10Builder> {
  factory SignalingSettings_HelloAuthParams_$10([void Function(SignalingSettings_HelloAuthParams_$10Builder)? b]) =
      _$SignalingSettings_HelloAuthParams_$10;

  // coverage:ignore-start
  const SignalingSettings_HelloAuthParams_$10._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSettings_HelloAuthParams_$10.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSettings_HelloAuthParams_$10> get serializer =>
      _$signalingSettingsHelloAuthParams$10Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_HelloAuthParams_$20Interface {
  String get token;
}

abstract class SignalingSettings_HelloAuthParams_$20
    implements
        $SignalingSettings_HelloAuthParams_$20Interface,
        Built<SignalingSettings_HelloAuthParams_$20, SignalingSettings_HelloAuthParams_$20Builder> {
  factory SignalingSettings_HelloAuthParams_$20([void Function(SignalingSettings_HelloAuthParams_$20Builder)? b]) =
      _$SignalingSettings_HelloAuthParams_$20;

  // coverage:ignore-start
  const SignalingSettings_HelloAuthParams_$20._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSettings_HelloAuthParams_$20.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSettings_HelloAuthParams_$20> get serializer =>
      _$signalingSettingsHelloAuthParams$20Serializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_HelloAuthParamsInterface {
  @BuiltValueField(wireName: '1.0')
  SignalingSettings_HelloAuthParams_$10 get $10;
  @BuiltValueField(wireName: '2.0')
  SignalingSettings_HelloAuthParams_$20 get $20;
}

abstract class SignalingSettings_HelloAuthParams
    implements
        $SignalingSettings_HelloAuthParamsInterface,
        Built<SignalingSettings_HelloAuthParams, SignalingSettings_HelloAuthParamsBuilder> {
  factory SignalingSettings_HelloAuthParams([void Function(SignalingSettings_HelloAuthParamsBuilder)? b]) =
      _$SignalingSettings_HelloAuthParams;

  // coverage:ignore-start
  const SignalingSettings_HelloAuthParams._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSettings_HelloAuthParams.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSettings_HelloAuthParams> get serializer => _$signalingSettingsHelloAuthParamsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_StunserversInterface {
  BuiltList<String> get urls;
}

abstract class SignalingSettings_Stunservers
    implements
        $SignalingSettings_StunserversInterface,
        Built<SignalingSettings_Stunservers, SignalingSettings_StunserversBuilder> {
  factory SignalingSettings_Stunservers([void Function(SignalingSettings_StunserversBuilder)? b]) =
      _$SignalingSettings_Stunservers;

  // coverage:ignore-start
  const SignalingSettings_Stunservers._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSettings_Stunservers.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSettings_Stunservers> get serializer => _$signalingSettingsStunserversSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettings_TurnserversInterface {
  BuiltList<String> get urls;
  String get username;
  JsonObject get credential;
}

abstract class SignalingSettings_Turnservers
    implements
        $SignalingSettings_TurnserversInterface,
        Built<SignalingSettings_Turnservers, SignalingSettings_TurnserversBuilder> {
  factory SignalingSettings_Turnservers([void Function(SignalingSettings_TurnserversBuilder)? b]) =
      _$SignalingSettings_Turnservers;

  // coverage:ignore-start
  const SignalingSettings_Turnservers._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSettings_Turnservers.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSettings_Turnservers> get serializer => _$signalingSettingsTurnserversSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSettingsInterface {
  SignalingSettings_HelloAuthParams get helloAuthParams;
  bool get hideWarning;
  String get server;
  String get signalingMode;
  String get sipDialinInfo;
  BuiltList<SignalingSettings_Stunservers> get stunservers;
  String get ticket;
  BuiltList<SignalingSettings_Turnservers> get turnservers;
  String? get userId;
}

abstract class SignalingSettings
    implements $SignalingSettingsInterface, Built<SignalingSettings, SignalingSettingsBuilder> {
  factory SignalingSettings([void Function(SignalingSettingsBuilder)? b]) = _$SignalingSettings;

  // coverage:ignore-start
  const SignalingSettings._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSettings.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSettings> get serializer => _$signalingSettingsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetSettingsResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  SignalingSettings get data;
}

abstract class SignalingGetSettingsResponseApplicationJson_Ocs
    implements
        $SignalingGetSettingsResponseApplicationJson_OcsInterface,
        Built<SignalingGetSettingsResponseApplicationJson_Ocs, SignalingGetSettingsResponseApplicationJson_OcsBuilder> {
  factory SignalingGetSettingsResponseApplicationJson_Ocs([
    void Function(SignalingGetSettingsResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingGetSettingsResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingGetSettingsResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingGetSettingsResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingGetSettingsResponseApplicationJson_Ocs> get serializer =>
      _$signalingGetSettingsResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetSettingsResponseApplicationJsonInterface {
  SignalingGetSettingsResponseApplicationJson_Ocs get ocs;
}

abstract class SignalingGetSettingsResponseApplicationJson
    implements
        $SignalingGetSettingsResponseApplicationJsonInterface,
        Built<SignalingGetSettingsResponseApplicationJson, SignalingGetSettingsResponseApplicationJsonBuilder> {
  factory SignalingGetSettingsResponseApplicationJson([
    void Function(SignalingGetSettingsResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingGetSettingsResponseApplicationJson;

  // coverage:ignore-start
  const SignalingGetSettingsResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingGetSettingsResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingGetSettingsResponseApplicationJson> get serializer =>
      _$signalingGetSettingsResponseApplicationJsonSerializer;
}

class SignalingGetWelcomeMessageApiVersion extends EnumClass {
  const SignalingGetWelcomeMessageApiVersion._(super.name);

  static const SignalingGetWelcomeMessageApiVersion v3 = _$signalingGetWelcomeMessageApiVersionV3;

  // coverage:ignore-start
  static BuiltSet<SignalingGetWelcomeMessageApiVersion> get values => _$signalingGetWelcomeMessageApiVersionValues;
  // coverage:ignore-end

  static SignalingGetWelcomeMessageApiVersion valueOf(String name) =>
      _$valueOfSignalingGetWelcomeMessageApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingGetWelcomeMessageApiVersion> get serializer =>
      const _$SignalingGetWelcomeMessageApiVersionSerializer();
}

class _$SignalingGetWelcomeMessageApiVersionSerializer
    implements PrimitiveSerializer<SignalingGetWelcomeMessageApiVersion> {
  const _$SignalingGetWelcomeMessageApiVersionSerializer();

  static const Map<SignalingGetWelcomeMessageApiVersion, Object> _toWire =
      <SignalingGetWelcomeMessageApiVersion, Object>{
    SignalingGetWelcomeMessageApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingGetWelcomeMessageApiVersion> _fromWire =
      <Object, SignalingGetWelcomeMessageApiVersion>{
    'v3': SignalingGetWelcomeMessageApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingGetWelcomeMessageApiVersion];

  @override
  String get wireName => 'SignalingGetWelcomeMessageApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingGetWelcomeMessageApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingGetWelcomeMessageApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetWelcomeMessageResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltMap<String, JsonObject> get data;
}

abstract class SignalingGetWelcomeMessageResponseApplicationJson_Ocs
    implements
        $SignalingGetWelcomeMessageResponseApplicationJson_OcsInterface,
        Built<SignalingGetWelcomeMessageResponseApplicationJson_Ocs,
            SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder> {
  factory SignalingGetWelcomeMessageResponseApplicationJson_Ocs([
    void Function(SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingGetWelcomeMessageResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingGetWelcomeMessageResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingGetWelcomeMessageResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingGetWelcomeMessageResponseApplicationJson_Ocs> get serializer =>
      _$signalingGetWelcomeMessageResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingGetWelcomeMessageResponseApplicationJsonInterface {
  SignalingGetWelcomeMessageResponseApplicationJson_Ocs get ocs;
}

abstract class SignalingGetWelcomeMessageResponseApplicationJson
    implements
        $SignalingGetWelcomeMessageResponseApplicationJsonInterface,
        Built<SignalingGetWelcomeMessageResponseApplicationJson,
            SignalingGetWelcomeMessageResponseApplicationJsonBuilder> {
  factory SignalingGetWelcomeMessageResponseApplicationJson([
    void Function(SignalingGetWelcomeMessageResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingGetWelcomeMessageResponseApplicationJson;

  // coverage:ignore-start
  const SignalingGetWelcomeMessageResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingGetWelcomeMessageResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingGetWelcomeMessageResponseApplicationJson> get serializer =>
      _$signalingGetWelcomeMessageResponseApplicationJsonSerializer;
}

class SignalingPullMessagesApiVersion extends EnumClass {
  const SignalingPullMessagesApiVersion._(super.name);

  static const SignalingPullMessagesApiVersion v3 = _$signalingPullMessagesApiVersionV3;

  // coverage:ignore-start
  static BuiltSet<SignalingPullMessagesApiVersion> get values => _$signalingPullMessagesApiVersionValues;
  // coverage:ignore-end

  static SignalingPullMessagesApiVersion valueOf(String name) => _$valueOfSignalingPullMessagesApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingPullMessagesApiVersion> get serializer =>
      const _$SignalingPullMessagesApiVersionSerializer();
}

class _$SignalingPullMessagesApiVersionSerializer implements PrimitiveSerializer<SignalingPullMessagesApiVersion> {
  const _$SignalingPullMessagesApiVersionSerializer();

  static const Map<SignalingPullMessagesApiVersion, Object> _toWire = <SignalingPullMessagesApiVersion, Object>{
    SignalingPullMessagesApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingPullMessagesApiVersion> _fromWire = <Object, SignalingPullMessagesApiVersion>{
    'v3': SignalingPullMessagesApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingPullMessagesApiVersion];

  @override
  String get wireName => 'SignalingPullMessagesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingPullMessagesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingPullMessagesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSessionInterface {
  int get inCall;
  int get lastPing;
  int get participantPermissions;
  int get roomId;
  String get sessionId;
  String get userId;
}

abstract class SignalingSession
    implements $SignalingSessionInterface, Built<SignalingSession, SignalingSessionBuilder> {
  factory SignalingSession([void Function(SignalingSessionBuilder)? b]) = _$SignalingSession;

  // coverage:ignore-start
  const SignalingSession._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSession.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSession> get serializer => _$signalingSessionSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingPullMessagesResponseApplicationJson_Ocs_DataInterface {
  String get type;
  SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data get data;
}

abstract class SignalingPullMessagesResponseApplicationJson_Ocs_Data
    implements
        $SignalingPullMessagesResponseApplicationJson_Ocs_DataInterface,
        Built<SignalingPullMessagesResponseApplicationJson_Ocs_Data,
            SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder> {
  factory SignalingPullMessagesResponseApplicationJson_Ocs_Data([
    void Function(SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder)? b,
  ]) = _$SignalingPullMessagesResponseApplicationJson_Ocs_Data;

  // coverage:ignore-start
  const SignalingPullMessagesResponseApplicationJson_Ocs_Data._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingPullMessagesResponseApplicationJson_Ocs_Data.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingPullMessagesResponseApplicationJson_Ocs_Data> get serializer =>
      _$signalingPullMessagesResponseApplicationJsonOcsDataSerializer;

  @BuiltValueHook(finalizeBuilder: true)
  static void _validate(SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder b) {
    b.data?.validateOneOf();
  }
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingPullMessagesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  BuiltList<SignalingPullMessagesResponseApplicationJson_Ocs_Data> get data;
}

abstract class SignalingPullMessagesResponseApplicationJson_Ocs
    implements
        $SignalingPullMessagesResponseApplicationJson_OcsInterface,
        Built<SignalingPullMessagesResponseApplicationJson_Ocs,
            SignalingPullMessagesResponseApplicationJson_OcsBuilder> {
  factory SignalingPullMessagesResponseApplicationJson_Ocs([
    void Function(SignalingPullMessagesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingPullMessagesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingPullMessagesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingPullMessagesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingPullMessagesResponseApplicationJson_Ocs> get serializer =>
      _$signalingPullMessagesResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingPullMessagesResponseApplicationJsonInterface {
  SignalingPullMessagesResponseApplicationJson_Ocs get ocs;
}

abstract class SignalingPullMessagesResponseApplicationJson
    implements
        $SignalingPullMessagesResponseApplicationJsonInterface,
        Built<SignalingPullMessagesResponseApplicationJson, SignalingPullMessagesResponseApplicationJsonBuilder> {
  factory SignalingPullMessagesResponseApplicationJson([
    void Function(SignalingPullMessagesResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingPullMessagesResponseApplicationJson;

  // coverage:ignore-start
  const SignalingPullMessagesResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingPullMessagesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingPullMessagesResponseApplicationJson> get serializer =>
      _$signalingPullMessagesResponseApplicationJsonSerializer;
}

class SignalingSendMessagesApiVersion extends EnumClass {
  const SignalingSendMessagesApiVersion._(super.name);

  static const SignalingSendMessagesApiVersion v3 = _$signalingSendMessagesApiVersionV3;

  // coverage:ignore-start
  static BuiltSet<SignalingSendMessagesApiVersion> get values => _$signalingSendMessagesApiVersionValues;
  // coverage:ignore-end

  static SignalingSendMessagesApiVersion valueOf(String name) => _$valueOfSignalingSendMessagesApiVersion(name);

  String get value => jsonSerializers.serializeWith(serializer, this)! as String;

  @BuiltValueSerializer(custom: true)
  static Serializer<SignalingSendMessagesApiVersion> get serializer =>
      const _$SignalingSendMessagesApiVersionSerializer();
}

class _$SignalingSendMessagesApiVersionSerializer implements PrimitiveSerializer<SignalingSendMessagesApiVersion> {
  const _$SignalingSendMessagesApiVersionSerializer();

  static const Map<SignalingSendMessagesApiVersion, Object> _toWire = <SignalingSendMessagesApiVersion, Object>{
    SignalingSendMessagesApiVersion.v3: 'v3',
  };

  static const Map<Object, SignalingSendMessagesApiVersion> _fromWire = <Object, SignalingSendMessagesApiVersion>{
    'v3': SignalingSendMessagesApiVersion.v3,
  };

  @override
  Iterable<Type> get types => const [SignalingSendMessagesApiVersion];

  @override
  String get wireName => 'SignalingSendMessagesApiVersion';

  @override
  Object serialize(
    Serializers serializers,
    SignalingSendMessagesApiVersion object, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _toWire[object]!;

  @override
  SignalingSendMessagesApiVersion deserialize(
    Serializers serializers,
    Object serialized, {
    FullType specifiedType = FullType.unspecified,
  }) =>
      _fromWire[serialized]!;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSendMessagesResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class SignalingSendMessagesResponseApplicationJson_Ocs
    implements
        $SignalingSendMessagesResponseApplicationJson_OcsInterface,
        Built<SignalingSendMessagesResponseApplicationJson_Ocs,
            SignalingSendMessagesResponseApplicationJson_OcsBuilder> {
  factory SignalingSendMessagesResponseApplicationJson_Ocs([
    void Function(SignalingSendMessagesResponseApplicationJson_OcsBuilder)? b,
  ]) = _$SignalingSendMessagesResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const SignalingSendMessagesResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSendMessagesResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSendMessagesResponseApplicationJson_Ocs> get serializer =>
      _$signalingSendMessagesResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $SignalingSendMessagesResponseApplicationJsonInterface {
  SignalingSendMessagesResponseApplicationJson_Ocs get ocs;
}

abstract class SignalingSendMessagesResponseApplicationJson
    implements
        $SignalingSendMessagesResponseApplicationJsonInterface,
        Built<SignalingSendMessagesResponseApplicationJson, SignalingSendMessagesResponseApplicationJsonBuilder> {
  factory SignalingSendMessagesResponseApplicationJson([
    void Function(SignalingSendMessagesResponseApplicationJsonBuilder)? b,
  ]) = _$SignalingSendMessagesResponseApplicationJson;

  // coverage:ignore-start
  const SignalingSendMessagesResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory SignalingSendMessagesResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<SignalingSendMessagesResponseApplicationJson> get serializer =>
      _$signalingSendMessagesResponseApplicationJsonSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarPostAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class TempAvatarPostAvatarResponseApplicationJson_Ocs
    implements
        $TempAvatarPostAvatarResponseApplicationJson_OcsInterface,
        Built<TempAvatarPostAvatarResponseApplicationJson_Ocs, TempAvatarPostAvatarResponseApplicationJson_OcsBuilder> {
  factory TempAvatarPostAvatarResponseApplicationJson_Ocs([
    void Function(TempAvatarPostAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TempAvatarPostAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TempAvatarPostAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory TempAvatarPostAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<TempAvatarPostAvatarResponseApplicationJson_Ocs> get serializer =>
      _$tempAvatarPostAvatarResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarPostAvatarResponseApplicationJsonInterface {
  TempAvatarPostAvatarResponseApplicationJson_Ocs get ocs;
}

abstract class TempAvatarPostAvatarResponseApplicationJson
    implements
        $TempAvatarPostAvatarResponseApplicationJsonInterface,
        Built<TempAvatarPostAvatarResponseApplicationJson, TempAvatarPostAvatarResponseApplicationJsonBuilder> {
  factory TempAvatarPostAvatarResponseApplicationJson([
    void Function(TempAvatarPostAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$TempAvatarPostAvatarResponseApplicationJson;

  // coverage:ignore-start
  const TempAvatarPostAvatarResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory TempAvatarPostAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<TempAvatarPostAvatarResponseApplicationJson> get serializer =>
      _$tempAvatarPostAvatarResponseApplicationJsonSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarDeleteAvatarResponseApplicationJson_OcsInterface {
  OCSMeta get meta;
  JsonObject get data;
}

abstract class TempAvatarDeleteAvatarResponseApplicationJson_Ocs
    implements
        $TempAvatarDeleteAvatarResponseApplicationJson_OcsInterface,
        Built<TempAvatarDeleteAvatarResponseApplicationJson_Ocs,
            TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder> {
  factory TempAvatarDeleteAvatarResponseApplicationJson_Ocs([
    void Function(TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder)? b,
  ]) = _$TempAvatarDeleteAvatarResponseApplicationJson_Ocs;

  // coverage:ignore-start
  const TempAvatarDeleteAvatarResponseApplicationJson_Ocs._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory TempAvatarDeleteAvatarResponseApplicationJson_Ocs.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<TempAvatarDeleteAvatarResponseApplicationJson_Ocs> get serializer =>
      _$tempAvatarDeleteAvatarResponseApplicationJsonOcsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $TempAvatarDeleteAvatarResponseApplicationJsonInterface {
  TempAvatarDeleteAvatarResponseApplicationJson_Ocs get ocs;
}

abstract class TempAvatarDeleteAvatarResponseApplicationJson
    implements
        $TempAvatarDeleteAvatarResponseApplicationJsonInterface,
        Built<TempAvatarDeleteAvatarResponseApplicationJson, TempAvatarDeleteAvatarResponseApplicationJsonBuilder> {
  factory TempAvatarDeleteAvatarResponseApplicationJson([
    void Function(TempAvatarDeleteAvatarResponseApplicationJsonBuilder)? b,
  ]) = _$TempAvatarDeleteAvatarResponseApplicationJson;

  // coverage:ignore-start
  const TempAvatarDeleteAvatarResponseApplicationJson._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory TempAvatarDeleteAvatarResponseApplicationJson.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<TempAvatarDeleteAvatarResponseApplicationJson> get serializer =>
      _$tempAvatarDeleteAvatarResponseApplicationJsonSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $BotWithDetailsAndSecret_1Interface {
  String get secret;
}

@BuiltValue(instantiable: false)
abstract interface class $BotWithDetailsAndSecretInterface
    implements $BotWithDetailsInterface, $BotWithDetailsAndSecret_1Interface {}

abstract class BotWithDetailsAndSecret
    implements $BotWithDetailsAndSecretInterface, Built<BotWithDetailsAndSecret, BotWithDetailsAndSecretBuilder> {
  factory BotWithDetailsAndSecret([void Function(BotWithDetailsAndSecretBuilder)? b]) = _$BotWithDetailsAndSecret;

  // coverage:ignore-start
  const BotWithDetailsAndSecret._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory BotWithDetailsAndSecret.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<BotWithDetailsAndSecret> get serializer => _$botWithDetailsAndSecretSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $FederationInviteInterface {
  @BuiltValueField(wireName: 'access_token')
  String get accessToken;
  int get id;
  @BuiltValueField(wireName: 'local_room_id')
  int get localRoomId;
  @BuiltValueField(wireName: 'remote_attendee_id')
  String get remoteAttendeeId;
  @BuiltValueField(wireName: 'remote_server_url')
  String get remoteServerUrl;
  @BuiltValueField(wireName: 'remote_token')
  String get remoteToken;
  @BuiltValueField(wireName: 'user_id')
  String get userId;
}

abstract class FederationInvite
    implements $FederationInviteInterface, Built<FederationInvite, FederationInviteBuilder> {
  factory FederationInvite([void Function(FederationInviteBuilder)? b]) = _$FederationInvite;

  // coverage:ignore-start
  const FederationInvite._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory FederationInvite.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<FederationInvite> get serializer => _$federationInviteSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_Spreed_Config_AttachmentsInterface {
  bool get allowed;
  String? get folder;
}

abstract class PublicCapabilities0_Spreed_Config_Attachments
    implements
        $PublicCapabilities0_Spreed_Config_AttachmentsInterface,
        Built<PublicCapabilities0_Spreed_Config_Attachments, PublicCapabilities0_Spreed_Config_AttachmentsBuilder> {
  factory PublicCapabilities0_Spreed_Config_Attachments([
    void Function(PublicCapabilities0_Spreed_Config_AttachmentsBuilder)? b,
  ]) = _$PublicCapabilities0_Spreed_Config_Attachments;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed_Config_Attachments._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed_Config_Attachments.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed_Config_Attachments> get serializer =>
      _$publicCapabilities0SpreedConfigAttachmentsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_Spreed_Config_CallInterface {
  bool get enabled;
  @BuiltValueField(wireName: 'breakout-rooms')
  bool get breakoutRooms;
  bool get recording;
  @BuiltValueField(wireName: 'recording-consent')
  int? get recordingConsent;
  @BuiltValueField(wireName: 'supported-reactions')
  BuiltList<String>? get supportedReactions;
  @BuiltValueField(wireName: 'predefined-backgrounds')
  BuiltList<String>? get predefinedBackgrounds;
  @BuiltValueField(wireName: 'can-upload-background')
  bool? get canUploadBackground;
  @BuiltValueField(wireName: 'sip-enabled')
  bool? get sipEnabled;
  @BuiltValueField(wireName: 'sip-dialout-enabled')
  bool? get sipDialoutEnabled;
  @BuiltValueField(wireName: 'can-enable-sip')
  bool? get canEnableSip;
}

abstract class PublicCapabilities0_Spreed_Config_Call
    implements
        $PublicCapabilities0_Spreed_Config_CallInterface,
        Built<PublicCapabilities0_Spreed_Config_Call, PublicCapabilities0_Spreed_Config_CallBuilder> {
  factory PublicCapabilities0_Spreed_Config_Call([void Function(PublicCapabilities0_Spreed_Config_CallBuilder)? b]) =
      _$PublicCapabilities0_Spreed_Config_Call;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed_Config_Call._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed_Config_Call.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed_Config_Call> get serializer =>
      _$publicCapabilities0SpreedConfigCallSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_Spreed_Config_ChatInterface {
  @BuiltValueField(wireName: 'max-length')
  int get maxLength;
  @BuiltValueField(wireName: 'read-privacy')
  int get readPrivacy;
  @BuiltValueField(wireName: 'has-translation-providers')
  bool? get hasTranslationProviders;
  @BuiltValueField(wireName: 'typing-privacy')
  int? get typingPrivacy;
  BuiltList<String>? get translations;
}

abstract class PublicCapabilities0_Spreed_Config_Chat
    implements
        $PublicCapabilities0_Spreed_Config_ChatInterface,
        Built<PublicCapabilities0_Spreed_Config_Chat, PublicCapabilities0_Spreed_Config_ChatBuilder> {
  factory PublicCapabilities0_Spreed_Config_Chat([void Function(PublicCapabilities0_Spreed_Config_ChatBuilder)? b]) =
      _$PublicCapabilities0_Spreed_Config_Chat;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed_Config_Chat._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed_Config_Chat.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed_Config_Chat> get serializer =>
      _$publicCapabilities0SpreedConfigChatSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_Spreed_Config_ConversationsInterface {
  @BuiltValueField(wireName: 'can-create')
  bool get canCreate;
}

abstract class PublicCapabilities0_Spreed_Config_Conversations
    implements
        $PublicCapabilities0_Spreed_Config_ConversationsInterface,
        Built<PublicCapabilities0_Spreed_Config_Conversations, PublicCapabilities0_Spreed_Config_ConversationsBuilder> {
  factory PublicCapabilities0_Spreed_Config_Conversations([
    void Function(PublicCapabilities0_Spreed_Config_ConversationsBuilder)? b,
  ]) = _$PublicCapabilities0_Spreed_Config_Conversations;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed_Config_Conversations._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed_Config_Conversations.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed_Config_Conversations> get serializer =>
      _$publicCapabilities0SpreedConfigConversationsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_Spreed_Config_PreviewsInterface {
  @BuiltValueField(wireName: 'max-gif-size')
  int get maxGifSize;
}

abstract class PublicCapabilities0_Spreed_Config_Previews
    implements
        $PublicCapabilities0_Spreed_Config_PreviewsInterface,
        Built<PublicCapabilities0_Spreed_Config_Previews, PublicCapabilities0_Spreed_Config_PreviewsBuilder> {
  factory PublicCapabilities0_Spreed_Config_Previews([
    void Function(PublicCapabilities0_Spreed_Config_PreviewsBuilder)? b,
  ]) = _$PublicCapabilities0_Spreed_Config_Previews;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed_Config_Previews._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed_Config_Previews.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed_Config_Previews> get serializer =>
      _$publicCapabilities0SpreedConfigPreviewsSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_Spreed_Config_SignalingInterface {
  @BuiltValueField(wireName: 'session-ping-limit')
  int get sessionPingLimit;
  @BuiltValueField(wireName: 'hello-v2-token-key')
  String? get helloV2TokenKey;
}

abstract class PublicCapabilities0_Spreed_Config_Signaling
    implements
        $PublicCapabilities0_Spreed_Config_SignalingInterface,
        Built<PublicCapabilities0_Spreed_Config_Signaling, PublicCapabilities0_Spreed_Config_SignalingBuilder> {
  factory PublicCapabilities0_Spreed_Config_Signaling([
    void Function(PublicCapabilities0_Spreed_Config_SignalingBuilder)? b,
  ]) = _$PublicCapabilities0_Spreed_Config_Signaling;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed_Config_Signaling._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed_Config_Signaling.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed_Config_Signaling> get serializer =>
      _$publicCapabilities0SpreedConfigSignalingSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_Spreed_ConfigInterface {
  PublicCapabilities0_Spreed_Config_Attachments get attachments;
  PublicCapabilities0_Spreed_Config_Call get call;
  PublicCapabilities0_Spreed_Config_Chat get chat;
  PublicCapabilities0_Spreed_Config_Conversations get conversations;
  PublicCapabilities0_Spreed_Config_Previews get previews;
  PublicCapabilities0_Spreed_Config_Signaling get signaling;
}

abstract class PublicCapabilities0_Spreed_Config
    implements
        $PublicCapabilities0_Spreed_ConfigInterface,
        Built<PublicCapabilities0_Spreed_Config, PublicCapabilities0_Spreed_ConfigBuilder> {
  factory PublicCapabilities0_Spreed_Config([void Function(PublicCapabilities0_Spreed_ConfigBuilder)? b]) =
      _$PublicCapabilities0_Spreed_Config;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed_Config._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed_Config.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed_Config> get serializer => _$publicCapabilities0SpreedConfigSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0_SpreedInterface {
  BuiltList<String> get features;
  PublicCapabilities0_Spreed_Config get config;
  String get version;
}

abstract class PublicCapabilities0_Spreed
    implements
        $PublicCapabilities0_SpreedInterface,
        Built<PublicCapabilities0_Spreed, PublicCapabilities0_SpreedBuilder> {
  factory PublicCapabilities0_Spreed([void Function(PublicCapabilities0_SpreedBuilder)? b]) =
      _$PublicCapabilities0_Spreed;

  // coverage:ignore-start
  const PublicCapabilities0_Spreed._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0_Spreed.fromJson(Map<String, dynamic> json) =>
      jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0_Spreed> get serializer => _$publicCapabilities0SpreedSerializer;
}

@BuiltValue(instantiable: false)
abstract interface class $PublicCapabilities0Interface {
  PublicCapabilities0_Spreed get spreed;
}

abstract class PublicCapabilities0
    implements $PublicCapabilities0Interface, Built<PublicCapabilities0, PublicCapabilities0Builder> {
  factory PublicCapabilities0([void Function(PublicCapabilities0Builder)? b]) = _$PublicCapabilities0;

  // coverage:ignore-start
  const PublicCapabilities0._();
  // coverage:ignore-end

  // coverage:ignore-start
  factory PublicCapabilities0.fromJson(Map<String, dynamic> json) => jsonSerializers.deserializeWith(serializer, json)!;
  // coverage:ignore-end

  // coverage:ignore-start
  Map<String, dynamic> toJson() => jsonSerializers.serializeWith(serializer, this)! as Map<String, dynamic>;
  // coverage:ignore-end

  static Serializer<PublicCapabilities0> get serializer => _$publicCapabilities0Serializer;
}

typedef Room_LastMessage = ({BuiltList<Never>? builtListNever, ChatMessage? chatMessage});

extension $Room_LastMessageExtension on Room_LastMessage {
  static Serializer<Room_LastMessage> get serializer => $e620970959f428e934829e52f32b7089Extension._serializer;
  static Room_LastMessage fromJson(Object? json) => $e620970959f428e934829e52f32b7089Extension._fromJson(json);
}

typedef RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data = ({
  BuiltList<Never>? builtListNever,
  RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0? roomAddParticipantToRoomResponseApplicationJsonOcsData0
});

extension $RoomAddParticipantToRoomResponseApplicationJson_Ocs_DataExtension
    on RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data {
  static Serializer<RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data> get serializer =>
      $bd993fb3f40af33e8594d0d698208560Extension._serializer;
  static RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data fromJson(Object? json) =>
      $bd993fb3f40af33e8594d0d698208560Extension._fromJson(json);
}

typedef SettingsSetUserSettingValue = ({int? $int, String? string});

extension $SettingsSetUserSettingValueExtension on SettingsSetUserSettingValue {
  static Serializer<SettingsSetUserSettingValue> get serializer =>
      $b2c4857c0136baea42828d89c87c757dExtension._serializer;
  static SettingsSetUserSettingValue fromJson(Object? json) =>
      $b2c4857c0136baea42828d89c87c757dExtension._fromJson(json);
}

typedef SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data = ({
  BuiltList<SignalingSession>? builtListSignalingSession,
  String? string
});

extension $SignalingPullMessagesResponseApplicationJson_Ocs_Data_DataExtension
    on SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data {
  static Serializer<SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data> get serializer =>
      $1df642f5035aea3b22543ab331c3fb01Extension._serializer;
  static SignalingPullMessagesResponseApplicationJson_Ocs_Data_Data fromJson(Object? json) =>
      $1df642f5035aea3b22543ab331c3fb01Extension._fromJson(json);
}

typedef PublicCapabilities = ({BuiltList<Never>? builtListNever, PublicCapabilities0? publicCapabilities0});

extension $PublicCapabilitiesExtension on PublicCapabilities {
  static Serializer<PublicCapabilities> get serializer => $bc4aac45771b11649d372f39a92b1cf3Extension._serializer;
  static PublicCapabilities fromJson(Object? json) => $bc4aac45771b11649d372f39a92b1cf3Extension._fromJson(json);
}

typedef _$e620970959f428e934829e52f32b7089 = ({BuiltList<Never>? builtListNever, ChatMessage? chatMessage});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $e620970959f428e934829e52f32b7089Extension on _$e620970959f428e934829e52f32b7089 {
  List<dynamic> get _values => [builtListNever, chatMessage];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<_$e620970959f428e934829e52f32b7089> get _serializer =>
      const _$e620970959f428e934829e52f32b7089Serializer();
  static _$e620970959f428e934829e52f32b7089 _fromJson(Object? json) =>
      jsonSerializers.deserializeWith(_serializer, json)!;
  Object? toJson() => jsonSerializers.serializeWith(_serializer, this);
}

class _$e620970959f428e934829e52f32b7089Serializer implements PrimitiveSerializer<_$e620970959f428e934829e52f32b7089> {
  const _$e620970959f428e934829e52f32b7089Serializer();

  @override
  Iterable<Type> get types => const [_$e620970959f428e934829e52f32b7089];

  @override
  String get wireName => r'_$e620970959f428e934829e52f32b7089';

  @override
  Object serialize(
    Serializers serializers,
    _$e620970959f428e934829e52f32b7089 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.chatMessage;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(ChatMessage))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$e620970959f428e934829e52f32b7089 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(data, specifiedType: const FullType(BuiltList, [FullType(Never)]))!
          as BuiltList<Never>;
    } catch (_) {}
    ChatMessage? chatMessage;
    try {
      chatMessage = serializers.deserialize(data, specifiedType: const FullType(ChatMessage))! as ChatMessage;
    } catch (_) {}
    return (builtListNever: builtListNever, chatMessage: chatMessage);
  }
}

typedef _$bd993fb3f40af33e8594d0d698208560 = ({
  BuiltList<Never>? builtListNever,
  RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0? roomAddParticipantToRoomResponseApplicationJsonOcsData0
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $bd993fb3f40af33e8594d0d698208560Extension on _$bd993fb3f40af33e8594d0d698208560 {
  List<dynamic> get _values => [builtListNever, roomAddParticipantToRoomResponseApplicationJsonOcsData0];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<_$bd993fb3f40af33e8594d0d698208560> get _serializer =>
      const _$bd993fb3f40af33e8594d0d698208560Serializer();
  static _$bd993fb3f40af33e8594d0d698208560 _fromJson(Object? json) =>
      jsonSerializers.deserializeWith(_serializer, json)!;
  Object? toJson() => jsonSerializers.serializeWith(_serializer, this);
}

class _$bd993fb3f40af33e8594d0d698208560Serializer implements PrimitiveSerializer<_$bd993fb3f40af33e8594d0d698208560> {
  const _$bd993fb3f40af33e8594d0d698208560Serializer();

  @override
  Iterable<Type> get types => const [_$bd993fb3f40af33e8594d0d698208560];

  @override
  String get wireName => r'_$bd993fb3f40af33e8594d0d698208560';

  @override
  Object serialize(
    Serializers serializers,
    _$bd993fb3f40af33e8594d0d698208560 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.roomAddParticipantToRoomResponseApplicationJsonOcsData0;
    if (value != null) {
      return serializers.serialize(
        value,
        specifiedType: const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0),
      )!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$bd993fb3f40af33e8594d0d698208560 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(data, specifiedType: const FullType(BuiltList, [FullType(Never)]))!
          as BuiltList<Never>;
    } catch (_) {}
    RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0? roomAddParticipantToRoomResponseApplicationJsonOcsData0;
    try {
      roomAddParticipantToRoomResponseApplicationJsonOcsData0 = serializers.deserialize(
        data,
        specifiedType: const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0),
      )! as RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0;
    } catch (_) {}
    return (
      builtListNever: builtListNever,
      roomAddParticipantToRoomResponseApplicationJsonOcsData0: roomAddParticipantToRoomResponseApplicationJsonOcsData0
    );
  }
}

typedef _$b2c4857c0136baea42828d89c87c757d = ({int? $int, String? string});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $b2c4857c0136baea42828d89c87c757dExtension on _$b2c4857c0136baea42828d89c87c757d {
  List<dynamic> get _values => [$int, string];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<_$b2c4857c0136baea42828d89c87c757d> get _serializer =>
      const _$b2c4857c0136baea42828d89c87c757dSerializer();
  static _$b2c4857c0136baea42828d89c87c757d _fromJson(Object? json) =>
      jsonSerializers.deserializeWith(_serializer, json)!;
  Object? toJson() => jsonSerializers.serializeWith(_serializer, this);
}

class _$b2c4857c0136baea42828d89c87c757dSerializer implements PrimitiveSerializer<_$b2c4857c0136baea42828d89c87c757d> {
  const _$b2c4857c0136baea42828d89c87c757dSerializer();

  @override
  Iterable<Type> get types => const [_$b2c4857c0136baea42828d89c87c757d];

  @override
  String get wireName => r'_$b2c4857c0136baea42828d89c87c757d';

  @override
  Object serialize(
    Serializers serializers,
    _$b2c4857c0136baea42828d89c87c757d object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.$int;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(int))!;
    }
    value = object.string;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(String))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$b2c4857c0136baea42828d89c87c757d deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    int? $int;
    try {
      $int = serializers.deserialize(data, specifiedType: const FullType(int))! as int;
    } catch (_) {}
    String? string;
    try {
      string = serializers.deserialize(data, specifiedType: const FullType(String))! as String;
    } catch (_) {}
    return ($int: $int, string: string);
  }
}

typedef _$1df642f5035aea3b22543ab331c3fb01 = ({BuiltList<SignalingSession>? builtListSignalingSession, String? string});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $1df642f5035aea3b22543ab331c3fb01Extension on _$1df642f5035aea3b22543ab331c3fb01 {
  List<dynamic> get _values => [builtListSignalingSession, string];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<_$1df642f5035aea3b22543ab331c3fb01> get _serializer =>
      const _$1df642f5035aea3b22543ab331c3fb01Serializer();
  static _$1df642f5035aea3b22543ab331c3fb01 _fromJson(Object? json) =>
      jsonSerializers.deserializeWith(_serializer, json)!;
  Object? toJson() => jsonSerializers.serializeWith(_serializer, this);
}

class _$1df642f5035aea3b22543ab331c3fb01Serializer implements PrimitiveSerializer<_$1df642f5035aea3b22543ab331c3fb01> {
  const _$1df642f5035aea3b22543ab331c3fb01Serializer();

  @override
  Iterable<Type> get types => const [_$1df642f5035aea3b22543ab331c3fb01];

  @override
  String get wireName => r'_$1df642f5035aea3b22543ab331c3fb01';

  @override
  Object serialize(
    Serializers serializers,
    _$1df642f5035aea3b22543ab331c3fb01 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListSignalingSession;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(SignalingSession)]))!;
    }
    value = object.string;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(String))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$1df642f5035aea3b22543ab331c3fb01 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<SignalingSession>? builtListSignalingSession;
    try {
      builtListSignalingSession = serializers.deserialize(
        data,
        specifiedType: const FullType(BuiltList, [FullType(SignalingSession)]),
      )! as BuiltList<SignalingSession>;
    } catch (_) {}
    String? string;
    try {
      string = serializers.deserialize(data, specifiedType: const FullType(String))! as String;
    } catch (_) {}
    return (builtListSignalingSession: builtListSignalingSession, string: string);
  }
}

typedef _$bc4aac45771b11649d372f39a92b1cf3 = ({
  BuiltList<Never>? builtListNever,
  PublicCapabilities0? publicCapabilities0
});

/// @nodoc
// ignore: library_private_types_in_public_api
extension $bc4aac45771b11649d372f39a92b1cf3Extension on _$bc4aac45771b11649d372f39a92b1cf3 {
  List<dynamic> get _values => [builtListNever, publicCapabilities0];
  void validateOneOf() => dynamite_utils.validateOneOf(_values);
  void validateAnyOf() => dynamite_utils.validateAnyOf(_values);
  static Serializer<_$bc4aac45771b11649d372f39a92b1cf3> get _serializer =>
      const _$bc4aac45771b11649d372f39a92b1cf3Serializer();
  static _$bc4aac45771b11649d372f39a92b1cf3 _fromJson(Object? json) =>
      jsonSerializers.deserializeWith(_serializer, json)!;
  Object? toJson() => jsonSerializers.serializeWith(_serializer, this);
}

class _$bc4aac45771b11649d372f39a92b1cf3Serializer implements PrimitiveSerializer<_$bc4aac45771b11649d372f39a92b1cf3> {
  const _$bc4aac45771b11649d372f39a92b1cf3Serializer();

  @override
  Iterable<Type> get types => const [_$bc4aac45771b11649d372f39a92b1cf3];

  @override
  String get wireName => r'_$bc4aac45771b11649d372f39a92b1cf3';

  @override
  Object serialize(
    Serializers serializers,
    _$bc4aac45771b11649d372f39a92b1cf3 object, {
    FullType specifiedType = FullType.unspecified,
  }) {
    dynamic value;
    value = object.builtListNever;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(BuiltList, [FullType(Never)]))!;
    }
    value = object.publicCapabilities0;
    if (value != null) {
      return serializers.serialize(value, specifiedType: const FullType(PublicCapabilities0))!;
    }
// Should not be possible after validation.
    throw StateError('Tried to serialize without any value.');
  }

  @override
  _$bc4aac45771b11649d372f39a92b1cf3 deserialize(
    Serializers serializers,
    Object data, {
    FullType specifiedType = FullType.unspecified,
  }) {
    BuiltList<Never>? builtListNever;
    try {
      builtListNever = serializers.deserialize(data, specifiedType: const FullType(BuiltList, [FullType(Never)]))!
          as BuiltList<Never>;
    } catch (_) {}
    PublicCapabilities0? publicCapabilities0;
    try {
      publicCapabilities0 =
          serializers.deserialize(data, specifiedType: const FullType(PublicCapabilities0))! as PublicCapabilities0;
    } catch (_) {}
    return (builtListNever: builtListNever, publicCapabilities0: publicCapabilities0);
  }
}

// coverage:ignore-start
@visibleForTesting
final Serializers serializers = (Serializers().toBuilder()
      ..add(AvatarGetAvatarApiVersion.serializer)
      ..add(AvatarUploadAvatarApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(AvatarUploadAvatarResponseApplicationJson),
        AvatarUploadAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(AvatarUploadAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AvatarUploadAvatarResponseApplicationJson_Ocs),
        AvatarUploadAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AvatarUploadAvatarResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(OCSMeta), OCSMetaBuilder.new)
      ..add(OCSMeta.serializer)
      ..addBuilderFactory(const FullType(Room), RoomBuilder.new)
      ..add(Room.serializer)
      ..addBuilderFactory(const FullType(ChatMessage), ChatMessageBuilder.new)
      ..add(ChatMessage.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        MapBuilder<String, JsonObject>.new,
      )
      ..addBuilderFactory(
        const FullType(BuiltMap, [
          FullType(String),
          FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        ]),
        MapBuilder<String, BuiltMap<String, JsonObject>>.new,
      )
      ..addBuilderFactory(const FullType(BuiltMap, [FullType(String), FullType(int)]), MapBuilder<String, int>.new)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Never)]), ListBuilder<Never>.new)
      ..add($e620970959f428e934829e52f32b7089Extension._serializer)
      ..add(AvatarDeleteAvatarApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(AvatarDeleteAvatarResponseApplicationJson),
        AvatarDeleteAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(AvatarDeleteAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AvatarDeleteAvatarResponseApplicationJson_Ocs),
        AvatarDeleteAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AvatarDeleteAvatarResponseApplicationJson_Ocs.serializer)
      ..add(AvatarEmojiAvatarApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(AvatarEmojiAvatarResponseApplicationJson),
        AvatarEmojiAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(AvatarEmojiAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(AvatarEmojiAvatarResponseApplicationJson_Ocs),
        AvatarEmojiAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(AvatarEmojiAvatarResponseApplicationJson_Ocs.serializer)
      ..add(AvatarGetAvatarDarkApiVersion.serializer)
      ..add(BotSendMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotSendMessageResponseApplicationJson),
        BotSendMessageResponseApplicationJsonBuilder.new,
      )
      ..add(BotSendMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotSendMessageResponseApplicationJson_Ocs),
        BotSendMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotSendMessageResponseApplicationJson_Ocs.serializer)
      ..add(BotReactApiVersion.serializer)
      ..addBuilderFactory(const FullType(BotReactResponseApplicationJson), BotReactResponseApplicationJsonBuilder.new)
      ..add(BotReactResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotReactResponseApplicationJson_Ocs),
        BotReactResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotReactResponseApplicationJson_Ocs.serializer)
      ..add(BotDeleteReactionApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotDeleteReactionResponseApplicationJson),
        BotDeleteReactionResponseApplicationJsonBuilder.new,
      )
      ..add(BotDeleteReactionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotDeleteReactionResponseApplicationJson_Ocs),
        BotDeleteReactionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotDeleteReactionResponseApplicationJson_Ocs.serializer)
      ..add(BotAdminListBotsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotAdminListBotsResponseApplicationJson),
        BotAdminListBotsResponseApplicationJsonBuilder.new,
      )
      ..add(BotAdminListBotsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotAdminListBotsResponseApplicationJson_Ocs),
        BotAdminListBotsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotAdminListBotsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BotWithDetails), BotWithDetailsBuilder.new)
      ..add(BotWithDetails.serializer)
      ..addBuilderFactory(const FullType(Bot), BotBuilder.new)
      ..add(Bot.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(BotWithDetails)]), ListBuilder<BotWithDetails>.new)
      ..add(BotListBotsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotListBotsResponseApplicationJson),
        BotListBotsResponseApplicationJsonBuilder.new,
      )
      ..add(BotListBotsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotListBotsResponseApplicationJson_Ocs),
        BotListBotsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotListBotsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Bot)]), ListBuilder<Bot>.new)
      ..add(BotEnableBotApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotEnableBotResponseApplicationJson),
        BotEnableBotResponseApplicationJsonBuilder.new,
      )
      ..add(BotEnableBotResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotEnableBotResponseApplicationJson_Ocs),
        BotEnableBotResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotEnableBotResponseApplicationJson_Ocs.serializer)
      ..add(BotDisableBotApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BotDisableBotResponseApplicationJson),
        BotDisableBotResponseApplicationJsonBuilder.new,
      )
      ..add(BotDisableBotResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BotDisableBotResponseApplicationJson_Ocs),
        BotDisableBotResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BotDisableBotResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomConfigureBreakoutRoomsMode.serializer)
      ..add(BreakoutRoomConfigureBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson),
        BreakoutRoomConfigureBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomConfigureBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Room)]), ListBuilder<Room>.new)
      ..add(BreakoutRoomRemoveBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson),
        BreakoutRoomRemoveBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomRemoveBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomBroadcastChatMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomBroadcastChatMessageResponseApplicationJson),
        BreakoutRoomBroadcastChatMessageResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomBroadcastChatMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs),
        BreakoutRoomBroadcastChatMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomBroadcastChatMessageResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomApplyAttendeeMapApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomApplyAttendeeMapResponseApplicationJson),
        BreakoutRoomApplyAttendeeMapResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomApplyAttendeeMapResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs),
        BreakoutRoomApplyAttendeeMapResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomApplyAttendeeMapResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomRequestAssistanceApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRequestAssistanceResponseApplicationJson),
        BreakoutRoomRequestAssistanceResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomRequestAssistanceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs),
        BreakoutRoomRequestAssistanceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomRequestAssistanceResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomResetRequestForAssistanceApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomResetRequestForAssistanceResponseApplicationJson),
        BreakoutRoomResetRequestForAssistanceResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomResetRequestForAssistanceResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs),
        BreakoutRoomResetRequestForAssistanceResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomResetRequestForAssistanceResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomStartBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStartBreakoutRoomsResponseApplicationJson),
        BreakoutRoomStartBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomStartBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomStartBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomStartBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomStopBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStopBreakoutRoomsResponseApplicationJson),
        BreakoutRoomStopBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomStopBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs),
        BreakoutRoomStopBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomStopBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(BreakoutRoomSwitchBreakoutRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson),
        BreakoutRoomSwitchBreakoutRoomResponseApplicationJsonBuilder.new,
      )
      ..add(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs),
        BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(BreakoutRoomSwitchBreakoutRoomResponseApplicationJson_Ocs.serializer)
      ..add(CallGetPeersForCallApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallGetPeersForCallResponseApplicationJson),
        CallGetPeersForCallResponseApplicationJsonBuilder.new,
      )
      ..add(CallGetPeersForCallResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallGetPeersForCallResponseApplicationJson_Ocs),
        CallGetPeersForCallResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallGetPeersForCallResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(CallPeer), CallPeerBuilder.new)
      ..add(CallPeer.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(CallPeer)]), ListBuilder<CallPeer>.new)
      ..add(CallUpdateCallFlagsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallUpdateCallFlagsResponseApplicationJson),
        CallUpdateCallFlagsResponseApplicationJsonBuilder.new,
      )
      ..add(CallUpdateCallFlagsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallUpdateCallFlagsResponseApplicationJson_Ocs),
        CallUpdateCallFlagsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallUpdateCallFlagsResponseApplicationJson_Ocs.serializer)
      ..add(CallJoinCallFlags.serializer)
      ..add(CallJoinCallForcePermissions.serializer)
      ..add(CallJoinCallApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallJoinCallResponseApplicationJson),
        CallJoinCallResponseApplicationJsonBuilder.new,
      )
      ..add(CallJoinCallResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallJoinCallResponseApplicationJson_Ocs),
        CallJoinCallResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallJoinCallResponseApplicationJson_Ocs.serializer)
      ..add(CallLeaveCallApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallLeaveCallResponseApplicationJson),
        CallLeaveCallResponseApplicationJsonBuilder.new,
      )
      ..add(CallLeaveCallResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallLeaveCallResponseApplicationJson_Ocs),
        CallLeaveCallResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallLeaveCallResponseApplicationJson_Ocs.serializer)
      ..add(CallRingAttendeeApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallRingAttendeeResponseApplicationJson),
        CallRingAttendeeResponseApplicationJsonBuilder.new,
      )
      ..add(CallRingAttendeeResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallRingAttendeeResponseApplicationJson_Ocs),
        CallRingAttendeeResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallRingAttendeeResponseApplicationJson_Ocs.serializer)
      ..add(CallSipDialOutApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CallSipDialOutResponseApplicationJson),
        CallSipDialOutResponseApplicationJsonBuilder.new,
      )
      ..add(CallSipDialOutResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CallSipDialOutResponseApplicationJson_Ocs),
        CallSipDialOutResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CallSipDialOutResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CallSipDialOutResponseApplicationJson_Ocs_Data),
        CallSipDialOutResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(CallSipDialOutResponseApplicationJson_Ocs_Data.serializer)
      ..add(CertificateGetCertificateExpirationApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(CertificateGetCertificateExpirationResponseApplicationJson),
        CertificateGetCertificateExpirationResponseApplicationJsonBuilder.new,
      )
      ..add(CertificateGetCertificateExpirationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(CertificateGetCertificateExpirationResponseApplicationJson_Ocs),
        CertificateGetCertificateExpirationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(CertificateGetCertificateExpirationResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data),
        CertificateGetCertificateExpirationResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(CertificateGetCertificateExpirationResponseApplicationJson_Ocs_Data.serializer)
      ..add(ChatReceiveMessagesLookIntoFuture.serializer)
      ..add(ChatReceiveMessagesSetReadMarker.serializer)
      ..add(ChatReceiveMessagesIncludeLastKnown.serializer)
      ..add(ChatReceiveMessagesNoStatusUpdate.serializer)
      ..add(ChatReceiveMessagesMarkNotificationsAsRead.serializer)
      ..add(ChatReceiveMessagesApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatReceiveMessagesHeaders), ChatChatReceiveMessagesHeadersBuilder.new)
      ..add(ChatChatReceiveMessagesHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatReceiveMessagesResponseApplicationJson),
        ChatReceiveMessagesResponseApplicationJsonBuilder.new,
      )
      ..add(ChatReceiveMessagesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatReceiveMessagesResponseApplicationJson_Ocs),
        ChatReceiveMessagesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatReceiveMessagesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatMessageWithParent), ChatMessageWithParentBuilder.new)
      ..add(ChatMessageWithParent.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(ChatMessageWithParent)]),
        ListBuilder<ChatMessageWithParent>.new,
      )
      ..add(ChatSendMessageApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatSendMessageHeaders), ChatChatSendMessageHeadersBuilder.new)
      ..add(ChatChatSendMessageHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatSendMessageResponseApplicationJson),
        ChatSendMessageResponseApplicationJsonBuilder.new,
      )
      ..add(ChatSendMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatSendMessageResponseApplicationJson_Ocs),
        ChatSendMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatSendMessageResponseApplicationJson_Ocs.serializer)
      ..add(ChatClearHistoryApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatClearHistoryHeaders), ChatChatClearHistoryHeadersBuilder.new)
      ..add(ChatChatClearHistoryHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatClearHistoryResponseApplicationJson),
        ChatClearHistoryResponseApplicationJsonBuilder.new,
      )
      ..add(ChatClearHistoryResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatClearHistoryResponseApplicationJson_Ocs),
        ChatClearHistoryResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatClearHistoryResponseApplicationJson_Ocs.serializer)
      ..add(ChatDeleteMessageApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatDeleteMessageHeaders), ChatChatDeleteMessageHeadersBuilder.new)
      ..add(ChatChatDeleteMessageHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteMessageResponseApplicationJson),
        ChatDeleteMessageResponseApplicationJsonBuilder.new,
      )
      ..add(ChatDeleteMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteMessageResponseApplicationJson_Ocs),
        ChatDeleteMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatDeleteMessageResponseApplicationJson_Ocs.serializer)
      ..add(ChatGetMessageContextApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatGetMessageContextHeaders), ChatChatGetMessageContextHeadersBuilder.new)
      ..add(ChatChatGetMessageContextHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetMessageContextResponseApplicationJson),
        ChatGetMessageContextResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetMessageContextResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetMessageContextResponseApplicationJson_Ocs),
        ChatGetMessageContextResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetMessageContextResponseApplicationJson_Ocs.serializer)
      ..add(ChatGetReminderApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetReminderResponseApplicationJson),
        ChatGetReminderResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetReminderResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetReminderResponseApplicationJson_Ocs),
        ChatGetReminderResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetReminderResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatReminder), ChatReminderBuilder.new)
      ..add(ChatReminder.serializer)
      ..add(ChatSetReminderApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReminderResponseApplicationJson),
        ChatSetReminderResponseApplicationJsonBuilder.new,
      )
      ..add(ChatSetReminderResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReminderResponseApplicationJson_Ocs),
        ChatSetReminderResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatSetReminderResponseApplicationJson_Ocs.serializer)
      ..add(ChatDeleteReminderApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteReminderResponseApplicationJson),
        ChatDeleteReminderResponseApplicationJsonBuilder.new,
      )
      ..add(ChatDeleteReminderResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatDeleteReminderResponseApplicationJson_Ocs),
        ChatDeleteReminderResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatDeleteReminderResponseApplicationJson_Ocs.serializer)
      ..add(ChatSetReadMarkerApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatSetReadMarkerHeaders), ChatChatSetReadMarkerHeadersBuilder.new)
      ..add(ChatChatSetReadMarkerHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReadMarkerResponseApplicationJson),
        ChatSetReadMarkerResponseApplicationJsonBuilder.new,
      )
      ..add(ChatSetReadMarkerResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatSetReadMarkerResponseApplicationJson_Ocs),
        ChatSetReadMarkerResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatSetReadMarkerResponseApplicationJson_Ocs.serializer)
      ..add(ChatMarkUnreadApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatMarkUnreadHeaders), ChatChatMarkUnreadHeadersBuilder.new)
      ..add(ChatChatMarkUnreadHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatMarkUnreadResponseApplicationJson),
        ChatMarkUnreadResponseApplicationJsonBuilder.new,
      )
      ..add(ChatMarkUnreadResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatMarkUnreadResponseApplicationJson_Ocs),
        ChatMarkUnreadResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatMarkUnreadResponseApplicationJson_Ocs.serializer)
      ..add(ChatMentionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatMentionsResponseApplicationJson),
        ChatMentionsResponseApplicationJsonBuilder.new,
      )
      ..add(ChatMentionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatMentionsResponseApplicationJson_Ocs),
        ChatMentionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatMentionsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(ChatMentionSuggestion), ChatMentionSuggestionBuilder.new)
      ..add(ChatMentionSuggestion.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(ChatMentionSuggestion)]),
        ListBuilder<ChatMentionSuggestion>.new,
      )
      ..add(ChatGetObjectsSharedInRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatChatGetObjectsSharedInRoomHeaders),
        ChatChatGetObjectsSharedInRoomHeadersBuilder.new,
      )
      ..add(ChatChatGetObjectsSharedInRoomHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomResponseApplicationJson),
        ChatGetObjectsSharedInRoomResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs),
        ChatGetObjectsSharedInRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(ChatMessage)]), ListBuilder<ChatMessage>.new)
      ..add(ChatShareObjectToChatApiVersion.serializer)
      ..addBuilderFactory(const FullType(ChatChatShareObjectToChatHeaders), ChatChatShareObjectToChatHeadersBuilder.new)
      ..add(ChatChatShareObjectToChatHeaders.serializer)
      ..addBuilderFactory(
        const FullType(ChatShareObjectToChatResponseApplicationJson),
        ChatShareObjectToChatResponseApplicationJsonBuilder.new,
      )
      ..add(ChatShareObjectToChatResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatShareObjectToChatResponseApplicationJson_Ocs),
        ChatShareObjectToChatResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatShareObjectToChatResponseApplicationJson_Ocs.serializer)
      ..add(ChatGetObjectsSharedInRoomOverviewApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson),
        ChatGetObjectsSharedInRoomOverviewResponseApplicationJsonBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs),
        ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ChatGetObjectsSharedInRoomOverviewResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(BuiltMap, [
          FullType(String),
          FullType(BuiltList, [FullType(ChatMessage)]),
        ]),
        MapBuilder<String, BuiltList<ChatMessage>>.new,
      )
      ..add(FilesIntegrationGetRoomByFileIdApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson),
        FilesIntegrationGetRoomByFileIdResponseApplicationJsonBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByFileIdResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs),
        FilesIntegrationGetRoomByFileIdResponseApplicationJson_OcsBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data),
        FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByFileIdResponseApplicationJson_Ocs_Data.serializer)
      ..add(FilesIntegrationGetRoomByShareTokenApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson),
        FilesIntegrationGetRoomByShareTokenResponseApplicationJsonBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByShareTokenResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs),
        FilesIntegrationGetRoomByShareTokenResponseApplicationJson_OcsBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data),
        FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(FilesIntegrationGetRoomByShareTokenResponseApplicationJson_Ocs_Data.serializer)
      ..add(GuestSetDisplayNameApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(GuestSetDisplayNameResponseApplicationJson),
        GuestSetDisplayNameResponseApplicationJsonBuilder.new,
      )
      ..add(GuestSetDisplayNameResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(GuestSetDisplayNameResponseApplicationJson_Ocs),
        GuestSetDisplayNameResponseApplicationJson_OcsBuilder.new,
      )
      ..add(GuestSetDisplayNameResponseApplicationJson_Ocs.serializer)
      ..add(HostedSignalingServerRequestTrialApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(HostedSignalingServerRequestTrialResponseApplicationJson),
        HostedSignalingServerRequestTrialResponseApplicationJsonBuilder.new,
      )
      ..add(HostedSignalingServerRequestTrialResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(HostedSignalingServerRequestTrialResponseApplicationJson_Ocs),
        HostedSignalingServerRequestTrialResponseApplicationJson_OcsBuilder.new,
      )
      ..add(HostedSignalingServerRequestTrialResponseApplicationJson_Ocs.serializer)
      ..add(HostedSignalingServerDeleteAccountApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(HostedSignalingServerDeleteAccountResponseApplicationJson),
        HostedSignalingServerDeleteAccountResponseApplicationJsonBuilder.new,
      )
      ..add(HostedSignalingServerDeleteAccountResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs),
        HostedSignalingServerDeleteAccountResponseApplicationJson_OcsBuilder.new,
      )
      ..add(HostedSignalingServerDeleteAccountResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeGetBridgeOfRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeOfRoomResponseApplicationJson),
        MatterbridgeGetBridgeOfRoomResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeGetBridgeOfRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs),
        MatterbridgeGetBridgeOfRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeGetBridgeOfRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(MatterbridgeWithProcessState), MatterbridgeWithProcessStateBuilder.new)
      ..add(MatterbridgeWithProcessState.serializer)
      ..addBuilderFactory(const FullType(Matterbridge), MatterbridgeBuilder.new)
      ..add(Matterbridge.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [
          FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
        ]),
        ListBuilder<BuiltMap<String, JsonObject>>.new,
      )
      ..addBuilderFactory(const FullType(MatterbridgeProcessState), MatterbridgeProcessStateBuilder.new)
      ..add(MatterbridgeProcessState.serializer)
      ..addBuilderFactory(
        const FullType(ContentString, [
          FullType(BuiltList, [
            FullType(BuiltMap, [FullType(String), FullType(JsonObject)]),
          ]),
        ]),
        ContentStringBuilder<BuiltList<BuiltMap<String, JsonObject>>>.new,
      )
      ..add(ContentString.serializer)
      ..add(MatterbridgeEditBridgeOfRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeEditBridgeOfRoomResponseApplicationJson),
        MatterbridgeEditBridgeOfRoomResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeEditBridgeOfRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs),
        MatterbridgeEditBridgeOfRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeEditBridgeOfRoomResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeDeleteBridgeOfRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson),
        MatterbridgeDeleteBridgeOfRoomResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs),
        MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeDeleteBridgeOfRoomResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeGetBridgeProcessStateApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeProcessStateResponseApplicationJson),
        MatterbridgeGetBridgeProcessStateResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeGetBridgeProcessStateResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs),
        MatterbridgeGetBridgeProcessStateResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeGetBridgeProcessStateResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeSettingsStopAllBridgesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsStopAllBridgesResponseApplicationJson),
        MatterbridgeSettingsStopAllBridgesResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeSettingsStopAllBridgesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs),
        MatterbridgeSettingsStopAllBridgesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeSettingsStopAllBridgesResponseApplicationJson_Ocs.serializer)
      ..add(MatterbridgeSettingsGetMatterbridgeVersionApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson),
        MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJsonBuilder.new,
      )
      ..add(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs),
        MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data),
        MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(MatterbridgeSettingsGetMatterbridgeVersionResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(String)]), ListBuilder<String>.new)
      ..add(PollCreatePollResultMode.serializer)
      ..add(PollCreatePollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollCreatePollResponseApplicationJson),
        PollCreatePollResponseApplicationJsonBuilder.new,
      )
      ..add(PollCreatePollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollCreatePollResponseApplicationJson_Ocs),
        PollCreatePollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollCreatePollResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Poll), PollBuilder.new)
      ..add(Poll.serializer)
      ..addBuilderFactory(const FullType(PollVote), PollVoteBuilder.new)
      ..add(PollVote.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(PollVote)]), ListBuilder<PollVote>.new)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(int)]), ListBuilder<int>.new)
      ..add(PollShowPollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollShowPollResponseApplicationJson),
        PollShowPollResponseApplicationJsonBuilder.new,
      )
      ..add(PollShowPollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollShowPollResponseApplicationJson_Ocs),
        PollShowPollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollShowPollResponseApplicationJson_Ocs.serializer)
      ..add(PollVotePollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollVotePollResponseApplicationJson),
        PollVotePollResponseApplicationJsonBuilder.new,
      )
      ..add(PollVotePollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollVotePollResponseApplicationJson_Ocs),
        PollVotePollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollVotePollResponseApplicationJson_Ocs.serializer)
      ..add(PollClosePollApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PollClosePollResponseApplicationJson),
        PollClosePollResponseApplicationJsonBuilder.new,
      )
      ..add(PollClosePollResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PollClosePollResponseApplicationJson_Ocs),
        PollClosePollResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PollClosePollResponseApplicationJson_Ocs.serializer)
      ..add(PublicShareAuthCreateRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(PublicShareAuthCreateRoomResponseApplicationJson),
        PublicShareAuthCreateRoomResponseApplicationJsonBuilder.new,
      )
      ..add(PublicShareAuthCreateRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(PublicShareAuthCreateRoomResponseApplicationJson_Ocs),
        PublicShareAuthCreateRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(PublicShareAuthCreateRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data),
        PublicShareAuthCreateRoomResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(PublicShareAuthCreateRoomResponseApplicationJson_Ocs_Data.serializer)
      ..add(ReactionGetReactionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ReactionGetReactionsResponseApplicationJson),
        ReactionGetReactionsResponseApplicationJsonBuilder.new,
      )
      ..add(ReactionGetReactionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReactionGetReactionsResponseApplicationJson_Ocs),
        ReactionGetReactionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReactionGetReactionsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Reaction), ReactionBuilder.new)
      ..add(Reaction.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Reaction)]), ListBuilder<Reaction>.new)
      ..addBuilderFactory(
        const FullType(BuiltMap, [
          FullType(String),
          FullType(BuiltList, [FullType(Reaction)]),
        ]),
        MapBuilder<String, BuiltList<Reaction>>.new,
      )
      ..add(ReactionReactApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ReactionReactResponseApplicationJson),
        ReactionReactResponseApplicationJsonBuilder.new,
      )
      ..add(ReactionReactResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReactionReactResponseApplicationJson_Ocs),
        ReactionReactResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReactionReactResponseApplicationJson_Ocs.serializer)
      ..add(ReactionDeleteApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(ReactionDeleteResponseApplicationJson),
        ReactionDeleteResponseApplicationJsonBuilder.new,
      )
      ..add(ReactionDeleteResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(ReactionDeleteResponseApplicationJson_Ocs),
        ReactionDeleteResponseApplicationJson_OcsBuilder.new,
      )
      ..add(ReactionDeleteResponseApplicationJson_Ocs.serializer)
      ..add(RecordingGetWelcomeMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingGetWelcomeMessageResponseApplicationJson),
        RecordingGetWelcomeMessageResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingGetWelcomeMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingGetWelcomeMessageResponseApplicationJson_Ocs),
        RecordingGetWelcomeMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingGetWelcomeMessageResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data),
        RecordingGetWelcomeMessageResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(RecordingGetWelcomeMessageResponseApplicationJson_Ocs_Data.serializer)
      ..add(RecordingStartApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStartResponseApplicationJson),
        RecordingStartResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingStartResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStartResponseApplicationJson_Ocs),
        RecordingStartResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingStartResponseApplicationJson_Ocs.serializer)
      ..add(RecordingStopApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStopResponseApplicationJson),
        RecordingStopResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingStopResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStopResponseApplicationJson_Ocs),
        RecordingStopResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingStopResponseApplicationJson_Ocs.serializer)
      ..add(RecordingStoreApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStoreResponseApplicationJson),
        RecordingStoreResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingStoreResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingStoreResponseApplicationJson_Ocs),
        RecordingStoreResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingStoreResponseApplicationJson_Ocs.serializer)
      ..add(RecordingNotificationDismissApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingNotificationDismissResponseApplicationJson),
        RecordingNotificationDismissResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingNotificationDismissResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingNotificationDismissResponseApplicationJson_Ocs),
        RecordingNotificationDismissResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingNotificationDismissResponseApplicationJson_Ocs.serializer)
      ..add(RecordingShareToChatApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RecordingShareToChatResponseApplicationJson),
        RecordingShareToChatResponseApplicationJsonBuilder.new,
      )
      ..add(RecordingShareToChatResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RecordingShareToChatResponseApplicationJson_Ocs),
        RecordingShareToChatResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RecordingShareToChatResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetRoomsNoStatusUpdate.serializer)
      ..add(RoomGetRoomsApiVersion.serializer)
      ..addBuilderFactory(const FullType(RoomRoomGetRoomsHeaders), RoomRoomGetRoomsHeadersBuilder.new)
      ..add(RoomRoomGetRoomsHeaders.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetRoomsResponseApplicationJson),
        RoomGetRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetRoomsResponseApplicationJson_Ocs),
        RoomGetRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetRoomsResponseApplicationJson_Ocs.serializer)
      ..add(RoomCreateRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomCreateRoomResponseApplicationJson),
        RoomCreateRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomCreateRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomCreateRoomResponseApplicationJson_Ocs),
        RoomCreateRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomCreateRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetListedRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetListedRoomsResponseApplicationJson),
        RoomGetListedRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetListedRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetListedRoomsResponseApplicationJson_Ocs),
        RoomGetListedRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetListedRoomsResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetNoteToSelfConversationApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRoomGetNoteToSelfConversationHeaders),
        RoomRoomGetNoteToSelfConversationHeadersBuilder.new,
      )
      ..add(RoomRoomGetNoteToSelfConversationHeaders.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetNoteToSelfConversationResponseApplicationJson),
        RoomGetNoteToSelfConversationResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetNoteToSelfConversationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetNoteToSelfConversationResponseApplicationJson_Ocs),
        RoomGetNoteToSelfConversationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetNoteToSelfConversationResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetSingleRoomApiVersion.serializer)
      ..addBuilderFactory(const FullType(RoomRoomGetSingleRoomHeaders), RoomRoomGetSingleRoomHeadersBuilder.new)
      ..add(RoomRoomGetSingleRoomHeaders.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetSingleRoomResponseApplicationJson),
        RoomGetSingleRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetSingleRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetSingleRoomResponseApplicationJson_Ocs),
        RoomGetSingleRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetSingleRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomRenameRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRenameRoomResponseApplicationJson),
        RoomRenameRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRenameRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRenameRoomResponseApplicationJson_Ocs),
        RoomRenameRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRenameRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomDeleteRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomDeleteRoomResponseApplicationJson),
        RoomDeleteRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomDeleteRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomDeleteRoomResponseApplicationJson_Ocs),
        RoomDeleteRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomDeleteRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetBreakoutRoomsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomsResponseApplicationJson),
        RoomGetBreakoutRoomsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetBreakoutRoomsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomsResponseApplicationJson_Ocs),
        RoomGetBreakoutRoomsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetBreakoutRoomsResponseApplicationJson_Ocs.serializer)
      ..add(RoomMakePublicApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePublicResponseApplicationJson),
        RoomMakePublicResponseApplicationJsonBuilder.new,
      )
      ..add(RoomMakePublicResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePublicResponseApplicationJson_Ocs),
        RoomMakePublicResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomMakePublicResponseApplicationJson_Ocs.serializer)
      ..add(RoomMakePrivateApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePrivateResponseApplicationJson),
        RoomMakePrivateResponseApplicationJsonBuilder.new,
      )
      ..add(RoomMakePrivateResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomMakePrivateResponseApplicationJson_Ocs),
        RoomMakePrivateResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomMakePrivateResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetDescriptionApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetDescriptionResponseApplicationJson),
        RoomSetDescriptionResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetDescriptionResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetDescriptionResponseApplicationJson_Ocs),
        RoomSetDescriptionResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetDescriptionResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetReadOnlyState.serializer)
      ..add(RoomSetReadOnlyApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetReadOnlyResponseApplicationJson),
        RoomSetReadOnlyResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetReadOnlyResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetReadOnlyResponseApplicationJson_Ocs),
        RoomSetReadOnlyResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetReadOnlyResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetListableScope.serializer)
      ..add(RoomSetListableApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetListableResponseApplicationJson),
        RoomSetListableResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetListableResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetListableResponseApplicationJson_Ocs),
        RoomSetListableResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetListableResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetPasswordApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPasswordResponseApplicationJson),
        RoomSetPasswordResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetPasswordResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPasswordResponseApplicationJson_Ocs),
        RoomSetPasswordResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetPasswordResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetPermissionsPermissions.serializer)
      ..add(RoomSetPermissionsMode.serializer)
      ..add(RoomSetPermissionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPermissionsResponseApplicationJson),
        RoomSetPermissionsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetPermissionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetPermissionsResponseApplicationJson_Ocs),
        RoomSetPermissionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetPermissionsResponseApplicationJson_Ocs.serializer)
      ..add(RoomGetParticipantsApiVersion.serializer)
      ..addBuilderFactory(const FullType(RoomRoomGetParticipantsHeaders), RoomRoomGetParticipantsHeadersBuilder.new)
      ..add(RoomRoomGetParticipantsHeaders.serializer)
      ..addBuilderFactory(const FullType(Header, [FullType(bool)]), HeaderBuilder<bool>.new)
      ..add(Header.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetParticipantsResponseApplicationJson),
        RoomGetParticipantsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetParticipantsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetParticipantsResponseApplicationJson_Ocs),
        RoomGetParticipantsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetParticipantsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(Participant), ParticipantBuilder.new)
      ..add(Participant.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(Participant)]), ListBuilder<Participant>.new)
      ..add(RoomAddParticipantToRoomSource.serializer)
      ..add(RoomAddParticipantToRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddParticipantToRoomResponseApplicationJson),
        RoomAddParticipantToRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomAddParticipantToRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs),
        RoomAddParticipantToRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomAddParticipantToRoomResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0),
        RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0Builder.new,
      )
      ..add(RoomAddParticipantToRoomResponseApplicationJson_Ocs_Data0.serializer)
      ..add($bd993fb3f40af33e8594d0d698208560Extension._serializer)
      ..add(RoomGetBreakoutRoomParticipantsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRoomGetBreakoutRoomParticipantsHeaders),
        RoomRoomGetBreakoutRoomParticipantsHeadersBuilder.new,
      )
      ..add(RoomRoomGetBreakoutRoomParticipantsHeaders.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomParticipantsResponseApplicationJson),
        RoomGetBreakoutRoomParticipantsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomGetBreakoutRoomParticipantsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs),
        RoomGetBreakoutRoomParticipantsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomGetBreakoutRoomParticipantsResponseApplicationJson_Ocs.serializer)
      ..add(RoomRemoveSelfFromRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveSelfFromRoomResponseApplicationJson),
        RoomRemoveSelfFromRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRemoveSelfFromRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveSelfFromRoomResponseApplicationJson_Ocs),
        RoomRemoveSelfFromRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRemoveSelfFromRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomRemoveAttendeeFromRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveAttendeeFromRoomResponseApplicationJson),
        RoomRemoveAttendeeFromRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRemoveAttendeeFromRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs),
        RoomRemoveAttendeeFromRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRemoveAttendeeFromRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetAttendeePermissionsMethod.serializer)
      ..add(RoomSetAttendeePermissionsPermissions.serializer)
      ..add(RoomSetAttendeePermissionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAttendeePermissionsResponseApplicationJson),
        RoomSetAttendeePermissionsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetAttendeePermissionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAttendeePermissionsResponseApplicationJson_Ocs),
        RoomSetAttendeePermissionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetAttendeePermissionsResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetAllAttendeesPermissionsMethod.serializer)
      ..add(RoomSetAllAttendeesPermissionsPermissions.serializer)
      ..add(RoomSetAllAttendeesPermissionsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAllAttendeesPermissionsResponseApplicationJson),
        RoomSetAllAttendeesPermissionsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetAllAttendeesPermissionsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs),
        RoomSetAllAttendeesPermissionsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetAllAttendeesPermissionsResponseApplicationJson_Ocs.serializer)
      ..add(RoomJoinRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomJoinRoomResponseApplicationJson),
        RoomJoinRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomJoinRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomJoinRoomResponseApplicationJson_Ocs),
        RoomJoinRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomJoinRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomLeaveRoomApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomLeaveRoomResponseApplicationJson),
        RoomLeaveRoomResponseApplicationJsonBuilder.new,
      )
      ..add(RoomLeaveRoomResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomLeaveRoomResponseApplicationJson_Ocs),
        RoomLeaveRoomResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomLeaveRoomResponseApplicationJson_Ocs.serializer)
      ..add(RoomResendInvitationsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomResendInvitationsResponseApplicationJson),
        RoomResendInvitationsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomResendInvitationsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomResendInvitationsResponseApplicationJson_Ocs),
        RoomResendInvitationsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomResendInvitationsResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetSessionStateState.serializer)
      ..add(RoomSetSessionStateApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetSessionStateResponseApplicationJson),
        RoomSetSessionStateResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetSessionStateResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetSessionStateResponseApplicationJson_Ocs),
        RoomSetSessionStateResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetSessionStateResponseApplicationJson_Ocs.serializer)
      ..add(RoomPromoteModeratorApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomPromoteModeratorResponseApplicationJson),
        RoomPromoteModeratorResponseApplicationJsonBuilder.new,
      )
      ..add(RoomPromoteModeratorResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomPromoteModeratorResponseApplicationJson_Ocs),
        RoomPromoteModeratorResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomPromoteModeratorResponseApplicationJson_Ocs.serializer)
      ..add(RoomDemoteModeratorApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomDemoteModeratorResponseApplicationJson),
        RoomDemoteModeratorResponseApplicationJsonBuilder.new,
      )
      ..add(RoomDemoteModeratorResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomDemoteModeratorResponseApplicationJson_Ocs),
        RoomDemoteModeratorResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomDemoteModeratorResponseApplicationJson_Ocs.serializer)
      ..add(RoomAddToFavoritesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddToFavoritesResponseApplicationJson),
        RoomAddToFavoritesResponseApplicationJsonBuilder.new,
      )
      ..add(RoomAddToFavoritesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomAddToFavoritesResponseApplicationJson_Ocs),
        RoomAddToFavoritesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomAddToFavoritesResponseApplicationJson_Ocs.serializer)
      ..add(RoomRemoveFromFavoritesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveFromFavoritesResponseApplicationJson),
        RoomRemoveFromFavoritesResponseApplicationJsonBuilder.new,
      )
      ..add(RoomRemoveFromFavoritesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomRemoveFromFavoritesResponseApplicationJson_Ocs),
        RoomRemoveFromFavoritesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomRemoveFromFavoritesResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetNotificationLevelApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationLevelResponseApplicationJson),
        RoomSetNotificationLevelResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetNotificationLevelResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationLevelResponseApplicationJson_Ocs),
        RoomSetNotificationLevelResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetNotificationLevelResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetNotificationCallsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationCallsResponseApplicationJson),
        RoomSetNotificationCallsResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetNotificationCallsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetNotificationCallsResponseApplicationJson_Ocs),
        RoomSetNotificationCallsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetNotificationCallsResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetLobbyApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetLobbyResponseApplicationJson),
        RoomSetLobbyResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetLobbyResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetLobbyResponseApplicationJson_Ocs),
        RoomSetLobbyResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetLobbyResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetsipEnabledState.serializer)
      ..add(RoomSetsipEnabledApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetsipEnabledResponseApplicationJson),
        RoomSetsipEnabledResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetsipEnabledResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetsipEnabledResponseApplicationJson_Ocs),
        RoomSetsipEnabledResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetsipEnabledResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetRecordingConsentApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetRecordingConsentResponseApplicationJson),
        RoomSetRecordingConsentResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetRecordingConsentResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetRecordingConsentResponseApplicationJson_Ocs),
        RoomSetRecordingConsentResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetRecordingConsentResponseApplicationJson_Ocs.serializer)
      ..add(RoomSetMessageExpirationApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetMessageExpirationResponseApplicationJson),
        RoomSetMessageExpirationResponseApplicationJsonBuilder.new,
      )
      ..add(RoomSetMessageExpirationResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(RoomSetMessageExpirationResponseApplicationJson_Ocs),
        RoomSetMessageExpirationResponseApplicationJson_OcsBuilder.new,
      )
      ..add(RoomSetMessageExpirationResponseApplicationJson_Ocs.serializer)
      ..add(SettingsSetsipSettingsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetsipSettingsResponseApplicationJson),
        SettingsSetsipSettingsResponseApplicationJsonBuilder.new,
      )
      ..add(SettingsSetsipSettingsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetsipSettingsResponseApplicationJson_Ocs),
        SettingsSetsipSettingsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SettingsSetsipSettingsResponseApplicationJson_Ocs.serializer)
      ..add(SettingsSetUserSettingKey.serializer)
      ..add($b2c4857c0136baea42828d89c87c757dExtension._serializer)
      ..add(SettingsSetUserSettingApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetUserSettingResponseApplicationJson),
        SettingsSetUserSettingResponseApplicationJsonBuilder.new,
      )
      ..add(SettingsSetUserSettingResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SettingsSetUserSettingResponseApplicationJson_Ocs),
        SettingsSetUserSettingResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SettingsSetUserSettingResponseApplicationJson_Ocs.serializer)
      ..add(SignalingGetSettingsApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetSettingsResponseApplicationJson),
        SignalingGetSettingsResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingGetSettingsResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetSettingsResponseApplicationJson_Ocs),
        SignalingGetSettingsResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingGetSettingsResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(SignalingSettings), SignalingSettingsBuilder.new)
      ..add(SignalingSettings.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSettings_HelloAuthParams),
        SignalingSettings_HelloAuthParamsBuilder.new,
      )
      ..add(SignalingSettings_HelloAuthParams.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSettings_HelloAuthParams_$10),
        SignalingSettings_HelloAuthParams_$10Builder.new,
      )
      ..add(SignalingSettings_HelloAuthParams_$10.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSettings_HelloAuthParams_$20),
        SignalingSettings_HelloAuthParams_$20Builder.new,
      )
      ..add(SignalingSettings_HelloAuthParams_$20.serializer)
      ..addBuilderFactory(const FullType(SignalingSettings_Stunservers), SignalingSettings_StunserversBuilder.new)
      ..add(SignalingSettings_Stunservers.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(SignalingSettings_Stunservers)]),
        ListBuilder<SignalingSettings_Stunservers>.new,
      )
      ..addBuilderFactory(const FullType(SignalingSettings_Turnservers), SignalingSettings_TurnserversBuilder.new)
      ..add(SignalingSettings_Turnservers.serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(SignalingSettings_Turnservers)]),
        ListBuilder<SignalingSettings_Turnservers>.new,
      )
      ..add(SignalingGetWelcomeMessageApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetWelcomeMessageResponseApplicationJson),
        SignalingGetWelcomeMessageResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingGetWelcomeMessageResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingGetWelcomeMessageResponseApplicationJson_Ocs),
        SignalingGetWelcomeMessageResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingGetWelcomeMessageResponseApplicationJson_Ocs.serializer)
      ..add(SignalingPullMessagesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingPullMessagesResponseApplicationJson),
        SignalingPullMessagesResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingPullMessagesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingPullMessagesResponseApplicationJson_Ocs),
        SignalingPullMessagesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingPullMessagesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(SignalingPullMessagesResponseApplicationJson_Ocs_Data),
        SignalingPullMessagesResponseApplicationJson_Ocs_DataBuilder.new,
      )
      ..add(SignalingPullMessagesResponseApplicationJson_Ocs_Data.serializer)
      ..addBuilderFactory(const FullType(SignalingSession), SignalingSessionBuilder.new)
      ..add(SignalingSession.serializer)
      ..addBuilderFactory(const FullType(BuiltList, [FullType(SignalingSession)]), ListBuilder<SignalingSession>.new)
      ..add($1df642f5035aea3b22543ab331c3fb01Extension._serializer)
      ..addBuilderFactory(
        const FullType(BuiltList, [FullType(SignalingPullMessagesResponseApplicationJson_Ocs_Data)]),
        ListBuilder<SignalingPullMessagesResponseApplicationJson_Ocs_Data>.new,
      )
      ..add(SignalingSendMessagesApiVersion.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSendMessagesResponseApplicationJson),
        SignalingSendMessagesResponseApplicationJsonBuilder.new,
      )
      ..add(SignalingSendMessagesResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(SignalingSendMessagesResponseApplicationJson_Ocs),
        SignalingSendMessagesResponseApplicationJson_OcsBuilder.new,
      )
      ..add(SignalingSendMessagesResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarPostAvatarResponseApplicationJson),
        TempAvatarPostAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(TempAvatarPostAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarPostAvatarResponseApplicationJson_Ocs),
        TempAvatarPostAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TempAvatarPostAvatarResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarDeleteAvatarResponseApplicationJson),
        TempAvatarDeleteAvatarResponseApplicationJsonBuilder.new,
      )
      ..add(TempAvatarDeleteAvatarResponseApplicationJson.serializer)
      ..addBuilderFactory(
        const FullType(TempAvatarDeleteAvatarResponseApplicationJson_Ocs),
        TempAvatarDeleteAvatarResponseApplicationJson_OcsBuilder.new,
      )
      ..add(TempAvatarDeleteAvatarResponseApplicationJson_Ocs.serializer)
      ..addBuilderFactory(const FullType(BotWithDetailsAndSecret), BotWithDetailsAndSecretBuilder.new)
      ..add(BotWithDetailsAndSecret.serializer)
      ..addBuilderFactory(const FullType(FederationInvite), FederationInviteBuilder.new)
      ..add(FederationInvite.serializer)
      ..addBuilderFactory(const FullType(PublicCapabilities0), PublicCapabilities0Builder.new)
      ..add(PublicCapabilities0.serializer)
      ..addBuilderFactory(const FullType(PublicCapabilities0_Spreed), PublicCapabilities0_SpreedBuilder.new)
      ..add(PublicCapabilities0_Spreed.serializer)
      ..addBuilderFactory(
        const FullType(PublicCapabilities0_Spreed_Config),
        PublicCapabilities0_Spreed_ConfigBuilder.new,
      )
      ..add(PublicCapabilities0_Spreed_Config.serializer)
      ..addBuilderFactory(
        const FullType(PublicCapabilities0_Spreed_Config_Attachments),
        PublicCapabilities0_Spreed_Config_AttachmentsBuilder.new,
      )
      ..add(PublicCapabilities0_Spreed_Config_Attachments.serializer)
      ..addBuilderFactory(
        const FullType(PublicCapabilities0_Spreed_Config_Call),
        PublicCapabilities0_Spreed_Config_CallBuilder.new,
      )
      ..add(PublicCapabilities0_Spreed_Config_Call.serializer)
      ..addBuilderFactory(
        const FullType(PublicCapabilities0_Spreed_Config_Chat),
        PublicCapabilities0_Spreed_Config_ChatBuilder.new,
      )
      ..add(PublicCapabilities0_Spreed_Config_Chat.serializer)
      ..addBuilderFactory(
        const FullType(PublicCapabilities0_Spreed_Config_Conversations),
        PublicCapabilities0_Spreed_Config_ConversationsBuilder.new,
      )
      ..add(PublicCapabilities0_Spreed_Config_Conversations.serializer)
      ..addBuilderFactory(
        const FullType(PublicCapabilities0_Spreed_Config_Previews),
        PublicCapabilities0_Spreed_Config_PreviewsBuilder.new,
      )
      ..add(PublicCapabilities0_Spreed_Config_Previews.serializer)
      ..addBuilderFactory(
        const FullType(PublicCapabilities0_Spreed_Config_Signaling),
        PublicCapabilities0_Spreed_Config_SignalingBuilder.new,
      )
      ..add(PublicCapabilities0_Spreed_Config_Signaling.serializer)
      ..add($bc4aac45771b11649d372f39a92b1cf3Extension._serializer))
    .build();
@visibleForTesting
final Serializers jsonSerializers = (serializers.toBuilder()
      ..add(DynamiteDoubleSerializer())
      ..addPlugin(StandardJsonPlugin())
      ..addPlugin(const HeaderPlugin())
      ..addPlugin(const ContentStringPlugin()))
    .build();
// coverage:ignore-end
